/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 83;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 8,
  Feature_HasJSBit = 10,
  Feature_HasComplxNumBit = 55,
  Feature_HasRCPC_IMMOBit = 75,
  Feature_HasFPARMv8Bit = 9,
  Feature_HasNEONBit = 4,
  Feature_HasSM4Bit = 54,
  Feature_HasSHA3Bit = 53,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 12,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 26,
  Feature_HasLSEBit = 27,
  Feature_HasNoLSEBit = 82,
  Feature_HasRDMBit = 17,
  Feature_HasFullFP16Bit = 15,
  Feature_HasNoFullFP16Bit = 72,
  Feature_HasFP16FMLBit = 7,
  Feature_HasFuseAESBit = 66,
  Feature_HasSVEBit = 23,
  Feature_HasSVEB16B16Bit = 30,
  Feature_HasSVE2Bit = 24,
  Feature_HasSVE2p1Bit = 39,
  Feature_HasSVEAESBit = 34,
  Feature_HasSVE2SM4Bit = 37,
  Feature_HasSVE2SHA3Bit = 80,
  Feature_HasSVE2BitPermBit = 35,
  Feature_HasSMEandIsNonStreamingSafeBit = 47,
  Feature_HasSMEBit = 43,
  Feature_HasSMEF64F64Bit = 44,
  Feature_HasSMEI16I64Bit = 46,
  Feature_HasSMEB16B16Bit = 81,
  Feature_HasSME2andIsNonStreamingSafeBit = 50,
  Feature_HasSME2Bit = 49,
  Feature_HasSME2p1Bit = 52,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasLUTBit = 41,
  Feature_HasSME_LUTv2Bit = 51,
  Feature_HasSVEorSMEBit = 0,
  Feature_HasNonStreamingSVEorSME2p2Bit = 36,
  Feature_HasSVE2orSMEBit = 28,
  Feature_HasSVE2orSME2Bit = 42,
  Feature_HasNonStreamingSVE2orSSVE_AESBit = 33,
  Feature_HasSVE2p1_or_HasSMEBit = 48,
  Feature_HasSVE2p1_or_HasSME2Bit = 25,
  Feature_HasSVE2p1_or_HasSME2p1Bit = 40,
  Feature_HasSVE2p2orSME2p2Bit = 32,
  Feature_HasSMEF16F16orSMEF8F16Bit = 45,
  Feature_HasNEONandIsStreamingSafeBit = 5,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 63,
  Feature_HasRCPCBit = 74,
  Feature_HasFRInt3264Bit = 16,
  Feature_HasMTEBit = 13,
  Feature_HasTMEBit = 11,
  Feature_HasBF16Bit = 3,
  Feature_HasNoBF16Bit = 73,
  Feature_HasMatMulInt8Bit = 6,
  Feature_HasMatMulFP32Bit = 79,
  Feature_HasMatMulFP64Bit = 38,
  Feature_HasLS64Bit = 70,
  Feature_HasHBCBit = 14,
  Feature_HasRCPC3Bit = 71,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 61,
  Feature_IsBEBit = 67,
  Feature_UseExperimentalZeroingPseudosBit = 31,
  Feature_UseAlternateSExtLoadCVTF32Bit = 65,
  Feature_UseScalarIncVLBit = 29,
  Feature_NoUseScalarIncVLBit = 78,
  Feature_UseSVEFPLD1RBit = 77,
  Feature_UseUnaryUndefPseudosBit = 76,
  Feature_NotForCodeSizeBit = 64,
  Feature_UseSTRQroBit = 62,
  Feature_TailCallX16X17Bit = 57,
  Feature_TailCallX17Bit = 68,
  Feature_TailCallNotX16Bit = 69,
  Feature_TailCallAnyBit = 56,
  Feature_SLSBLRMitigationBit = 60,
  Feature_NoSLSBLRMitigationBit = 59,
  Feature_OptimizedGISelOrOtherSelectorBit = 58,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSVEB16B16())
    Features.set(Feature_HasSVEB16B16Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2BitPerm())
    Features.set(Feature_HasSVE2BitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEB16B16())
    Features.set(Feature_HasSMEB16B16Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVEorSMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVEorSME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2orSMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2orSME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2orSSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_HasSMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_HasSME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_HasSME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2orSME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16orSMEF8F16Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasBF16())
    Features.set(Feature_HasBF16Bit);
  if (!Subtarget->hasBF16())
    Features.set(Feature_HasNoBF16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!(Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2())))
    Features.set(Feature_UseUnaryUndefPseudosBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasBF16,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoBF16,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVEorSME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEB16B16,
  GIFBS_HasSMEF16F16orSMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2BitPerm,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2orSME,
  GIFBS_HasSVE2p1_or_HasSME,
  GIFBS_HasSVE2p1_or_HasSME2,
  GIFBS_HasSVE2p1_or_HasSME2p1,
  GIFBS_HasSVEB16B16,
  GIFBS_HasSVEorSME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasBF16_HasNEON,
  GIFBS_HasBF16_HasNEONandIsStreamingSafe,
  GIFBS_HasBF16_HasSVE,
  GIFBS_HasBF16_HasSVEorSME,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2orSME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2orSME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVEorSME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVEorSME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES,
  GIFBS_HasSVEorSME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasBF16Bit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoBF16Bit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVEorSME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEB16B16Bit, },
  {Feature_HasSMEF16F16orSMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2BitPermBit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2orSMEBit, },
  {Feature_HasSVE2p1_or_HasSMEBit, },
  {Feature_HasSVE2p1_or_HasSME2Bit, },
  {Feature_HasSVE2p1_or_HasSME2p1Bit, },
  {Feature_HasSVEB16B16Bit, },
  {Feature_HasSVEorSMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasBF16Bit, Feature_HasNEONBit, },
  {Feature_HasBF16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasBF16Bit, Feature_HasSVEBit, },
  {Feature_HasBF16Bit, Feature_HasSVEorSMEBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2orSME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2orSME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEorSMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEorSMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2orSSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasSVEorSMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         // Only handle G_ADD for now. FIXME. build capability to compute whether
         // operands of G_OR have common bits set or not.
         return MI.getOpcode() == TargetOpcode::G_ADD;
      
    llvm_unreachable("add_and_or_is_add should have returned");
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(817), /*)*//*default:*//*Label 154*/ GIMT_Encode4(421531),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3066),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(32755),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(46191),
    /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(48020),
    /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(48102), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(48184),
    /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(51866),
    /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(63913), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(68104), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(75545), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(88001),
    /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(89424),
    /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(90847),
    /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(91115),
    /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(91265),
    /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(92688), GIMT_Encode4(0),
    /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(92721),
    /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(101787),
    /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(102879), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(105893), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(119970),
    /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(121321),
    /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(122313),
    /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(123305),
    /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(124797), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(126289),
    /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(127281),
    /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(128273),
    /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(129265),
    /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(130257),
    /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(131249), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FENCE*//*Label 31*/ GIMT_Encode4(132241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC*//*Label 32*/ GIMT_Encode4(132292),
    /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 33*/ GIMT_Encode4(243277), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ANYEXT*//*Label 34*/ GIMT_Encode4(251132),
    /*TargetOpcode::G_TRUNC*//*Label 35*/ GIMT_Encode4(251422),
    /*TargetOpcode::G_CONSTANT*//*Label 36*/ GIMT_Encode4(252625),
    /*TargetOpcode::G_FCONSTANT*//*Label 37*/ GIMT_Encode4(252745), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 38*/ GIMT_Encode4(253034),
    /*TargetOpcode::G_SEXT_INREG*//*Label 39*/ GIMT_Encode4(254932),
    /*TargetOpcode::G_ZEXT*//*Label 40*/ GIMT_Encode4(256586),
    /*TargetOpcode::G_SHL*//*Label 41*/ GIMT_Encode4(259365),
    /*TargetOpcode::G_LSHR*//*Label 42*/ GIMT_Encode4(260145),
    /*TargetOpcode::G_ASHR*//*Label 43*/ GIMT_Encode4(260538), GIMT_Encode4(0),
    /*TargetOpcode::G_FSHR*//*Label 44*/ GIMT_Encode4(261314),
    /*TargetOpcode::G_ROTR*//*Label 45*/ GIMT_Encode4(261444), GIMT_Encode4(0),
    /*TargetOpcode::G_ICMP*//*Label 46*/ GIMT_Encode4(261937), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SELECT*//*Label 47*/ GIMT_Encode4(266513), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UMULH*//*Label 48*/ GIMT_Encode4(266999),
    /*TargetOpcode::G_SMULH*//*Label 49*/ GIMT_Encode4(267483),
    /*TargetOpcode::G_UADDSAT*//*Label 50*/ GIMT_Encode4(267967),
    /*TargetOpcode::G_SADDSAT*//*Label 51*/ GIMT_Encode4(268397),
    /*TargetOpcode::G_USUBSAT*//*Label 52*/ GIMT_Encode4(268827),
    /*TargetOpcode::G_SSUBSAT*//*Label 53*/ GIMT_Encode4(269257), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FADD*//*Label 54*/ GIMT_Encode4(269687),
    /*TargetOpcode::G_FSUB*//*Label 55*/ GIMT_Encode4(272413),
    /*TargetOpcode::G_FMUL*//*Label 56*/ GIMT_Encode4(274501),
    /*TargetOpcode::G_FMA*//*Label 57*/ GIMT_Encode4(279963), GIMT_Encode4(0),
    /*TargetOpcode::G_FDIV*//*Label 58*/ GIMT_Encode4(296236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FNEG*//*Label 59*/ GIMT_Encode4(298129),
    /*TargetOpcode::G_FPEXT*//*Label 60*/ GIMT_Encode4(302057),
    /*TargetOpcode::G_FPTRUNC*//*Label 61*/ GIMT_Encode4(302421),
    /*TargetOpcode::G_FPTOSI*//*Label 62*/ GIMT_Encode4(302749),
    /*TargetOpcode::G_FPTOUI*//*Label 63*/ GIMT_Encode4(303812),
    /*TargetOpcode::G_SITOFP*//*Label 64*/ GIMT_Encode4(304875),
    /*TargetOpcode::G_UITOFP*//*Label 65*/ GIMT_Encode4(309152),
    /*TargetOpcode::G_FPTOSI_SAT*//*Label 66*/ GIMT_Encode4(312807),
    /*TargetOpcode::G_FPTOUI_SAT*//*Label 67*/ GIMT_Encode4(313127),
    /*TargetOpcode::G_FABS*//*Label 68*/ GIMT_Encode4(313447), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FCANONICALIZE*//*Label 69*/ GIMT_Encode4(314663),
    /*TargetOpcode::G_FMINNUM*//*Label 70*/ GIMT_Encode4(314945),
    /*TargetOpcode::G_FMAXNUM*//*Label 71*/ GIMT_Encode4(315323),
    /*TargetOpcode::G_FMINNUM_IEEE*//*Label 72*/ GIMT_Encode4(315701),
    /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 73*/ GIMT_Encode4(316051),
    /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(316401),
    /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(317104), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(317807),
    /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(318211),
    /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(318615),
    /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(319019),
    /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(319423),
    /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(320238),
    /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(320404),
    /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(320503), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 84*/ GIMT_Encode4(320519),
    /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 85*/ GIMT_Encode4(325975),
    /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 86*/ GIMT_Encode4(357968), GIMT_Encode4(0),
    /*TargetOpcode::G_SPLAT_VECTOR*//*Label 87*/ GIMT_Encode4(361519), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(363809), GIMT_Encode4(0),
    /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(363961), GIMT_Encode4(0),
    /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(364635),
    /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(364795),
    /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(365109),
    /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(365263), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(366686),
    /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(366986),
    /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(368409),
    /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(369832), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(371255),
    /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(373658),
    /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(375551),
    /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(380566), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(382459),
    /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(398066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(398366),
    /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(398380),
    /*TargetOpcode::G_UBSANTRAP*//*Label 106*/ GIMT_Encode4(398401), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_VECREDUCE_FADD*//*Label 107*/ GIMT_Encode4(398426), GIMT_Encode4(0),
    /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 108*/ GIMT_Encode4(398736),
    /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 109*/ GIMT_Encode4(398907),
    /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 110*/ GIMT_Encode4(399078),
    /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 111*/ GIMT_Encode4(399249),
    /*TargetOpcode::G_VECREDUCE_ADD*//*Label 112*/ GIMT_Encode4(399420), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 113*/ GIMT_Encode4(400549),
    /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 114*/ GIMT_Encode4(400752),
    /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 115*/ GIMT_Encode4(400955),
    /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 116*/ GIMT_Encode4(401158), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*AArch64::G_AARCH64_PREFETCH*//*Label 117*/ GIMT_Encode4(401361), GIMT_Encode4(0),
    /*AArch64::G_BSP*//*Label 118*/ GIMT_Encode4(401501),
    /*AArch64::G_DUP*//*Label 119*/ GIMT_Encode4(402041),
    /*AArch64::G_DUPLANE16*//*Label 120*/ GIMT_Encode4(404132),
    /*AArch64::G_DUPLANE32*//*Label 121*/ GIMT_Encode4(404453),
    /*AArch64::G_DUPLANE64*//*Label 122*/ GIMT_Encode4(404708),
    /*AArch64::G_DUPLANE8*//*Label 123*/ GIMT_Encode4(404854),
    /*AArch64::G_EXT*//*Label 124*/ GIMT_Encode4(405033),
    /*AArch64::G_FCMEQ*//*Label 125*/ GIMT_Encode4(406916),
    /*AArch64::G_FCMEQZ*//*Label 126*/ GIMT_Encode4(407255),
    /*AArch64::G_FCMGE*//*Label 127*/ GIMT_Encode4(407485),
    /*AArch64::G_FCMGEZ*//*Label 128*/ GIMT_Encode4(408149),
    /*AArch64::G_FCMGT*//*Label 129*/ GIMT_Encode4(408379),
    /*AArch64::G_FCMGTZ*//*Label 130*/ GIMT_Encode4(409043),
    /*AArch64::G_FCMLEZ*//*Label 131*/ GIMT_Encode4(409273),
    /*AArch64::G_FCMLTZ*//*Label 132*/ GIMT_Encode4(409503),
    /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(409733),
    /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(409811),
    /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(410011),
    /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(410309),
    /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(410515),
    /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(410914),
    /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(411284),
    /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(411401),
    /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(412634),
    /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(413459),
    /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(414284),
    /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(414490),
    /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(415357),
    /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(415727),
    /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(415844),
    /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(417077),
    /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(417902),
    /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(418727),
    /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(419425),
    /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(419881),
    /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(420706),
    // Label 0: @3066
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(32754),
    /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3165),
    /*GILLT_s64*//*Label 156*/ GIMT_Encode4(4688), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(9780),
    /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(13012),
    /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(18774),
    /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(22006),
    /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(28044),
    /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(28628),
    /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(32066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(32650), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(32676), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(32702), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(32728),
    // Label 155: @3165
    GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4687),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3209), // Rule ID 13177 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
        // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13177,
        GIR_EraseRootFromParent_Done,
      // Label 170: @3209
      GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3361), // Rule ID 13604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 13604,
        GIR_EraseRootFromParent_Done,
      // Label 171: @3361
      GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3513), // Rule ID 15465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 15465,
        GIR_EraseRootFromParent_Done,
      // Label 172: @3513
      GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3665), // Rule ID 15477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 15477,
        GIR_EraseRootFromParent_Done,
      // Label 173: @3665
      GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3817), // Rule ID 15489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 15489,
        GIR_EraseRootFromParent_Done,
      // Label 174: @3817
      GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3850), // Rule ID 103 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
        // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 103,
        GIR_EraseRootFromParent_Done,
      // Label 175: @3850
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4002), // Rule ID 2603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 2603,
        GIR_EraseRootFromParent_Done,
      // Label 176: @4002
      GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4154), // Rule ID 10159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10159,
        GIR_EraseRootFromParent_Done,
      // Label 177: @4154
      GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4306), // Rule ID 10171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10171,
        GIR_EraseRootFromParent_Done,
      // Label 178: @4306
      GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4458), // Rule ID 10183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10183,
        GIR_EraseRootFromParent_Done,
      // Label 179: @4458
      GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4491), // Rule ID 13181 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
        // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13181,
        GIR_EraseRootFromParent_Done,
      // Label 180: @4491
      GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4527), // Rule ID 13744 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
        // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13744,
        GIR_EraseRootFromParent_Done,
      // Label 181: @4527
      GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4560), // Rule ID 109 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
        // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 109,
        GIR_EraseRootFromParent_Done,
      // Label 182: @4560
      GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4596), // Rule ID 3889 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3889,
        GIR_EraseRootFromParent_Done,
      // Label 183: @4596
      GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4629), // Rule ID 13179 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
        // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13179,
        GIR_EraseRootFromParent_Done,
      // Label 184: @4629
      GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4662), // Rule ID 107 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 107,
        GIR_EraseRootFromParent_Done,
      // Label 185: @4662
      GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4686), // Rule ID 105 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 105,
        GIR_Done,
      // Label 186: @4686
      GIM_Reject,
    // Label 169: @4687
    GIM_Reject,
    // Label 156: @4688
    GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(9779),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4835), // Rule ID 5401 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5401,
        GIR_EraseRootFromParent_Done,
      // Label 188: @4835
      GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(4971), // Rule ID 5400 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5400,
        GIR_EraseRootFromParent_Done,
      // Label 189: @4971
      GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5107), // Rule ID 5410 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5410,
        GIR_EraseRootFromParent_Done,
      // Label 190: @5107
      GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5243), // Rule ID 5399 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5399,
        GIR_EraseRootFromParent_Done,
      // Label 191: @5243
      GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5379), // Rule ID 5398 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5398,
        GIR_EraseRootFromParent_Done,
      // Label 192: @5379
      GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5447), // Rule ID 7071 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7071,
        GIR_EraseRootFromParent_Done,
      // Label 193: @5447
      GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5515), // Rule ID 13905 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13905,
        GIR_EraseRootFromParent_Done,
      // Label 194: @5515
      GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5548), // Rule ID 13178 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
        // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13178,
        GIR_EraseRootFromParent_Done,
      // Label 195: @5548
      GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5681), // Rule ID 3941 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3941,
        GIR_EraseRootFromParent_Done,
      // Label 196: @5681
      GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5776), // Rule ID 3939 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3939,
        GIR_EraseRootFromParent_Done,
      // Label 197: @5776
      GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5871), // Rule ID 3940 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3940,
        GIR_EraseRootFromParent_Done,
      // Label 198: @5871
      GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5904), // Rule ID 104 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
        // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 104,
        GIR_EraseRootFromParent_Done,
      // Label 199: @5904
      GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6037), // Rule ID 13754 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13754,
        GIR_EraseRootFromParent_Done,
      // Label 200: @6037
      GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6132), // Rule ID 13752 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13752,
        GIR_EraseRootFromParent_Done,
      // Label 201: @6132
      GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6227), // Rule ID 13753 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13753,
        GIR_EraseRootFromParent_Done,
      // Label 202: @6227
      GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6309), // Rule ID 13189 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13189,
        GIR_EraseRootFromParent_Done,
      // Label 203: @6309
      GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6391), // Rule ID 13190 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13190,
        GIR_EraseRootFromParent_Done,
      // Label 204: @6391
      GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6473), // Rule ID 135 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 135,
        GIR_EraseRootFromParent_Done,
      // Label 205: @6473
      GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(6555), // Rule ID 137 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 137,
        GIR_EraseRootFromParent_Done,
      // Label 206: @6555
      GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6613), // Rule ID 13599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13599,
        GIR_EraseRootFromParent_Done,
      // Label 207: @6613
      GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6671), // Rule ID 15460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15460,
        GIR_EraseRootFromParent_Done,
      // Label 208: @6671
      GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6729), // Rule ID 15472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15472,
        GIR_EraseRootFromParent_Done,
      // Label 209: @6729
      GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6787), // Rule ID 15484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15484,
        GIR_EraseRootFromParent_Done,
      // Label 210: @6787
      GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6845), // Rule ID 2600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2600,
        GIR_EraseRootFromParent_Done,
      // Label 211: @6845
      GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6903), // Rule ID 10156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10156,
        GIR_EraseRootFromParent_Done,
      // Label 212: @6903
      GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6961), // Rule ID 10168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10168,
        GIR_EraseRootFromParent_Done,
      // Label 213: @6961
      GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7019), // Rule ID 10180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10180,
        GIR_EraseRootFromParent_Done,
      // Label 214: @7019
      GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7182), // Rule ID 13871 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13871,
        GIR_EraseRootFromParent_Done,
      // Label 215: @7182
      GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(7345), // Rule ID 13868 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13868,
        GIR_EraseRootFromParent_Done,
      // Label 216: @7345
      GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(7495), // Rule ID 13877 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13877,
        GIR_EraseRootFromParent_Done,
      // Label 217: @7495
      GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(7645), // Rule ID 13880 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13880,
        GIR_EraseRootFromParent_Done,
      // Label 218: @7645
      GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(7795), // Rule ID 13876 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13876,
        GIR_EraseRootFromParent_Done,
      // Label 219: @7795
      GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(7958), // Rule ID 5383 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5383,
        GIR_EraseRootFromParent_Done,
      // Label 220: @7958
      GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8121), // Rule ID 5380 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5380,
        GIR_EraseRootFromParent_Done,
      // Label 221: @8121
      GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8271), // Rule ID 5407 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5407,
        GIR_EraseRootFromParent_Done,
      // Label 222: @8271
      GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8421), // Rule ID 5413 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5413,
        GIR_EraseRootFromParent_Done,
      // Label 223: @8421
      GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8571), // Rule ID 5406 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5406,
        GIR_EraseRootFromParent_Done,
      // Label 224: @8571
      GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8604), // Rule ID 13182 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
        // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13182,
        GIR_EraseRootFromParent_Done,
      // Label 225: @8604
      GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8640), // Rule ID 13745 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
        // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13745,
        GIR_EraseRootFromParent_Done,
      // Label 226: @8640
      GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8673), // Rule ID 110 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
        // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 110,
        GIR_EraseRootFromParent_Done,
      // Label 227: @8673
      GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(8709), // Rule ID 3890 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3890,
        GIR_EraseRootFromParent_Done,
      // Label 228: @8709
      GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(8742), // Rule ID 13180 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
        // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13180,
        GIR_EraseRootFromParent_Done,
      // Label 229: @8742
      GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(8775), // Rule ID 108 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 108,
        GIR_EraseRootFromParent_Done,
      // Label 230: @8775
      GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(8831), // Rule ID 13288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 635:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13288,
        GIR_EraseRootFromParent_Done,
      // Label 231: @8831
      GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(8887), // Rule ID 13300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 700:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13300,
        GIR_EraseRootFromParent_Done,
      // Label 232: @8887
      GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(8954), // Rule ID 13506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13506,
        GIR_EraseRootFromParent_Done,
      // Label 233: @8954
      GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9021), // Rule ID 13894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13894,
        GIR_EraseRootFromParent_Done,
      // Label 234: @9021
      GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(9088), // Rule ID 13509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13509,
        GIR_EraseRootFromParent_Done,
      // Label 235: @9088
      GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(9155), // Rule ID 13897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13897,
        GIR_EraseRootFromParent_Done,
      // Label 236: @9155
      GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(9211), // Rule ID 985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 635:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 985,
        GIR_EraseRootFromParent_Done,
      // Label 237: @9211
      GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(9267), // Rule ID 1046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 700:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1046,
        GIR_EraseRootFromParent_Done,
      // Label 238: @9267
      GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(9334), // Rule ID 2107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2107,
        GIR_EraseRootFromParent_Done,
      // Label 239: @9334
      GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(9401), // Rule ID 6338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6338,
        GIR_EraseRootFromParent_Done,
      // Label 240: @9401
      GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(9468), // Rule ID 2116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2116,
        GIR_EraseRootFromParent_Done,
      // Label 241: @9468
      GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(9535), // Rule ID 6344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6344,
        GIR_EraseRootFromParent_Done,
      // Label 242: @9535
      GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(9583), // Rule ID 13287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13287,
        GIR_EraseRootFromParent_Done,
      // Label 243: @9583
      GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(9631), // Rule ID 13299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13299,
        GIR_EraseRootFromParent_Done,
      // Label 244: @9631
      GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(9679), // Rule ID 984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 984,
        GIR_EraseRootFromParent_Done,
      // Label 245: @9679
      GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(9727), // Rule ID 1045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1045,
        GIR_EraseRootFromParent_Done,
      // Label 246: @9727
      GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(9751), // Rule ID 106 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 106,
        GIR_Done,
      // Label 247: @9751
      GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(9778), // Rule ID 1595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1595,
        GIR_Done,
      // Label 248: @9778
      GIM_Reject,
    // Label 187: @9779
    GIM_Reject,
    // Label 157: @9780
    GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(13011),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(9927), // Rule ID 5397 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5397,
        GIR_EraseRootFromParent_Done,
      // Label 250: @9927
      GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10063), // Rule ID 5396 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5396,
        GIR_EraseRootFromParent_Done,
      // Label 251: @10063
      GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(10199), // Rule ID 5409 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5409,
        GIR_EraseRootFromParent_Done,
      // Label 252: @10199
      GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(10335), // Rule ID 5395 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5395,
        GIR_EraseRootFromParent_Done,
      // Label 253: @10335
      GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(10471), // Rule ID 5394 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5394,
        GIR_EraseRootFromParent_Done,
      // Label 254: @10471
      GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(10634), // Rule ID 13870 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13870,
        GIR_EraseRootFromParent_Done,
      // Label 255: @10634
      GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(10797), // Rule ID 13867 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13867,
        GIR_EraseRootFromParent_Done,
      // Label 256: @10797
      GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(10947), // Rule ID 13875 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13875,
        GIR_EraseRootFromParent_Done,
      // Label 257: @10947
      GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11097), // Rule ID 13879 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13879,
        GIR_EraseRootFromParent_Done,
      // Label 258: @11097
      GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11247), // Rule ID 13874 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13874,
        GIR_EraseRootFromParent_Done,
      // Label 259: @11247
      GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11410), // Rule ID 5382 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5382,
        GIR_EraseRootFromParent_Done,
      // Label 260: @11410
      GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11573), // Rule ID 5379 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5379,
        GIR_EraseRootFromParent_Done,
      // Label 261: @11573
      GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11723), // Rule ID 5405 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5405,
        GIR_EraseRootFromParent_Done,
      // Label 262: @11723
      GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11873), // Rule ID 5412 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5412,
        GIR_EraseRootFromParent_Done,
      // Label 263: @11873
      GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12023), // Rule ID 5404 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5404,
        GIR_EraseRootFromParent_Done,
      // Label 264: @12023
      GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12092), // Rule ID 13322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13322,
        GIR_EraseRootFromParent_Done,
      // Label 265: @12092
      GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12161), // Rule ID 13334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13334,
        GIR_EraseRootFromParent_Done,
      // Label 266: @12161
      GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12217), // Rule ID 13284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13284,
        GIR_EraseRootFromParent_Done,
      // Label 267: @12217
      GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12273), // Rule ID 13296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13296,
        GIR_EraseRootFromParent_Done,
      // Label 268: @12273
      GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12340), // Rule ID 13526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13526,
        GIR_EraseRootFromParent_Done,
      // Label 269: @12340
      GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12407), // Rule ID 13547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13547,
        GIR_EraseRootFromParent_Done,
      // Label 270: @12407
      GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12476), // Rule ID 1353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1353,
        GIR_EraseRootFromParent_Done,
      // Label 271: @12476
      GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12545), // Rule ID 1476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1476,
        GIR_EraseRootFromParent_Done,
      // Label 272: @12545
      GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12601), // Rule ID 981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 981,
        GIR_EraseRootFromParent_Done,
      // Label 273: @12601
      GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12657), // Rule ID 1042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1042,
        GIR_EraseRootFromParent_Done,
      // Label 274: @12657
      GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12724), // Rule ID 2224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2224,
        GIR_EraseRootFromParent_Done,
      // Label 275: @12724
      GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12791), // Rule ID 2283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2283,
        GIR_EraseRootFromParent_Done,
      // Label 276: @12791
      GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(12839), // Rule ID 13283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13283,
        GIR_EraseRootFromParent_Done,
      // Label 277: @12839
      GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12887), // Rule ID 13295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13295,
        GIR_EraseRootFromParent_Done,
      // Label 278: @12887
      GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12935), // Rule ID 980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 980,
        GIR_EraseRootFromParent_Done,
      // Label 279: @12935
      GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12983), // Rule ID 1041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1041,
        GIR_EraseRootFromParent_Done,
      // Label 280: @12983
      GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13010), // Rule ID 1092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1092,
        GIR_Done,
      // Label 281: @13010
      GIM_Reject,
    // Label 249: @13011
    GIM_Reject,
    // Label 158: @13012
    GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(18773),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13141), // Rule ID 13461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13461,
        GIR_EraseRootFromParent_Done,
      // Label 283: @13141
      GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13259), // Rule ID 13462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13462,
        GIR_EraseRootFromParent_Done,
      // Label 284: @13259
      GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13377), // Rule ID 13491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13491,
        GIR_EraseRootFromParent_Done,
      // Label 285: @13377
      GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13495), // Rule ID 13492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13492,
        GIR_EraseRootFromParent_Done,
      // Label 286: @13495
      GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13613), // Rule ID 2030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2030,
        GIR_EraseRootFromParent_Done,
      // Label 287: @13613
      GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13731), // Rule ID 13460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13460,
        GIR_EraseRootFromParent_Done,
      // Label 288: @13731
      GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13849), // Rule ID 2082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2082,
        GIR_EraseRootFromParent_Done,
      // Label 289: @13849
      GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13967), // Rule ID 13490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13490,
        GIR_EraseRootFromParent_Done,
      // Label 290: @13967
      GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14054), // Rule ID 13366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13366,
        GIR_EraseRootFromParent_Done,
      // Label 291: @14054
      GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14141), // Rule ID 13390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13390,
        GIR_EraseRootFromParent_Done,
      // Label 292: @14141
      GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14228), // Rule ID 1687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1687,
        GIR_EraseRootFromParent_Done,
      // Label 293: @14228
      GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14315), // Rule ID 1765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1765,
        GIR_EraseRootFromParent_Done,
      // Label 294: @14315
      GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(14430), // Rule ID 13456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13456,
        GIR_EraseRootFromParent_Done,
      // Label 295: @14430
      GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(14545), // Rule ID 13455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13455,
        GIR_EraseRootFromParent_Done,
      // Label 296: @14545
      GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(14660), // Rule ID 13486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13486,
        GIR_EraseRootFromParent_Done,
      // Label 297: @14660
      GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(14775), // Rule ID 13485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13485,
        GIR_EraseRootFromParent_Done,
      // Label 298: @14775
      GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(14844), // Rule ID 1789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1789,
        GIR_EraseRootFromParent_Done,
      // Label 299: @14844
      GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(14913), // Rule ID 1788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1788,
        GIR_EraseRootFromParent_Done,
      // Label 300: @14913
      GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14982), // Rule ID 1705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1705,
        GIR_EraseRootFromParent_Done,
      // Label 301: @14982
      GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15051), // Rule ID 1787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1787,
        GIR_EraseRootFromParent_Done,
      // Label 302: @15051
      GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15120), // Rule ID 1786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1786,
        GIR_EraseRootFromParent_Done,
      // Label 303: @15120
      GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15235), // Rule ID 13454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13454,
        GIR_EraseRootFromParent_Done,
      // Label 304: @15235
      GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15350), // Rule ID 2028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2028,
        GIR_EraseRootFromParent_Done,
      // Label 305: @15350
      GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15465), // Rule ID 13484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13484,
        GIR_EraseRootFromParent_Done,
      // Label 306: @15465
      GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15580), // Rule ID 2080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2080,
        GIR_EraseRootFromParent_Done,
      // Label 307: @15580
      GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(15647), // Rule ID 13378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13378,
        GIR_EraseRootFromParent_Done,
      // Label 308: @15647
      GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(15714), // Rule ID 13408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13408,
        GIR_EraseRootFromParent_Done,
      // Label 309: @15714
      GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(15781), // Rule ID 1717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1717,
        GIR_EraseRootFromParent_Done,
      // Label 310: @15781
      GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(15848), // Rule ID 1807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1807,
        GIR_EraseRootFromParent_Done,
      // Label 311: @15848
      GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(15929), // Rule ID 13364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13364,
        GIR_EraseRootFromParent_Done,
      // Label 312: @15929
      GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16010), // Rule ID 13388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13388,
        GIR_EraseRootFromParent_Done,
      // Label 313: @16010
      GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16091), // Rule ID 1685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1685,
        GIR_EraseRootFromParent_Done,
      // Label 314: @16091
      GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16172), // Rule ID 1763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1763,
        GIR_EraseRootFromParent_Done,
      // Label 315: @16172
      GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16264), // Rule ID 13459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13459,
        GIR_EraseRootFromParent_Done,
      // Label 316: @16264
      GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16356), // Rule ID 13458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13458,
        GIR_EraseRootFromParent_Done,
      // Label 317: @16356
      GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(16448), // Rule ID 13489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13489,
        GIR_EraseRootFromParent_Done,
      // Label 318: @16448
      GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(16540), // Rule ID 13488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13488,
        GIR_EraseRootFromParent_Done,
      // Label 319: @16540
      GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(16632), // Rule ID 13457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13457,
        GIR_EraseRootFromParent_Done,
      // Label 320: @16632
      GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(16724), // Rule ID 2029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2029,
        GIR_EraseRootFromParent_Done,
      // Label 321: @16724
      GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(16816), // Rule ID 13487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13487,
        GIR_EraseRootFromParent_Done,
      // Label 322: @16816
      GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(16908), // Rule ID 2081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2081,
        GIR_EraseRootFromParent_Done,
      // Label 323: @16908
      GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(16959), // Rule ID 13402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13402,
        GIR_EraseRootFromParent_Done,
      // Label 324: @16959
      GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17010), // Rule ID 13372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13372,
        GIR_EraseRootFromParent_Done,
      // Label 325: @17010
      GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17061), // Rule ID 13401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13401,
        GIR_EraseRootFromParent_Done,
      // Label 326: @17061
      GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17112), // Rule ID 1801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1801,
        GIR_EraseRootFromParent_Done,
      // Label 327: @17112
      GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(17163), // Rule ID 1711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1711,
        GIR_EraseRootFromParent_Done,
      // Label 328: @17163
      GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(17214), // Rule ID 1800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1800,
        GIR_EraseRootFromParent_Done,
      // Label 329: @17214
      GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(17270), // Rule ID 13290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13290,
        GIR_EraseRootFromParent_Done,
      // Label 330: @17270
      GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(17326), // Rule ID 13302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13302,
        GIR_EraseRootFromParent_Done,
      // Label 331: @17326
      GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(17393), // Rule ID 13530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13530,
        GIR_EraseRootFromParent_Done,
      // Label 332: @17393
      GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17460), // Rule ID 13551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13551,
        GIR_EraseRootFromParent_Done,
      // Label 333: @17460
      GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(17516), // Rule ID 987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 987,
        GIR_EraseRootFromParent_Done,
      // Label 334: @17516
      GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(17572), // Rule ID 1048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1048,
        GIR_EraseRootFromParent_Done,
      // Label 335: @17572
      GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(17639), // Rule ID 2228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2228,
        GIR_EraseRootFromParent_Done,
      // Label 336: @17639
      GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(17706), // Rule ID 2287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2287,
        GIR_EraseRootFromParent_Done,
      // Label 337: @17706
      GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(17769), // Rule ID 1785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1785,
        GIR_EraseRootFromParent_Done,
      // Label 338: @17769
      GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(17832), // Rule ID 1784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1784,
        GIR_EraseRootFromParent_Done,
      // Label 339: @17832
      GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(17895), // Rule ID 1704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1704,
        GIR_EraseRootFromParent_Done,
      // Label 340: @17895
      GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(17958), // Rule ID 1783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1783,
        GIR_EraseRootFromParent_Done,
      // Label 341: @17958
      GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18021), // Rule ID 1782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1782,
        GIR_EraseRootFromParent_Done,
      // Label 342: @18021
      GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18082), // Rule ID 13377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13377,
        GIR_EraseRootFromParent_Done,
      // Label 343: @18082
      GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18143), // Rule ID 13407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13407,
        GIR_EraseRootFromParent_Done,
      // Label 344: @18143
      GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18191), // Rule ID 13400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13400,
        GIR_EraseRootFromParent_Done,
      // Label 345: @18191
      GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18239), // Rule ID 13289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13289,
        GIR_EraseRootFromParent_Done,
      // Label 346: @18239
      GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18287), // Rule ID 13371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13371,
        GIR_EraseRootFromParent_Done,
      // Label 347: @18287
      GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18335), // Rule ID 13301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13301,
        GIR_EraseRootFromParent_Done,
      // Label 348: @18335
      GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18383), // Rule ID 13399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13399,
        GIR_EraseRootFromParent_Done,
      // Label 349: @18383
      GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18444), // Rule ID 1716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1716,
        GIR_EraseRootFromParent_Done,
      // Label 350: @18444
      GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18505), // Rule ID 1806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1806,
        GIR_EraseRootFromParent_Done,
      // Label 351: @18505
      GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18553), // Rule ID 1799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1799,
        GIR_EraseRootFromParent_Done,
      // Label 352: @18553
      GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18601), // Rule ID 986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 986,
        GIR_EraseRootFromParent_Done,
      // Label 353: @18601
      GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18649), // Rule ID 1710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1710,
        GIR_EraseRootFromParent_Done,
      // Label 354: @18649
      GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18697), // Rule ID 1047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1047,
        GIR_EraseRootFromParent_Done,
      // Label 355: @18697
      GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18745), // Rule ID 1798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1798,
        GIR_EraseRootFromParent_Done,
      // Label 356: @18745
      GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(18772), // Rule ID 1094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1094,
        GIR_Done,
      // Label 357: @18772
      GIM_Reject,
    // Label 282: @18773
    GIM_Reject,
    // Label 159: @18774
    GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(22005),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(18921), // Rule ID 5393 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5393,
        GIR_EraseRootFromParent_Done,
      // Label 359: @18921
      GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19057), // Rule ID 5392 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5392,
        GIR_EraseRootFromParent_Done,
      // Label 360: @19057
      GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19193), // Rule ID 5408 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5408,
        GIR_EraseRootFromParent_Done,
      // Label 361: @19193
      GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19329), // Rule ID 5391 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5391,
        GIR_EraseRootFromParent_Done,
      // Label 362: @19329
      GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19465), // Rule ID 5390 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5390,
        GIR_EraseRootFromParent_Done,
      // Label 363: @19465
      GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19628), // Rule ID 13869 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13869,
        GIR_EraseRootFromParent_Done,
      // Label 364: @19628
      GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19791), // Rule ID 13866 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13866,
        GIR_EraseRootFromParent_Done,
      // Label 365: @19791
      GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19941), // Rule ID 13873 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13873,
        GIR_EraseRootFromParent_Done,
      // Label 366: @19941
      GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20091), // Rule ID 13878 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13878,
        GIR_EraseRootFromParent_Done,
      // Label 367: @20091
      GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20241), // Rule ID 13872 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13872,
        GIR_EraseRootFromParent_Done,
      // Label 368: @20241
      GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20404), // Rule ID 5381 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5381,
        GIR_EraseRootFromParent_Done,
      // Label 369: @20404
      GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20567), // Rule ID 5378 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5378,
        GIR_EraseRootFromParent_Done,
      // Label 370: @20567
      GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20717), // Rule ID 5403 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5403,
        GIR_EraseRootFromParent_Done,
      // Label 371: @20717
      GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20867), // Rule ID 5411 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5411,
        GIR_EraseRootFromParent_Done,
      // Label 372: @20867
      GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21017), // Rule ID 5402 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5402,
        GIR_EraseRootFromParent_Done,
      // Label 373: @21017
      GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21086), // Rule ID 13318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13318,
        GIR_EraseRootFromParent_Done,
      // Label 374: @21086
      GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21155), // Rule ID 13330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13330,
        GIR_EraseRootFromParent_Done,
      // Label 375: @21155
      GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21211), // Rule ID 13280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13280,
        GIR_EraseRootFromParent_Done,
      // Label 376: @21211
      GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21267), // Rule ID 13292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13292,
        GIR_EraseRootFromParent_Done,
      // Label 377: @21267
      GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21334), // Rule ID 13522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13522,
        GIR_EraseRootFromParent_Done,
      // Label 378: @21334
      GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21401), // Rule ID 13543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13543,
        GIR_EraseRootFromParent_Done,
      // Label 379: @21401
      GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21470), // Rule ID 1349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1349,
        GIR_EraseRootFromParent_Done,
      // Label 380: @21470
      GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21539), // Rule ID 1472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1472,
        GIR_EraseRootFromParent_Done,
      // Label 381: @21539
      GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21595), // Rule ID 977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 977,
        GIR_EraseRootFromParent_Done,
      // Label 382: @21595
      GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(21651), // Rule ID 1038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1038,
        GIR_EraseRootFromParent_Done,
      // Label 383: @21651
      GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(21718), // Rule ID 2220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2220,
        GIR_EraseRootFromParent_Done,
      // Label 384: @21718
      GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(21785), // Rule ID 2279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2279,
        GIR_EraseRootFromParent_Done,
      // Label 385: @21785
      GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(21833), // Rule ID 13279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13279,
        GIR_EraseRootFromParent_Done,
      // Label 386: @21833
      GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(21881), // Rule ID 13291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13291,
        GIR_EraseRootFromParent_Done,
      // Label 387: @21881
      GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(21929), // Rule ID 976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 976,
        GIR_EraseRootFromParent_Done,
      // Label 388: @21929
      GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(21977), // Rule ID 1037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1037,
        GIR_EraseRootFromParent_Done,
      // Label 389: @21977
      GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22004), // Rule ID 1090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1090,
        GIR_Done,
      // Label 390: @22004
      GIM_Reject,
    // Label 358: @22005
    GIM_Reject,
    // Label 160: @22006
    GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(28043),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22135), // Rule ID 13452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13452,
        GIR_EraseRootFromParent_Done,
      // Label 392: @22135
      GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(22253), // Rule ID 13453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13453,
        GIR_EraseRootFromParent_Done,
      // Label 393: @22253
      GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(22371), // Rule ID 13482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13482,
        GIR_EraseRootFromParent_Done,
      // Label 394: @22371
      GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(22489), // Rule ID 13483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13483,
        GIR_EraseRootFromParent_Done,
      // Label 395: @22489
      GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(22607), // Rule ID 2027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2027,
        GIR_EraseRootFromParent_Done,
      // Label 396: @22607
      GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(22725), // Rule ID 13451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13451,
        GIR_EraseRootFromParent_Done,
      // Label 397: @22725
      GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(22843), // Rule ID 2079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2079,
        GIR_EraseRootFromParent_Done,
      // Label 398: @22843
      GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(22961), // Rule ID 13481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13481,
        GIR_EraseRootFromParent_Done,
      // Label 399: @22961
      GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23048), // Rule ID 13362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13362,
        GIR_EraseRootFromParent_Done,
      // Label 400: @23048
      GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(23135), // Rule ID 13386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13386,
        GIR_EraseRootFromParent_Done,
      // Label 401: @23135
      GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(23222), // Rule ID 1683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1683,
        GIR_EraseRootFromParent_Done,
      // Label 402: @23222
      GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(23309), // Rule ID 1761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1761,
        GIR_EraseRootFromParent_Done,
      // Label 403: @23309
      GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(23424), // Rule ID 13447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13447,
        GIR_EraseRootFromParent_Done,
      // Label 404: @23424
      GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(23539), // Rule ID 13446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13446,
        GIR_EraseRootFromParent_Done,
      // Label 405: @23539
      GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(23654), // Rule ID 13477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13477,
        GIR_EraseRootFromParent_Done,
      // Label 406: @23654
      GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(23769), // Rule ID 13476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13476,
        GIR_EraseRootFromParent_Done,
      // Label 407: @23769
      GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(23838), // Rule ID 1781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1781,
        GIR_EraseRootFromParent_Done,
      // Label 408: @23838
      GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(23907), // Rule ID 1780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1780,
        GIR_EraseRootFromParent_Done,
      // Label 409: @23907
      GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(23976), // Rule ID 1703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1703,
        GIR_EraseRootFromParent_Done,
      // Label 410: @23976
      GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24045), // Rule ID 1779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1779,
        GIR_EraseRootFromParent_Done,
      // Label 411: @24045
      GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24114), // Rule ID 1778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1778,
        GIR_EraseRootFromParent_Done,
      // Label 412: @24114
      GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24229), // Rule ID 13445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13445,
        GIR_EraseRootFromParent_Done,
      // Label 413: @24229
      GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24344), // Rule ID 2025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2025,
        GIR_EraseRootFromParent_Done,
      // Label 414: @24344
      GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24459), // Rule ID 13475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13475,
        GIR_EraseRootFromParent_Done,
      // Label 415: @24459
      GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(24574), // Rule ID 2077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2077,
        GIR_EraseRootFromParent_Done,
      // Label 416: @24574
      GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24641), // Rule ID 13376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13376,
        GIR_EraseRootFromParent_Done,
      // Label 417: @24641
      GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(24708), // Rule ID 13406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13406,
        GIR_EraseRootFromParent_Done,
      // Label 418: @24708
      GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(24775), // Rule ID 1715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1715,
        GIR_EraseRootFromParent_Done,
      // Label 419: @24775
      GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(24842), // Rule ID 1805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1805,
        GIR_EraseRootFromParent_Done,
      // Label 420: @24842
      GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(24923), // Rule ID 13360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13360,
        GIR_EraseRootFromParent_Done,
      // Label 421: @24923
      GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25004), // Rule ID 13384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13384,
        GIR_EraseRootFromParent_Done,
      // Label 422: @25004
      GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25085), // Rule ID 1681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1681,
        GIR_EraseRootFromParent_Done,
      // Label 423: @25085
      GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25166), // Rule ID 1759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1759,
        GIR_EraseRootFromParent_Done,
      // Label 424: @25166
      GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25258), // Rule ID 13450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13450,
        GIR_EraseRootFromParent_Done,
      // Label 425: @25258
      GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25350), // Rule ID 13449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13449,
        GIR_EraseRootFromParent_Done,
      // Label 426: @25350
      GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(25442), // Rule ID 13480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13480,
        GIR_EraseRootFromParent_Done,
      // Label 427: @25442
      GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(25534), // Rule ID 13479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13479,
        GIR_EraseRootFromParent_Done,
      // Label 428: @25534
      GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(25626), // Rule ID 13448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13448,
        GIR_EraseRootFromParent_Done,
      // Label 429: @25626
      GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(25718), // Rule ID 2026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2026,
        GIR_EraseRootFromParent_Done,
      // Label 430: @25718
      GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(25810), // Rule ID 13478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13478,
        GIR_EraseRootFromParent_Done,
      // Label 431: @25810
      GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(25902), // Rule ID 2078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2078,
        GIR_EraseRootFromParent_Done,
      // Label 432: @25902
      GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(25953), // Rule ID 13398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13398,
        GIR_EraseRootFromParent_Done,
      // Label 433: @25953
      GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26004), // Rule ID 13370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13370,
        GIR_EraseRootFromParent_Done,
      // Label 434: @26004
      GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26055), // Rule ID 13397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13397,
        GIR_EraseRootFromParent_Done,
      // Label 435: @26055
      GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26106), // Rule ID 1797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1797,
        GIR_EraseRootFromParent_Done,
      // Label 436: @26106
      GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26157), // Rule ID 1709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1709,
        GIR_EraseRootFromParent_Done,
      // Label 437: @26157
      GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(26208), // Rule ID 1796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1796,
        GIR_EraseRootFromParent_Done,
      // Label 438: @26208
      GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(26277), // Rule ID 13324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 634:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13324,
        GIR_EraseRootFromParent_Done,
      // Label 439: @26277
      GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(26346), // Rule ID 13336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13336,
        GIR_EraseRootFromParent_Done,
      // Label 440: @26346
      GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(26402), // Rule ID 13286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13286,
        GIR_EraseRootFromParent_Done,
      // Label 441: @26402
      GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(26458), // Rule ID 13298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13298,
        GIR_EraseRootFromParent_Done,
      // Label 442: @26458
      GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(26525), // Rule ID 13528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13528,
        GIR_EraseRootFromParent_Done,
      // Label 443: @26525
      GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(26592), // Rule ID 13549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13549,
        GIR_EraseRootFromParent_Done,
      // Label 444: @26592
      GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(26661), // Rule ID 1355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 634:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1355,
        GIR_EraseRootFromParent_Done,
      // Label 445: @26661
      GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(26730), // Rule ID 1478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1478,
        GIR_EraseRootFromParent_Done,
      // Label 446: @26730
      GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(26786), // Rule ID 983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 983,
        GIR_EraseRootFromParent_Done,
      // Label 447: @26786
      GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(26842), // Rule ID 1044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1044,
        GIR_EraseRootFromParent_Done,
      // Label 448: @26842
      GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(26909), // Rule ID 2226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2226,
        GIR_EraseRootFromParent_Done,
      // Label 449: @26909
      GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(26976), // Rule ID 2285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2285,
        GIR_EraseRootFromParent_Done,
      // Label 450: @26976
      GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(27039), // Rule ID 1777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1777,
        GIR_EraseRootFromParent_Done,
      // Label 451: @27039
      GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(27102), // Rule ID 1776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1776,
        GIR_EraseRootFromParent_Done,
      // Label 452: @27102
      GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(27165), // Rule ID 1702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1702,
        GIR_EraseRootFromParent_Done,
      // Label 453: @27165
      GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(27228), // Rule ID 1775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1775,
        GIR_EraseRootFromParent_Done,
      // Label 454: @27228
      GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(27291), // Rule ID 1774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1774,
        GIR_EraseRootFromParent_Done,
      // Label 455: @27291
      GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(27352), // Rule ID 13375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13375,
        GIR_EraseRootFromParent_Done,
      // Label 456: @27352
      GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(27413), // Rule ID 13405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13405,
        GIR_EraseRootFromParent_Done,
      // Label 457: @27413
      GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(27461), // Rule ID 13396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13396,
        GIR_EraseRootFromParent_Done,
      // Label 458: @27461
      GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(27509), // Rule ID 13285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13285,
        GIR_EraseRootFromParent_Done,
      // Label 459: @27509
      GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(27557), // Rule ID 13369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13369,
        GIR_EraseRootFromParent_Done,
      // Label 460: @27557
      GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(27605), // Rule ID 13297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13297,
        GIR_EraseRootFromParent_Done,
      // Label 461: @27605
      GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(27653), // Rule ID 13395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13395,
        GIR_EraseRootFromParent_Done,
      // Label 462: @27653
      GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(27714), // Rule ID 1714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1714,
        GIR_EraseRootFromParent_Done,
      // Label 463: @27714
      GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(27775), // Rule ID 1804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1804,
        GIR_EraseRootFromParent_Done,
      // Label 464: @27775
      GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(27823), // Rule ID 1795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1795,
        GIR_EraseRootFromParent_Done,
      // Label 465: @27823
      GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(27871), // Rule ID 982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 982,
        GIR_EraseRootFromParent_Done,
      // Label 466: @27871
      GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(27919), // Rule ID 1708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1708,
        GIR_EraseRootFromParent_Done,
      // Label 467: @27919
      GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(27967), // Rule ID 1043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1043,
        GIR_EraseRootFromParent_Done,
      // Label 468: @27967
      GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(28015), // Rule ID 1794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1794,
        GIR_EraseRootFromParent_Done,
      // Label 469: @28015
      GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(28042), // Rule ID 1093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1093,
        GIR_Done,
      // Label 470: @28042
      GIM_Reject,
    // Label 391: @28043
    GIM_Reject,
    // Label 161: @28044
    GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(28627),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(28124), // Rule ID 13314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13314,
        GIR_EraseRootFromParent_Done,
      // Label 472: @28124
      GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(28193), // Rule ID 13326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13326,
        GIR_EraseRootFromParent_Done,
      // Label 473: @28193
      GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(28260), // Rule ID 13518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13518,
        GIR_EraseRootFromParent_Done,
      // Label 474: @28260
      GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(28327), // Rule ID 13539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13539,
        GIR_EraseRootFromParent_Done,
      // Label 475: @28327
      GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(28396), // Rule ID 1345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1345,
        GIR_EraseRootFromParent_Done,
      // Label 476: @28396
      GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(28465), // Rule ID 1468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1468,
        GIR_EraseRootFromParent_Done,
      // Label 477: @28465
      GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(28532), // Rule ID 2216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2216,
        GIR_EraseRootFromParent_Done,
      // Label 478: @28532
      GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(28599), // Rule ID 2275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2275,
        GIR_EraseRootFromParent_Done,
      // Label 479: @28599
      GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(28626), // Rule ID 1088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1088,
        GIR_Done,
      // Label 480: @28626
      GIM_Reject,
    // Label 471: @28627
    GIM_Reject,
    // Label 162: @28628
    GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(32065),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(28726), // Rule ID 13358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13358,
        GIR_EraseRootFromParent_Done,
      // Label 482: @28726
      GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(28813), // Rule ID 13382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13382,
        GIR_EraseRootFromParent_Done,
      // Label 483: @28813
      GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(28900), // Rule ID 1679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1679,
        GIR_EraseRootFromParent_Done,
      // Label 484: @28900
      GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(28987), // Rule ID 1757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1757,
        GIR_EraseRootFromParent_Done,
      // Label 485: @28987
      GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(29056), // Rule ID 1773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1773,
        GIR_EraseRootFromParent_Done,
      // Label 486: @29056
      GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(29125), // Rule ID 1772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1772,
        GIR_EraseRootFromParent_Done,
      // Label 487: @29125
      GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(29194), // Rule ID 1701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1701,
        GIR_EraseRootFromParent_Done,
      // Label 488: @29194
      GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(29263), // Rule ID 1771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1771,
        GIR_EraseRootFromParent_Done,
      // Label 489: @29263
      GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(29332), // Rule ID 1770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1770,
        GIR_EraseRootFromParent_Done,
      // Label 490: @29332
      GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(29399), // Rule ID 13374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13374,
        GIR_EraseRootFromParent_Done,
      // Label 491: @29399
      GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(29466), // Rule ID 13404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13404,
        GIR_EraseRootFromParent_Done,
      // Label 492: @29466
      GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(29533), // Rule ID 1713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1713,
        GIR_EraseRootFromParent_Done,
      // Label 493: @29533
      GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(29600), // Rule ID 1803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1803,
        GIR_EraseRootFromParent_Done,
      // Label 494: @29600
      GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(29681), // Rule ID 13356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13356,
        GIR_EraseRootFromParent_Done,
      // Label 495: @29681
      GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(29762), // Rule ID 13380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13380,
        GIR_EraseRootFromParent_Done,
      // Label 496: @29762
      GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(29843), // Rule ID 1677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1677,
        GIR_EraseRootFromParent_Done,
      // Label 497: @29843
      GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(29924), // Rule ID 1755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1755,
        GIR_EraseRootFromParent_Done,
      // Label 498: @29924
      GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(29975), // Rule ID 13394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13394,
        GIR_EraseRootFromParent_Done,
      // Label 499: @29975
      GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(30026), // Rule ID 13368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13368,
        GIR_EraseRootFromParent_Done,
      // Label 500: @30026
      GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(30077), // Rule ID 13393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13393,
        GIR_EraseRootFromParent_Done,
      // Label 501: @30077
      GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(30128), // Rule ID 1793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1793,
        GIR_EraseRootFromParent_Done,
      // Label 502: @30128
      GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(30179), // Rule ID 1707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1707,
        GIR_EraseRootFromParent_Done,
      // Label 503: @30179
      GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(30230), // Rule ID 1792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1792,
        GIR_EraseRootFromParent_Done,
      // Label 504: @30230
      GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(30299), // Rule ID 13320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 634:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13320,
        GIR_EraseRootFromParent_Done,
      // Label 505: @30299
      GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(30368), // Rule ID 13332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13332,
        GIR_EraseRootFromParent_Done,
      // Label 506: @30368
      GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(30424), // Rule ID 13282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13282,
        GIR_EraseRootFromParent_Done,
      // Label 507: @30424
      GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(30480), // Rule ID 13294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13294,
        GIR_EraseRootFromParent_Done,
      // Label 508: @30480
      GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(30547), // Rule ID 13524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13524,
        GIR_EraseRootFromParent_Done,
      // Label 509: @30547
      GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(30614), // Rule ID 13545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13545,
        GIR_EraseRootFromParent_Done,
      // Label 510: @30614
      GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(30683), // Rule ID 1351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 634:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1351,
        GIR_EraseRootFromParent_Done,
      // Label 511: @30683
      GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(30752), // Rule ID 1474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1474,
        GIR_EraseRootFromParent_Done,
      // Label 512: @30752
      GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(30808), // Rule ID 979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 979,
        GIR_EraseRootFromParent_Done,
      // Label 513: @30808
      GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(30864), // Rule ID 1040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1040,
        GIR_EraseRootFromParent_Done,
      // Label 514: @30864
      GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(30931), // Rule ID 2222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2222,
        GIR_EraseRootFromParent_Done,
      // Label 515: @30931
      GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(30998), // Rule ID 2281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2281,
        GIR_EraseRootFromParent_Done,
      // Label 516: @30998
      GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(31061), // Rule ID 1769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1769,
        GIR_EraseRootFromParent_Done,
      // Label 517: @31061
      GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(31124), // Rule ID 1768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1768,
        GIR_EraseRootFromParent_Done,
      // Label 518: @31124
      GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(31187), // Rule ID 1700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1700,
        GIR_EraseRootFromParent_Done,
      // Label 519: @31187
      GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(31250), // Rule ID 1767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1767,
        GIR_EraseRootFromParent_Done,
      // Label 520: @31250
      GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(31313), // Rule ID 1766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1766,
        GIR_EraseRootFromParent_Done,
      // Label 521: @31313
      GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(31374), // Rule ID 13373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13373,
        GIR_EraseRootFromParent_Done,
      // Label 522: @31374
      GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(31435), // Rule ID 13403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13403,
        GIR_EraseRootFromParent_Done,
      // Label 523: @31435
      GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(31483), // Rule ID 13392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13392,
        GIR_EraseRootFromParent_Done,
      // Label 524: @31483
      GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(31531), // Rule ID 13281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13281,
        GIR_EraseRootFromParent_Done,
      // Label 525: @31531
      GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(31579), // Rule ID 13367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13367,
        GIR_EraseRootFromParent_Done,
      // Label 526: @31579
      GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(31627), // Rule ID 13293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13293,
        GIR_EraseRootFromParent_Done,
      // Label 527: @31627
      GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(31675), // Rule ID 13391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13391,
        GIR_EraseRootFromParent_Done,
      // Label 528: @31675
      GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(31736), // Rule ID 1712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1712,
        GIR_EraseRootFromParent_Done,
      // Label 529: @31736
      GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(31797), // Rule ID 1802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1802,
        GIR_EraseRootFromParent_Done,
      // Label 530: @31797
      GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(31845), // Rule ID 1791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1791,
        GIR_EraseRootFromParent_Done,
      // Label 531: @31845
      GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(31893), // Rule ID 978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 978,
        GIR_EraseRootFromParent_Done,
      // Label 532: @31893
      GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(31941), // Rule ID 1706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1706,
        GIR_EraseRootFromParent_Done,
      // Label 533: @31941
      GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(31989), // Rule ID 1039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1039,
        GIR_EraseRootFromParent_Done,
      // Label 534: @31989
      GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(32037), // Rule ID 1790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1790,
        GIR_EraseRootFromParent_Done,
      // Label 535: @32037
      GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(32064), // Rule ID 1091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1091,
        GIR_Done,
      // Label 536: @32064
      GIM_Reject,
    // Label 481: @32065
    GIM_Reject,
    // Label 163: @32066
    GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(32649),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(32146), // Rule ID 13316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 634:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13316,
        GIR_EraseRootFromParent_Done,
      // Label 538: @32146
      GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(32215), // Rule ID 13328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13328,
        GIR_EraseRootFromParent_Done,
      // Label 539: @32215
      GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(32282), // Rule ID 13520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13520,
        GIR_EraseRootFromParent_Done,
      // Label 540: @32282
      GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(32349), // Rule ID 13541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13541,
        GIR_EraseRootFromParent_Done,
      // Label 541: @32349
      GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(32418), // Rule ID 1347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 634:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1347,
        GIR_EraseRootFromParent_Done,
      // Label 542: @32418
      GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(32487), // Rule ID 1470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1470,
        GIR_EraseRootFromParent_Done,
      // Label 543: @32487
      GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(32554), // Rule ID 2218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2218,
        GIR_EraseRootFromParent_Done,
      // Label 544: @32554
      GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(32621), // Rule ID 2277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2277,
        GIR_EraseRootFromParent_Done,
      // Label 545: @32621
      GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(32648), // Rule ID 1089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1089,
        GIR_Done,
      // Label 546: @32648
      GIM_Reject,
    // Label 537: @32649
    GIM_Reject,
    // Label 164: @32650
    GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(32675), // Rule ID 2736 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2736,
      GIR_Done,
    // Label 547: @32675
    GIM_Reject,
    // Label 165: @32676
    GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(32701), // Rule ID 2735 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2735,
      GIR_Done,
    // Label 548: @32701
    GIM_Reject,
    // Label 166: @32702
    GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(32727), // Rule ID 2734 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2734,
      GIR_Done,
    // Label 549: @32727
    GIM_Reject,
    // Label 167: @32728
    GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(32753), // Rule ID 2733 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2733,
      GIR_Done,
    // Label 550: @32753
    GIM_Reject,
    // Label 168: @32754
    GIM_Reject,
    // Label 1: @32755
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 564*/ GIMT_Encode4(46190),
    /*GILLT_s32*//*Label 551*/ GIMT_Encode4(32854),
    /*GILLT_s64*//*Label 552*/ GIMT_Encode4(33708), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 553*/ GIMT_Encode4(36738),
    /*GILLT_v2s64*//*Label 554*/ GIMT_Encode4(38273),
    /*GILLT_v4s16*//*Label 555*/ GIMT_Encode4(40733),
    /*GILLT_v4s32*//*Label 556*/ GIMT_Encode4(42268),
    /*GILLT_v8s8*//*Label 557*/ GIMT_Encode4(44728),
    /*GILLT_v8s16*//*Label 558*/ GIMT_Encode4(44803),
    /*GILLT_v16s8*//*Label 559*/ GIMT_Encode4(46011), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 560*/ GIMT_Encode4(46086), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 561*/ GIMT_Encode4(46112), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 562*/ GIMT_Encode4(46138), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 563*/ GIMT_Encode4(46164),
    // Label 551: @32854
    GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(33707),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(33017), // Rule ID 10153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10153,
        GIR_EraseRootFromParent_Done,
      // Label 566: @33017
      GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(33169), // Rule ID 10165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10165,
        GIR_EraseRootFromParent_Done,
      // Label 567: @33169
      GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(33321), // Rule ID 10177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10177,
        GIR_EraseRootFromParent_Done,
      // Label 568: @33321
      GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(33473), // Rule ID 10189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10189,
        GIR_EraseRootFromParent_Done,
      // Label 569: @33473
      GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(33535), // Rule ID 3921 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3921,
        GIR_EraseRootFromParent_Done,
      // Label 570: @33535
      GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(33571), // Rule ID 3886 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
        // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // R2
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3886,
        GIR_EraseRootFromParent_Done,
      // Label 571: @33571
      GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(33604), // Rule ID 3891 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3891,
        GIR_EraseRootFromParent_Done,
      // Label 572: @33604
      GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(33640), // Rule ID 3880 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
        // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3880,
        GIR_EraseRootFromParent_Done,
      // Label 573: @33640
      GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(33676), // Rule ID 3884 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3884,
        GIR_EraseRootFromParent_Done,
      // Label 574: @33676
      GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(33706), // Rule ID 3882 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3882,
        GIR_Done,
      // Label 575: @33706
      GIM_Reject,
    // Label 565: @33707
    GIM_Reject,
    // Label 552: @33708
    GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36737),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(33855), // Rule ID 5425 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5425,
        GIR_EraseRootFromParent_Done,
      // Label 577: @33855
      GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(33991), // Rule ID 5424 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5424,
        GIR_EraseRootFromParent_Done,
      // Label 578: @33991
      GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(34127), // Rule ID 5434 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5434,
        GIR_EraseRootFromParent_Done,
      // Label 579: @34127
      GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(34263), // Rule ID 5423 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5423,
        GIR_EraseRootFromParent_Done,
      // Label 580: @34263
      GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(34399), // Rule ID 5422 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5422,
        GIR_EraseRootFromParent_Done,
      // Label 581: @34399
      GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(34536), // Rule ID 3938 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3938,
        GIR_EraseRootFromParent_Done,
      // Label 582: @34536
      GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(34635), // Rule ID 3936 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3936,
        GIR_EraseRootFromParent_Done,
      // Label 583: @34635
      GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(34734), // Rule ID 3937 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3937,
        GIR_EraseRootFromParent_Done,
      // Label 584: @34734
      GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(34820), // Rule ID 3931 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3931,
        GIR_EraseRootFromParent_Done,
      // Label 585: @34820
      GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(34906), // Rule ID 3932 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3932,
        GIR_EraseRootFromParent_Done,
      // Label 586: @34906
      GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(35039), // Rule ID 3944 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3944,
        GIR_EraseRootFromParent_Done,
      // Label 587: @35039
      GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(35134), // Rule ID 3942 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3942,
        GIR_EraseRootFromParent_Done,
      // Label 588: @35134
      GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(35229), // Rule ID 3943 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3943,
        GIR_EraseRootFromParent_Done,
      // Label 589: @35229
      GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(35311), // Rule ID 136 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 136,
        GIR_EraseRootFromParent_Done,
      // Label 590: @35311
      GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(35393), // Rule ID 138 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 138,
        GIR_EraseRootFromParent_Done,
      // Label 591: @35393
      GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(35455), // Rule ID 3922 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3922,
        GIR_EraseRootFromParent_Done,
      // Label 592: @35455
      GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(35513), // Rule ID 10150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10150,
        GIR_EraseRootFromParent_Done,
      // Label 593: @35513
      GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(35571), // Rule ID 10162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10162,
        GIR_EraseRootFromParent_Done,
      // Label 594: @35571
      GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(35629), // Rule ID 10174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10174,
        GIR_EraseRootFromParent_Done,
      // Label 595: @35629
      GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(35687), // Rule ID 10186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10186,
        GIR_EraseRootFromParent_Done,
      // Label 596: @35687
      GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(35850), // Rule ID 5389 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5389,
        GIR_EraseRootFromParent_Done,
      // Label 597: @35850
      GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(36013), // Rule ID 5386 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5386,
        GIR_EraseRootFromParent_Done,
      // Label 598: @36013
      GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36163), // Rule ID 5431 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5431,
        GIR_EraseRootFromParent_Done,
      // Label 599: @36163
      GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36313), // Rule ID 5437 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5437,
        GIR_EraseRootFromParent_Done,
      // Label 600: @36313
      GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36463), // Rule ID 5430 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5430,
        GIR_EraseRootFromParent_Done,
      // Label 601: @36463
      GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36499), // Rule ID 3887 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
        // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // R2
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3887,
        GIR_EraseRootFromParent_Done,
      // Label 602: @36499
      GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36532), // Rule ID 3892 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3892,
        GIR_EraseRootFromParent_Done,
      // Label 603: @36532
      GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36568), // Rule ID 3881 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
        // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3881,
        GIR_EraseRootFromParent_Done,
      // Label 604: @36568
      GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(36604), // Rule ID 3885 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3885,
        GIR_EraseRootFromParent_Done,
      // Label 605: @36604
      GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36643), // Rule ID 1643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1643,
        GIR_EraseRootFromParent_Done,
      // Label 606: @36643
      GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(36679), // Rule ID 5270 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5270,
        GIR_EraseRootFromParent_Done,
      // Label 607: @36679
      GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(36706), // Rule ID 1632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1632,
        GIR_Done,
      // Label 608: @36706
      GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(36736), // Rule ID 3883 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3883,
        GIR_Done,
      // Label 609: @36736
      GIM_Reject,
    // Label 576: @36737
    GIM_Reject,
    // Label 553: @36738
    GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(38272),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(36885), // Rule ID 5421 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5421,
        GIR_EraseRootFromParent_Done,
      // Label 611: @36885
      GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37021), // Rule ID 5420 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5420,
        GIR_EraseRootFromParent_Done,
      // Label 612: @37021
      GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37157), // Rule ID 5433 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5433,
        GIR_EraseRootFromParent_Done,
      // Label 613: @37157
      GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37293), // Rule ID 5419 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5419,
        GIR_EraseRootFromParent_Done,
      // Label 614: @37293
      GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37429), // Rule ID 5418 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5418,
        GIR_EraseRootFromParent_Done,
      // Label 615: @37429
      GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(37592), // Rule ID 5388 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5388,
        GIR_EraseRootFromParent_Done,
      // Label 616: @37592
      GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(37755), // Rule ID 5385 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5385,
        GIR_EraseRootFromParent_Done,
      // Label 617: @37755
      GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(37905), // Rule ID 5429 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5429,
        GIR_EraseRootFromParent_Done,
      // Label 618: @37905
      GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38055), // Rule ID 5436 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5436,
        GIR_EraseRootFromParent_Done,
      // Label 619: @38055
      GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38205), // Rule ID 5428 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5428,
        GIR_EraseRootFromParent_Done,
      // Label 620: @38205
      GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38244), // Rule ID 957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 957,
        GIR_EraseRootFromParent_Done,
      // Label 621: @38244
      GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38271), // Rule ID 1464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1464,
        GIR_Done,
      // Label 622: @38271
      GIM_Reject,
    // Label 610: @38272
    GIM_Reject,
    // Label 554: @38273
    GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(40732),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38402), // Rule ID 2036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2036,
        GIR_EraseRootFromParent_Done,
      // Label 624: @38402
      GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38516), // Rule ID 13468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13468,
        GIR_EraseRootFromParent_Done,
      // Label 625: @38516
      GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(38630), // Rule ID 2088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2088,
        GIR_EraseRootFromParent_Done,
      // Label 626: @38630
      GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(38744), // Rule ID 13498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13498,
        GIR_EraseRootFromParent_Done,
      // Label 627: @38744
      GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(38809), // Rule ID 1843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1843,
        GIR_EraseRootFromParent_Done,
      // Label 628: @38809
      GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(38874), // Rule ID 1842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1842,
        GIR_EraseRootFromParent_Done,
      // Label 629: @38874
      GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(38939), // Rule ID 1747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1747,
        GIR_EraseRootFromParent_Done,
      // Label 630: @38939
      GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39004), // Rule ID 1841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1841,
        GIR_EraseRootFromParent_Done,
      // Label 631: @39004
      GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39069), // Rule ID 1840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1840,
        GIR_EraseRootFromParent_Done,
      // Label 632: @39069
      GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39180), // Rule ID 13466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13466,
        GIR_EraseRootFromParent_Done,
      // Label 633: @39180
      GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39291), // Rule ID 2034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2034,
        GIR_EraseRootFromParent_Done,
      // Label 634: @39291
      GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39402), // Rule ID 13496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13496,
        GIR_EraseRootFromParent_Done,
      // Label 635: @39402
      GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39513), // Rule ID 2086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2086,
        GIR_EraseRootFromParent_Done,
      // Label 636: @39513
      GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(39576), // Rule ID 1723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1723,
        GIR_EraseRootFromParent_Done,
      // Label 637: @39576
      GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(39639), // Rule ID 1813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1813,
        GIR_EraseRootFromParent_Done,
      // Label 638: @39639
      GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(39727), // Rule ID 13467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13467,
        GIR_EraseRootFromParent_Done,
      // Label 639: @39727
      GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(39815), // Rule ID 2035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2035,
        GIR_EraseRootFromParent_Done,
      // Label 640: @39815
      GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(39903), // Rule ID 13497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13497,
        GIR_EraseRootFromParent_Done,
      // Label 641: @39903
      GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(39991), // Rule ID 2087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2087,
        GIR_EraseRootFromParent_Done,
      // Label 642: @39991
      GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40038), // Rule ID 1855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1855,
        GIR_EraseRootFromParent_Done,
      // Label 643: @40038
      GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40085), // Rule ID 1753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1753,
        GIR_EraseRootFromParent_Done,
      // Label 644: @40085
      GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40132), // Rule ID 1854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1854,
        GIR_EraseRootFromParent_Done,
      // Label 645: @40132
      GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40191), // Rule ID 1839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1839,
        GIR_EraseRootFromParent_Done,
      // Label 646: @40191
      GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40250), // Rule ID 1838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1838,
        GIR_EraseRootFromParent_Done,
      // Label 647: @40250
      GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(40309), // Rule ID 1746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1746,
        GIR_EraseRootFromParent_Done,
      // Label 648: @40309
      GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40368), // Rule ID 1837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1837,
        GIR_EraseRootFromParent_Done,
      // Label 649: @40368
      GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(40427), // Rule ID 1836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1836,
        GIR_EraseRootFromParent_Done,
      // Label 650: @40427
      GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(40462), // Rule ID 959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 959,
        GIR_EraseRootFromParent_Done,
      // Label 651: @40462
      GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(40519), // Rule ID 1722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1722,
        GIR_EraseRootFromParent_Done,
      // Label 652: @40519
      GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(40576), // Rule ID 1812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1812,
        GIR_EraseRootFromParent_Done,
      // Label 653: @40576
      GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(40620), // Rule ID 1853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1853,
        GIR_EraseRootFromParent_Done,
      // Label 654: @40620
      GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(40664), // Rule ID 1752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1752,
        GIR_EraseRootFromParent_Done,
      // Label 655: @40664
      GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(40708), // Rule ID 1852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1852,
        GIR_EraseRootFromParent_Done,
      // Label 656: @40708
      GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(40731), // Rule ID 1466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1466,
        GIR_Done,
      // Label 657: @40731
      GIM_Reject,
    // Label 623: @40732
    GIM_Reject,
    // Label 555: @40733
    GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42267),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(40880), // Rule ID 5417 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5417,
        GIR_EraseRootFromParent_Done,
      // Label 659: @40880
      GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41016), // Rule ID 5416 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5416,
        GIR_EraseRootFromParent_Done,
      // Label 660: @41016
      GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41152), // Rule ID 5432 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5432,
        GIR_EraseRootFromParent_Done,
      // Label 661: @41152
      GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(41288), // Rule ID 5415 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5415,
        GIR_EraseRootFromParent_Done,
      // Label 662: @41288
      GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(41424), // Rule ID 5414 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5414,
        GIR_EraseRootFromParent_Done,
      // Label 663: @41424
      GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(41587), // Rule ID 5387 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5387,
        GIR_EraseRootFromParent_Done,
      // Label 664: @41587
      GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(41750), // Rule ID 5384 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5384,
        GIR_EraseRootFromParent_Done,
      // Label 665: @41750
      GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(41900), // Rule ID 5427 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5427,
        GIR_EraseRootFromParent_Done,
      // Label 666: @41900
      GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42050), // Rule ID 5435 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5435,
        GIR_EraseRootFromParent_Done,
      // Label 667: @42050
      GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42200), // Rule ID 5426 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5426,
        GIR_EraseRootFromParent_Done,
      // Label 668: @42200
      GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42239), // Rule ID 955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 955,
        GIR_EraseRootFromParent_Done,
      // Label 669: @42239
      GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42266), // Rule ID 1462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1462,
        GIR_Done,
      // Label 670: @42266
      GIM_Reject,
    // Label 658: @42267
    GIM_Reject,
    // Label 556: @42268
    GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(44727),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(42397), // Rule ID 2033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2033,
        GIR_EraseRootFromParent_Done,
      // Label 672: @42397
      GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(42511), // Rule ID 13465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13465,
        GIR_EraseRootFromParent_Done,
      // Label 673: @42511
      GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(42625), // Rule ID 2085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2085,
        GIR_EraseRootFromParent_Done,
      // Label 674: @42625
      GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(42739), // Rule ID 13495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13495,
        GIR_EraseRootFromParent_Done,
      // Label 675: @42739
      GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(42804), // Rule ID 1835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1835,
        GIR_EraseRootFromParent_Done,
      // Label 676: @42804
      GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(42869), // Rule ID 1834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1834,
        GIR_EraseRootFromParent_Done,
      // Label 677: @42869
      GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(42934), // Rule ID 1745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1745,
        GIR_EraseRootFromParent_Done,
      // Label 678: @42934
      GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(42999), // Rule ID 1833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1833,
        GIR_EraseRootFromParent_Done,
      // Label 679: @42999
      GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(43064), // Rule ID 1832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1832,
        GIR_EraseRootFromParent_Done,
      // Label 680: @43064
      GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(43175), // Rule ID 13463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13463,
        GIR_EraseRootFromParent_Done,
      // Label 681: @43175
      GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(43286), // Rule ID 2031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2031,
        GIR_EraseRootFromParent_Done,
      // Label 682: @43286
      GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(43397), // Rule ID 13493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13493,
        GIR_EraseRootFromParent_Done,
      // Label 683: @43397
      GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(43508), // Rule ID 2083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2083,
        GIR_EraseRootFromParent_Done,
      // Label 684: @43508
      GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(43571), // Rule ID 1721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1721,
        GIR_EraseRootFromParent_Done,
      // Label 685: @43571
      GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(43634), // Rule ID 1811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1811,
        GIR_EraseRootFromParent_Done,
      // Label 686: @43634
      GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(43722), // Rule ID 13464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13464,
        GIR_EraseRootFromParent_Done,
      // Label 687: @43722
      GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(43810), // Rule ID 2032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2032,
        GIR_EraseRootFromParent_Done,
      // Label 688: @43810
      GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(43898), // Rule ID 13494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13494,
        GIR_EraseRootFromParent_Done,
      // Label 689: @43898
      GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(43986), // Rule ID 2084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2084,
        GIR_EraseRootFromParent_Done,
      // Label 690: @43986
      GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44033), // Rule ID 1851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1851,
        GIR_EraseRootFromParent_Done,
      // Label 691: @44033
      GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44080), // Rule ID 1751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1751,
        GIR_EraseRootFromParent_Done,
      // Label 692: @44080
      GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44127), // Rule ID 1850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1850,
        GIR_EraseRootFromParent_Done,
      // Label 693: @44127
      GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44186), // Rule ID 1831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1831,
        GIR_EraseRootFromParent_Done,
      // Label 694: @44186
      GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44245), // Rule ID 1830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1830,
        GIR_EraseRootFromParent_Done,
      // Label 695: @44245
      GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44304), // Rule ID 1744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1744,
        GIR_EraseRootFromParent_Done,
      // Label 696: @44304
      GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44363), // Rule ID 1829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1829,
        GIR_EraseRootFromParent_Done,
      // Label 697: @44363
      GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(44422), // Rule ID 1828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1828,
        GIR_EraseRootFromParent_Done,
      // Label 698: @44422
      GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(44457), // Rule ID 958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 958,
        GIR_EraseRootFromParent_Done,
      // Label 699: @44457
      GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(44514), // Rule ID 1720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1720,
        GIR_EraseRootFromParent_Done,
      // Label 700: @44514
      GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(44571), // Rule ID 1810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1810,
        GIR_EraseRootFromParent_Done,
      // Label 701: @44571
      GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(44615), // Rule ID 1849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1849,
        GIR_EraseRootFromParent_Done,
      // Label 702: @44615
      GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(44659), // Rule ID 1750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1750,
        GIR_EraseRootFromParent_Done,
      // Label 703: @44659
      GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(44703), // Rule ID 1848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1848,
        GIR_EraseRootFromParent_Done,
      // Label 704: @44703
      GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(44726), // Rule ID 1465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1465,
        GIR_Done,
      // Label 705: @44726
      GIM_Reject,
    // Label 671: @44727
    GIM_Reject,
    // Label 557: @44728
    GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(44802),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(44778), // Rule ID 953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 953,
        GIR_EraseRootFromParent_Done,
      // Label 707: @44778
      GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(44801), // Rule ID 1460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1460,
        GIR_Done,
      // Label 708: @44801
      GIM_Reject,
    // Label 706: @44802
    GIM_Reject,
    // Label 558: @44803
    GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46010),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(44883), // Rule ID 1827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1827,
        GIR_EraseRootFromParent_Done,
      // Label 710: @44883
      GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(44948), // Rule ID 1826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1826,
        GIR_EraseRootFromParent_Done,
      // Label 711: @44948
      GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(45013), // Rule ID 1743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1743,
        GIR_EraseRootFromParent_Done,
      // Label 712: @45013
      GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(45078), // Rule ID 1825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1825,
        GIR_EraseRootFromParent_Done,
      // Label 713: @45078
      GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(45143), // Rule ID 1824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1824,
        GIR_EraseRootFromParent_Done,
      // Label 714: @45143
      GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(45206), // Rule ID 1719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1719,
        GIR_EraseRootFromParent_Done,
      // Label 715: @45206
      GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(45269), // Rule ID 1809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1809,
        GIR_EraseRootFromParent_Done,
      // Label 716: @45269
      GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(45316), // Rule ID 1847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1847,
        GIR_EraseRootFromParent_Done,
      // Label 717: @45316
      GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(45363), // Rule ID 1749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1749,
        GIR_EraseRootFromParent_Done,
      // Label 718: @45363
      GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(45410), // Rule ID 1846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1846,
        GIR_EraseRootFromParent_Done,
      // Label 719: @45410
      GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(45469), // Rule ID 1823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1823,
        GIR_EraseRootFromParent_Done,
      // Label 720: @45469
      GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(45528), // Rule ID 1822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1822,
        GIR_EraseRootFromParent_Done,
      // Label 721: @45528
      GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(45587), // Rule ID 1742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1742,
        GIR_EraseRootFromParent_Done,
      // Label 722: @45587
      GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(45646), // Rule ID 1821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1821,
        GIR_EraseRootFromParent_Done,
      // Label 723: @45646
      GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(45705), // Rule ID 1820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1820,
        GIR_EraseRootFromParent_Done,
      // Label 724: @45705
      GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(45740), // Rule ID 956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 956,
        GIR_EraseRootFromParent_Done,
      // Label 725: @45740
      GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(45797), // Rule ID 1718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1718,
        GIR_EraseRootFromParent_Done,
      // Label 726: @45797
      GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(45854), // Rule ID 1808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1808,
        GIR_EraseRootFromParent_Done,
      // Label 727: @45854
      GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(45898), // Rule ID 1845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1845,
        GIR_EraseRootFromParent_Done,
      // Label 728: @45898
      GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(45942), // Rule ID 1748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1748,
        GIR_EraseRootFromParent_Done,
      // Label 729: @45942
      GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(45986), // Rule ID 1844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1844,
        GIR_EraseRootFromParent_Done,
      // Label 730: @45986
      GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(46009), // Rule ID 1463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1463,
        GIR_Done,
      // Label 731: @46009
      GIM_Reject,
    // Label 709: @46010
    GIM_Reject,
    // Label 559: @46011
    GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(46085),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(46061), // Rule ID 954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 954,
        GIR_EraseRootFromParent_Done,
      // Label 733: @46061
      GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(46084), // Rule ID 1461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1461,
        GIR_Done,
      // Label 734: @46084
      GIM_Reject,
    // Label 732: @46085
    GIM_Reject,
    // Label 560: @46086
    GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(46111), // Rule ID 7575 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7575,
      GIR_Done,
    // Label 735: @46111
    GIM_Reject,
    // Label 561: @46112
    GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(46137), // Rule ID 7574 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7574,
      GIR_Done,
    // Label 736: @46137
    GIM_Reject,
    // Label 562: @46138
    GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(46163), // Rule ID 7573 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7573,
      GIR_Done,
    // Label 737: @46163
    GIM_Reject,
    // Label 563: @46164
    GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(46189), // Rule ID 7572 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7572,
      GIR_Done,
    // Label 738: @46189
    GIM_Reject,
    // Label 564: @46190
    GIM_Reject,
    // Label 2: @46191
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 747*/ GIMT_Encode4(48019),
    /*GILLT_s32*//*Label 739*/ GIMT_Encode4(46242),
    /*GILLT_s64*//*Label 740*/ GIMT_Encode4(46399), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 741*/ GIMT_Encode4(46943), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 742*/ GIMT_Encode4(47281),
    /*GILLT_v4s32*//*Label 743*/ GIMT_Encode4(47619),
    /*GILLT_v8s8*//*Label 744*/ GIMT_Encode4(47785),
    /*GILLT_v8s16*//*Label 745*/ GIMT_Encode4(47819),
    /*GILLT_v16s8*//*Label 746*/ GIMT_Encode4(47985),
    // Label 739: @46242
    GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(46398),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(46312), // Rule ID 3923 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3923,
        GIR_EraseRootFromParent_Done,
      // Label 749: @46312
      GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(46367), // Rule ID 13748 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13748,
        GIR_EraseRootFromParent_Done,
      // Label 750: @46367
      GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(46397), // Rule ID 3919 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3919,
        GIR_EraseRootFromParent_Done,
      // Label 751: @46397
      GIM_Reject,
    // Label 748: @46398
    GIM_Reject,
    // Label 740: @46399
    GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(46942),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(46469), // Rule ID 3924 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3924,
        GIR_EraseRootFromParent_Done,
      // Label 753: @46469
      GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(46524), // Rule ID 13749 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13749,
        GIR_EraseRootFromParent_Done,
      // Label 754: @46524
      GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(46637), // Rule ID 3935 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3935,
        GIR_EraseRootFromParent_Done,
      // Label 755: @46637
      GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(46712), // Rule ID 3933 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3933,
        GIR_EraseRootFromParent_Done,
      // Label 756: @46712
      GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(46787), // Rule ID 3934 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3934,
        GIR_EraseRootFromParent_Done,
      // Label 757: @46787
      GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46849), // Rule ID 3927 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3927,
        GIR_EraseRootFromParent_Done,
      // Label 758: @46849
      GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46911), // Rule ID 3930 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3930,
        GIR_EraseRootFromParent_Done,
      // Label 759: @46911
      GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46941), // Rule ID 3920 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3920,
        GIR_EraseRootFromParent_Done,
      // Label 760: @46941
      GIM_Reject,
    // Label 752: @46942
    GIM_Reject,
    // Label 741: @46943
    GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(47280),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(47044), // Rule ID 13442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13442,
        GIR_EraseRootFromParent_Done,
      // Label 762: @47044
      GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(47130), // Rule ID 2022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2022,
        GIR_EraseRootFromParent_Done,
      // Label 763: @47130
      GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(47193), // Rule ID 13443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13443,
        GIR_EraseRootFromParent_Done,
      // Label 764: @47193
      GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(47256), // Rule ID 2023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2023,
        GIR_EraseRootFromParent_Done,
      // Label 765: @47256
      GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(47279), // Rule ID 1340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1340,
        GIR_Done,
      // Label 766: @47279
      GIM_Reject,
    // Label 761: @47280
    GIM_Reject,
    // Label 742: @47281
    GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(47618),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(47382), // Rule ID 13439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13439,
        GIR_EraseRootFromParent_Done,
      // Label 768: @47382
      GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(47468), // Rule ID 2019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2019,
        GIR_EraseRootFromParent_Done,
      // Label 769: @47468
      GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(47531), // Rule ID 13440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13440,
        GIR_EraseRootFromParent_Done,
      // Label 770: @47531
      GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47594), // Rule ID 2020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2020,
        GIR_EraseRootFromParent_Done,
      // Label 771: @47594
      GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47617), // Rule ID 1338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1338,
        GIR_Done,
      // Label 772: @47617
      GIM_Reject,
    // Label 767: @47618
    GIM_Reject,
    // Label 743: @47619
    GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47784),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47697), // Rule ID 13444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13444,
        GIR_EraseRootFromParent_Done,
      // Label 774: @47697
      GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47760), // Rule ID 2024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2024,
        GIR_EraseRootFromParent_Done,
      // Label 775: @47760
      GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47783), // Rule ID 1341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1341,
        GIR_Done,
      // Label 776: @47783
      GIM_Reject,
    // Label 773: @47784
    GIM_Reject,
    // Label 744: @47785
    GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47818), // Rule ID 1336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1336,
      GIR_Done,
    // Label 777: @47818
    GIM_Reject,
    // Label 745: @47819
    GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47984),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(47897), // Rule ID 13441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13441,
        GIR_EraseRootFromParent_Done,
      // Label 779: @47897
      GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47960), // Rule ID 2021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2021,
        GIR_EraseRootFromParent_Done,
      // Label 780: @47960
      GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47983), // Rule ID 1339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1339,
        GIR_Done,
      // Label 781: @47983
      GIM_Reject,
    // Label 778: @47984
    GIM_Reject,
    // Label 746: @47985
    GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(48018), // Rule ID 1337 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1337,
      GIR_Done,
    // Label 782: @48018
    GIM_Reject,
    // Label 747: @48019
    GIM_Reject,
    // Label 3: @48020
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 785*/ GIMT_Encode4(48101),
    /*GILLT_s32*//*Label 783*/ GIMT_Encode4(48039),
    /*GILLT_s64*//*Label 784*/ GIMT_Encode4(48070),
    // Label 783: @48039
    GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48069), // Rule ID 129 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 129,
      GIR_Done,
    // Label 786: @48069
    GIM_Reject,
    // Label 784: @48070
    GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48100), // Rule ID 130 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 130,
      GIR_Done,
    // Label 787: @48100
    GIM_Reject,
    // Label 785: @48101
    GIM_Reject,
    // Label 4: @48102
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 790*/ GIMT_Encode4(48183),
    /*GILLT_s32*//*Label 788*/ GIMT_Encode4(48121),
    /*GILLT_s64*//*Label 789*/ GIMT_Encode4(48152),
    // Label 788: @48121
    GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48151), // Rule ID 127 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 127,
      GIR_Done,
    // Label 791: @48151
    GIM_Reject,
    // Label 789: @48152
    GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48182), // Rule ID 128 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 128,
      GIR_Done,
    // Label 792: @48182
    GIM_Reject,
    // Label 790: @48183
    GIM_Reject,
    // Label 5: @48184
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 811*/ GIMT_Encode4(51865),
    /*GILLT_s32*//*Label 793*/ GIMT_Encode4(48283),
    /*GILLT_s64*//*Label 794*/ GIMT_Encode4(48781), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 795*/ GIMT_Encode4(50216),
    /*GILLT_v2s64*//*Label 796*/ GIMT_Encode4(50376),
    /*GILLT_v4s16*//*Label 797*/ GIMT_Encode4(50536),
    /*GILLT_v4s32*//*Label 798*/ GIMT_Encode4(50696),
    /*GILLT_v8s8*//*Label 799*/ GIMT_Encode4(50856),
    /*GILLT_v8s16*//*Label 800*/ GIMT_Encode4(51016),
    /*GILLT_v16s8*//*Label 801*/ GIMT_Encode4(51176),
    /*GILLT_nxv1s1*//*Label 802*/ GIMT_Encode4(51336),
    /*GILLT_nxv2s1*//*Label 803*/ GIMT_Encode4(51421), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 804*/ GIMT_Encode4(51506),
    /*GILLT_nxv4s1*//*Label 805*/ GIMT_Encode4(51532), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 806*/ GIMT_Encode4(51617),
    /*GILLT_nxv8s1*//*Label 807*/ GIMT_Encode4(51643),
    /*GILLT_nxv8s16*//*Label 808*/ GIMT_Encode4(51728),
    /*GILLT_nxv16s1*//*Label 809*/ GIMT_Encode4(51754),
    /*GILLT_nxv16s8*//*Label 810*/ GIMT_Encode4(51839),
    // Label 793: @48283
    GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(48780),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(48349), // Rule ID 13201 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13201,
        GIR_EraseRootFromParent_Done,
      // Label 813: @48349
      GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(48404), // Rule ID 174 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 174,
        GIR_EraseRootFromParent_Done,
      // Label 814: @48404
      GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(48473), // Rule ID 5713 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5713,
        GIR_EraseRootFromParent_Done,
      // Label 815: @48473
      GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(48542), // Rule ID 5714 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5714,
        GIR_EraseRootFromParent_Done,
      // Label 816: @48542
      GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(48595), // Rule ID 13199 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13199,
        GIR_EraseRootFromParent_Done,
      // Label 817: @48595
      GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(48648), // Rule ID 172 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 172,
        GIR_EraseRootFromParent_Done,
      // Label 818: @48648
      GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(48689), // Rule ID 154 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 154,
        GIR_EraseRootFromParent_Done,
      // Label 819: @48689
      GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(48722), // Rule ID 13197 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13197,
        GIR_EraseRootFromParent_Done,
      // Label 820: @48722
      GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(48755), // Rule ID 170 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 170,
        GIR_EraseRootFromParent_Done,
      // Label 821: @48755
      GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(48779), // Rule ID 168 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 168,
        GIR_Done,
      // Label 822: @48779
      GIM_Reject,
    // Label 812: @48780
    GIM_Reject,
    // Label 794: @48781
    GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50215),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(48847), // Rule ID 13202 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13202,
        GIR_EraseRootFromParent_Done,
      // Label 824: @48847
      GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(48902), // Rule ID 175 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 175,
        GIR_EraseRootFromParent_Done,
      // Label 825: @48902
      GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(49015), // Rule ID 5715 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 5715,
        GIR_EraseRootFromParent_Done,
      // Label 826: @49015
      GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(49128), // Rule ID 5716 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 5716,
        GIR_EraseRootFromParent_Done,
      // Label 827: @49128
      GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(49227), // Rule ID 7294 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7294,
        GIR_EraseRootFromParent_Done,
      // Label 828: @49227
      GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(49326), // Rule ID 7295 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7295,
        GIR_EraseRootFromParent_Done,
      // Label 829: @49326
      GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(49425), // Rule ID 7296 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7296,
        GIR_EraseRootFromParent_Done,
      // Label 830: @49425
      GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(49524), // Rule ID 7301 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7301,
        GIR_EraseRootFromParent_Done,
      // Label 831: @49524
      GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(49623), // Rule ID 7302 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7302,
        GIR_EraseRootFromParent_Done,
      // Label 832: @49623
      GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(49722), // Rule ID 7303 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7303,
        GIR_EraseRootFromParent_Done,
      // Label 833: @49722
      GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(49775), // Rule ID 13200 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13200,
        GIR_EraseRootFromParent_Done,
      // Label 834: @49775
      GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(49828), // Rule ID 173 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 173,
        GIR_EraseRootFromParent_Done,
      // Label 835: @49828
      GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(49928), // Rule ID 3972 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 3972,
        GIR_EraseRootFromParent_Done,
      // Label 836: @49928
      GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(49969), // Rule ID 155 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 155,
        GIR_EraseRootFromParent_Done,
      // Label 837: @49969
      GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(50002), // Rule ID 13198 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13198,
        GIR_EraseRootFromParent_Done,
      // Label 838: @50002
      GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(50035), // Rule ID 171 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 171,
        GIR_EraseRootFromParent_Done,
      // Label 839: @50035
      GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(50099), // Rule ID 13853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13853,
        GIR_EraseRootFromParent_Done,
      // Label 840: @50099
      GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(50163), // Rule ID 5067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5067,
        GIR_EraseRootFromParent_Done,
      // Label 841: @50163
      GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(50187), // Rule ID 169 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 169,
        GIR_Done,
      // Label 842: @50187
      GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(50214), // Rule ID 2452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2452,
        GIR_Done,
      // Label 843: @50214
      GIM_Reject,
    // Label 823: @50215
    GIM_Reject,
    // Label 795: @50216
    GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(50375),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(50291), // Rule ID 13852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13852,
        GIR_EraseRootFromParent_Done,
      // Label 845: @50291
      GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(50351), // Rule ID 5066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5066,
        GIR_EraseRootFromParent_Done,
      // Label 846: @50351
      GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(50374), // Rule ID 2451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2451,
        GIR_Done,
      // Label 847: @50374
      GIM_Reject,
    // Label 844: @50375
    GIM_Reject,
    // Label 796: @50376
    GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(50535),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(50451), // Rule ID 13856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13856,
        GIR_EraseRootFromParent_Done,
      // Label 849: @50451
      GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(50511), // Rule ID 5070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5070,
        GIR_EraseRootFromParent_Done,
      // Label 850: @50511
      GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(50534), // Rule ID 2455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2455,
        GIR_Done,
      // Label 851: @50534
      GIM_Reject,
    // Label 848: @50535
    GIM_Reject,
    // Label 797: @50536
    GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(50695),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(50611), // Rule ID 13851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13851,
        GIR_EraseRootFromParent_Done,
      // Label 853: @50611
      GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(50671), // Rule ID 5065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5065,
        GIR_EraseRootFromParent_Done,
      // Label 854: @50671
      GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(50694), // Rule ID 2450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2450,
        GIR_Done,
      // Label 855: @50694
      GIM_Reject,
    // Label 852: @50695
    GIM_Reject,
    // Label 798: @50696
    GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(50855),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(50771), // Rule ID 13855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13855,
        GIR_EraseRootFromParent_Done,
      // Label 857: @50771
      GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(50831), // Rule ID 5069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5069,
        GIR_EraseRootFromParent_Done,
      // Label 858: @50831
      GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(50854), // Rule ID 2454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2454,
        GIR_Done,
      // Label 859: @50854
      GIM_Reject,
    // Label 856: @50855
    GIM_Reject,
    // Label 799: @50856
    GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(51015),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(50931), // Rule ID 13337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13337,
        GIR_EraseRootFromParent_Done,
      // Label 861: @50931
      GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(50991), // Rule ID 1585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1585,
        GIR_EraseRootFromParent_Done,
      // Label 862: @50991
      GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(51014), // Rule ID 1583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1583,
        GIR_Done,
      // Label 863: @51014
      GIM_Reject,
    // Label 860: @51015
    GIM_Reject,
    // Label 800: @51016
    GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(51175),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(51091), // Rule ID 13854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13854,
        GIR_EraseRootFromParent_Done,
      // Label 865: @51091
      GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(51151), // Rule ID 5068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5068,
        GIR_EraseRootFromParent_Done,
      // Label 866: @51151
      GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(51174), // Rule ID 2453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2453,
        GIR_Done,
      // Label 867: @51174
      GIM_Reject,
    // Label 864: @51175
    GIM_Reject,
    // Label 801: @51176
    GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(51335),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(51251), // Rule ID 13338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13338,
        GIR_EraseRootFromParent_Done,
      // Label 869: @51251
      GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(51311), // Rule ID 1586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1586,
        GIR_EraseRootFromParent_Done,
      // Label 870: @51311
      GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(51334), // Rule ID 1584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1584,
        GIR_Done,
      // Label 871: @51334
      GIM_Reject,
    // Label 868: @51335
    GIM_Reject,
    // Label 802: @51336
    GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(51420),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(51398), // Rule ID 10954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10954,
        GIR_EraseRootFromParent_Done,
      // Label 873: @51398
      GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(51419), // Rule ID 2709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2709,
        GIR_EraseRootFromParent_Done,
      // Label 874: @51419
      GIM_Reject,
    // Label 872: @51420
    GIM_Reject,
    // Label 803: @51421
    GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(51505),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(51483), // Rule ID 10953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10953,
        GIR_EraseRootFromParent_Done,
      // Label 876: @51483
      GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(51504), // Rule ID 2708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2708,
        GIR_EraseRootFromParent_Done,
      // Label 877: @51504
      GIM_Reject,
    // Label 875: @51505
    GIM_Reject,
    // Label 804: @51506
    GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(51531), // Rule ID 3139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3139,
      GIR_Done,
    // Label 878: @51531
    GIM_Reject,
    // Label 805: @51532
    GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(51616),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(51594), // Rule ID 10952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10952,
        GIR_EraseRootFromParent_Done,
      // Label 880: @51594
      GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(51615), // Rule ID 2707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2707,
        GIR_EraseRootFromParent_Done,
      // Label 881: @51615
      GIM_Reject,
    // Label 879: @51616
    GIM_Reject,
    // Label 806: @51617
    GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(51642), // Rule ID 3138 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3138,
      GIR_Done,
    // Label 882: @51642
    GIM_Reject,
    // Label 807: @51643
    GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(51727),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(51705), // Rule ID 10951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10951,
        GIR_EraseRootFromParent_Done,
      // Label 884: @51705
      GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(51726), // Rule ID 2706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2706,
        GIR_EraseRootFromParent_Done,
      // Label 885: @51726
      GIM_Reject,
    // Label 883: @51727
    GIM_Reject,
    // Label 808: @51728
    GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(51753), // Rule ID 3137 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3137,
      GIR_Done,
    // Label 886: @51753
    GIM_Reject,
    // Label 809: @51754
    GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(51838),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(51816), // Rule ID 10950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10950,
        GIR_EraseRootFromParent_Done,
      // Label 888: @51816
      GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(51837), // Rule ID 2705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2705,
        GIR_EraseRootFromParent_Done,
      // Label 889: @51837
      GIM_Reject,
    // Label 887: @51838
    GIM_Reject,
    // Label 810: @51839
    GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(51864), // Rule ID 3136 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3136,
      GIR_Done,
    // Label 890: @51864
    GIM_Reject,
    // Label 811: @51865
    GIM_Reject,
    // Label 6: @51866
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 909*/ GIMT_Encode4(63912),
    /*GILLT_s32*//*Label 891*/ GIMT_Encode4(51965),
    /*GILLT_s64*//*Label 892*/ GIMT_Encode4(52325), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 893*/ GIMT_Encode4(54492),
    /*GILLT_v2s64*//*Label 894*/ GIMT_Encode4(55800),
    /*GILLT_v4s16*//*Label 895*/ GIMT_Encode4(57108),
    /*GILLT_v4s32*//*Label 896*/ GIMT_Encode4(58416),
    /*GILLT_v8s8*//*Label 897*/ GIMT_Encode4(59724),
    /*GILLT_v8s16*//*Label 898*/ GIMT_Encode4(61032),
    /*GILLT_v16s8*//*Label 899*/ GIMT_Encode4(62340),
    /*GILLT_nxv1s1*//*Label 900*/ GIMT_Encode4(63648),
    /*GILLT_nxv2s1*//*Label 901*/ GIMT_Encode4(63680), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 902*/ GIMT_Encode4(63712),
    /*GILLT_nxv4s1*//*Label 903*/ GIMT_Encode4(63738), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 904*/ GIMT_Encode4(63770),
    /*GILLT_nxv8s1*//*Label 905*/ GIMT_Encode4(63796),
    /*GILLT_nxv8s16*//*Label 906*/ GIMT_Encode4(63828),
    /*GILLT_nxv16s1*//*Label 907*/ GIMT_Encode4(63854),
    /*GILLT_nxv16s8*//*Label 908*/ GIMT_Encode4(63886),
    // Label 891: @51965
    GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(52324),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(52031), // Rule ID 13221 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13221,
        GIR_EraseRootFromParent_Done,
      // Label 911: @52031
      GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(52086), // Rule ID 186 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 186,
        GIR_EraseRootFromParent_Done,
      // Label 912: @52086
      GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(52127), // Rule ID 158 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 158,
        GIR_EraseRootFromParent_Done,
      // Label 913: @52127
      GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(52160), // Rule ID 13223 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13223,
        GIR_EraseRootFromParent_Done,
      // Label 914: @52160
      GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(52193), // Rule ID 190 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 190,
        GIR_EraseRootFromParent_Done,
      // Label 915: @52193
      GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(52246), // Rule ID 13219 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13219,
        GIR_EraseRootFromParent_Done,
      // Label 916: @52246
      GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(52299), // Rule ID 184 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 184,
        GIR_EraseRootFromParent_Done,
      // Label 917: @52299
      GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(52323), // Rule ID 188 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 188,
        GIR_Done,
      // Label 918: @52323
      GIM_Reject,
    // Label 910: @52324
    GIM_Reject,
    // Label 892: @52325
    GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(54491),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(52458), // Rule ID 3985 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3985,
        GIR_EraseRootFromParent_Done,
      // Label 920: @52458
      GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(52580), // Rule ID 13771 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13771,
        GIR_EraseRootFromParent_Done,
      // Label 921: @52580
      GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(52635), // Rule ID 13222 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13222,
        GIR_EraseRootFromParent_Done,
      // Label 922: @52635
      GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(52690), // Rule ID 187 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 187,
        GIR_EraseRootFromParent_Done,
      // Label 923: @52690
      GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(52799), // Rule ID 13571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13571,
        GIR_EraseRootFromParent_Done,
      // Label 924: @52799
      GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(52908), // Rule ID 13570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13570,
        GIR_EraseRootFromParent_Done,
      // Label 925: @52908
      GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(53017), // Rule ID 13573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13573,
        GIR_EraseRootFromParent_Done,
      // Label 926: @53017
      GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(53126), // Rule ID 13572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13572,
        GIR_EraseRootFromParent_Done,
      // Label 927: @53126
      GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(53235), // Rule ID 2439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2439,
        GIR_EraseRootFromParent_Done,
      // Label 928: @53235
      GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(53344), // Rule ID 13568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13568,
        GIR_EraseRootFromParent_Done,
      // Label 929: @53344
      GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(53453), // Rule ID 13567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13567,
        GIR_EraseRootFromParent_Done,
      // Label 930: @53453
      GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(53562), // Rule ID 13569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13569,
        GIR_EraseRootFromParent_Done,
      // Label 931: @53562
      GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(53603), // Rule ID 159 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 159,
        GIR_EraseRootFromParent_Done,
      // Label 932: @53603
      GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(53636), // Rule ID 13224 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13224,
        GIR_EraseRootFromParent_Done,
      // Label 933: @53636
      GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(53669), // Rule ID 191 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 191,
        GIR_EraseRootFromParent_Done,
      // Label 934: @53669
      GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(53736), // Rule ID 13507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13507,
        GIR_EraseRootFromParent_Done,
      // Label 935: @53736
      GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(53803), // Rule ID 13895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13895,
        GIR_EraseRootFromParent_Done,
      // Label 936: @53803
      GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(53870), // Rule ID 13510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13510,
        GIR_EraseRootFromParent_Done,
      // Label 937: @53870
      GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(53937), // Rule ID 13898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13898,
        GIR_EraseRootFromParent_Done,
      // Label 938: @53937
      GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(53990), // Rule ID 13220 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13220,
        GIR_EraseRootFromParent_Done,
      // Label 939: @53990
      GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(54057), // Rule ID 2108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2108,
        GIR_EraseRootFromParent_Done,
      // Label 940: @54057
      GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(54124), // Rule ID 6339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6339,
        GIR_EraseRootFromParent_Done,
      // Label 941: @54124
      GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(54191), // Rule ID 2117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2117,
        GIR_EraseRootFromParent_Done,
      // Label 942: @54191
      GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(54258), // Rule ID 6345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6345,
        GIR_EraseRootFromParent_Done,
      // Label 943: @54258
      GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(54311), // Rule ID 185 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 185,
        GIR_EraseRootFromParent_Done,
      // Label 944: @54311
      GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(54375), // Rule ID 13859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13859,
        GIR_EraseRootFromParent_Done,
      // Label 945: @54375
      GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(54439), // Rule ID 5079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5079,
        GIR_EraseRootFromParent_Done,
      // Label 946: @54439
      GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(54463), // Rule ID 189 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 189,
        GIR_Done,
      // Label 947: @54463
      GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(54490), // Rule ID 5085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5085,
        GIR_Done,
      // Label 948: @54490
      GIM_Reject,
    // Label 919: @54491
    GIM_Reject,
    // Label 893: @54492
    GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(55799),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(54612), // Rule ID 13564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13564,
        GIR_EraseRootFromParent_Done,
      // Label 950: @54612
      GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(54721), // Rule ID 13563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13563,
        GIR_EraseRootFromParent_Done,
      // Label 951: @54721
      GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(54830), // Rule ID 13566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13566,
        GIR_EraseRootFromParent_Done,
      // Label 952: @54830
      GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(54939), // Rule ID 13565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13565,
        GIR_EraseRootFromParent_Done,
      // Label 953: @54939
      GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(55048), // Rule ID 2438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2438,
        GIR_EraseRootFromParent_Done,
      // Label 954: @55048
      GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(55157), // Rule ID 13561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13561,
        GIR_EraseRootFromParent_Done,
      // Label 955: @55157
      GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(55266), // Rule ID 13560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13560,
        GIR_EraseRootFromParent_Done,
      // Label 956: @55266
      GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(55375), // Rule ID 13562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13562,
        GIR_EraseRootFromParent_Done,
      // Label 957: @55375
      GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(55442), // Rule ID 13527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13527,
        GIR_EraseRootFromParent_Done,
      // Label 958: @55442
      GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(55509), // Rule ID 13548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13548,
        GIR_EraseRootFromParent_Done,
      // Label 959: @55509
      GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(55576), // Rule ID 2225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2225,
        GIR_EraseRootFromParent_Done,
      // Label 960: @55576
      GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(55643), // Rule ID 2284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2284,
        GIR_EraseRootFromParent_Done,
      // Label 961: @55643
      GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(55707), // Rule ID 13858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13858,
        GIR_EraseRootFromParent_Done,
      // Label 962: @55707
      GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(55771), // Rule ID 5078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5078,
        GIR_EraseRootFromParent_Done,
      // Label 963: @55771
      GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(55798), // Rule ID 5084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5084,
        GIR_Done,
      // Label 964: @55798
      GIM_Reject,
    // Label 949: @55799
    GIM_Reject,
    // Label 894: @55800
    GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(57107),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(55920), // Rule ID 13592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13592,
        GIR_EraseRootFromParent_Done,
      // Label 966: @55920
      GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(56029), // Rule ID 13591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13591,
        GIR_EraseRootFromParent_Done,
      // Label 967: @56029
      GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(56138), // Rule ID 13594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13594,
        GIR_EraseRootFromParent_Done,
      // Label 968: @56138
      GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(56247), // Rule ID 13593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13593,
        GIR_EraseRootFromParent_Done,
      // Label 969: @56247
      GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(56356), // Rule ID 2442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2442,
        GIR_EraseRootFromParent_Done,
      // Label 970: @56356
      GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(56465), // Rule ID 13589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13589,
        GIR_EraseRootFromParent_Done,
      // Label 971: @56465
      GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(56574), // Rule ID 13588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13588,
        GIR_EraseRootFromParent_Done,
      // Label 972: @56574
      GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(56683), // Rule ID 13590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13590,
        GIR_EraseRootFromParent_Done,
      // Label 973: @56683
      GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(56750), // Rule ID 13531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13531,
        GIR_EraseRootFromParent_Done,
      // Label 974: @56750
      GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(56817), // Rule ID 13552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13552,
        GIR_EraseRootFromParent_Done,
      // Label 975: @56817
      GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(56884), // Rule ID 2229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2229,
        GIR_EraseRootFromParent_Done,
      // Label 976: @56884
      GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(56951), // Rule ID 2288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2288,
        GIR_EraseRootFromParent_Done,
      // Label 977: @56951
      GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(57015), // Rule ID 13862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13862,
        GIR_EraseRootFromParent_Done,
      // Label 978: @57015
      GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(57079), // Rule ID 5082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5082,
        GIR_EraseRootFromParent_Done,
      // Label 979: @57079
      GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(57106), // Rule ID 5088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5088,
        GIR_Done,
      // Label 980: @57106
      GIM_Reject,
    // Label 965: @57107
    GIM_Reject,
    // Label 895: @57108
    GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(58415),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(57228), // Rule ID 13557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13557,
        GIR_EraseRootFromParent_Done,
      // Label 982: @57228
      GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(57337), // Rule ID 13556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13556,
        GIR_EraseRootFromParent_Done,
      // Label 983: @57337
      GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(57446), // Rule ID 13559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13559,
        GIR_EraseRootFromParent_Done,
      // Label 984: @57446
      GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(57555), // Rule ID 13558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13558,
        GIR_EraseRootFromParent_Done,
      // Label 985: @57555
      GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(57664), // Rule ID 2437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2437,
        GIR_EraseRootFromParent_Done,
      // Label 986: @57664
      GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(57773), // Rule ID 13554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13554,
        GIR_EraseRootFromParent_Done,
      // Label 987: @57773
      GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(57882), // Rule ID 13553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13553,
        GIR_EraseRootFromParent_Done,
      // Label 988: @57882
      GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(57991), // Rule ID 13555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13555,
        GIR_EraseRootFromParent_Done,
      // Label 989: @57991
      GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(58058), // Rule ID 13523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13523,
        GIR_EraseRootFromParent_Done,
      // Label 990: @58058
      GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(58125), // Rule ID 13544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13544,
        GIR_EraseRootFromParent_Done,
      // Label 991: @58125
      GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(58192), // Rule ID 2221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2221,
        GIR_EraseRootFromParent_Done,
      // Label 992: @58192
      GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(58259), // Rule ID 2280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2280,
        GIR_EraseRootFromParent_Done,
      // Label 993: @58259
      GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(58323), // Rule ID 13857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13857,
        GIR_EraseRootFromParent_Done,
      // Label 994: @58323
      GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(58387), // Rule ID 5077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5077,
        GIR_EraseRootFromParent_Done,
      // Label 995: @58387
      GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(58414), // Rule ID 5083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5083,
        GIR_Done,
      // Label 996: @58414
      GIM_Reject,
    // Label 981: @58415
    GIM_Reject,
    // Label 896: @58416
    GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(59723),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(58536), // Rule ID 13585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13585,
        GIR_EraseRootFromParent_Done,
      // Label 998: @58536
      GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(58645), // Rule ID 13584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13584,
        GIR_EraseRootFromParent_Done,
      // Label 999: @58645
      GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(58754), // Rule ID 13587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13587,
        GIR_EraseRootFromParent_Done,
      // Label 1000: @58754
      GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(58863), // Rule ID 13586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13586,
        GIR_EraseRootFromParent_Done,
      // Label 1001: @58863
      GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(58972), // Rule ID 2441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2441,
        GIR_EraseRootFromParent_Done,
      // Label 1002: @58972
      GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(59081), // Rule ID 13582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13582,
        GIR_EraseRootFromParent_Done,
      // Label 1003: @59081
      GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(59190), // Rule ID 13581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13581,
        GIR_EraseRootFromParent_Done,
      // Label 1004: @59190
      GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(59299), // Rule ID 13583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13583,
        GIR_EraseRootFromParent_Done,
      // Label 1005: @59299
      GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(59366), // Rule ID 13529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13529,
        GIR_EraseRootFromParent_Done,
      // Label 1006: @59366
      GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(59433), // Rule ID 13550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13550,
        GIR_EraseRootFromParent_Done,
      // Label 1007: @59433
      GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(59500), // Rule ID 2227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2227,
        GIR_EraseRootFromParent_Done,
      // Label 1008: @59500
      GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(59567), // Rule ID 2286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2286,
        GIR_EraseRootFromParent_Done,
      // Label 1009: @59567
      GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(59631), // Rule ID 13861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13861,
        GIR_EraseRootFromParent_Done,
      // Label 1010: @59631
      GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(59695), // Rule ID 5081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5081,
        GIR_EraseRootFromParent_Done,
      // Label 1011: @59695
      GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(59722), // Rule ID 5087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5087,
        GIR_Done,
      // Label 1012: @59722
      GIM_Reject,
    // Label 997: @59723
    GIM_Reject,
    // Label 897: @59724
    GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61031),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(59844), // Rule ID 13345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13345,
        GIR_EraseRootFromParent_Done,
      // Label 1014: @59844
      GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(59953), // Rule ID 13344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13344,
        GIR_EraseRootFromParent_Done,
      // Label 1015: @59953
      GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(60062), // Rule ID 13347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13347,
        GIR_EraseRootFromParent_Done,
      // Label 1016: @60062
      GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(60171), // Rule ID 13346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13346,
        GIR_EraseRootFromParent_Done,
      // Label 1017: @60171
      GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(60280), // Rule ID 1593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1593,
        GIR_EraseRootFromParent_Done,
      // Label 1018: @60280
      GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(60389), // Rule ID 13342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13342,
        GIR_EraseRootFromParent_Done,
      // Label 1019: @60389
      GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(60498), // Rule ID 13341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13341,
        GIR_EraseRootFromParent_Done,
      // Label 1020: @60498
      GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(60607), // Rule ID 13343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13343,
        GIR_EraseRootFromParent_Done,
      // Label 1021: @60607
      GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(60674), // Rule ID 13519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13519,
        GIR_EraseRootFromParent_Done,
      // Label 1022: @60674
      GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(60741), // Rule ID 13540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13540,
        GIR_EraseRootFromParent_Done,
      // Label 1023: @60741
      GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(60808), // Rule ID 2217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2217,
        GIR_EraseRootFromParent_Done,
      // Label 1024: @60808
      GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(60875), // Rule ID 2276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2276,
        GIR_EraseRootFromParent_Done,
      // Label 1025: @60875
      GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(60939), // Rule ID 13339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13339,
        GIR_EraseRootFromParent_Done,
      // Label 1026: @60939
      GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(61003), // Rule ID 1589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1589,
        GIR_EraseRootFromParent_Done,
      // Label 1027: @61003
      GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(61030), // Rule ID 1591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1591,
        GIR_Done,
      // Label 1028: @61030
      GIM_Reject,
    // Label 1013: @61031
    GIM_Reject,
    // Label 898: @61032
    GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(62339),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(61152), // Rule ID 13578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13578,
        GIR_EraseRootFromParent_Done,
      // Label 1030: @61152
      GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(61261), // Rule ID 13577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13577,
        GIR_EraseRootFromParent_Done,
      // Label 1031: @61261
      GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(61370), // Rule ID 13580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13580,
        GIR_EraseRootFromParent_Done,
      // Label 1032: @61370
      GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61479), // Rule ID 13579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13579,
        GIR_EraseRootFromParent_Done,
      // Label 1033: @61479
      GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61588), // Rule ID 2440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2440,
        GIR_EraseRootFromParent_Done,
      // Label 1034: @61588
      GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61697), // Rule ID 13575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13575,
        GIR_EraseRootFromParent_Done,
      // Label 1035: @61697
      GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61806), // Rule ID 13574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13574,
        GIR_EraseRootFromParent_Done,
      // Label 1036: @61806
      GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61915), // Rule ID 13576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13576,
        GIR_EraseRootFromParent_Done,
      // Label 1037: @61915
      GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61982), // Rule ID 13525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13525,
        GIR_EraseRootFromParent_Done,
      // Label 1038: @61982
      GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(62049), // Rule ID 13546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13546,
        GIR_EraseRootFromParent_Done,
      // Label 1039: @62049
      GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(62116), // Rule ID 2223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2223,
        GIR_EraseRootFromParent_Done,
      // Label 1040: @62116
      GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(62183), // Rule ID 2282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2282,
        GIR_EraseRootFromParent_Done,
      // Label 1041: @62183
      GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(62247), // Rule ID 13860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13860,
        GIR_EraseRootFromParent_Done,
      // Label 1042: @62247
      GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(62311), // Rule ID 5080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5080,
        GIR_EraseRootFromParent_Done,
      // Label 1043: @62311
      GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(62338), // Rule ID 5086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5086,
        GIR_Done,
      // Label 1044: @62338
      GIM_Reject,
    // Label 1029: @62339
    GIM_Reject,
    // Label 899: @62340
    GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(63647),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(62460), // Rule ID 13352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13352,
        GIR_EraseRootFromParent_Done,
      // Label 1046: @62460
      GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(62569), // Rule ID 13351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13351,
        GIR_EraseRootFromParent_Done,
      // Label 1047: @62569
      GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62678), // Rule ID 13354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13354,
        GIR_EraseRootFromParent_Done,
      // Label 1048: @62678
      GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62787), // Rule ID 13353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13353,
        GIR_EraseRootFromParent_Done,
      // Label 1049: @62787
      GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62896), // Rule ID 1594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1594,
        GIR_EraseRootFromParent_Done,
      // Label 1050: @62896
      GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(63005), // Rule ID 13349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13349,
        GIR_EraseRootFromParent_Done,
      // Label 1051: @63005
      GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(63114), // Rule ID 13348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13348,
        GIR_EraseRootFromParent_Done,
      // Label 1052: @63114
      GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(63223), // Rule ID 13350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13350,
        GIR_EraseRootFromParent_Done,
      // Label 1053: @63223
      GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(63290), // Rule ID 13521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13521,
        GIR_EraseRootFromParent_Done,
      // Label 1054: @63290
      GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(63357), // Rule ID 13542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13542,
        GIR_EraseRootFromParent_Done,
      // Label 1055: @63357
      GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(63424), // Rule ID 2219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2219,
        GIR_EraseRootFromParent_Done,
      // Label 1056: @63424
      GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(63491), // Rule ID 2278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2278,
        GIR_EraseRootFromParent_Done,
      // Label 1057: @63491
      GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(63555), // Rule ID 13340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13340,
        GIR_EraseRootFromParent_Done,
      // Label 1058: @63555
      GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63619), // Rule ID 1590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1590,
        GIR_EraseRootFromParent_Done,
      // Label 1059: @63619
      GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63646), // Rule ID 1592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1592,
        GIR_Done,
      // Label 1060: @63646
      GIM_Reject,
    // Label 1045: @63647
    GIM_Reject,
    // Label 900: @63648
    GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63679), // Rule ID 8613 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8613,
      GIR_EraseRootFromParent_Done,
    // Label 1061: @63679
    GIM_Reject,
    // Label 901: @63680
    GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63711), // Rule ID 8612 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8612,
      GIR_EraseRootFromParent_Done,
    // Label 1062: @63711
    GIM_Reject,
    // Label 902: @63712
    GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63737), // Rule ID 7595 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7595,
      GIR_Done,
    // Label 1063: @63737
    GIM_Reject,
    // Label 903: @63738
    GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63769), // Rule ID 8611 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8611,
      GIR_EraseRootFromParent_Done,
    // Label 1064: @63769
    GIM_Reject,
    // Label 904: @63770
    GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63795), // Rule ID 7594 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7594,
      GIR_Done,
    // Label 1065: @63795
    GIM_Reject,
    // Label 905: @63796
    GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63827), // Rule ID 8610 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8610,
      GIR_EraseRootFromParent_Done,
    // Label 1066: @63827
    GIM_Reject,
    // Label 906: @63828
    GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63853), // Rule ID 7593 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7593,
      GIR_Done,
    // Label 1067: @63853
    GIM_Reject,
    // Label 907: @63854
    GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63885), // Rule ID 8609 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8609,
      GIR_EraseRootFromParent_Done,
    // Label 1068: @63885
    GIM_Reject,
    // Label 908: @63886
    GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63911), // Rule ID 7592 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7592,
      GIR_Done,
    // Label 1069: @63911
    GIM_Reject,
    // Label 909: @63912
    GIM_Reject,
    // Label 7: @63913
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1088*/ GIMT_Encode4(68103),
    /*GILLT_s32*//*Label 1070*/ GIMT_Encode4(64012),
    /*GILLT_s64*//*Label 1071*/ GIMT_Encode4(64692), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1072*/ GIMT_Encode4(65435),
    /*GILLT_v2s64*//*Label 1073*/ GIMT_Encode4(65503),
    /*GILLT_v4s16*//*Label 1074*/ GIMT_Encode4(66029),
    /*GILLT_v4s32*//*Label 1075*/ GIMT_Encode4(66097),
    /*GILLT_v8s8*//*Label 1076*/ GIMT_Encode4(66623),
    /*GILLT_v8s16*//*Label 1077*/ GIMT_Encode4(66694),
    /*GILLT_v16s8*//*Label 1078*/ GIMT_Encode4(67220),
    /*GILLT_nxv1s1*//*Label 1079*/ GIMT_Encode4(67749),
    /*GILLT_nxv2s1*//*Label 1080*/ GIMT_Encode4(67799), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 1081*/ GIMT_Encode4(67849),
    /*GILLT_nxv4s1*//*Label 1082*/ GIMT_Encode4(67875), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 1083*/ GIMT_Encode4(67925),
    /*GILLT_nxv8s1*//*Label 1084*/ GIMT_Encode4(67951),
    /*GILLT_nxv8s16*//*Label 1085*/ GIMT_Encode4(68001),
    /*GILLT_nxv16s1*//*Label 1086*/ GIMT_Encode4(68027),
    /*GILLT_nxv16s8*//*Label 1087*/ GIMT_Encode4(68077),
    // Label 1070: @64012
    GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64691),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64081), // Rule ID 13210 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13210,
        GIR_EraseRootFromParent_Done,
      // Label 1090: @64081
      GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64136), // Rule ID 13209 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13209,
        GIR_EraseRootFromParent_Done,
      // Label 1091: @64136
      GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64194), // Rule ID 13207 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13207,
        GIR_EraseRootFromParent_Done,
      // Label 1092: @64194
      GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64252), // Rule ID 178 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 178,
        GIR_EraseRootFromParent_Done,
      // Label 1093: @64252
      GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(64310), // Rule ID 13208 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13208,
        GIR_EraseRootFromParent_Done,
      // Label 1094: @64310
      GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(64365), // Rule ID 13211 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13211,
        GIR_EraseRootFromParent_Done,
      // Label 1095: @64365
      GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(64406), // Rule ID 156 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 156,
        GIR_EraseRootFromParent_Done,
      // Label 1096: @64406
      GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(64439), // Rule ID 13217 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13217,
        GIR_EraseRootFromParent_Done,
      // Label 1097: @64439
      GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(64472), // Rule ID 182 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 182,
        GIR_EraseRootFromParent_Done,
      // Label 1098: @64472
      GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(64525), // Rule ID 13203 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13203,
        GIR_EraseRootFromParent_Done,
      // Label 1099: @64525
      GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(64581), // Rule ID 176 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 176,
        GIR_EraseRootFromParent_Done,
      // Label 1100: @64581
      GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(64634), // Rule ID 13204 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13204,
        GIR_EraseRootFromParent_Done,
      // Label 1101: @64634
      GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(64666), // Rule ID 3970 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // Wm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3970,
        GIR_EraseRootFromParent_Done,
      // Label 1102: @64666
      GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(64690), // Rule ID 180 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 180,
        GIR_Done,
      // Label 1103: @64690
      GIM_Reject,
    // Label 1089: @64691
    GIM_Reject,
    // Label 1071: @64692
    GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65434),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(64761), // Rule ID 13215 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13215,
        GIR_EraseRootFromParent_Done,
      // Label 1105: @64761
      GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(64816), // Rule ID 13214 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13214,
        GIR_EraseRootFromParent_Done,
      // Label 1106: @64816
      GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(64874), // Rule ID 13212 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13212,
        GIR_EraseRootFromParent_Done,
      // Label 1107: @64874
      GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(64932), // Rule ID 179 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 179,
        GIR_EraseRootFromParent_Done,
      // Label 1108: @64932
      GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(64990), // Rule ID 13213 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13213,
        GIR_EraseRootFromParent_Done,
      // Label 1109: @64990
      GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(65045), // Rule ID 13216 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13216,
        GIR_EraseRootFromParent_Done,
      // Label 1110: @65045
      GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(65086), // Rule ID 157 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 157,
        GIR_EraseRootFromParent_Done,
      // Label 1111: @65086
      GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(65119), // Rule ID 13218 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13218,
        GIR_EraseRootFromParent_Done,
      // Label 1112: @65119
      GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(65152), // Rule ID 183 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 183,
        GIR_EraseRootFromParent_Done,
      // Label 1113: @65152
      GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(65205), // Rule ID 13205 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13205,
        GIR_EraseRootFromParent_Done,
      // Label 1114: @65205
      GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(65261), // Rule ID 177 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 177,
        GIR_EraseRootFromParent_Done,
      // Label 1115: @65261
      GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(65314), // Rule ID 13206 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13206,
        GIR_EraseRootFromParent_Done,
      // Label 1116: @65314
      GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(65346), // Rule ID 3971 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // Xm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3971,
        GIR_EraseRootFromParent_Done,
      // Label 1117: @65346
      GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(65382), // Rule ID 4973 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4973,
        GIR_EraseRootFromParent_Done,
      // Label 1118: @65382
      GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(65406), // Rule ID 181 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 181,
        GIR_Done,
      // Label 1119: @65406
      GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(65433), // Rule ID 5073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5073,
        GIR_Done,
      // Label 1120: @65433
      GIM_Reject,
    // Label 1104: @65434
    GIM_Reject,
    // Label 1072: @65435
    GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(65502),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(65482), // Rule ID 4971 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4971,
        GIR_EraseRootFromParent_Done,
      // Label 1122: @65482
      GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(65501), // Rule ID 5072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5072,
        GIR_Done,
      // Label 1123: @65501
      GIM_Reject,
    // Label 1121: @65502
    GIM_Reject,
    // Label 1073: @65503
    GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(66028),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(65603), // Rule ID 13740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13740,
        GIR_EraseRootFromParent_Done,
      // Label 1125: @65603
      GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(65688), // Rule ID 13739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13739,
        GIR_EraseRootFromParent_Done,
      // Label 1126: @65688
      GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(65773), // Rule ID 13738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13738,
        GIR_EraseRootFromParent_Done,
      // Label 1127: @65773
      GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(65858), // Rule ID 3798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3798,
        GIR_EraseRootFromParent_Done,
      // Label 1128: @65858
      GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(65890), // Rule ID 4974 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4974,
        GIR_EraseRootFromParent_Done,
      // Label 1129: @65890
      GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(65947), // Rule ID 3794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3794,
        GIR_EraseRootFromParent_Done,
      // Label 1130: @65947
      GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(66004), // Rule ID 13728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13728,
        GIR_EraseRootFromParent_Done,
      // Label 1131: @66004
      GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(66027), // Rule ID 5076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5076,
        GIR_Done,
      // Label 1132: @66027
      GIM_Reject,
    // Label 1124: @66028
    GIM_Reject,
    // Label 1074: @66029
    GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(66096),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(66076), // Rule ID 4969 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4969,
        GIR_EraseRootFromParent_Done,
      // Label 1134: @66076
      GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(66095), // Rule ID 5071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5071,
        GIR_Done,
      // Label 1135: @66095
      GIM_Reject,
    // Label 1133: @66096
    GIM_Reject,
    // Label 1075: @66097
    GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(66622),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(66197), // Rule ID 13737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13737,
        GIR_EraseRootFromParent_Done,
      // Label 1137: @66197
      GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(66282), // Rule ID 13736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13736,
        GIR_EraseRootFromParent_Done,
      // Label 1138: @66282
      GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(66367), // Rule ID 13735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13735,
        GIR_EraseRootFromParent_Done,
      // Label 1139: @66367
      GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(66452), // Rule ID 3797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3797,
        GIR_EraseRootFromParent_Done,
      // Label 1140: @66452
      GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(66484), // Rule ID 4972 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4972,
        GIR_EraseRootFromParent_Done,
      // Label 1141: @66484
      GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(66541), // Rule ID 3793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3793,
        GIR_EraseRootFromParent_Done,
      // Label 1142: @66541
      GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(66598), // Rule ID 13727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13727,
        GIR_EraseRootFromParent_Done,
      // Label 1143: @66598
      GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(66621), // Rule ID 5075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5075,
        GIR_Done,
      // Label 1144: @66621
      GIM_Reject,
    // Label 1136: @66622
    GIM_Reject,
    // Label 1076: @66623
    GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(66693),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(66673), // Rule ID 960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 960,
        GIR_EraseRootFromParent_Done,
      // Label 1146: @66673
      GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(66692), // Rule ID 1587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1587,
        GIR_Done,
      // Label 1147: @66692
      GIM_Reject,
    // Label 1145: @66693
    GIM_Reject,
    // Label 1077: @66694
    GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(67219),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(66794), // Rule ID 13734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13734,
        GIR_EraseRootFromParent_Done,
      // Label 1149: @66794
      GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(66879), // Rule ID 13733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13733,
        GIR_EraseRootFromParent_Done,
      // Label 1150: @66879
      GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(66964), // Rule ID 13732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13732,
        GIR_EraseRootFromParent_Done,
      // Label 1151: @66964
      GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(67049), // Rule ID 3796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3796,
        GIR_EraseRootFromParent_Done,
      // Label 1152: @67049
      GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(67081), // Rule ID 4970 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4970,
        GIR_EraseRootFromParent_Done,
      // Label 1153: @67081
      GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(67138), // Rule ID 3792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3792,
        GIR_EraseRootFromParent_Done,
      // Label 1154: @67138
      GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(67195), // Rule ID 13726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13726,
        GIR_EraseRootFromParent_Done,
      // Label 1155: @67195
      GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(67218), // Rule ID 5074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5074,
        GIR_Done,
      // Label 1156: @67218
      GIM_Reject,
    // Label 1148: @67219
    GIM_Reject,
    // Label 1078: @67220
    GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(67748),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(67320), // Rule ID 13731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13731,
        GIR_EraseRootFromParent_Done,
      // Label 1158: @67320
      GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(67405), // Rule ID 13730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13730,
        GIR_EraseRootFromParent_Done,
      // Label 1159: @67405
      GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(67490), // Rule ID 13729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13729,
        GIR_EraseRootFromParent_Done,
      // Label 1160: @67490
      GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(67575), // Rule ID 3795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3795,
        GIR_EraseRootFromParent_Done,
      // Label 1161: @67575
      GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(67610), // Rule ID 961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 961,
        GIR_EraseRootFromParent_Done,
      // Label 1162: @67610
      GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(67667), // Rule ID 3791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3791,
        GIR_EraseRootFromParent_Done,
      // Label 1163: @67667
      GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(67724), // Rule ID 13725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13725,
        GIR_EraseRootFromParent_Done,
      // Label 1164: @67724
      GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(67747), // Rule ID 1588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1588,
        GIR_Done,
      // Label 1165: @67747
      GIM_Reject,
    // Label 1157: @67748
    GIM_Reject,
    // Label 1079: @67749
    GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(67798), // Rule ID 8603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8603,
      GIR_EraseRootFromParent_Done,
    // Label 1166: @67798
    GIM_Reject,
    // Label 1080: @67799
    GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(67848), // Rule ID 8602 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8602,
      GIR_EraseRootFromParent_Done,
    // Label 1167: @67848
    GIM_Reject,
    // Label 1081: @67849
    GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(67874), // Rule ID 7599 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7599,
      GIR_Done,
    // Label 1168: @67874
    GIM_Reject,
    // Label 1082: @67875
    GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(67924), // Rule ID 8601 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8601,
      GIR_EraseRootFromParent_Done,
    // Label 1169: @67924
    GIM_Reject,
    // Label 1083: @67925
    GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(67950), // Rule ID 7598 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7598,
      GIR_Done,
    // Label 1170: @67950
    GIM_Reject,
    // Label 1084: @67951
    GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(68000), // Rule ID 8600 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8600,
      GIR_EraseRootFromParent_Done,
    // Label 1171: @68000
    GIM_Reject,
    // Label 1085: @68001
    GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(68026), // Rule ID 7597 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7597,
      GIR_Done,
    // Label 1172: @68026
    GIM_Reject,
    // Label 1086: @68027
    GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(68076), // Rule ID 8599 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8599,
      GIR_EraseRootFromParent_Done,
    // Label 1173: @68076
    GIM_Reject,
    // Label 1087: @68077
    GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(68102), // Rule ID 7596 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7596,
      GIR_Done,
    // Label 1174: @68102
    GIM_Reject,
    // Label 1088: @68103
    GIM_Reject,
    // Label 8: @68104
    GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(75544),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1187*/ GIMT_Encode4(75543),
      /*GILLT_v2s64*//*Label 1176*/ GIMT_Encode4(68191), GIMT_Encode4(0),
      /*GILLT_v4s32*//*Label 1177*/ GIMT_Encode4(68712), GIMT_Encode4(0),
      /*GILLT_v8s16*//*Label 1178*/ GIMT_Encode4(70995),
      /*GILLT_v16s8*//*Label 1179*/ GIMT_Encode4(73537), GIMT_Encode4(0),
      /*GILLT_nxv2s1*//*Label 1180*/ GIMT_Encode4(75319), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
      /*GILLT_nxv4s1*//*Label 1181*/ GIMT_Encode4(75345),
      /*GILLT_nxv4s16*//*Label 1182*/ GIMT_Encode4(75371),
      /*GILLT_nxv4s32*//*Label 1183*/ GIMT_Encode4(75418),
      /*GILLT_nxv8s1*//*Label 1184*/ GIMT_Encode4(75444),
      /*GILLT_nxv8s16*//*Label 1185*/ GIMT_Encode4(75470),
      /*GILLT_nxv16s1*//*Label 1186*/ GIMT_Encode4(75517),
      // Label 1176: @68191
      GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(68711),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(68272), // Rule ID 5839 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5839,
          GIR_EraseRootFromParent_Done,
        // Label 1189: @68272
        GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(68334), // Rule ID 5843 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5843,
          GIR_EraseRootFromParent_Done,
        // Label 1190: @68334
        GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(68392), // Rule ID 5840 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5840,
          GIR_EraseRootFromParent_Done,
        // Label 1191: @68392
        GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(68450), // Rule ID 5844 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5844,
          GIR_EraseRootFromParent_Done,
        // Label 1192: @68450
        GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(68580), // Rule ID 5838 //
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5838,
          GIR_EraseRootFromParent_Done,
        // Label 1193: @68580
        GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(68710), // Rule ID 5842 //
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5842,
          GIR_EraseRootFromParent_Done,
        // Label 1194: @68710
        GIM_Reject,
      // Label 1188: @68711
      GIM_Reject,
      // Label 1177: @68712
      GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(70994),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(68849), // Rule ID 5443 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5443,
          GIR_EraseRootFromParent_Done,
        // Label 1196: @68849
        GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(68971), // Rule ID 5449 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5449,
          GIR_EraseRootFromParent_Done,
        // Label 1197: @68971
        GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(69073), // Rule ID 5610 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[4] Operand 2
          GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5610,
          GIR_EraseRootFromParent_Done,
        // Label 1198: @69073
        GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(69202), // Rule ID 6392 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
          GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6392,
          GIR_EraseRootFromParent_Done,
        // Label 1199: @69202
        GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(69244), // Rule ID 5849 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
          // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5849,
          GIR_EraseRootFromParent_Done,
        // Label 1200: @69244
        GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(69286), // Rule ID 5853 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
          // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5853,
          GIR_EraseRootFromParent_Done,
        // Label 1201: @69286
        GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(69409), // Rule ID 2536 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
          // MIs[2] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2536,
          GIR_EraseRootFromParent_Done,
        // Label 1202: @69409
        GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(69532), // Rule ID 6360 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6360,
          GIR_EraseRootFromParent_Done,
        // Label 1203: @69532
        GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(69652), // Rule ID 6398 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6398,
          GIR_EraseRootFromParent_Done,
        // Label 1204: @69652
        GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(69769), // Rule ID 2463 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 561:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2463,
          GIR_EraseRootFromParent_Done,
        // Label 1205: @69769
        GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(69886), // Rule ID 5371 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5371,
          GIR_EraseRootFromParent_Done,
        // Label 1206: @69886
        GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(70003), // Rule ID 5374 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 631:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5374,
          GIR_EraseRootFromParent_Done,
        // Label 1207: @70003
        GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(70120), // Rule ID 5377 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 633:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5377,
          GIR_EraseRootFromParent_Done,
        // Label 1208: @70120
        GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(70224), // Rule ID 2459 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2459,
          GIR_EraseRootFromParent_Done,
        // Label 1209: @70224
        GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(70280), // Rule ID 5543 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5543,
          GIR_EraseRootFromParent_Done,
        // Label 1210: @70280
        GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(70346), // Rule ID 5847 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5847,
          GIR_EraseRootFromParent_Done,
        // Label 1211: @70346
        GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(70412), // Rule ID 5851 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5851,
          GIR_EraseRootFromParent_Done,
        // Label 1212: @70412
        GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(70505), // Rule ID 4936 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4936,
          GIR_EraseRootFromParent_Done,
        // Label 1213: @70505
        GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(70601), // Rule ID 4983 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4983,
          GIR_EraseRootFromParent_Done,
        // Label 1214: @70601
        GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(70663), // Rule ID 5848 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5848,
          GIR_EraseRootFromParent_Done,
        // Label 1215: @70663
        GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(70725), // Rule ID 5852 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5852,
          GIR_EraseRootFromParent_Done,
        // Label 1216: @70725
        GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(70859), // Rule ID 5846 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5846,
          GIR_EraseRootFromParent_Done,
        // Label 1217: @70859
        GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(70993), // Rule ID 5850 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5850,
          GIR_EraseRootFromParent_Done,
        // Label 1218: @70993
        GIM_Reject,
      // Label 1195: @70994
      GIM_Reject,
      // Label 1178: @70995
      GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73536),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(71132), // Rule ID 5442 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5442,
          GIR_EraseRootFromParent_Done,
        // Label 1220: @71132
        GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(71254), // Rule ID 5448 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5448,
          GIR_EraseRootFromParent_Done,
        // Label 1221: @71254
        GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(71356), // Rule ID 5609 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[4] Operand 2
          GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5609,
          GIR_EraseRootFromParent_Done,
        // Label 1222: @71356
        GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(71485), // Rule ID 6391 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
          GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6391,
          GIR_EraseRootFromParent_Done,
        // Label 1223: @71485
        GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(71527), // Rule ID 5857 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
          // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5857,
          GIR_EraseRootFromParent_Done,
        // Label 1224: @71527
        GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(71569), // Rule ID 5861 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
          // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5861,
          GIR_EraseRootFromParent_Done,
        // Label 1225: @71569
        GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(71692), // Rule ID 2534 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
          // MIs[2] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2534,
          GIR_EraseRootFromParent_Done,
        // Label 1226: @71692
        GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(71815), // Rule ID 6359 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6359,
          GIR_EraseRootFromParent_Done,
        // Label 1227: @71815
        GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(71935), // Rule ID 6397 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6397,
          GIR_EraseRootFromParent_Done,
        // Label 1228: @71935
        GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(72052), // Rule ID 2462 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 561:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2462,
          GIR_EraseRootFromParent_Done,
        // Label 1229: @72052
        GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(72169), // Rule ID 5370 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5370,
          GIR_EraseRootFromParent_Done,
        // Label 1230: @72169
        GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(72286), // Rule ID 5373 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 631:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5373,
          GIR_EraseRootFromParent_Done,
        // Label 1231: @72286
        GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(72403), // Rule ID 5376 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 633:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5376,
          GIR_EraseRootFromParent_Done,
        // Label 1232: @72403
        GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(72504), // Rule ID 4930 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4930,
          GIR_EraseRootFromParent_Done,
        // Label 1233: @72504
        GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(72560), // Rule ID 5534 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5534,
          GIR_EraseRootFromParent_Done,
        // Label 1234: @72560
        GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(72626), // Rule ID 5855 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5855,
          GIR_EraseRootFromParent_Done,
        // Label 1235: @72626
        GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(72692), // Rule ID 5859 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5859,
          GIR_EraseRootFromParent_Done,
        // Label 1236: @72692
        GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(72758), // Rule ID 5863 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8bf16] } V64:{ *:[v4bf16] }:$Rn, immAllZerosV:{ *:[v4bf16] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4bf16] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5863,
          GIR_EraseRootFromParent_Done,
        // Label 1237: @72758
        GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(72851), // Rule ID 4938 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4938,
          GIR_EraseRootFromParent_Done,
        // Label 1238: @72851
        GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(72947), // Rule ID 4982 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4982,
          GIR_EraseRootFromParent_Done,
        // Label 1239: @72947
        GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(73009), // Rule ID 5856 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5856,
          GIR_EraseRootFromParent_Done,
        // Label 1240: @73009
        GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(73071), // Rule ID 5860 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5860,
          GIR_EraseRootFromParent_Done,
        // Label 1241: @73071
        GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(73133), // Rule ID 5864 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8bf16] } V64:{ *:[v4bf16] }:$Rn, (undef:{ *:[v4bf16] }))  =>  (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5864,
          GIR_EraseRootFromParent_Done,
        // Label 1242: @73133
        GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(73267), // Rule ID 5854 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5854,
          GIR_EraseRootFromParent_Done,
        // Label 1243: @73267
        GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(73401), // Rule ID 5858 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5858,
          GIR_EraseRootFromParent_Done,
        // Label 1244: @73401
        GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(73535), // Rule ID 5862 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v8bf16] } V64:{ *:[v4bf16] }:$Rd, V64:{ *:[v4bf16] }:$Rn)  =>  (INSvi64lane:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5862,
          GIR_EraseRootFromParent_Done,
        // Label 1245: @73535
        GIM_Reject,
      // Label 1219: @73536
      GIM_Reject,
      // Label 1179: @73537
      GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(75318),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(73674), // Rule ID 5441 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5441,
          GIR_EraseRootFromParent_Done,
        // Label 1247: @73674
        GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(73796), // Rule ID 5447 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5447,
          GIR_EraseRootFromParent_Done,
        // Label 1248: @73796
        GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(73898), // Rule ID 5608 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[4] Operand 2
          GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5608,
          GIR_EraseRootFromParent_Done,
        // Label 1249: @73898
        GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(74027), // Rule ID 6390 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
          GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6390,
          GIR_EraseRootFromParent_Done,
        // Label 1250: @74027
        GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(74069), // Rule ID 5869 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
          // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5869,
          GIR_EraseRootFromParent_Done,
        // Label 1251: @74069
        GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(74192), // Rule ID 2532 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
          // MIs[2] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2532,
          GIR_EraseRootFromParent_Done,
        // Label 1252: @74192
        GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(74315), // Rule ID 6358 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6358,
          GIR_EraseRootFromParent_Done,
        // Label 1253: @74315
        GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(74435), // Rule ID 6396 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6396,
          GIR_EraseRootFromParent_Done,
        // Label 1254: @74435
        GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(74552), // Rule ID 2461 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 561:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2461,
          GIR_EraseRootFromParent_Done,
        // Label 1255: @74552
        GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(74669), // Rule ID 5369 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 689:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5369,
          GIR_EraseRootFromParent_Done,
        // Label 1256: @74669
        GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(74786), // Rule ID 5372 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 631:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5372,
          GIR_EraseRootFromParent_Done,
        // Label 1257: @74786
        GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(74903), // Rule ID 5375 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 633:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5375,
          GIR_EraseRootFromParent_Done,
        // Label 1258: @74903
        GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(74959), // Rule ID 5525 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5525,
          GIR_EraseRootFromParent_Done,
        // Label 1259: @74959
        GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75025), // Rule ID 5867 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5867,
          GIR_EraseRootFromParent_Done,
        // Label 1260: @75025
        GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75121), // Rule ID 4981 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4981,
          GIR_EraseRootFromParent_Done,
        // Label 1261: @75121
        GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75183), // Rule ID 5868 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5868,
          GIR_EraseRootFromParent_Done,
        // Label 1262: @75183
        GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75317), // Rule ID 5866 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5866,
          GIR_EraseRootFromParent_Done,
        // Label 1263: @75317
        GIM_Reject,
      // Label 1246: @75318
      GIM_Reject,
      // Label 1180: @75319
      GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75344), // Rule ID 9280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9280,
        GIR_Done,
      // Label 1264: @75344
      GIM_Reject,
      // Label 1181: @75345
      GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75370), // Rule ID 9281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9281,
        GIR_Done,
      // Label 1265: @75370
      GIM_Reject,
      // Label 1182: @75371
      GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75417),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(75401), // Rule ID 9284 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9284,
          GIR_Done,
        // Label 1267: @75401
        GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(75416), // Rule ID 9287 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv4bf16] } nxv2bf16:{ *:[nxv2bf16] }:$v1, nxv2bf16:{ *:[nxv2bf16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4bf16] } ?:{ *:[nxv2bf16] }:$v1, ?:{ *:[nxv2bf16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9287,
          GIR_Done,
        // Label 1268: @75416
        GIM_Reject,
      // Label 1266: @75417
      GIM_Reject,
      // Label 1183: @75418
      GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(75443), // Rule ID 9286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9286,
        GIR_Done,
      // Label 1269: @75443
      GIM_Reject,
      // Label 1184: @75444
      GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(75469), // Rule ID 9282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9282,
        GIR_Done,
      // Label 1270: @75469
      GIM_Reject,
      // Label 1185: @75470
      GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(75516),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(75500), // Rule ID 9285 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9285,
          GIR_Done,
        // Label 1272: @75500
        GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(75515), // Rule ID 9288 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv8bf16] } nxv4bf16:{ *:[nxv4bf16] }:$v1, nxv4bf16:{ *:[nxv4bf16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv4bf16] }:$v1, ?:{ *:[nxv4bf16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9288,
          GIR_Done,
        // Label 1273: @75515
        GIM_Reject,
      // Label 1271: @75516
      GIM_Reject,
      // Label 1186: @75517
      GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(75542), // Rule ID 9283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9283,
        GIR_Done,
      // Label 1274: @75542
      GIM_Reject,
      // Label 1187: @75543
      GIM_Reject,
    // Label 1175: @75544
    GIM_Reject,
    // Label 9: @75545
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1292*/ GIMT_Encode4(88000),
    /*GILLT_s16*//*Label 1275*/ GIMT_Encode4(75648),
    /*GILLT_s32*//*Label 1276*/ GIMT_Encode4(75702),
    /*GILLT_s64*//*Label 1277*/ GIMT_Encode4(76083),
    /*GILLT_s128*//*Label 1278*/ GIMT_Encode4(78312),
    /*GILLT_v2s32*//*Label 1279*/ GIMT_Encode4(79061),
    /*GILLT_v2s64*//*Label 1280*/ GIMT_Encode4(80092),
    /*GILLT_v4s16*//*Label 1281*/ GIMT_Encode4(80977),
    /*GILLT_v4s32*//*Label 1282*/ GIMT_Encode4(82378),
    /*GILLT_v8s8*//*Label 1283*/ GIMT_Encode4(83339),
    /*GILLT_v8s16*//*Label 1284*/ GIMT_Encode4(83958),
    /*GILLT_v16s8*//*Label 1285*/ GIMT_Encode4(85254), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 1286*/ GIMT_Encode4(85764), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 1287*/ GIMT_Encode4(85824), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 1288*/ GIMT_Encode4(86337),
    /*GILLT_nxv4s32*//*Label 1289*/ GIMT_Encode4(86397), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 1290*/ GIMT_Encode4(86910), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 1291*/ GIMT_Encode4(87775),
    // Label 1275: @75648
    GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(75701),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(75682), // Rule ID 6781 //
        // (bitconvert:{ *:[f16] } FPR16:{ *:[bf16] }:$src)  =>  FPR16:{ *:[f16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6781,
        GIR_EraseRootFromParent_Done,
      // Label 1294: @75682
      GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(75700), // Rule ID 6782 //
        // (bitconvert:{ *:[bf16] } FPR16:{ *:[f16] }:$src)  =>  FPR16:{ *:[bf16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6782,
        GIR_EraseRootFromParent_Done,
      // Label 1295: @75700
      GIM_Reject,
    // Label 1293: @75701
    GIM_Reject,
    // Label 1276: @75702
    GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(76082),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(75780), // Rule ID 7254 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7254,
        GIR_EraseRootFromParent_Done,
      // Label 1297: @75780
      GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(75850), // Rule ID 7255 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7255,
        GIR_EraseRootFromParent_Done,
      // Label 1298: @75850
      GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(75915), // Rule ID 7256 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7256,
        GIR_EraseRootFromParent_Done,
      // Label 1299: @75915
      GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(75980), // Rule ID 7257 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7257,
        GIR_EraseRootFromParent_Done,
      // Label 1300: @75980
      GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(76033), // Rule ID 5827 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5827,
        GIR_EraseRootFromParent_Done,
      // Label 1301: @76033
      GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(76057), // Rule ID 6776 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6776,
        GIR_Done,
      // Label 1302: @76057
      GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(76081), // Rule ID 6777 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 6777,
        GIR_Done,
      // Label 1303: @76081
      GIM_Reject,
    // Label 1296: @76082
    GIM_Reject,
    // Label 1277: @76083
    GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(76156), // Rule ID 7258 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7258,
      GIR_EraseRootFromParent_Done,
    // Label 1304: @76156
    GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(76229), // Rule ID 7259 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7259,
      GIR_EraseRootFromParent_Done,
    // Label 1305: @76229
    GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(76297), // Rule ID 7260 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7260,
      GIR_EraseRootFromParent_Done,
    // Label 1306: @76297
    GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(76365), // Rule ID 7261 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7261,
      GIR_EraseRootFromParent_Done,
    // Label 1307: @76365
    GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(76421), // Rule ID 5829 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5829,
      GIR_EraseRootFromParent_Done,
    // Label 1308: @76421
    GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(76451), // Rule ID 6748 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6748,
      GIR_Done,
    // Label 1309: @76451
    GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(76481), // Rule ID 6749 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6749,
      GIR_Done,
    // Label 1310: @76481
    GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(76511), // Rule ID 6750 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6750,
      GIR_Done,
    // Label 1311: @76511
    GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(76541), // Rule ID 6751 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6751,
      GIR_Done,
    // Label 1312: @76541
    GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(76571), // Rule ID 6752 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6752,
      GIR_Done,
    // Label 1313: @76571
    GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(76601), // Rule ID 6753 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6753,
      GIR_Done,
    // Label 1314: @76601
    GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(76631), // Rule ID 6754 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6754,
      GIR_Done,
    // Label 1315: @76631
    GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(76681), // Rule ID 6761 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6761,
      GIR_EraseRootFromParent_Done,
    // Label 1316: @76681
    GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(76731), // Rule ID 6762 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6762,
      GIR_EraseRootFromParent_Done,
    // Label 1317: @76731
    GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(76781), // Rule ID 6763 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6763,
      GIR_EraseRootFromParent_Done,
    // Label 1318: @76781
    GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(76831), // Rule ID 6764 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6764,
      GIR_EraseRootFromParent_Done,
    // Label 1319: @76831
    GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(76881), // Rule ID 6765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6765,
      GIR_EraseRootFromParent_Done,
    // Label 1320: @76881
    GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(76931), // Rule ID 6766 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6766,
      GIR_EraseRootFromParent_Done,
    // Label 1321: @76931
    GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(76958), // Rule ID 6767 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6767,
      GIR_Done,
    // Label 1322: @76958
    GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(76985), // Rule ID 6768 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6768,
      GIR_Done,
    // Label 1323: @76985
    GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(77012), // Rule ID 6769 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6769,
      GIR_Done,
    // Label 1324: @77012
    GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(77039), // Rule ID 6778 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6778,
      GIR_Done,
    // Label 1325: @77039
    GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(77066), // Rule ID 6779 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6779,
      GIR_Done,
    // Label 1326: @77066
    GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(77093), // Rule ID 6780 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6780,
      GIR_Done,
    // Label 1327: @77093
    GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(77125), // Rule ID 6783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6783,
      GIR_EraseRootFromParent_Done,
    // Label 1328: @77125
    GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(77157), // Rule ID 6784 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6784,
      GIR_EraseRootFromParent_Done,
    // Label 1329: @77157
    GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(77189), // Rule ID 6785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6785,
      GIR_EraseRootFromParent_Done,
    // Label 1330: @77189
    GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(77221), // Rule ID 6786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6786,
      GIR_EraseRootFromParent_Done,
    // Label 1331: @77221
    GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(77253), // Rule ID 6787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6787,
      GIR_EraseRootFromParent_Done,
    // Label 1332: @77253
    GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(77285), // Rule ID 6788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6788,
      GIR_EraseRootFromParent_Done,
    // Label 1333: @77285
    GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(77311), // Rule ID 6789 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6789,
      GIR_Done,
    // Label 1334: @77311
    GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(77337), // Rule ID 6790 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6790,
      GIR_Done,
    // Label 1335: @77337
    GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(77363), // Rule ID 6791 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6791,
      GIR_Done,
    // Label 1336: @77363
    GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(77389), // Rule ID 6792 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6792,
      GIR_Done,
    // Label 1337: @77389
    GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(77415), // Rule ID 6793 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6793,
      GIR_Done,
    // Label 1338: @77415
    GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(77441), // Rule ID 6794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6794,
      GIR_Done,
    // Label 1339: @77441
    GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(77470), // Rule ID 6795 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6795,
      GIR_EraseRootFromParent_Done,
    // Label 1340: @77470
    GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(77499), // Rule ID 6796 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6796,
      GIR_EraseRootFromParent_Done,
    // Label 1341: @77499
    GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(77531), // Rule ID 6868 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6868,
      GIR_EraseRootFromParent_Done,
    // Label 1342: @77531
    GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(77563), // Rule ID 6869 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6869,
      GIR_EraseRootFromParent_Done,
    // Label 1343: @77563
    GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(77595), // Rule ID 6870 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6870,
      GIR_EraseRootFromParent_Done,
    // Label 1344: @77595
    GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(77627), // Rule ID 6871 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6871,
      GIR_EraseRootFromParent_Done,
    // Label 1345: @77627
    GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(77659), // Rule ID 6872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6872,
      GIR_EraseRootFromParent_Done,
    // Label 1346: @77659
    GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(77691), // Rule ID 6873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6873,
      GIR_EraseRootFromParent_Done,
    // Label 1347: @77691
    GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(77717), // Rule ID 6874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6874,
      GIR_Done,
    // Label 1348: @77717
    GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(77743), // Rule ID 6875 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6875,
      GIR_Done,
    // Label 1349: @77743
    GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(77769), // Rule ID 6876 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6876,
      GIR_Done,
    // Label 1350: @77769
    GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(77795), // Rule ID 6877 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6877,
      GIR_Done,
    // Label 1351: @77795
    GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(77821), // Rule ID 6878 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6878,
      GIR_Done,
    // Label 1352: @77821
    GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(77847), // Rule ID 6879 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6879,
      GIR_Done,
    // Label 1353: @77847
    GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(77876), // Rule ID 6880 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6880,
      GIR_EraseRootFromParent_Done,
    // Label 1354: @77876
    GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(77905), // Rule ID 6881 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6881,
      GIR_EraseRootFromParent_Done,
    // Label 1355: @77905
    GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(77937), // Rule ID 6882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6882,
      GIR_EraseRootFromParent_Done,
    // Label 1356: @77937
    GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(77969), // Rule ID 6883 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6883,
      GIR_EraseRootFromParent_Done,
    // Label 1357: @77969
    GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(78001), // Rule ID 6884 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6884,
      GIR_EraseRootFromParent_Done,
    // Label 1358: @78001
    GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(78033), // Rule ID 6885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6885,
      GIR_EraseRootFromParent_Done,
    // Label 1359: @78033
    GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(78065), // Rule ID 6886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6886,
      GIR_EraseRootFromParent_Done,
    // Label 1360: @78065
    GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(78097), // Rule ID 6887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6887,
      GIR_EraseRootFromParent_Done,
    // Label 1361: @78097
    GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(78123), // Rule ID 6888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6888,
      GIR_Done,
    // Label 1362: @78123
    GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(78149), // Rule ID 6889 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6889,
      GIR_Done,
    // Label 1363: @78149
    GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(78175), // Rule ID 6890 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6890,
      GIR_Done,
    // Label 1364: @78175
    GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(78201), // Rule ID 6891 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6891,
      GIR_Done,
    // Label 1365: @78201
    GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(78227), // Rule ID 6892 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6892,
      GIR_Done,
    // Label 1366: @78227
    GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(78253), // Rule ID 6893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6893,
      GIR_Done,
    // Label 1367: @78253
    GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(78282), // Rule ID 6894 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6894,
      GIR_EraseRootFromParent_Done,
    // Label 1368: @78282
    GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(78311), // Rule ID 6895 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6895,
      GIR_EraseRootFromParent_Done,
    // Label 1369: @78311
    GIM_Reject,
    // Label 1278: @78312
    GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(78344), // Rule ID 6911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6911,
      GIR_EraseRootFromParent_Done,
    // Label 1370: @78344
    GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(78376), // Rule ID 6912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6912,
      GIR_EraseRootFromParent_Done,
    // Label 1371: @78376
    GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(78408), // Rule ID 6913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6913,
      GIR_EraseRootFromParent_Done,
    // Label 1372: @78408
    GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(78440), // Rule ID 6914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6914,
      GIR_EraseRootFromParent_Done,
    // Label 1373: @78440
    GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(78472), // Rule ID 6915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6915,
      GIR_EraseRootFromParent_Done,
    // Label 1374: @78472
    GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(78504), // Rule ID 6916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6916,
      GIR_EraseRootFromParent_Done,
    // Label 1375: @78504
    GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(78536), // Rule ID 6917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6917,
      GIR_EraseRootFromParent_Done,
    // Label 1376: @78536
    GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(78568), // Rule ID 6918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6918,
      GIR_EraseRootFromParent_Done,
    // Label 1377: @78568
    GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(78601), // Rule ID 6919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6919,
      GIR_EraseRootFromParent_Done,
    // Label 1378: @78601
    GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(78672), // Rule ID 6920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6920,
      GIR_EraseRootFromParent_Done,
    // Label 1379: @78672
    GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(78743), // Rule ID 6921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6921,
      GIR_EraseRootFromParent_Done,
    // Label 1380: @78743
    GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(78814), // Rule ID 6922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6922,
      GIR_EraseRootFromParent_Done,
    // Label 1381: @78814
    GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(78885), // Rule ID 6923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6923,
      GIR_EraseRootFromParent_Done,
    // Label 1382: @78885
    GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(78918), // Rule ID 6924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6924,
      GIR_EraseRootFromParent_Done,
    // Label 1383: @78918
    GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(78989), // Rule ID 6925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6925,
      GIR_EraseRootFromParent_Done,
    // Label 1384: @78989
    GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(79060), // Rule ID 6926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6926,
      GIR_EraseRootFromParent_Done,
    // Label 1385: @79060
    GIM_Reject,
    // Label 1279: @79061
    GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(79091), // Rule ID 6744 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6744,
      GIR_Done,
    // Label 1386: @79091
    GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(79121), // Rule ID 6747 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6747,
      GIR_Done,
    // Label 1387: @79121
    GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(79171), // Rule ID 6757 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6757,
      GIR_EraseRootFromParent_Done,
    // Label 1388: @79171
    GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(79221), // Rule ID 6760 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6760,
      GIR_EraseRootFromParent_Done,
    // Label 1389: @79221
    GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(79253), // Rule ID 6797 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6797,
      GIR_EraseRootFromParent_Done,
    // Label 1390: @79253
    GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(79285), // Rule ID 6798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6798,
      GIR_EraseRootFromParent_Done,
    // Label 1391: @79285
    GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(79317), // Rule ID 6799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6799,
      GIR_EraseRootFromParent_Done,
    // Label 1392: @79317
    GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(79349), // Rule ID 6800 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6800,
      GIR_EraseRootFromParent_Done,
    // Label 1393: @79349
    GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(79381), // Rule ID 6801 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6801,
      GIR_EraseRootFromParent_Done,
    // Label 1394: @79381
    GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(79413), // Rule ID 6802 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6802,
      GIR_EraseRootFromParent_Done,
    // Label 1395: @79413
    GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(79445), // Rule ID 6803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6803,
      GIR_EraseRootFromParent_Done,
    // Label 1396: @79445
    GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(79471), // Rule ID 6804 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6804,
      GIR_Done,
    // Label 1397: @79471
    GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(79497), // Rule ID 6805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6805,
      GIR_Done,
    // Label 1398: @79497
    GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(79523), // Rule ID 6806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6806,
      GIR_Done,
    // Label 1399: @79523
    GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(79549), // Rule ID 6807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6807,
      GIR_Done,
    // Label 1400: @79549
    GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(79575), // Rule ID 6808 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6808,
      GIR_Done,
    // Label 1401: @79575
    GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(79601), // Rule ID 6809 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6809,
      GIR_Done,
    // Label 1402: @79601
    GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(79627), // Rule ID 6810 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6810,
      GIR_Done,
    // Label 1403: @79627
    GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(79656), // Rule ID 6811 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6811,
      GIR_EraseRootFromParent_Done,
    // Label 1404: @79656
    GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(79688), // Rule ID 6896 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6896,
      GIR_EraseRootFromParent_Done,
    // Label 1405: @79688
    GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(79720), // Rule ID 6897 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6897,
      GIR_EraseRootFromParent_Done,
    // Label 1406: @79720
    GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(79752), // Rule ID 6898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6898,
      GIR_EraseRootFromParent_Done,
    // Label 1407: @79752
    GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(79784), // Rule ID 6899 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6899,
      GIR_EraseRootFromParent_Done,
    // Label 1408: @79784
    GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(79816), // Rule ID 6900 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6900,
      GIR_EraseRootFromParent_Done,
    // Label 1409: @79816
    GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(79848), // Rule ID 6901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6901,
      GIR_EraseRootFromParent_Done,
    // Label 1410: @79848
    GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(79880), // Rule ID 6902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6902,
      GIR_EraseRootFromParent_Done,
    // Label 1411: @79880
    GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(79906), // Rule ID 6903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6903,
      GIR_Done,
    // Label 1412: @79906
    GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(79932), // Rule ID 6904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6904,
      GIR_Done,
    // Label 1413: @79932
    GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(79958), // Rule ID 6905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6905,
      GIR_Done,
    // Label 1414: @79958
    GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(79984), // Rule ID 6906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6906,
      GIR_Done,
    // Label 1415: @79984
    GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(80010), // Rule ID 6907 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6907,
      GIR_Done,
    // Label 1416: @80010
    GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(80036), // Rule ID 6908 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6908,
      GIR_Done,
    // Label 1417: @80036
    GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(80062), // Rule ID 6909 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6909,
      GIR_Done,
    // Label 1418: @80062
    GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(80091), // Rule ID 6910 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6910,
      GIR_EraseRootFromParent_Done,
    // Label 1419: @80091
    GIM_Reject,
    // Label 1280: @80092
    GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(80124), // Rule ID 6927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6927,
      GIR_EraseRootFromParent_Done,
    // Label 1420: @80124
    GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(80156), // Rule ID 6928 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6928,
      GIR_EraseRootFromParent_Done,
    // Label 1421: @80156
    GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(80188), // Rule ID 6929 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6929,
      GIR_EraseRootFromParent_Done,
    // Label 1422: @80188
    GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(80220), // Rule ID 6930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6930,
      GIR_EraseRootFromParent_Done,
    // Label 1423: @80220
    GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(80252), // Rule ID 6931 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6931,
      GIR_EraseRootFromParent_Done,
    // Label 1424: @80252
    GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(80284), // Rule ID 6932 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6932,
      GIR_EraseRootFromParent_Done,
    // Label 1425: @80284
    GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(80316), // Rule ID 6933 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6933,
      GIR_EraseRootFromParent_Done,
    // Label 1426: @80316
    GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(80349), // Rule ID 6934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6934,
      GIR_EraseRootFromParent_Done,
    // Label 1427: @80349
    GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(80375), // Rule ID 6935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6935,
      GIR_Done,
    // Label 1428: @80375
    GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(80401), // Rule ID 6936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6936,
      GIR_Done,
    // Label 1429: @80401
    GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(80427), // Rule ID 6937 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6937,
      GIR_Done,
    // Label 1430: @80427
    GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(80453), // Rule ID 6938 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6938,
      GIR_Done,
    // Label 1431: @80453
    GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(80479), // Rule ID 6939 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6939,
      GIR_Done,
    // Label 1432: @80479
    GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(80505), // Rule ID 6940 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6940,
      GIR_Done,
    // Label 1433: @80505
    GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(80534), // Rule ID 6941 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6941,
      GIR_EraseRootFromParent_Done,
    // Label 1434: @80534
    GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(80566), // Rule ID 6957 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6957,
      GIR_EraseRootFromParent_Done,
    // Label 1435: @80566
    GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(80598), // Rule ID 6958 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6958,
      GIR_EraseRootFromParent_Done,
    // Label 1436: @80598
    GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(80630), // Rule ID 6959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6959,
      GIR_EraseRootFromParent_Done,
    // Label 1437: @80630
    GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(80662), // Rule ID 6960 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6960,
      GIR_EraseRootFromParent_Done,
    // Label 1438: @80662
    GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(80694), // Rule ID 6961 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6961,
      GIR_EraseRootFromParent_Done,
    // Label 1439: @80694
    GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(80726), // Rule ID 6962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6962,
      GIR_EraseRootFromParent_Done,
    // Label 1440: @80726
    GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(80758), // Rule ID 6963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6963,
      GIR_EraseRootFromParent_Done,
    // Label 1441: @80758
    GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(80791), // Rule ID 6964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6964,
      GIR_EraseRootFromParent_Done,
    // Label 1442: @80791
    GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(80817), // Rule ID 6965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6965,
      GIR_Done,
    // Label 1443: @80817
    GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(80843), // Rule ID 6966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6966,
      GIR_Done,
    // Label 1444: @80843
    GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(80869), // Rule ID 6967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6967,
      GIR_Done,
    // Label 1445: @80869
    GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(80895), // Rule ID 6968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6968,
      GIR_Done,
    // Label 1446: @80895
    GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(80921), // Rule ID 6969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6969,
      GIR_Done,
    // Label 1447: @80921
    GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(80947), // Rule ID 6970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6970,
      GIR_Done,
    // Label 1448: @80947
    GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(80976), // Rule ID 6971 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6971,
      GIR_EraseRootFromParent_Done,
    // Label 1449: @80976
    GIM_Reject,
    // Label 1281: @80977
    GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(81007), // Rule ID 6743 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6743,
      GIR_Done,
    // Label 1450: @81007
    GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(81037), // Rule ID 6745 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6745,
      GIR_Done,
    // Label 1451: @81037
    GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(81067), // Rule ID 6746 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4bf16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6746,
      GIR_Done,
    // Label 1452: @81067
    GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(81117), // Rule ID 6756 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6756,
      GIR_EraseRootFromParent_Done,
    // Label 1453: @81117
    GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(81167), // Rule ID 6758 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6758,
      GIR_EraseRootFromParent_Done,
    // Label 1454: @81167
    GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(81217), // Rule ID 6759 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4bf16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6759,
      GIR_EraseRootFromParent_Done,
    // Label 1455: @81217
    GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(81249), // Rule ID 6812 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6812,
      GIR_EraseRootFromParent_Done,
    // Label 1456: @81249
    GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(81281), // Rule ID 6813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6813,
      GIR_EraseRootFromParent_Done,
    // Label 1457: @81281
    GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(81313), // Rule ID 6814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6814,
      GIR_EraseRootFromParent_Done,
    // Label 1458: @81313
    GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(81345), // Rule ID 6815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6815,
      GIR_EraseRootFromParent_Done,
    // Label 1459: @81345
    GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(81377), // Rule ID 6816 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6816,
      GIR_EraseRootFromParent_Done,
    // Label 1460: @81377
    GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(81409), // Rule ID 6817 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6817,
      GIR_EraseRootFromParent_Done,
    // Label 1461: @81409
    GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(81435), // Rule ID 6818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6818,
      GIR_Done,
    // Label 1462: @81435
    GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(81461), // Rule ID 6819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6819,
      GIR_Done,
    // Label 1463: @81461
    GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(81487), // Rule ID 6820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6820,
      GIR_Done,
    // Label 1464: @81487
    GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(81513), // Rule ID 6821 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6821,
      GIR_Done,
    // Label 1465: @81513
    GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(81539), // Rule ID 6822 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6822,
      GIR_Done,
    // Label 1466: @81539
    GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(81565), // Rule ID 6823 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6823,
      GIR_Done,
    // Label 1467: @81565
    GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(81594), // Rule ID 6824 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6824,
      GIR_EraseRootFromParent_Done,
    // Label 1468: @81594
    GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(81623), // Rule ID 6825 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6825,
      GIR_EraseRootFromParent_Done,
    // Label 1469: @81623
    GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(81655), // Rule ID 6826 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6826,
      GIR_EraseRootFromParent_Done,
    // Label 1470: @81655
    GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(81687), // Rule ID 6827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6827,
      GIR_EraseRootFromParent_Done,
    // Label 1471: @81687
    GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(81719), // Rule ID 6828 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6828,
      GIR_EraseRootFromParent_Done,
    // Label 1472: @81719
    GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(81751), // Rule ID 6829 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6829,
      GIR_EraseRootFromParent_Done,
    // Label 1473: @81751
    GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(81783), // Rule ID 6830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6830,
      GIR_EraseRootFromParent_Done,
    // Label 1474: @81783
    GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(81815), // Rule ID 6831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6831,
      GIR_EraseRootFromParent_Done,
    // Label 1475: @81815
    GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(81847), // Rule ID 6832 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6832,
      GIR_EraseRootFromParent_Done,
    // Label 1476: @81847
    GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(81879), // Rule ID 6833 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6833,
      GIR_EraseRootFromParent_Done,
    // Label 1477: @81879
    GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(81911), // Rule ID 6834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6834,
      GIR_EraseRootFromParent_Done,
    // Label 1478: @81911
    GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(81943), // Rule ID 6835 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6835,
      GIR_EraseRootFromParent_Done,
    // Label 1479: @81943
    GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(81975), // Rule ID 6836 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6836,
      GIR_EraseRootFromParent_Done,
    // Label 1480: @81975
    GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(82007), // Rule ID 6837 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6837,
      GIR_EraseRootFromParent_Done,
    // Label 1481: @82007
    GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(82033), // Rule ID 6838 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6838,
      GIR_Done,
    // Label 1482: @82033
    GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(82059), // Rule ID 6839 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6839,
      GIR_Done,
    // Label 1483: @82059
    GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(82085), // Rule ID 6840 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6840,
      GIR_Done,
    // Label 1484: @82085
    GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(82111), // Rule ID 6841 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6841,
      GIR_Done,
    // Label 1485: @82111
    GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(82137), // Rule ID 6842 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6842,
      GIR_Done,
    // Label 1486: @82137
    GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(82163), // Rule ID 6843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6843,
      GIR_Done,
    // Label 1487: @82163
    GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(82189), // Rule ID 6844 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4bf16] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6844,
      GIR_Done,
    // Label 1488: @82189
    GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(82215), // Rule ID 6845 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4bf16] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6845,
      GIR_Done,
    // Label 1489: @82215
    GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(82241), // Rule ID 6846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4bf16] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6846,
      GIR_Done,
    // Label 1490: @82241
    GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(82267), // Rule ID 6847 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4bf16] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6847,
      GIR_Done,
    // Label 1491: @82267
    GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(82293), // Rule ID 6848 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4bf16] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6848,
      GIR_Done,
    // Label 1492: @82293
    GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(82319), // Rule ID 6849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4bf16] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6849,
      GIR_Done,
    // Label 1493: @82319
    GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(82348), // Rule ID 6850 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6850,
      GIR_EraseRootFromParent_Done,
    // Label 1494: @82348
    GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(82377), // Rule ID 6851 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6851,
      GIR_EraseRootFromParent_Done,
    // Label 1495: @82377
    GIM_Reject,
    // Label 1282: @82378
    GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(82410), // Rule ID 6942 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6942,
      GIR_EraseRootFromParent_Done,
    // Label 1496: @82410
    GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(82442), // Rule ID 6943 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6943,
      GIR_EraseRootFromParent_Done,
    // Label 1497: @82442
    GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(82474), // Rule ID 6944 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6944,
      GIR_EraseRootFromParent_Done,
    // Label 1498: @82474
    GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(82506), // Rule ID 6945 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6945,
      GIR_EraseRootFromParent_Done,
    // Label 1499: @82506
    GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(82538), // Rule ID 6946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6946,
      GIR_EraseRootFromParent_Done,
    // Label 1500: @82538
    GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(82570), // Rule ID 6947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6947,
      GIR_EraseRootFromParent_Done,
    // Label 1501: @82570
    GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(82602), // Rule ID 6948 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6948,
      GIR_EraseRootFromParent_Done,
    // Label 1502: @82602
    GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(82673), // Rule ID 6949 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6949,
      GIR_EraseRootFromParent_Done,
    // Label 1503: @82673
    GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(82699), // Rule ID 6950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6950,
      GIR_Done,
    // Label 1504: @82699
    GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(82725), // Rule ID 6951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6951,
      GIR_Done,
    // Label 1505: @82725
    GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(82751), // Rule ID 6952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6952,
      GIR_Done,
    // Label 1506: @82751
    GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(82777), // Rule ID 6953 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6953,
      GIR_Done,
    // Label 1507: @82777
    GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(82803), // Rule ID 6954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6954,
      GIR_Done,
    // Label 1508: @82803
    GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(82829), // Rule ID 6955 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6955,
      GIR_Done,
    // Label 1509: @82829
    GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(82858), // Rule ID 6956 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6956,
      GIR_EraseRootFromParent_Done,
    // Label 1510: @82858
    GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(82890), // Rule ID 6972 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6972,
      GIR_EraseRootFromParent_Done,
    // Label 1511: @82890
    GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(82922), // Rule ID 6973 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6973,
      GIR_EraseRootFromParent_Done,
    // Label 1512: @82922
    GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(82954), // Rule ID 6974 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6974,
      GIR_EraseRootFromParent_Done,
    // Label 1513: @82954
    GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(82986), // Rule ID 6975 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6975,
      GIR_EraseRootFromParent_Done,
    // Label 1514: @82986
    GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(83018), // Rule ID 6976 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6976,
      GIR_EraseRootFromParent_Done,
    // Label 1515: @83018
    GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(83050), // Rule ID 6977 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6977,
      GIR_EraseRootFromParent_Done,
    // Label 1516: @83050
    GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(83082), // Rule ID 6978 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6978,
      GIR_EraseRootFromParent_Done,
    // Label 1517: @83082
    GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(83153), // Rule ID 6979 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6979,
      GIR_EraseRootFromParent_Done,
    // Label 1518: @83153
    GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(83179), // Rule ID 6980 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6980,
      GIR_Done,
    // Label 1519: @83179
    GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(83205), // Rule ID 6981 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6981,
      GIR_Done,
    // Label 1520: @83205
    GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(83231), // Rule ID 6982 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6982,
      GIR_Done,
    // Label 1521: @83231
    GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(83257), // Rule ID 6983 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6983,
      GIR_Done,
    // Label 1522: @83257
    GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(83283), // Rule ID 6984 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6984,
      GIR_Done,
    // Label 1523: @83283
    GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(83309), // Rule ID 6985 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6985,
      GIR_Done,
    // Label 1524: @83309
    GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(83338), // Rule ID 6986 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6986,
      GIR_EraseRootFromParent_Done,
    // Label 1525: @83338
    GIM_Reject,
    // Label 1283: @83339
    GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(83413), // Rule ID 5721 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5721,
      GIR_EraseRootFromParent_Done,
    // Label 1526: @83413
    GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(83443), // Rule ID 6742 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6742,
      GIR_Done,
    // Label 1527: @83443
    GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(83493), // Rule ID 6755 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6755,
      GIR_EraseRootFromParent_Done,
    // Label 1528: @83493
    GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(83525), // Rule ID 6852 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6852,
      GIR_EraseRootFromParent_Done,
    // Label 1529: @83525
    GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(83557), // Rule ID 6853 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6853,
      GIR_EraseRootFromParent_Done,
    // Label 1530: @83557
    GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(83589), // Rule ID 6854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6854,
      GIR_EraseRootFromParent_Done,
    // Label 1531: @83589
    GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(83621), // Rule ID 6855 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6855,
      GIR_EraseRootFromParent_Done,
    // Label 1532: @83621
    GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(83653), // Rule ID 6856 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6856,
      GIR_EraseRootFromParent_Done,
    // Label 1533: @83653
    GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(83685), // Rule ID 6857 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6857,
      GIR_EraseRootFromParent_Done,
    // Label 1534: @83685
    GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(83717), // Rule ID 6858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6858,
      GIR_EraseRootFromParent_Done,
    // Label 1535: @83717
    GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(83749), // Rule ID 6859 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6859,
      GIR_EraseRootFromParent_Done,
    // Label 1536: @83749
    GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(83775), // Rule ID 6860 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6860,
      GIR_Done,
    // Label 1537: @83775
    GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(83801), // Rule ID 6861 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6861,
      GIR_Done,
    // Label 1538: @83801
    GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(83827), // Rule ID 6862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6862,
      GIR_Done,
    // Label 1539: @83827
    GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(83853), // Rule ID 6863 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6863,
      GIR_Done,
    // Label 1540: @83853
    GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(83879), // Rule ID 6864 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6864,
      GIR_Done,
    // Label 1541: @83879
    GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(83905), // Rule ID 6865 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6865,
      GIR_Done,
    // Label 1542: @83905
    GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(83931), // Rule ID 6866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6866,
      GIR_Done,
    // Label 1543: @83931
    GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(83957), // Rule ID 6867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6867,
      GIR_Done,
    // Label 1544: @83957
    GIM_Reject,
    // Label 1284: @83958
    GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(83990), // Rule ID 6987 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6987,
      GIR_EraseRootFromParent_Done,
    // Label 1545: @83990
    GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(84022), // Rule ID 6988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6988,
      GIR_EraseRootFromParent_Done,
    // Label 1546: @84022
    GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(84054), // Rule ID 6989 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6989,
      GIR_EraseRootFromParent_Done,
    // Label 1547: @84054
    GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(84086), // Rule ID 6990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6990,
      GIR_EraseRootFromParent_Done,
    // Label 1548: @84086
    GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(84118), // Rule ID 6991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6991,
      GIR_EraseRootFromParent_Done,
    // Label 1549: @84118
    GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(84150), // Rule ID 6992 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6992,
      GIR_EraseRootFromParent_Done,
    // Label 1550: @84150
    GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(84221), // Rule ID 6993 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6993,
      GIR_EraseRootFromParent_Done,
    // Label 1551: @84221
    GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(84247), // Rule ID 6994 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6994,
      GIR_Done,
    // Label 1552: @84247
    GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(84273), // Rule ID 6995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6995,
      GIR_Done,
    // Label 1553: @84273
    GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(84299), // Rule ID 6996 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6996,
      GIR_Done,
    // Label 1554: @84299
    GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(84325), // Rule ID 6997 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6997,
      GIR_Done,
    // Label 1555: @84325
    GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(84351), // Rule ID 6998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6998,
      GIR_Done,
    // Label 1556: @84351
    GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(84380), // Rule ID 6999 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6999,
      GIR_EraseRootFromParent_Done,
    // Label 1557: @84380
    GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(84409), // Rule ID 7000 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7000,
      GIR_EraseRootFromParent_Done,
    // Label 1558: @84409
    GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(84441), // Rule ID 7001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7001,
      GIR_EraseRootFromParent_Done,
    // Label 1559: @84441
    GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(84473), // Rule ID 7002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7002,
      GIR_EraseRootFromParent_Done,
    // Label 1560: @84473
    GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(84505), // Rule ID 7003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7003,
      GIR_EraseRootFromParent_Done,
    // Label 1561: @84505
    GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(84537), // Rule ID 7004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7004,
      GIR_EraseRootFromParent_Done,
    // Label 1562: @84537
    GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(84569), // Rule ID 7005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7005,
      GIR_EraseRootFromParent_Done,
    // Label 1563: @84569
    GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(84601), // Rule ID 7006 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7006,
      GIR_EraseRootFromParent_Done,
    // Label 1564: @84601
    GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(84633), // Rule ID 7007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7007,
      GIR_EraseRootFromParent_Done,
    // Label 1565: @84633
    GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(84665), // Rule ID 7008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7008,
      GIR_EraseRootFromParent_Done,
    // Label 1566: @84665
    GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(84697), // Rule ID 7009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7009,
      GIR_EraseRootFromParent_Done,
    // Label 1567: @84697
    GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(84729), // Rule ID 7010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7010,
      GIR_EraseRootFromParent_Done,
    // Label 1568: @84729
    GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(84761), // Rule ID 7011 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7011,
      GIR_EraseRootFromParent_Done,
    // Label 1569: @84761
    GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(84793), // Rule ID 7012 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7012,
      GIR_EraseRootFromParent_Done,
    // Label 1570: @84793
    GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(84864), // Rule ID 7013 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7013,
      GIR_EraseRootFromParent_Done,
    // Label 1571: @84864
    GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(84890), // Rule ID 7014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7014,
      GIR_Done,
    // Label 1572: @84890
    GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(84916), // Rule ID 7015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7015,
      GIR_Done,
    // Label 1573: @84916
    GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(84942), // Rule ID 7016 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7016,
      GIR_Done,
    // Label 1574: @84942
    GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(84968), // Rule ID 7017 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7017,
      GIR_Done,
    // Label 1575: @84968
    GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(84994), // Rule ID 7018 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7018,
      GIR_Done,
    // Label 1576: @84994
    GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(85065), // Rule ID 7019 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8bf16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7019,
      GIR_EraseRootFromParent_Done,
    // Label 1577: @85065
    GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(85091), // Rule ID 7020 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8bf16] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7020,
      GIR_Done,
    // Label 1578: @85091
    GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(85117), // Rule ID 7021 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8bf16] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7021,
      GIR_Done,
    // Label 1579: @85117
    GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(85143), // Rule ID 7022 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8bf16] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7022,
      GIR_Done,
    // Label 1580: @85143
    GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(85169), // Rule ID 7023 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8bf16] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7023,
      GIR_Done,
    // Label 1581: @85169
    GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(85195), // Rule ID 7024 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8bf16] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7024,
      GIR_Done,
    // Label 1582: @85195
    GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(85224), // Rule ID 7025 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7025,
      GIR_EraseRootFromParent_Done,
    // Label 1583: @85224
    GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(85253), // Rule ID 7026 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7026,
      GIR_EraseRootFromParent_Done,
    // Label 1584: @85253
    GIM_Reject,
    // Label 1285: @85254
    GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(85286), // Rule ID 7027 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7027,
      GIR_EraseRootFromParent_Done,
    // Label 1585: @85286
    GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(85318), // Rule ID 7028 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7028,
      GIR_EraseRootFromParent_Done,
    // Label 1586: @85318
    GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(85350), // Rule ID 7029 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7029,
      GIR_EraseRootFromParent_Done,
    // Label 1587: @85350
    GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(85382), // Rule ID 7030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7030,
      GIR_EraseRootFromParent_Done,
    // Label 1588: @85382
    GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(85414), // Rule ID 7031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7031,
      GIR_EraseRootFromParent_Done,
    // Label 1589: @85414
    GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(85446), // Rule ID 7032 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7032,
      GIR_EraseRootFromParent_Done,
    // Label 1590: @85446
    GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(85478), // Rule ID 7033 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7033,
      GIR_EraseRootFromParent_Done,
    // Label 1591: @85478
    GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(85510), // Rule ID 7034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7034,
      GIR_EraseRootFromParent_Done,
    // Label 1592: @85510
    GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(85581), // Rule ID 7035 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7035,
      GIR_EraseRootFromParent_Done,
    // Label 1593: @85581
    GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(85607), // Rule ID 7036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7036,
      GIR_Done,
    // Label 1594: @85607
    GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85633), // Rule ID 7037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7037,
      GIR_Done,
    // Label 1595: @85633
    GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85659), // Rule ID 7038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7038,
      GIR_Done,
    // Label 1596: @85659
    GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85685), // Rule ID 7039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7039,
      GIR_Done,
    // Label 1597: @85685
    GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(85711), // Rule ID 7040 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7040,
      GIR_Done,
    // Label 1598: @85711
    GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85737), // Rule ID 7041 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7041,
      GIR_Done,
    // Label 1599: @85737
    GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85763), // Rule ID 7042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7042,
      GIR_Done,
    // Label 1600: @85763
    GIM_Reject,
    // Label 1286: @85764
    GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85823),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85801), // Rule ID 10835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv2bf16] } ZPR:{ *:[nxv2f16] }:$src)  =>  ZPR:{ *:[nxv2bf16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10835,
        GIR_EraseRootFromParent_Done,
      // Label 1602: @85801
      GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85822), // Rule ID 10836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv2f16] } ZPR:{ *:[nxv2bf16] }:$src)  =>  ZPR:{ *:[nxv2f16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10836,
        GIR_EraseRootFromParent_Done,
      // Label 1603: @85822
      GIM_Reject,
    // Label 1601: @85823
    GIM_Reject,
    // Label 1287: @85824
    GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85856), // Rule ID 10788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10788,
      GIR_EraseRootFromParent_Done,
    // Label 1604: @85856
    GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85888), // Rule ID 10789 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10789,
      GIR_EraseRootFromParent_Done,
    // Label 1605: @85888
    GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(85920), // Rule ID 10790 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10790,
      GIR_EraseRootFromParent_Done,
    // Label 1606: @85920
    GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(85952), // Rule ID 10791 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10791,
      GIR_EraseRootFromParent_Done,
    // Label 1607: @85952
    GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(85984), // Rule ID 10792 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10792,
      GIR_EraseRootFromParent_Done,
    // Label 1608: @85984
    GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86016), // Rule ID 10793 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10793,
      GIR_EraseRootFromParent_Done,
    // Label 1609: @86016
    GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(86048), // Rule ID 10794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10794,
      GIR_EraseRootFromParent_Done,
    // Label 1610: @86048
    GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86080), // Rule ID 10809 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10809,
      GIR_EraseRootFromParent_Done,
    // Label 1611: @86080
    GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86112), // Rule ID 10810 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10810,
      GIR_EraseRootFromParent_Done,
    // Label 1612: @86112
    GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86144), // Rule ID 10811 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10811,
      GIR_EraseRootFromParent_Done,
    // Label 1613: @86144
    GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86176), // Rule ID 10812 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10812,
      GIR_EraseRootFromParent_Done,
    // Label 1614: @86176
    GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86208), // Rule ID 10813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10813,
      GIR_EraseRootFromParent_Done,
    // Label 1615: @86208
    GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86240), // Rule ID 10814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10814,
      GIR_EraseRootFromParent_Done,
    // Label 1616: @86240
    GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(86272), // Rule ID 10815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10815,
      GIR_EraseRootFromParent_Done,
    // Label 1617: @86272
    GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(86304), // Rule ID 10827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10827,
      GIR_EraseRootFromParent_Done,
    // Label 1618: @86304
    GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(86336), // Rule ID 10828 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10828,
      GIR_EraseRootFromParent_Done,
    // Label 1619: @86336
    GIM_Reject,
    // Label 1288: @86337
    GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(86396),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(86374), // Rule ID 10833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv4bf16] } ZPR:{ *:[nxv4f16] }:$src)  =>  ZPR:{ *:[nxv4bf16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10833,
        GIR_EraseRootFromParent_Done,
      // Label 1621: @86374
      GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(86395), // Rule ID 10834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv4f16] } ZPR:{ *:[nxv4bf16] }:$src)  =>  ZPR:{ *:[nxv4f16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10834,
        GIR_EraseRootFromParent_Done,
      // Label 1622: @86395
      GIM_Reject,
    // Label 1620: @86396
    GIM_Reject,
    // Label 1289: @86397
    GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(86429), // Rule ID 10781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10781,
      GIR_EraseRootFromParent_Done,
    // Label 1623: @86429
    GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(86461), // Rule ID 10782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10782,
      GIR_EraseRootFromParent_Done,
    // Label 1624: @86461
    GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(86493), // Rule ID 10783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10783,
      GIR_EraseRootFromParent_Done,
    // Label 1625: @86493
    GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(86525), // Rule ID 10784 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10784,
      GIR_EraseRootFromParent_Done,
    // Label 1626: @86525
    GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(86557), // Rule ID 10785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10785,
      GIR_EraseRootFromParent_Done,
    // Label 1627: @86557
    GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(86589), // Rule ID 10786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10786,
      GIR_EraseRootFromParent_Done,
    // Label 1628: @86589
    GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(86621), // Rule ID 10787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10787,
      GIR_EraseRootFromParent_Done,
    // Label 1629: @86621
    GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(86653), // Rule ID 10802 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10802,
      GIR_EraseRootFromParent_Done,
    // Label 1630: @86653
    GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(86685), // Rule ID 10803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10803,
      GIR_EraseRootFromParent_Done,
    // Label 1631: @86685
    GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(86717), // Rule ID 10804 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10804,
      GIR_EraseRootFromParent_Done,
    // Label 1632: @86717
    GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(86749), // Rule ID 10805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10805,
      GIR_EraseRootFromParent_Done,
    // Label 1633: @86749
    GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(86781), // Rule ID 10806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10806,
      GIR_EraseRootFromParent_Done,
    // Label 1634: @86781
    GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(86813), // Rule ID 10807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10807,
      GIR_EraseRootFromParent_Done,
    // Label 1635: @86813
    GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(86845), // Rule ID 10808 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10808,
      GIR_EraseRootFromParent_Done,
    // Label 1636: @86845
    GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(86877), // Rule ID 10825 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10825,
      GIR_EraseRootFromParent_Done,
    // Label 1637: @86877
    GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(86909), // Rule ID 10826 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10826,
      GIR_EraseRootFromParent_Done,
    // Label 1638: @86909
    GIM_Reject,
    // Label 1290: @86910
    GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(86942), // Rule ID 10774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10774,
      GIR_EraseRootFromParent_Done,
    // Label 1639: @86942
    GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(86974), // Rule ID 10775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10775,
      GIR_EraseRootFromParent_Done,
    // Label 1640: @86974
    GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(87006), // Rule ID 10776 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10776,
      GIR_EraseRootFromParent_Done,
    // Label 1641: @87006
    GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(87038), // Rule ID 10777 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10777,
      GIR_EraseRootFromParent_Done,
    // Label 1642: @87038
    GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(87070), // Rule ID 10778 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10778,
      GIR_EraseRootFromParent_Done,
    // Label 1643: @87070
    GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(87102), // Rule ID 10779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10779,
      GIR_EraseRootFromParent_Done,
    // Label 1644: @87102
    GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(87134), // Rule ID 10780 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10780,
      GIR_EraseRootFromParent_Done,
    // Label 1645: @87134
    GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(87166), // Rule ID 10795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10795,
      GIR_EraseRootFromParent_Done,
    // Label 1646: @87166
    GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(87198), // Rule ID 10796 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10796,
      GIR_EraseRootFromParent_Done,
    // Label 1647: @87198
    GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(87230), // Rule ID 10797 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10797,
      GIR_EraseRootFromParent_Done,
    // Label 1648: @87230
    GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(87262), // Rule ID 10798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10798,
      GIR_EraseRootFromParent_Done,
    // Label 1649: @87262
    GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(87294), // Rule ID 10799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10799,
      GIR_EraseRootFromParent_Done,
    // Label 1650: @87294
    GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(87326), // Rule ID 10800 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10800,
      GIR_EraseRootFromParent_Done,
    // Label 1651: @87326
    GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(87358), // Rule ID 10801 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10801,
      GIR_EraseRootFromParent_Done,
    // Label 1652: @87358
    GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(87390), // Rule ID 10816 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10816,
      GIR_EraseRootFromParent_Done,
    // Label 1653: @87390
    GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(87422), // Rule ID 10817 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10817,
      GIR_EraseRootFromParent_Done,
    // Label 1654: @87422
    GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(87454), // Rule ID 10818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10818,
      GIR_EraseRootFromParent_Done,
    // Label 1655: @87454
    GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(87486), // Rule ID 10819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10819,
      GIR_EraseRootFromParent_Done,
    // Label 1656: @87486
    GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(87518), // Rule ID 10820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10820,
      GIR_EraseRootFromParent_Done,
    // Label 1657: @87518
    GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(87550), // Rule ID 10821 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10821,
      GIR_EraseRootFromParent_Done,
    // Label 1658: @87550
    GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(87582), // Rule ID 10822 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10822,
      GIR_EraseRootFromParent_Done,
    // Label 1659: @87582
    GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(87614), // Rule ID 10823 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10823,
      GIR_EraseRootFromParent_Done,
    // Label 1660: @87614
    GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(87646), // Rule ID 10824 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10824,
      GIR_EraseRootFromParent_Done,
    // Label 1661: @87646
    GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(87678), // Rule ID 10829 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10829,
      GIR_EraseRootFromParent_Done,
    // Label 1662: @87678
    GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(87710), // Rule ID 10830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10830,
      GIR_EraseRootFromParent_Done,
    // Label 1663: @87710
    GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(87742), // Rule ID 10831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10831,
      GIR_EraseRootFromParent_Done,
    // Label 1664: @87742
    GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(87774), // Rule ID 10832 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10832,
      GIR_EraseRootFromParent_Done,
    // Label 1665: @87774
    GIM_Reject,
    // Label 1291: @87775
    GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(87807), // Rule ID 10767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10767,
      GIR_EraseRootFromParent_Done,
    // Label 1666: @87807
    GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(87839), // Rule ID 10768 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10768,
      GIR_EraseRootFromParent_Done,
    // Label 1667: @87839
    GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(87871), // Rule ID 10769 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10769,
      GIR_EraseRootFromParent_Done,
    // Label 1668: @87871
    GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(87903), // Rule ID 10770 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10770,
      GIR_EraseRootFromParent_Done,
    // Label 1669: @87903
    GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(87935), // Rule ID 10771 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10771,
      GIR_EraseRootFromParent_Done,
    // Label 1670: @87935
    GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(87967), // Rule ID 10772 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10772,
      GIR_EraseRootFromParent_Done,
    // Label 1671: @87967
    GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(87999), // Rule ID 10773 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10773,
      GIR_EraseRootFromParent_Done,
    // Label 1672: @87999
    GIM_Reject,
    // Label 1292: @88000
    GIM_Reject,
    // Label 10: @88001
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1681*/ GIMT_Encode4(89423),
    /*GILLT_s16*//*Label 1673*/ GIMT_Encode4(88052),
    /*GILLT_s32*//*Label 1674*/ GIMT_Encode4(88083),
    /*GILLT_s64*//*Label 1675*/ GIMT_Encode4(88114), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1676*/ GIMT_Encode4(88145),
    /*GILLT_v2s64*//*Label 1677*/ GIMT_Encode4(88176),
    /*GILLT_v4s16*//*Label 1678*/ GIMT_Encode4(88207),
    /*GILLT_v4s32*//*Label 1679*/ GIMT_Encode4(88238), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 1680*/ GIMT_Encode4(88269),
    // Label 1673: @88052
    GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(88082), // Rule ID 559 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 559,
      GIR_Done,
    // Label 1682: @88082
    GIM_Reject,
    // Label 1674: @88083
    GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(88113), // Rule ID 561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 561,
      GIR_Done,
    // Label 1683: @88113
    GIM_Reject,
    // Label 1675: @88114
    GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(88144), // Rule ID 563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 563,
      GIR_Done,
    // Label 1684: @88144
    GIM_Reject,
    // Label 1676: @88145
    GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(88175), // Rule ID 921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 921,
      GIR_Done,
    // Label 1685: @88175
    GIM_Reject,
    // Label 1677: @88176
    GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(88206), // Rule ID 925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 925,
      GIR_Done,
    // Label 1686: @88206
    GIM_Reject,
    // Label 1678: @88207
    GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(88237), // Rule ID 917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 917,
      GIR_Done,
    // Label 1687: @88237
    GIM_Reject,
    // Label 1679: @88238
    GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(88268), // Rule ID 923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 923,
      GIR_Done,
    // Label 1688: @88268
    GIM_Reject,
    // Label 1680: @88269
    GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(89422),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(88304), // Rule ID 919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 919,
        GIR_Done,
      // Label 1690: @88304
      GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(88489), // Rule ID 7182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7182,
        GIR_EraseRootFromParent_Done,
      // Label 1691: @88489
      GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(88624), // Rule ID 7184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (ftrunc:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7184,
        GIR_EraseRootFromParent_Done,
      // Label 1692: @88624
      GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(89421), // Rule ID 7186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (ftrunc:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7186,
        GIR_EraseRootFromParent_Done,
      // Label 1693: @89421
      GIM_Reject,
    // Label 1689: @89422
    GIM_Reject,
    // Label 1681: @89423
    GIM_Reject,
    // Label 11: @89424
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1702*/ GIMT_Encode4(90846),
    /*GILLT_s16*//*Label 1694*/ GIMT_Encode4(89475),
    /*GILLT_s32*//*Label 1695*/ GIMT_Encode4(89506),
    /*GILLT_s64*//*Label 1696*/ GIMT_Encode4(89537), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1697*/ GIMT_Encode4(89568),
    /*GILLT_v2s64*//*Label 1698*/ GIMT_Encode4(89599),
    /*GILLT_v4s16*//*Label 1699*/ GIMT_Encode4(89630),
    /*GILLT_v4s32*//*Label 1700*/ GIMT_Encode4(89661), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 1701*/ GIMT_Encode4(89692),
    // Label 1694: @89475
    GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(89505), // Rule ID 523 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 523,
      GIR_Done,
    // Label 1703: @89505
    GIM_Reject,
    // Label 1695: @89506
    GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(89536), // Rule ID 525 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 525,
      GIR_Done,
    // Label 1704: @89536
    GIM_Reject,
    // Label 1696: @89537
    GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(89567), // Rule ID 527 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 527,
      GIR_Done,
    // Label 1705: @89567
    GIM_Reject,
    // Label 1697: @89568
    GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(89598), // Rule ID 861 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 861,
      GIR_Done,
    // Label 1706: @89598
    GIM_Reject,
    // Label 1698: @89599
    GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(89629), // Rule ID 865 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 865,
      GIR_Done,
    // Label 1707: @89629
    GIM_Reject,
    // Label 1699: @89630
    GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(89660), // Rule ID 857 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 857,
      GIR_Done,
    // Label 1708: @89660
    GIM_Reject,
    // Label 1700: @89661
    GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(89691), // Rule ID 863 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 863,
      GIR_Done,
    // Label 1709: @89691
    GIM_Reject,
    // Label 1701: @89692
    GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(90845),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(89727), // Rule ID 859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 859,
        GIR_Done,
      // Label 1711: @89727
      GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(89912), // Rule ID 7164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7164,
        GIR_EraseRootFromParent_Done,
      // Label 1712: @89912
      GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(90047), // Rule ID 7166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fround:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7166,
        GIR_EraseRootFromParent_Done,
      // Label 1713: @90047
      GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(90844), // Rule ID 7168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fround:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7168,
        GIR_EraseRootFromParent_Done,
      // Label 1714: @90844
      GIM_Reject,
    // Label 1710: @90845
    GIM_Reject,
    // Label 1702: @90846
    GIM_Reject,
    // Label 12: @90847
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1717*/ GIMT_Encode4(91114),
    /*GILLT_s32*//*Label 1715*/ GIMT_Encode4(90866),
    /*GILLT_s64*//*Label 1716*/ GIMT_Encode4(90990),
    // Label 1715: @90866
    GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(90909), // Rule ID 4805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4805,
      GIR_EraseRootFromParent_Done,
    // Label 1718: @90909
    GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(90949), // Rule ID 4811 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4811,
      GIR_EraseRootFromParent_Done,
    // Label 1719: @90949
    GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(90989), // Rule ID 4813 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4813,
      GIR_EraseRootFromParent_Done,
    // Label 1720: @90989
    GIM_Reject,
    // Label 1716: @90990
    GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(91033), // Rule ID 4807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4807,
      GIR_EraseRootFromParent_Done,
    // Label 1721: @91033
    GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(91073), // Rule ID 4815 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4815,
      GIR_EraseRootFromParent_Done,
    // Label 1722: @91073
    GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(91113), // Rule ID 4817 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4817,
      GIR_EraseRootFromParent_Done,
    // Label 1723: @91113
    GIM_Reject,
    // Label 1717: @91114
    GIM_Reject,
    // Label 13: @91115
    GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(91264),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1728*/ GIMT_Encode4(91263),
      /*GILLT_s16*//*Label 1725*/ GIMT_Encode4(91146),
      /*GILLT_s32*//*Label 1726*/ GIMT_Encode4(91187),
      /*GILLT_s64*//*Label 1727*/ GIMT_Encode4(91225),
      // Label 1725: @91146
      GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(91186), // Rule ID 4809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4809,
        GIR_EraseRootFromParent_Done,
      // Label 1729: @91186
      GIM_Reject,
      // Label 1726: @91187
      GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(91224), // Rule ID 4819 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4819,
        GIR_EraseRootFromParent_Done,
      // Label 1730: @91224
      GIM_Reject,
      // Label 1727: @91225
      GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(91262), // Rule ID 4821 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4821,
        GIR_EraseRootFromParent_Done,
      // Label 1731: @91262
      GIM_Reject,
      // Label 1728: @91263
      GIM_Reject,
    // Label 1724: @91264
    GIM_Reject,
    // Label 14: @91265
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1740*/ GIMT_Encode4(92687),
    /*GILLT_s16*//*Label 1732*/ GIMT_Encode4(91316),
    /*GILLT_s32*//*Label 1733*/ GIMT_Encode4(91347),
    /*GILLT_s64*//*Label 1734*/ GIMT_Encode4(91378), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1735*/ GIMT_Encode4(91409),
    /*GILLT_v2s64*//*Label 1736*/ GIMT_Encode4(91440),
    /*GILLT_v4s16*//*Label 1737*/ GIMT_Encode4(91471),
    /*GILLT_v4s32*//*Label 1738*/ GIMT_Encode4(91502), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 1739*/ GIMT_Encode4(91533),
    // Label 1732: @91316
    GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(91346), // Rule ID 541 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 541,
      GIR_Done,
    // Label 1741: @91346
    GIM_Reject,
    // Label 1733: @91347
    GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(91377), // Rule ID 543 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 543,
      GIR_Done,
    // Label 1742: @91377
    GIM_Reject,
    // Label 1734: @91378
    GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(91408), // Rule ID 545 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 545,
      GIR_Done,
    // Label 1743: @91408
    GIM_Reject,
    // Label 1735: @91409
    GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(91439), // Rule ID 891 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 891,
      GIR_Done,
    // Label 1744: @91439
    GIM_Reject,
    // Label 1736: @91440
    GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(91470), // Rule ID 895 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 895,
      GIR_Done,
    // Label 1745: @91470
    GIM_Reject,
    // Label 1737: @91471
    GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(91501), // Rule ID 887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 887,
      GIR_Done,
    // Label 1746: @91501
    GIM_Reject,
    // Label 1738: @91502
    GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(91532), // Rule ID 893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 893,
      GIR_Done,
    // Label 1747: @91532
    GIM_Reject,
    // Label 1739: @91533
    GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(92686),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(91568), // Rule ID 889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 889,
        GIR_Done,
      // Label 1749: @91568
      GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(91753), // Rule ID 7170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7170,
        GIR_EraseRootFromParent_Done,
      // Label 1750: @91753
      GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(91888), // Rule ID 7172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (froundeven:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7172,
        GIR_EraseRootFromParent_Done,
      // Label 1751: @91888
      GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(92685), // Rule ID 7174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (froundeven:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7174,
        GIR_EraseRootFromParent_Done,
      // Label 1752: @92685
      GIM_Reject,
    // Label 1748: @92686
    GIM_Reject,
    // Label 1740: @92687
    GIM_Reject,
    // Label 15: @92688
    GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(92720), // Rule ID 3872 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3872,
      GIR_EraseRootFromParent_Done,
    // Label 1753: @92720
    GIM_Reject,
    // Label 16: @92721
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1774*/ GIMT_Encode4(101786),
    /*GILLT_s8*//*Label 1754*/ GIMT_Encode4(92828),
    /*GILLT_s16*//*Label 1755*/ GIMT_Encode4(93004),
    /*GILLT_s32*//*Label 1756*/ GIMT_Encode4(93246),
    /*GILLT_s64*//*Label 1757*/ GIMT_Encode4(95544),
    /*GILLT_s128*//*Label 1758*/ GIMT_Encode4(98225),
    /*GILLT_v2s32*//*Label 1759*/ GIMT_Encode4(98434),
    /*GILLT_v2s64*//*Label 1760*/ GIMT_Encode4(98812),
    /*GILLT_v4s16*//*Label 1761*/ GIMT_Encode4(99190),
    /*GILLT_v4s32*//*Label 1762*/ GIMT_Encode4(99698),
    /*GILLT_v8s8*//*Label 1763*/ GIMT_Encode4(100076),
    /*GILLT_v8s16*//*Label 1764*/ GIMT_Encode4(100284),
    /*GILLT_v16s8*//*Label 1765*/ GIMT_Encode4(100792), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 1766*/ GIMT_Encode4(101000),
    /*GILLT_nxv2s32*//*Label 1767*/ GIMT_Encode4(101114),
    /*GILLT_nxv2s64*//*Label 1768*/ GIMT_Encode4(101178), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 1769*/ GIMT_Encode4(101292),
    /*GILLT_nxv4s32*//*Label 1770*/ GIMT_Encode4(101406), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 1771*/ GIMT_Encode4(101520),
    /*GILLT_nxv16s1*//*Label 1772*/ GIMT_Encode4(101678),
    /*GILLT_nxv16s8*//*Label 1773*/ GIMT_Encode4(101722),
    // Label 1754: @92828
    GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(93003),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(92889), // Rule ID 248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 248,
        GIR_EraseRootFromParent_Done,
      // Label 1776: @92889
      GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(92930), // Rule ID 249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 249,
        GIR_EraseRootFromParent_Done,
      // Label 1777: @92930
      GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(92966), // Rule ID 272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 272,
        GIR_EraseRootFromParent_Done,
      // Label 1778: @92966
      GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(93002), // Rule ID 293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 293,
        GIR_EraseRootFromParent_Done,
      // Label 1779: @93002
      GIM_Reject,
    // Label 1775: @93003
    GIM_Reject,
    // Label 1755: @93004
    GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(93245),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(93065), // Rule ID 250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 250,
        GIR_EraseRootFromParent_Done,
      // Label 1781: @93065
      GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(93106), // Rule ID 251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 251,
        GIR_EraseRootFromParent_Done,
      // Label 1782: @93106
      GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(93142), // Rule ID 273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 273,
        GIR_EraseRootFromParent_Done,
      // Label 1783: @93142
      GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(93178), // Rule ID 294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 294,
        GIR_EraseRootFromParent_Done,
      // Label 1784: @93178
      GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(93211), // Rule ID 4099 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4099,
        GIR_EraseRootFromParent_Done,
      // Label 1785: @93211
      GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(93244), // Rule ID 4130 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4130,
        GIR_EraseRootFromParent_Done,
      // Label 1786: @93244
      GIM_Reject,
    // Label 1780: @93245
    GIM_Reject,
    // Label 1756: @93246
    GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(93299), // Rule ID 244 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 244,
      GIR_EraseRootFromParent_Done,
    // Label 1787: @93299
    GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(93352), // Rule ID 245 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 245,
      GIR_EraseRootFromParent_Done,
    // Label 1788: @93352
    GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(93408), // Rule ID 252 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 252,
      GIR_EraseRootFromParent_Done,
    // Label 1789: @93408
    GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(93464), // Rule ID 253 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 253,
      GIR_EraseRootFromParent_Done,
    // Label 1790: @93464
    GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(93524), // Rule ID 4091 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4091,
      GIR_EraseRootFromParent_Done,
    // Label 1791: @93524
    GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(93584), // Rule ID 4092 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4092,
      GIR_EraseRootFromParent_Done,
    // Label 1792: @93584
    GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(93644), // Rule ID 4093 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4093,
      GIR_EraseRootFromParent_Done,
    // Label 1793: @93644
    GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(93704), // Rule ID 4094 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4094,
      GIR_EraseRootFromParent_Done,
    // Label 1794: @93704
    GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(93764), // Rule ID 4095 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4095,
      GIR_EraseRootFromParent_Done,
    // Label 1795: @93764
    GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(93824), // Rule ID 4096 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4096,
      GIR_EraseRootFromParent_Done,
    // Label 1796: @93824
    GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(93872), // Rule ID 271 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 271,
      GIR_EraseRootFromParent_Done,
    // Label 1797: @93872
    GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(93923), // Rule ID 274 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 274,
      GIR_EraseRootFromParent_Done,
    // Label 1798: @93923
    GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(93982), // Rule ID 7222 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15274>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7222,
      GIR_EraseRootFromParent_Done,
    // Label 1799: @93982
    GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(94041), // Rule ID 7224 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15274>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7224,
      GIR_EraseRootFromParent_Done,
    // Label 1800: @94041
    GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(94100), // Rule ID 7234 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15283>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7234,
      GIR_EraseRootFromParent_Done,
    // Label 1801: @94100
    GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(94159), // Rule ID 7236 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15283>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7236,
      GIR_EraseRootFromParent_Done,
    // Label 1802: @94159
    GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(94218), // Rule ID 7244 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7244,
      GIR_EraseRootFromParent_Done,
    // Label 1803: @94218
    GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(94277), // Rule ID 7245 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7245,
      GIR_EraseRootFromParent_Done,
    // Label 1804: @94277
    GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(94325), // Rule ID 292 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 292,
      GIR_EraseRootFromParent_Done,
    // Label 1805: @94325
    GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(94376), // Rule ID 295 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 295,
      GIR_EraseRootFromParent_Done,
    // Label 1806: @94376
    GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(94430), // Rule ID 7226 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15274>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7226,
      GIR_EraseRootFromParent_Done,
    // Label 1807: @94430
    GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(94484), // Rule ID 7228 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15274>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7228,
      GIR_EraseRootFromParent_Done,
    // Label 1808: @94484
    GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(94538), // Rule ID 7238 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15283>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7238,
      GIR_EraseRootFromParent_Done,
    // Label 1809: @94538
    GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(94592), // Rule ID 7240 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15283>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7240,
      GIR_EraseRootFromParent_Done,
    // Label 1810: @94592
    GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(94646), // Rule ID 7246 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7246,
      GIR_EraseRootFromParent_Done,
    // Label 1811: @94646
    GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(94700), // Rule ID 7247 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15291>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7247,
      GIR_EraseRootFromParent_Done,
    // Label 1812: @94700
    GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(94757), // Rule ID 7562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15272>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7562,
      GIR_EraseRootFromParent_Done,
    // Label 1813: @94757
    GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(94814), // Rule ID 7564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15281>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7564,
      GIR_EraseRootFromParent_Done,
    // Label 1814: @94814
    GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(94871), // Rule ID 7566 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15266>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7566,
      GIR_EraseRootFromParent_Done,
    // Label 1815: @94871
    GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(94926), // Rule ID 4121 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4121,
      GIR_EraseRootFromParent_Done,
    // Label 1816: @94926
    GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(94981), // Rule ID 4122 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4122,
      GIR_EraseRootFromParent_Done,
    // Label 1817: @94981
    GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(95036), // Rule ID 4123 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4123,
      GIR_EraseRootFromParent_Done,
    // Label 1818: @95036
    GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(95091), // Rule ID 4145 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4145,
      GIR_EraseRootFromParent_Done,
    // Label 1819: @95091
    GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(95146), // Rule ID 4146 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4146,
      GIR_EraseRootFromParent_Done,
    // Label 1820: @95146
    GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(95201), // Rule ID 4147 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4147,
      GIR_EraseRootFromParent_Done,
    // Label 1821: @95201
    GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(95241), // Rule ID 7214 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15262>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7214,
      GIR_Done,
    // Label 1822: @95241
    GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(95281), // Rule ID 7215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15264>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7215,
      GIR_Done,
    // Label 1823: @95281
    GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(95321), // Rule ID 7216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15266>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7216,
      GIR_Done,
    // Label 1824: @95321
    GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(95358), // Rule ID 7218 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15270>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7218,
      GIR_Done,
    // Label 1825: @95358
    GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(95395), // Rule ID 7220 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15272>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7220,
      GIR_Done,
    // Label 1826: @95395
    GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(95432), // Rule ID 7230 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15279>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7230,
      GIR_Done,
    // Label 1827: @95432
    GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(95469), // Rule ID 7232 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15281>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7232,
      GIR_Done,
    // Label 1828: @95469
    GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(95506), // Rule ID 7242 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15288>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7242,
      GIR_Done,
    // Label 1829: @95506
    GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(95543), // Rule ID 7243 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15266>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7243,
      GIR_Done,
    // Label 1830: @95543
    GIM_Reject,
    // Label 1757: @95544
    GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(95597), // Rule ID 246 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 246,
      GIR_EraseRootFromParent_Done,
    // Label 1831: @95597
    GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(95650), // Rule ID 247 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 247,
      GIR_EraseRootFromParent_Done,
    // Label 1832: @95650
    GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(95706), // Rule ID 254 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 254,
      GIR_EraseRootFromParent_Done,
    // Label 1833: @95706
    GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(95762), // Rule ID 255 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 255,
      GIR_EraseRootFromParent_Done,
    // Label 1834: @95762
    GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(95815), // Rule ID 4055 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4055,
      GIR_EraseRootFromParent_Done,
    // Label 1835: @95815
    GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(95868), // Rule ID 4056 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4056,
      GIR_EraseRootFromParent_Done,
    // Label 1836: @95868
    GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(95921), // Rule ID 4057 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4057,
      GIR_EraseRootFromParent_Done,
    // Label 1837: @95921
    GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(95974), // Rule ID 4058 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4058,
      GIR_EraseRootFromParent_Done,
    // Label 1838: @95974
    GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(96066), // Rule ID 4083 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4083,
      GIR_EraseRootFromParent_Done,
    // Label 1839: @96066
    GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(96158), // Rule ID 4084 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4084,
      GIR_EraseRootFromParent_Done,
    // Label 1840: @96158
    GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(96250), // Rule ID 4085 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4085,
      GIR_EraseRootFromParent_Done,
    // Label 1841: @96250
    GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(96342), // Rule ID 4086 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4086,
      GIR_EraseRootFromParent_Done,
    // Label 1842: @96342
    GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(96434), // Rule ID 4087 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4087,
      GIR_EraseRootFromParent_Done,
    // Label 1843: @96434
    GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(96526), // Rule ID 4088 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4088,
      GIR_EraseRootFromParent_Done,
    // Label 1844: @96526
    GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(96618), // Rule ID 4089 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4089,
      GIR_EraseRootFromParent_Done,
    // Label 1845: @96618
    GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(96710), // Rule ID 4090 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4090,
      GIR_EraseRootFromParent_Done,
    // Label 1846: @96710
    GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(96758), // Rule ID 270 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 270,
      GIR_EraseRootFromParent_Done,
    // Label 1847: @96758
    GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(96809), // Rule ID 275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 275,
      GIR_EraseRootFromParent_Done,
    // Label 1848: @96809
    GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(96868), // Rule ID 7250 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7250,
      GIR_EraseRootFromParent_Done,
    // Label 1849: @96868
    GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(96927), // Rule ID 7251 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7251,
      GIR_EraseRootFromParent_Done,
    // Label 1850: @96927
    GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(96975), // Rule ID 291 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 291,
      GIR_EraseRootFromParent_Done,
    // Label 1851: @96975
    GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(97026), // Rule ID 296 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 296,
      GIR_EraseRootFromParent_Done,
    // Label 1852: @97026
    GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(97080), // Rule ID 7252 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7252,
      GIR_EraseRootFromParent_Done,
    // Label 1853: @97080
    GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(97134), // Rule ID 7253 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15299>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7253,
      GIR_EraseRootFromParent_Done,
    // Label 1854: @97134
    GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(97191), // Rule ID 7567 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15268>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7567,
      GIR_EraseRootFromParent_Done,
    // Label 1855: @97191
    GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(97239), // Rule ID 4106 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4106,
      GIR_EraseRootFromParent_Done,
    // Label 1856: @97239
    GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(97287), // Rule ID 4107 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4107,
      GIR_EraseRootFromParent_Done,
    // Label 1857: @97287
    GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(97335), // Rule ID 4136 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4136,
      GIR_EraseRootFromParent_Done,
    // Label 1858: @97335
    GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(97383), // Rule ID 4137 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4137,
      GIR_EraseRootFromParent_Done,
    // Label 1859: @97383
    GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(97470), // Rule ID 4124 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4124,
      GIR_EraseRootFromParent_Done,
    // Label 1860: @97470
    GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(97557), // Rule ID 4125 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4125,
      GIR_EraseRootFromParent_Done,
    // Label 1861: @97557
    GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(97644), // Rule ID 4126 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4126,
      GIR_EraseRootFromParent_Done,
    // Label 1862: @97644
    GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(97731), // Rule ID 4127 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4127,
      GIR_EraseRootFromParent_Done,
    // Label 1863: @97731
    GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(97818), // Rule ID 4148 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4148,
      GIR_EraseRootFromParent_Done,
    // Label 1864: @97818
    GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(97905), // Rule ID 4149 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4149,
      GIR_EraseRootFromParent_Done,
    // Label 1865: @97905
    GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(97992), // Rule ID 4150 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4150,
      GIR_EraseRootFromParent_Done,
    // Label 1866: @97992
    GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(98079), // Rule ID 4151 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4151,
      GIR_EraseRootFromParent_Done,
    // Label 1867: @98079
    GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(98119), // Rule ID 7217 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15268>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7217,
      GIR_Done,
    // Label 1868: @98119
    GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(98156), // Rule ID 7248 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15296>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7248,
      GIR_Done,
    // Label 1869: @98156
    GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(98193), // Rule ID 7249 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15268>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7249,
      GIR_Done,
    // Label 1870: @98193
    GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(98224), // Rule ID 6460 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6460,
      GIR_Done,
    // Label 1871: @98224
    GIM_Reject,
    // Label 1758: @98225
    GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(98433),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(98286), // Rule ID 256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 256,
        GIR_EraseRootFromParent_Done,
      // Label 1873: @98286
      GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(98327), // Rule ID 257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 257,
        GIR_EraseRootFromParent_Done,
      // Label 1874: @98327
      GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(98363), // Rule ID 276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 276,
        GIR_EraseRootFromParent_Done,
      // Label 1875: @98363
      GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(98399), // Rule ID 297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 297,
        GIR_EraseRootFromParent_Done,
      // Label 1876: @98399
      GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(98432), // Rule ID 4116 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4116,
        GIR_EraseRootFromParent_Done,
      // Label 1877: @98432
      GIM_Reject,
    // Label 1872: @98433
    GIM_Reject,
    // Label 1759: @98434
    GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(98811),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(98495), // Rule ID 4043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4043,
        GIR_EraseRootFromParent_Done,
      // Label 1879: @98495
      GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(98540), // Rule ID 4044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4044,
        GIR_EraseRootFromParent_Done,
      // Label 1880: @98540
      GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(98585), // Rule ID 4045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4045,
        GIR_EraseRootFromParent_Done,
      // Label 1881: @98585
      GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(98630), // Rule ID 4046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4046,
        GIR_EraseRootFromParent_Done,
      // Label 1882: @98630
      GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(98670), // Rule ID 4100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4100,
        GIR_EraseRootFromParent_Done,
      // Label 1883: @98670
      GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(98710), // Rule ID 4103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4103,
        GIR_EraseRootFromParent_Done,
      // Label 1884: @98710
      GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(98750), // Rule ID 4131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4131,
        GIR_EraseRootFromParent_Done,
      // Label 1885: @98750
      GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(98790), // Rule ID 4132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4132,
        GIR_EraseRootFromParent_Done,
      // Label 1886: @98790
      GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(98810), // Rule ID 6459 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6459,
        GIR_Done,
      // Label 1887: @98810
      GIM_Reject,
    // Label 1878: @98811
    GIM_Reject,
    // Label 1760: @98812
    GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(99189),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(98873), // Rule ID 4059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4059,
        GIR_EraseRootFromParent_Done,
      // Label 1889: @98873
      GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(98918), // Rule ID 4060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4060,
        GIR_EraseRootFromParent_Done,
      // Label 1890: @98918
      GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(98963), // Rule ID 4061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4061,
        GIR_EraseRootFromParent_Done,
      // Label 1891: @98963
      GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(99008), // Rule ID 4062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4062,
        GIR_EraseRootFromParent_Done,
      // Label 1892: @99008
      GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(99048), // Rule ID 4109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4109,
        GIR_EraseRootFromParent_Done,
      // Label 1893: @99048
      GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(99088), // Rule ID 4113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4113,
        GIR_EraseRootFromParent_Done,
      // Label 1894: @99088
      GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(99128), // Rule ID 4138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4138,
        GIR_EraseRootFromParent_Done,
      // Label 1895: @99128
      GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(99168), // Rule ID 4139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4139,
        GIR_EraseRootFromParent_Done,
      // Label 1896: @99168
      GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(99188), // Rule ID 6456 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6456,
        GIR_Done,
      // Label 1897: @99188
      GIM_Reject,
    // Label 1888: @99189
    GIM_Reject,
    // Label 1761: @99190
    GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(99697),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(99251), // Rule ID 4049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4049,
        GIR_EraseRootFromParent_Done,
      // Label 1899: @99251
      GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(99296), // Rule ID 4050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4050,
        GIR_EraseRootFromParent_Done,
      // Label 1900: @99296
      GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(99341), // Rule ID 4051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4051,
        GIR_EraseRootFromParent_Done,
      // Label 1901: @99341
      GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(99386), // Rule ID 4052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4052,
        GIR_EraseRootFromParent_Done,
      // Label 1902: @99386
      GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(99431), // Rule ID 4053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v4bf16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4053,
        GIR_EraseRootFromParent_Done,
      // Label 1903: @99431
      GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(99476), // Rule ID 4054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v4bf16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4054,
        GIR_EraseRootFromParent_Done,
      // Label 1904: @99476
      GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(99516), // Rule ID 4102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4102,
        GIR_EraseRootFromParent_Done,
      // Label 1905: @99516
      GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(99556), // Rule ID 4104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4104,
        GIR_EraseRootFromParent_Done,
      // Label 1906: @99556
      GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(99596), // Rule ID 4105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v4bf16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4105,
        GIR_EraseRootFromParent_Done,
      // Label 1907: @99596
      GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(99636), // Rule ID 4133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4133,
        GIR_EraseRootFromParent_Done,
      // Label 1908: @99636
      GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(99676), // Rule ID 4135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4135,
        GIR_EraseRootFromParent_Done,
      // Label 1909: @99676
      GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(99696), // Rule ID 6458 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6458,
        GIR_Done,
      // Label 1910: @99696
      GIM_Reject,
    // Label 1898: @99697
    GIM_Reject,
    // Label 1762: @99698
    GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(100075),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(99759), // Rule ID 4063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4063,
        GIR_EraseRootFromParent_Done,
      // Label 1912: @99759
      GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(99804), // Rule ID 4064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4064,
        GIR_EraseRootFromParent_Done,
      // Label 1913: @99804
      GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(99849), // Rule ID 4065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4065,
        GIR_EraseRootFromParent_Done,
      // Label 1914: @99849
      GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(99894), // Rule ID 4066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4066,
        GIR_EraseRootFromParent_Done,
      // Label 1915: @99894
      GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(99934), // Rule ID 4108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4108,
        GIR_EraseRootFromParent_Done,
      // Label 1916: @99934
      GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(99974), // Rule ID 4112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4112,
        GIR_EraseRootFromParent_Done,
      // Label 1917: @99974
      GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(100014), // Rule ID 4140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4140,
        GIR_EraseRootFromParent_Done,
      // Label 1918: @100014
      GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(100054), // Rule ID 4141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4141,
        GIR_EraseRootFromParent_Done,
      // Label 1919: @100054
      GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(100074), // Rule ID 6455 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6455,
        GIR_Done,
      // Label 1920: @100074
      GIM_Reject,
    // Label 1911: @100075
    GIM_Reject,
    // Label 1763: @100076
    GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(100283),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(100137), // Rule ID 4047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4047,
        GIR_EraseRootFromParent_Done,
      // Label 1922: @100137
      GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(100182), // Rule ID 4048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4048,
        GIR_EraseRootFromParent_Done,
      // Label 1923: @100182
      GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(100222), // Rule ID 4101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4101,
        GIR_EraseRootFromParent_Done,
      // Label 1924: @100222
      GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(100262), // Rule ID 4134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4134,
        GIR_EraseRootFromParent_Done,
      // Label 1925: @100262
      GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(100282), // Rule ID 6457 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6457,
        GIR_Done,
      // Label 1926: @100282
      GIM_Reject,
    // Label 1921: @100283
    GIM_Reject,
    // Label 1764: @100284
    GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(100791),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(100345), // Rule ID 4067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4067,
        GIR_EraseRootFromParent_Done,
      // Label 1928: @100345
      GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(100390), // Rule ID 4068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4068,
        GIR_EraseRootFromParent_Done,
      // Label 1929: @100390
      GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(100435), // Rule ID 4069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4069,
        GIR_EraseRootFromParent_Done,
      // Label 1930: @100435
      GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(100480), // Rule ID 4070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4070,
        GIR_EraseRootFromParent_Done,
      // Label 1931: @100480
      GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(100525), // Rule ID 4071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v8bf16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4071,
        GIR_EraseRootFromParent_Done,
      // Label 1932: @100525
      GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(100570), // Rule ID 4072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v8bf16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4072,
        GIR_EraseRootFromParent_Done,
      // Label 1933: @100570
      GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(100610), // Rule ID 4111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4111,
        GIR_EraseRootFromParent_Done,
      // Label 1934: @100610
      GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(100650), // Rule ID 4114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4114,
        GIR_EraseRootFromParent_Done,
      // Label 1935: @100650
      GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(100690), // Rule ID 4115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v8bf16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4115,
        GIR_EraseRootFromParent_Done,
      // Label 1936: @100690
      GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(100730), // Rule ID 4142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4142,
        GIR_EraseRootFromParent_Done,
      // Label 1937: @100730
      GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(100770), // Rule ID 4144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4144,
        GIR_EraseRootFromParent_Done,
      // Label 1938: @100770
      GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(100790), // Rule ID 6454 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6454,
        GIR_Done,
      // Label 1939: @100790
      GIM_Reject,
    // Label 1927: @100791
    GIM_Reject,
    // Label 1765: @100792
    GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(100999),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(100853), // Rule ID 4073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4073,
        GIR_EraseRootFromParent_Done,
      // Label 1941: @100853
      GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(100898), // Rule ID 4074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4074,
        GIR_EraseRootFromParent_Done,
      // Label 1942: @100898
      GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(100938), // Rule ID 4110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4110,
        GIR_EraseRootFromParent_Done,
      // Label 1943: @100938
      GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(100978), // Rule ID 4143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4143,
        GIR_EraseRootFromParent_Done,
      // Label 1944: @100978
      GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(100998), // Rule ID 6453 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6453,
        GIR_Done,
      // Label 1945: @100998
      GIM_Reject,
    // Label 1940: @100999
    GIM_Reject,
    // Label 1766: @101000
    GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(101113),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(101068), // Rule ID 11248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11248,
        GIR_EraseRootFromParent_Done,
      // Label 1947: @101068
      GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(101112), // Rule ID 11251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2bf16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2bf16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11251,
        GIR_EraseRootFromParent_Done,
      // Label 1948: @101112
      GIM_Reject,
    // Label 1946: @101113
    GIM_Reject,
    // Label 1767: @101114
    GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(101177), // Rule ID 11257 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11257,
      GIR_EraseRootFromParent_Done,
    // Label 1949: @101177
    GIM_Reject,
    // Label 1768: @101178
    GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(101291),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(101246), // Rule ID 11233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11233,
        GIR_EraseRootFromParent_Done,
      // Label 1951: @101246
      GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(101290), // Rule ID 11260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11260,
        GIR_EraseRootFromParent_Done,
      // Label 1952: @101290
      GIM_Reject,
    // Label 1950: @101291
    GIM_Reject,
    // Label 1769: @101292
    GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(101405),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(101360), // Rule ID 11242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11242,
        GIR_EraseRootFromParent_Done,
      // Label 1954: @101360
      GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(101404), // Rule ID 11245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4bf16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4bf16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11245,
        GIR_EraseRootFromParent_Done,
      // Label 1955: @101404
      GIM_Reject,
    // Label 1953: @101405
    GIM_Reject,
    // Label 1770: @101406
    GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(101519),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(101474), // Rule ID 11221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11221,
        GIR_EraseRootFromParent_Done,
      // Label 1957: @101474
      GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(101518), // Rule ID 11254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11254,
        GIR_EraseRootFromParent_Done,
      // Label 1958: @101518
      GIM_Reject,
    // Label 1956: @101519
    GIM_Reject,
    // Label 1771: @101520
    GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(101677),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(101588), // Rule ID 11200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11200,
        GIR_EraseRootFromParent_Done,
      // Label 1960: @101588
      GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(101632), // Rule ID 11236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11236,
        GIR_EraseRootFromParent_Done,
      // Label 1961: @101632
      GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(101676), // Rule ID 11239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv8bf16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8bf16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11239,
        GIR_EraseRootFromParent_Done,
      // Label 1962: @101676
      GIM_Reject,
    // Label 1959: @101677
    GIM_Reject,
    // Label 1772: @101678
    GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(101721), // Rule ID 2404 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2404,
      GIR_EraseRootFromParent_Done,
    // Label 1963: @101721
    GIM_Reject,
    // Label 1773: @101722
    GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(101785), // Rule ID 11168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11168,
      GIR_EraseRootFromParent_Done,
    // Label 1964: @101785
    GIM_Reject,
    // Label 1774: @101786
    GIM_Reject,
    // Label 17: @101787
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1967*/ GIMT_Encode4(102878),
    /*GILLT_s32*//*Label 1965*/ GIMT_Encode4(101806),
    /*GILLT_s64*//*Label 1966*/ GIMT_Encode4(102235),
    // Label 1965: @101806
    GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(101862), // Rule ID 258 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 258,
      GIR_EraseRootFromParent_Done,
    // Label 1968: @101862
    GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(101918), // Rule ID 259 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 259,
      GIR_EraseRootFromParent_Done,
    // Label 1969: @101918
    GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(101974), // Rule ID 262 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 262,
      GIR_EraseRootFromParent_Done,
    // Label 1970: @101974
    GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(102030), // Rule ID 263 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 263,
      GIR_EraseRootFromParent_Done,
    // Label 1971: @102030
    GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(102081), // Rule ID 279 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 279,
      GIR_EraseRootFromParent_Done,
    // Label 1972: @102081
    GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(102132), // Rule ID 281 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 281,
      GIR_EraseRootFromParent_Done,
    // Label 1973: @102132
    GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(102183), // Rule ID 300 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 300,
      GIR_EraseRootFromParent_Done,
    // Label 1974: @102183
    GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(102234), // Rule ID 302 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 302,
      GIR_EraseRootFromParent_Done,
    // Label 1975: @102234
    GIM_Reject,
    // Label 1966: @102235
    GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(102291), // Rule ID 260 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 260,
      GIR_EraseRootFromParent_Done,
    // Label 1976: @102291
    GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(102347), // Rule ID 261 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 261,
      GIR_EraseRootFromParent_Done,
    // Label 1977: @102347
    GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(102403), // Rule ID 264 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 264,
      GIR_EraseRootFromParent_Done,
    // Label 1978: @102403
    GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(102459), // Rule ID 265 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 265,
      GIR_EraseRootFromParent_Done,
    // Label 1979: @102459
    GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(102515), // Rule ID 266 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 266,
      GIR_EraseRootFromParent_Done,
    // Label 1980: @102515
    GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(102571), // Rule ID 267 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 267,
      GIR_EraseRootFromParent_Done,
    // Label 1981: @102571
    GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(102622), // Rule ID 280 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 280,
      GIR_EraseRootFromParent_Done,
    // Label 1982: @102622
    GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(102673), // Rule ID 282 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 282,
      GIR_EraseRootFromParent_Done,
    // Label 1983: @102673
    GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(102724), // Rule ID 283 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 283,
      GIR_EraseRootFromParent_Done,
    // Label 1984: @102724
    GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(102775), // Rule ID 301 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 301,
      GIR_EraseRootFromParent_Done,
    // Label 1985: @102775
    GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(102826), // Rule ID 303 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 303,
      GIR_EraseRootFromParent_Done,
    // Label 1986: @102826
    GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(102877), // Rule ID 304 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 304,
      GIR_EraseRootFromParent_Done,
    // Label 1987: @102877
    GIM_Reject,
    // Label 1967: @102878
    GIM_Reject,
    // Label 18: @102879
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1990*/ GIMT_Encode4(105892),
    /*GILLT_s32*//*Label 1988*/ GIMT_Encode4(102898),
    /*GILLT_s64*//*Label 1989*/ GIMT_Encode4(104357),
    // Label 1988: @102898
    GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(102954), // Rule ID 240 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 240,
      GIR_EraseRootFromParent_Done,
    // Label 1991: @102954
    GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(103010), // Rule ID 241 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 241,
      GIR_EraseRootFromParent_Done,
    // Label 1992: @103010
    GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(103066), // Rule ID 242 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 242,
      GIR_EraseRootFromParent_Done,
    // Label 1993: @103066
    GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(103122), // Rule ID 243 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 243,
      GIR_EraseRootFromParent_Done,
    // Label 1994: @103122
    GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(103178), // Rule ID 4097 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4097,
      GIR_EraseRootFromParent_Done,
    // Label 1995: @103178
    GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(103234), // Rule ID 4098 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4098,
      GIR_EraseRootFromParent_Done,
    // Label 1996: @103234
    GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(103285), // Rule ID 277 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 277,
      GIR_EraseRootFromParent_Done,
    // Label 1997: @103285
    GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(103336), // Rule ID 278 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 278,
      GIR_EraseRootFromParent_Done,
    // Label 1998: @103336
    GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(103395), // Rule ID 7223 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15274>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7223,
      GIR_EraseRootFromParent_Done,
    // Label 1999: @103395
    GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(103454), // Rule ID 7225 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15274>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7225,
      GIR_EraseRootFromParent_Done,
    // Label 2000: @103454
    GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(103513), // Rule ID 7235 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15283>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7235,
      GIR_EraseRootFromParent_Done,
    // Label 2001: @103513
    GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(103572), // Rule ID 7237 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15283>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7237,
      GIR_EraseRootFromParent_Done,
    // Label 2002: @103572
    GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(103623), // Rule ID 298 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 298,
      GIR_EraseRootFromParent_Done,
    // Label 2003: @103623
    GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(103674), // Rule ID 299 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 299,
      GIR_EraseRootFromParent_Done,
    // Label 2004: @103674
    GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(103725), // Rule ID 4119 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4119,
      GIR_EraseRootFromParent_Done,
    // Label 2005: @103725
    GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(103776), // Rule ID 4152 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4152,
      GIR_EraseRootFromParent_Done,
    // Label 2006: @103776
    GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(103827), // Rule ID 4153 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4153,
      GIR_EraseRootFromParent_Done,
    // Label 2007: @103827
    GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(103878), // Rule ID 4154 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4154,
      GIR_EraseRootFromParent_Done,
    // Label 2008: @103878
    GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(103932), // Rule ID 7227 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15274>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7227,
      GIR_EraseRootFromParent_Done,
    // Label 2009: @103932
    GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(103986), // Rule ID 7229 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15274>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7229,
      GIR_EraseRootFromParent_Done,
    // Label 2010: @103986
    GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(104040), // Rule ID 7239 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15283>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7239,
      GIR_EraseRootFromParent_Done,
    // Label 2011: @104040
    GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(104094), // Rule ID 7241 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15283>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7241,
      GIR_EraseRootFromParent_Done,
    // Label 2012: @104094
    GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(104151), // Rule ID 7563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15272>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7563,
      GIR_EraseRootFromParent_Done,
    // Label 2013: @104151
    GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(104208), // Rule ID 7565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15281>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7565,
      GIR_EraseRootFromParent_Done,
    // Label 2014: @104208
    GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(104245), // Rule ID 7219 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15270>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7219,
      GIR_Done,
    // Label 2015: @104245
    GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(104282), // Rule ID 7221 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15272>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7221,
      GIR_Done,
    // Label 2016: @104282
    GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(104319), // Rule ID 7231 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15279>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7231,
      GIR_Done,
    // Label 2017: @104319
    GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(104356), // Rule ID 7233 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15281>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7233,
      GIR_Done,
    // Label 2018: @104356
    GIM_Reject,
    // Label 1989: @104357
    GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(104445), // Rule ID 4075 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4075,
      GIR_EraseRootFromParent_Done,
    // Label 2019: @104445
    GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(104533), // Rule ID 4076 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4076,
      GIR_EraseRootFromParent_Done,
    // Label 2020: @104533
    GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(104621), // Rule ID 4077 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4077,
      GIR_EraseRootFromParent_Done,
    // Label 2021: @104621
    GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(104709), // Rule ID 4078 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4078,
      GIR_EraseRootFromParent_Done,
    // Label 2022: @104709
    GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(104797), // Rule ID 4079 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4079,
      GIR_EraseRootFromParent_Done,
    // Label 2023: @104797
    GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(104885), // Rule ID 4080 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4080,
      GIR_EraseRootFromParent_Done,
    // Label 2024: @104885
    GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(104973), // Rule ID 4081 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4081,
      GIR_EraseRootFromParent_Done,
    // Label 2025: @104973
    GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(105061), // Rule ID 4082 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4082,
      GIR_EraseRootFromParent_Done,
    // Label 2026: @105061
    GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(105144), // Rule ID 4117 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4117,
      GIR_EraseRootFromParent_Done,
    // Label 2027: @105144
    GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(105227), // Rule ID 4118 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4118,
      GIR_EraseRootFromParent_Done,
    // Label 2028: @105227
    GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(105310), // Rule ID 4120 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4120,
      GIR_EraseRootFromParent_Done,
    // Label 2029: @105310
    GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(105393), // Rule ID 4128 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4128,
      GIR_EraseRootFromParent_Done,
    // Label 2030: @105393
    GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(105476), // Rule ID 4155 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4155,
      GIR_EraseRootFromParent_Done,
    // Label 2031: @105476
    GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(105559), // Rule ID 4156 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4156,
      GIR_EraseRootFromParent_Done,
    // Label 2032: @105559
    GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(105642), // Rule ID 4157 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4157,
      GIR_EraseRootFromParent_Done,
    // Label 2033: @105642
    GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(105725), // Rule ID 4158 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4158,
      GIR_EraseRootFromParent_Done,
    // Label 2034: @105725
    GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(105808), // Rule ID 4159 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4159,
      GIR_EraseRootFromParent_Done,
    // Label 2035: @105808
    GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(105891), // Rule ID 4160 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4160,
      GIR_EraseRootFromParent_Done,
    // Label 2036: @105891
    GIM_Reject,
    // Label 1990: @105892
    GIM_Reject,
    // Label 19: @105893
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2057*/ GIMT_Encode4(119969),
    /*GILLT_s8*//*Label 2037*/ GIMT_Encode4(106000),
    /*GILLT_s16*//*Label 2038*/ GIMT_Encode4(106367),
    /*GILLT_s32*//*Label 2039*/ GIMT_Encode4(107755),
    /*GILLT_s64*//*Label 2040*/ GIMT_Encode4(112350),
    /*GILLT_s128*//*Label 2041*/ GIMT_Encode4(116119),
    /*GILLT_v2s32*//*Label 2042*/ GIMT_Encode4(116325),
    /*GILLT_v2s64*//*Label 2043*/ GIMT_Encode4(116731),
    /*GILLT_v4s16*//*Label 2044*/ GIMT_Encode4(117181),
    /*GILLT_v4s32*//*Label 2045*/ GIMT_Encode4(117773),
    /*GILLT_v8s8*//*Label 2046*/ GIMT_Encode4(118179),
    /*GILLT_v8s16*//*Label 2047*/ GIMT_Encode4(118399),
    /*GILLT_v16s8*//*Label 2048*/ GIMT_Encode4(118991), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 2049*/ GIMT_Encode4(119211),
    /*GILLT_nxv2s32*//*Label 2050*/ GIMT_Encode4(119321),
    /*GILLT_nxv2s64*//*Label 2051*/ GIMT_Encode4(119381), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 2052*/ GIMT_Encode4(119491),
    /*GILLT_nxv4s32*//*Label 2053*/ GIMT_Encode4(119601), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 2054*/ GIMT_Encode4(119711),
    /*GILLT_nxv16s1*//*Label 2055*/ GIMT_Encode4(119865),
    /*GILLT_nxv16s8*//*Label 2056*/ GIMT_Encode4(119909),
    // Label 2037: @106000
    GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(106366),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(106080), // Rule ID 13162 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13162,
        GIR_EraseRootFromParent_Done,
      // Label 2059: @106080
      GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(106179), // Rule ID 13163 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13163,
        GIR_EraseRootFromParent_Done,
      // Label 2060: @106179
      GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(106228), // Rule ID 314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 314,
        GIR_EraseRootFromParent_Done,
      // Label 2061: @106228
      GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(106277), // Rule ID 315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 315,
        GIR_EraseRootFromParent_Done,
      // Label 2062: @106277
      GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(106321), // Rule ID 324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 324,
        GIR_EraseRootFromParent_Done,
      // Label 2063: @106321
      GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(106365), // Rule ID 332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 332,
        GIR_EraseRootFromParent_Done,
      // Label 2064: @106365
      GIM_Reject,
    // Label 2058: @106366
    GIM_Reject,
    // Label 2038: @106367
    GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(107754),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(106478), // Rule ID 4497 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4497,
        GIR_EraseRootFromParent_Done,
      // Label 2066: @106478
      GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(106577), // Rule ID 4498 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4498,
        GIR_EraseRootFromParent_Done,
      // Label 2067: @106577
      GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(106676), // Rule ID 13160 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13160,
        GIR_EraseRootFromParent_Done,
      // Label 2068: @106676
      GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(106775), // Rule ID 13161 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13161,
        GIR_EraseRootFromParent_Done,
      // Label 2069: @106775
      GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(106869), // Rule ID 4529 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4529,
        GIR_EraseRootFromParent_Done,
      // Label 2070: @106869
      GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(106963), // Rule ID 4557 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4557,
        GIR_EraseRootFromParent_Done,
      // Label 2071: @106963
      GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(107057), // Rule ID 13159 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13159,
        GIR_EraseRootFromParent_Done,
      // Label 2072: @107057
      GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(107151), // Rule ID 13165 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13165,
        GIR_EraseRootFromParent_Done,
      // Label 2073: @107151
      GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(107219), // Rule ID 6524 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6524,
        GIR_EraseRootFromParent_Done,
      // Label 2074: @107219
      GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(107287), // Rule ID 6525 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[bf16] } VecListOne128:{ *:[v8bf16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8bf16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6525,
        GIR_EraseRootFromParent_Done,
      // Label 2075: @107287
      GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(107386), // Rule ID 6530 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6530,
        GIR_EraseRootFromParent_Done,
      // Label 2076: @107386
      GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(107485), // Rule ID 6531 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[bf16] } VecListOne64:{ *:[v4bf16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4bf16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6531,
        GIR_EraseRootFromParent_Done,
      // Label 2077: @107485
      GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(107534), // Rule ID 316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 316,
        GIR_EraseRootFromParent_Done,
      // Label 2078: @107534
      GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(107583), // Rule ID 317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 317,
        GIR_EraseRootFromParent_Done,
      // Label 2079: @107583
      GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(107627), // Rule ID 325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 325,
        GIR_EraseRootFromParent_Done,
      // Label 2080: @107627
      GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(107671), // Rule ID 333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 333,
        GIR_EraseRootFromParent_Done,
      // Label 2081: @107671
      GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(107712), // Rule ID 4507 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st FPR16Op:{ *:[bf16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16:{ *:[bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4507,
        GIR_EraseRootFromParent_Done,
      // Label 2082: @107712
      GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(107753), // Rule ID 4534 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (st FPR16Op:{ *:[bf16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16:{ *:[bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4534,
        GIR_EraseRootFromParent_Done,
      // Label 2083: @107753
      GIM_Reject,
    // Label 2065: @107754
    GIM_Reject,
    // Label 2039: @107755
    GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(107861), // Rule ID 4499 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4499,
      GIR_EraseRootFromParent_Done,
    // Label 2084: @107861
    GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(107967), // Rule ID 4500 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4500,
      GIR_EraseRootFromParent_Done,
    // Label 2085: @107967
    GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(108073), // Rule ID 4501 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4501,
      GIR_EraseRootFromParent_Done,
    // Label 2086: @108073
    GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(108179), // Rule ID 4502 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4502,
      GIR_EraseRootFromParent_Done,
    // Label 2087: @108179
    GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(108285), // Rule ID 13167 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13167,
      GIR_EraseRootFromParent_Done,
    // Label 2088: @108285
    GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(108391), // Rule ID 13168 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13168,
      GIR_EraseRootFromParent_Done,
    // Label 2089: @108391
    GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(108504), // Rule ID 4495 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4495,
      GIR_EraseRootFromParent_Done,
    // Label 2090: @108504
    GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(108617), // Rule ID 4496 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4496,
      GIR_EraseRootFromParent_Done,
    // Label 2091: @108617
    GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(108718), // Rule ID 4530 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4530,
      GIR_EraseRootFromParent_Done,
    // Label 2092: @108718
    GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(108819), // Rule ID 4531 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4531,
      GIR_EraseRootFromParent_Done,
    // Label 2093: @108819
    GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(108920), // Rule ID 4558 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4558,
      GIR_EraseRootFromParent_Done,
    // Label 2094: @108920
    GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(109021), // Rule ID 4559 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4559,
      GIR_EraseRootFromParent_Done,
    // Label 2095: @109021
    GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(109122), // Rule ID 13164 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13164,
      GIR_EraseRootFromParent_Done,
    // Label 2096: @109122
    GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(109223), // Rule ID 13166 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13166,
      GIR_EraseRootFromParent_Done,
    // Label 2097: @109223
    GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(109331), // Rule ID 4528 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4528,
      GIR_EraseRootFromParent_Done,
    // Label 2098: @109331
    GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(109439), // Rule ID 4556 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4556,
      GIR_EraseRootFromParent_Done,
    // Label 2099: @109439
    GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(109514), // Rule ID 6520 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6520,
      GIR_EraseRootFromParent_Done,
    // Label 2100: @109514
    GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(109589), // Rule ID 6521 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6521,
      GIR_EraseRootFromParent_Done,
    // Label 2101: @109589
    GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(109695), // Rule ID 6528 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6528,
      GIR_EraseRootFromParent_Done,
    // Label 2102: @109695
    GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(109801), // Rule ID 6529 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6529,
      GIR_EraseRootFromParent_Done,
    // Label 2103: @109801
    GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(109883), // Rule ID 6518 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6518,
      GIR_EraseRootFromParent_Done,
    // Label 2104: @109883
    GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(109965), // Rule ID 6519 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6519,
      GIR_EraseRootFromParent_Done,
    // Label 2105: @109965
    GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(110078), // Rule ID 6526 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6526,
      GIR_EraseRootFromParent_Done,
    // Label 2106: @110078
    GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(110191), // Rule ID 6527 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6527,
      GIR_EraseRootFromParent_Done,
    // Label 2107: @110191
    GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(110244), // Rule ID 310 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 310,
      GIR_EraseRootFromParent_Done,
    // Label 2108: @110244
    GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(110297), // Rule ID 311 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 311,
      GIR_EraseRootFromParent_Done,
    // Label 2109: @110297
    GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(110353), // Rule ID 318 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 318,
      GIR_EraseRootFromParent_Done,
    // Label 2110: @110353
    GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(110409), // Rule ID 319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 319,
      GIR_EraseRootFromParent_Done,
    // Label 2111: @110409
    GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(110469), // Rule ID 306 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 306,
      GIR_EraseRootFromParent_Done,
    // Label 2112: @110469
    GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(110529), // Rule ID 307 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 307,
      GIR_EraseRootFromParent_Done,
    // Label 2113: @110529
    GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(110589), // Rule ID 308 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 308,
      GIR_EraseRootFromParent_Done,
    // Label 2114: @110589
    GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(110649), // Rule ID 309 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 309,
      GIR_EraseRootFromParent_Done,
    // Label 2115: @110649
    GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(110701), // Rule ID 323 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 323,
      GIR_EraseRootFromParent_Done,
    // Label 2116: @110701
    GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(110752), // Rule ID 326 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 326,
      GIR_EraseRootFromParent_Done,
    // Label 2117: @110752
    GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(110811), // Rule ID 328 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 328,
      GIR_EraseRootFromParent_Done,
    // Label 2118: @110811
    GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(110870), // Rule ID 329 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 329,
      GIR_EraseRootFromParent_Done,
    // Label 2119: @110870
    GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(110947), // Rule ID 7282 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7282,
      GIR_EraseRootFromParent_Done,
    // Label 2120: @110947
    GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111024), // Rule ID 7283 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7283,
      GIR_EraseRootFromParent_Done,
    // Label 2121: @111024
    GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111083), // Rule ID 7263 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15314>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7263,
      GIR_EraseRootFromParent_Done,
    // Label 2122: @111083
    GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111142), // Rule ID 7264 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15314>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7264,
      GIR_EraseRootFromParent_Done,
    // Label 2123: @111142
    GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111201), // Rule ID 7268 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15321>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7268,
      GIR_EraseRootFromParent_Done,
    // Label 2124: @111201
    GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111260), // Rule ID 7269 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15321>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7269,
      GIR_EraseRootFromParent_Done,
    // Label 2125: @111260
    GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111319), // Rule ID 7273 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7273,
      GIR_EraseRootFromParent_Done,
    // Label 2126: @111319
    GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111378), // Rule ID 7274 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7274,
      GIR_EraseRootFromParent_Done,
    // Label 2127: @111378
    GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111450), // Rule ID 7284 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7284,
      GIR_EraseRootFromParent_Done,
    // Label 2128: @111450
    GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111522), // Rule ID 7285 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7285,
      GIR_EraseRootFromParent_Done,
    // Label 2129: @111522
    GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(111574), // Rule ID 331 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 331,
      GIR_EraseRootFromParent_Done,
    // Label 2130: @111574
    GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(111625), // Rule ID 334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 334,
      GIR_EraseRootFromParent_Done,
    // Label 2131: @111625
    GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(111684), // Rule ID 337 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 337,
      GIR_EraseRootFromParent_Done,
    // Label 2132: @111684
    GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(111743), // Rule ID 338 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 338,
      GIR_EraseRootFromParent_Done,
    // Label 2133: @111743
    GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(111797), // Rule ID 7265 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15314>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7265,
      GIR_EraseRootFromParent_Done,
    // Label 2134: @111797
    GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(111851), // Rule ID 7266 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15314>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7266,
      GIR_EraseRootFromParent_Done,
    // Label 2135: @111851
    GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(111905), // Rule ID 7270 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15321>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7270,
      GIR_EraseRootFromParent_Done,
    // Label 2136: @111905
    GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(111959), // Rule ID 7271 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15321>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7271,
      GIR_EraseRootFromParent_Done,
    // Label 2137: @111959
    GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112013), // Rule ID 7275 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7275,
      GIR_EraseRootFromParent_Done,
    // Label 2138: @112013
    GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112067), // Rule ID 7276 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15328>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7276,
      GIR_EraseRootFromParent_Done,
    // Label 2139: @112067
    GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112124), // Rule ID 7568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15312>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7568,
      GIR_EraseRootFromParent_Done,
    // Label 2140: @112124
    GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112181), // Rule ID 7569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15319>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7569,
      GIR_EraseRootFromParent_Done,
    // Label 2141: @112181
    GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112238), // Rule ID 7570 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15326>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7570,
      GIR_EraseRootFromParent_Done,
    // Label 2142: @112238
    GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112275), // Rule ID 7262 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15312>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7262,
      GIR_Done,
    // Label 2143: @112275
    GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112312), // Rule ID 7267 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15319>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7267,
      GIR_Done,
    // Label 2144: @112312
    GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(112349), // Rule ID 7272 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15326>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7272,
      GIR_Done,
    // Label 2145: @112349
    GIM_Reject,
    // Label 2040: @112350
    GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(112456), // Rule ID 4503 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4503,
      GIR_EraseRootFromParent_Done,
    // Label 2146: @112456
    GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(112562), // Rule ID 4504 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4504,
      GIR_EraseRootFromParent_Done,
    // Label 2147: @112562
    GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(112668), // Rule ID 4505 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4505,
      GIR_EraseRootFromParent_Done,
    // Label 2148: @112668
    GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(112774), // Rule ID 4506 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4506,
      GIR_EraseRootFromParent_Done,
    // Label 2149: @112774
    GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(112875), // Rule ID 4532 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4532,
      GIR_EraseRootFromParent_Done,
    // Label 2150: @112875
    GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(112976), // Rule ID 4533 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4533,
      GIR_EraseRootFromParent_Done,
    // Label 2151: @112976
    GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113077), // Rule ID 4560 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4560,
      GIR_EraseRootFromParent_Done,
    // Label 2152: @113077
    GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113178), // Rule ID 4561 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4561,
      GIR_EraseRootFromParent_Done,
    // Label 2153: @113178
    GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113253), // Rule ID 6522 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6522,
      GIR_EraseRootFromParent_Done,
    // Label 2154: @113253
    GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113328), // Rule ID 6523 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6523,
      GIR_EraseRootFromParent_Done,
    // Label 2155: @113328
    GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113381), // Rule ID 312 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 312,
      GIR_EraseRootFromParent_Done,
    // Label 2156: @113381
    GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113434), // Rule ID 313 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 313,
      GIR_EraseRootFromParent_Done,
    // Label 2157: @113434
    GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113490), // Rule ID 320 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 320,
      GIR_EraseRootFromParent_Done,
    // Label 2158: @113490
    GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113546), // Rule ID 321 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 321,
      GIR_EraseRootFromParent_Done,
    // Label 2159: @113546
    GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113599), // Rule ID 4475 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4475,
      GIR_EraseRootFromParent_Done,
    // Label 2160: @113599
    GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113652), // Rule ID 4476 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4476,
      GIR_EraseRootFromParent_Done,
    // Label 2161: @113652
    GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113705), // Rule ID 4477 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4477,
      GIR_EraseRootFromParent_Done,
    // Label 2162: @113705
    GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113758), // Rule ID 4478 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4478,
      GIR_EraseRootFromParent_Done,
    // Label 2163: @113758
    GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113847), // Rule ID 4457 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4457,
      GIR_EraseRootFromParent_Done,
    // Label 2164: @113847
    GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113936), // Rule ID 4458 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4458,
      GIR_EraseRootFromParent_Done,
    // Label 2165: @113936
    GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114025), // Rule ID 4459 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4459,
      GIR_EraseRootFromParent_Done,
    // Label 2166: @114025
    GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114114), // Rule ID 4460 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4460,
      GIR_EraseRootFromParent_Done,
    // Label 2167: @114114
    GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114203), // Rule ID 4461 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4461,
      GIR_EraseRootFromParent_Done,
    // Label 2168: @114203
    GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114292), // Rule ID 4462 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4462,
      GIR_EraseRootFromParent_Done,
    // Label 2169: @114292
    GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114344), // Rule ID 322 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 322,
      GIR_EraseRootFromParent_Done,
    // Label 2170: @114344
    GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114395), // Rule ID 327 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 327,
      GIR_EraseRootFromParent_Done,
    // Label 2171: @114395
    GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114443), // Rule ID 4508 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4508,
      GIR_EraseRootFromParent_Done,
    // Label 2172: @114443
    GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114491), // Rule ID 4509 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4509,
      GIR_EraseRootFromParent_Done,
    // Label 2173: @114491
    GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114575), // Rule ID 4525 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4525,
      GIR_EraseRootFromParent_Done,
    // Label 2174: @114575
    GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114659), // Rule ID 4526 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4526,
      GIR_EraseRootFromParent_Done,
    // Label 2175: @114659
    GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114743), // Rule ID 4527 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4527,
      GIR_EraseRootFromParent_Done,
    // Label 2176: @114743
    GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114820), // Rule ID 7286 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7286,
      GIR_EraseRootFromParent_Done,
    // Label 2177: @114820
    GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114897), // Rule ID 7287 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7287,
      GIR_EraseRootFromParent_Done,
    // Label 2178: @114897
    GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114956), // Rule ID 7278 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7278,
      GIR_EraseRootFromParent_Done,
    // Label 2179: @114956
    GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(115015), // Rule ID 7279 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7279,
      GIR_EraseRootFromParent_Done,
    // Label 2180: @115015
    GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(115087), // Rule ID 7288 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7288,
      GIR_EraseRootFromParent_Done,
    // Label 2181: @115087
    GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(115159), // Rule ID 7289 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7289,
      GIR_EraseRootFromParent_Done,
    // Label 2182: @115159
    GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(115256), // Rule ID 7560 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[3] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15333>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7560,
      GIR_EraseRootFromParent_Done,
    // Label 2183: @115256
    GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(115308), // Rule ID 330 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 330,
      GIR_EraseRootFromParent_Done,
    // Label 2184: @115308
    GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115359), // Rule ID 335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 335,
      GIR_EraseRootFromParent_Done,
    // Label 2185: @115359
    GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115413), // Rule ID 7280 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7280,
      GIR_EraseRootFromParent_Done,
    // Label 2186: @115413
    GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115467), // Rule ID 7281 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15335>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7281,
      GIR_EraseRootFromParent_Done,
    // Label 2187: @115467
    GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115524), // Rule ID 7571 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15333>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7571,
      GIR_EraseRootFromParent_Done,
    // Label 2188: @115524
    GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(115572), // Rule ID 4535 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4535,
      GIR_EraseRootFromParent_Done,
    // Label 2189: @115572
    GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(115620), // Rule ID 4536 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4536,
      GIR_EraseRootFromParent_Done,
    // Label 2190: @115620
    GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(115704), // Rule ID 4553 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4553,
      GIR_EraseRootFromParent_Done,
    // Label 2191: @115704
    GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(115788), // Rule ID 4554 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4554,
      GIR_EraseRootFromParent_Done,
    // Label 2192: @115788
    GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(115872), // Rule ID 4555 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4555,
      GIR_EraseRootFromParent_Done,
    // Label 2193: @115872
    GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(115956), // Rule ID 7559 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15333>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7559,
      GIR_EraseRootFromParent_Done,
    // Label 2194: @115956
    GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(116054), // Rule ID 7561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15333>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7561,
      GIR_EraseRootFromParent_Done,
    // Label 2195: @116054
    GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(116091), // Rule ID 7277 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15333>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7277,
      GIR_Done,
    // Label 2196: @116091
    GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(116118), // Rule ID 6468 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6468,
      GIR_Done,
    // Label 2197: @116118
    GIM_Reject,
    // Label 2041: @116119
    GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(116324),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(116180), // Rule ID 4455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4455,
        GIR_EraseRootFromParent_Done,
      // Label 2199: @116180
      GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(116221), // Rule ID 4456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4456,
        GIR_EraseRootFromParent_Done,
      // Label 2200: @116221
      GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(116254), // Rule ID 4516 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4516,
        GIR_EraseRootFromParent_Done,
      // Label 2201: @116254
      GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(116287), // Rule ID 4543 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4543,
        GIR_EraseRootFromParent_Done,
      // Label 2202: @116287
      GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(116323), // Rule ID 336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 336,
        GIR_EraseRootFromParent_Done,
      // Label 2203: @116323
      GIM_Reject,
    // Label 2198: @116324
    GIM_Reject,
    // Label 2042: @116325
    GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(116730),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(116386), // Rule ID 4463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4463,
        GIR_EraseRootFromParent_Done,
      // Label 2205: @116386
      GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(116435), // Rule ID 4464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4464,
        GIR_EraseRootFromParent_Done,
      // Label 2206: @116435
      GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(116484), // Rule ID 4465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4465,
        GIR_EraseRootFromParent_Done,
      // Label 2207: @116484
      GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(116533), // Rule ID 4466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4466,
        GIR_EraseRootFromParent_Done,
      // Label 2208: @116533
      GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(116577), // Rule ID 4510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4510,
        GIR_EraseRootFromParent_Done,
      // Label 2209: @116577
      GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(116621), // Rule ID 4513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4513,
        GIR_EraseRootFromParent_Done,
      // Label 2210: @116621
      GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(116665), // Rule ID 4537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4537,
        GIR_EraseRootFromParent_Done,
      // Label 2211: @116665
      GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(116709), // Rule ID 4540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4540,
        GIR_EraseRootFromParent_Done,
      // Label 2212: @116709
      GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(116729), // Rule ID 6467 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6467,
        GIR_Done,
      // Label 2213: @116729
      GIM_Reject,
    // Label 2204: @116730
    GIM_Reject,
    // Label 2043: @116731
    GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(117180),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116792), // Rule ID 4479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4479,
        GIR_EraseRootFromParent_Done,
      // Label 2215: @116792
      GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116841), // Rule ID 4480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4480,
        GIR_EraseRootFromParent_Done,
      // Label 2216: @116841
      GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116890), // Rule ID 4481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4481,
        GIR_EraseRootFromParent_Done,
      // Label 2217: @116890
      GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116939), // Rule ID 4482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4482,
        GIR_EraseRootFromParent_Done,
      // Label 2218: @116939
      GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116983), // Rule ID 4518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4518,
        GIR_EraseRootFromParent_Done,
      // Label 2219: @116983
      GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(117027), // Rule ID 4522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4522,
        GIR_EraseRootFromParent_Done,
      // Label 2220: @117027
      GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(117071), // Rule ID 4545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4545,
        GIR_EraseRootFromParent_Done,
      // Label 2221: @117071
      GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(117115), // Rule ID 4549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4549,
        GIR_EraseRootFromParent_Done,
      // Label 2222: @117115
      GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(117159), // Rule ID 4550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4550,
        GIR_EraseRootFromParent_Done,
      // Label 2223: @117159
      GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(117179), // Rule ID 6464 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6464,
        GIR_Done,
      // Label 2224: @117179
      GIM_Reject,
    // Label 2214: @117180
    GIM_Reject,
    // Label 2044: @117181
    GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(117772),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(117242), // Rule ID 4467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4467,
        GIR_EraseRootFromParent_Done,
      // Label 2226: @117242
      GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(117291), // Rule ID 4468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4468,
        GIR_EraseRootFromParent_Done,
      // Label 2227: @117291
      GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(117340), // Rule ID 4471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4471,
        GIR_EraseRootFromParent_Done,
      // Label 2228: @117340
      GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(117389), // Rule ID 4472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4472,
        GIR_EraseRootFromParent_Done,
      // Label 2229: @117389
      GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(117438), // Rule ID 4473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4473,
        GIR_EraseRootFromParent_Done,
      // Label 2230: @117438
      GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(117487), // Rule ID 4474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4474,
        GIR_EraseRootFromParent_Done,
      // Label 2231: @117487
      GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(117531), // Rule ID 4512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4512,
        GIR_EraseRootFromParent_Done,
      // Label 2232: @117531
      GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(117575), // Rule ID 4514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4514,
        GIR_EraseRootFromParent_Done,
      // Label 2233: @117575
      GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(117619), // Rule ID 4515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4515,
        GIR_EraseRootFromParent_Done,
      // Label 2234: @117619
      GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(117663), // Rule ID 4539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4539,
        GIR_EraseRootFromParent_Done,
      // Label 2235: @117663
      GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(117707), // Rule ID 4541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4541,
        GIR_EraseRootFromParent_Done,
      // Label 2236: @117707
      GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(117751), // Rule ID 4542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4542,
        GIR_EraseRootFromParent_Done,
      // Label 2237: @117751
      GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(117771), // Rule ID 6466 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6466,
        GIR_Done,
      // Label 2238: @117771
      GIM_Reject,
    // Label 2225: @117772
    GIM_Reject,
    // Label 2045: @117773
    GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(118178),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(117834), // Rule ID 4483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4483,
        GIR_EraseRootFromParent_Done,
      // Label 2240: @117834
      GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117883), // Rule ID 4484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4484,
        GIR_EraseRootFromParent_Done,
      // Label 2241: @117883
      GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117932), // Rule ID 4485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4485,
        GIR_EraseRootFromParent_Done,
      // Label 2242: @117932
      GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117981), // Rule ID 4486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4486,
        GIR_EraseRootFromParent_Done,
      // Label 2243: @117981
      GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(118025), // Rule ID 4517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4517,
        GIR_EraseRootFromParent_Done,
      // Label 2244: @118025
      GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(118069), // Rule ID 4521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4521,
        GIR_EraseRootFromParent_Done,
      // Label 2245: @118069
      GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(118113), // Rule ID 4544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4544,
        GIR_EraseRootFromParent_Done,
      // Label 2246: @118113
      GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(118157), // Rule ID 4548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4548,
        GIR_EraseRootFromParent_Done,
      // Label 2247: @118157
      GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(118177), // Rule ID 6463 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6463,
        GIR_Done,
      // Label 2248: @118177
      GIM_Reject,
    // Label 2239: @118178
    GIM_Reject,
    // Label 2046: @118179
    GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(118398),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(118240), // Rule ID 4469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4469,
        GIR_EraseRootFromParent_Done,
      // Label 2250: @118240
      GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(118289), // Rule ID 4470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4470,
        GIR_EraseRootFromParent_Done,
      // Label 2251: @118289
      GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(118333), // Rule ID 4511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4511,
        GIR_EraseRootFromParent_Done,
      // Label 2252: @118333
      GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(118377), // Rule ID 4538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4538,
        GIR_EraseRootFromParent_Done,
      // Label 2253: @118377
      GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(118397), // Rule ID 6465 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6465,
        GIR_Done,
      // Label 2254: @118397
      GIM_Reject,
    // Label 2249: @118398
    GIM_Reject,
    // Label 2047: @118399
    GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(118990),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(118460), // Rule ID 4487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4487,
        GIR_EraseRootFromParent_Done,
      // Label 2256: @118460
      GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(118509), // Rule ID 4488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4488,
        GIR_EraseRootFromParent_Done,
      // Label 2257: @118509
      GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(118558), // Rule ID 4491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4491,
        GIR_EraseRootFromParent_Done,
      // Label 2258: @118558
      GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(118607), // Rule ID 4492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4492,
        GIR_EraseRootFromParent_Done,
      // Label 2259: @118607
      GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(118656), // Rule ID 4493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4493,
        GIR_EraseRootFromParent_Done,
      // Label 2260: @118656
      GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(118705), // Rule ID 4494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4494,
        GIR_EraseRootFromParent_Done,
      // Label 2261: @118705
      GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(118749), // Rule ID 4520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4520,
        GIR_EraseRootFromParent_Done,
      // Label 2262: @118749
      GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(118793), // Rule ID 4523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4523,
        GIR_EraseRootFromParent_Done,
      // Label 2263: @118793
      GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(118837), // Rule ID 4524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4524,
        GIR_EraseRootFromParent_Done,
      // Label 2264: @118837
      GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(118881), // Rule ID 4547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4547,
        GIR_EraseRootFromParent_Done,
      // Label 2265: @118881
      GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(118925), // Rule ID 4551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4551,
        GIR_EraseRootFromParent_Done,
      // Label 2266: @118925
      GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(118969), // Rule ID 4552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4552,
        GIR_EraseRootFromParent_Done,
      // Label 2267: @118969
      GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118989), // Rule ID 6462 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6462,
        GIR_Done,
      // Label 2268: @118989
      GIM_Reject,
    // Label 2255: @118990
    GIM_Reject,
    // Label 2048: @118991
    GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(119210),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(119052), // Rule ID 4489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4489,
        GIR_EraseRootFromParent_Done,
      // Label 2270: @119052
      GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(119101), // Rule ID 4490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4490,
        GIR_EraseRootFromParent_Done,
      // Label 2271: @119101
      GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(119145), // Rule ID 4519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4519,
        GIR_EraseRootFromParent_Done,
      // Label 2272: @119145
      GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(119189), // Rule ID 4546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4546,
        GIR_EraseRootFromParent_Done,
      // Label 2273: @119189
      GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(119209), // Rule ID 6461 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6461,
        GIR_Done,
      // Label 2274: @119209
      GIM_Reject,
    // Label 2269: @119210
    GIM_Reject,
    // Label 2049: @119211
    GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(119320),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(119275), // Rule ID 11155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11155,
        GIR_EraseRootFromParent_Done,
      // Label 2276: @119275
      GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(119319), // Rule ID 11158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2bf16:{ *:[nxv2bf16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2bf16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11158,
        GIR_EraseRootFromParent_Done,
      // Label 2277: @119319
      GIM_Reject,
    // Label 2275: @119320
    GIM_Reject,
    // Label 2050: @119321
    GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(119380), // Rule ID 11164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11164,
      GIR_EraseRootFromParent_Done,
    // Label 2278: @119380
    GIM_Reject,
    // Label 2051: @119381
    GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(119490),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(119445), // Rule ID 11140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11140,
        GIR_EraseRootFromParent_Done,
      // Label 2280: @119445
      GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(119489), // Rule ID 11167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11167,
        GIR_EraseRootFromParent_Done,
      // Label 2281: @119489
      GIM_Reject,
    // Label 2279: @119490
    GIM_Reject,
    // Label 2052: @119491
    GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(119600),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(119555), // Rule ID 11149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11149,
        GIR_EraseRootFromParent_Done,
      // Label 2283: @119555
      GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(119599), // Rule ID 11152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4bf16:{ *:[nxv4bf16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4bf16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11152,
        GIR_EraseRootFromParent_Done,
      // Label 2284: @119599
      GIM_Reject,
    // Label 2282: @119600
    GIM_Reject,
    // Label 2053: @119601
    GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(119710),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(119665), // Rule ID 11134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11134,
        GIR_EraseRootFromParent_Done,
      // Label 2286: @119665
      GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(119709), // Rule ID 11161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11161,
        GIR_EraseRootFromParent_Done,
      // Label 2287: @119709
      GIM_Reject,
    // Label 2285: @119710
    GIM_Reject,
    // Label 2054: @119711
    GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(119864),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(119775), // Rule ID 11125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11125,
        GIR_EraseRootFromParent_Done,
      // Label 2289: @119775
      GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(119819), // Rule ID 11143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11143,
        GIR_EraseRootFromParent_Done,
      // Label 2290: @119819
      GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(119863), // Rule ID 11146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv8bf16:{ *:[nxv8bf16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8bf16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11146,
        GIR_EraseRootFromParent_Done,
      // Label 2291: @119863
      GIM_Reject,
    // Label 2288: @119864
    GIM_Reject,
    // Label 2055: @119865
    GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(119908), // Rule ID 2406 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
      GIR_RootToRootCopy, /*OpIdx*/0, // Val
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2406,
      GIR_EraseRootFromParent_Done,
    // Label 2292: @119908
    GIM_Reject,
    // Label 2056: @119909
    GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(119968), // Rule ID 11111 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11111,
      GIR_EraseRootFromParent_Done,
    // Label 2293: @119968
    GIM_Reject,
    // Label 2057: @119969
    GIM_Reject,
    // Label 20: @119970
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2296*/ GIMT_Encode4(121320),
    /*GILLT_s32*//*Label 2294*/ GIMT_Encode4(119989),
    /*GILLT_s64*//*Label 2295*/ GIMT_Encode4(121007),
    // Label 2294: @119989
    GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(121006),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(120055), // Rule ID 7500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7500,
        GIR_EraseRootFromParent_Done,
      // Label 2298: @120055
      GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(120110), // Rule ID 7501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7501,
        GIR_EraseRootFromParent_Done,
      // Label 2299: @120110
      GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(120165), // Rule ID 7502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7502,
        GIR_EraseRootFromParent_Done,
      // Label 2300: @120165
      GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(120220), // Rule ID 7503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7503,
        GIR_EraseRootFromParent_Done,
      // Label 2301: @120220
      GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(120275), // Rule ID 7504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7504,
        GIR_EraseRootFromParent_Done,
      // Label 2302: @120275
      GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(120330), // Rule ID 7505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7505,
        GIR_EraseRootFromParent_Done,
      // Label 2303: @120330
      GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(120385), // Rule ID 7506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7506,
        GIR_EraseRootFromParent_Done,
      // Label 2304: @120385
      GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(120440), // Rule ID 7507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7507,
        GIR_EraseRootFromParent_Done,
      // Label 2305: @120440
      GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(120495), // Rule ID 7508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7508,
        GIR_EraseRootFromParent_Done,
      // Label 2306: @120495
      GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(120550), // Rule ID 7509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7509,
        GIR_EraseRootFromParent_Done,
      // Label 2307: @120550
      GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(120605), // Rule ID 7510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7510,
        GIR_EraseRootFromParent_Done,
      // Label 2308: @120605
      GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(120660), // Rule ID 7511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7511,
        GIR_EraseRootFromParent_Done,
      // Label 2309: @120660
      GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(120715), // Rule ID 7512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7512,
        GIR_EraseRootFromParent_Done,
      // Label 2310: @120715
      GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(120770), // Rule ID 7513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7513,
        GIR_EraseRootFromParent_Done,
      // Label 2311: @120770
      GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(120825), // Rule ID 7514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7514,
        GIR_EraseRootFromParent_Done,
      // Label 2312: @120825
      GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(120885), // Rule ID 13091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13091,
        GIR_EraseRootFromParent_Done,
      // Label 2313: @120885
      GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(120945), // Rule ID 13092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13092,
        GIR_EraseRootFromParent_Done,
      // Label 2314: @120945
      GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(121005), // Rule ID 13093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13093,
        GIR_EraseRootFromParent_Done,
      // Label 2315: @121005
      GIM_Reject,
    // Label 2297: @121006
    GIM_Reject,
    // Label 2295: @121007
    GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(121319),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(121073), // Rule ID 2542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2542,
        GIR_EraseRootFromParent_Done,
      // Label 2317: @121073
      GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(121121), // Rule ID 2543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2543,
        GIR_EraseRootFromParent_Done,
      // Label 2318: @121121
      GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(121169), // Rule ID 2544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2544,
        GIR_EraseRootFromParent_Done,
      // Label 2319: @121169
      GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(121217), // Rule ID 2545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2545,
        GIR_EraseRootFromParent_Done,
      // Label 2320: @121217
      GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(121265), // Rule ID 2546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2546,
        GIR_EraseRootFromParent_Done,
      // Label 2321: @121265
      GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(121318), // Rule ID 13094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13094,
        GIR_EraseRootFromParent_Done,
      // Label 2322: @121318
      GIM_Reject,
    // Label 2316: @121319
    GIM_Reject,
    // Label 2296: @121320
    GIM_Reject,
    // Label 21: @121321
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2325*/ GIMT_Encode4(122312),
    /*GILLT_s32*//*Label 2323*/ GIMT_Encode4(121340),
    /*GILLT_s64*//*Label 2324*/ GIMT_Encode4(122085),
    // Label 2323: @121340
    GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(122084),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(121397), // Rule ID 7485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7485,
        GIR_EraseRootFromParent_Done,
      // Label 2327: @121397
      GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(121446), // Rule ID 7486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7486,
        GIR_EraseRootFromParent_Done,
      // Label 2328: @121446
      GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(121495), // Rule ID 7487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7487,
        GIR_EraseRootFromParent_Done,
      // Label 2329: @121495
      GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(121544), // Rule ID 7488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7488,
        GIR_EraseRootFromParent_Done,
      // Label 2330: @121544
      GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(121593), // Rule ID 7489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7489,
        GIR_EraseRootFromParent_Done,
      // Label 2331: @121593
      GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(121642), // Rule ID 7490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7490,
        GIR_EraseRootFromParent_Done,
      // Label 2332: @121642
      GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(121691), // Rule ID 7491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7491,
        GIR_EraseRootFromParent_Done,
      // Label 2333: @121691
      GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(121740), // Rule ID 7492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7492,
        GIR_EraseRootFromParent_Done,
      // Label 2334: @121740
      GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(121789), // Rule ID 7493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7493,
        GIR_EraseRootFromParent_Done,
      // Label 2335: @121789
      GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(121838), // Rule ID 7494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7494,
        GIR_EraseRootFromParent_Done,
      // Label 2336: @121838
      GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(121887), // Rule ID 7495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7495,
        GIR_EraseRootFromParent_Done,
      // Label 2337: @121887
      GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(121936), // Rule ID 7496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7496,
        GIR_EraseRootFromParent_Done,
      // Label 2338: @121936
      GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(121985), // Rule ID 7497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7497,
        GIR_EraseRootFromParent_Done,
      // Label 2339: @121985
      GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(122034), // Rule ID 7498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7498,
        GIR_EraseRootFromParent_Done,
      // Label 2340: @122034
      GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(122083), // Rule ID 7499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7499,
        GIR_EraseRootFromParent_Done,
      // Label 2341: @122083
      GIM_Reject,
    // Label 2326: @122084
    GIM_Reject,
    // Label 2324: @122085
    GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(122311),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(122142), // Rule ID 7480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7480,
        GIR_EraseRootFromParent_Done,
      // Label 2343: @122142
      GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(122184), // Rule ID 7481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7481,
        GIR_EraseRootFromParent_Done,
      // Label 2344: @122184
      GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(122226), // Rule ID 7482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7482,
        GIR_EraseRootFromParent_Done,
      // Label 2345: @122226
      GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(122268), // Rule ID 7483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7483,
        GIR_EraseRootFromParent_Done,
      // Label 2346: @122268
      GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(122310), // Rule ID 7484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7484,
        GIR_EraseRootFromParent_Done,
      // Label 2347: @122310
      GIM_Reject,
    // Label 2342: @122311
    GIM_Reject,
    // Label 2325: @122312
    GIM_Reject,
    // Label 22: @122313
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2350*/ GIMT_Encode4(123304),
    /*GILLT_s32*//*Label 2348*/ GIMT_Encode4(122332),
    /*GILLT_s64*//*Label 2349*/ GIMT_Encode4(123077),
    // Label 2348: @122332
    GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(123076),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(122389), // Rule ID 7325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7325,
        GIR_EraseRootFromParent_Done,
      // Label 2352: @122389
      GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(122438), // Rule ID 7326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7326,
        GIR_EraseRootFromParent_Done,
      // Label 2353: @122438
      GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(122487), // Rule ID 7327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7327,
        GIR_EraseRootFromParent_Done,
      // Label 2354: @122487
      GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(122536), // Rule ID 7328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7328,
        GIR_EraseRootFromParent_Done,
      // Label 2355: @122536
      GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(122585), // Rule ID 7329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7329,
        GIR_EraseRootFromParent_Done,
      // Label 2356: @122585
      GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(122634), // Rule ID 7330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7330,
        GIR_EraseRootFromParent_Done,
      // Label 2357: @122634
      GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(122683), // Rule ID 7331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7331,
        GIR_EraseRootFromParent_Done,
      // Label 2358: @122683
      GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(122732), // Rule ID 7332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7332,
        GIR_EraseRootFromParent_Done,
      // Label 2359: @122732
      GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(122781), // Rule ID 7333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7333,
        GIR_EraseRootFromParent_Done,
      // Label 2360: @122781
      GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(122830), // Rule ID 7334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7334,
        GIR_EraseRootFromParent_Done,
      // Label 2361: @122830
      GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(122879), // Rule ID 7335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7335,
        GIR_EraseRootFromParent_Done,
      // Label 2362: @122879
      GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(122928), // Rule ID 7336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7336,
        GIR_EraseRootFromParent_Done,
      // Label 2363: @122928
      GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(122977), // Rule ID 7337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7337,
        GIR_EraseRootFromParent_Done,
      // Label 2364: @122977
      GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(123026), // Rule ID 7338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7338,
        GIR_EraseRootFromParent_Done,
      // Label 2365: @123026
      GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(123075), // Rule ID 7339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7339,
        GIR_EraseRootFromParent_Done,
      // Label 2366: @123075
      GIM_Reject,
    // Label 2351: @123076
    GIM_Reject,
    // Label 2349: @123077
    GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(123303),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(123134), // Rule ID 2537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2537,
        GIR_EraseRootFromParent_Done,
      // Label 2368: @123134
      GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(123176), // Rule ID 2538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2538,
        GIR_EraseRootFromParent_Done,
      // Label 2369: @123176
      GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(123218), // Rule ID 2539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2539,
        GIR_EraseRootFromParent_Done,
      // Label 2370: @123218
      GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(123260), // Rule ID 2540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2540,
        GIR_EraseRootFromParent_Done,
      // Label 2371: @123260
      GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(123302), // Rule ID 2541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2541,
        GIR_EraseRootFromParent_Done,
      // Label 2372: @123302
      GIM_Reject,
    // Label 2367: @123303
    GIM_Reject,
    // Label 2350: @123304
    GIM_Reject,
    // Label 23: @123305
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2375*/ GIMT_Encode4(124796),
    /*GILLT_s32*//*Label 2373*/ GIMT_Encode4(123324),
    /*GILLT_s64*//*Label 2374*/ GIMT_Encode4(124444),
    // Label 2373: @123324
    GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(124443),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(123406), // Rule ID 7520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7520,
        GIR_EraseRootFromParent_Done,
      // Label 2377: @123406
      GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(123480), // Rule ID 7521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7521,
        GIR_EraseRootFromParent_Done,
      // Label 2378: @123480
      GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(123554), // Rule ID 7522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7522,
        GIR_EraseRootFromParent_Done,
      // Label 2379: @123554
      GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(123628), // Rule ID 7523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7523,
        GIR_EraseRootFromParent_Done,
      // Label 2380: @123628
      GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(123702), // Rule ID 7524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7524,
        GIR_EraseRootFromParent_Done,
      // Label 2381: @123702
      GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(123776), // Rule ID 7525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7525,
        GIR_EraseRootFromParent_Done,
      // Label 2382: @123776
      GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(123850), // Rule ID 7526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7526,
        GIR_EraseRootFromParent_Done,
      // Label 2383: @123850
      GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(123924), // Rule ID 7527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7527,
        GIR_EraseRootFromParent_Done,
      // Label 2384: @123924
      GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(123998), // Rule ID 7528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7528,
        GIR_EraseRootFromParent_Done,
      // Label 2385: @123998
      GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(124072), // Rule ID 7529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7529,
        GIR_EraseRootFromParent_Done,
      // Label 2386: @124072
      GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(124146), // Rule ID 7530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7530,
        GIR_EraseRootFromParent_Done,
      // Label 2387: @124146
      GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(124220), // Rule ID 7531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7531,
        GIR_EraseRootFromParent_Done,
      // Label 2388: @124220
      GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(124294), // Rule ID 7532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7532,
        GIR_EraseRootFromParent_Done,
      // Label 2389: @124294
      GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(124368), // Rule ID 7533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7533,
        GIR_EraseRootFromParent_Done,
      // Label 2390: @124368
      GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(124442), // Rule ID 7534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7534,
        GIR_EraseRootFromParent_Done,
      // Label 2391: @124442
      GIM_Reject,
    // Label 2376: @124443
    GIM_Reject,
    // Label 2374: @124444
    GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(124795),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(124526), // Rule ID 7515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7515,
        GIR_EraseRootFromParent_Done,
      // Label 2393: @124526
      GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(124593), // Rule ID 7516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7516,
        GIR_EraseRootFromParent_Done,
      // Label 2394: @124593
      GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(124660), // Rule ID 7517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7517,
        GIR_EraseRootFromParent_Done,
      // Label 2395: @124660
      GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(124727), // Rule ID 7518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7518,
        GIR_EraseRootFromParent_Done,
      // Label 2396: @124727
      GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(124794), // Rule ID 7519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7519,
        GIR_EraseRootFromParent_Done,
      // Label 2397: @124794
      GIM_Reject,
    // Label 2392: @124795
    GIM_Reject,
    // Label 2375: @124796
    GIM_Reject,
    // Label 24: @124797
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2400*/ GIMT_Encode4(126288),
    /*GILLT_s32*//*Label 2398*/ GIMT_Encode4(124816),
    /*GILLT_s64*//*Label 2399*/ GIMT_Encode4(125936),
    // Label 2398: @124816
    GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(125935),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(124898), // Rule ID 7540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7540,
        GIR_EraseRootFromParent_Done,
      // Label 2402: @124898
      GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(124972), // Rule ID 7541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7541,
        GIR_EraseRootFromParent_Done,
      // Label 2403: @124972
      GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(125046), // Rule ID 7542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7542,
        GIR_EraseRootFromParent_Done,
      // Label 2404: @125046
      GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(125120), // Rule ID 7543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7543,
        GIR_EraseRootFromParent_Done,
      // Label 2405: @125120
      GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(125194), // Rule ID 7544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7544,
        GIR_EraseRootFromParent_Done,
      // Label 2406: @125194
      GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(125268), // Rule ID 7545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7545,
        GIR_EraseRootFromParent_Done,
      // Label 2407: @125268
      GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(125342), // Rule ID 7546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7546,
        GIR_EraseRootFromParent_Done,
      // Label 2408: @125342
      GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(125416), // Rule ID 7547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7547,
        GIR_EraseRootFromParent_Done,
      // Label 2409: @125416
      GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(125490), // Rule ID 7548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7548,
        GIR_EraseRootFromParent_Done,
      // Label 2410: @125490
      GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(125564), // Rule ID 7549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7549,
        GIR_EraseRootFromParent_Done,
      // Label 2411: @125564
      GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(125638), // Rule ID 7550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7550,
        GIR_EraseRootFromParent_Done,
      // Label 2412: @125638
      GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(125712), // Rule ID 7551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7551,
        GIR_EraseRootFromParent_Done,
      // Label 2413: @125712
      GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(125786), // Rule ID 7552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7552,
        GIR_EraseRootFromParent_Done,
      // Label 2414: @125786
      GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(125860), // Rule ID 7553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7553,
        GIR_EraseRootFromParent_Done,
      // Label 2415: @125860
      GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(125934), // Rule ID 7554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7554,
        GIR_EraseRootFromParent_Done,
      // Label 2416: @125934
      GIM_Reject,
    // Label 2401: @125935
    GIM_Reject,
    // Label 2399: @125936
    GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(126287),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(126018), // Rule ID 7535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7535,
        GIR_EraseRootFromParent_Done,
      // Label 2418: @126018
      GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(126085), // Rule ID 7536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7536,
        GIR_EraseRootFromParent_Done,
      // Label 2419: @126085
      GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(126152), // Rule ID 7537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7537,
        GIR_EraseRootFromParent_Done,
      // Label 2420: @126152
      GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(126219), // Rule ID 7538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7538,
        GIR_EraseRootFromParent_Done,
      // Label 2421: @126219
      GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(126286), // Rule ID 7539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7539,
        GIR_EraseRootFromParent_Done,
      // Label 2422: @126286
      GIM_Reject,
    // Label 2417: @126287
    GIM_Reject,
    // Label 2400: @126288
    GIM_Reject,
    // Label 25: @126289
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2425*/ GIMT_Encode4(127280),
    /*GILLT_s32*//*Label 2423*/ GIMT_Encode4(126308),
    /*GILLT_s64*//*Label 2424*/ GIMT_Encode4(127053),
    // Label 2423: @126308
    GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(127052),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(126365), // Rule ID 7345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7345,
        GIR_EraseRootFromParent_Done,
      // Label 2427: @126365
      GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(126414), // Rule ID 7346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7346,
        GIR_EraseRootFromParent_Done,
      // Label 2428: @126414
      GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(126463), // Rule ID 7347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7347,
        GIR_EraseRootFromParent_Done,
      // Label 2429: @126463
      GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(126512), // Rule ID 7348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7348,
        GIR_EraseRootFromParent_Done,
      // Label 2430: @126512
      GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(126561), // Rule ID 7349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7349,
        GIR_EraseRootFromParent_Done,
      // Label 2431: @126561
      GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(126610), // Rule ID 7350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7350,
        GIR_EraseRootFromParent_Done,
      // Label 2432: @126610
      GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(126659), // Rule ID 7351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7351,
        GIR_EraseRootFromParent_Done,
      // Label 2433: @126659
      GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(126708), // Rule ID 7352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7352,
        GIR_EraseRootFromParent_Done,
      // Label 2434: @126708
      GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(126757), // Rule ID 7353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7353,
        GIR_EraseRootFromParent_Done,
      // Label 2435: @126757
      GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(126806), // Rule ID 7354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7354,
        GIR_EraseRootFromParent_Done,
      // Label 2436: @126806
      GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(126855), // Rule ID 7355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7355,
        GIR_EraseRootFromParent_Done,
      // Label 2437: @126855
      GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(126904), // Rule ID 7356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7356,
        GIR_EraseRootFromParent_Done,
      // Label 2438: @126904
      GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(126953), // Rule ID 7357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7357,
        GIR_EraseRootFromParent_Done,
      // Label 2439: @126953
      GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(127002), // Rule ID 7358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7358,
        GIR_EraseRootFromParent_Done,
      // Label 2440: @127002
      GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(127051), // Rule ID 7359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7359,
        GIR_EraseRootFromParent_Done,
      // Label 2441: @127051
      GIM_Reject,
    // Label 2426: @127052
    GIM_Reject,
    // Label 2424: @127053
    GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(127279),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(127110), // Rule ID 7340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7340,
        GIR_EraseRootFromParent_Done,
      // Label 2443: @127110
      GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(127152), // Rule ID 7341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7341,
        GIR_EraseRootFromParent_Done,
      // Label 2444: @127152
      GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(127194), // Rule ID 7342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7342,
        GIR_EraseRootFromParent_Done,
      // Label 2445: @127194
      GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(127236), // Rule ID 7343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7343,
        GIR_EraseRootFromParent_Done,
      // Label 2446: @127236
      GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(127278), // Rule ID 7344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7344,
        GIR_EraseRootFromParent_Done,
      // Label 2447: @127278
      GIM_Reject,
    // Label 2442: @127279
    GIM_Reject,
    // Label 2425: @127280
    GIM_Reject,
    // Label 26: @127281
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2450*/ GIMT_Encode4(128272),
    /*GILLT_s32*//*Label 2448*/ GIMT_Encode4(127300),
    /*GILLT_s64*//*Label 2449*/ GIMT_Encode4(128045),
    // Label 2448: @127300
    GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(128044),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(127357), // Rule ID 7365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7365,
        GIR_EraseRootFromParent_Done,
      // Label 2452: @127357
      GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(127406), // Rule ID 7366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7366,
        GIR_EraseRootFromParent_Done,
      // Label 2453: @127406
      GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(127455), // Rule ID 7367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7367,
        GIR_EraseRootFromParent_Done,
      // Label 2454: @127455
      GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(127504), // Rule ID 7368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7368,
        GIR_EraseRootFromParent_Done,
      // Label 2455: @127504
      GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(127553), // Rule ID 7369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7369,
        GIR_EraseRootFromParent_Done,
      // Label 2456: @127553
      GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(127602), // Rule ID 7370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7370,
        GIR_EraseRootFromParent_Done,
      // Label 2457: @127602
      GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(127651), // Rule ID 7371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7371,
        GIR_EraseRootFromParent_Done,
      // Label 2458: @127651
      GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(127700), // Rule ID 7372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7372,
        GIR_EraseRootFromParent_Done,
      // Label 2459: @127700
      GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(127749), // Rule ID 7373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7373,
        GIR_EraseRootFromParent_Done,
      // Label 2460: @127749
      GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(127798), // Rule ID 7374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7374,
        GIR_EraseRootFromParent_Done,
      // Label 2461: @127798
      GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(127847), // Rule ID 7375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7375,
        GIR_EraseRootFromParent_Done,
      // Label 2462: @127847
      GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(127896), // Rule ID 7376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7376,
        GIR_EraseRootFromParent_Done,
      // Label 2463: @127896
      GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(127945), // Rule ID 7377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7377,
        GIR_EraseRootFromParent_Done,
      // Label 2464: @127945
      GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(127994), // Rule ID 7378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7378,
        GIR_EraseRootFromParent_Done,
      // Label 2465: @127994
      GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(128043), // Rule ID 7379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7379,
        GIR_EraseRootFromParent_Done,
      // Label 2466: @128043
      GIM_Reject,
    // Label 2451: @128044
    GIM_Reject,
    // Label 2449: @128045
    GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(128271),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(128102), // Rule ID 7360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7360,
        GIR_EraseRootFromParent_Done,
      // Label 2468: @128102
      GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(128144), // Rule ID 7361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7361,
        GIR_EraseRootFromParent_Done,
      // Label 2469: @128144
      GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(128186), // Rule ID 7362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7362,
        GIR_EraseRootFromParent_Done,
      // Label 2470: @128186
      GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(128228), // Rule ID 7363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7363,
        GIR_EraseRootFromParent_Done,
      // Label 2471: @128228
      GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(128270), // Rule ID 7364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7364,
        GIR_EraseRootFromParent_Done,
      // Label 2472: @128270
      GIM_Reject,
    // Label 2467: @128271
    GIM_Reject,
    // Label 2450: @128272
    GIM_Reject,
    // Label 27: @128273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2475*/ GIMT_Encode4(129264),
    /*GILLT_s32*//*Label 2473*/ GIMT_Encode4(128292),
    /*GILLT_s64*//*Label 2474*/ GIMT_Encode4(129037),
    // Label 2473: @128292
    GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(129036),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(128349), // Rule ID 7405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7405,
        GIR_EraseRootFromParent_Done,
      // Label 2477: @128349
      GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(128398), // Rule ID 7406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7406,
        GIR_EraseRootFromParent_Done,
      // Label 2478: @128398
      GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(128447), // Rule ID 7407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7407,
        GIR_EraseRootFromParent_Done,
      // Label 2479: @128447
      GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(128496), // Rule ID 7408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7408,
        GIR_EraseRootFromParent_Done,
      // Label 2480: @128496
      GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(128545), // Rule ID 7409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7409,
        GIR_EraseRootFromParent_Done,
      // Label 2481: @128545
      GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(128594), // Rule ID 7410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7410,
        GIR_EraseRootFromParent_Done,
      // Label 2482: @128594
      GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(128643), // Rule ID 7411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7411,
        GIR_EraseRootFromParent_Done,
      // Label 2483: @128643
      GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(128692), // Rule ID 7412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7412,
        GIR_EraseRootFromParent_Done,
      // Label 2484: @128692
      GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(128741), // Rule ID 7413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7413,
        GIR_EraseRootFromParent_Done,
      // Label 2485: @128741
      GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(128790), // Rule ID 7414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7414,
        GIR_EraseRootFromParent_Done,
      // Label 2486: @128790
      GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(128839), // Rule ID 7415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7415,
        GIR_EraseRootFromParent_Done,
      // Label 2487: @128839
      GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(128888), // Rule ID 7416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7416,
        GIR_EraseRootFromParent_Done,
      // Label 2488: @128888
      GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(128937), // Rule ID 7417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7417,
        GIR_EraseRootFromParent_Done,
      // Label 2489: @128937
      GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(128986), // Rule ID 7418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7418,
        GIR_EraseRootFromParent_Done,
      // Label 2490: @128986
      GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(129035), // Rule ID 7419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7419,
        GIR_EraseRootFromParent_Done,
      // Label 2491: @129035
      GIM_Reject,
    // Label 2476: @129036
    GIM_Reject,
    // Label 2474: @129037
    GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(129263),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(129094), // Rule ID 7400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7400,
        GIR_EraseRootFromParent_Done,
      // Label 2493: @129094
      GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(129136), // Rule ID 7401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7401,
        GIR_EraseRootFromParent_Done,
      // Label 2494: @129136
      GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(129178), // Rule ID 7402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7402,
        GIR_EraseRootFromParent_Done,
      // Label 2495: @129178
      GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(129220), // Rule ID 7403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7403,
        GIR_EraseRootFromParent_Done,
      // Label 2496: @129220
      GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(129262), // Rule ID 7404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7404,
        GIR_EraseRootFromParent_Done,
      // Label 2497: @129262
      GIM_Reject,
    // Label 2492: @129263
    GIM_Reject,
    // Label 2475: @129264
    GIM_Reject,
    // Label 28: @129265
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2500*/ GIMT_Encode4(130256),
    /*GILLT_s32*//*Label 2498*/ GIMT_Encode4(129284),
    /*GILLT_s64*//*Label 2499*/ GIMT_Encode4(130029),
    // Label 2498: @129284
    GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(130028),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(129341), // Rule ID 7425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7425,
        GIR_EraseRootFromParent_Done,
      // Label 2502: @129341
      GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(129390), // Rule ID 7426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7426,
        GIR_EraseRootFromParent_Done,
      // Label 2503: @129390
      GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(129439), // Rule ID 7427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7427,
        GIR_EraseRootFromParent_Done,
      // Label 2504: @129439
      GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(129488), // Rule ID 7428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7428,
        GIR_EraseRootFromParent_Done,
      // Label 2505: @129488
      GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(129537), // Rule ID 7429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7429,
        GIR_EraseRootFromParent_Done,
      // Label 2506: @129537
      GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(129586), // Rule ID 7430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7430,
        GIR_EraseRootFromParent_Done,
      // Label 2507: @129586
      GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(129635), // Rule ID 7431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7431,
        GIR_EraseRootFromParent_Done,
      // Label 2508: @129635
      GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(129684), // Rule ID 7432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7432,
        GIR_EraseRootFromParent_Done,
      // Label 2509: @129684
      GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(129733), // Rule ID 7433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7433,
        GIR_EraseRootFromParent_Done,
      // Label 2510: @129733
      GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(129782), // Rule ID 7434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7434,
        GIR_EraseRootFromParent_Done,
      // Label 2511: @129782
      GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(129831), // Rule ID 7435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7435,
        GIR_EraseRootFromParent_Done,
      // Label 2512: @129831
      GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(129880), // Rule ID 7436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7436,
        GIR_EraseRootFromParent_Done,
      // Label 2513: @129880
      GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(129929), // Rule ID 7437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7437,
        GIR_EraseRootFromParent_Done,
      // Label 2514: @129929
      GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(129978), // Rule ID 7438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7438,
        GIR_EraseRootFromParent_Done,
      // Label 2515: @129978
      GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(130027), // Rule ID 7439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7439,
        GIR_EraseRootFromParent_Done,
      // Label 2516: @130027
      GIM_Reject,
    // Label 2501: @130028
    GIM_Reject,
    // Label 2499: @130029
    GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(130255),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(130086), // Rule ID 7420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7420,
        GIR_EraseRootFromParent_Done,
      // Label 2518: @130086
      GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(130128), // Rule ID 7421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7421,
        GIR_EraseRootFromParent_Done,
      // Label 2519: @130128
      GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(130170), // Rule ID 7422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7422,
        GIR_EraseRootFromParent_Done,
      // Label 2520: @130170
      GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(130212), // Rule ID 7423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7423,
        GIR_EraseRootFromParent_Done,
      // Label 2521: @130212
      GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(130254), // Rule ID 7424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7424,
        GIR_EraseRootFromParent_Done,
      // Label 2522: @130254
      GIM_Reject,
    // Label 2517: @130255
    GIM_Reject,
    // Label 2500: @130256
    GIM_Reject,
    // Label 29: @130257
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2525*/ GIMT_Encode4(131248),
    /*GILLT_s32*//*Label 2523*/ GIMT_Encode4(130276),
    /*GILLT_s64*//*Label 2524*/ GIMT_Encode4(131021),
    // Label 2523: @130276
    GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(131020),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(130333), // Rule ID 7445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7445,
        GIR_EraseRootFromParent_Done,
      // Label 2527: @130333
      GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(130382), // Rule ID 7446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7446,
        GIR_EraseRootFromParent_Done,
      // Label 2528: @130382
      GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(130431), // Rule ID 7447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7447,
        GIR_EraseRootFromParent_Done,
      // Label 2529: @130431
      GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(130480), // Rule ID 7448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7448,
        GIR_EraseRootFromParent_Done,
      // Label 2530: @130480
      GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(130529), // Rule ID 7449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7449,
        GIR_EraseRootFromParent_Done,
      // Label 2531: @130529
      GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(130578), // Rule ID 7450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7450,
        GIR_EraseRootFromParent_Done,
      // Label 2532: @130578
      GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(130627), // Rule ID 7451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7451,
        GIR_EraseRootFromParent_Done,
      // Label 2533: @130627
      GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(130676), // Rule ID 7452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7452,
        GIR_EraseRootFromParent_Done,
      // Label 2534: @130676
      GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(130725), // Rule ID 7453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7453,
        GIR_EraseRootFromParent_Done,
      // Label 2535: @130725
      GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(130774), // Rule ID 7454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7454,
        GIR_EraseRootFromParent_Done,
      // Label 2536: @130774
      GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(130823), // Rule ID 7455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7455,
        GIR_EraseRootFromParent_Done,
      // Label 2537: @130823
      GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(130872), // Rule ID 7456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7456,
        GIR_EraseRootFromParent_Done,
      // Label 2538: @130872
      GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(130921), // Rule ID 7457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7457,
        GIR_EraseRootFromParent_Done,
      // Label 2539: @130921
      GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(130970), // Rule ID 7458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7458,
        GIR_EraseRootFromParent_Done,
      // Label 2540: @130970
      GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(131019), // Rule ID 7459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7459,
        GIR_EraseRootFromParent_Done,
      // Label 2541: @131019
      GIM_Reject,
    // Label 2526: @131020
    GIM_Reject,
    // Label 2524: @131021
    GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(131247),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(131078), // Rule ID 7440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7440,
        GIR_EraseRootFromParent_Done,
      // Label 2543: @131078
      GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(131120), // Rule ID 7441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7441,
        GIR_EraseRootFromParent_Done,
      // Label 2544: @131120
      GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(131162), // Rule ID 7442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7442,
        GIR_EraseRootFromParent_Done,
      // Label 2545: @131162
      GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(131204), // Rule ID 7443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7443,
        GIR_EraseRootFromParent_Done,
      // Label 2546: @131204
      GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(131246), // Rule ID 7444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7444,
        GIR_EraseRootFromParent_Done,
      // Label 2547: @131246
      GIM_Reject,
    // Label 2542: @131247
    GIM_Reject,
    // Label 2525: @131248
    GIM_Reject,
    // Label 30: @131249
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2550*/ GIMT_Encode4(132240),
    /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(131268),
    /*GILLT_s64*//*Label 2549*/ GIMT_Encode4(132013),
    // Label 2548: @131268
    GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(132012),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(131325), // Rule ID 7465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7465,
        GIR_EraseRootFromParent_Done,
      // Label 2552: @131325
      GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(131374), // Rule ID 7466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7466,
        GIR_EraseRootFromParent_Done,
      // Label 2553: @131374
      GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(131423), // Rule ID 7467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7467,
        GIR_EraseRootFromParent_Done,
      // Label 2554: @131423
      GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(131472), // Rule ID 7468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7468,
        GIR_EraseRootFromParent_Done,
      // Label 2555: @131472
      GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(131521), // Rule ID 7469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7469,
        GIR_EraseRootFromParent_Done,
      // Label 2556: @131521
      GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(131570), // Rule ID 7470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7470,
        GIR_EraseRootFromParent_Done,
      // Label 2557: @131570
      GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(131619), // Rule ID 7471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7471,
        GIR_EraseRootFromParent_Done,
      // Label 2558: @131619
      GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(131668), // Rule ID 7472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7472,
        GIR_EraseRootFromParent_Done,
      // Label 2559: @131668
      GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(131717), // Rule ID 7473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7473,
        GIR_EraseRootFromParent_Done,
      // Label 2560: @131717
      GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(131766), // Rule ID 7474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7474,
        GIR_EraseRootFromParent_Done,
      // Label 2561: @131766
      GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(131815), // Rule ID 7475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7475,
        GIR_EraseRootFromParent_Done,
      // Label 2562: @131815
      GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(131864), // Rule ID 7476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7476,
        GIR_EraseRootFromParent_Done,
      // Label 2563: @131864
      GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(131913), // Rule ID 7477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7477,
        GIR_EraseRootFromParent_Done,
      // Label 2564: @131913
      GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(131962), // Rule ID 7478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7478,
        GIR_EraseRootFromParent_Done,
      // Label 2565: @131962
      GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(132011), // Rule ID 7479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7479,
        GIR_EraseRootFromParent_Done,
      // Label 2566: @132011
      GIM_Reject,
    // Label 2551: @132012
    GIM_Reject,
    // Label 2549: @132013
    GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(132239),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(132070), // Rule ID 7460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7460,
        GIR_EraseRootFromParent_Done,
      // Label 2568: @132070
      GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(132112), // Rule ID 7461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7461,
        GIR_EraseRootFromParent_Done,
      // Label 2569: @132112
      GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(132154), // Rule ID 7462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7462,
        GIR_EraseRootFromParent_Done,
      // Label 2570: @132154
      GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(132196), // Rule ID 7463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7463,
        GIR_EraseRootFromParent_Done,
      // Label 2571: @132196
      GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(132238), // Rule ID 7464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7464,
        GIR_EraseRootFromParent_Done,
      // Label 2572: @132238
      GIM_Reject,
    // Label 2567: @132239
    GIM_Reject,
    // Label 2550: @132240
    GIM_Reject,
    // Label 31: @132241
    GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(132268), // Rule ID 7212 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7212,
      GIR_EraseRootFromParent_Done,
    // Label 2573: @132268
    GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(132291), // Rule ID 7213 //
      // MIs[0] Operand 0
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7213,
      GIR_EraseRootFromParent_Done,
    // Label 2574: @132291
    GIM_Reject,
    // Label 32: @132292
    GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(144891),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(132391), // Rule ID 6564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v16i8] } 506:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 504:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6564,
        GIR_EraseRootFromParent_Done,
      // Label 2576: @132391
      GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(132482), // Rule ID 6565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v16i8] } 505:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 503:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6565,
        GIR_EraseRootFromParent_Done,
      // Label 2577: @132482
      GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(132543), // Rule ID 4920 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f32] } 742:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4920,
        GIR_EraseRootFromParent_Done,
      // Label 2578: @132543
      GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(132583), // Rule ID 2598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1179:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2598,
        GIR_EraseRootFromParent_Done,
      // Label 2579: @132583
      GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(132623), // Rule ID 10139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1181:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10139,
        GIR_EraseRootFromParent_Done,
      // Label 2580: @132623
      GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(132663), // Rule ID 10142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1187:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10142,
        GIR_EraseRootFromParent_Done,
      // Label 2581: @132663
      GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(132703), // Rule ID 10145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10145,
        GIR_EraseRootFromParent_Done,
      // Label 2582: @132703
      GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(132739), // Rule ID 39 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfcvtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8bf16] } 564:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (BFCVTN:{ *:[v8bf16] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 39,
        GIR_EraseRootFromParent_Done,
      // Label 2583: @132739
      GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(132775), // Rule ID 41 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfcvt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[bf16] } 563:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (BFCVT:{ *:[bf16] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 41,
        GIR_EraseRootFromParent_Done,
      // Label 2584: @132775
      GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(132814), // Rule ID 78 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 538:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 78,
        GIR_EraseRootFromParent_Done,
      // Label 2585: @132814
      GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(132850), // Rule ID 357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 357,
        GIR_EraseRootFromParent_Done,
      // Label 2586: @132850
      GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(132886), // Rule ID 358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 358,
        GIR_EraseRootFromParent_Done,
      // Label 2587: @132886
      GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(132922), // Rule ID 359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 359,
        GIR_EraseRootFromParent_Done,
      // Label 2588: @132922
      GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(132958), // Rule ID 360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 360,
        GIR_EraseRootFromParent_Done,
      // Label 2589: @132958
      GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(132994), // Rule ID 361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 361,
        GIR_EraseRootFromParent_Done,
      // Label 2590: @132994
      GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(133030), // Rule ID 362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 362,
        GIR_EraseRootFromParent_Done,
      // Label 2591: @133030
      GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(133066), // Rule ID 363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 363,
        GIR_EraseRootFromParent_Done,
      // Label 2592: @133066
      GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(133102), // Rule ID 364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 364,
        GIR_EraseRootFromParent_Done,
      // Label 2593: @133102
      GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(133138), // Rule ID 365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 365,
        GIR_EraseRootFromParent_Done,
      // Label 2594: @133138
      GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(133174), // Rule ID 366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 366,
        GIR_EraseRootFromParent_Done,
      // Label 2595: @133174
      GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(133210), // Rule ID 367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 367,
        GIR_EraseRootFromParent_Done,
      // Label 2596: @133210
      GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(133246), // Rule ID 368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 368,
        GIR_EraseRootFromParent_Done,
      // Label 2597: @133246
      GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(133282), // Rule ID 369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 580:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 369,
        GIR_EraseRootFromParent_Done,
      // Label 2598: @133282
      GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(133318), // Rule ID 370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 580:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 370,
        GIR_EraseRootFromParent_Done,
      // Label 2599: @133318
      GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(133354), // Rule ID 371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 580:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 371,
        GIR_EraseRootFromParent_Done,
      // Label 2600: @133354
      GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(133390), // Rule ID 372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 580:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 372,
        GIR_EraseRootFromParent_Done,
      // Label 2601: @133390
      GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(133426), // Rule ID 373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 580:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 373,
        GIR_EraseRootFromParent_Done,
      // Label 2602: @133426
      GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(133462), // Rule ID 374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 580:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 374,
        GIR_EraseRootFromParent_Done,
      // Label 2603: @133462
      GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(133498), // Rule ID 375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 581:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 375,
        GIR_EraseRootFromParent_Done,
      // Label 2604: @133498
      GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(133534), // Rule ID 376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 581:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 376,
        GIR_EraseRootFromParent_Done,
      // Label 2605: @133534
      GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(133570), // Rule ID 377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 581:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 377,
        GIR_EraseRootFromParent_Done,
      // Label 2606: @133570
      GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(133606), // Rule ID 378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 581:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 378,
        GIR_EraseRootFromParent_Done,
      // Label 2607: @133606
      GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(133642), // Rule ID 379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 581:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 379,
        GIR_EraseRootFromParent_Done,
      // Label 2608: @133642
      GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(133678), // Rule ID 380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 581:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 380,
        GIR_EraseRootFromParent_Done,
      // Label 2609: @133678
      GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(133714), // Rule ID 381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 582:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 381,
        GIR_EraseRootFromParent_Done,
      // Label 2610: @133714
      GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(133750), // Rule ID 382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 582:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 382,
        GIR_EraseRootFromParent_Done,
      // Label 2611: @133750
      GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(133786), // Rule ID 383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 582:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 383,
        GIR_EraseRootFromParent_Done,
      // Label 2612: @133786
      GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(133822), // Rule ID 384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 582:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 384,
        GIR_EraseRootFromParent_Done,
      // Label 2613: @133822
      GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(133858), // Rule ID 385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 582:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 385,
        GIR_EraseRootFromParent_Done,
      // Label 2614: @133858
      GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(133894), // Rule ID 386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 582:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 386,
        GIR_EraseRootFromParent_Done,
      // Label 2615: @133894
      GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(133930), // Rule ID 387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 387,
        GIR_EraseRootFromParent_Done,
      // Label 2616: @133930
      GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(133966), // Rule ID 388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 388,
        GIR_EraseRootFromParent_Done,
      // Label 2617: @133966
      GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(134002), // Rule ID 389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 389,
        GIR_EraseRootFromParent_Done,
      // Label 2618: @134002
      GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(134038), // Rule ID 390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 390,
        GIR_EraseRootFromParent_Done,
      // Label 2619: @134038
      GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(134074), // Rule ID 391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 391,
        GIR_EraseRootFromParent_Done,
      // Label 2620: @134074
      GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(134110), // Rule ID 392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 392,
        GIR_EraseRootFromParent_Done,
      // Label 2621: @134110
      GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(134146), // Rule ID 393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 393,
        GIR_EraseRootFromParent_Done,
      // Label 2622: @134146
      GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(134182), // Rule ID 394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 394,
        GIR_EraseRootFromParent_Done,
      // Label 2623: @134182
      GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(134218), // Rule ID 395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 395,
        GIR_EraseRootFromParent_Done,
      // Label 2624: @134218
      GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(134254), // Rule ID 396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 396,
        GIR_EraseRootFromParent_Done,
      // Label 2625: @134254
      GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(134290), // Rule ID 397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 397,
        GIR_EraseRootFromParent_Done,
      // Label 2626: @134290
      GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(134326), // Rule ID 398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 398,
        GIR_EraseRootFromParent_Done,
      // Label 2627: @134326
      GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(134362), // Rule ID 399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 399,
        GIR_EraseRootFromParent_Done,
      // Label 2628: @134362
      GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(134398), // Rule ID 400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 400,
        GIR_EraseRootFromParent_Done,
      // Label 2629: @134398
      GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(134434), // Rule ID 401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 401,
        GIR_EraseRootFromParent_Done,
      // Label 2630: @134434
      GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(134470), // Rule ID 402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 402,
        GIR_EraseRootFromParent_Done,
      // Label 2631: @134470
      GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(134506), // Rule ID 403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 403,
        GIR_EraseRootFromParent_Done,
      // Label 2632: @134506
      GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(134542), // Rule ID 404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 404,
        GIR_EraseRootFromParent_Done,
      // Label 2633: @134542
      GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(134578), // Rule ID 570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 540:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 570,
        GIR_EraseRootFromParent_Done,
      // Label 2634: @134578
      GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(134614), // Rule ID 571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 540:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 571,
        GIR_EraseRootFromParent_Done,
      // Label 2635: @134614
      GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(134650), // Rule ID 572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 542:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 572,
        GIR_EraseRootFromParent_Done,
      // Label 2636: @134650
      GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(134686), // Rule ID 573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 542:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 573,
        GIR_EraseRootFromParent_Done,
      // Label 2637: @134686
      GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(134722), // Rule ID 574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 539:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 574,
        GIR_EraseRootFromParent_Done,
      // Label 2638: @134722
      GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(134758), // Rule ID 575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 539:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 575,
        GIR_EraseRootFromParent_Done,
      // Label 2639: @134758
      GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(134794), // Rule ID 576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 541:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 576,
        GIR_EraseRootFromParent_Done,
      // Label 2640: @134794
      GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(134830), // Rule ID 577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 541:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 577,
        GIR_EraseRootFromParent_Done,
      // Label 2641: @134830
      GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(134866), // Rule ID 705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 705,
        GIR_EraseRootFromParent_Done,
      // Label 2642: @134866
      GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(134902), // Rule ID 706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 706,
        GIR_EraseRootFromParent_Done,
      // Label 2643: @134902
      GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(134938), // Rule ID 707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 707,
        GIR_EraseRootFromParent_Done,
      // Label 2644: @134938
      GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(134974), // Rule ID 708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 708,
        GIR_EraseRootFromParent_Done,
      // Label 2645: @134974
      GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(135010), // Rule ID 709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 709,
        GIR_EraseRootFromParent_Done,
      // Label 2646: @135010
      GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(135046), // Rule ID 710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 710,
        GIR_EraseRootFromParent_Done,
      // Label 2647: @135046
      GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(135082), // Rule ID 784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 784,
        GIR_EraseRootFromParent_Done,
      // Label 2648: @135082
      GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(135118), // Rule ID 785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 785,
        GIR_EraseRootFromParent_Done,
      // Label 2649: @135118
      GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(135154), // Rule ID 786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 786,
        GIR_EraseRootFromParent_Done,
      // Label 2650: @135154
      GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(135190), // Rule ID 787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 787,
        GIR_EraseRootFromParent_Done,
      // Label 2651: @135190
      GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(135226), // Rule ID 788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 788,
        GIR_EraseRootFromParent_Done,
      // Label 2652: @135226
      GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(135262), // Rule ID 789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 789,
        GIR_EraseRootFromParent_Done,
      // Label 2653: @135262
      GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(135298), // Rule ID 790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 790,
        GIR_EraseRootFromParent_Done,
      // Label 2654: @135298
      GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(135334), // Rule ID 791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 791,
        GIR_EraseRootFromParent_Done,
      // Label 2655: @135334
      GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(135370), // Rule ID 792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 792,
        GIR_EraseRootFromParent_Done,
      // Label 2656: @135370
      GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(135406), // Rule ID 793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 793,
        GIR_EraseRootFromParent_Done,
      // Label 2657: @135406
      GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(135442), // Rule ID 794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 794,
        GIR_EraseRootFromParent_Done,
      // Label 2658: @135442
      GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(135478), // Rule ID 795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 580:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 795,
        GIR_EraseRootFromParent_Done,
      // Label 2659: @135478
      GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(135514), // Rule ID 796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 796,
        GIR_EraseRootFromParent_Done,
      // Label 2660: @135514
      GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(135550), // Rule ID 797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 797,
        GIR_EraseRootFromParent_Done,
      // Label 2661: @135550
      GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(135586), // Rule ID 798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 798,
        GIR_EraseRootFromParent_Done,
      // Label 2662: @135586
      GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(135622), // Rule ID 799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 799,
        GIR_EraseRootFromParent_Done,
      // Label 2663: @135622
      GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(135658), // Rule ID 800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 800,
        GIR_EraseRootFromParent_Done,
      // Label 2664: @135658
      GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(135694), // Rule ID 801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 801,
        GIR_EraseRootFromParent_Done,
      // Label 2665: @135694
      GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(135730), // Rule ID 802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 802,
        GIR_EraseRootFromParent_Done,
      // Label 2666: @135730
      GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(135766), // Rule ID 803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 803,
        GIR_EraseRootFromParent_Done,
      // Label 2667: @135766
      GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(135802), // Rule ID 804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 804,
        GIR_EraseRootFromParent_Done,
      // Label 2668: @135802
      GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(135838), // Rule ID 805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 805,
        GIR_EraseRootFromParent_Done,
      // Label 2669: @135838
      GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(135874), // Rule ID 806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 806,
        GIR_EraseRootFromParent_Done,
      // Label 2670: @135874
      GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(135910), // Rule ID 807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 807,
        GIR_EraseRootFromParent_Done,
      // Label 2671: @135910
      GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(135946), // Rule ID 808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 808,
        GIR_EraseRootFromParent_Done,
      // Label 2672: @135946
      GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(135982), // Rule ID 809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 809,
        GIR_EraseRootFromParent_Done,
      // Label 2673: @135982
      GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(136018), // Rule ID 810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 810,
        GIR_EraseRootFromParent_Done,
      // Label 2674: @136018
      GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(136054), // Rule ID 811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 811,
        GIR_EraseRootFromParent_Done,
      // Label 2675: @136054
      GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(136090), // Rule ID 812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 812,
        GIR_EraseRootFromParent_Done,
      // Label 2676: @136090
      GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(136126), // Rule ID 813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 813,
        GIR_EraseRootFromParent_Done,
      // Label 2677: @136126
      GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(136162), // Rule ID 814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 814,
        GIR_EraseRootFromParent_Done,
      // Label 2678: @136162
      GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(136198), // Rule ID 815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 815,
        GIR_EraseRootFromParent_Done,
      // Label 2679: @136198
      GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(136234), // Rule ID 816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 816,
        GIR_EraseRootFromParent_Done,
      // Label 2680: @136234
      GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(136270), // Rule ID 817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 817,
        GIR_EraseRootFromParent_Done,
      // Label 2681: @136270
      GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(136306), // Rule ID 818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 818,
        GIR_EraseRootFromParent_Done,
      // Label 2682: @136306
      GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(136342), // Rule ID 819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 819,
        GIR_EraseRootFromParent_Done,
      // Label 2683: @136342
      GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(136378), // Rule ID 820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 820,
        GIR_EraseRootFromParent_Done,
      // Label 2684: @136378
      GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(136414), // Rule ID 821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 821,
        GIR_EraseRootFromParent_Done,
      // Label 2685: @136414
      GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(136450), // Rule ID 822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 822,
        GIR_EraseRootFromParent_Done,
      // Label 2686: @136450
      GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(136486), // Rule ID 823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 823,
        GIR_EraseRootFromParent_Done,
      // Label 2687: @136486
      GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(136522), // Rule ID 824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 824,
        GIR_EraseRootFromParent_Done,
      // Label 2688: @136522
      GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(136558), // Rule ID 851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 607:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 851,
        GIR_EraseRootFromParent_Done,
      // Label 2689: @136558
      GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(136594), // Rule ID 852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 607:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 852,
        GIR_EraseRootFromParent_Done,
      // Label 2690: @136594
      GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(136630), // Rule ID 853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 853,
        GIR_EraseRootFromParent_Done,
      // Label 2691: @136630
      GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(136666), // Rule ID 854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 854,
        GIR_EraseRootFromParent_Done,
      // Label 2692: @136666
      GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(136702), // Rule ID 855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 607:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 855,
        GIR_EraseRootFromParent_Done,
      // Label 2693: @136702
      GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(136738), // Rule ID 926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 926,
        GIR_EraseRootFromParent_Done,
      // Label 2694: @136738
      GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(136774), // Rule ID 927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 927,
        GIR_EraseRootFromParent_Done,
      // Label 2695: @136774
      GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(136810), // Rule ID 928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 928,
        GIR_EraseRootFromParent_Done,
      // Label 2696: @136810
      GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(136846), // Rule ID 929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 929,
        GIR_EraseRootFromParent_Done,
      // Label 2697: @136846
      GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(136882), // Rule ID 930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 930,
        GIR_EraseRootFromParent_Done,
      // Label 2698: @136882
      GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(136918), // Rule ID 931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 613:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 931,
        GIR_EraseRootFromParent_Done,
      // Label 2699: @136918
      GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(136954), // Rule ID 932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 932,
        GIR_EraseRootFromParent_Done,
      // Label 2700: @136954
      GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(136990), // Rule ID 933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 933,
        GIR_EraseRootFromParent_Done,
      // Label 2701: @136990
      GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(137026), // Rule ID 934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 934,
        GIR_EraseRootFromParent_Done,
      // Label 2702: @137026
      GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(137062), // Rule ID 935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 935,
        GIR_EraseRootFromParent_Done,
      // Label 2703: @137062
      GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(137098), // Rule ID 936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 936,
        GIR_EraseRootFromParent_Done,
      // Label 2704: @137098
      GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(137134), // Rule ID 937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 937,
        GIR_EraseRootFromParent_Done,
      // Label 2705: @137134
      GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(137170), // Rule ID 938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 614:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 938,
        GIR_EraseRootFromParent_Done,
      // Label 2706: @137170
      GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(137206), // Rule ID 939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 614:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 939,
        GIR_EraseRootFromParent_Done,
      // Label 2707: @137206
      GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(137242), // Rule ID 940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 940,
        GIR_EraseRootFromParent_Done,
      // Label 2708: @137242
      GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(137278), // Rule ID 941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 941,
        GIR_EraseRootFromParent_Done,
      // Label 2709: @137278
      GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(137314), // Rule ID 942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 614:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 942,
        GIR_EraseRootFromParent_Done,
      // Label 2710: @137314
      GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(137350), // Rule ID 989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 989,
        GIR_EraseRootFromParent_Done,
      // Label 2711: @137350
      GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(137386), // Rule ID 991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 991,
        GIR_EraseRootFromParent_Done,
      // Label 2712: @137386
      GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(137422), // Rule ID 993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 993,
        GIR_EraseRootFromParent_Done,
      // Label 2713: @137422
      GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(137458), // Rule ID 995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 995,
        GIR_EraseRootFromParent_Done,
      // Label 2714: @137458
      GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(137494), // Rule ID 997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 635:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 997,
        GIR_EraseRootFromParent_Done,
      // Label 2715: @137494
      GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(137530), // Rule ID 999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 999,
        GIR_EraseRootFromParent_Done,
      // Label 2716: @137530
      GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(137566), // Rule ID 1010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1010,
        GIR_EraseRootFromParent_Done,
      // Label 2717: @137566
      GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(137602), // Rule ID 1011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1011,
        GIR_EraseRootFromParent_Done,
      // Label 2718: @137602
      GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(137638), // Rule ID 1012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 653:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1012,
        GIR_EraseRootFromParent_Done,
      // Label 2719: @137638
      GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(137674), // Rule ID 1013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 653:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1013,
        GIR_EraseRootFromParent_Done,
      // Label 2720: @137674
      GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(137710), // Rule ID 1014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 653:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1014,
        GIR_EraseRootFromParent_Done,
      // Label 2721: @137710
      GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(137746), // Rule ID 1015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 653:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1015,
        GIR_EraseRootFromParent_Done,
      // Label 2722: @137746
      GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(137782), // Rule ID 1016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 653:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1016,
        GIR_EraseRootFromParent_Done,
      // Label 2723: @137782
      GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(137818), // Rule ID 1017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1017,
        GIR_EraseRootFromParent_Done,
      // Label 2724: @137818
      GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(137854), // Rule ID 1018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1018,
        GIR_EraseRootFromParent_Done,
      // Label 2725: @137854
      GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(137890), // Rule ID 1019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1019,
        GIR_EraseRootFromParent_Done,
      // Label 2726: @137890
      GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(137926), // Rule ID 1020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1020,
        GIR_EraseRootFromParent_Done,
      // Label 2727: @137926
      GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(137962), // Rule ID 1021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1021,
        GIR_EraseRootFromParent_Done,
      // Label 2728: @137962
      GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(137998), // Rule ID 1022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1022,
        GIR_EraseRootFromParent_Done,
      // Label 2729: @137998
      GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(138034), // Rule ID 1023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1023,
        GIR_EraseRootFromParent_Done,
      // Label 2730: @138034
      GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(138070), // Rule ID 1050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1050,
        GIR_EraseRootFromParent_Done,
      // Label 2731: @138070
      GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(138106), // Rule ID 1052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1052,
        GIR_EraseRootFromParent_Done,
      // Label 2732: @138106
      GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(138142), // Rule ID 1054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1054,
        GIR_EraseRootFromParent_Done,
      // Label 2733: @138142
      GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(138178), // Rule ID 1056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1056,
        GIR_EraseRootFromParent_Done,
      // Label 2734: @138178
      GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(138214), // Rule ID 1058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 700:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1058,
        GIR_EraseRootFromParent_Done,
      // Label 2735: @138214
      GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(138250), // Rule ID 1060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1060,
        GIR_EraseRootFromParent_Done,
      // Label 2736: @138250
      GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(138286), // Rule ID 1074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1074,
        GIR_EraseRootFromParent_Done,
      // Label 2737: @138286
      GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(138322), // Rule ID 1075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1075,
        GIR_EraseRootFromParent_Done,
      // Label 2738: @138322
      GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(138358), // Rule ID 1076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1076,
        GIR_EraseRootFromParent_Done,
      // Label 2739: @138358
      GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(138394), // Rule ID 1077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1077,
        GIR_EraseRootFromParent_Done,
      // Label 2740: @138394
      GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(138430), // Rule ID 1641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 761:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1641,
        GIR_EraseRootFromParent_Done,
      // Label 2741: @138430
      GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(138466), // Rule ID 1647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 653:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1647,
        GIR_EraseRootFromParent_Done,
      // Label 2742: @138466
      GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(138502), // Rule ID 1648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 653:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1648,
        GIR_EraseRootFromParent_Done,
      // Label 2743: @138502
      GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(138538), // Rule ID 1649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 660:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1649,
        GIR_EraseRootFromParent_Done,
      // Label 2744: @138538
      GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(138574), // Rule ID 1650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 660:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1650,
        GIR_EraseRootFromParent_Done,
      // Label 2745: @138574
      GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(138610), // Rule ID 1651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 638:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1651,
        GIR_EraseRootFromParent_Done,
      // Label 2746: @138610
      GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(138646), // Rule ID 1652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1652,
        GIR_EraseRootFromParent_Done,
      // Label 2747: @138646
      GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(138682), // Rule ID 1658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1658,
        GIR_EraseRootFromParent_Done,
      // Label 2748: @138682
      GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(138718), // Rule ID 1931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1931,
        GIR_EraseRootFromParent_Done,
      // Label 2749: @138718
      GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(138754), // Rule ID 1933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1933,
        GIR_EraseRootFromParent_Done,
      // Label 2750: @138754
      GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(138790), // Rule ID 1935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1935,
        GIR_EraseRootFromParent_Done,
      // Label 2751: @138790
      GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(138826), // Rule ID 1937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1937,
        GIR_EraseRootFromParent_Done,
      // Label 2752: @138826
      GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(138862), // Rule ID 1939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1939,
        GIR_EraseRootFromParent_Done,
      // Label 2753: @138862
      GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(138898), // Rule ID 1941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1941,
        GIR_EraseRootFromParent_Done,
      // Label 2754: @138898
      GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(138934), // Rule ID 1943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1943,
        GIR_EraseRootFromParent_Done,
      // Label 2755: @138934
      GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(138970), // Rule ID 1945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1945,
        GIR_EraseRootFromParent_Done,
      // Label 2756: @138970
      GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(139006), // Rule ID 1947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1947,
        GIR_EraseRootFromParent_Done,
      // Label 2757: @139006
      GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(139042), // Rule ID 1949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 600:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1949,
        GIR_EraseRootFromParent_Done,
      // Label 2758: @139042
      GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(139078), // Rule ID 1951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 600:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1951,
        GIR_EraseRootFromParent_Done,
      // Label 2759: @139078
      GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(139114), // Rule ID 1953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 600:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1953,
        GIR_EraseRootFromParent_Done,
      // Label 2760: @139114
      GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(139150), // Rule ID 2291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 506:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2291,
        GIR_EraseRootFromParent_Done,
      // Label 2761: @139150
      GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(139186), // Rule ID 2292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 505:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2292,
        GIR_EraseRootFromParent_Done,
      // Label 2762: @139186
      GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(139222), // Rule ID 2300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2300,
        GIR_EraseRootFromParent_Done,
      // Label 2763: @139222
      GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(139258), // Rule ID 2479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 653:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2479,
        GIR_EraseRootFromParent_Done,
      // Label 2764: @139258
      GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(139297), // Rule ID 3557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1448:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3557,
        GIR_EraseRootFromParent_Done,
      // Label 2765: @139297
      GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(139336), // Rule ID 3558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1448:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3558,
        GIR_EraseRootFromParent_Done,
      // Label 2766: @139336
      GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(139375), // Rule ID 3559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1448:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3559,
        GIR_EraseRootFromParent_Done,
      // Label 2767: @139375
      GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(139414), // Rule ID 3560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1448:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3560,
        GIR_EraseRootFromParent_Done,
      // Label 2768: @139414
      GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(139470), // Rule ID 3564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1450:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3564,
        GIR_EraseRootFromParent_Done,
      // Label 2769: @139470
      GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(139526), // Rule ID 3565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1450:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3565,
        GIR_EraseRootFromParent_Done,
      // Label 2770: @139526
      GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(139582), // Rule ID 3566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1450:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3566,
        GIR_EraseRootFromParent_Done,
      // Label 2771: @139582
      GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(139638), // Rule ID 3567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1450:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3567,
        GIR_EraseRootFromParent_Done,
      // Label 2772: @139638
      GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(139671), // Rule ID 3977 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 493:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3977,
        GIR_EraseRootFromParent_Done,
      // Label 2773: @139671
      GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(139736), // Rule ID 3978 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 494:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 3978,
        GIR_EraseRootFromParent_Done,
      // Label 2774: @139736
      GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(139769), // Rule ID 4800 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 611:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4800,
        GIR_EraseRootFromParent_Done,
      // Label 2775: @139769
      GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(139802), // Rule ID 4801 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 613:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4801,
        GIR_EraseRootFromParent_Done,
      // Label 2776: @139802
      GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(139835), // Rule ID 4802 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4802,
        GIR_EraseRootFromParent_Done,
      // Label 2777: @139835
      GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(139868), // Rule ID 4803 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 612:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4803,
        GIR_EraseRootFromParent_Done,
      // Label 2778: @139868
      GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(139901), // Rule ID 4919 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4919,
        GIR_EraseRootFromParent_Done,
      // Label 2779: @139901
      GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(139934), // Rule ID 4929 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4929,
        GIR_EraseRootFromParent_Done,
      // Label 2780: @139934
      GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(139970), // Rule ID 5271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5271,
        GIR_EraseRootFromParent_Done,
      // Label 2781: @139970
      GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(140003), // Rule ID 5276 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5276,
        GIR_EraseRootFromParent_Done,
      // Label 2782: @140003
      GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(140036), // Rule ID 5277 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 579:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5277,
        GIR_EraseRootFromParent_Done,
      // Label 2783: @140036
      GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(140069), // Rule ID 5278 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 580:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5278,
        GIR_EraseRootFromParent_Done,
      // Label 2784: @140069
      GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(140102), // Rule ID 5279 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 581:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5279,
        GIR_EraseRootFromParent_Done,
      // Label 2785: @140102
      GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(140135), // Rule ID 5280 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 582:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5280,
        GIR_EraseRootFromParent_Done,
      // Label 2786: @140135
      GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(140168), // Rule ID 5281 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5281,
        GIR_EraseRootFromParent_Done,
      // Label 2787: @140168
      GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(140201), // Rule ID 5282 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5282,
        GIR_EraseRootFromParent_Done,
      // Label 2788: @140201
      GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(140234), // Rule ID 5283 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5283,
        GIR_EraseRootFromParent_Done,
      // Label 2789: @140234
      GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(140267), // Rule ID 5284 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5284,
        GIR_EraseRootFromParent_Done,
      // Label 2790: @140267
      GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(140300), // Rule ID 5285 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5285,
        GIR_EraseRootFromParent_Done,
      // Label 2791: @140300
      GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(140333), // Rule ID 5286 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5286,
        GIR_EraseRootFromParent_Done,
      // Label 2792: @140333
      GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(140366), // Rule ID 5287 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5287,
        GIR_EraseRootFromParent_Done,
      // Label 2793: @140366
      GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(140399), // Rule ID 5288 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 607:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5288,
        GIR_EraseRootFromParent_Done,
      // Label 2794: @140399
      GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(140432), // Rule ID 5289 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 607:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5289,
        GIR_EraseRootFromParent_Done,
      // Label 2795: @140432
      GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(140465), // Rule ID 5301 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5301,
        GIR_EraseRootFromParent_Done,
      // Label 2796: @140465
      GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(140498), // Rule ID 5302 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5302,
        GIR_EraseRootFromParent_Done,
      // Label 2797: @140498
      GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(140531), // Rule ID 5303 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 609:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5303,
        GIR_EraseRootFromParent_Done,
      // Label 2798: @140531
      GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(140564), // Rule ID 5304 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 614:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5304,
        GIR_EraseRootFromParent_Done,
      // Label 2799: @140564
      GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(140597), // Rule ID 5305 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 614:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5305,
        GIR_EraseRootFromParent_Done,
      // Label 2800: @140597
      GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(140630), // Rule ID 5306 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 614:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5306,
        GIR_EraseRootFromParent_Done,
      // Label 2801: @140630
      GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(140663), // Rule ID 5307 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 614:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5307,
        GIR_EraseRootFromParent_Done,
      // Label 2802: @140663
      GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(140696), // Rule ID 5646 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 575:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5646,
        GIR_EraseRootFromParent_Done,
      // Label 2803: @140696
      GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(140781), // Rule ID 5647 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 575:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5647,
        GIR_EraseRootFromParent_Done,
      // Label 2804: @140781
      GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(140814), // Rule ID 5648 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 575:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5648,
        GIR_EraseRootFromParent_Done,
      // Label 2805: @140814
      GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(140847), // Rule ID 5650 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5650,
        GIR_EraseRootFromParent_Done,
      // Label 2806: @140847
      GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(140880), // Rule ID 5652 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5652,
        GIR_EraseRootFromParent_Done,
      // Label 2807: @140880
      GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(140913), // Rule ID 5654 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5654,
        GIR_EraseRootFromParent_Done,
      // Label 2808: @140913
      GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(140946), // Rule ID 5656 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5656,
        GIR_EraseRootFromParent_Done,
      // Label 2809: @140946
      GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(140979), // Rule ID 5658 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5658,
        GIR_EraseRootFromParent_Done,
      // Label 2810: @140979
      GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(141012), // Rule ID 5660 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5660,
        GIR_EraseRootFromParent_Done,
      // Label 2811: @141012
      GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(141045), // Rule ID 5662 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 600:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5662,
        GIR_EraseRootFromParent_Done,
      // Label 2812: @141045
      GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(141078), // Rule ID 5664 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 600:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5664,
        GIR_EraseRootFromParent_Done,
      // Label 2813: @141078
      GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(141111), // Rule ID 13098 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13098,
        GIR_EraseRootFromParent_Done,
      // Label 2814: @141111
      GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(141144), // Rule ID 13100 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13100,
        GIR_EraseRootFromParent_Done,
      // Label 2815: @141144
      GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(141177), // Rule ID 13102 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13102,
        GIR_EraseRootFromParent_Done,
      // Label 2816: @141177
      GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(141210), // Rule ID 13104 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13104,
        GIR_EraseRootFromParent_Done,
      // Label 2817: @141210
      GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(141325), // Rule ID 13105 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 637:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13105,
        GIR_EraseRootFromParent_Done,
      // Label 2818: @141325
      GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(141358), // Rule ID 13107 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13107,
        GIR_EraseRootFromParent_Done,
      // Label 2819: @141358
      GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(141391), // Rule ID 13109 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13109,
        GIR_EraseRootFromParent_Done,
      // Label 2820: @141391
      GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(141424), // Rule ID 13111 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13111,
        GIR_EraseRootFromParent_Done,
      // Label 2821: @141424
      GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(141457), // Rule ID 13113 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13113,
        GIR_EraseRootFromParent_Done,
      // Label 2822: @141457
      GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(141572), // Rule ID 13114 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13114,
        GIR_EraseRootFromParent_Done,
      // Label 2823: @141572
      GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(141691), // Rule ID 13115 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 637:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13115,
        GIR_EraseRootFromParent_Done,
      // Label 2824: @141691
      GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(141806), // Rule ID 13116 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 637:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13116,
        GIR_EraseRootFromParent_Done,
      // Label 2825: @141806
      GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(141925), // Rule ID 13117 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13117,
        GIR_EraseRootFromParent_Done,
      // Label 2826: @141925
      GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(142040), // Rule ID 13118 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13118,
        GIR_EraseRootFromParent_Done,
      // Label 2827: @142040
      GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(142073), // Rule ID 13120 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13120,
        GIR_EraseRootFromParent_Done,
      // Label 2828: @142073
      GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(142106), // Rule ID 13122 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13122,
        GIR_EraseRootFromParent_Done,
      // Label 2829: @142106
      GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(142139), // Rule ID 13124 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13124,
        GIR_EraseRootFromParent_Done,
      // Label 2830: @142139
      GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(142172), // Rule ID 13126 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13126,
        GIR_EraseRootFromParent_Done,
      // Label 2831: @142172
      GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(142287), // Rule ID 13127 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 647:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13127,
        GIR_EraseRootFromParent_Done,
      // Label 2832: @142287
      GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(142406), // Rule ID 13128 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 647:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13128,
        GIR_EraseRootFromParent_Done,
      // Label 2833: @142406
      GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(142439), // Rule ID 13130 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13130,
        GIR_EraseRootFromParent_Done,
      // Label 2834: @142439
      GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(142472), // Rule ID 13132 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13132,
        GIR_EraseRootFromParent_Done,
      // Label 2835: @142472
      GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(142505), // Rule ID 13134 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13134,
        GIR_EraseRootFromParent_Done,
      // Label 2836: @142505
      GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(142538), // Rule ID 13136 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13136,
        GIR_EraseRootFromParent_Done,
      // Label 2837: @142538
      GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(142653), // Rule ID 13137 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 650:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13137,
        GIR_EraseRootFromParent_Done,
      // Label 2838: @142653
      GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(142772), // Rule ID 13138 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 650:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13138,
        GIR_EraseRootFromParent_Done,
      // Label 2839: @142772
      GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(142805), // Rule ID 13140 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13140,
        GIR_EraseRootFromParent_Done,
      // Label 2840: @142805
      GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(142838), // Rule ID 13142 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13142,
        GIR_EraseRootFromParent_Done,
      // Label 2841: @142838
      GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(142871), // Rule ID 13144 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13144,
        GIR_EraseRootFromParent_Done,
      // Label 2842: @142871
      GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(142904), // Rule ID 13146 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13146,
        GIR_EraseRootFromParent_Done,
      // Label 2843: @142904
      GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(143019), // Rule ID 13147 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13147,
        GIR_EraseRootFromParent_Done,
      // Label 2844: @143019
      GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(143138), // Rule ID 13148 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13148,
        GIR_EraseRootFromParent_Done,
      // Label 2845: @143138
      GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(143171), // Rule ID 13150 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13150,
        GIR_EraseRootFromParent_Done,
      // Label 2846: @143171
      GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(143204), // Rule ID 13152 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13152,
        GIR_EraseRootFromParent_Done,
      // Label 2847: @143204
      GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(143237), // Rule ID 13154 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13154,
        GIR_EraseRootFromParent_Done,
      // Label 2848: @143237
      GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(143270), // Rule ID 13156 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13156,
        GIR_EraseRootFromParent_Done,
      // Label 2849: @143270
      GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(143385), // Rule ID 13157 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 711:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13157,
        GIR_EraseRootFromParent_Done,
      // Label 2850: @143385
      GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(143504), // Rule ID 13158 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 711:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13158,
        GIR_EraseRootFromParent_Done,
      // Label 2851: @143504
      GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(143536), // Rule ID 2369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1490:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2369,
        GIR_EraseRootFromParent_Done,
      // Label 2852: @143536
      GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(143568), // Rule ID 2370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1491:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2370,
        GIR_EraseRootFromParent_Done,
      // Label 2853: @143568
      GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(143600), // Rule ID 2371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1492:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2371,
        GIR_EraseRootFromParent_Done,
      // Label 2854: @143600
      GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(143632), // Rule ID 3076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3076,
        GIR_EraseRootFromParent_Done,
      // Label 2855: @143632
      GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(143664), // Rule ID 3077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3077,
        GIR_EraseRootFromParent_Done,
      // Label 2856: @143664
      GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(143696), // Rule ID 3078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3078,
        GIR_EraseRootFromParent_Done,
      // Label 2857: @143696
      GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(143728), // Rule ID 3336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1482:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3336,
        GIR_EraseRootFromParent_Done,
      // Label 2858: @143728
      GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(143760), // Rule ID 3337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1482:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3337,
        GIR_EraseRootFromParent_Done,
      // Label 2859: @143760
      GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(143792), // Rule ID 3338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1482:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3338,
        GIR_EraseRootFromParent_Done,
      // Label 2860: @143792
      GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(143824), // Rule ID 3421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3421,
        GIR_EraseRootFromParent_Done,
      // Label 2861: @143824
      GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(143856), // Rule ID 3422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3422,
        GIR_EraseRootFromParent_Done,
      // Label 2862: @143856
      GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(143888), // Rule ID 3423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3423,
        GIR_EraseRootFromParent_Done,
      // Label 2863: @143888
      GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(143920), // Rule ID 3449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1108:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3449,
        GIR_EraseRootFromParent_Done,
      // Label 2864: @143920
      GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(143952), // Rule ID 4647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4647,
        GIR_EraseRootFromParent_Done,
      // Label 2865: @143952
      GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(143984), // Rule ID 4648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4648,
        GIR_EraseRootFromParent_Done,
      // Label 2866: @143984
      GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(144013), // Rule ID 4649 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4649,
        GIR_EraseRootFromParent_Done,
      // Label 2867: @144013
      GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(144042), // Rule ID 4650 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4650,
        GIR_EraseRootFromParent_Done,
      // Label 2868: @144042
      GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(144071), // Rule ID 4651 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4651,
        GIR_EraseRootFromParent_Done,
      // Label 2869: @144071
      GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(144100), // Rule ID 4652 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4652,
        GIR_EraseRootFromParent_Done,
      // Label 2870: @144100
      GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(144132), // Rule ID 4659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4659,
        GIR_EraseRootFromParent_Done,
      // Label 2871: @144132
      GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(144164), // Rule ID 4660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4660,
        GIR_EraseRootFromParent_Done,
      // Label 2872: @144164
      GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(144193), // Rule ID 4661 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4661,
        GIR_EraseRootFromParent_Done,
      // Label 2873: @144193
      GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(144222), // Rule ID 4662 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4662,
        GIR_EraseRootFromParent_Done,
      // Label 2874: @144222
      GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(144251), // Rule ID 4663 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4663,
        GIR_EraseRootFromParent_Done,
      // Label 2875: @144251
      GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(144280), // Rule ID 4664 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4664,
        GIR_EraseRootFromParent_Done,
      // Label 2876: @144280
      GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(144309), // Rule ID 4959 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4959,
        GIR_EraseRootFromParent_Done,
      // Label 2877: @144309
      GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(144338), // Rule ID 4960 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4960,
        GIR_EraseRootFromParent_Done,
      // Label 2878: @144338
      GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(144367), // Rule ID 4961 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4961,
        GIR_EraseRootFromParent_Done,
      // Label 2879: @144367
      GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(144396), // Rule ID 4962 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4962,
        GIR_EraseRootFromParent_Done,
      // Label 2880: @144396
      GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(144425), // Rule ID 4963 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4963,
        GIR_EraseRootFromParent_Done,
      // Label 2881: @144425
      GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(144454), // Rule ID 4964 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4964,
        GIR_EraseRootFromParent_Done,
      // Label 2882: @144454
      GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(144483), // Rule ID 4965 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4965,
        GIR_EraseRootFromParent_Done,
      // Label 2883: @144483
      GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(144512), // Rule ID 4966 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4966,
        GIR_EraseRootFromParent_Done,
      // Label 2884: @144512
      GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(144541), // Rule ID 4967 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4967,
        GIR_EraseRootFromParent_Done,
      // Label 2885: @144541
      GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(144570), // Rule ID 4968 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4968,
        GIR_EraseRootFromParent_Done,
      // Label 2886: @144570
      GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(144602), // Rule ID 8562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1481:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8562,
        GIR_EraseRootFromParent_Done,
      // Label 2887: @144602
      GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(144634), // Rule ID 8563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8563,
        GIR_EraseRootFromParent_Done,
      // Label 2888: @144634
      GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(144666), // Rule ID 8564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8564,
        GIR_EraseRootFromParent_Done,
      // Label 2889: @144666
      GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(144698), // Rule ID 12099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12099,
        GIR_EraseRootFromParent_Done,
      // Label 2890: @144698
      GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(144730), // Rule ID 12100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12100,
        GIR_EraseRootFromParent_Done,
      // Label 2891: @144730
      GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(144762), // Rule ID 12101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12101,
        GIR_EraseRootFromParent_Done,
      // Label 2892: @144762
      GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(144794), // Rule ID 12102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1674:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12102,
        GIR_EraseRootFromParent_Done,
      // Label 2893: @144794
      GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(144826), // Rule ID 12103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1674:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12103,
        GIR_EraseRootFromParent_Done,
      // Label 2894: @144826
      GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(144858), // Rule ID 12104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1674:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12104,
        GIR_EraseRootFromParent_Done,
      // Label 2895: @144858
      GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(144890), // Rule ID 12262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1107:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12262,
        GIR_EraseRootFromParent_Done,
      // Label 2896: @144890
      GIM_Reject,
    // Label 2575: @144891
    GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(191086),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(145083), // Rule ID 2526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[5] Operand 1
        // No operand predicates
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2526,
        GIR_EraseRootFromParent_Done,
      // Label 2898: @145083
      GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(145267), // Rule ID 6308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[5] Operand 1
        // No operand predicates
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6308,
        GIR_EraseRootFromParent_Done,
      // Label 2899: @145267
      GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(145407), // Rule ID 2045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2045,
        GIR_EraseRootFromParent_Done,
      // Label 2900: @145407
      GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(145547), // Rule ID 2052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2052,
        GIR_EraseRootFromParent_Done,
      // Label 2901: @145547
      GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(145687), // Rule ID 2048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2048,
        GIR_EraseRootFromParent_Done,
      // Label 2902: @145687
      GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(145827), // Rule ID 2055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2055,
        GIR_EraseRootFromParent_Done,
      // Label 2903: @145827
      GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(145964), // Rule ID 2043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2043,
        GIR_EraseRootFromParent_Done,
      // Label 2904: @145964
      GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(146101), // Rule ID 2050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2050,
        GIR_EraseRootFromParent_Done,
      // Label 2905: @146101
      GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(146238), // Rule ID 2046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2046,
        GIR_EraseRootFromParent_Done,
      // Label 2906: @146238
      GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(146375), // Rule ID 2053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2053,
        GIR_EraseRootFromParent_Done,
      // Label 2907: @146375
      GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(146536), // Rule ID 2527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2527,
        GIR_EraseRootFromParent_Done,
      // Label 2908: @146536
      GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(146697), // Rule ID 6309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6309,
        GIR_EraseRootFromParent_Done,
      // Label 2909: @146697
      GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(146807), // Rule ID 2073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2073,
        GIR_EraseRootFromParent_Done,
      // Label 2910: @146807
      GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(146917), // Rule ID 2076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2076,
        GIR_EraseRootFromParent_Done,
      // Label 2911: @146917
      GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147006), // Rule ID 1731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1731,
        GIR_EraseRootFromParent_Done,
      // Label 2912: @147006
      GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147095), // Rule ID 1733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1733,
        GIR_EraseRootFromParent_Done,
      // Label 2913: @147095
      GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147184), // Rule ID 1735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1735,
        GIR_EraseRootFromParent_Done,
      // Label 2914: @147184
      GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147273), // Rule ID 1737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1737,
        GIR_EraseRootFromParent_Done,
      // Label 2915: @147273
      GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147456), // Rule ID 2525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2525,
        GIR_EraseRootFromParent_Done,
      // Label 2916: @147456
      GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147639), // Rule ID 6307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6307,
        GIR_EraseRootFromParent_Done,
      // Label 2917: @147639
      GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147743), // Rule ID 13409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13409,
        GIR_EraseRootFromParent_Done,
      // Label 2918: @147743
      GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147847), // Rule ID 13412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13412,
        GIR_EraseRootFromParent_Done,
      // Label 2919: @147847
      GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147978), // Rule ID 2482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2482,
        GIR_EraseRootFromParent_Done,
      // Label 2920: @147978
      GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148109), // Rule ID 2483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2483,
        GIR_EraseRootFromParent_Done,
      // Label 2921: @148109
      GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148240), // Rule ID 2484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2484,
        GIR_EraseRootFromParent_Done,
      // Label 2922: @148240
      GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148371), // Rule ID 13595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13595,
        GIR_EraseRootFromParent_Done,
      // Label 2923: @148371
      GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148502), // Rule ID 13596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13596,
        GIR_EraseRootFromParent_Done,
      // Label 2924: @148502
      GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148633), // Rule ID 13597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13597,
        GIR_EraseRootFromParent_Done,
      // Label 2925: @148633
      GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148747), // Rule ID 2044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2044,
        GIR_EraseRootFromParent_Done,
      // Label 2926: @148747
      GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148861), // Rule ID 2051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2051,
        GIR_EraseRootFromParent_Done,
      // Label 2927: @148861
      GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148975), // Rule ID 2047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2047,
        GIR_EraseRootFromParent_Done,
      // Label 2928: @148975
      GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(149089), // Rule ID 2054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2054,
        GIR_EraseRootFromParent_Done,
      // Label 2929: @149089
      GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(149203), // Rule ID 2049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[i64] } 654:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2049,
        GIR_EraseRootFromParent_Done,
      // Label 2930: @149203
      GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(149317), // Rule ID 2056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[i64] } 673:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2056,
        GIR_EraseRootFromParent_Done,
      // Label 2931: @149317
      GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(149421), // Rule ID 1975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1975,
        GIR_EraseRootFromParent_Done,
      // Label 2932: @149421
      GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(149525), // Rule ID 2005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 655:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2005,
        GIR_EraseRootFromParent_Done,
      // Label 2933: @149525
      GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(149629), // Rule ID 2012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2012,
        GIR_EraseRootFromParent_Done,
      // Label 2934: @149629
      GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(149733), // Rule ID 2071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2071,
        GIR_EraseRootFromParent_Done,
      // Label 2935: @149733
      GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(149837), // Rule ID 1978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1978,
        GIR_EraseRootFromParent_Done,
      // Label 2936: @149837
      GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(149941), // Rule ID 2008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 655:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2008,
        GIR_EraseRootFromParent_Done,
      // Label 2937: @149941
      GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(150045), // Rule ID 2015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2015,
        GIR_EraseRootFromParent_Done,
      // Label 2938: @150045
      GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(150149), // Rule ID 2074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2074,
        GIR_EraseRootFromParent_Done,
      // Label 2939: @150149
      GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(150206), // Rule ID 1739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1739,
        GIR_EraseRootFromParent_Done,
      // Label 2940: @150206
      GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(150263), // Rule ID 1741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1741,
        GIR_EraseRootFromParent_Done,
      // Label 2941: @150263
      GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(150373), // Rule ID 6326 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 741:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6326,
        GIR_EraseRootFromParent_Done,
      // Label 2942: @150373
      GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(150470), // Rule ID 13863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13863,
        GIR_EraseRootFromParent_Done,
      // Label 2943: @150470
      GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(150567), // Rule ID 13864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13864,
        GIR_EraseRootFromParent_Done,
      // Label 2944: @150567
      GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(150664), // Rule ID 13865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13865,
        GIR_EraseRootFromParent_Done,
      // Label 2945: @150664
      GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(150747), // Rule ID 1730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1730,
        GIR_EraseRootFromParent_Done,
      // Label 2946: @150747
      GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(150830), // Rule ID 1732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1732,
        GIR_EraseRootFromParent_Done,
      // Label 2947: @150830
      GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(150913), // Rule ID 1734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1734,
        GIR_EraseRootFromParent_Done,
      // Label 2948: @150913
      GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(150996), // Rule ID 1736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1736,
        GIR_EraseRootFromParent_Done,
      // Label 2949: @150996
      GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(151076), // Rule ID 5260 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 654:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5260,
        GIR_EraseRootFromParent_Done,
      // Label 2950: @151076
      GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(151156), // Rule ID 5261 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 673:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5261,
        GIR_EraseRootFromParent_Done,
      // Label 2951: @151156
      GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(151253), // Rule ID 5257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5257,
        GIR_EraseRootFromParent_Done,
      // Label 2952: @151253
      GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(151350), // Rule ID 5258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5258,
        GIR_EraseRootFromParent_Done,
      // Label 2953: @151350
      GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(151447), // Rule ID 5259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5259,
        GIR_EraseRootFromParent_Done,
      // Label 2954: @151447
      GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(151528), // Rule ID 13410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13410,
        GIR_EraseRootFromParent_Done,
      // Label 2955: @151528
      GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(151609), // Rule ID 13411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13411,
        GIR_EraseRootFromParent_Done,
      // Label 2956: @151609
      GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(151690), // Rule ID 13413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13413,
        GIR_EraseRootFromParent_Done,
      // Label 2957: @151690
      GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(151771), // Rule ID 13414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13414,
        GIR_EraseRootFromParent_Done,
      // Label 2958: @151771
      GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(151852), // Rule ID 13415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13415,
        GIR_EraseRootFromParent_Done,
      // Label 2959: @151852
      GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(151933), // Rule ID 13416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13416,
        GIR_EraseRootFromParent_Done,
      // Label 2960: @151933
      GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(152014), // Rule ID 13417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13417,
        GIR_EraseRootFromParent_Done,
      // Label 2961: @152014
      GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(152095), // Rule ID 13418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13418,
        GIR_EraseRootFromParent_Done,
      // Label 2962: @152095
      GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(152201), // Rule ID 6323 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 740:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6323,
        GIR_EraseRootFromParent_Done,
      // Label 2963: @152201
      GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(152282), // Rule ID 1976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1976,
        GIR_EraseRootFromParent_Done,
      // Label 2964: @152282
      GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(152363), // Rule ID 1977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1977,
        GIR_EraseRootFromParent_Done,
      // Label 2965: @152363
      GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(152444), // Rule ID 2006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 655:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2006,
        GIR_EraseRootFromParent_Done,
      // Label 2966: @152444
      GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(152525), // Rule ID 2007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 655:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2007,
        GIR_EraseRootFromParent_Done,
      // Label 2967: @152525
      GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(152606), // Rule ID 2013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2013,
        GIR_EraseRootFromParent_Done,
      // Label 2968: @152606
      GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(152687), // Rule ID 2014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2014,
        GIR_EraseRootFromParent_Done,
      // Label 2969: @152687
      GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(152768), // Rule ID 2072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2072,
        GIR_EraseRootFromParent_Done,
      // Label 2970: @152768
      GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(152849), // Rule ID 1979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1979,
        GIR_EraseRootFromParent_Done,
      // Label 2971: @152849
      GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(152930), // Rule ID 1980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1980,
        GIR_EraseRootFromParent_Done,
      // Label 2972: @152930
      GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(153011), // Rule ID 2009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 655:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2009,
        GIR_EraseRootFromParent_Done,
      // Label 2973: @153011
      GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(153092), // Rule ID 2010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 655:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2010,
        GIR_EraseRootFromParent_Done,
      // Label 2974: @153092
      GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(153173), // Rule ID 2016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2016,
        GIR_EraseRootFromParent_Done,
      // Label 2975: @153173
      GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(153254), // Rule ID 2017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2017,
        GIR_EraseRootFromParent_Done,
      // Label 2976: @153254
      GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(153335), // Rule ID 2075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2075,
        GIR_EraseRootFromParent_Done,
      // Label 2977: @153335
      GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(153416), // Rule ID 1981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1981,
        GIR_EraseRootFromParent_Done,
      // Label 2978: @153416
      GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(153497), // Rule ID 1982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1982,
        GIR_EraseRootFromParent_Done,
      // Label 2979: @153497
      GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(153578), // Rule ID 1983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1983,
        GIR_EraseRootFromParent_Done,
      // Label 2980: @153578
      GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(153659), // Rule ID 1984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1984,
        GIR_EraseRootFromParent_Done,
      // Label 2981: @153659
      GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(153740), // Rule ID 2011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 655:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2011,
        GIR_EraseRootFromParent_Done,
      // Label 2982: @153740
      GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(153821), // Rule ID 2018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 663:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2018,
        GIR_EraseRootFromParent_Done,
      // Label 2983: @153821
      GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(153899), // Rule ID 6310 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6310,
        GIR_EraseRootFromParent_Done,
      // Label 2984: @153899
      GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(153959), // Rule ID 6384 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
        // (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6384,
        GIR_EraseRootFromParent_Done,
      // Label 2985: @153959
      GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(154019), // Rule ID 6385 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
        // (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6385,
        GIR_EraseRootFromParent_Done,
      // Label 2986: @154019
      GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(154079), // Rule ID 6386 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
        // (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6386,
        GIR_EraseRootFromParent_Done,
      // Label 2987: @154079
      GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(154126), // Rule ID 3865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3865,
        GIR_EraseRootFromParent_Done,
      // Label 2988: @154126
      GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(154173), // Rule ID 3866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3866,
        GIR_EraseRootFromParent_Done,
      // Label 2989: @154173
      GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(154220), // Rule ID 3867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3867,
        GIR_EraseRootFromParent_Done,
      // Label 2990: @154220
      GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(154267), // Rule ID 3868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3868,
        GIR_EraseRootFromParent_Done,
      // Label 2991: @154267
      GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(154313), // Rule ID 3553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1447:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3553,
        GIR_EraseRootFromParent_Done,
      // Label 2992: @154313
      GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(154359), // Rule ID 3554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1447:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3554,
        GIR_EraseRootFromParent_Done,
      // Label 2993: @154359
      GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(154405), // Rule ID 3555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1447:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3555,
        GIR_EraseRootFromParent_Done,
      // Label 2994: @154405
      GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(154451), // Rule ID 3556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1447:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3556,
        GIR_EraseRootFromParent_Done,
      // Label 2995: @154451
      GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(154507), // Rule ID 2096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 667:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2096,
        GIR_EraseRootFromParent_Done,
      // Label 2996: @154507
      GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(154563), // Rule ID 2097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 668:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2097,
        GIR_EraseRootFromParent_Done,
      // Label 2997: @154563
      GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(154619), // Rule ID 2102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 671:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2102,
        GIR_EraseRootFromParent_Done,
      // Label 2998: @154619
      GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(154675), // Rule ID 2103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2103,
        GIR_EraseRootFromParent_Done,
      // Label 2999: @154675
      GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(154731), // Rule ID 2109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 716:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2109,
        GIR_EraseRootFromParent_Done,
      // Label 3000: @154731
      GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(154787), // Rule ID 2112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 718:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2112,
        GIR_EraseRootFromParent_Done,
      // Label 3001: @154787
      GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(154843), // Rule ID 2134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2134,
        GIR_EraseRootFromParent_Done,
      // Label 3002: @154843
      GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(154899), // Rule ID 2136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2136,
        GIR_EraseRootFromParent_Done,
      // Label 3003: @154899
      GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(154955), // Rule ID 2138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2138,
        GIR_EraseRootFromParent_Done,
      // Label 3004: @154955
      GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(155008), // Rule ID 6311 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6311,
        GIR_EraseRootFromParent_Done,
      // Label 3005: @155008
      GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(155061), // Rule ID 6312 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 738:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6312,
        GIR_EraseRootFromParent_Done,
      // Label 3006: @155061
      GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(155114), // Rule ID 6313 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6313,
        GIR_EraseRootFromParent_Done,
      // Label 3007: @155114
      GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(155167), // Rule ID 6314 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 738:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6314,
        GIR_EraseRootFromParent_Done,
      // Label 3008: @155167
      GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(155220), // Rule ID 6315 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1i64] } 737:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6315,
        GIR_EraseRootFromParent_Done,
      // Label 3009: @155220
      GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(155273), // Rule ID 6316 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1i64] } 738:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6316,
        GIR_EraseRootFromParent_Done,
      // Label 3010: @155273
      GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(155326), // Rule ID 6317 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 741:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6317,
        GIR_EraseRootFromParent_Done,
      // Label 3011: @155326
      GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(155379), // Rule ID 6318 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6318,
        GIR_EraseRootFromParent_Done,
      // Label 3012: @155379
      GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(155432), // Rule ID 6319 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1f64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6319,
        GIR_EraseRootFromParent_Done,
      // Label 3013: @155432
      GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(155485), // Rule ID 6320 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6320,
        GIR_EraseRootFromParent_Done,
      // Label 3014: @155485
      GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(155538), // Rule ID 6321 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1f64] } 741:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6321,
        GIR_EraseRootFromParent_Done,
      // Label 3015: @155538
      GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(155591), // Rule ID 6322 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6322,
        GIR_EraseRootFromParent_Done,
      // Label 3016: @155591
      GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(155673), // Rule ID 6324 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6324,
        GIR_EraseRootFromParent_Done,
      // Label 3017: @155673
      GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(155755), // Rule ID 6325 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6325,
        GIR_EraseRootFromParent_Done,
      // Label 3018: @155755
      GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(155837), // Rule ID 6327 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 741:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6327,
        GIR_EraseRootFromParent_Done,
      // Label 3019: @155837
      GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(155919), // Rule ID 6328 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6328,
        GIR_EraseRootFromParent_Done,
      // Label 3020: @155919
      GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(156025), // Rule ID 6329 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6329,
        GIR_EraseRootFromParent_Done,
      // Label 3021: @156025
      GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(156131), // Rule ID 6330 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6330,
        GIR_EraseRootFromParent_Done,
      // Label 3022: @156131
      GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(156237), // Rule ID 6331 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 738:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6331,
        GIR_EraseRootFromParent_Done,
      // Label 3023: @156237
      GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(156343), // Rule ID 6332 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 738:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6332,
        GIR_EraseRootFromParent_Done,
      // Label 3024: @156343
      GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(156398), // Rule ID 7140 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 293:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7140,
        GIR_EraseRootFromParent_Done,
      // Label 3025: @156398
      GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(156440), // Rule ID 3028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3028,
        GIR_EraseRootFromParent_Done,
      // Label 3026: @156440
      GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(156482), // Rule ID 3029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3029,
        GIR_EraseRootFromParent_Done,
      // Label 3027: @156482
      GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(156524), // Rule ID 3030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3030,
        GIR_EraseRootFromParent_Done,
      // Label 3028: @156524
      GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(156566), // Rule ID 3064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3064,
        GIR_EraseRootFromParent_Done,
      // Label 3029: @156566
      GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(156608), // Rule ID 3065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3065,
        GIR_EraseRootFromParent_Done,
      // Label 3030: @156608
      GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(156650), // Rule ID 3066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3066,
        GIR_EraseRootFromParent_Done,
      // Label 3031: @156650
      GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(156692), // Rule ID 3537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1192:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3537,
        GIR_EraseRootFromParent_Done,
      // Label 3032: @156692
      GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(156734), // Rule ID 3538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1192:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3538,
        GIR_EraseRootFromParent_Done,
      // Label 3033: @156734
      GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(156776), // Rule ID 3539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1192:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3539,
        GIR_EraseRootFromParent_Done,
      // Label 3034: @156776
      GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(156818), // Rule ID 3540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1192:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3540,
        GIR_EraseRootFromParent_Done,
      // Label 3035: @156818
      GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(156860), // Rule ID 3541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1192:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3541,
        GIR_EraseRootFromParent_Done,
      // Label 3036: @156860
      GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(156902), // Rule ID 3542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1192:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3542,
        GIR_EraseRootFromParent_Done,
      // Label 3037: @156902
      GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(156944), // Rule ID 3543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1192:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3543,
        GIR_EraseRootFromParent_Done,
      // Label 3038: @156944
      GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(156986), // Rule ID 3544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1192:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3544,
        GIR_EraseRootFromParent_Done,
      // Label 3039: @156986
      GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(157028), // Rule ID 12036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1660:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12036,
        GIR_EraseRootFromParent_Done,
      // Label 3040: @157028
      GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(157070), // Rule ID 12037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1660:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12037,
        GIR_EraseRootFromParent_Done,
      // Label 3041: @157070
      GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(157112), // Rule ID 12038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1660:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12038,
        GIR_EraseRootFromParent_Done,
      // Label 3042: @157112
      GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(157154), // Rule ID 12039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1539:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12039,
        GIR_EraseRootFromParent_Done,
      // Label 3043: @157154
      GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(157196), // Rule ID 12040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1539:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12040,
        GIR_EraseRootFromParent_Done,
      // Label 3044: @157196
      GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(157238), // Rule ID 12041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1539:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12041,
        GIR_EraseRootFromParent_Done,
      // Label 3045: @157238
      GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(157280), // Rule ID 12043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1497:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12043,
        GIR_EraseRootFromParent_Done,
      // Label 3046: @157280
      GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(157322), // Rule ID 12045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1497:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12045,
        GIR_EraseRootFromParent_Done,
      // Label 3047: @157322
      GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(157364), // Rule ID 12047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1497:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12047,
        GIR_EraseRootFromParent_Done,
      // Label 3048: @157364
      GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(157406), // Rule ID 12048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1664:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12048,
        GIR_EraseRootFromParent_Done,
      // Label 3049: @157406
      GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(157448), // Rule ID 12049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1664:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12049,
        GIR_EraseRootFromParent_Done,
      // Label 3050: @157448
      GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(157490), // Rule ID 12050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12050,
        GIR_EraseRootFromParent_Done,
      // Label 3051: @157490
      GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(157532), // Rule ID 12051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1654:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12051,
        GIR_EraseRootFromParent_Done,
      // Label 3052: @157532
      GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(157574), // Rule ID 12052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1654:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12052,
        GIR_EraseRootFromParent_Done,
      // Label 3053: @157574
      GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(157616), // Rule ID 12053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1654:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12053,
        GIR_EraseRootFromParent_Done,
      // Label 3054: @157616
      GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(157658), // Rule ID 12054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1859:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12054,
        GIR_EraseRootFromParent_Done,
      // Label 3055: @157658
      GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(157700), // Rule ID 12055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1859:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12055,
        GIR_EraseRootFromParent_Done,
      // Label 3056: @157700
      GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(157742), // Rule ID 12056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12056,
        GIR_EraseRootFromParent_Done,
      // Label 3057: @157742
      GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(157784), // Rule ID 12057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12057,
        GIR_EraseRootFromParent_Done,
      // Label 3058: @157784
      GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157826), // Rule ID 12058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12058,
        GIR_EraseRootFromParent_Done,
      // Label 3059: @157826
      GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(157868), // Rule ID 12059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12059,
        GIR_EraseRootFromParent_Done,
      // Label 3060: @157868
      GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(157910), // Rule ID 12117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12117,
        GIR_EraseRootFromParent_Done,
      // Label 3061: @157910
      GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(157952), // Rule ID 12118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12118,
        GIR_EraseRootFromParent_Done,
      // Label 3062: @157952
      GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(157994), // Rule ID 12119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12119,
        GIR_EraseRootFromParent_Done,
      // Label 3063: @157994
      GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(158036), // Rule ID 12120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12120,
        GIR_EraseRootFromParent_Done,
      // Label 3064: @158036
      GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(158078), // Rule ID 12121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12121,
        GIR_EraseRootFromParent_Done,
      // Label 3065: @158078
      GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(158120), // Rule ID 12122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12122,
        GIR_EraseRootFromParent_Done,
      // Label 3066: @158120
      GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(158162), // Rule ID 12123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1880:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12123,
        GIR_EraseRootFromParent_Done,
      // Label 3067: @158162
      GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(158204), // Rule ID 12124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1880:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12124,
        GIR_EraseRootFromParent_Done,
      // Label 3068: @158204
      GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158246), // Rule ID 12125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1880:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12125,
        GIR_EraseRootFromParent_Done,
      // Label 3069: @158246
      GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158298), // Rule ID 2118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i16] } 737:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2118,
        GIR_EraseRootFromParent_Done,
      // Label 3070: @158298
      GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158350), // Rule ID 2119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8i16] } 737:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2119,
        GIR_EraseRootFromParent_Done,
      // Label 3071: @158350
      GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(158402), // Rule ID 2120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i32] } 737:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2120,
        GIR_EraseRootFromParent_Done,
      // Label 3072: @158402
      GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(158454), // Rule ID 2121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2121,
        GIR_EraseRootFromParent_Done,
      // Label 3073: @158454
      GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(158506), // Rule ID 2122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 737:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2122,
        GIR_EraseRootFromParent_Done,
      // Label 3074: @158506
      GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(158558), // Rule ID 2123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i16] } 738:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2123,
        GIR_EraseRootFromParent_Done,
      // Label 3075: @158558
      GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(158610), // Rule ID 2124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8i16] } 738:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2124,
        GIR_EraseRootFromParent_Done,
      // Label 3076: @158610
      GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(158662), // Rule ID 2125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i32] } 738:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2125,
        GIR_EraseRootFromParent_Done,
      // Label 3077: @158662
      GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(158714), // Rule ID 2126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 738:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2126,
        GIR_EraseRootFromParent_Done,
      // Label 3078: @158714
      GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(158766), // Rule ID 2127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 738:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2127,
        GIR_EraseRootFromParent_Done,
      // Label 3079: @158766
      GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(158818), // Rule ID 2128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2128,
        GIR_EraseRootFromParent_Done,
      // Label 3080: @158818
      GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(158870), // Rule ID 2129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8f16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2129,
        GIR_EraseRootFromParent_Done,
      // Label 3081: @158870
      GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(158922), // Rule ID 2130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2130,
        GIR_EraseRootFromParent_Done,
      // Label 3082: @158922
      GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(158974), // Rule ID 2131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2131,
        GIR_EraseRootFromParent_Done,
      // Label 3083: @158974
      GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159026), // Rule ID 2132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2132,
        GIR_EraseRootFromParent_Done,
      // Label 3084: @159026
      GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159078), // Rule ID 2230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f16] } 741:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2230,
        GIR_EraseRootFromParent_Done,
      // Label 3085: @159078
      GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159130), // Rule ID 2231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8f16] } 741:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2231,
        GIR_EraseRootFromParent_Done,
      // Label 3086: @159130
      GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(159182), // Rule ID 2232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f32] } 741:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2232,
        GIR_EraseRootFromParent_Done,
      // Label 3087: @159182
      GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(159234), // Rule ID 2233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f32] } 741:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2233,
        GIR_EraseRootFromParent_Done,
      // Label 3088: @159234
      GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(159286), // Rule ID 2234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f64] } 741:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2234,
        GIR_EraseRootFromParent_Done,
      // Label 3089: @159286
      GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(159331), // Rule ID 40 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfcvtn2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8bf16] } 565:{ *:[iPTR] }, V128:{ *:[v8bf16] }:$Rd, V128:{ *:[v4f32] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rd, V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 40,
        GIR_EraseRootFromParent_Done,
      // Label 3090: @159331
      GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(159376), // Rule ID 75 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 75,
        GIR_EraseRootFromParent_Done,
      // Label 3091: @159376
      GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(159421), // Rule ID 141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 495:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 141,
        GIR_EraseRootFromParent_Done,
      // Label 3092: @159421
      GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(159466), // Rule ID 142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 500:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 142,
        GIR_EraseRootFromParent_Done,
      // Label 3093: @159466
      GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(159511), // Rule ID 143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 143,
        GIR_EraseRootFromParent_Done,
      // Label 3094: @159511
      GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(159556), // Rule ID 144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 144,
        GIR_EraseRootFromParent_Done,
      // Label 3095: @159556
      GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(159601), // Rule ID 145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 496:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 145,
        GIR_EraseRootFromParent_Done,
      // Label 3096: @159601
      GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(159646), // Rule ID 146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 497:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 146,
        GIR_EraseRootFromParent_Done,
      // Label 3097: @159646
      GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(159691), // Rule ID 147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 498:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 147,
        GIR_EraseRootFromParent_Done,
      // Label 3098: @159691
      GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(159736), // Rule ID 148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 499:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 148,
        GIR_EraseRootFromParent_Done,
      // Label 3099: @159736
      GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(159781), // Rule ID 1030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 690:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1030,
        GIR_EraseRootFromParent_Done,
      // Label 3100: @159781
      GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(159826), // Rule ID 1031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 690:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1031,
        GIR_EraseRootFromParent_Done,
      // Label 3101: @159826
      GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(159871), // Rule ID 1032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1032,
        GIR_EraseRootFromParent_Done,
      // Label 3102: @159871
      GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(159916), // Rule ID 1033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1033,
        GIR_EraseRootFromParent_Done,
      // Label 3103: @159916
      GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(159961), // Rule ID 1034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1034,
        GIR_EraseRootFromParent_Done,
      // Label 3104: @159961
      GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(160006), // Rule ID 1035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1035,
        GIR_EraseRootFromParent_Done,
      // Label 3105: @160006
      GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(160051), // Rule ID 1036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1036,
        GIR_EraseRootFromParent_Done,
      // Label 3106: @160051
      GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(160096), // Rule ID 1078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 729:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1078,
        GIR_EraseRootFromParent_Done,
      // Label 3107: @160096
      GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(160141), // Rule ID 1079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 729:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1079,
        GIR_EraseRootFromParent_Done,
      // Label 3108: @160141
      GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(160186), // Rule ID 1080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 729:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1080,
        GIR_EraseRootFromParent_Done,
      // Label 3109: @160186
      GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(160231), // Rule ID 1081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 729:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1081,
        GIR_EraseRootFromParent_Done,
      // Label 3110: @160231
      GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(160276), // Rule ID 1082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 729:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1082,
        GIR_EraseRootFromParent_Done,
      // Label 3111: @160276
      GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(160321), // Rule ID 1083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 729:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1083,
        GIR_EraseRootFromParent_Done,
      // Label 3112: @160321
      GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(160366), // Rule ID 1084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 729:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1084,
        GIR_EraseRootFromParent_Done,
      // Label 3113: @160366
      GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(160411), // Rule ID 1096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 562:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1096,
        GIR_EraseRootFromParent_Done,
      // Label 3114: @160411
      GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(160456), // Rule ID 1098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 562:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1098,
        GIR_EraseRootFromParent_Done,
      // Label 3115: @160456
      GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(160501), // Rule ID 1100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 562:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1100,
        GIR_EraseRootFromParent_Done,
      // Label 3116: @160501
      GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(160546), // Rule ID 1102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 562:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1102,
        GIR_EraseRootFromParent_Done,
      // Label 3117: @160546
      GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(160591), // Rule ID 1104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 562:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1104,
        GIR_EraseRootFromParent_Done,
      // Label 3118: @160591
      GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(160636), // Rule ID 1106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 562:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1106,
        GIR_EraseRootFromParent_Done,
      // Label 3119: @160636
      GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(160681), // Rule ID 1108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 562:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1108,
        GIR_EraseRootFromParent_Done,
      // Label 3120: @160681
      GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(160726), // Rule ID 1151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 571:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1151,
        GIR_EraseRootFromParent_Done,
      // Label 3121: @160726
      GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(160771), // Rule ID 1152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 571:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1152,
        GIR_EraseRootFromParent_Done,
      // Label 3122: @160771
      GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(160816), // Rule ID 1153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 571:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1153,
        GIR_EraseRootFromParent_Done,
      // Label 3123: @160816
      GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(160861), // Rule ID 1154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 571:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1154,
        GIR_EraseRootFromParent_Done,
      // Label 3124: @160861
      GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(160906), // Rule ID 1155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 571:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1155,
        GIR_EraseRootFromParent_Done,
      // Label 3125: @160906
      GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(160951), // Rule ID 1157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 572:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1157,
        GIR_EraseRootFromParent_Done,
      // Label 3126: @160951
      GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(160996), // Rule ID 1159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 572:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1159,
        GIR_EraseRootFromParent_Done,
      // Label 3127: @160996
      GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(161041), // Rule ID 1161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 572:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1161,
        GIR_EraseRootFromParent_Done,
      // Label 3128: @161041
      GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(161086), // Rule ID 1163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 572:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1163,
        GIR_EraseRootFromParent_Done,
      // Label 3129: @161086
      GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(161131), // Rule ID 1165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 572:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1165,
        GIR_EraseRootFromParent_Done,
      // Label 3130: @161131
      GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(161176), // Rule ID 1167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 573:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1167,
        GIR_EraseRootFromParent_Done,
      // Label 3131: @161176
      GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(161221), // Rule ID 1169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 573:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1169,
        GIR_EraseRootFromParent_Done,
      // Label 3132: @161221
      GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(161266), // Rule ID 1171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 573:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1171,
        GIR_EraseRootFromParent_Done,
      // Label 3133: @161266
      GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(161311), // Rule ID 1173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 573:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1173,
        GIR_EraseRootFromParent_Done,
      // Label 3134: @161311
      GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(161356), // Rule ID 1175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 573:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1175,
        GIR_EraseRootFromParent_Done,
      // Label 3135: @161356
      GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(161401), // Rule ID 1177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 574:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1177,
        GIR_EraseRootFromParent_Done,
      // Label 3136: @161401
      GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(161446), // Rule ID 1179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 574:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1179,
        GIR_EraseRootFromParent_Done,
      // Label 3137: @161446
      GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(161491), // Rule ID 1181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 574:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1181,
        GIR_EraseRootFromParent_Done,
      // Label 3138: @161491
      GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(161536), // Rule ID 1183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 574:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1183,
        GIR_EraseRootFromParent_Done,
      // Label 3139: @161536
      GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(161581), // Rule ID 1185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 574:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1185,
        GIR_EraseRootFromParent_Done,
      // Label 3140: @161581
      GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(161626), // Rule ID 1221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1221,
        GIR_EraseRootFromParent_Done,
      // Label 3141: @161626
      GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(161671), // Rule ID 1222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1222,
        GIR_EraseRootFromParent_Done,
      // Label 3142: @161671
      GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(161716), // Rule ID 1223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1223,
        GIR_EraseRootFromParent_Done,
      // Label 3143: @161716
      GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(161761), // Rule ID 1224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1224,
        GIR_EraseRootFromParent_Done,
      // Label 3144: @161761
      GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(161806), // Rule ID 1225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1225,
        GIR_EraseRootFromParent_Done,
      // Label 3145: @161806
      GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(161851), // Rule ID 1236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1236,
        GIR_EraseRootFromParent_Done,
      // Label 3146: @161851
      GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(161896), // Rule ID 1237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1237,
        GIR_EraseRootFromParent_Done,
      // Label 3147: @161896
      GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(161941), // Rule ID 1238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1238,
        GIR_EraseRootFromParent_Done,
      // Label 3148: @161941
      GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(161986), // Rule ID 1239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1239,
        GIR_EraseRootFromParent_Done,
      // Label 3149: @161986
      GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(162031), // Rule ID 1240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1240,
        GIR_EraseRootFromParent_Done,
      // Label 3150: @162031
      GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(162076), // Rule ID 1251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1251,
        GIR_EraseRootFromParent_Done,
      // Label 3151: @162076
      GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(162121), // Rule ID 1252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1252,
        GIR_EraseRootFromParent_Done,
      // Label 3152: @162121
      GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(162166), // Rule ID 1253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1253,
        GIR_EraseRootFromParent_Done,
      // Label 3153: @162166
      GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(162211), // Rule ID 1254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1254,
        GIR_EraseRootFromParent_Done,
      // Label 3154: @162211
      GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(162256), // Rule ID 1255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1255,
        GIR_EraseRootFromParent_Done,
      // Label 3155: @162256
      GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(162301), // Rule ID 1266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1266,
        GIR_EraseRootFromParent_Done,
      // Label 3156: @162301
      GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(162346), // Rule ID 1267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1267,
        GIR_EraseRootFromParent_Done,
      // Label 3157: @162346
      GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(162391), // Rule ID 1268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1268,
        GIR_EraseRootFromParent_Done,
      // Label 3158: @162391
      GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(162436), // Rule ID 1269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1269,
        GIR_EraseRootFromParent_Done,
      // Label 3159: @162436
      GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(162481), // Rule ID 1270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1270,
        GIR_EraseRootFromParent_Done,
      // Label 3160: @162481
      GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(162526), // Rule ID 1301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1301,
        GIR_EraseRootFromParent_Done,
      // Label 3161: @162526
      GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(162571), // Rule ID 1302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1302,
        GIR_EraseRootFromParent_Done,
      // Label 3162: @162571
      GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(162616), // Rule ID 1303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1303,
        GIR_EraseRootFromParent_Done,
      // Label 3163: @162616
      GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(162661), // Rule ID 1304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1304,
        GIR_EraseRootFromParent_Done,
      // Label 3164: @162661
      GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(162706), // Rule ID 1305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1305,
        GIR_EraseRootFromParent_Done,
      // Label 3165: @162706
      GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(162751), // Rule ID 1316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 608:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1316,
        GIR_EraseRootFromParent_Done,
      // Label 3166: @162751
      GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(162796), // Rule ID 1317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 608:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1317,
        GIR_EraseRootFromParent_Done,
      // Label 3167: @162796
      GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(162841), // Rule ID 1318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1318,
        GIR_EraseRootFromParent_Done,
      // Label 3168: @162841
      GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(162886), // Rule ID 1319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1319,
        GIR_EraseRootFromParent_Done,
      // Label 3169: @162886
      GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(162931), // Rule ID 1320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 608:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1320,
        GIR_EraseRootFromParent_Done,
      // Label 3170: @162931
      GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(162976), // Rule ID 1321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1321,
        GIR_EraseRootFromParent_Done,
      // Label 3171: @162976
      GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(163021), // Rule ID 1322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1322,
        GIR_EraseRootFromParent_Done,
      // Label 3172: @163021
      GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(163066), // Rule ID 1323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1323,
        GIR_EraseRootFromParent_Done,
      // Label 3173: @163066
      GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(163111), // Rule ID 1324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1324,
        GIR_EraseRootFromParent_Done,
      // Label 3174: @163111
      GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(163156), // Rule ID 1325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 615:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1325,
        GIR_EraseRootFromParent_Done,
      // Label 3175: @163156
      GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(163201), // Rule ID 1342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 628:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1342,
        GIR_EraseRootFromParent_Done,
      // Label 3176: @163201
      GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(163246), // Rule ID 1343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 628:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1343,
        GIR_EraseRootFromParent_Done,
      // Label 3177: @163246
      GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(163291), // Rule ID 1357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1357,
        GIR_EraseRootFromParent_Done,
      // Label 3178: @163291
      GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(163336), // Rule ID 1359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 634:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1359,
        GIR_EraseRootFromParent_Done,
      // Label 3179: @163336
      GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(163381), // Rule ID 1361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1361,
        GIR_EraseRootFromParent_Done,
      // Label 3180: @163381
      GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(163426), // Rule ID 1363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 634:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1363,
        GIR_EraseRootFromParent_Done,
      // Label 3181: @163426
      GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(163471), // Rule ID 1365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1365,
        GIR_EraseRootFromParent_Done,
      // Label 3182: @163471
      GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(163516), // Rule ID 1367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 634:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1367,
        GIR_EraseRootFromParent_Done,
      // Label 3183: @163516
      GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(163561), // Rule ID 1374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 644:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1374,
        GIR_EraseRootFromParent_Done,
      // Label 3184: @163561
      GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(163606), // Rule ID 1375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 644:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1375,
        GIR_EraseRootFromParent_Done,
      // Label 3185: @163606
      GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(163651), // Rule ID 1376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 644:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1376,
        GIR_EraseRootFromParent_Done,
      // Label 3186: @163651
      GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(163696), // Rule ID 1377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 644:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1377,
        GIR_EraseRootFromParent_Done,
      // Label 3187: @163696
      GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(163741), // Rule ID 1378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 644:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1378,
        GIR_EraseRootFromParent_Done,
      // Label 3188: @163741
      GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(163786), // Rule ID 1379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 644:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1379,
        GIR_EraseRootFromParent_Done,
      // Label 3189: @163786
      GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(163831), // Rule ID 1380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 646:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1380,
        GIR_EraseRootFromParent_Done,
      // Label 3190: @163831
      GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(163876), // Rule ID 1381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 646:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1381,
        GIR_EraseRootFromParent_Done,
      // Label 3191: @163876
      GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(163921), // Rule ID 1382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 646:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1382,
        GIR_EraseRootFromParent_Done,
      // Label 3192: @163921
      GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(163966), // Rule ID 1383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 646:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1383,
        GIR_EraseRootFromParent_Done,
      // Label 3193: @163966
      GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(164011), // Rule ID 1384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 646:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1384,
        GIR_EraseRootFromParent_Done,
      // Label 3194: @164011
      GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(164056), // Rule ID 1385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 646:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1385,
        GIR_EraseRootFromParent_Done,
      // Label 3195: @164056
      GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(164101), // Rule ID 1392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 649:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1392,
        GIR_EraseRootFromParent_Done,
      // Label 3196: @164101
      GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(164146), // Rule ID 1393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 649:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1393,
        GIR_EraseRootFromParent_Done,
      // Label 3197: @164146
      GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(164191), // Rule ID 1394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 649:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1394,
        GIR_EraseRootFromParent_Done,
      // Label 3198: @164191
      GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(164236), // Rule ID 1395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 649:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1395,
        GIR_EraseRootFromParent_Done,
      // Label 3199: @164236
      GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(164281), // Rule ID 1396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 649:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1396,
        GIR_EraseRootFromParent_Done,
      // Label 3200: @164281
      GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(164326), // Rule ID 1397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 649:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1397,
        GIR_EraseRootFromParent_Done,
      // Label 3201: @164326
      GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(164371), // Rule ID 1404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 654:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1404,
        GIR_EraseRootFromParent_Done,
      // Label 3202: @164371
      GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(164416), // Rule ID 1405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 654:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1405,
        GIR_EraseRootFromParent_Done,
      // Label 3203: @164416
      GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(164461), // Rule ID 1406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 654:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1406,
        GIR_EraseRootFromParent_Done,
      // Label 3204: @164461
      GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(164506), // Rule ID 1407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 654:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1407,
        GIR_EraseRootFromParent_Done,
      // Label 3205: @164506
      GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(164551), // Rule ID 1408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 654:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1408,
        GIR_EraseRootFromParent_Done,
      // Label 3206: @164551
      GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(164596), // Rule ID 1409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1409,
        GIR_EraseRootFromParent_Done,
      // Label 3207: @164596
      GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(164641), // Rule ID 1410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1410,
        GIR_EraseRootFromParent_Done,
      // Label 3208: @164641
      GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(164686), // Rule ID 1411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 655:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1411,
        GIR_EraseRootFromParent_Done,
      // Label 3209: @164686
      GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(164731), // Rule ID 1412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 655:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1412,
        GIR_EraseRootFromParent_Done,
      // Label 3210: @164731
      GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(164776), // Rule ID 1413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 655:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1413,
        GIR_EraseRootFromParent_Done,
      // Label 3211: @164776
      GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(164821), // Rule ID 1414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 655:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1414,
        GIR_EraseRootFromParent_Done,
      // Label 3212: @164821
      GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(164866), // Rule ID 1415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1415,
        GIR_EraseRootFromParent_Done,
      // Label 3213: @164866
      GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(164911), // Rule ID 1416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1416,
        GIR_EraseRootFromParent_Done,
      // Label 3214: @164911
      GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(164956), // Rule ID 1417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1417,
        GIR_EraseRootFromParent_Done,
      // Label 3215: @164956
      GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(165001), // Rule ID 1418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1418,
        GIR_EraseRootFromParent_Done,
      // Label 3216: @165001
      GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(165046), // Rule ID 1419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1419,
        GIR_EraseRootFromParent_Done,
      // Label 3217: @165046
      GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(165091), // Rule ID 1420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1420,
        GIR_EraseRootFromParent_Done,
      // Label 3218: @165091
      GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(165136), // Rule ID 1421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1421,
        GIR_EraseRootFromParent_Done,
      // Label 3219: @165136
      GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(165181), // Rule ID 1422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1422,
        GIR_EraseRootFromParent_Done,
      // Label 3220: @165181
      GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(165226), // Rule ID 1423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1423,
        GIR_EraseRootFromParent_Done,
      // Label 3221: @165226
      GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(165271), // Rule ID 1424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1424,
        GIR_EraseRootFromParent_Done,
      // Label 3222: @165271
      GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(165316), // Rule ID 1425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1425,
        GIR_EraseRootFromParent_Done,
      // Label 3223: @165316
      GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(165361), // Rule ID 1426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1426,
        GIR_EraseRootFromParent_Done,
      // Label 3224: @165361
      GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(165406), // Rule ID 1427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1427,
        GIR_EraseRootFromParent_Done,
      // Label 3225: @165406
      GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(165451), // Rule ID 1428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1428,
        GIR_EraseRootFromParent_Done,
      // Label 3226: @165451
      GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(165496), // Rule ID 1429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1429,
        GIR_EraseRootFromParent_Done,
      // Label 3227: @165496
      GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(165541), // Rule ID 1430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1430,
        GIR_EraseRootFromParent_Done,
      // Label 3228: @165541
      GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(165586), // Rule ID 1431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1431,
        GIR_EraseRootFromParent_Done,
      // Label 3229: @165586
      GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(165631), // Rule ID 1432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 669:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1432,
        GIR_EraseRootFromParent_Done,
      // Label 3230: @165631
      GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(165676), // Rule ID 1433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 673:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1433,
        GIR_EraseRootFromParent_Done,
      // Label 3231: @165676
      GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(165721), // Rule ID 1434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 673:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1434,
        GIR_EraseRootFromParent_Done,
      // Label 3232: @165721
      GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(165766), // Rule ID 1435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 673:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1435,
        GIR_EraseRootFromParent_Done,
      // Label 3233: @165766
      GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(165811), // Rule ID 1436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 673:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1436,
        GIR_EraseRootFromParent_Done,
      // Label 3234: @165811
      GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(165856), // Rule ID 1437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 673:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1437,
        GIR_EraseRootFromParent_Done,
      // Label 3235: @165856
      GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(165901), // Rule ID 1438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1438,
        GIR_EraseRootFromParent_Done,
      // Label 3236: @165901
      GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(165946), // Rule ID 1439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1439,
        GIR_EraseRootFromParent_Done,
      // Label 3237: @165946
      GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(165991), // Rule ID 1446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 677:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1446,
        GIR_EraseRootFromParent_Done,
      // Label 3238: @165991
      GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(166036), // Rule ID 1447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 677:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1447,
        GIR_EraseRootFromParent_Done,
      // Label 3239: @166036
      GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(166081), // Rule ID 1448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 677:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1448,
        GIR_EraseRootFromParent_Done,
      // Label 3240: @166081
      GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(166126), // Rule ID 1449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 677:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1449,
        GIR_EraseRootFromParent_Done,
      // Label 3241: @166126
      GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(166171), // Rule ID 1450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 677:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1450,
        GIR_EraseRootFromParent_Done,
      // Label 3242: @166171
      GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(166216), // Rule ID 1451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 677:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1451,
        GIR_EraseRootFromParent_Done,
      // Label 3243: @166216
      GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(166261), // Rule ID 1452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 677:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1452,
        GIR_EraseRootFromParent_Done,
      // Label 3244: @166261
      GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(166306), // Rule ID 1453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1453,
        GIR_EraseRootFromParent_Done,
      // Label 3245: @166306
      GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(166351), // Rule ID 1454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1454,
        GIR_EraseRootFromParent_Done,
      // Label 3246: @166351
      GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(166396), // Rule ID 1455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1455,
        GIR_EraseRootFromParent_Done,
      // Label 3247: @166396
      GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(166441), // Rule ID 1456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1456,
        GIR_EraseRootFromParent_Done,
      // Label 3248: @166441
      GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(166486), // Rule ID 1457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1457,
        GIR_EraseRootFromParent_Done,
      // Label 3249: @166486
      GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(166531), // Rule ID 1458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1458,
        GIR_EraseRootFromParent_Done,
      // Label 3250: @166531
      GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(166576), // Rule ID 1459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1459,
        GIR_EraseRootFromParent_Done,
      // Label 3251: @166576
      GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(166621), // Rule ID 1480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1480,
        GIR_EraseRootFromParent_Done,
      // Label 3252: @166621
      GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(166666), // Rule ID 1482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1482,
        GIR_EraseRootFromParent_Done,
      // Label 3253: @166666
      GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(166711), // Rule ID 1484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1484,
        GIR_EraseRootFromParent_Done,
      // Label 3254: @166711
      GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(166756), // Rule ID 1486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1486,
        GIR_EraseRootFromParent_Done,
      // Label 3255: @166756
      GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(166801), // Rule ID 1488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1488,
        GIR_EraseRootFromParent_Done,
      // Label 3256: @166801
      GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(166846), // Rule ID 1490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1490,
        GIR_EraseRootFromParent_Done,
      // Label 3257: @166846
      GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(166891), // Rule ID 1497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 705:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1497,
        GIR_EraseRootFromParent_Done,
      // Label 3258: @166891
      GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(166936), // Rule ID 1498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 705:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1498,
        GIR_EraseRootFromParent_Done,
      // Label 3259: @166936
      GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(166981), // Rule ID 1499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 705:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1499,
        GIR_EraseRootFromParent_Done,
      // Label 3260: @166981
      GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(167026), // Rule ID 1500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 705:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1500,
        GIR_EraseRootFromParent_Done,
      // Label 3261: @167026
      GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(167071), // Rule ID 1501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 705:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1501,
        GIR_EraseRootFromParent_Done,
      // Label 3262: @167071
      GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(167116), // Rule ID 1502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 705:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1502,
        GIR_EraseRootFromParent_Done,
      // Label 3263: @167116
      GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(167161), // Rule ID 1503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 707:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1503,
        GIR_EraseRootFromParent_Done,
      // Label 3264: @167161
      GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(167206), // Rule ID 1504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 707:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1504,
        GIR_EraseRootFromParent_Done,
      // Label 3265: @167206
      GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(167251), // Rule ID 1505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 707:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1505,
        GIR_EraseRootFromParent_Done,
      // Label 3266: @167251
      GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(167296), // Rule ID 1506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 707:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1506,
        GIR_EraseRootFromParent_Done,
      // Label 3267: @167296
      GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(167341), // Rule ID 1507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 707:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1507,
        GIR_EraseRootFromParent_Done,
      // Label 3268: @167341
      GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(167386), // Rule ID 1508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 707:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1508,
        GIR_EraseRootFromParent_Done,
      // Label 3269: @167386
      GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(167431), // Rule ID 1515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 710:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1515,
        GIR_EraseRootFromParent_Done,
      // Label 3270: @167431
      GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(167476), // Rule ID 1516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 710:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1516,
        GIR_EraseRootFromParent_Done,
      // Label 3271: @167476
      GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(167521), // Rule ID 1517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 710:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1517,
        GIR_EraseRootFromParent_Done,
      // Label 3272: @167521
      GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(167566), // Rule ID 1518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 710:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1518,
        GIR_EraseRootFromParent_Done,
      // Label 3273: @167566
      GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(167611), // Rule ID 1519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 710:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1519,
        GIR_EraseRootFromParent_Done,
      // Label 3274: @167611
      GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(167656), // Rule ID 1520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 710:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1520,
        GIR_EraseRootFromParent_Done,
      // Label 3275: @167656
      GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(167701), // Rule ID 1527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1527,
        GIR_EraseRootFromParent_Done,
      // Label 3276: @167701
      GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(167746), // Rule ID 1528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 714:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1528,
        GIR_EraseRootFromParent_Done,
      // Label 3277: @167746
      GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(167791), // Rule ID 1529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1529,
        GIR_EraseRootFromParent_Done,
      // Label 3278: @167791
      GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(167836), // Rule ID 1530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1530,
        GIR_EraseRootFromParent_Done,
      // Label 3279: @167836
      GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(167881), // Rule ID 1531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1531,
        GIR_EraseRootFromParent_Done,
      // Label 3280: @167881
      GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(167926), // Rule ID 1532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1532,
        GIR_EraseRootFromParent_Done,
      // Label 3281: @167926
      GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(167971), // Rule ID 1533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1533,
        GIR_EraseRootFromParent_Done,
      // Label 3282: @167971
      GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(168016), // Rule ID 1534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1534,
        GIR_EraseRootFromParent_Done,
      // Label 3283: @168016
      GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(168061), // Rule ID 1535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1535,
        GIR_EraseRootFromParent_Done,
      // Label 3284: @168061
      GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(168106), // Rule ID 1536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1536,
        GIR_EraseRootFromParent_Done,
      // Label 3285: @168106
      GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(168151), // Rule ID 1537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1537,
        GIR_EraseRootFromParent_Done,
      // Label 3286: @168151
      GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(168196), // Rule ID 1538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1538,
        GIR_EraseRootFromParent_Done,
      // Label 3287: @168196
      GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(168241), // Rule ID 1539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1539,
        GIR_EraseRootFromParent_Done,
      // Label 3288: @168241
      GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(168286), // Rule ID 1540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1540,
        GIR_EraseRootFromParent_Done,
      // Label 3289: @168286
      GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(168331), // Rule ID 1541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 717:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1541,
        GIR_EraseRootFromParent_Done,
      // Label 3290: @168331
      GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(168376), // Rule ID 1542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 717:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1542,
        GIR_EraseRootFromParent_Done,
      // Label 3291: @168376
      GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(168421), // Rule ID 1543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 717:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1543,
        GIR_EraseRootFromParent_Done,
      // Label 3292: @168421
      GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(168466), // Rule ID 1544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 717:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1544,
        GIR_EraseRootFromParent_Done,
      // Label 3293: @168466
      GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(168511), // Rule ID 1545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 717:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1545,
        GIR_EraseRootFromParent_Done,
      // Label 3294: @168511
      GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(168556), // Rule ID 1546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 717:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1546,
        GIR_EraseRootFromParent_Done,
      // Label 3295: @168556
      GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(168601), // Rule ID 1547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 717:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1547,
        GIR_EraseRootFromParent_Done,
      // Label 3296: @168601
      GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(168646), // Rule ID 1548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 719:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1548,
        GIR_EraseRootFromParent_Done,
      // Label 3297: @168646
      GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(168691), // Rule ID 1549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 719:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1549,
        GIR_EraseRootFromParent_Done,
      // Label 3298: @168691
      GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(168736), // Rule ID 1550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 719:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1550,
        GIR_EraseRootFromParent_Done,
      // Label 3299: @168736
      GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(168781), // Rule ID 1551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 719:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1551,
        GIR_EraseRootFromParent_Done,
      // Label 3300: @168781
      GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(168826), // Rule ID 1552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 719:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1552,
        GIR_EraseRootFromParent_Done,
      // Label 3301: @168826
      GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(168871), // Rule ID 1553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 719:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1553,
        GIR_EraseRootFromParent_Done,
      // Label 3302: @168871
      GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(168916), // Rule ID 1554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 719:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1554,
        GIR_EraseRootFromParent_Done,
      // Label 3303: @168916
      GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(168961), // Rule ID 1561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 723:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1561,
        GIR_EraseRootFromParent_Done,
      // Label 3304: @168961
      GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(169006), // Rule ID 1562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 723:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1562,
        GIR_EraseRootFromParent_Done,
      // Label 3305: @169006
      GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(169051), // Rule ID 1563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 723:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1563,
        GIR_EraseRootFromParent_Done,
      // Label 3306: @169051
      GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(169096), // Rule ID 1564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 723:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1564,
        GIR_EraseRootFromParent_Done,
      // Label 3307: @169096
      GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(169141), // Rule ID 1565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 723:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1565,
        GIR_EraseRootFromParent_Done,
      // Label 3308: @169141
      GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(169186), // Rule ID 1566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 723:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1566,
        GIR_EraseRootFromParent_Done,
      // Label 3309: @169186
      GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(169231), // Rule ID 1567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 723:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1567,
        GIR_EraseRootFromParent_Done,
      // Label 3310: @169231
      GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(169276), // Rule ID 1568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1568,
        GIR_EraseRootFromParent_Done,
      // Label 3311: @169276
      GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(169321), // Rule ID 1569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1569,
        GIR_EraseRootFromParent_Done,
      // Label 3312: @169321
      GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(169366), // Rule ID 1570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1570,
        GIR_EraseRootFromParent_Done,
      // Label 3313: @169366
      GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(169411), // Rule ID 1571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1571,
        GIR_EraseRootFromParent_Done,
      // Label 3314: @169411
      GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(169456), // Rule ID 1572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 726:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1572,
        GIR_EraseRootFromParent_Done,
      // Label 3315: @169456
      GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(169501), // Rule ID 1573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1573,
        GIR_EraseRootFromParent_Done,
      // Label 3316: @169501
      GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(169546), // Rule ID 1574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 726:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1574,
        GIR_EraseRootFromParent_Done,
      // Label 3317: @169546
      GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(169591), // Rule ID 1602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 760:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1602,
        GIR_EraseRootFromParent_Done,
      // Label 3318: @169591
      GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(169636), // Rule ID 1603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 760:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1603,
        GIR_EraseRootFromParent_Done,
      // Label 3319: @169636
      GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(169681), // Rule ID 1604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 760:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1604,
        GIR_EraseRootFromParent_Done,
      // Label 3320: @169681
      GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(169726), // Rule ID 1605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 572:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1605,
        GIR_EraseRootFromParent_Done,
      // Label 3321: @169726
      GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(169771), // Rule ID 1606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 572:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1606,
        GIR_EraseRootFromParent_Done,
      // Label 3322: @169771
      GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(169816), // Rule ID 1607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 573:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1607,
        GIR_EraseRootFromParent_Done,
      // Label 3323: @169816
      GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(169861), // Rule ID 1608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 573:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1608,
        GIR_EraseRootFromParent_Done,
      // Label 3324: @169861
      GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(169906), // Rule ID 1615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1615,
        GIR_EraseRootFromParent_Done,
      // Label 3325: @169906
      GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(169951), // Rule ID 1616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1616,
        GIR_EraseRootFromParent_Done,
      // Label 3326: @169951
      GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(169996), // Rule ID 1617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1617,
        GIR_EraseRootFromParent_Done,
      // Label 3327: @169996
      GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(170041), // Rule ID 1618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 608:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1618,
        GIR_EraseRootFromParent_Done,
      // Label 3328: @170041
      GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(170086), // Rule ID 1619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 608:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1619,
        GIR_EraseRootFromParent_Done,
      // Label 3329: @170086
      GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(170131), // Rule ID 1620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 608:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1620,
        GIR_EraseRootFromParent_Done,
      // Label 3330: @170131
      GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(170176), // Rule ID 1621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 615:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1621,
        GIR_EraseRootFromParent_Done,
      // Label 3331: @170176
      GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(170221), // Rule ID 1622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1622,
        GIR_EraseRootFromParent_Done,
      // Label 3332: @170221
      GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(170266), // Rule ID 1623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1623,
        GIR_EraseRootFromParent_Done,
      // Label 3333: @170266
      GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(170311), // Rule ID 1624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 654:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1624,
        GIR_EraseRootFromParent_Done,
      // Label 3334: @170311
      GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(170356), // Rule ID 1625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 655:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1625,
        GIR_EraseRootFromParent_Done,
      // Label 3335: @170356
      GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(170401), // Rule ID 1626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 663:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1626,
        GIR_EraseRootFromParent_Done,
      // Label 3336: @170401
      GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(170446), // Rule ID 1627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 666:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1627,
        GIR_EraseRootFromParent_Done,
      // Label 3337: @170446
      GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(170491), // Rule ID 1628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 669:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1628,
        GIR_EraseRootFromParent_Done,
      // Label 3338: @170491
      GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(170536), // Rule ID 1629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 673:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1629,
        GIR_EraseRootFromParent_Done,
      // Label 3339: @170536
      GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(170581), // Rule ID 1630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 677:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1630,
        GIR_EraseRootFromParent_Done,
      // Label 3340: @170581
      GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(170626), // Rule ID 1631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1631,
        GIR_EraseRootFromParent_Done,
      // Label 3341: @170626
      GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(170671), // Rule ID 1633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 714:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1633,
        GIR_EraseRootFromParent_Done,
      // Label 3342: @170671
      GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(170716), // Rule ID 1634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1634,
        GIR_EraseRootFromParent_Done,
      // Label 3343: @170716
      GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(170761), // Rule ID 1635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 717:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1635,
        GIR_EraseRootFromParent_Done,
      // Label 3344: @170761
      GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(170806), // Rule ID 1636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 719:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1636,
        GIR_EraseRootFromParent_Done,
      // Label 3345: @170806
      GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(170851), // Rule ID 1637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 723:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1637,
        GIR_EraseRootFromParent_Done,
      // Label 3346: @170851
      GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(170896), // Rule ID 1638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 726:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1638,
        GIR_EraseRootFromParent_Done,
      // Label 3347: @170896
      GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(170941), // Rule ID 1639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1639,
        GIR_EraseRootFromParent_Done,
      // Label 3348: @170941
      GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(170986), // Rule ID 1653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 690:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1653,
        GIR_EraseRootFromParent_Done,
      // Label 3349: @170986
      GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(171031), // Rule ID 1654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1654,
        GIR_EraseRootFromParent_Done,
      // Label 3350: @171031
      GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(171076), // Rule ID 1659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 729:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1659,
        GIR_EraseRootFromParent_Done,
      // Label 3351: @171076
      GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(171121), // Rule ID 1660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 729:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1660,
        GIR_EraseRootFromParent_Done,
      // Label 3352: @171121
      GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(171166), // Rule ID 1661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 561:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1661,
        GIR_EraseRootFromParent_Done,
      // Label 3353: @171166
      GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(171211), // Rule ID 1662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 561:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1662,
        GIR_EraseRootFromParent_Done,
      // Label 3354: @171211
      GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(171256), // Rule ID 1663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 561:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1663,
        GIR_EraseRootFromParent_Done,
      // Label 3355: @171256
      GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(171301), // Rule ID 1664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 689:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1664,
        GIR_EraseRootFromParent_Done,
      // Label 3356: @171301
      GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(171346), // Rule ID 1665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1665,
        GIR_EraseRootFromParent_Done,
      // Label 3357: @171346
      GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(171391), // Rule ID 1666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1666,
        GIR_EraseRootFromParent_Done,
      // Label 3358: @171391
      GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(171436), // Rule ID 1667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 631:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1667,
        GIR_EraseRootFromParent_Done,
      // Label 3359: @171436
      GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(171481), // Rule ID 1668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 631:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1668,
        GIR_EraseRootFromParent_Done,
      // Label 3360: @171481
      GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(171526), // Rule ID 1669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 631:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1669,
        GIR_EraseRootFromParent_Done,
      // Label 3361: @171526
      GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(171571), // Rule ID 1670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 633:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1670,
        GIR_EraseRootFromParent_Done,
      // Label 3362: @171571
      GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(171616), // Rule ID 1671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 633:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1671,
        GIR_EraseRootFromParent_Done,
      // Label 3363: @171616
      GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(171661), // Rule ID 1672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 633:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1672,
        GIR_EraseRootFromParent_Done,
      // Label 3364: @171661
      GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(171706), // Rule ID 1738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1738,
        GIR_EraseRootFromParent_Done,
      // Label 3365: @171706
      GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(171751), // Rule ID 1740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1740,
        GIR_EraseRootFromParent_Done,
      // Label 3366: @171751
      GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(171796), // Rule ID 2289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 504:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2289,
        GIR_EraseRootFromParent_Done,
      // Label 3367: @171796
      GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(171841), // Rule ID 2290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 503:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2290,
        GIR_EraseRootFromParent_Done,
      // Label 3368: @171841
      GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(171886), // Rule ID 2301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2301,
        GIR_EraseRootFromParent_Done,
      // Label 3369: @171886
      GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(171931), // Rule ID 2302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2302,
        GIR_EraseRootFromParent_Done,
      // Label 3370: @171931
      GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(171976), // Rule ID 2325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2325,
        GIR_EraseRootFromParent_Done,
      // Label 3371: @171976
      GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(172021), // Rule ID 2326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2326,
        GIR_EraseRootFromParent_Done,
      // Label 3372: @172021
      GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(172066), // Rule ID 2327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2327,
        GIR_EraseRootFromParent_Done,
      // Label 3373: @172066
      GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(172111), // Rule ID 2328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2328,
        GIR_EraseRootFromParent_Done,
      // Label 3374: @172111
      GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(172156), // Rule ID 2329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2329,
        GIR_EraseRootFromParent_Done,
      // Label 3375: @172156
      GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(172201), // Rule ID 2330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2330,
        GIR_EraseRootFromParent_Done,
      // Label 3376: @172201
      GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(172246), // Rule ID 2333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2333,
        GIR_EraseRootFromParent_Done,
      // Label 3377: @172246
      GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(172291), // Rule ID 2336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2336,
        GIR_EraseRootFromParent_Done,
      // Label 3378: @172291
      GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(172336), // Rule ID 2339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2339,
        GIR_EraseRootFromParent_Done,
      // Label 3379: @172336
      GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(172381), // Rule ID 2342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2342,
        GIR_EraseRootFromParent_Done,
      // Label 3380: @172381
      GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(172426), // Rule ID 2345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2345,
        GIR_EraseRootFromParent_Done,
      // Label 3381: @172426
      GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(172471), // Rule ID 2348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2348,
        GIR_EraseRootFromParent_Done,
      // Label 3382: @172471
      GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(172516), // Rule ID 2351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2351,
        GIR_EraseRootFromParent_Done,
      // Label 3383: @172516
      GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(172561), // Rule ID 2354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2354,
        GIR_EraseRootFromParent_Done,
      // Label 3384: @172561
      GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(172606), // Rule ID 2357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2357,
        GIR_EraseRootFromParent_Done,
      // Label 3385: @172606
      GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(172651), // Rule ID 2472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 654:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2472,
        GIR_EraseRootFromParent_Done,
      // Label 3386: @172651
      GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(172696), // Rule ID 2473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2473,
        GIR_EraseRootFromParent_Done,
      // Label 3387: @172696
      GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(172741), // Rule ID 2474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 760:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2474,
        GIR_EraseRootFromParent_Done,
      // Label 3388: @172741
      GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(172786), // Rule ID 2475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 572:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2475,
        GIR_EraseRootFromParent_Done,
      // Label 3389: @172786
      GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(172831), // Rule ID 2480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 690:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2480,
        GIR_EraseRootFromParent_Done,
      // Label 3390: @172831
      GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(172876), // Rule ID 2581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1846:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2581,
        GIR_EraseRootFromParent_Done,
      // Label 3391: @172876
      GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(172921), // Rule ID 2582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1846:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2582,
        GIR_EraseRootFromParent_Done,
      // Label 3392: @172921
      GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(172966), // Rule ID 2583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1846:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2583,
        GIR_EraseRootFromParent_Done,
      // Label 3393: @172966
      GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(173011), // Rule ID 2584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1846:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2584,
        GIR_EraseRootFromParent_Done,
      // Label 3394: @173011
      GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(173056), // Rule ID 2585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1636:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2585,
        GIR_EraseRootFromParent_Done,
      // Label 3395: @173056
      GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(173101), // Rule ID 2586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1636:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2586,
        GIR_EraseRootFromParent_Done,
      // Label 3396: @173101
      GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(173146), // Rule ID 2587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1636:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2587,
        GIR_EraseRootFromParent_Done,
      // Label 3397: @173146
      GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(173191), // Rule ID 2588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1636:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2588,
        GIR_EraseRootFromParent_Done,
      // Label 3398: @173191
      GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(173236), // Rule ID 3783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 524:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3783,
        GIR_EraseRootFromParent_Done,
      // Label 3399: @173236
      GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(173281), // Rule ID 3811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 511:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3811,
        GIR_EraseRootFromParent_Done,
      // Label 3400: @173281
      GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(173326), // Rule ID 3821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3821,
        GIR_EraseRootFromParent_Done,
      // Label 3401: @173326
      GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(173371), // Rule ID 3822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3822,
        GIR_EraseRootFromParent_Done,
      // Label 3402: @173371
      GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(173419), // Rule ID 3823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 731:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3823,
        GIR_EraseRootFromParent_Done,
      // Label 3403: @173419
      GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(173467), // Rule ID 3824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 730:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3824,
        GIR_EraseRootFromParent_Done,
      // Label 3404: @173467
      GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(173515), // Rule ID 3825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 731:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3825,
        GIR_EraseRootFromParent_Done,
      // Label 3405: @173515
      GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(173563), // Rule ID 3826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 730:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3826,
        GIR_EraseRootFromParent_Done,
      // Label 3406: @173563
      GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(173611), // Rule ID 3827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 731:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3827,
        GIR_EraseRootFromParent_Done,
      // Label 3407: @173611
      GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(173659), // Rule ID 3828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 730:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3828,
        GIR_EraseRootFromParent_Done,
      // Label 3408: @173659
      GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(173707), // Rule ID 3829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 731:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3829,
        GIR_EraseRootFromParent_Done,
      // Label 3409: @173707
      GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(173755), // Rule ID 3830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 730:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3830,
        GIR_EraseRootFromParent_Done,
      // Label 3410: @173755
      GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(173803), // Rule ID 3831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 731:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3831,
        GIR_EraseRootFromParent_Done,
      // Label 3411: @173803
      GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(173851), // Rule ID 3832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 730:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3832,
        GIR_EraseRootFromParent_Done,
      // Label 3412: @173851
      GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(173893), // Rule ID 3897 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1990:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3897,
        GIR_EraseRootFromParent_Done,
      // Label 3413: @173893
      GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(173935), // Rule ID 3898 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1990:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3898,
        GIR_EraseRootFromParent_Done,
      // Label 3414: @173935
      GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(173977), // Rule ID 3899 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3899,
        GIR_EraseRootFromParent_Done,
      // Label 3415: @173977
      GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(174019), // Rule ID 3900 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3900,
        GIR_EraseRootFromParent_Done,
      // Label 3416: @174019
      GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(174061), // Rule ID 5230 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 571:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5230,
        GIR_EraseRootFromParent_Done,
      // Label 3417: @174061
      GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(174106), // Rule ID 5234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 573:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5234,
        GIR_EraseRootFromParent_Done,
      // Label 3418: @174106
      GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(174151), // Rule ID 5238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 605:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5238,
        GIR_EraseRootFromParent_Done,
      // Label 3419: @174151
      GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(174196), // Rule ID 5239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 608:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5239,
        GIR_EraseRootFromParent_Done,
      // Label 3420: @174196
      GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(174241), // Rule ID 5240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 615:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5240,
        GIR_EraseRootFromParent_Done,
      // Label 3421: @174241
      GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(174286), // Rule ID 5241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 666:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5241,
        GIR_EraseRootFromParent_Done,
      // Label 3422: @174286
      GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(174331), // Rule ID 5242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 666:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5242,
        GIR_EraseRootFromParent_Done,
      // Label 3423: @174331
      GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(174376), // Rule ID 5243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 669:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5243,
        GIR_EraseRootFromParent_Done,
      // Label 3424: @174376
      GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(174421), // Rule ID 5244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5244,
        GIR_EraseRootFromParent_Done,
      // Label 3425: @174421
      GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(174466), // Rule ID 5245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 673:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5245,
        GIR_EraseRootFromParent_Done,
      // Label 3426: @174466
      GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(174511), // Rule ID 5246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5246,
        GIR_EraseRootFromParent_Done,
      // Label 3427: @174511
      GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(174556), // Rule ID 5247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 714:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5247,
        GIR_EraseRootFromParent_Done,
      // Label 3428: @174556
      GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(174601), // Rule ID 5248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 714:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5248,
        GIR_EraseRootFromParent_Done,
      // Label 3429: @174601
      GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(174646), // Rule ID 5249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5249,
        GIR_EraseRootFromParent_Done,
      // Label 3430: @174646
      GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(174691), // Rule ID 5250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5250,
        GIR_EraseRootFromParent_Done,
      // Label 3431: @174691
      GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(174736), // Rule ID 5251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 717:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5251,
        GIR_EraseRootFromParent_Done,
      // Label 3432: @174736
      GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(174781), // Rule ID 5252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 717:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5252,
        GIR_EraseRootFromParent_Done,
      // Label 3433: @174781
      GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(174826), // Rule ID 5253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 719:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5253,
        GIR_EraseRootFromParent_Done,
      // Label 3434: @174826
      GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(174871), // Rule ID 5254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 719:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5254,
        GIR_EraseRootFromParent_Done,
      // Label 3435: @174871
      GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(174916), // Rule ID 5272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 729:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5272,
        GIR_EraseRootFromParent_Done,
      // Label 3436: @174916
      GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(174958), // Rule ID 5611 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Ri
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5611,
        GIR_EraseRootFromParent_Done,
      // Label 3437: @174958
      GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(175000), // Rule ID 5612 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Ri
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5612,
        GIR_EraseRootFromParent_Done,
      // Label 3438: @175000
      GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(175097), // Rule ID 6333 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 572:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6333,
        GIR_EraseRootFromParent_Done,
      // Label 3439: @175097
      GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(175194), // Rule ID 6334 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 573:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6334,
        GIR_EraseRootFromParent_Done,
      // Label 3440: @175194
      GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(175236), // Rule ID 7098 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7098,
        GIR_EraseRootFromParent_Done,
      // Label 3441: @175236
      GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(175278), // Rule ID 7099 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 726:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7099,
        GIR_EraseRootFromParent_Done,
      // Label 3442: @175278
      GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(175320), // Rule ID 7100 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 677:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7100,
        GIR_EraseRootFromParent_Done,
      // Label 3443: @175320
      GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(175362), // Rule ID 7101 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 723:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7101,
        GIR_EraseRootFromParent_Done,
      // Label 3444: @175362
      GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(175410), // Rule ID 7141 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 293:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7141,
        GIR_EraseRootFromParent_Done,
      // Label 3445: @175410
      GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(175455), // Rule ID 10239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1847:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10239,
        GIR_EraseRootFromParent_Done,
      // Label 3446: @175455
      GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(175500), // Rule ID 10240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1847:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10240,
        GIR_EraseRootFromParent_Done,
      // Label 3447: @175500
      GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(175545), // Rule ID 10241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1847:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10241,
        GIR_EraseRootFromParent_Done,
      // Label 3448: @175545
      GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(175590), // Rule ID 10242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1847:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10242,
        GIR_EraseRootFromParent_Done,
      // Label 3449: @175590
      GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(175635), // Rule ID 10251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1602:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10251,
        GIR_EraseRootFromParent_Done,
      // Label 3450: @175635
      GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(175680), // Rule ID 10252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1602:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10252,
        GIR_EraseRootFromParent_Done,
      // Label 3451: @175680
      GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(175725), // Rule ID 10253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1602:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10253,
        GIR_EraseRootFromParent_Done,
      // Label 3452: @175725
      GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(175770), // Rule ID 10254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1602:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10254,
        GIR_EraseRootFromParent_Done,
      // Label 3453: @175770
      GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(175815), // Rule ID 10255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1832:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10255,
        GIR_EraseRootFromParent_Done,
      // Label 3454: @175815
      GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(175860), // Rule ID 10256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1832:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10256,
        GIR_EraseRootFromParent_Done,
      // Label 3455: @175860
      GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(175905), // Rule ID 10257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1832:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10257,
        GIR_EraseRootFromParent_Done,
      // Label 3456: @175905
      GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(175950), // Rule ID 10258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1832:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10258,
        GIR_EraseRootFromParent_Done,
      // Label 3457: @175950
      GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(175995), // Rule ID 10259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1833:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10259,
        GIR_EraseRootFromParent_Done,
      // Label 3458: @175995
      GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(176040), // Rule ID 10260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1833:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10260,
        GIR_EraseRootFromParent_Done,
      // Label 3459: @176040
      GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(176085), // Rule ID 10261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1833:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10261,
        GIR_EraseRootFromParent_Done,
      // Label 3460: @176085
      GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(176130), // Rule ID 10262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1833:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10262,
        GIR_EraseRootFromParent_Done,
      // Label 3461: @176130
      GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(176176), // Rule ID 150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 547:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 150,
        GIR_EraseRootFromParent_Done,
      // Label 3462: @176176
      GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(176223), // Rule ID 151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // MIs[0] Rm
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1089:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 151,
        GIR_EraseRootFromParent_Done,
      // Label 3463: @176223
      GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(176260), // Rule ID 2375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1972:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2375,
        GIR_EraseRootFromParent_Done,
      // Label 3464: @176260
      GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(176297), // Rule ID 2376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1973:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2376,
        GIR_EraseRootFromParent_Done,
      // Label 3465: @176297
      GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(176334), // Rule ID 2377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1974:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2377,
        GIR_EraseRootFromParent_Done,
      // Label 3466: @176334
      GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(176371), // Rule ID 2379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1977:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2379,
        GIR_EraseRootFromParent_Done,
      // Label 3467: @176371
      GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(176408), // Rule ID 2380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1978:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2380,
        GIR_EraseRootFromParent_Done,
      // Label 3468: @176408
      GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(176445), // Rule ID 2381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2381,
        GIR_EraseRootFromParent_Done,
      // Label 3469: @176445
      GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(176482), // Rule ID 2383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1898:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2383,
        GIR_EraseRootFromParent_Done,
      // Label 3470: @176482
      GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(176519), // Rule ID 2384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1899:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2384,
        GIR_EraseRootFromParent_Done,
      // Label 3471: @176519
      GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(176556), // Rule ID 2385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1900:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2385,
        GIR_EraseRootFromParent_Done,
      // Label 3472: @176556
      GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(176593), // Rule ID 2387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1903:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2387,
        GIR_EraseRootFromParent_Done,
      // Label 3473: @176593
      GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(176630), // Rule ID 2388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1904:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2388,
        GIR_EraseRootFromParent_Done,
      // Label 3474: @176630
      GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(176667), // Rule ID 2389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1905:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2389,
        GIR_EraseRootFromParent_Done,
      // Label 3475: @176667
      GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(176704), // Rule ID 2391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1742:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2391,
        GIR_EraseRootFromParent_Done,
      // Label 3476: @176704
      GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(176741), // Rule ID 2392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1743:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2392,
        GIR_EraseRootFromParent_Done,
      // Label 3477: @176741
      GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(176778), // Rule ID 2393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1744:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2393,
        GIR_EraseRootFromParent_Done,
      // Label 3478: @176778
      GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(176815), // Rule ID 2395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2395,
        GIR_EraseRootFromParent_Done,
      // Label 3479: @176815
      GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(176852), // Rule ID 2396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2396,
        GIR_EraseRootFromParent_Done,
      // Label 3480: @176852
      GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(176889), // Rule ID 2397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1749:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2397,
        GIR_EraseRootFromParent_Done,
      // Label 3481: @176889
      GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(176926), // Rule ID 2398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1367:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2398,
        GIR_EraseRootFromParent_Done,
      // Label 3482: @176926
      GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(176966), // Rule ID 2568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1446:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2568,
        GIR_EraseRootFromParent_Done,
      // Label 3483: @176966
      GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(177006), // Rule ID 2569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1454:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2569,
        GIR_EraseRootFromParent_Done,
      // Label 3484: @177006
      GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(177046), // Rule ID 2570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1454:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2570,
        GIR_EraseRootFromParent_Done,
      // Label 3485: @177046
      GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(177086), // Rule ID 2571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2571,
        GIR_EraseRootFromParent_Done,
      // Label 3486: @177086
      GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(177126), // Rule ID 2572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2572,
        GIR_EraseRootFromParent_Done,
      // Label 3487: @177126
      GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(177163), // Rule ID 2589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1634:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2589,
        GIR_EraseRootFromParent_Done,
      // Label 3488: @177163
      GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(177200), // Rule ID 2590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1634:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2590,
        GIR_EraseRootFromParent_Done,
      // Label 3489: @177200
      GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(177237), // Rule ID 2591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1634:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2591,
        GIR_EraseRootFromParent_Done,
      // Label 3490: @177237
      GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(177274), // Rule ID 2592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1182:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2592,
        GIR_EraseRootFromParent_Done,
      // Label 3491: @177274
      GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(177311), // Rule ID 2593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1182:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2593,
        GIR_EraseRootFromParent_Done,
      // Label 3492: @177311
      GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(177348), // Rule ID 2594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1182:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2594,
        GIR_EraseRootFromParent_Done,
      // Label 3493: @177348
      GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(177385), // Rule ID 2595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1182:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2595,
        GIR_EraseRootFromParent_Done,
      // Label 3494: @177385
      GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(177422), // Rule ID 2791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2791,
        GIR_EraseRootFromParent_Done,
      // Label 3495: @177422
      GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(177459), // Rule ID 2792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2792,
        GIR_EraseRootFromParent_Done,
      // Label 3496: @177459
      GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(177496), // Rule ID 2793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2793,
        GIR_EraseRootFromParent_Done,
      // Label 3497: @177496
      GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(177533), // Rule ID 2982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2982,
        GIR_EraseRootFromParent_Done,
      // Label 3498: @177533
      GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(177570), // Rule ID 2983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2983,
        GIR_EraseRootFromParent_Done,
      // Label 3499: @177570
      GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(177607), // Rule ID 2984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2984,
        GIR_EraseRootFromParent_Done,
      // Label 3500: @177607
      GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(177644), // Rule ID 2985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2985,
        GIR_EraseRootFromParent_Done,
      // Label 3501: @177644
      GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(177681), // Rule ID 2986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1451:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2986,
        GIR_EraseRootFromParent_Done,
      // Label 3502: @177681
      GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(177718), // Rule ID 3008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1509:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3008,
        GIR_EraseRootFromParent_Done,
      // Label 3503: @177718
      GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(177755), // Rule ID 3009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1509:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3009,
        GIR_EraseRootFromParent_Done,
      // Label 3504: @177755
      GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(177792), // Rule ID 3010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1509:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3010,
        GIR_EraseRootFromParent_Done,
      // Label 3505: @177792
      GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(177829), // Rule ID 3014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1452:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3014,
        GIR_EraseRootFromParent_Done,
      // Label 3506: @177829
      GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(177866), // Rule ID 3015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1452:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3015,
        GIR_EraseRootFromParent_Done,
      // Label 3507: @177866
      GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(177903), // Rule ID 3016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1452:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3016,
        GIR_EraseRootFromParent_Done,
      // Label 3508: @177903
      GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(177940), // Rule ID 3017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1120:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3017,
        GIR_EraseRootFromParent_Done,
      // Label 3509: @177940
      GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(177977), // Rule ID 3018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1120:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3018,
        GIR_EraseRootFromParent_Done,
      // Label 3510: @177977
      GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(178014), // Rule ID 3019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1120:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3019,
        GIR_EraseRootFromParent_Done,
      // Label 3511: @178014
      GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(178051), // Rule ID 3020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1120:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3020,
        GIR_EraseRootFromParent_Done,
      // Label 3512: @178051
      GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(178088), // Rule ID 3021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1510:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3021,
        GIR_EraseRootFromParent_Done,
      // Label 3513: @178088
      GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(178125), // Rule ID 3022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1510:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3022,
        GIR_EraseRootFromParent_Done,
      // Label 3514: @178125
      GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(178162), // Rule ID 3023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1510:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3023,
        GIR_EraseRootFromParent_Done,
      // Label 3515: @178162
      GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(178199), // Rule ID 3070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1097:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3070,
        GIR_EraseRootFromParent_Done,
      // Label 3516: @178199
      GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(178236), // Rule ID 3071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1097:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3071,
        GIR_EraseRootFromParent_Done,
      // Label 3517: @178236
      GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(178273), // Rule ID 3072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1097:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3072,
        GIR_EraseRootFromParent_Done,
      // Label 3518: @178273
      GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(178310), // Rule ID 3079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1673:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3079,
        GIR_EraseRootFromParent_Done,
      // Label 3519: @178310
      GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(178347), // Rule ID 3080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3080,
        GIR_EraseRootFromParent_Done,
      // Label 3520: @178347
      GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(178384), // Rule ID 3081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3081,
        GIR_EraseRootFromParent_Done,
      // Label 3521: @178384
      GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(178424), // Rule ID 3189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1953:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3189,
        GIR_EraseRootFromParent_Done,
      // Label 3522: @178424
      GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(178464), // Rule ID 3190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1953:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3190,
        GIR_EraseRootFromParent_Done,
      // Label 3523: @178464
      GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(178504), // Rule ID 3191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1953:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3191,
        GIR_EraseRootFromParent_Done,
      // Label 3524: @178504
      GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(178544), // Rule ID 3192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1953:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3192,
        GIR_EraseRootFromParent_Done,
      // Label 3525: @178544
      GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(178584), // Rule ID 3197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1953:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3197,
        GIR_EraseRootFromParent_Done,
      // Label 3526: @178584
      GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(178624), // Rule ID 3198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1953:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3198,
        GIR_EraseRootFromParent_Done,
      // Label 3527: @178624
      GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(178664), // Rule ID 3199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1953:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3199,
        GIR_EraseRootFromParent_Done,
      // Label 3528: @178664
      GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(178704), // Rule ID 3200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1953:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3200,
        GIR_EraseRootFromParent_Done,
      // Label 3529: @178704
      GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(178741), // Rule ID 3393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1188:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3393,
        GIR_EraseRootFromParent_Done,
      // Label 3530: @178741
      GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(178778), // Rule ID 3394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1188:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3394,
        GIR_EraseRootFromParent_Done,
      // Label 3531: @178778
      GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(178815), // Rule ID 3395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1188:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3395,
        GIR_EraseRootFromParent_Done,
      // Label 3532: @178815
      GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(178852), // Rule ID 3396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1188:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3396,
        GIR_EraseRootFromParent_Done,
      // Label 3533: @178852
      GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(178889), // Rule ID 3418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1365:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3418,
        GIR_EraseRootFromParent_Done,
      // Label 3534: @178889
      GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(178926), // Rule ID 3419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1365:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3419,
        GIR_EraseRootFromParent_Done,
      // Label 3535: @178926
      GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(178963), // Rule ID 3420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1365:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3420,
        GIR_EraseRootFromParent_Done,
      // Label 3536: @178963
      GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(179000), // Rule ID 3442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1141:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3442,
        GIR_EraseRootFromParent_Done,
      // Label 3537: @179000
      GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(179037), // Rule ID 3447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1545:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3447,
        GIR_EraseRootFromParent_Done,
      // Label 3538: @179037
      GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(179074), // Rule ID 3448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1106:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3448,
        GIR_EraseRootFromParent_Done,
      // Label 3539: @179074
      GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(179111), // Rule ID 3462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1975:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3462,
        GIR_EraseRootFromParent_Done,
      // Label 3540: @179111
      GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(179148), // Rule ID 3463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1975:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3463,
        GIR_EraseRootFromParent_Done,
      // Label 3541: @179148
      GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(179185), // Rule ID 3464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1975:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3464,
        GIR_EraseRootFromParent_Done,
      // Label 3542: @179185
      GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(179222), // Rule ID 3465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1975:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3465,
        GIR_EraseRootFromParent_Done,
      // Label 3543: @179222
      GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(179259), // Rule ID 3466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1975:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3466,
        GIR_EraseRootFromParent_Done,
      // Label 3544: @179259
      GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(179296), // Rule ID 3467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1975:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3467,
        GIR_EraseRootFromParent_Done,
      // Label 3545: @179296
      GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(179333), // Rule ID 3468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1975:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3468,
        GIR_EraseRootFromParent_Done,
      // Label 3546: @179333
      GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(179370), // Rule ID 3469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1975:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3469,
        GIR_EraseRootFromParent_Done,
      // Label 3547: @179370
      GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(179407), // Rule ID 3534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3534,
        GIR_EraseRootFromParent_Done,
      // Label 3548: @179407
      GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(179444), // Rule ID 3535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3535,
        GIR_EraseRootFromParent_Done,
      // Label 3549: @179444
      GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(179481), // Rule ID 3536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3536,
        GIR_EraseRootFromParent_Done,
      // Label 3550: @179481
      GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(179518), // Rule ID 3568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1439:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3568,
        GIR_EraseRootFromParent_Done,
      // Label 3551: @179518
      GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(179555), // Rule ID 3569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1439:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3569,
        GIR_EraseRootFromParent_Done,
      // Label 3552: @179555
      GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(179592), // Rule ID 3570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1439:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3570,
        GIR_EraseRootFromParent_Done,
      // Label 3553: @179592
      GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(179629), // Rule ID 3571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1439:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3571,
        GIR_EraseRootFromParent_Done,
      // Label 3554: @179629
      GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(179666), // Rule ID 3572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1983:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3572,
        GIR_EraseRootFromParent_Done,
      // Label 3555: @179666
      GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(179703), // Rule ID 3573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1983:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3573,
        GIR_EraseRootFromParent_Done,
      // Label 3556: @179703
      GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(179740), // Rule ID 3574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3574,
        GIR_EraseRootFromParent_Done,
      // Label 3557: @179740
      GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(179777), // Rule ID 3575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3575,
        GIR_EraseRootFromParent_Done,
      // Label 3558: @179777
      GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(179814), // Rule ID 3576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1983:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3576,
        GIR_EraseRootFromParent_Done,
      // Label 3559: @179814
      GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(179851), // Rule ID 3577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1983:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3577,
        GIR_EraseRootFromParent_Done,
      // Label 3560: @179851
      GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(179888), // Rule ID 3578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1983:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3578,
        GIR_EraseRootFromParent_Done,
      // Label 3561: @179888
      GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(179925), // Rule ID 3579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1983:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3579,
        GIR_EraseRootFromParent_Done,
      // Label 3562: @179925
      GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(179962), // Rule ID 3580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3580,
        GIR_EraseRootFromParent_Done,
      // Label 3563: @179962
      GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(179999), // Rule ID 3581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3581,
        GIR_EraseRootFromParent_Done,
      // Label 3564: @179999
      GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(180036), // Rule ID 3582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3582,
        GIR_EraseRootFromParent_Done,
      // Label 3565: @180036
      GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(180073), // Rule ID 3583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3583,
        GIR_EraseRootFromParent_Done,
      // Label 3566: @180073
      GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(180110), // Rule ID 3584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1738:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3584,
        GIR_EraseRootFromParent_Done,
      // Label 3567: @180110
      GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(180147), // Rule ID 3585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1738:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3585,
        GIR_EraseRootFromParent_Done,
      // Label 3568: @180147
      GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(180184), // Rule ID 3586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1738:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3586,
        GIR_EraseRootFromParent_Done,
      // Label 3569: @180184
      GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(180221), // Rule ID 3587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1738:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3587,
        GIR_EraseRootFromParent_Done,
      // Label 3570: @180221
      GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(180258), // Rule ID 8567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1143:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8567,
        GIR_EraseRootFromParent_Done,
      // Label 3571: @180258
      GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(180295), // Rule ID 9068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1101:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9068,
        GIR_EraseRootFromParent_Done,
      // Label 3572: @180295
      GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(180332), // Rule ID 9069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1103:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9069,
        GIR_EraseRootFromParent_Done,
      // Label 3573: @180332
      GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(180369), // Rule ID 9070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1104:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9070,
        GIR_EraseRootFromParent_Done,
      // Label 3574: @180369
      GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(180406), // Rule ID 9071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1102:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9071,
        GIR_EraseRootFromParent_Done,
      // Label 3575: @180406
      GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(180443), // Rule ID 9072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1101:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9072,
        GIR_EraseRootFromParent_Done,
      // Label 3576: @180443
      GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(180480), // Rule ID 9073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1103:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9073,
        GIR_EraseRootFromParent_Done,
      // Label 3577: @180480
      GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(180517), // Rule ID 9074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1104:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9074,
        GIR_EraseRootFromParent_Done,
      // Label 3578: @180517
      GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(180554), // Rule ID 9075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1102:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9075,
        GIR_EraseRootFromParent_Done,
      // Label 3579: @180554
      GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(180594), // Rule ID 10105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1935:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10105,
        GIR_EraseRootFromParent_Done,
      // Label 3580: @180594
      GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(180634), // Rule ID 10106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1935:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10106,
        GIR_EraseRootFromParent_Done,
      // Label 3581: @180634
      GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(180674), // Rule ID 10107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1935:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10107,
        GIR_EraseRootFromParent_Done,
      // Label 3582: @180674
      GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(180714), // Rule ID 10108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1935:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10108,
        GIR_EraseRootFromParent_Done,
      // Label 3583: @180714
      GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(180754), // Rule ID 10109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1941:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10109,
        GIR_EraseRootFromParent_Done,
      // Label 3584: @180754
      GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(180794), // Rule ID 10110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1941:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10110,
        GIR_EraseRootFromParent_Done,
      // Label 3585: @180794
      GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(180834), // Rule ID 10111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1941:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10111,
        GIR_EraseRootFromParent_Done,
      // Label 3586: @180834
      GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(180874), // Rule ID 10112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1941:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10112,
        GIR_EraseRootFromParent_Done,
      // Label 3587: @180874
      GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(180914), // Rule ID 10117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1947:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10117,
        GIR_EraseRootFromParent_Done,
      // Label 3588: @180914
      GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(180954), // Rule ID 10118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1947:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10118,
        GIR_EraseRootFromParent_Done,
      // Label 3589: @180954
      GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(180994), // Rule ID 10119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1947:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10119,
        GIR_EraseRootFromParent_Done,
      // Label 3590: @180994
      GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(181034), // Rule ID 10120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1947:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10120,
        GIR_EraseRootFromParent_Done,
      // Label 3591: @181034
      GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(181074), // Rule ID 10121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1935:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10121,
        GIR_EraseRootFromParent_Done,
      // Label 3592: @181074
      GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(181114), // Rule ID 10122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1935:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10122,
        GIR_EraseRootFromParent_Done,
      // Label 3593: @181114
      GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(181154), // Rule ID 10123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1935:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10123,
        GIR_EraseRootFromParent_Done,
      // Label 3594: @181154
      GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(181194), // Rule ID 10124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1935:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10124,
        GIR_EraseRootFromParent_Done,
      // Label 3595: @181194
      GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(181234), // Rule ID 10125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1941:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10125,
        GIR_EraseRootFromParent_Done,
      // Label 3596: @181234
      GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(181274), // Rule ID 10126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1941:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10126,
        GIR_EraseRootFromParent_Done,
      // Label 3597: @181274
      GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(181314), // Rule ID 10127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1941:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10127,
        GIR_EraseRootFromParent_Done,
      // Label 3598: @181314
      GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(181354), // Rule ID 10128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1941:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10128,
        GIR_EraseRootFromParent_Done,
      // Label 3599: @181354
      GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(181394), // Rule ID 10133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1947:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10133,
        GIR_EraseRootFromParent_Done,
      // Label 3600: @181394
      GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(181434), // Rule ID 10134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1947:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10134,
        GIR_EraseRootFromParent_Done,
      // Label 3601: @181434
      GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(181474), // Rule ID 10135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1947:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10135,
        GIR_EraseRootFromParent_Done,
      // Label 3602: @181474
      GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(181514), // Rule ID 10136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1947:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10136,
        GIR_EraseRootFromParent_Done,
      // Label 3603: @181514
      GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(181551), // Rule ID 10295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10295,
        GIR_EraseRootFromParent_Done,
      // Label 3604: @181551
      GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(181588), // Rule ID 10296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10296,
        GIR_EraseRootFromParent_Done,
      // Label 3605: @181588
      GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(181625), // Rule ID 10297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10297,
        GIR_EraseRootFromParent_Done,
      // Label 3606: @181625
      GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(181662), // Rule ID 10298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10298,
        GIR_EraseRootFromParent_Done,
      // Label 3607: @181662
      GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(181699), // Rule ID 10299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10299,
        GIR_EraseRootFromParent_Done,
      // Label 3608: @181699
      GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(181736), // Rule ID 10300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10300,
        GIR_EraseRootFromParent_Done,
      // Label 3609: @181736
      GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(181773), // Rule ID 10301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10301,
        GIR_EraseRootFromParent_Done,
      // Label 3610: @181773
      GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(181810), // Rule ID 10302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10302,
        GIR_EraseRootFromParent_Done,
      // Label 3611: @181810
      GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(181847), // Rule ID 10303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10303,
        GIR_EraseRootFromParent_Done,
      // Label 3612: @181847
      GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(181884), // Rule ID 11557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1980:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11557,
        GIR_EraseRootFromParent_Done,
      // Label 3613: @181884
      GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(181921), // Rule ID 11558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1980:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11558,
        GIR_EraseRootFromParent_Done,
      // Label 3614: @181921
      GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(181958), // Rule ID 11559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1980:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11559,
        GIR_EraseRootFromParent_Done,
      // Label 3615: @181958
      GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(181995), // Rule ID 11560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1980:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11560,
        GIR_EraseRootFromParent_Done,
      // Label 3616: @181995
      GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(182032), // Rule ID 11561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1980:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11561,
        GIR_EraseRootFromParent_Done,
      // Label 3617: @182032
      GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(182069), // Rule ID 11562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1980:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11562,
        GIR_EraseRootFromParent_Done,
      // Label 3618: @182069
      GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(182106), // Rule ID 11563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1980:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11563,
        GIR_EraseRootFromParent_Done,
      // Label 3619: @182106
      GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(182143), // Rule ID 11564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1980:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11564,
        GIR_EraseRootFromParent_Done,
      // Label 3620: @182143
      GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(182180), // Rule ID 11565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1901:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11565,
        GIR_EraseRootFromParent_Done,
      // Label 3621: @182180
      GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(182217), // Rule ID 11566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1901:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11566,
        GIR_EraseRootFromParent_Done,
      // Label 3622: @182217
      GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(182254), // Rule ID 11567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1901:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11567,
        GIR_EraseRootFromParent_Done,
      // Label 3623: @182254
      GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(182291), // Rule ID 11568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1901:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11568,
        GIR_EraseRootFromParent_Done,
      // Label 3624: @182291
      GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(182328), // Rule ID 11569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1901:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11569,
        GIR_EraseRootFromParent_Done,
      // Label 3625: @182328
      GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(182365), // Rule ID 11570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1901:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11570,
        GIR_EraseRootFromParent_Done,
      // Label 3626: @182365
      GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(182402), // Rule ID 11571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1901:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11571,
        GIR_EraseRootFromParent_Done,
      // Label 3627: @182402
      GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(182439), // Rule ID 11572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1901:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11572,
        GIR_EraseRootFromParent_Done,
      // Label 3628: @182439
      GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(182476), // Rule ID 11573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1906:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11573,
        GIR_EraseRootFromParent_Done,
      // Label 3629: @182476
      GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(182513), // Rule ID 11574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1906:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11574,
        GIR_EraseRootFromParent_Done,
      // Label 3630: @182513
      GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(182550), // Rule ID 11575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1906:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11575,
        GIR_EraseRootFromParent_Done,
      // Label 3631: @182550
      GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(182587), // Rule ID 11576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11576,
        GIR_EraseRootFromParent_Done,
      // Label 3632: @182587
      GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(182624), // Rule ID 11577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1906:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11577,
        GIR_EraseRootFromParent_Done,
      // Label 3633: @182624
      GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(182661), // Rule ID 11578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1906:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11578,
        GIR_EraseRootFromParent_Done,
      // Label 3634: @182661
      GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(182698), // Rule ID 11579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1906:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11579,
        GIR_EraseRootFromParent_Done,
      // Label 3635: @182698
      GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(182735), // Rule ID 11580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1906:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11580,
        GIR_EraseRootFromParent_Done,
      // Label 3636: @182735
      GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(182772), // Rule ID 11581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11581,
        GIR_EraseRootFromParent_Done,
      // Label 3637: @182772
      GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(182809), // Rule ID 11582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11582,
        GIR_EraseRootFromParent_Done,
      // Label 3638: @182809
      GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(182846), // Rule ID 11583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1745:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11583,
        GIR_EraseRootFromParent_Done,
      // Label 3639: @182846
      GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(182883), // Rule ID 11584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11584,
        GIR_EraseRootFromParent_Done,
      // Label 3640: @182883
      GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(182920), // Rule ID 11585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1745:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11585,
        GIR_EraseRootFromParent_Done,
      // Label 3641: @182920
      GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(182957), // Rule ID 11586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11586,
        GIR_EraseRootFromParent_Done,
      // Label 3642: @182957
      GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(182994), // Rule ID 11587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1745:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11587,
        GIR_EraseRootFromParent_Done,
      // Label 3643: @182994
      GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(183031), // Rule ID 11588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1745:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11588,
        GIR_EraseRootFromParent_Done,
      // Label 3644: @183031
      GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(183068), // Rule ID 11589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11589,
        GIR_EraseRootFromParent_Done,
      // Label 3645: @183068
      GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(183105), // Rule ID 11590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11590,
        GIR_EraseRootFromParent_Done,
      // Label 3646: @183105
      GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(183142), // Rule ID 11591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1750:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11591,
        GIR_EraseRootFromParent_Done,
      // Label 3647: @183142
      GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(183179), // Rule ID 11592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11592,
        GIR_EraseRootFromParent_Done,
      // Label 3648: @183179
      GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(183216), // Rule ID 11593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1750:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11593,
        GIR_EraseRootFromParent_Done,
      // Label 3649: @183216
      GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(183253), // Rule ID 11594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11594,
        GIR_EraseRootFromParent_Done,
      // Label 3650: @183253
      GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(183290), // Rule ID 11595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1750:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11595,
        GIR_EraseRootFromParent_Done,
      // Label 3651: @183290
      GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(183327), // Rule ID 11596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1750:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11596,
        GIR_EraseRootFromParent_Done,
      // Label 3652: @183327
      GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(183364), // Rule ID 11616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1647:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11616,
        GIR_EraseRootFromParent_Done,
      // Label 3653: @183364
      GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(183401), // Rule ID 11617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1647:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11617,
        GIR_EraseRootFromParent_Done,
      // Label 3654: @183401
      GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(183438), // Rule ID 11618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1647:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11618,
        GIR_EraseRootFromParent_Done,
      // Label 3655: @183438
      GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(183475), // Rule ID 11619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1647:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11619,
        GIR_EraseRootFromParent_Done,
      // Label 3656: @183475
      GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(183512), // Rule ID 11907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1511:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11907,
        GIR_EraseRootFromParent_Done,
      // Label 3657: @183512
      GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(183549), // Rule ID 11908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1511:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11908,
        GIR_EraseRootFromParent_Done,
      // Label 3658: @183549
      GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(183586), // Rule ID 11909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1511:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11909,
        GIR_EraseRootFromParent_Done,
      // Label 3659: @183586
      GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(183623), // Rule ID 11910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11910,
        GIR_EraseRootFromParent_Done,
      // Label 3660: @183623
      GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(183660), // Rule ID 11911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11911,
        GIR_EraseRootFromParent_Done,
      // Label 3661: @183660
      GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(183697), // Rule ID 11912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11912,
        GIR_EraseRootFromParent_Done,
      // Label 3662: @183697
      GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(183734), // Rule ID 11913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11913,
        GIR_EraseRootFromParent_Done,
      // Label 3663: @183734
      GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(183771), // Rule ID 11914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11914,
        GIR_EraseRootFromParent_Done,
      // Label 3664: @183771
      GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(183808), // Rule ID 11915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11915,
        GIR_EraseRootFromParent_Done,
      // Label 3665: @183808
      GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(183845), // Rule ID 11916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11916,
        GIR_EraseRootFromParent_Done,
      // Label 3666: @183845
      GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(183882), // Rule ID 11917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11917,
        GIR_EraseRootFromParent_Done,
      // Label 3667: @183882
      GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(183919), // Rule ID 11918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11918,
        GIR_EraseRootFromParent_Done,
      // Label 3668: @183919
      GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(183956), // Rule ID 11919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11919,
        GIR_EraseRootFromParent_Done,
      // Label 3669: @183956
      GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(183993), // Rule ID 11920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11920,
        GIR_EraseRootFromParent_Done,
      // Label 3670: @183993
      GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(184030), // Rule ID 11921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11921,
        GIR_EraseRootFromParent_Done,
      // Label 3671: @184030
      GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(184067), // Rule ID 11922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1884:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11922,
        GIR_EraseRootFromParent_Done,
      // Label 3672: @184067
      GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(184104), // Rule ID 11923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1884:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11923,
        GIR_EraseRootFromParent_Done,
      // Label 3673: @184104
      GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(184141), // Rule ID 11924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1884:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11924,
        GIR_EraseRootFromParent_Done,
      // Label 3674: @184141
      GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(184178), // Rule ID 11925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1885:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11925,
        GIR_EraseRootFromParent_Done,
      // Label 3675: @184178
      GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(184215), // Rule ID 11926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1885:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11926,
        GIR_EraseRootFromParent_Done,
      // Label 3676: @184215
      GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(184252), // Rule ID 11927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1885:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11927,
        GIR_EraseRootFromParent_Done,
      // Label 3677: @184252
      GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(184289), // Rule ID 11928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1506:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11928,
        GIR_EraseRootFromParent_Done,
      // Label 3678: @184289
      GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(184326), // Rule ID 11929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1506:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11929,
        GIR_EraseRootFromParent_Done,
      // Label 3679: @184326
      GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(184363), // Rule ID 11930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1506:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11930,
        GIR_EraseRootFromParent_Done,
      // Label 3680: @184363
      GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(184400), // Rule ID 11931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1507:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11931,
        GIR_EraseRootFromParent_Done,
      // Label 3681: @184400
      GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(184437), // Rule ID 11932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1507:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11932,
        GIR_EraseRootFromParent_Done,
      // Label 3682: @184437
      GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(184474), // Rule ID 11933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1507:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11933,
        GIR_EraseRootFromParent_Done,
      // Label 3683: @184474
      GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(184511), // Rule ID 11934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11934,
        GIR_EraseRootFromParent_Done,
      // Label 3684: @184511
      GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(184548), // Rule ID 11935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11935,
        GIR_EraseRootFromParent_Done,
      // Label 3685: @184548
      GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(184585), // Rule ID 11936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11936,
        GIR_EraseRootFromParent_Done,
      // Label 3686: @184585
      GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(184622), // Rule ID 11937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11937,
        GIR_EraseRootFromParent_Done,
      // Label 3687: @184622
      GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(184659), // Rule ID 11938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11938,
        GIR_EraseRootFromParent_Done,
      // Label 3688: @184659
      GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(184696), // Rule ID 11939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11939,
        GIR_EraseRootFromParent_Done,
      // Label 3689: @184696
      GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(184733), // Rule ID 11949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11949,
        GIR_EraseRootFromParent_Done,
      // Label 3690: @184733
      GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(184770), // Rule ID 11950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11950,
        GIR_EraseRootFromParent_Done,
      // Label 3691: @184770
      GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(184807), // Rule ID 11951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11951,
        GIR_EraseRootFromParent_Done,
      // Label 3692: @184807
      GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(184844), // Rule ID 11952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11952,
        GIR_EraseRootFromParent_Done,
      // Label 3693: @184844
      GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(184881), // Rule ID 11953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11953,
        GIR_EraseRootFromParent_Done,
      // Label 3694: @184881
      GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(184918), // Rule ID 11954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11954,
        GIR_EraseRootFromParent_Done,
      // Label 3695: @184918
      GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(184955), // Rule ID 11955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1886:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11955,
        GIR_EraseRootFromParent_Done,
      // Label 3696: @184955
      GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(184992), // Rule ID 11956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1886:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11956,
        GIR_EraseRootFromParent_Done,
      // Label 3697: @184992
      GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(185029), // Rule ID 11957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1886:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11957,
        GIR_EraseRootFromParent_Done,
      // Label 3698: @185029
      GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(185066), // Rule ID 11958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1887:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11958,
        GIR_EraseRootFromParent_Done,
      // Label 3699: @185066
      GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(185103), // Rule ID 11959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1887:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11959,
        GIR_EraseRootFromParent_Done,
      // Label 3700: @185103
      GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(185140), // Rule ID 11960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1887:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11960,
        GIR_EraseRootFromParent_Done,
      // Label 3701: @185140
      GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(185177), // Rule ID 11961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1622:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11961,
        GIR_EraseRootFromParent_Done,
      // Label 3702: @185177
      GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(185214), // Rule ID 11962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1622:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11962,
        GIR_EraseRootFromParent_Done,
      // Label 3703: @185214
      GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(185251), // Rule ID 11963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1622:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11963,
        GIR_EraseRootFromParent_Done,
      // Label 3704: @185251
      GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(185288), // Rule ID 11964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1624:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11964,
        GIR_EraseRootFromParent_Done,
      // Label 3705: @185288
      GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(185325), // Rule ID 11965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11965,
        GIR_EraseRootFromParent_Done,
      // Label 3706: @185325
      GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(185362), // Rule ID 11966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11966,
        GIR_EraseRootFromParent_Done,
      // Label 3707: @185362
      GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(185399), // Rule ID 11967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1575:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11967,
        GIR_EraseRootFromParent_Done,
      // Label 3708: @185399
      GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(185436), // Rule ID 11968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1575:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11968,
        GIR_EraseRootFromParent_Done,
      // Label 3709: @185436
      GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(185473), // Rule ID 11969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1575:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11969,
        GIR_EraseRootFromParent_Done,
      // Label 3710: @185473
      GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(185510), // Rule ID 11970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1577:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11970,
        GIR_EraseRootFromParent_Done,
      // Label 3711: @185510
      GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(185547), // Rule ID 11971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1577:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11971,
        GIR_EraseRootFromParent_Done,
      // Label 3712: @185547
      GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(185584), // Rule ID 11972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1577:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11972,
        GIR_EraseRootFromParent_Done,
      // Label 3713: @185584
      GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(185621), // Rule ID 11973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11973,
        GIR_EraseRootFromParent_Done,
      // Label 3714: @185621
      GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(185658), // Rule ID 11974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11974,
        GIR_EraseRootFromParent_Done,
      // Label 3715: @185658
      GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(185695), // Rule ID 11975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11975,
        GIR_EraseRootFromParent_Done,
      // Label 3716: @185695
      GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(185732), // Rule ID 11976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1815:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11976,
        GIR_EraseRootFromParent_Done,
      // Label 3717: @185732
      GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(185769), // Rule ID 11977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1815:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11977,
        GIR_EraseRootFromParent_Done,
      // Label 3718: @185769
      GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(185806), // Rule ID 11978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1815:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11978,
        GIR_EraseRootFromParent_Done,
      // Label 3719: @185806
      GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(185843), // Rule ID 11979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1453:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11979,
        GIR_EraseRootFromParent_Done,
      // Label 3720: @185843
      GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(185880), // Rule ID 11980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1453:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11980,
        GIR_EraseRootFromParent_Done,
      // Label 3721: @185880
      GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(185917), // Rule ID 12081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1483:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12081,
        GIR_EraseRootFromParent_Done,
      // Label 3722: @185917
      GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(185954), // Rule ID 12082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1483:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12082,
        GIR_EraseRootFromParent_Done,
      // Label 3723: @185954
      GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(185991), // Rule ID 12083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1483:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12083,
        GIR_EraseRootFromParent_Done,
      // Label 3724: @185991
      GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(186028), // Rule ID 12084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1724:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12084,
        GIR_EraseRootFromParent_Done,
      // Label 3725: @186028
      GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(186065), // Rule ID 12085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12085,
        GIR_EraseRootFromParent_Done,
      // Label 3726: @186065
      GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(186102), // Rule ID 12086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12086,
        GIR_EraseRootFromParent_Done,
      // Label 3727: @186102
      GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(186139), // Rule ID 12087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1499:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12087,
        GIR_EraseRootFromParent_Done,
      // Label 3728: @186139
      GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(186176), // Rule ID 12088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1499:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12088,
        GIR_EraseRootFromParent_Done,
      // Label 3729: @186176
      GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(186213), // Rule ID 12089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1499:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12089,
        GIR_EraseRootFromParent_Done,
      // Label 3730: @186213
      GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(186250), // Rule ID 12105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12105,
        GIR_EraseRootFromParent_Done,
      // Label 3731: @186250
      GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(186287), // Rule ID 12106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12106,
        GIR_EraseRootFromParent_Done,
      // Label 3732: @186287
      GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(186324), // Rule ID 12107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12107,
        GIR_EraseRootFromParent_Done,
      // Label 3733: @186324
      GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(186361), // Rule ID 12108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1675:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12108,
        GIR_EraseRootFromParent_Done,
      // Label 3734: @186361
      GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(186398), // Rule ID 12109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1675:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12109,
        GIR_EraseRootFromParent_Done,
      // Label 3735: @186398
      GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(186435), // Rule ID 12110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1675:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12110,
        GIR_EraseRootFromParent_Done,
      // Label 3736: @186435
      GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(186472), // Rule ID 12126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12126,
        GIR_EraseRootFromParent_Done,
      // Label 3737: @186472
      GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(186509), // Rule ID 12127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12127,
        GIR_EraseRootFromParent_Done,
      // Label 3738: @186509
      GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(186546), // Rule ID 12128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12128,
        GIR_EraseRootFromParent_Done,
      // Label 3739: @186546
      GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(186583), // Rule ID 12129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12129,
        GIR_EraseRootFromParent_Done,
      // Label 3740: @186583
      GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(186620), // Rule ID 12130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12130,
        GIR_EraseRootFromParent_Done,
      // Label 3741: @186620
      GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(186657), // Rule ID 12131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12131,
        GIR_EraseRootFromParent_Done,
      // Label 3742: @186657
      GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(186697), // Rule ID 12209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1911:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12209,
        GIR_EraseRootFromParent_Done,
      // Label 3743: @186697
      GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(186737), // Rule ID 12210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1911:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12210,
        GIR_EraseRootFromParent_Done,
      // Label 3744: @186737
      GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(186777), // Rule ID 12211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1911:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12211,
        GIR_EraseRootFromParent_Done,
      // Label 3745: @186777
      GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(186817), // Rule ID 12212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1911:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12212,
        GIR_EraseRootFromParent_Done,
      // Label 3746: @186817
      GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(186857), // Rule ID 12213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1917:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12213,
        GIR_EraseRootFromParent_Done,
      // Label 3747: @186857
      GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(186897), // Rule ID 12214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1917:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12214,
        GIR_EraseRootFromParent_Done,
      // Label 3748: @186897
      GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(186937), // Rule ID 12215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1917:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12215,
        GIR_EraseRootFromParent_Done,
      // Label 3749: @186937
      GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(186977), // Rule ID 12216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1917:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12216,
        GIR_EraseRootFromParent_Done,
      // Label 3750: @186977
      GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(187017), // Rule ID 12221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1929:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12221,
        GIR_EraseRootFromParent_Done,
      // Label 3751: @187017
      GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(187057), // Rule ID 12222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1929:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12222,
        GIR_EraseRootFromParent_Done,
      // Label 3752: @187057
      GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(187097), // Rule ID 12223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1929:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12223,
        GIR_EraseRootFromParent_Done,
      // Label 3753: @187097
      GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(187137), // Rule ID 12224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1929:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12224,
        GIR_EraseRootFromParent_Done,
      // Label 3754: @187137
      GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(187177), // Rule ID 12225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12225,
        GIR_EraseRootFromParent_Done,
      // Label 3755: @187177
      GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(187217), // Rule ID 12226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1923:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12226,
        GIR_EraseRootFromParent_Done,
      // Label 3756: @187217
      GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(187257), // Rule ID 12227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1923:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12227,
        GIR_EraseRootFromParent_Done,
      // Label 3757: @187257
      GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(187297), // Rule ID 12228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1923:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12228,
        GIR_EraseRootFromParent_Done,
      // Label 3758: @187297
      GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(187337), // Rule ID 12233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1911:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12233,
        GIR_EraseRootFromParent_Done,
      // Label 3759: @187337
      GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(187377), // Rule ID 12234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1911:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12234,
        GIR_EraseRootFromParent_Done,
      // Label 3760: @187377
      GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(187417), // Rule ID 12235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1911:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12235,
        GIR_EraseRootFromParent_Done,
      // Label 3761: @187417
      GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(187457), // Rule ID 12236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1911:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12236,
        GIR_EraseRootFromParent_Done,
      // Label 3762: @187457
      GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(187497), // Rule ID 12237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1917:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12237,
        GIR_EraseRootFromParent_Done,
      // Label 3763: @187497
      GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(187537), // Rule ID 12238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1917:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12238,
        GIR_EraseRootFromParent_Done,
      // Label 3764: @187537
      GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(187577), // Rule ID 12239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1917:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12239,
        GIR_EraseRootFromParent_Done,
      // Label 3765: @187577
      GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(187617), // Rule ID 12240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1917:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12240,
        GIR_EraseRootFromParent_Done,
      // Label 3766: @187617
      GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(187657), // Rule ID 12245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1929:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12245,
        GIR_EraseRootFromParent_Done,
      // Label 3767: @187657
      GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(187697), // Rule ID 12246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1929:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12246,
        GIR_EraseRootFromParent_Done,
      // Label 3768: @187697
      GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(187737), // Rule ID 12247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1929:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12247,
        GIR_EraseRootFromParent_Done,
      // Label 3769: @187737
      GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(187777), // Rule ID 12248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1929:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12248,
        GIR_EraseRootFromParent_Done,
      // Label 3770: @187777
      GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(187817), // Rule ID 12249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12249,
        GIR_EraseRootFromParent_Done,
      // Label 3771: @187817
      GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(187857), // Rule ID 12250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1923:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12250,
        GIR_EraseRootFromParent_Done,
      // Label 3772: @187857
      GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(187897), // Rule ID 12251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1923:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12251,
        GIR_EraseRootFromParent_Done,
      // Label 3773: @187897
      GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(187937), // Rule ID 12252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1923:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12252,
        GIR_EraseRootFromParent_Done,
      // Label 3774: @187937
      GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(187974), // Rule ID 12261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1105:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12261,
        GIR_EraseRootFromParent_Done,
      // Label 3775: @187974
      GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(188011), // Rule ID 12263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1453:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12263,
        GIR_EraseRootFromParent_Done,
      // Label 3776: @188011
      GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(188048), // Rule ID 12264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1544:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12264,
        GIR_EraseRootFromParent_Done,
      // Label 3777: @188048
      GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(188085), // Rule ID 12265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1485:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12265,
        GIR_EraseRootFromParent_Done,
      // Label 3778: @188085
      GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(188122), // Rule ID 12266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1119:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12266,
        GIR_EraseRootFromParent_Done,
      // Label 3779: @188122
      GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(188159), // Rule ID 12267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1119:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12267,
        GIR_EraseRootFromParent_Done,
      // Label 3780: @188159
      GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(188196), // Rule ID 12268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1119:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12268,
        GIR_EraseRootFromParent_Done,
      // Label 3781: @188196
      GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(188233), // Rule ID 12269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1119:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12269,
        GIR_EraseRootFromParent_Done,
      // Label 3782: @188233
      GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(188270), // Rule ID 12270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1136:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12270,
        GIR_EraseRootFromParent_Done,
      // Label 3783: @188270
      GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(188307), // Rule ID 12271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1136:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12271,
        GIR_EraseRootFromParent_Done,
      // Label 3784: @188307
      GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(188344), // Rule ID 12272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1136:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12272,
        GIR_EraseRootFromParent_Done,
      // Label 3785: @188344
      GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(188381), // Rule ID 12273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1136:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12273,
        GIR_EraseRootFromParent_Done,
      // Label 3786: @188381
      GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(188418), // Rule ID 12451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1285:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12451,
        GIR_EraseRootFromParent_Done,
      // Label 3787: @188418
      GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(188455), // Rule ID 12452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1285:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12452,
        GIR_EraseRootFromParent_Done,
      // Label 3788: @188455
      GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(188492), // Rule ID 12453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1285:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12453,
        GIR_EraseRootFromParent_Done,
      // Label 3789: @188492
      GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(188529), // Rule ID 12454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1303:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12454,
        GIR_EraseRootFromParent_Done,
      // Label 3790: @188529
      GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(188566), // Rule ID 12455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1303:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12455,
        GIR_EraseRootFromParent_Done,
      // Label 3791: @188566
      GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(188603), // Rule ID 12456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1303:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12456,
        GIR_EraseRootFromParent_Done,
      // Label 3792: @188603
      GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(188640), // Rule ID 12457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1288:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12457,
        GIR_EraseRootFromParent_Done,
      // Label 3793: @188640
      GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(188677), // Rule ID 12458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1288:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12458,
        GIR_EraseRootFromParent_Done,
      // Label 3794: @188677
      GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(188714), // Rule ID 12459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1288:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12459,
        GIR_EraseRootFromParent_Done,
      // Label 3795: @188714
      GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(188751), // Rule ID 12460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12460,
        GIR_EraseRootFromParent_Done,
      // Label 3796: @188751
      GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(188788), // Rule ID 12461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12461,
        GIR_EraseRootFromParent_Done,
      // Label 3797: @188788
      GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(188825), // Rule ID 12462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12462,
        GIR_EraseRootFromParent_Done,
      // Label 3798: @188825
      GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(188862), // Rule ID 12463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1200:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12463,
        GIR_EraseRootFromParent_Done,
      // Label 3799: @188862
      GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(188899), // Rule ID 12464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1200:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12464,
        GIR_EraseRootFromParent_Done,
      // Label 3800: @188899
      GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(188936), // Rule ID 12465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1200:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12465,
        GIR_EraseRootFromParent_Done,
      // Label 3801: @188936
      GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(188973), // Rule ID 12466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1200:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12466,
        GIR_EraseRootFromParent_Done,
      // Label 3802: @188973
      GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(189010), // Rule ID 12467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1112:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12467,
        GIR_EraseRootFromParent_Done,
      // Label 3803: @189010
      GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(189047), // Rule ID 12468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1112:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12468,
        GIR_EraseRootFromParent_Done,
      // Label 3804: @189047
      GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(189084), // Rule ID 12469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1112:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12469,
        GIR_EraseRootFromParent_Done,
      // Label 3805: @189084
      GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(189121), // Rule ID 12470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1112:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12470,
        GIR_EraseRootFromParent_Done,
      // Label 3806: @189121
      GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(189158), // Rule ID 12471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1100:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12471,
        GIR_EraseRootFromParent_Done,
      // Label 3807: @189158
      GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(189195), // Rule ID 12472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1100:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12472,
        GIR_EraseRootFromParent_Done,
      // Label 3808: @189195
      GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(189232), // Rule ID 12473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1100:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12473,
        GIR_EraseRootFromParent_Done,
      // Label 3809: @189232
      GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(189269), // Rule ID 12474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1100:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12474,
        GIR_EraseRootFromParent_Done,
      // Label 3810: @189269
      GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(189306), // Rule ID 12475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1553:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12475,
        GIR_EraseRootFromParent_Done,
      // Label 3811: @189306
      GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(189343), // Rule ID 12476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1553:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12476,
        GIR_EraseRootFromParent_Done,
      // Label 3812: @189343
      GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(189380), // Rule ID 12477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1553:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12477,
        GIR_EraseRootFromParent_Done,
      // Label 3813: @189380
      GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(189417), // Rule ID 12478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1553:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12478,
        GIR_EraseRootFromParent_Done,
      // Label 3814: @189417
      GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(189454), // Rule ID 12479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1791:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12479,
        GIR_EraseRootFromParent_Done,
      // Label 3815: @189454
      GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(189491), // Rule ID 12480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1791:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12480,
        GIR_EraseRootFromParent_Done,
      // Label 3816: @189491
      GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(189528), // Rule ID 12481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1791:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12481,
        GIR_EraseRootFromParent_Done,
      // Label 3817: @189528
      GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(189565), // Rule ID 12482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1791:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12482,
        GIR_EraseRootFromParent_Done,
      // Label 3818: @189565
      GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(189602), // Rule ID 12483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1562:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12483,
        GIR_EraseRootFromParent_Done,
      // Label 3819: @189602
      GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(189639), // Rule ID 12484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1562:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12484,
        GIR_EraseRootFromParent_Done,
      // Label 3820: @189639
      GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(189676), // Rule ID 12485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1562:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12485,
        GIR_EraseRootFromParent_Done,
      // Label 3821: @189676
      GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(189713), // Rule ID 12486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1562:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12486,
        GIR_EraseRootFromParent_Done,
      // Label 3822: @189713
      GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(189750), // Rule ID 12487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1800:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12487,
        GIR_EraseRootFromParent_Done,
      // Label 3823: @189750
      GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(189787), // Rule ID 12488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1800:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12488,
        GIR_EraseRootFromParent_Done,
      // Label 3824: @189787
      GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(189824), // Rule ID 12489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1800:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12489,
        GIR_EraseRootFromParent_Done,
      // Label 3825: @189824
      GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(189861), // Rule ID 12490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1800:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12490,
        GIR_EraseRootFromParent_Done,
      // Label 3826: @189861
      GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(189898), // Rule ID 12491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1984:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12491,
        GIR_EraseRootFromParent_Done,
      // Label 3827: @189898
      GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(189935), // Rule ID 12492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1984:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12492,
        GIR_EraseRootFromParent_Done,
      // Label 3828: @189935
      GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(189972), // Rule ID 12493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12493,
        GIR_EraseRootFromParent_Done,
      // Label 3829: @189972
      GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(190009), // Rule ID 12494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12494,
        GIR_EraseRootFromParent_Done,
      // Label 3830: @190009
      GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(190046), // Rule ID 12495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1984:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12495,
        GIR_EraseRootFromParent_Done,
      // Label 3831: @190046
      GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(190083), // Rule ID 12496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1984:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12496,
        GIR_EraseRootFromParent_Done,
      // Label 3832: @190083
      GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(190120), // Rule ID 12497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1984:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12497,
        GIR_EraseRootFromParent_Done,
      // Label 3833: @190120
      GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(190157), // Rule ID 12498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1984:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12498,
        GIR_EraseRootFromParent_Done,
      // Label 3834: @190157
      GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(190194), // Rule ID 12499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1909:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12499,
        GIR_EraseRootFromParent_Done,
      // Label 3835: @190194
      GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(190231), // Rule ID 12500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1909:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12500,
        GIR_EraseRootFromParent_Done,
      // Label 3836: @190231
      GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(190268), // Rule ID 12501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1909:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12501,
        GIR_EraseRootFromParent_Done,
      // Label 3837: @190268
      GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(190305), // Rule ID 12502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1909:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12502,
        GIR_EraseRootFromParent_Done,
      // Label 3838: @190305
      GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(190342), // Rule ID 12503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1909:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12503,
        GIR_EraseRootFromParent_Done,
      // Label 3839: @190342
      GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(190379), // Rule ID 12504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1909:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12504,
        GIR_EraseRootFromParent_Done,
      // Label 3840: @190379
      GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(190416), // Rule ID 12505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1909:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12505,
        GIR_EraseRootFromParent_Done,
      // Label 3841: @190416
      GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(190453), // Rule ID 12506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1909:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12506,
        GIR_EraseRootFromParent_Done,
      // Label 3842: @190453
      GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(190490), // Rule ID 12507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12507,
        GIR_EraseRootFromParent_Done,
      // Label 3843: @190490
      GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(190527), // Rule ID 12508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12508,
        GIR_EraseRootFromParent_Done,
      // Label 3844: @190527
      GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(190564), // Rule ID 12509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12509,
        GIR_EraseRootFromParent_Done,
      // Label 3845: @190564
      GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(190601), // Rule ID 12510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12510,
        GIR_EraseRootFromParent_Done,
      // Label 3846: @190601
      GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(190638), // Rule ID 12511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1910:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12511,
        GIR_EraseRootFromParent_Done,
      // Label 3847: @190638
      GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(190675), // Rule ID 12512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1910:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12512,
        GIR_EraseRootFromParent_Done,
      // Label 3848: @190675
      GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(190712), // Rule ID 12513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1910:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12513,
        GIR_EraseRootFromParent_Done,
      // Label 3849: @190712
      GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(190749), // Rule ID 12514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1910:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12514,
        GIR_EraseRootFromParent_Done,
      // Label 3850: @190749
      GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(190791), // Rule ID 3205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1963:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3205,
        GIR_EraseRootFromParent_Done,
      // Label 3851: @190791
      GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(190833), // Rule ID 3206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1965:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3206,
        GIR_EraseRootFromParent_Done,
      // Label 3852: @190833
      GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(190875), // Rule ID 3207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1966:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3207,
        GIR_EraseRootFromParent_Done,
      // Label 3853: @190875
      GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(190917), // Rule ID 3208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1964:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3208,
        GIR_EraseRootFromParent_Done,
      // Label 3854: @190917
      GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(190959), // Rule ID 12257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1959:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12257,
        GIR_EraseRootFromParent_Done,
      // Label 3855: @190959
      GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(191001), // Rule ID 12258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1961:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12258,
        GIR_EraseRootFromParent_Done,
      // Label 3856: @191001
      GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(191043), // Rule ID 12259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1962:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12259,
        GIR_EraseRootFromParent_Done,
      // Label 3857: @191043
      GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(191085), // Rule ID 12260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1960:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12260,
        GIR_EraseRootFromParent_Done,
      // Label 3858: @191085
      GIM_Reject,
    // Label 2897: @191086
    GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(235566),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(191207), // Rule ID 2057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2057,
        GIR_EraseRootFromParent_Done,
      // Label 3860: @191207
      GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(191320), // Rule ID 2064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2064,
        GIR_EraseRootFromParent_Done,
      // Label 3861: @191320
      GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(191433), // Rule ID 2060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2060,
        GIR_EraseRootFromParent_Done,
      // Label 3862: @191433
      GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(191546), // Rule ID 2067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2067,
        GIR_EraseRootFromParent_Done,
      // Label 3863: @191546
      GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(191648), // Rule ID 32 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2f32] } 566:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, (bitconvert:{ *:[v4bf16] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (BF16DOTlanev4bf16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF16DOTlanev4bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32,
        GIR_EraseRootFromParent_Done,
      // Label 3864: @191648
      GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(191750), // Rule ID 33 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f32] } 566:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, (bitconvert:{ *:[v8bf16] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (BF16DOTlanev8bf16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF16DOTlanev8bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33,
        GIR_EraseRootFromParent_Done,
      // Label 3865: @191750
      GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(191804), // Rule ID 71 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71,
        GIR_EraseRootFromParent_Done,
      // Label 3866: @191804
      GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(191858), // Rule ID 72 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72,
        GIR_EraseRootFromParent_Done,
      // Label 3867: @191858
      GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(191912), // Rule ID 73 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 73,
        GIR_EraseRootFromParent_Done,
      // Label 3868: @191912
      GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(191966), // Rule ID 74 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 74,
        GIR_EraseRootFromParent_Done,
      // Label 3869: @191966
      GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(192022), // Rule ID 2599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1631:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2599,
        GIR_EraseRootFromParent_Done,
      // Label 3870: @192022
      GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(192078), // Rule ID 2608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1837:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2608,
        GIR_EraseRootFromParent_Done,
      // Label 3871: @192078
      GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(192134), // Rule ID 2609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1627:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2609,
        GIR_EraseRootFromParent_Done,
      // Label 3872: @192134
      GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(192190), // Rule ID 10194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1823:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10194,
        GIR_EraseRootFromParent_Done,
      // Label 3873: @192190
      GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(192246), // Rule ID 10195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1838:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10195,
        GIR_EraseRootFromParent_Done,
      // Label 3874: @192246
      GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(192302), // Rule ID 10196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1593:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10196,
        GIR_EraseRootFromParent_Done,
      // Label 3875: @192302
      GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(192358), // Rule ID 10197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1824:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10197,
        GIR_EraseRootFromParent_Done,
      // Label 3876: @192358
      GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(192414), // Rule ID 10200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1843:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10200,
        GIR_EraseRootFromParent_Done,
      // Label 3877: @192414
      GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(192470), // Rule ID 10203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1829:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10203,
        GIR_EraseRootFromParent_Done,
      // Label 3878: @192470
      GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(192526), // Rule ID 10204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1633:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10204,
        GIR_EraseRootFromParent_Done,
      // Label 3879: @192526
      GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(192582), // Rule ID 10205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1844:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10205,
        GIR_EraseRootFromParent_Done,
      // Label 3880: @192582
      GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(192638), // Rule ID 10206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1599:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10206,
        GIR_EraseRootFromParent_Done,
      // Label 3881: @192638
      GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(192694), // Rule ID 10207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1830:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10207,
        GIR_EraseRootFromParent_Done,
      // Label 3882: @192694
      GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(192750), // Rule ID 10210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1849:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10210,
        GIR_EraseRootFromParent_Done,
      // Label 3883: @192750
      GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(192806), // Rule ID 10213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1835:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10213,
        GIR_EraseRootFromParent_Done,
      // Label 3884: @192806
      GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(192862), // Rule ID 10214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1639:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10214,
        GIR_EraseRootFromParent_Done,
      // Label 3885: @192862
      GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(192918), // Rule ID 10215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1850:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10215,
        GIR_EraseRootFromParent_Done,
      // Label 3886: @192918
      GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(192974), // Rule ID 10216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1605:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10216,
        GIR_EraseRootFromParent_Done,
      // Label 3887: @192974
      GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(193030), // Rule ID 10217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1836:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10217,
        GIR_EraseRootFromParent_Done,
      // Label 3888: @193030
      GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(193086), // Rule ID 10220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1840:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10220,
        GIR_EraseRootFromParent_Done,
      // Label 3889: @193086
      GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(193142), // Rule ID 10223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1826:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10223,
        GIR_EraseRootFromParent_Done,
      // Label 3890: @193142
      GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(193198), // Rule ID 10224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1630:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10224,
        GIR_EraseRootFromParent_Done,
      // Label 3891: @193198
      GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(193254), // Rule ID 10225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1841:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10225,
        GIR_EraseRootFromParent_Done,
      // Label 3892: @193254
      GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(193310), // Rule ID 10226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1596:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10226,
        GIR_EraseRootFromParent_Done,
      // Label 3893: @193310
      GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(193366), // Rule ID 10227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1827:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10227,
        GIR_EraseRootFromParent_Done,
      // Label 3894: @193366
      GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(193422), // Rule ID 10228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10228,
        GIR_EraseRootFromParent_Done,
      // Label 3895: @193422
      GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(193478), // Rule ID 10229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10229,
        GIR_EraseRootFromParent_Done,
      // Label 3896: @193478
      GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(193534), // Rule ID 10230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10230,
        GIR_EraseRootFromParent_Done,
      // Label 3897: @193534
      GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(193590), // Rule ID 10231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1637:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10231,
        GIR_EraseRootFromParent_Done,
      // Label 3898: @193590
      GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(193646), // Rule ID 10232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10232,
        GIR_EraseRootFromParent_Done,
      // Label 3899: @193646
      GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(193702), // Rule ID 10233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10233,
        GIR_EraseRootFromParent_Done,
      // Label 3900: @193702
      GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(193758), // Rule ID 10234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10234,
        GIR_EraseRootFromParent_Done,
      // Label 3901: @193758
      GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(193814), // Rule ID 10235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10235,
        GIR_EraseRootFromParent_Done,
      // Label 3902: @193814
      GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(193870), // Rule ID 10236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1839:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10236,
        GIR_EraseRootFromParent_Done,
      // Label 3903: @193870
      GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(193926), // Rule ID 10237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10237,
        GIR_EraseRootFromParent_Done,
      // Label 3904: @193926
      GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(193982), // Rule ID 10238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10238,
        GIR_EraseRootFromParent_Done,
      // Label 3905: @193982
      GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(194072), // Rule ID 37 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 567:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, (AArch64duplane16:{ *:[v8bf16] } V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (BFMLALBIdx:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALBIdx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 37,
        GIR_EraseRootFromParent_Done,
      // Label 3906: @194072
      GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(194162), // Rule ID 38 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 568:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, (AArch64duplane16:{ *:[v8bf16] } V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (BFMLALTIdx:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALTIdx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 38,
        GIR_EraseRootFromParent_Done,
      // Label 3907: @194162
      GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(194252), // Rule ID 59 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59,
        GIR_EraseRootFromParent_Done,
      // Label 3908: @194252
      GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(194342), // Rule ID 60 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 601:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60,
        GIR_EraseRootFromParent_Done,
      // Label 3909: @194342
      GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(194432), // Rule ID 61 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61,
        GIR_EraseRootFromParent_Done,
      // Label 3910: @194432
      GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(194522), // Rule ID 62 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62,
        GIR_EraseRootFromParent_Done,
      // Label 3911: @194522
      GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(194612), // Rule ID 63 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63,
        GIR_EraseRootFromParent_Done,
      // Label 3912: @194612
      GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(194702), // Rule ID 64 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64,
        GIR_EraseRootFromParent_Done,
      // Label 3913: @194702
      GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(194792), // Rule ID 65 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 65,
        GIR_EraseRootFromParent_Done,
      // Label 3914: @194792
      GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(194882), // Rule ID 66 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 66,
        GIR_EraseRootFromParent_Done,
      // Label 3915: @194882
      GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(194972), // Rule ID 2058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2058,
        GIR_EraseRootFromParent_Done,
      // Label 3916: @194972
      GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(195062), // Rule ID 2059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2059,
        GIR_EraseRootFromParent_Done,
      // Label 3917: @195062
      GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(195152), // Rule ID 2065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2065,
        GIR_EraseRootFromParent_Done,
      // Label 3918: @195152
      GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(195242), // Rule ID 2066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2066,
        GIR_EraseRootFromParent_Done,
      // Label 3919: @195242
      GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(195332), // Rule ID 2061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2061,
        GIR_EraseRootFromParent_Done,
      // Label 3920: @195332
      GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(195422), // Rule ID 2062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2062,
        GIR_EraseRootFromParent_Done,
      // Label 3921: @195422
      GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(195512), // Rule ID 2068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2068,
        GIR_EraseRootFromParent_Done,
      // Label 3922: @195512
      GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(195602), // Rule ID 2069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2069,
        GIR_EraseRootFromParent_Done,
      // Label 3923: @195602
      GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(195692), // Rule ID 2063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 661:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2063,
        GIR_EraseRootFromParent_Done,
      // Label 3924: @195692
      GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(195782), // Rule ID 2070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2070,
        GIR_EraseRootFromParent_Done,
      // Label 3925: @195782
      GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(195859), // Rule ID 2737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1210:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2737,
        GIR_EraseRootFromParent_Done,
      // Label 3926: @195859
      GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(195936), // Rule ID 2738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1210:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2738,
        GIR_EraseRootFromParent_Done,
      // Label 3927: @195936
      GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196013), // Rule ID 2739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1210:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2739,
        GIR_EraseRootFromParent_Done,
      // Label 3928: @196013
      GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196090), // Rule ID 2740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1210:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2740,
        GIR_EraseRootFromParent_Done,
      // Label 3929: @196090
      GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(196167), // Rule ID 2741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1210:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2741,
        GIR_EraseRootFromParent_Done,
      // Label 3930: @196167
      GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(196244), // Rule ID 2742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1210:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2742,
        GIR_EraseRootFromParent_Done,
      // Label 3931: @196244
      GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(196321), // Rule ID 8005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8005,
        GIR_EraseRootFromParent_Done,
      // Label 3932: @196321
      GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(196398), // Rule ID 8006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8006,
        GIR_EraseRootFromParent_Done,
      // Label 3933: @196398
      GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(196475), // Rule ID 8007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8007,
        GIR_EraseRootFromParent_Done,
      // Label 3934: @196475
      GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(196552), // Rule ID 8008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8008,
        GIR_EraseRootFromParent_Done,
      // Label 3935: @196552
      GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(196629), // Rule ID 8009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8009,
        GIR_EraseRootFromParent_Done,
      // Label 3936: @196629
      GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(196706), // Rule ID 8010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8010,
        GIR_EraseRootFromParent_Done,
      // Label 3937: @196706
      GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(196783), // Rule ID 8011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1324:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8011,
        GIR_EraseRootFromParent_Done,
      // Label 3938: @196783
      GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(196860), // Rule ID 8012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1324:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8012,
        GIR_EraseRootFromParent_Done,
      // Label 3939: @196860
      GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(196937), // Rule ID 8013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1324:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8013,
        GIR_EraseRootFromParent_Done,
      // Label 3940: @196937
      GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197014), // Rule ID 8014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1324:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8014,
        GIR_EraseRootFromParent_Done,
      // Label 3941: @197014
      GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197091), // Rule ID 8015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1324:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8015,
        GIR_EraseRootFromParent_Done,
      // Label 3942: @197091
      GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197168), // Rule ID 8016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1324:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8016,
        GIR_EraseRootFromParent_Done,
      // Label 3943: @197168
      GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197245), // Rule ID 8017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1362:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8017,
        GIR_EraseRootFromParent_Done,
      // Label 3944: @197245
      GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197322), // Rule ID 8018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1362:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8018,
        GIR_EraseRootFromParent_Done,
      // Label 3945: @197322
      GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197399), // Rule ID 8019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1362:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8019,
        GIR_EraseRootFromParent_Done,
      // Label 3946: @197399
      GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197476), // Rule ID 8020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1362:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8020,
        GIR_EraseRootFromParent_Done,
      // Label 3947: @197476
      GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(197553), // Rule ID 8021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1362:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8021,
        GIR_EraseRootFromParent_Done,
      // Label 3948: @197553
      GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197630), // Rule ID 8022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1362:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8022,
        GIR_EraseRootFromParent_Done,
      // Label 3949: @197630
      GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197707), // Rule ID 8023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1278:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8023,
        GIR_EraseRootFromParent_Done,
      // Label 3950: @197707
      GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197784), // Rule ID 8024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1278:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8024,
        GIR_EraseRootFromParent_Done,
      // Label 3951: @197784
      GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197861), // Rule ID 8025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1278:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8025,
        GIR_EraseRootFromParent_Done,
      // Label 3952: @197861
      GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197938), // Rule ID 8026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1278:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8026,
        GIR_EraseRootFromParent_Done,
      // Label 3953: @197938
      GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(198015), // Rule ID 8027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1278:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8027,
        GIR_EraseRootFromParent_Done,
      // Label 3954: @198015
      GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(198092), // Rule ID 8028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1278:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8028,
        GIR_EraseRootFromParent_Done,
      // Label 3955: @198092
      GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(198169), // Rule ID 8029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1296:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8029,
        GIR_EraseRootFromParent_Done,
      // Label 3956: @198169
      GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(198246), // Rule ID 8030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1296:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8030,
        GIR_EraseRootFromParent_Done,
      // Label 3957: @198246
      GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198323), // Rule ID 8031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1296:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8031,
        GIR_EraseRootFromParent_Done,
      // Label 3958: @198323
      GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198400), // Rule ID 8032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1296:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8032,
        GIR_EraseRootFromParent_Done,
      // Label 3959: @198400
      GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198477), // Rule ID 8033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1296:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8033,
        GIR_EraseRootFromParent_Done,
      // Label 3960: @198477
      GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198554), // Rule ID 8034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1296:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8034,
        GIR_EraseRootFromParent_Done,
      // Label 3961: @198554
      GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198631), // Rule ID 8035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1272:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8035,
        GIR_EraseRootFromParent_Done,
      // Label 3962: @198631
      GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198708), // Rule ID 8036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1272:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8036,
        GIR_EraseRootFromParent_Done,
      // Label 3963: @198708
      GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198785), // Rule ID 8037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1272:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8037,
        GIR_EraseRootFromParent_Done,
      // Label 3964: @198785
      GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198862), // Rule ID 8038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1272:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8038,
        GIR_EraseRootFromParent_Done,
      // Label 3965: @198862
      GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198939), // Rule ID 8039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1272:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8039,
        GIR_EraseRootFromParent_Done,
      // Label 3966: @198939
      GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(199016), // Rule ID 8040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1272:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8040,
        GIR_EraseRootFromParent_Done,
      // Label 3967: @199016
      GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(199093), // Rule ID 8041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1290:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8041,
        GIR_EraseRootFromParent_Done,
      // Label 3968: @199093
      GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(199170), // Rule ID 8042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1290:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8042,
        GIR_EraseRootFromParent_Done,
      // Label 3969: @199170
      GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(199247), // Rule ID 8043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1290:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8043,
        GIR_EraseRootFromParent_Done,
      // Label 3970: @199247
      GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(199324), // Rule ID 8044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1290:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8044,
        GIR_EraseRootFromParent_Done,
      // Label 3971: @199324
      GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(199401), // Rule ID 8045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1290:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8045,
        GIR_EraseRootFromParent_Done,
      // Label 3972: @199401
      GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(199478), // Rule ID 8046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1290:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8046,
        GIR_EraseRootFromParent_Done,
      // Label 3973: @199478
      GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(199534), // Rule ID 67 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 67,
        GIR_EraseRootFromParent_Done,
      // Label 3974: @199534
      GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199590), // Rule ID 68 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 68,
        GIR_EraseRootFromParent_Done,
      // Label 3975: @199590
      GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199646), // Rule ID 69 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 69,
        GIR_EraseRootFromParent_Done,
      // Label 3976: @199646
      GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(199702), // Rule ID 70 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70,
        GIR_EraseRootFromParent_Done,
      // Label 3977: @199702
      GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199757), // Rule ID 2758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2758,
        GIR_EraseRootFromParent_Done,
      // Label 3978: @199757
      GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199812), // Rule ID 2759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2759,
        GIR_EraseRootFromParent_Done,
      // Label 3979: @199812
      GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199867), // Rule ID 2760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2760,
        GIR_EraseRootFromParent_Done,
      // Label 3980: @199867
      GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199922), // Rule ID 3561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1449:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zd
        GIR_RootToRootCopy, /*OpIdx*/4, // Idx
        GIR_RootToRootCopy, /*OpIdx*/3, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3561,
        GIR_EraseRootFromParent_Done,
      // Label 3981: @199922
      GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199977), // Rule ID 3562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1449:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zd
        GIR_RootToRootCopy, /*OpIdx*/4, // Idx
        GIR_RootToRootCopy, /*OpIdx*/3, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3562,
        GIR_EraseRootFromParent_Done,
      // Label 3982: @199977
      GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200032), // Rule ID 3563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1449:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zd
        GIR_RootToRootCopy, /*OpIdx*/4, // Idx
        GIR_RootToRootCopy, /*OpIdx*/3, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3563,
        GIR_EraseRootFromParent_Done,
      // Label 3983: @200032
      GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(200087), // Rule ID 3812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
        // (intrinsic_wo_chain:{ *:[v2i64] } 535:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3812,
        GIR_EraseRootFromParent_Done,
      // Label 3984: @200087
      GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200134), // Rule ID 2822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1325:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2822,
        GIR_EraseRootFromParent_Done,
      // Label 3985: @200134
      GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200181), // Rule ID 2823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1325:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2823,
        GIR_EraseRootFromParent_Done,
      // Label 3986: @200181
      GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200228), // Rule ID 2824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1325:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2824,
        GIR_EraseRootFromParent_Done,
      // Label 3987: @200228
      GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200275), // Rule ID 2825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1325:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (BFMUL_ZZZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2825,
        GIR_EraseRootFromParent_Done,
      // Label 3988: @200275
      GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200322), // Rule ID 2987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1430:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2987,
        GIR_EraseRootFromParent_Done,
      // Label 3989: @200322
      GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200369), // Rule ID 2988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1430:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2988,
        GIR_EraseRootFromParent_Done,
      // Label 3990: @200369
      GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200416), // Rule ID 2989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1430:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2989,
        GIR_EraseRootFromParent_Done,
      // Label 3991: @200416
      GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200463), // Rule ID 2990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1576:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2990,
        GIR_EraseRootFromParent_Done,
      // Label 3992: @200463
      GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200510), // Rule ID 2991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2991,
        GIR_EraseRootFromParent_Done,
      // Label 3993: @200510
      GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200557), // Rule ID 3039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3039,
        GIR_EraseRootFromParent_Done,
      // Label 3994: @200557
      GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200604), // Rule ID 3041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3041,
        GIR_EraseRootFromParent_Done,
      // Label 3995: @200604
      GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200651), // Rule ID 3043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3043,
        GIR_EraseRootFromParent_Done,
      // Label 3996: @200651
      GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200698), // Rule ID 3045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3045,
        GIR_EraseRootFromParent_Done,
      // Label 3997: @200698
      GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200745), // Rule ID 3067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1667:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3067,
        GIR_EraseRootFromParent_Done,
      // Label 3998: @200745
      GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200792), // Rule ID 3068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1667:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3068,
        GIR_EraseRootFromParent_Done,
      // Label 3999: @200792
      GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200839), // Rule ID 3069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1667:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3069,
        GIR_EraseRootFromParent_Done,
      // Label 4000: @200839
      GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200886), // Rule ID 3148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3148,
        GIR_EraseRootFromParent_Done,
      // Label 4001: @200886
      GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200933), // Rule ID 3149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3149,
        GIR_EraseRootFromParent_Done,
      // Label 4002: @200933
      GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200980), // Rule ID 3150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3150,
        GIR_EraseRootFromParent_Done,
      // Label 4003: @200980
      GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201027), // Rule ID 3151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3151,
        GIR_EraseRootFromParent_Done,
      // Label 4004: @201027
      GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201074), // Rule ID 3545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1204:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3545,
        GIR_EraseRootFromParent_Done,
      // Label 4005: @201074
      GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201121), // Rule ID 3588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1417:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3588,
        GIR_EraseRootFromParent_Done,
      // Label 4006: @201121
      GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201168), // Rule ID 3589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1417:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3589,
        GIR_EraseRootFromParent_Done,
      // Label 4007: @201168
      GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201215), // Rule ID 3590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3590,
        GIR_EraseRootFromParent_Done,
      // Label 4008: @201215
      GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201262), // Rule ID 3591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1417:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3591,
        GIR_EraseRootFromParent_Done,
      // Label 4009: @201262
      GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201309), // Rule ID 3592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1418:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3592,
        GIR_EraseRootFromParent_Done,
      // Label 4010: @201309
      GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201356), // Rule ID 3593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1418:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3593,
        GIR_EraseRootFromParent_Done,
      // Label 4011: @201356
      GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201403), // Rule ID 3594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1418:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3594,
        GIR_EraseRootFromParent_Done,
      // Label 4012: @201403
      GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201450), // Rule ID 3595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1418:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3595,
        GIR_EraseRootFromParent_Done,
      // Label 4013: @201450
      GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201497), // Rule ID 11610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1617:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11610,
        GIR_EraseRootFromParent_Done,
      // Label 4014: @201497
      GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201544), // Rule ID 11611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11611,
        GIR_EraseRootFromParent_Done,
      // Label 4015: @201544
      GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201591), // Rule ID 11612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11612,
        GIR_EraseRootFromParent_Done,
      // Label 4016: @201591
      GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201638), // Rule ID 11613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1648:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11613,
        GIR_EraseRootFromParent_Done,
      // Label 4017: @201638
      GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201685), // Rule ID 11614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1648:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11614,
        GIR_EraseRootFromParent_Done,
      // Label 4018: @201685
      GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201732), // Rule ID 11615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1648:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11615,
        GIR_EraseRootFromParent_Done,
      // Label 4019: @201732
      GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201779), // Rule ID 11638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1578:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11638,
        GIR_EraseRootFromParent_Done,
      // Label 4020: @201779
      GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(201826), // Rule ID 11639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1578:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11639,
        GIR_EraseRootFromParent_Done,
      // Label 4021: @201826
      GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(201873), // Rule ID 11640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11640,
        GIR_EraseRootFromParent_Done,
      // Label 4022: @201873
      GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201920), // Rule ID 11641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11641,
        GIR_EraseRootFromParent_Done,
      // Label 4023: @201920
      GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201967), // Rule ID 11642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11642,
        GIR_EraseRootFromParent_Done,
      // Label 4024: @201967
      GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202014), // Rule ID 11643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1816:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11643,
        GIR_EraseRootFromParent_Done,
      // Label 4025: @202014
      GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202061), // Rule ID 11644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11644,
        GIR_EraseRootFromParent_Done,
      // Label 4026: @202061
      GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202108), // Rule ID 11645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11645,
        GIR_EraseRootFromParent_Done,
      // Label 4027: @202108
      GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202155), // Rule ID 11646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1625:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11646,
        GIR_EraseRootFromParent_Done,
      // Label 4028: @202155
      GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202202), // Rule ID 11647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1625:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11647,
        GIR_EraseRootFromParent_Done,
      // Label 4029: @202202
      GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202249), // Rule ID 11891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11891,
        GIR_EraseRootFromParent_Done,
      // Label 4030: @202249
      GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202296), // Rule ID 11892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11892,
        GIR_EraseRootFromParent_Done,
      // Label 4031: @202296
      GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202343), // Rule ID 11893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11893,
        GIR_EraseRootFromParent_Done,
      // Label 4032: @202343
      GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202390), // Rule ID 11894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11894,
        GIR_EraseRootFromParent_Done,
      // Label 4033: @202390
      GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202437), // Rule ID 11895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1874:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11895,
        GIR_EraseRootFromParent_Done,
      // Label 4034: @202437
      GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202484), // Rule ID 11897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11897,
        GIR_EraseRootFromParent_Done,
      // Label 4035: @202484
      GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202531), // Rule ID 11899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11899,
        GIR_EraseRootFromParent_Done,
      // Label 4036: @202531
      GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202578), // Rule ID 11901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11901,
        GIR_EraseRootFromParent_Done,
      // Label 4037: @202578
      GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202625), // Rule ID 11903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11903,
        GIR_EraseRootFromParent_Done,
      // Label 4038: @202625
      GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202672), // Rule ID 11904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11904,
        GIR_EraseRootFromParent_Done,
      // Label 4039: @202672
      GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202719), // Rule ID 11905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11905,
        GIR_EraseRootFromParent_Done,
      // Label 4040: @202719
      GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202766), // Rule ID 11906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1663:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11906,
        GIR_EraseRootFromParent_Done,
      // Label 4041: @202766
      GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202813), // Rule ID 11981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1883:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11981,
        GIR_EraseRootFromParent_Done,
      // Label 4042: @202813
      GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202860), // Rule ID 11983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1883:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11983,
        GIR_EraseRootFromParent_Done,
      // Label 4043: @202860
      GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202907), // Rule ID 11985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1883:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11985,
        GIR_EraseRootFromParent_Done,
      // Label 4044: @202907
      GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202954), // Rule ID 11987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1883:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11987,
        GIR_EraseRootFromParent_Done,
      // Label 4045: @202954
      GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203001), // Rule ID 11989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1684:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11989,
        GIR_EraseRootFromParent_Done,
      // Label 4046: @203001
      GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203048), // Rule ID 11990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1684:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11990,
        GIR_EraseRootFromParent_Done,
      // Label 4047: @203048
      GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203095), // Rule ID 11991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1684:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11991,
        GIR_EraseRootFromParent_Done,
      // Label 4048: @203095
      GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203142), // Rule ID 11992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1684:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11992,
        GIR_EraseRootFromParent_Done,
      // Label 4049: @203142
      GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203189), // Rule ID 11997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11997,
        GIR_EraseRootFromParent_Done,
      // Label 4050: @203189
      GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203236), // Rule ID 11998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11998,
        GIR_EraseRootFromParent_Done,
      // Label 4051: @203236
      GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203283), // Rule ID 11999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11999,
        GIR_EraseRootFromParent_Done,
      // Label 4052: @203283
      GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203330), // Rule ID 12000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12000,
        GIR_EraseRootFromParent_Done,
      // Label 4053: @203330
      GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203377), // Rule ID 12060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1661:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12060,
        GIR_EraseRootFromParent_Done,
      // Label 4054: @203377
      GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203424), // Rule ID 12061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1661:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12061,
        GIR_EraseRootFromParent_Done,
      // Label 4055: @203424
      GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203471), // Rule ID 12062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1661:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12062,
        GIR_EraseRootFromParent_Done,
      // Label 4056: @203471
      GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203518), // Rule ID 12063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1540:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12063,
        GIR_EraseRootFromParent_Done,
      // Label 4057: @203518
      GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203565), // Rule ID 12064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1540:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12064,
        GIR_EraseRootFromParent_Done,
      // Label 4058: @203565
      GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(203612), // Rule ID 12065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1540:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12065,
        GIR_EraseRootFromParent_Done,
      // Label 4059: @203612
      GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203659), // Rule ID 12066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12066,
        GIR_EraseRootFromParent_Done,
      // Label 4060: @203659
      GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203706), // Rule ID 12067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1498:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12067,
        GIR_EraseRootFromParent_Done,
      // Label 4061: @203706
      GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203753), // Rule ID 12068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1498:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12068,
        GIR_EraseRootFromParent_Done,
      // Label 4062: @203753
      GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203800), // Rule ID 12069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12069,
        GIR_EraseRootFromParent_Done,
      // Label 4063: @203800
      GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203847), // Rule ID 12070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12070,
        GIR_EraseRootFromParent_Done,
      // Label 4064: @203847
      GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(203894), // Rule ID 12071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12071,
        GIR_EraseRootFromParent_Done,
      // Label 4065: @203894
      GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(203941), // Rule ID 12072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1655:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12072,
        GIR_EraseRootFromParent_Done,
      // Label 4066: @203941
      GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(203988), // Rule ID 12073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1655:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12073,
        GIR_EraseRootFromParent_Done,
      // Label 4067: @203988
      GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(204035), // Rule ID 12074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1655:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12074,
        GIR_EraseRootFromParent_Done,
      // Label 4068: @204035
      GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(204082), // Rule ID 12075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12075,
        GIR_EraseRootFromParent_Done,
      // Label 4069: @204082
      GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(204129), // Rule ID 12076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12076,
        GIR_EraseRootFromParent_Done,
      // Label 4070: @204129
      GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(204176), // Rule ID 12077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12077,
        GIR_EraseRootFromParent_Done,
      // Label 4071: @204176
      GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(204223), // Rule ID 12078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12078,
        GIR_EraseRootFromParent_Done,
      // Label 4072: @204223
      GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(204270), // Rule ID 12079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12079,
        GIR_EraseRootFromParent_Done,
      // Label 4073: @204270
      GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204317), // Rule ID 12080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12080,
        GIR_EraseRootFromParent_Done,
      // Label 4074: @204317
      GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204384), // Rule ID 2551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1157:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2551,
        GIR_EraseRootFromParent_Done,
      // Label 4075: @204384
      GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204451), // Rule ID 2555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2555,
        GIR_EraseRootFromParent_Done,
      // Label 4076: @204451
      GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204518), // Rule ID 7824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1157:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7824,
        GIR_EraseRootFromParent_Done,
      // Label 4077: @204518
      GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204585), // Rule ID 7826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1157:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7826,
        GIR_EraseRootFromParent_Done,
      // Label 4078: @204585
      GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204652), // Rule ID 7828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1157:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7828,
        GIR_EraseRootFromParent_Done,
      // Label 4079: @204652
      GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204719), // Rule ID 7858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1177:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7858,
        GIR_EraseRootFromParent_Done,
      // Label 4080: @204719
      GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(204786), // Rule ID 7860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1177:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7860,
        GIR_EraseRootFromParent_Done,
      // Label 4081: @204786
      GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(204853), // Rule ID 7862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1177:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7862,
        GIR_EraseRootFromParent_Done,
      // Label 4082: @204853
      GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(204920), // Rule ID 7864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1177:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7864,
        GIR_EraseRootFromParent_Done,
      // Label 4083: @204920
      GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(204987), // Rule ID 7870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1437:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7870,
        GIR_EraseRootFromParent_Done,
      // Label 4084: @204987
      GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(205054), // Rule ID 7872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1437:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7872,
        GIR_EraseRootFromParent_Done,
      // Label 4085: @205054
      GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(205121), // Rule ID 7874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1437:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7874,
        GIR_EraseRootFromParent_Done,
      // Label 4086: @205121
      GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(205188), // Rule ID 7876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1437:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7876,
        GIR_EraseRootFromParent_Done,
      // Label 4087: @205188
      GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(205255), // Rule ID 11773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11773,
        GIR_EraseRootFromParent_Done,
      // Label 4088: @205255
      GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(205322), // Rule ID 11775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1580:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11775,
        GIR_EraseRootFromParent_Done,
      // Label 4089: @205322
      GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(205389), // Rule ID 11777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1580:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11777,
        GIR_EraseRootFromParent_Done,
      // Label 4090: @205389
      GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(205456), // Rule ID 11779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1580:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11779,
        GIR_EraseRootFromParent_Done,
      // Label 4091: @205456
      GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(205523), // Rule ID 11781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1580:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11781,
        GIR_EraseRootFromParent_Done,
      // Label 4092: @205523
      GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(205590), // Rule ID 11787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1640:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11787,
        GIR_EraseRootFromParent_Done,
      // Label 4093: @205590
      GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(205657), // Rule ID 11789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1640:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11789,
        GIR_EraseRootFromParent_Done,
      // Label 4094: @205657
      GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(205724), // Rule ID 11791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1640:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11791,
        GIR_EraseRootFromParent_Done,
      // Label 4095: @205724
      GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(205791), // Rule ID 11793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1640:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11793,
        GIR_EraseRootFromParent_Done,
      // Label 4096: @205791
      GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(205845), // Rule ID 30 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 566:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (BFDOTv4bf16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOTv4bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 30,
        GIR_EraseRootFromParent_Done,
      // Label 4097: @205845
      GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(205899), // Rule ID 31 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 566:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFDOTv8bf16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOTv8bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 31,
        GIR_EraseRootFromParent_Done,
      // Label 4098: @205899
      GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(205953), // Rule ID 34 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 569:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFMMLA:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34,
        GIR_EraseRootFromParent_Done,
      // Label 4099: @205953
      GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(206007), // Rule ID 35 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 567:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFMLALB:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35,
        GIR_EraseRootFromParent_Done,
      // Label 4100: @206007
      GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(206061), // Rule ID 36 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 568:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFMLALT:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 36,
        GIR_EraseRootFromParent_Done,
      // Label 4101: @206061
      GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(206115), // Rule ID 42 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 651:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 42,
        GIR_EraseRootFromParent_Done,
      // Label 4102: @206115
      GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(206169), // Rule ID 43 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 712:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 43,
        GIR_EraseRootFromParent_Done,
      // Label 4103: @206169
      GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(206223), // Rule ID 44 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 728:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 44,
        GIR_EraseRootFromParent_Done,
      // Label 4104: @206223
      GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(206277), // Rule ID 51 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51,
        GIR_EraseRootFromParent_Done,
      // Label 4105: @206277
      GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(206331), // Rule ID 52 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 601:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52,
        GIR_EraseRootFromParent_Done,
      // Label 4106: @206331
      GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(206385), // Rule ID 53 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53,
        GIR_EraseRootFromParent_Done,
      // Label 4107: @206385
      GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(206439), // Rule ID 54 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54,
        GIR_EraseRootFromParent_Done,
      // Label 4108: @206439
      GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(206493), // Rule ID 55 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55,
        GIR_EraseRootFromParent_Done,
      // Label 4109: @206493
      GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(206547), // Rule ID 56 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56,
        GIR_EraseRootFromParent_Done,
      // Label 4110: @206547
      GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(206601), // Rule ID 57 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57,
        GIR_EraseRootFromParent_Done,
      // Label 4111: @206601
      GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(206655), // Rule ID 58 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58,
        GIR_EraseRootFromParent_Done,
      // Label 4112: @206655
      GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(206709), // Rule ID 1575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1575,
        GIR_EraseRootFromParent_Done,
      // Label 4113: @206709
      GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(206763), // Rule ID 1576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1576,
        GIR_EraseRootFromParent_Done,
      // Label 4114: @206763
      GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(206817), // Rule ID 1577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1577,
        GIR_EraseRootFromParent_Done,
      // Label 4115: @206817
      GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(206871), // Rule ID 1578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1578,
        GIR_EraseRootFromParent_Done,
      // Label 4116: @206871
      GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(206925), // Rule ID 1579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1579,
        GIR_EraseRootFromParent_Done,
      // Label 4117: @206925
      GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(206979), // Rule ID 1580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1580,
        GIR_EraseRootFromParent_Done,
      // Label 4118: @206979
      GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(207033), // Rule ID 1581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1581,
        GIR_EraseRootFromParent_Done,
      // Label 4119: @207033
      GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(207087), // Rule ID 1582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1582,
        GIR_EraseRootFromParent_Done,
      // Label 4120: @207087
      GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(207141), // Rule ID 2293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 512:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2293,
        GIR_EraseRootFromParent_Done,
      // Label 4121: @207141
      GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(207195), // Rule ID 2294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2294,
        GIR_EraseRootFromParent_Done,
      // Label 4122: @207195
      GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(207249), // Rule ID 2295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 514:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2295,
        GIR_EraseRootFromParent_Done,
      // Label 4123: @207249
      GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(207303), // Rule ID 2296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2296,
        GIR_EraseRootFromParent_Done,
      // Label 4124: @207303
      GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(207357), // Rule ID 2297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2297,
        GIR_EraseRootFromParent_Done,
      // Label 4125: @207357
      GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(207411), // Rule ID 2298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 519:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2298,
        GIR_EraseRootFromParent_Done,
      // Label 4126: @207411
      GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(207465), // Rule ID 2299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 521:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2299,
        GIR_EraseRootFromParent_Done,
      // Label 4127: @207465
      GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(207522), // Rule ID 3634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1472:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3634,
        GIR_EraseRootFromParent_Done,
      // Label 4128: @207522
      GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(207579), // Rule ID 3635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1472:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3635,
        GIR_EraseRootFromParent_Done,
      // Label 4129: @207579
      GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(207636), // Rule ID 3636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1472:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3636,
        GIR_EraseRootFromParent_Done,
      // Label 4130: @207636
      GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(207693), // Rule ID 3637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1472:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3637,
        GIR_EraseRootFromParent_Done,
      // Label 4131: @207693
      GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(207747), // Rule ID 3784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 522:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3784,
        GIR_EraseRootFromParent_Done,
      // Label 4132: @207747
      GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(207801), // Rule ID 3785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 523:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3785,
        GIR_EraseRootFromParent_Done,
      // Label 4133: @207801
      GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(207855), // Rule ID 3786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3786,
        GIR_EraseRootFromParent_Done,
      // Label 4134: @207855
      GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(207909), // Rule ID 3787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 510:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3787,
        GIR_EraseRootFromParent_Done,
      // Label 4135: @207909
      GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(207963), // Rule ID 3788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 510:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3788,
        GIR_EraseRootFromParent_Done,
      // Label 4136: @207963
      GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(208017), // Rule ID 3789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 510:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3789,
        GIR_EraseRootFromParent_Done,
      // Label 4137: @208017
      GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(208071), // Rule ID 3790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 510:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3790,
        GIR_EraseRootFromParent_Done,
      // Label 4138: @208071
      GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(208125), // Rule ID 3799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 508:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3799,
        GIR_EraseRootFromParent_Done,
      // Label 4139: @208125
      GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(208179), // Rule ID 3800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 508:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3800,
        GIR_EraseRootFromParent_Done,
      // Label 4140: @208179
      GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(208233), // Rule ID 3801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 508:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3801,
        GIR_EraseRootFromParent_Done,
      // Label 4141: @208233
      GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(208287), // Rule ID 3802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 508:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3802,
        GIR_EraseRootFromParent_Done,
      // Label 4142: @208287
      GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(208341), // Rule ID 3803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 509:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3803,
        GIR_EraseRootFromParent_Done,
      // Label 4143: @208341
      GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(208395), // Rule ID 3804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 509:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3804,
        GIR_EraseRootFromParent_Done,
      // Label 4144: @208395
      GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(208449), // Rule ID 3805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 509:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3805,
        GIR_EraseRootFromParent_Done,
      // Label 4145: @208449
      GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(208503), // Rule ID 3806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 509:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3806,
        GIR_EraseRootFromParent_Done,
      // Label 4146: @208503
      GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(208557), // Rule ID 3807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 507:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3807,
        GIR_EraseRootFromParent_Done,
      // Label 4147: @208557
      GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(208611), // Rule ID 3808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 507:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3808,
        GIR_EraseRootFromParent_Done,
      // Label 4148: @208611
      GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(208665), // Rule ID 3809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 507:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3809,
        GIR_EraseRootFromParent_Done,
      // Label 4149: @208665
      GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(208719), // Rule ID 3810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 507:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3810,
        GIR_EraseRootFromParent_Done,
      // Label 4150: @208719
      GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(208773), // Rule ID 3814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootToRootCopy, /*OpIdx*/4, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3814,
        GIR_EraseRootFromParent_Done,
      // Label 4151: @208773
      GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(208827), // Rule ID 3815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3815,
        GIR_EraseRootFromParent_Done,
      // Label 4152: @208827
      GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(208881), // Rule ID 3816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3816,
        GIR_EraseRootFromParent_Done,
      // Label 4153: @208881
      GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(208938), // Rule ID 3833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 732:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3833,
        GIR_EraseRootFromParent_Done,
      // Label 4154: @208938
      GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(208995), // Rule ID 3834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 735:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3834,
        GIR_EraseRootFromParent_Done,
      // Label 4155: @208995
      GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(209052), // Rule ID 3835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 733:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3835,
        GIR_EraseRootFromParent_Done,
      // Label 4156: @209052
      GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(209109), // Rule ID 3836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 734:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3836,
        GIR_EraseRootFromParent_Done,
      // Label 4157: @209109
      GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(209166), // Rule ID 3841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 732:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3841,
        GIR_EraseRootFromParent_Done,
      // Label 4158: @209166
      GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(209223), // Rule ID 3842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 735:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3842,
        GIR_EraseRootFromParent_Done,
      // Label 4159: @209223
      GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(209280), // Rule ID 3843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 733:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3843,
        GIR_EraseRootFromParent_Done,
      // Label 4160: @209280
      GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(209337), // Rule ID 3844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 734:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3844,
        GIR_EraseRootFromParent_Done,
      // Label 4161: @209337
      GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(209394), // Rule ID 3849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 732:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3849,
        GIR_EraseRootFromParent_Done,
      // Label 4162: @209394
      GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(209451), // Rule ID 3850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 735:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3850,
        GIR_EraseRootFromParent_Done,
      // Label 4163: @209451
      GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(209508), // Rule ID 3851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 733:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3851,
        GIR_EraseRootFromParent_Done,
      // Label 4164: @209508
      GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(209565), // Rule ID 3852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 734:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3852,
        GIR_EraseRootFromParent_Done,
      // Label 4165: @209565
      GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(209622), // Rule ID 3853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 732:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3853,
        GIR_EraseRootFromParent_Done,
      // Label 4166: @209622
      GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(209679), // Rule ID 3854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 735:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3854,
        GIR_EraseRootFromParent_Done,
      // Label 4167: @209679
      GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(209736), // Rule ID 3855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 733:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3855,
        GIR_EraseRootFromParent_Done,
      // Label 4168: @209736
      GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(209793), // Rule ID 3856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 734:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3856,
        GIR_EraseRootFromParent_Done,
      // Label 4169: @209793
      GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(209850), // Rule ID 3857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 732:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3857,
        GIR_EraseRootFromParent_Done,
      // Label 4170: @209850
      GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(209907), // Rule ID 3858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 735:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3858,
        GIR_EraseRootFromParent_Done,
      // Label 4171: @209907
      GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(209964), // Rule ID 3859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 733:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3859,
        GIR_EraseRootFromParent_Done,
      // Label 4172: @209964
      GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(210021), // Rule ID 3860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 734:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3860,
        GIR_EraseRootFromParent_Done,
      // Label 4173: @210021
      GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(210075), // Rule ID 5255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 661:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5255,
        GIR_EraseRootFromParent_Done,
      // Label 4174: @210075
      GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(210129), // Rule ID 5256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5256,
        GIR_EraseRootFromParent_Done,
      // Label 4175: @210129
      GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(210180), // Rule ID 5613 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 695:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Ri
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5613,
        GIR_EraseRootFromParent_Done,
      // Label 4176: @210180
      GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(210231), // Rule ID 5614 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 695:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Ri
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5614,
        GIR_EraseRootFromParent_Done,
      // Label 4177: @210231
      GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(210273), // Rule ID 2649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1739:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2649,
        GIR_EraseRootFromParent_Done,
      // Label 4178: @210273
      GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(210315), // Rule ID 2650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1739:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2650,
        GIR_EraseRootFromParent_Done,
      // Label 4179: @210315
      GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(210357), // Rule ID 2651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1739:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2651,
        GIR_EraseRootFromParent_Done,
      // Label 4180: @210357
      GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(210399), // Rule ID 2652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1739:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2652,
        GIR_EraseRootFromParent_Done,
      // Label 4181: @210399
      GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(210441), // Rule ID 2653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1739:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2653,
        GIR_EraseRootFromParent_Done,
      // Label 4182: @210441
      GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(210483), // Rule ID 2654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1739:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2654,
        GIR_EraseRootFromParent_Done,
      // Label 4183: @210483
      GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(210525), // Rule ID 2655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1739:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2655,
        GIR_EraseRootFromParent_Done,
      // Label 4184: @210525
      GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(210567), // Rule ID 2656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1739:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2656,
        GIR_EraseRootFromParent_Done,
      // Label 4185: @210567
      GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(210609), // Rule ID 2700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1111:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2700,
        GIR_EraseRootFromParent_Done,
      // Label 4186: @210609
      GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(210651), // Rule ID 2701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1111:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2701,
        GIR_EraseRootFromParent_Done,
      // Label 4187: @210651
      GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(210693), // Rule ID 2702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1111:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2702,
        GIR_EraseRootFromParent_Done,
      // Label 4188: @210693
      GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(210735), // Rule ID 2703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1111:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2703,
        GIR_EraseRootFromParent_Done,
      // Label 4189: @210735
      GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(210777), // Rule ID 2704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1111:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2704,
        GIR_EraseRootFromParent_Done,
      // Label 4190: @210777
      GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(210819), // Rule ID 2743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1210:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2743,
        GIR_EraseRootFromParent_Done,
      // Label 4191: @210819
      GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(210861), // Rule ID 2745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1210:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2745,
        GIR_EraseRootFromParent_Done,
      // Label 4192: @210861
      GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(210903), // Rule ID 2747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1210:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2747,
        GIR_EraseRootFromParent_Done,
      // Label 4193: @210903
      GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(210945), // Rule ID 2749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2749,
        GIR_EraseRootFromParent_Done,
      // Label 4194: @210945
      GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(210987), // Rule ID 2750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2750,
        GIR_EraseRootFromParent_Done,
      // Label 4195: @210987
      GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(211029), // Rule ID 2751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2751,
        GIR_EraseRootFromParent_Done,
      // Label 4196: @211029
      GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(211071), // Rule ID 2752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1210:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFADD_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2752,
        GIR_EraseRootFromParent_Done,
      // Label 4197: @211071
      GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(211113), // Rule ID 2834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1246:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2834,
        GIR_EraseRootFromParent_Done,
      // Label 4198: @211113
      GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(211155), // Rule ID 2835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1247:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2835,
        GIR_EraseRootFromParent_Done,
      // Label 4199: @211155
      GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(211197), // Rule ID 2836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1242:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2836,
        GIR_EraseRootFromParent_Done,
      // Label 4200: @211197
      GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(211239), // Rule ID 2837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1243:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2837,
        GIR_EraseRootFromParent_Done,
      // Label 4201: @211239
      GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(211281), // Rule ID 2838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1249:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2838,
        GIR_EraseRootFromParent_Done,
      // Label 4202: @211281
      GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(211323), // Rule ID 2841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1213:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2841,
        GIR_EraseRootFromParent_Done,
      // Label 4203: @211323
      GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(211365), // Rule ID 2842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1213:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2842,
        GIR_EraseRootFromParent_Done,
      // Label 4204: @211365
      GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(211407), // Rule ID 2843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1213:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2843,
        GIR_EraseRootFromParent_Done,
      // Label 4205: @211407
      GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(211449), // Rule ID 2845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1127:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLALB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALB_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2845,
        GIR_EraseRootFromParent_Done,
      // Label 4206: @211449
      GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(211491), // Rule ID 2857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1235:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2857,
        GIR_EraseRootFromParent_Done,
      // Label 4207: @211491
      GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(211533), // Rule ID 2859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1233:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2859,
        GIR_EraseRootFromParent_Done,
      // Label 4208: @211533
      GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(211575), // Rule ID 2867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1270:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2867,
        GIR_EraseRootFromParent_Done,
      // Label 4209: @211575
      GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(211617), // Rule ID 2868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1270:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2868,
        GIR_EraseRootFromParent_Done,
      // Label 4210: @211617
      GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(211659), // Rule ID 2869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1270:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2869,
        GIR_EraseRootFromParent_Done,
      // Label 4211: @211659
      GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(211701), // Rule ID 2873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1248:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2873,
        GIR_EraseRootFromParent_Done,
      // Label 4212: @211701
      GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(211743), // Rule ID 2926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2926,
        GIR_EraseRootFromParent_Done,
      // Label 4213: @211743
      GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(211785), // Rule ID 2927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2927,
        GIR_EraseRootFromParent_Done,
      // Label 4214: @211785
      GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(211827), // Rule ID 2956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1643:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2956,
        GIR_EraseRootFromParent_Done,
      // Label 4215: @211827
      GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(211869), // Rule ID 2957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1643:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2957,
        GIR_EraseRootFromParent_Done,
      // Label 4216: @211869
      GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(211911), // Rule ID 2958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1643:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2958,
        GIR_EraseRootFromParent_Done,
      // Label 4217: @211911
      GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(211953), // Rule ID 2959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1643:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2959,
        GIR_EraseRootFromParent_Done,
      // Label 4218: @211953
      GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(211995), // Rule ID 2960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1564:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2960,
        GIR_EraseRootFromParent_Done,
      // Label 4219: @211995
      GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(212037), // Rule ID 2961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1564:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2961,
        GIR_EraseRootFromParent_Done,
      // Label 4220: @212037
      GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(212079), // Rule ID 2962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1564:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2962,
        GIR_EraseRootFromParent_Done,
      // Label 4221: @212079
      GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(212121), // Rule ID 2992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1538:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2992,
        GIR_EraseRootFromParent_Done,
      // Label 4222: @212121
      GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(212163), // Rule ID 2994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1538:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2994,
        GIR_EraseRootFromParent_Done,
      // Label 4223: @212163
      GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(212205), // Rule ID 2996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1538:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2996,
        GIR_EraseRootFromParent_Done,
      // Label 4224: @212205
      GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(212247), // Rule ID 2998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1538:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2998,
        GIR_EraseRootFromParent_Done,
      // Label 4225: @212247
      GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(212289), // Rule ID 3000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1508:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3000,
        GIR_EraseRootFromParent_Done,
      // Label 4226: @212289
      GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(212331), // Rule ID 3001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1508:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3001,
        GIR_EraseRootFromParent_Done,
      // Label 4227: @212331
      GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(212373), // Rule ID 3002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1508:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3002,
        GIR_EraseRootFromParent_Done,
      // Label 4228: @212373
      GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(212415), // Rule ID 3003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3003,
        GIR_EraseRootFromParent_Done,
      // Label 4229: @212415
      GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(212457), // Rule ID 3004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1580:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3004,
        GIR_EraseRootFromParent_Done,
      // Label 4230: @212457
      GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(212499), // Rule ID 3005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1580:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3005,
        GIR_EraseRootFromParent_Done,
      // Label 4231: @212499
      GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(212541), // Rule ID 3006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1580:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3006,
        GIR_EraseRootFromParent_Done,
      // Label 4232: @212541
      GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(212583), // Rule ID 3007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1580:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3007,
        GIR_EraseRootFromParent_Done,
      // Label 4233: @212583
      GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(212625), // Rule ID 3024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1199:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3024,
        GIR_EraseRootFromParent_Done,
      // Label 4234: @212625
      GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(212667), // Rule ID 3025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1199:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3025,
        GIR_EraseRootFromParent_Done,
      // Label 4235: @212667
      GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(212709), // Rule ID 3026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1199:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3026,
        GIR_EraseRootFromParent_Done,
      // Label 4236: @212709
      GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(212751), // Rule ID 3027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1199:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3027,
        GIR_EraseRootFromParent_Done,
      // Label 4237: @212751
      GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(212793), // Rule ID 3051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1501:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3051,
        GIR_EraseRootFromParent_Done,
      // Label 4238: @212793
      GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(212835), // Rule ID 3053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1501:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3053,
        GIR_EraseRootFromParent_Done,
      // Label 4239: @212835
      GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(212877), // Rule ID 3055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1501:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3055,
        GIR_EraseRootFromParent_Done,
      // Label 4240: @212877
      GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(212919), // Rule ID 3057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1501:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3057,
        GIR_EraseRootFromParent_Done,
      // Label 4241: @212919
      GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(212961), // Rule ID 3059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1502:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3059,
        GIR_EraseRootFromParent_Done,
      // Label 4242: @212961
      GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(213003), // Rule ID 3060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1502:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3060,
        GIR_EraseRootFromParent_Done,
      // Label 4243: @213003
      GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(213045), // Rule ID 3061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1502:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3061,
        GIR_EraseRootFromParent_Done,
      // Label 4244: @213045
      GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(213087), // Rule ID 3062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1091:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3062,
        GIR_EraseRootFromParent_Done,
      // Label 4245: @213087
      GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(213129), // Rule ID 3063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1091:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3063,
        GIR_EraseRootFromParent_Done,
      // Label 4246: @213129
      GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(213171), // Rule ID 3073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1098:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3073,
        GIR_EraseRootFromParent_Done,
      // Label 4247: @213171
      GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(213213), // Rule ID 3074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1098:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3074,
        GIR_EraseRootFromParent_Done,
      // Label 4248: @213213
      GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(213255), // Rule ID 3075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1098:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3075,
        GIR_EraseRootFromParent_Done,
      // Label 4249: @213255
      GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(213297), // Rule ID 3096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3096,
        GIR_EraseRootFromParent_Done,
      // Label 4250: @213297
      GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(213339), // Rule ID 3097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3097,
        GIR_EraseRootFromParent_Done,
      // Label 4251: @213339
      GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(213381), // Rule ID 3098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3098,
        GIR_EraseRootFromParent_Done,
      // Label 4252: @213381
      GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(213423), // Rule ID 3099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1157:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3099,
        GIR_EraseRootFromParent_Done,
      // Label 4253: @213423
      GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(213465), // Rule ID 3140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1198:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3140,
        GIR_EraseRootFromParent_Done,
      // Label 4254: @213465
      GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(213507), // Rule ID 3142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1198:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3142,
        GIR_EraseRootFromParent_Done,
      // Label 4255: @213507
      GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(213549), // Rule ID 3144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1198:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3144,
        GIR_EraseRootFromParent_Done,
      // Label 4256: @213549
      GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(213591), // Rule ID 3146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1198:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3146,
        GIR_EraseRootFromParent_Done,
      // Label 4257: @213591
      GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(213636), // Rule ID 3179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1162:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3179,
        GIR_EraseRootFromParent_Done,
      // Label 4258: @213636
      GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(213681), // Rule ID 3180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1162:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3180,
        GIR_EraseRootFromParent_Done,
      // Label 4259: @213681
      GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(213726), // Rule ID 3181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1162:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3181,
        GIR_EraseRootFromParent_Done,
      // Label 4260: @213726
      GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(213771), // Rule ID 3182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1164:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3182,
        GIR_EraseRootFromParent_Done,
      // Label 4261: @213771
      GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(213816), // Rule ID 3183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1164:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3183,
        GIR_EraseRootFromParent_Done,
      // Label 4262: @213816
      GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(213861), // Rule ID 3184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1164:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3184,
        GIR_EraseRootFromParent_Done,
      // Label 4263: @213861
      GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(213903), // Rule ID 3239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1208:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3239,
        GIR_EraseRootFromParent_Done,
      // Label 4264: @213903
      GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(213945), // Rule ID 3240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1208:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3240,
        GIR_EraseRootFromParent_Done,
      // Label 4265: @213945
      GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(213987), // Rule ID 3241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1208:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3241,
        GIR_EraseRootFromParent_Done,
      // Label 4266: @213987
      GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(214029), // Rule ID 3293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1114:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3293,
        GIR_EraseRootFromParent_Done,
      // Label 4267: @214029
      GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(214071), // Rule ID 3294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1114:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3294,
        GIR_EraseRootFromParent_Done,
      // Label 4268: @214071
      GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(214113), // Rule ID 3295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1114:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3295,
        GIR_EraseRootFromParent_Done,
      // Label 4269: @214113
      GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(214155), // Rule ID 3296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1114:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3296,
        GIR_EraseRootFromParent_Done,
      // Label 4270: @214155
      GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(214197), // Rule ID 3305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1116:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3305,
        GIR_EraseRootFromParent_Done,
      // Label 4271: @214197
      GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(214239), // Rule ID 3306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1116:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3306,
        GIR_EraseRootFromParent_Done,
      // Label 4272: @214239
      GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(214281), // Rule ID 3307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1116:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3307,
        GIR_EraseRootFromParent_Done,
      // Label 4273: @214281
      GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(214323), // Rule ID 3347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3347,
        GIR_EraseRootFromParent_Done,
      // Label 4274: @214323
      GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(214365), // Rule ID 3348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1153:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3348,
        GIR_EraseRootFromParent_Done,
      // Label 4275: @214365
      GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(214407), // Rule ID 3349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1153:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3349,
        GIR_EraseRootFromParent_Done,
      // Label 4276: @214407
      GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(214449), // Rule ID 3350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1153:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3350,
        GIR_EraseRootFromParent_Done,
      // Label 4277: @214449
      GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(214491), // Rule ID 3351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1153:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3351,
        GIR_EraseRootFromParent_Done,
      // Label 4278: @214491
      GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(214533), // Rule ID 3352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1153:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3352,
        GIR_EraseRootFromParent_Done,
      // Label 4279: @214533
      GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(214575), // Rule ID 3353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1153:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3353,
        GIR_EraseRootFromParent_Done,
      // Label 4280: @214575
      GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(214617), // Rule ID 3354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1153:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3354,
        GIR_EraseRootFromParent_Done,
      // Label 4281: @214617
      GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(214659), // Rule ID 3439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1145:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3439,
        GIR_EraseRootFromParent_Done,
      // Label 4282: @214659
      GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(214701), // Rule ID 3440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1144:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3440,
        GIR_EraseRootFromParent_Done,
      // Label 4283: @214701
      GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(214743), // Rule ID 3441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1140:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3441,
        GIR_EraseRootFromParent_Done,
      // Label 4284: @214743
      GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(214788), // Rule ID 3443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1421:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3443,
        GIR_EraseRootFromParent_Done,
      // Label 4285: @214788
      GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(214833), // Rule ID 3444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1421:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3444,
        GIR_EraseRootFromParent_Done,
      // Label 4286: @214833
      GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(214875), // Rule ID 3445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3445,
        GIR_EraseRootFromParent_Done,
      // Label 4287: @214875
      GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(214917), // Rule ID 3446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3446,
        GIR_EraseRootFromParent_Done,
      // Label 4288: @214917
      GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(214959), // Rule ID 3450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1125:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFDOT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3450,
        GIR_EraseRootFromParent_Done,
      // Label 4289: @214959
      GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(215001), // Rule ID 3452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_bf16f32_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1232:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (BFCVT_ZPmZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVT_ZPmZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3452,
        GIR_EraseRootFromParent_Done,
      // Label 4290: @215001
      GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(215043), // Rule ID 3455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1572:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3455,
        GIR_EraseRootFromParent_Done,
      // Label 4291: @215043
      GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(215085), // Rule ID 3458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1135:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMMLA_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3458,
        GIR_EraseRootFromParent_Done,
      // Label 4292: @215085
      GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(215127), // Rule ID 3502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1221:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3502,
        GIR_EraseRootFromParent_Done,
      // Label 4293: @215127
      GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(215169), // Rule ID 3504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1221:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3504,
        GIR_EraseRootFromParent_Done,
      // Label 4294: @215169
      GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(215211), // Rule ID 3506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1221:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3506,
        GIR_EraseRootFromParent_Done,
      // Label 4295: @215211
      GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(215253), // Rule ID 3508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1221:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFCLAMP_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCLAMP_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3508,
        GIR_EraseRootFromParent_Done,
      // Label 4296: @215253
      GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(215295), // Rule ID 3510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1533:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3510,
        GIR_EraseRootFromParent_Done,
      // Label 4297: @215295
      GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(215337), // Rule ID 3626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1517:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3626,
        GIR_EraseRootFromParent_Done,
      // Label 4298: @215337
      GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(215379), // Rule ID 3628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1517:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3628,
        GIR_EraseRootFromParent_Done,
      // Label 4299: @215379
      GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(215421), // Rule ID 3630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1517:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3630,
        GIR_EraseRootFromParent_Done,
      // Label 4300: @215421
      GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(215463), // Rule ID 3632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1517:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3632,
        GIR_EraseRootFromParent_Done,
      // Label 4301: @215463
      GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(215505), // Rule ID 7624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7624,
        GIR_EraseRootFromParent_Done,
      // Label 4302: @215505
      GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(215547), // Rule ID 7626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7626,
        GIR_EraseRootFromParent_Done,
      // Label 4303: @215547
      GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(215589), // Rule ID 7628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7628,
        GIR_EraseRootFromParent_Done,
      // Label 4304: @215589
      GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(215631), // Rule ID 7630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1726:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7630,
        GIR_EraseRootFromParent_Done,
      // Label 4305: @215631
      GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(215673), // Rule ID 7648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1137:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7648,
        GIR_EraseRootFromParent_Done,
      // Label 4306: @215673
      GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(215715), // Rule ID 7649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1137:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7649,
        GIR_EraseRootFromParent_Done,
      // Label 4307: @215715
      GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(215757), // Rule ID 7650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1137:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7650,
        GIR_EraseRootFromParent_Done,
      // Label 4308: @215757
      GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(215799), // Rule ID 7651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1137:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7651,
        GIR_EraseRootFromParent_Done,
      // Label 4309: @215799
      GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(215841), // Rule ID 7764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1573:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7764,
        GIR_EraseRootFromParent_Done,
      // Label 4310: @215841
      GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(215883), // Rule ID 7765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1573:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7765,
        GIR_EraseRootFromParent_Done,
      // Label 4311: @215883
      GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(215925), // Rule ID 7766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1573:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7766,
        GIR_EraseRootFromParent_Done,
      // Label 4312: @215925
      GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(215967), // Rule ID 7767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1573:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7767,
        GIR_EraseRootFromParent_Done,
      // Label 4313: @215967
      GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(216009), // Rule ID 7768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7768,
        GIR_EraseRootFromParent_Done,
      // Label 4314: @216009
      GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(216051), // Rule ID 7769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7769,
        GIR_EraseRootFromParent_Done,
      // Label 4315: @216051
      GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(216093), // Rule ID 7770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7770,
        GIR_EraseRootFromParent_Done,
      // Label 4316: @216093
      GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(216135), // Rule ID 7771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7771,
        GIR_EraseRootFromParent_Done,
      // Label 4317: @216135
      GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(216177), // Rule ID 7780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7780,
        GIR_EraseRootFromParent_Done,
      // Label 4318: @216177
      GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(216219), // Rule ID 7781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7781,
        GIR_EraseRootFromParent_Done,
      // Label 4319: @216219
      GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(216261), // Rule ID 7782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1529:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7782,
        GIR_EraseRootFromParent_Done,
      // Label 4320: @216261
      GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(216303), // Rule ID 7783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1529:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7783,
        GIR_EraseRootFromParent_Done,
      // Label 4321: @216303
      GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(216345), // Rule ID 7784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7784,
        GIR_EraseRootFromParent_Done,
      // Label 4322: @216345
      GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(216387), // Rule ID 7785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7785,
        GIR_EraseRootFromParent_Done,
      // Label 4323: @216387
      GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(216429), // Rule ID 7854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1177:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7854,
        GIR_EraseRootFromParent_Done,
      // Label 4324: @216429
      GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(216471), // Rule ID 7855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1177:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7855,
        GIR_EraseRootFromParent_Done,
      // Label 4325: @216471
      GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(216513), // Rule ID 7856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1177:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7856,
        GIR_EraseRootFromParent_Done,
      // Label 4326: @216513
      GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(216555), // Rule ID 7857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1177:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7857,
        GIR_EraseRootFromParent_Done,
      // Label 4327: @216555
      GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(216597), // Rule ID 7866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1437:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7866,
        GIR_EraseRootFromParent_Done,
      // Label 4328: @216597
      GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(216639), // Rule ID 7867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1437:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7867,
        GIR_EraseRootFromParent_Done,
      // Label 4329: @216639
      GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(216681), // Rule ID 7868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1437:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7868,
        GIR_EraseRootFromParent_Done,
      // Label 4330: @216681
      GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(216723), // Rule ID 7869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1437:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7869,
        GIR_EraseRootFromParent_Done,
      // Label 4331: @216723
      GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(216765), // Rule ID 7970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1504:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7970,
        GIR_EraseRootFromParent_Done,
      // Label 4332: @216765
      GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(216807), // Rule ID 7971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1504:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7971,
        GIR_EraseRootFromParent_Done,
      // Label 4333: @216807
      GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(216849), // Rule ID 7972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1504:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7972,
        GIR_EraseRootFromParent_Done,
      // Label 4334: @216849
      GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(216891), // Rule ID 7973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1504:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7973,
        GIR_EraseRootFromParent_Done,
      // Label 4335: @216891
      GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(216933), // Rule ID 7974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1754:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7974,
        GIR_EraseRootFromParent_Done,
      // Label 4336: @216933
      GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(216975), // Rule ID 7975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7975,
        GIR_EraseRootFromParent_Done,
      // Label 4337: @216975
      GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(217017), // Rule ID 7976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7976,
        GIR_EraseRootFromParent_Done,
      // Label 4338: @217017
      GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(217059), // Rule ID 7977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7977,
        GIR_EraseRootFromParent_Done,
      // Label 4339: @217059
      GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(217101), // Rule ID 8173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8173,
        GIR_EraseRootFromParent_Done,
      // Label 4340: @217101
      GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(217143), // Rule ID 8175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8175,
        GIR_EraseRootFromParent_Done,
      // Label 4341: @217143
      GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(217185), // Rule ID 8177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8177,
        GIR_EraseRootFromParent_Done,
      // Label 4342: @217185
      GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(217227), // Rule ID 8185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8185,
        GIR_EraseRootFromParent_Done,
      // Label 4343: @217227
      GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(217269), // Rule ID 8187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8187,
        GIR_EraseRootFromParent_Done,
      // Label 4344: @217269
      GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(217311), // Rule ID 8189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8189,
        GIR_EraseRootFromParent_Done,
      // Label 4345: @217311
      GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(217353), // Rule ID 8227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1205:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8227,
        GIR_EraseRootFromParent_Done,
      // Label 4346: @217353
      GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(217395), // Rule ID 8228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1205:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8228,
        GIR_EraseRootFromParent_Done,
      // Label 4347: @217395
      GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(217437), // Rule ID 8229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1205:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8229,
        GIR_EraseRootFromParent_Done,
      // Label 4348: @217437
      GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(217479), // Rule ID 8230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8230,
        GIR_EraseRootFromParent_Done,
      // Label 4349: @217479
      GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(217521), // Rule ID 8231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8231,
        GIR_EraseRootFromParent_Done,
      // Label 4350: @217521
      GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(217563), // Rule ID 8232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8232,
        GIR_EraseRootFromParent_Done,
      // Label 4351: @217563
      GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(217605), // Rule ID 8233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1266:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8233,
        GIR_EraseRootFromParent_Done,
      // Label 4352: @217605
      GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(217647), // Rule ID 8234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1266:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8234,
        GIR_EraseRootFromParent_Done,
      // Label 4353: @217647
      GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(217689), // Rule ID 8235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1266:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8235,
        GIR_EraseRootFromParent_Done,
      // Label 4354: @217689
      GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(217731), // Rule ID 8236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8236,
        GIR_EraseRootFromParent_Done,
      // Label 4355: @217731
      GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(217773), // Rule ID 8237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8237,
        GIR_EraseRootFromParent_Done,
      // Label 4356: @217773
      GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(217815), // Rule ID 8238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8238,
        GIR_EraseRootFromParent_Done,
      // Label 4357: @217815
      GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(217857), // Rule ID 8275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1206:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8275,
        GIR_EraseRootFromParent_Done,
      // Label 4358: @217857
      GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(217899), // Rule ID 8277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1206:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8277,
        GIR_EraseRootFromParent_Done,
      // Label 4359: @217899
      GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(217941), // Rule ID 8279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1206:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8279,
        GIR_EraseRootFromParent_Done,
      // Label 4360: @217941
      GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(217983), // Rule ID 8281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1206:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8281,
        GIR_EraseRootFromParent_Done,
      // Label 4361: @217983
      GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(218025), // Rule ID 8283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1206:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8283,
        GIR_EraseRootFromParent_Done,
      // Label 4362: @218025
      GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(218067), // Rule ID 8285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1206:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8285,
        GIR_EraseRootFromParent_Done,
      // Label 4363: @218067
      GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(218109), // Rule ID 8287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1328:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8287,
        GIR_EraseRootFromParent_Done,
      // Label 4364: @218109
      GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(218151), // Rule ID 8288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1328:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8288,
        GIR_EraseRootFromParent_Done,
      // Label 4365: @218151
      GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(218193), // Rule ID 8289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1328:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8289,
        GIR_EraseRootFromParent_Done,
      // Label 4366: @218193
      GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(218235), // Rule ID 8290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1328:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8290,
        GIR_EraseRootFromParent_Done,
      // Label 4367: @218235
      GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(218277), // Rule ID 8291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1328:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8291,
        GIR_EraseRootFromParent_Done,
      // Label 4368: @218277
      GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(218319), // Rule ID 8292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1328:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8292,
        GIR_EraseRootFromParent_Done,
      // Label 4369: @218319
      GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(218361), // Rule ID 8566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1146:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8566,
        GIR_EraseRootFromParent_Done,
      // Label 4370: @218361
      GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(218403), // Rule ID 8568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1142:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8568,
        GIR_EraseRootFromParent_Done,
      // Label 4371: @218403
      GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(218445), // Rule ID 8569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1139:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8569,
        GIR_EraseRootFromParent_Done,
      // Label 4372: @218445
      GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(218487), // Rule ID 8570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1139:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8570,
        GIR_EraseRootFromParent_Done,
      // Label 4373: @218487
      GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(218529), // Rule ID 8571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1139:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8571,
        GIR_EraseRootFromParent_Done,
      // Label 4374: @218529
      GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(218571), // Rule ID 8572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1139:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8572,
        GIR_EraseRootFromParent_Done,
      // Label 4375: @218571
      GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(218613), // Rule ID 8573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1139:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8573,
        GIR_EraseRootFromParent_Done,
      // Label 4376: @218613
      GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(218655), // Rule ID 8594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1197:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8594,
        GIR_EraseRootFromParent_Done,
      // Label 4377: @218655
      GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(218697), // Rule ID 8595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1197:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8595,
        GIR_EraseRootFromParent_Done,
      // Label 4378: @218697
      GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(218739), // Rule ID 8596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1197:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8596,
        GIR_EraseRootFromParent_Done,
      // Label 4379: @218739
      GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(218781), // Rule ID 8597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1197:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8597,
        GIR_EraseRootFromParent_Done,
      // Label 4380: @218781
      GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(218823), // Rule ID 8598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1197:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8598,
        GIR_EraseRootFromParent_Done,
      // Label 4381: @218823
      GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(218865), // Rule ID 8614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1442:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8614,
        GIR_EraseRootFromParent_Done,
      // Label 4382: @218865
      GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(218907), // Rule ID 8615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1442:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8615,
        GIR_EraseRootFromParent_Done,
      // Label 4383: @218907
      GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(218949), // Rule ID 8616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1442:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8616,
        GIR_EraseRootFromParent_Done,
      // Label 4384: @218949
      GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(218991), // Rule ID 8617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1442:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8617,
        GIR_EraseRootFromParent_Done,
      // Label 4385: @218991
      GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(219033), // Rule ID 8618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1442:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8618,
        GIR_EraseRootFromParent_Done,
      // Label 4386: @219033
      GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(219075), // Rule ID 8619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1438:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8619,
        GIR_EraseRootFromParent_Done,
      // Label 4387: @219075
      GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(219117), // Rule ID 8620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8620,
        GIR_EraseRootFromParent_Done,
      // Label 4388: @219117
      GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(219159), // Rule ID 8621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8621,
        GIR_EraseRootFromParent_Done,
      // Label 4389: @219159
      GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(219201), // Rule ID 8622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8622,
        GIR_EraseRootFromParent_Done,
      // Label 4390: @219201
      GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(219243), // Rule ID 8623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1438:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8623,
        GIR_EraseRootFromParent_Done,
      // Label 4391: @219243
      GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(219285), // Rule ID 8624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1436:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8624,
        GIR_EraseRootFromParent_Done,
      // Label 4392: @219285
      GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(219327), // Rule ID 8625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1436:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8625,
        GIR_EraseRootFromParent_Done,
      // Label 4393: @219327
      GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(219369), // Rule ID 8626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1436:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8626,
        GIR_EraseRootFromParent_Done,
      // Label 4394: @219369
      GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(219411), // Rule ID 8627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1436:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8627,
        GIR_EraseRootFromParent_Done,
      // Label 4395: @219411
      GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(219453), // Rule ID 8628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1436:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8628,
        GIR_EraseRootFromParent_Done,
      // Label 4396: @219453
      GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(219495), // Rule ID 8629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1432:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8629,
        GIR_EraseRootFromParent_Done,
      // Label 4397: @219495
      GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(219537), // Rule ID 8630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1432:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8630,
        GIR_EraseRootFromParent_Done,
      // Label 4398: @219537
      GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(219579), // Rule ID 8631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1432:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8631,
        GIR_EraseRootFromParent_Done,
      // Label 4399: @219579
      GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(219621), // Rule ID 8632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1432:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8632,
        GIR_EraseRootFromParent_Done,
      // Label 4400: @219621
      GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(219663), // Rule ID 8633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1432:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8633,
        GIR_EraseRootFromParent_Done,
      // Label 4401: @219663
      GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(219705), // Rule ID 8642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1155:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8642,
        GIR_EraseRootFromParent_Done,
      // Label 4402: @219705
      GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(219747), // Rule ID 8643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1155:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8643,
        GIR_EraseRootFromParent_Done,
      // Label 4403: @219747
      GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(219789), // Rule ID 8644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1155:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8644,
        GIR_EraseRootFromParent_Done,
      // Label 4404: @219789
      GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(219831), // Rule ID 8645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1155:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8645,
        GIR_EraseRootFromParent_Done,
      // Label 4405: @219831
      GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(219873), // Rule ID 8646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1155:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8646,
        GIR_EraseRootFromParent_Done,
      // Label 4406: @219873
      GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(219915), // Rule ID 8647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1155:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8647,
        GIR_EraseRootFromParent_Done,
      // Label 4407: @219915
      GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(219957), // Rule ID 8648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1155:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8648,
        GIR_EraseRootFromParent_Done,
      // Label 4408: @219957
      GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(219999), // Rule ID 8649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1155:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8649,
        GIR_EraseRootFromParent_Done,
      // Label 4409: @219999
      GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(220044), // Rule ID 9398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1176:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9398,
        GIR_EraseRootFromParent_Done,
      // Label 4410: @220044
      GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(220089), // Rule ID 9399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1176:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9399,
        GIR_EraseRootFromParent_Done,
      // Label 4411: @220089
      GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(220134), // Rule ID 9400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1176:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9400,
        GIR_EraseRootFromParent_Done,
      // Label 4412: @220134
      GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(220179), // Rule ID 9401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1166:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9401,
        GIR_EraseRootFromParent_Done,
      // Label 4413: @220179
      GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(220224), // Rule ID 9402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1166:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9402,
        GIR_EraseRootFromParent_Done,
      // Label 4414: @220224
      GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(220269), // Rule ID 9403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1166:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9403,
        GIR_EraseRootFromParent_Done,
      // Label 4415: @220269
      GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(220314), // Rule ID 9404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1174:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9404,
        GIR_EraseRootFromParent_Done,
      // Label 4416: @220314
      GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(220359), // Rule ID 9405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1174:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9405,
        GIR_EraseRootFromParent_Done,
      // Label 4417: @220359
      GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(220404), // Rule ID 9406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1174:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9406,
        GIR_EraseRootFromParent_Done,
      // Label 4418: @220404
      GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(220449), // Rule ID 9407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1171:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9407,
        GIR_EraseRootFromParent_Done,
      // Label 4419: @220449
      GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(220494), // Rule ID 9408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1171:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9408,
        GIR_EraseRootFromParent_Done,
      // Label 4420: @220494
      GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(220539), // Rule ID 9409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1171:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9409,
        GIR_EraseRootFromParent_Done,
      // Label 4421: @220539
      GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(220584), // Rule ID 9410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1170:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9410,
        GIR_EraseRootFromParent_Done,
      // Label 4422: @220584
      GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(220629), // Rule ID 9411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1170:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9411,
        GIR_EraseRootFromParent_Done,
      // Label 4423: @220629
      GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(220674), // Rule ID 9412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1170:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9412,
        GIR_EraseRootFromParent_Done,
      // Label 4424: @220674
      GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(220719), // Rule ID 9413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1168:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9413,
        GIR_EraseRootFromParent_Done,
      // Label 4425: @220719
      GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(220764), // Rule ID 9414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1168:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9414,
        GIR_EraseRootFromParent_Done,
      // Label 4426: @220764
      GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(220809), // Rule ID 9415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1168:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9415,
        GIR_EraseRootFromParent_Done,
      // Label 4427: @220809
      GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(220854), // Rule ID 9416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1172:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9416,
        GIR_EraseRootFromParent_Done,
      // Label 4428: @220854
      GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(220899), // Rule ID 9417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1172:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9417,
        GIR_EraseRootFromParent_Done,
      // Label 4429: @220899
      GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(220944), // Rule ID 9418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1172:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9418,
        GIR_EraseRootFromParent_Done,
      // Label 4430: @220944
      GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(220989), // Rule ID 9419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1173:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9419,
        GIR_EraseRootFromParent_Done,
      // Label 4431: @220989
      GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(221034), // Rule ID 9420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1173:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9420,
        GIR_EraseRootFromParent_Done,
      // Label 4432: @221034
      GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(221079), // Rule ID 9421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1173:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9421,
        GIR_EraseRootFromParent_Done,
      // Label 4433: @221079
      GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(221121), // Rule ID 9818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1209:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9818,
        GIR_EraseRootFromParent_Done,
      // Label 4434: @221121
      GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(221163), // Rule ID 9819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1209:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9819,
        GIR_EraseRootFromParent_Done,
      // Label 4435: @221163
      GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(221205), // Rule ID 9820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1209:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9820,
        GIR_EraseRootFromParent_Done,
      // Label 4436: @221205
      GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(221247), // Rule ID 10358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1414:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10358,
        GIR_EraseRootFromParent_Done,
      // Label 4437: @221247
      GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(221289), // Rule ID 10359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1414:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10359,
        GIR_EraseRootFromParent_Done,
      // Label 4438: @221289
      GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(221331), // Rule ID 10360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1414:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10360,
        GIR_EraseRootFromParent_Done,
      // Label 4439: @221331
      GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(221373), // Rule ID 10361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10361,
        GIR_EraseRootFromParent_Done,
      // Label 4440: @221373
      GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(221415), // Rule ID 10362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1411:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10362,
        GIR_EraseRootFromParent_Done,
      // Label 4441: @221415
      GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(221457), // Rule ID 10363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1411:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10363,
        GIR_EraseRootFromParent_Done,
      // Label 4442: @221457
      GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(221499), // Rule ID 10364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10364,
        GIR_EraseRootFromParent_Done,
      // Label 4443: @221499
      GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(221541), // Rule ID 10365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1411:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10365,
        GIR_EraseRootFromParent_Done,
      // Label 4444: @221541
      GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(221583), // Rule ID 10378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1416:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10378,
        GIR_EraseRootFromParent_Done,
      // Label 4445: @221583
      GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(221625), // Rule ID 10379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1416:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10379,
        GIR_EraseRootFromParent_Done,
      // Label 4446: @221625
      GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(221667), // Rule ID 10380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1416:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10380,
        GIR_EraseRootFromParent_Done,
      // Label 4447: @221667
      GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(221709), // Rule ID 10381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1413:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10381,
        GIR_EraseRootFromParent_Done,
      // Label 4448: @221709
      GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(221751), // Rule ID 10382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1413:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10382,
        GIR_EraseRootFromParent_Done,
      // Label 4449: @221751
      GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(221793), // Rule ID 10383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1413:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10383,
        GIR_EraseRootFromParent_Done,
      // Label 4450: @221793
      GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(221835), // Rule ID 10410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1234:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10410,
        GIR_EraseRootFromParent_Done,
      // Label 4451: @221835
      GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(221877), // Rule ID 10414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1237:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10414,
        GIR_EraseRootFromParent_Done,
      // Label 4452: @221877
      GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(221919), // Rule ID 10418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1236:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10418,
        GIR_EraseRootFromParent_Done,
      // Label 4453: @221919
      GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(221961), // Rule ID 10422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1238:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10422,
        GIR_EraseRootFromParent_Done,
      // Label 4454: @221961
      GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(222003), // Rule ID 10426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1524:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10426,
        GIR_EraseRootFromParent_Done,
      // Label 4455: @222003
      GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(222045), // Rule ID 10430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1771:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10430,
        GIR_EraseRootFromParent_Done,
      // Label 4456: @222045
      GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(222087), // Rule ID 10434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1768:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10434,
        GIR_EraseRootFromParent_Done,
      // Label 4457: @222087
      GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(222129), // Rule ID 10438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10438,
        GIR_EraseRootFromParent_Done,
      // Label 4458: @222129
      GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(222171), // Rule ID 10442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1521:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10442,
        GIR_EraseRootFromParent_Done,
      // Label 4459: @222171
      GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(222213), // Rule ID 10446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1522:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10446,
        GIR_EraseRootFromParent_Done,
      // Label 4460: @222213
      GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(222255), // Rule ID 10450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1770:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10450,
        GIR_EraseRootFromParent_Done,
      // Label 4461: @222255
      GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(222297), // Rule ID 10454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1769:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10454,
        GIR_EraseRootFromParent_Done,
      // Label 4462: @222297
      GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(222339), // Rule ID 10464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10464,
        GIR_EraseRootFromParent_Done,
      // Label 4463: @222339
      GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(222381), // Rule ID 10465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10465,
        GIR_EraseRootFromParent_Done,
      // Label 4464: @222381
      GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(222423), // Rule ID 10466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10466,
        GIR_EraseRootFromParent_Done,
      // Label 4465: @222423
      GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(222465), // Rule ID 10470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10470,
        GIR_EraseRootFromParent_Done,
      // Label 4466: @222465
      GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(222507), // Rule ID 10474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1253:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10474,
        GIR_EraseRootFromParent_Done,
      // Label 4467: @222507
      GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(222549), // Rule ID 10478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10478,
        GIR_EraseRootFromParent_Done,
      // Label 4468: @222549
      GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(222591), // Rule ID 10482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10482,
        GIR_EraseRootFromParent_Done,
      // Label 4469: @222591
      GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(222633), // Rule ID 10486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1261:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10486,
        GIR_EraseRootFromParent_Done,
      // Label 4470: @222633
      GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(222675), // Rule ID 10666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1129:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLALT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10666,
        GIR_EraseRootFromParent_Done,
      // Label 4471: @222675
      GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(222717), // Rule ID 10668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_bf16f32_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1245:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (BFCVTNT_ZPmZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTNT_ZPmZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10668,
        GIR_EraseRootFromParent_Done,
      // Label 4472: @222717
      GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(222759), // Rule ID 11543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11543,
        GIR_EraseRootFromParent_Done,
      // Label 4473: @222759
      GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(222801), // Rule ID 11544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1881:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11544,
        GIR_EraseRootFromParent_Done,
      // Label 4474: @222801
      GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(222843), // Rule ID 11546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1322:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11546,
        GIR_EraseRootFromParent_Done,
      // Label 4475: @222843
      GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(222885), // Rule ID 11547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1322:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11547,
        GIR_EraseRootFromParent_Done,
      // Label 4476: @222885
      GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(222927), // Rule ID 11606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1645:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11606,
        GIR_EraseRootFromParent_Done,
      // Label 4477: @222927
      GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(222969), // Rule ID 11607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1645:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11607,
        GIR_EraseRootFromParent_Done,
      // Label 4478: @222969
      GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(223011), // Rule ID 11608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1645:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11608,
        GIR_EraseRootFromParent_Done,
      // Label 4479: @223011
      GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(223053), // Rule ID 11609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1645:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11609,
        GIR_EraseRootFromParent_Done,
      // Label 4480: @223053
      GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(223095), // Rule ID 11662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1566:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11662,
        GIR_EraseRootFromParent_Done,
      // Label 4481: @223095
      GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(223137), // Rule ID 11663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1566:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11663,
        GIR_EraseRootFromParent_Done,
      // Label 4482: @223137
      GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(223179), // Rule ID 11664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11664,
        GIR_EraseRootFromParent_Done,
      // Label 4483: @223179
      GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(223221), // Rule ID 11665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11665,
        GIR_EraseRootFromParent_Done,
      // Label 4484: @223221
      GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(223263), // Rule ID 11666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11666,
        GIR_EraseRootFromParent_Done,
      // Label 4485: @223263
      GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(223305), // Rule ID 11667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11667,
        GIR_EraseRootFromParent_Done,
      // Label 4486: @223305
      GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(223347), // Rule ID 11668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11668,
        GIR_EraseRootFromParent_Done,
      // Label 4487: @223347
      GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(223389), // Rule ID 11669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11669,
        GIR_EraseRootFromParent_Done,
      // Label 4488: @223389
      GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(223431), // Rule ID 11670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11670,
        GIR_EraseRootFromParent_Done,
      // Label 4489: @223431
      GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(223473), // Rule ID 11671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1568:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11671,
        GIR_EraseRootFromParent_Done,
      // Label 4490: @223473
      GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(223515), // Rule ID 11672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11672,
        GIR_EraseRootFromParent_Done,
      // Label 4491: @223515
      GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(223557), // Rule ID 11673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1568:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11673,
        GIR_EraseRootFromParent_Done,
      // Label 4492: @223557
      GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(223599), // Rule ID 11674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1570:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11674,
        GIR_EraseRootFromParent_Done,
      // Label 4493: @223599
      GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(223641), // Rule ID 11675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1570:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11675,
        GIR_EraseRootFromParent_Done,
      // Label 4494: @223641
      GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(223683), // Rule ID 11676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1570:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11676,
        GIR_EraseRootFromParent_Done,
      // Label 4495: @223683
      GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(223725), // Rule ID 11677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1806:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11677,
        GIR_EraseRootFromParent_Done,
      // Label 4496: @223725
      GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(223767), // Rule ID 11678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1806:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11678,
        GIR_EraseRootFromParent_Done,
      // Label 4497: @223767
      GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(223809), // Rule ID 11679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1806:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11679,
        GIR_EraseRootFromParent_Done,
      // Label 4498: @223809
      GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(223851), // Rule ID 11680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11680,
        GIR_EraseRootFromParent_Done,
      // Label 4499: @223851
      GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(223893), // Rule ID 11681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11681,
        GIR_EraseRootFromParent_Done,
      // Label 4500: @223893
      GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(223935), // Rule ID 11682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11682,
        GIR_EraseRootFromParent_Done,
      // Label 4501: @223935
      GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(223977), // Rule ID 11691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11691,
        GIR_EraseRootFromParent_Done,
      // Label 4502: @223977
      GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(224019), // Rule ID 11692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11692,
        GIR_EraseRootFromParent_Done,
      // Label 4503: @224019
      GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(224061), // Rule ID 11693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11693,
        GIR_EraseRootFromParent_Done,
      // Label 4504: @224061
      GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(224103), // Rule ID 11694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11694,
        GIR_EraseRootFromParent_Done,
      // Label 4505: @224103
      GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(224145), // Rule ID 11695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11695,
        GIR_EraseRootFromParent_Done,
      // Label 4506: @224145
      GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(224187), // Rule ID 11696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11696,
        GIR_EraseRootFromParent_Done,
      // Label 4507: @224187
      GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(224229), // Rule ID 11697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11697,
        GIR_EraseRootFromParent_Done,
      // Label 4508: @224229
      GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(224271), // Rule ID 11698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11698,
        GIR_EraseRootFromParent_Done,
      // Label 4509: @224271
      GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(224313), // Rule ID 11699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11699,
        GIR_EraseRootFromParent_Done,
      // Label 4510: @224313
      GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(224355), // Rule ID 11700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11700,
        GIR_EraseRootFromParent_Done,
      // Label 4511: @224355
      GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(224397), // Rule ID 11701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11701,
        GIR_EraseRootFromParent_Done,
      // Label 4512: @224397
      GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(224439), // Rule ID 11702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11702,
        GIR_EraseRootFromParent_Done,
      // Label 4513: @224439
      GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(224481), // Rule ID 11703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11703,
        GIR_EraseRootFromParent_Done,
      // Label 4514: @224481
      GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(224523), // Rule ID 11704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11704,
        GIR_EraseRootFromParent_Done,
      // Label 4515: @224523
      GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(224565), // Rule ID 11705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11705,
        GIR_EraseRootFromParent_Done,
      // Label 4516: @224565
      GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(224607), // Rule ID 11706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11706,
        GIR_EraseRootFromParent_Done,
      // Label 4517: @224607
      GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(224649), // Rule ID 11707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11707,
        GIR_EraseRootFromParent_Done,
      // Label 4518: @224649
      GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(224691), // Rule ID 11708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11708,
        GIR_EraseRootFromParent_Done,
      // Label 4519: @224691
      GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(224733), // Rule ID 11709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1781:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11709,
        GIR_EraseRootFromParent_Done,
      // Label 4520: @224733
      GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(224775), // Rule ID 11711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1781:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11711,
        GIR_EraseRootFromParent_Done,
      // Label 4521: @224775
      GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(224817), // Rule ID 11713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1781:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11713,
        GIR_EraseRootFromParent_Done,
      // Label 4522: @224817
      GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(224859), // Rule ID 11715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1781:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11715,
        GIR_EraseRootFromParent_Done,
      // Label 4523: @224859
      GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(224901), // Rule ID 11717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1541:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11717,
        GIR_EraseRootFromParent_Done,
      // Label 4524: @224901
      GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(224943), // Rule ID 11718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11718,
        GIR_EraseRootFromParent_Done,
      // Label 4525: @224943
      GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(224985), // Rule ID 11719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11719,
        GIR_EraseRootFromParent_Done,
      // Label 4526: @224985
      GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(225027), // Rule ID 11720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1541:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11720,
        GIR_EraseRootFromParent_Done,
      // Label 4527: @225027
      GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(225069), // Rule ID 11721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1782:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11721,
        GIR_EraseRootFromParent_Done,
      // Label 4528: @225069
      GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(225111), // Rule ID 11722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1782:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11722,
        GIR_EraseRootFromParent_Done,
      // Label 4529: @225111
      GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(225153), // Rule ID 11723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11723,
        GIR_EraseRootFromParent_Done,
      // Label 4530: @225153
      GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(225195), // Rule ID 11724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1782:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11724,
        GIR_EraseRootFromParent_Done,
      // Label 4531: @225195
      GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(225237), // Rule ID 11725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1676:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11725,
        GIR_EraseRootFromParent_Done,
      // Label 4532: @225237
      GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(225279), // Rule ID 11727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11727,
        GIR_EraseRootFromParent_Done,
      // Label 4533: @225279
      GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(225321), // Rule ID 11729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11729,
        GIR_EraseRootFromParent_Done,
      // Label 4534: @225321
      GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(225363), // Rule ID 11731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1676:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11731,
        GIR_EraseRootFromParent_Done,
      // Label 4535: @225363
      GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(225405), // Rule ID 11733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1868:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11733,
        GIR_EraseRootFromParent_Done,
      // Label 4536: @225405
      GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(225447), // Rule ID 11735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11735,
        GIR_EraseRootFromParent_Done,
      // Label 4537: @225447
      GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(225489), // Rule ID 11737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11737,
        GIR_EraseRootFromParent_Done,
      // Label 4538: @225489
      GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(225531), // Rule ID 11739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11739,
        GIR_EraseRootFromParent_Done,
      // Label 4539: @225531
      GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(225573), // Rule ID 11741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1542:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11741,
        GIR_EraseRootFromParent_Done,
      // Label 4540: @225573
      GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(225615), // Rule ID 11742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1542:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11742,
        GIR_EraseRootFromParent_Done,
      // Label 4541: @225615
      GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(225657), // Rule ID 11743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1542:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11743,
        GIR_EraseRootFromParent_Done,
      // Label 4542: @225657
      GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(225699), // Rule ID 11744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1542:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11744,
        GIR_EraseRootFromParent_Done,
      // Label 4543: @225699
      GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(225741), // Rule ID 11745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1783:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11745,
        GIR_EraseRootFromParent_Done,
      // Label 4544: @225741
      GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(225783), // Rule ID 11746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1783:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11746,
        GIR_EraseRootFromParent_Done,
      // Label 4545: @225783
      GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(225825), // Rule ID 11747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1783:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11747,
        GIR_EraseRootFromParent_Done,
      // Label 4546: @225825
      GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(225867), // Rule ID 11748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1783:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11748,
        GIR_EraseRootFromParent_Done,
      // Label 4547: @225867
      GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(225909), // Rule ID 11749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1758:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11749,
        GIR_EraseRootFromParent_Done,
      // Label 4548: @225909
      GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(225951), // Rule ID 11750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11750,
        GIR_EraseRootFromParent_Done,
      // Label 4549: @225951
      GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(225993), // Rule ID 11751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1758:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11751,
        GIR_EraseRootFromParent_Done,
      // Label 4550: @225993
      GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(226035), // Rule ID 11752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1099:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11752,
        GIR_EraseRootFromParent_Done,
      // Label 4551: @226035
      GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(226077), // Rule ID 11753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1099:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11753,
        GIR_EraseRootFromParent_Done,
      // Label 4552: @226077
      GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(226119), // Rule ID 11754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1099:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11754,
        GIR_EraseRootFromParent_Done,
      // Label 4553: @226119
      GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(226161), // Rule ID 11755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1099:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11755,
        GIR_EraseRootFromParent_Done,
      // Label 4554: @226161
      GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(226203), // Rule ID 11756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1552:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11756,
        GIR_EraseRootFromParent_Done,
      // Label 4555: @226203
      GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(226245), // Rule ID 11757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1552:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11757,
        GIR_EraseRootFromParent_Done,
      // Label 4556: @226245
      GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(226287), // Rule ID 11758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1552:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11758,
        GIR_EraseRootFromParent_Done,
      // Label 4557: @226287
      GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(226329), // Rule ID 11759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11759,
        GIR_EraseRootFromParent_Done,
      // Label 4558: @226329
      GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(226371), // Rule ID 11760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1790:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11760,
        GIR_EraseRootFromParent_Done,
      // Label 4559: @226371
      GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(226413), // Rule ID 11761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1790:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11761,
        GIR_EraseRootFromParent_Done,
      // Label 4560: @226413
      GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(226455), // Rule ID 11762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11762,
        GIR_EraseRootFromParent_Done,
      // Label 4561: @226455
      GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(226497), // Rule ID 11763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11763,
        GIR_EraseRootFromParent_Done,
      // Label 4562: @226497
      GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(226539), // Rule ID 11764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1561:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11764,
        GIR_EraseRootFromParent_Done,
      // Label 4563: @226539
      GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(226581), // Rule ID 11765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1561:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11765,
        GIR_EraseRootFromParent_Done,
      // Label 4564: @226581
      GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(226623), // Rule ID 11766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1561:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11766,
        GIR_EraseRootFromParent_Done,
      // Label 4565: @226623
      GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(226665), // Rule ID 11767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1561:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11767,
        GIR_EraseRootFromParent_Done,
      // Label 4566: @226665
      GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(226707), // Rule ID 11768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1799:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11768,
        GIR_EraseRootFromParent_Done,
      // Label 4567: @226707
      GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(226749), // Rule ID 11769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11769,
        GIR_EraseRootFromParent_Done,
      // Label 4568: @226749
      GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(226791), // Rule ID 11770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11770,
        GIR_EraseRootFromParent_Done,
      // Label 4569: @226791
      GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(226833), // Rule ID 11771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11771,
        GIR_EraseRootFromParent_Done,
      // Label 4570: @226833
      GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(226875), // Rule ID 11772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11772,
        GIR_EraseRootFromParent_Done,
      // Label 4571: @226875
      GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(226917), // Rule ID 11783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1640:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11783,
        GIR_EraseRootFromParent_Done,
      // Label 4572: @226917
      GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(226959), // Rule ID 11784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1640:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11784,
        GIR_EraseRootFromParent_Done,
      // Label 4573: @226959
      GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(227001), // Rule ID 11785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1640:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11785,
        GIR_EraseRootFromParent_Done,
      // Label 4574: @227001
      GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(227043), // Rule ID 11786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1640:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11786,
        GIR_EraseRootFromParent_Done,
      // Label 4575: @227043
      GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(227085), // Rule ID 11795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1581:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11795,
        GIR_EraseRootFromParent_Done,
      // Label 4576: @227085
      GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(227127), // Rule ID 11796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1581:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11796,
        GIR_EraseRootFromParent_Done,
      // Label 4577: @227127
      GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(227169), // Rule ID 11797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1581:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11797,
        GIR_EraseRootFromParent_Done,
      // Label 4578: @227169
      GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(227211), // Rule ID 11798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1581:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11798,
        GIR_EraseRootFromParent_Done,
      // Label 4579: @227211
      GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(227253), // Rule ID 11799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1817:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11799,
        GIR_EraseRootFromParent_Done,
      // Label 4580: @227253
      GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(227295), // Rule ID 11800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11800,
        GIR_EraseRootFromParent_Done,
      // Label 4581: @227295
      GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(227337), // Rule ID 11801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11801,
        GIR_EraseRootFromParent_Done,
      // Label 4582: @227337
      GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(227379), // Rule ID 11802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11802,
        GIR_EraseRootFromParent_Done,
      // Label 4583: @227379
      GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(227421), // Rule ID 11803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1668:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11803,
        GIR_EraseRootFromParent_Done,
      // Label 4584: @227421
      GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(227463), // Rule ID 11804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1668:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11804,
        GIR_EraseRootFromParent_Done,
      // Label 4585: @227463
      GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(227505), // Rule ID 11805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1668:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11805,
        GIR_EraseRootFromParent_Done,
      // Label 4586: @227505
      GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(227547), // Rule ID 11806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1668:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11806,
        GIR_EraseRootFromParent_Done,
      // Label 4587: @227547
      GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(227589), // Rule ID 11807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11807,
        GIR_EraseRootFromParent_Done,
      // Label 4588: @227589
      GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(227631), // Rule ID 11808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11808,
        GIR_EraseRootFromParent_Done,
      // Label 4589: @227631
      GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(227673), // Rule ID 11809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11809,
        GIR_EraseRootFromParent_Done,
      // Label 4590: @227673
      GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(227715), // Rule ID 11810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11810,
        GIR_EraseRootFromParent_Done,
      // Label 4591: @227715
      GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(227757), // Rule ID 11811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11811,
        GIR_EraseRootFromParent_Done,
      // Label 4592: @227757
      GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(227799), // Rule ID 11812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11812,
        GIR_EraseRootFromParent_Done,
      // Label 4593: @227799
      GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(227841), // Rule ID 11813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11813,
        GIR_EraseRootFromParent_Done,
      // Label 4594: @227841
      GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(227883), // Rule ID 11814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11814,
        GIR_EraseRootFromParent_Done,
      // Label 4595: @227883
      GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(227925), // Rule ID 11815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1882:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11815,
        GIR_EraseRootFromParent_Done,
      // Label 4596: @227925
      GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(227967), // Rule ID 11816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1882:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11816,
        GIR_EraseRootFromParent_Done,
      // Label 4597: @227967
      GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(228009), // Rule ID 11817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1882:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11817,
        GIR_EraseRootFromParent_Done,
      // Label 4598: @228009
      GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(228051), // Rule ID 11818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1882:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11818,
        GIR_EraseRootFromParent_Done,
      // Label 4599: @228051
      GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(228093), // Rule ID 11819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11819,
        GIR_EraseRootFromParent_Done,
      // Label 4600: @228093
      GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(228135), // Rule ID 11820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1671:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11820,
        GIR_EraseRootFromParent_Done,
      // Label 4601: @228135
      GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(228177), // Rule ID 11821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1671:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11821,
        GIR_EraseRootFromParent_Done,
      // Label 4602: @228177
      GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(228219), // Rule ID 11822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11822,
        GIR_EraseRootFromParent_Done,
      // Label 4603: @228219
      GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(228261), // Rule ID 11823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11823,
        GIR_EraseRootFromParent_Done,
      // Label 4604: @228261
      GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(228303), // Rule ID 11824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11824,
        GIR_EraseRootFromParent_Done,
      // Label 4605: @228303
      GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(228345), // Rule ID 11825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11825,
        GIR_EraseRootFromParent_Done,
      // Label 4606: @228345
      GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(228387), // Rule ID 11826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11826,
        GIR_EraseRootFromParent_Done,
      // Label 4607: @228387
      GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(228429), // Rule ID 11827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11827,
        GIR_EraseRootFromParent_Done,
      // Label 4608: @228429
      GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(228471), // Rule ID 11828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11828,
        GIR_EraseRootFromParent_Done,
      // Label 4609: @228471
      GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(228513), // Rule ID 11829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11829,
        GIR_EraseRootFromParent_Done,
      // Label 4610: @228513
      GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(228555), // Rule ID 11830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1678:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11830,
        GIR_EraseRootFromParent_Done,
      // Label 4611: @228555
      GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(228597), // Rule ID 11831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1869:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11831,
        GIR_EraseRootFromParent_Done,
      // Label 4612: @228597
      GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(228639), // Rule ID 11832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11832,
        GIR_EraseRootFromParent_Done,
      // Label 4613: @228639
      GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(228681), // Rule ID 11833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11833,
        GIR_EraseRootFromParent_Done,
      // Label 4614: @228681
      GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(228723), // Rule ID 11834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11834,
        GIR_EraseRootFromParent_Done,
      // Label 4615: @228723
      GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(228765), // Rule ID 11835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11835,
        GIR_EraseRootFromParent_Done,
      // Label 4616: @228765
      GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(228807), // Rule ID 11836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11836,
        GIR_EraseRootFromParent_Done,
      // Label 4617: @228807
      GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(228849), // Rule ID 11837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11837,
        GIR_EraseRootFromParent_Done,
      // Label 4618: @228849
      GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(228891), // Rule ID 11838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1662:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11838,
        GIR_EraseRootFromParent_Done,
      // Label 4619: @228891
      GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(228933), // Rule ID 11839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11839,
        GIR_EraseRootFromParent_Done,
      // Label 4620: @228933
      GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(228975), // Rule ID 11840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11840,
        GIR_EraseRootFromParent_Done,
      // Label 4621: @228975
      GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(229017), // Rule ID 11841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11841,
        GIR_EraseRootFromParent_Done,
      // Label 4622: @229017
      GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(229059), // Rule ID 11842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11842,
        GIR_EraseRootFromParent_Done,
      // Label 4623: @229059
      GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(229101), // Rule ID 11843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1649:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11843,
        GIR_EraseRootFromParent_Done,
      // Label 4624: @229101
      GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(229143), // Rule ID 11844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11844,
        GIR_EraseRootFromParent_Done,
      // Label 4625: @229143
      GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(229185), // Rule ID 11845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11845,
        GIR_EraseRootFromParent_Done,
      // Label 4626: @229185
      GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(229227), // Rule ID 11846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1649:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11846,
        GIR_EraseRootFromParent_Done,
      // Label 4627: @229227
      GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(229269), // Rule ID 11847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11847,
        GIR_EraseRootFromParent_Done,
      // Label 4628: @229269
      GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(229311), // Rule ID 11848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11848,
        GIR_EraseRootFromParent_Done,
      // Label 4629: @229311
      GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(229353), // Rule ID 11849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11849,
        GIR_EraseRootFromParent_Done,
      // Label 4630: @229353
      GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(229395), // Rule ID 11850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11850,
        GIR_EraseRootFromParent_Done,
      // Label 4631: @229395
      GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(229437), // Rule ID 12013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12013,
        GIR_EraseRootFromParent_Done,
      // Label 4632: @229437
      GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(229479), // Rule ID 12015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12015,
        GIR_EraseRootFromParent_Done,
      // Label 4633: @229479
      GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(229521), // Rule ID 12017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12017,
        GIR_EraseRootFromParent_Done,
      // Label 4634: @229521
      GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(229563), // Rule ID 12019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12019,
        GIR_EraseRootFromParent_Done,
      // Label 4635: @229563
      GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(229605), // Rule ID 12021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1503:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12021,
        GIR_EraseRootFromParent_Done,
      // Label 4636: @229605
      GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(229647), // Rule ID 12022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1503:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12022,
        GIR_EraseRootFromParent_Done,
      // Label 4637: @229647
      GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(229689), // Rule ID 12023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1503:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12023,
        GIR_EraseRootFromParent_Done,
      // Label 4638: @229689
      GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(229731), // Rule ID 12024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12024,
        GIR_EraseRootFromParent_Done,
      // Label 4639: @229731
      GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(229773), // Rule ID 12025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12025,
        GIR_EraseRootFromParent_Done,
      // Label 4640: @229773
      GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(229815), // Rule ID 12026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12026,
        GIR_EraseRootFromParent_Done,
      // Label 4641: @229815
      GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(229857), // Rule ID 12027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12027,
        GIR_EraseRootFromParent_Done,
      // Label 4642: @229857
      GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(229899), // Rule ID 12028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12028,
        GIR_EraseRootFromParent_Done,
      // Label 4643: @229899
      GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(229941), // Rule ID 12029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12029,
        GIR_EraseRootFromParent_Done,
      // Label 4644: @229941
      GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(229983), // Rule ID 12030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1092:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12030,
        GIR_EraseRootFromParent_Done,
      // Label 4645: @229983
      GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(230025), // Rule ID 12031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1092:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12031,
        GIR_EraseRootFromParent_Done,
      // Label 4646: @230025
      GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(230067), // Rule ID 12032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1515:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12032,
        GIR_EraseRootFromParent_Done,
      // Label 4647: @230067
      GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(230109), // Rule ID 12033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1515:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12033,
        GIR_EraseRootFromParent_Done,
      // Label 4648: @230109
      GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(230151), // Rule ID 12034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1516:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12034,
        GIR_EraseRootFromParent_Done,
      // Label 4649: @230151
      GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(230193), // Rule ID 12035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1516:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12035,
        GIR_EraseRootFromParent_Done,
      // Label 4650: @230193
      GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(230235), // Rule ID 12090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1484:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12090,
        GIR_EraseRootFromParent_Done,
      // Label 4651: @230235
      GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(230277), // Rule ID 12091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1484:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12091,
        GIR_EraseRootFromParent_Done,
      // Label 4652: @230277
      GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(230319), // Rule ID 12092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1484:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12092,
        GIR_EraseRootFromParent_Done,
      // Label 4653: @230319
      GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(230361), // Rule ID 12093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12093,
        GIR_EraseRootFromParent_Done,
      // Label 4654: @230361
      GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(230403), // Rule ID 12094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12094,
        GIR_EraseRootFromParent_Done,
      // Label 4655: @230403
      GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(230445), // Rule ID 12095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12095,
        GIR_EraseRootFromParent_Done,
      // Label 4656: @230445
      GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(230487), // Rule ID 12096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1500:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12096,
        GIR_EraseRootFromParent_Done,
      // Label 4657: @230487
      GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(230529), // Rule ID 12097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1500:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12097,
        GIR_EraseRootFromParent_Done,
      // Label 4658: @230529
      GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(230571), // Rule ID 12098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1500:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12098,
        GIR_EraseRootFromParent_Done,
      // Label 4659: @230571
      GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(230616), // Rule ID 12111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1435:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12111,
        GIR_EraseRootFromParent_Done,
      // Label 4660: @230616
      GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(230661), // Rule ID 12112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1435:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12112,
        GIR_EraseRootFromParent_Done,
      // Label 4661: @230661
      GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(230703), // Rule ID 12113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1201:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12113,
        GIR_EraseRootFromParent_Done,
      // Label 4662: @230703
      GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(230745), // Rule ID 12114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1201:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12114,
        GIR_EraseRootFromParent_Done,
      // Label 4663: @230745
      GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(230787), // Rule ID 12115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1201:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12115,
        GIR_EraseRootFromParent_Done,
      // Label 4664: @230787
      GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(230829), // Rule ID 12116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1201:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12116,
        GIR_EraseRootFromParent_Done,
      // Label 4665: @230829
      GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(230871), // Rule ID 12132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1284:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12132,
        GIR_EraseRootFromParent_Done,
      // Label 4666: @230871
      GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(230913), // Rule ID 12133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1284:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12133,
        GIR_EraseRootFromParent_Done,
      // Label 4667: @230913
      GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(230955), // Rule ID 12134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1284:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12134,
        GIR_EraseRootFromParent_Done,
      // Label 4668: @230955
      GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(230997), // Rule ID 12135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1302:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12135,
        GIR_EraseRootFromParent_Done,
      // Label 4669: @230997
      GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(231039), // Rule ID 12136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1302:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12136,
        GIR_EraseRootFromParent_Done,
      // Label 4670: @231039
      GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(231081), // Rule ID 12137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1302:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12137,
        GIR_EraseRootFromParent_Done,
      // Label 4671: @231081
      GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(231123), // Rule ID 12138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1287:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12138,
        GIR_EraseRootFromParent_Done,
      // Label 4672: @231123
      GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(231165), // Rule ID 12139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1287:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12139,
        GIR_EraseRootFromParent_Done,
      // Label 4673: @231165
      GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(231207), // Rule ID 12140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1287:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12140,
        GIR_EraseRootFromParent_Done,
      // Label 4674: @231207
      GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(231249), // Rule ID 12141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12141,
        GIR_EraseRootFromParent_Done,
      // Label 4675: @231249
      GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(231291), // Rule ID 12142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1305:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12142,
        GIR_EraseRootFromParent_Done,
      // Label 4676: @231291
      GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(231333), // Rule ID 12143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1305:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12143,
        GIR_EraseRootFromParent_Done,
      // Label 4677: @231333
      GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(231375), // Rule ID 12148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1311:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12148,
        GIR_EraseRootFromParent_Done,
      // Label 4678: @231375
      GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(231417), // Rule ID 12149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1313:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12149,
        GIR_EraseRootFromParent_Done,
      // Label 4679: @231417
      GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(231459), // Rule ID 12150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1318:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12150,
        GIR_EraseRootFromParent_Done,
      // Label 4680: @231459
      GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(231501), // Rule ID 12151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1320:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12151,
        GIR_EraseRootFromParent_Done,
      // Label 4681: @231501
      GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(231543), // Rule ID 12152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1118:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12152,
        GIR_EraseRootFromParent_Done,
      // Label 4682: @231543
      GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(231585), // Rule ID 12154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1118:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12154,
        GIR_EraseRootFromParent_Done,
      // Label 4683: @231585
      GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(231627), // Rule ID 12156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1118:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12156,
        GIR_EraseRootFromParent_Done,
      // Label 4684: @231627
      GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(231669), // Rule ID 12158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1118:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12158,
        GIR_EraseRootFromParent_Done,
      // Label 4685: @231669
      GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(231711), // Rule ID 12160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1147:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12160,
        GIR_EraseRootFromParent_Done,
      // Label 4686: @231711
      GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(231753), // Rule ID 12162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1147:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12162,
        GIR_EraseRootFromParent_Done,
      // Label 4687: @231753
      GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(231795), // Rule ID 12164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1147:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12164,
        GIR_EraseRootFromParent_Done,
      // Label 4688: @231795
      GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(231837), // Rule ID 12166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1147:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12166,
        GIR_EraseRootFromParent_Done,
      // Label 4689: @231837
      GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(231879), // Rule ID 12168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1148:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12168,
        GIR_EraseRootFromParent_Done,
      // Label 4690: @231879
      GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(231921), // Rule ID 12169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1148:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12169,
        GIR_EraseRootFromParent_Done,
      // Label 4691: @231921
      GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(231963), // Rule ID 12170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1148:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12170,
        GIR_EraseRootFromParent_Done,
      // Label 4692: @231963
      GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(232005), // Rule ID 12171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1148:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12171,
        GIR_EraseRootFromParent_Done,
      // Label 4693: @232005
      GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(232047), // Rule ID 12172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1149:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12172,
        GIR_EraseRootFromParent_Done,
      // Label 4694: @232047
      GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(232089), // Rule ID 12173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1149:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12173,
        GIR_EraseRootFromParent_Done,
      // Label 4695: @232089
      GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(232131), // Rule ID 12174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1149:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12174,
        GIR_EraseRootFromParent_Done,
      // Label 4696: @232131
      GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(232173), // Rule ID 12175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1149:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12175,
        GIR_EraseRootFromParent_Done,
      // Label 4697: @232173
      GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(232215), // Rule ID 12176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1433:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12176,
        GIR_EraseRootFromParent_Done,
      // Label 4698: @232215
      GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(232257), // Rule ID 12178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1433:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12178,
        GIR_EraseRootFromParent_Done,
      // Label 4699: @232257
      GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(232299), // Rule ID 12180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1433:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12180,
        GIR_EraseRootFromParent_Done,
      // Label 4700: @232299
      GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(232341), // Rule ID 12182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1433:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12182,
        GIR_EraseRootFromParent_Done,
      // Label 4701: @232341
      GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(232383), // Rule ID 12274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1764:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12274,
        GIR_EraseRootFromParent_Done,
      // Label 4702: @232383
      GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(232425), // Rule ID 12276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12276,
        GIR_EraseRootFromParent_Done,
      // Label 4703: @232425
      GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(232467), // Rule ID 12278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12278,
        GIR_EraseRootFromParent_Done,
      // Label 4704: @232467
      GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(232509), // Rule ID 12280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12280,
        GIR_EraseRootFromParent_Done,
      // Label 4705: @232509
      GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(232551), // Rule ID 12282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1268:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12282,
        GIR_EraseRootFromParent_Done,
      // Label 4706: @232551
      GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(232593), // Rule ID 12284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1131:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLSLB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12284,
        GIR_EraseRootFromParent_Done,
      // Label 4707: @232593
      GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(232635), // Rule ID 12285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1133:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLSLT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12285,
        GIR_EraseRootFromParent_Done,
      // Label 4708: @232635
      GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(232677), // Rule ID 12288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1780:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12288,
        GIR_EraseRootFromParent_Done,
      // Label 4709: @232677
      GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(232719), // Rule ID 12406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFSUB_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12406,
        GIR_EraseRootFromParent_Done,
      // Label 4710: @232719
      GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(232761), // Rule ID 12410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMAXNM_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMAXNM_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12410,
        GIR_EraseRootFromParent_Done,
      // Label 4711: @232761
      GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(232803), // Rule ID 12411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1296:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMINNM_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMINNM_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12411,
        GIR_EraseRootFromParent_Done,
      // Label 4712: @232803
      GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(232845), // Rule ID 12412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMAX_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMAX_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12412,
        GIR_EraseRootFromParent_Done,
      // Label 4713: @232845
      GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(232887), // Rule ID 12413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1290:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMIN_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMIN_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12413,
        GIR_EraseRootFromParent_Done,
      // Label 4714: @232887
      GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(232929), // Rule ID 12515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12515,
        GIR_EraseRootFromParent_Done,
      // Label 4715: @232929
      GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(232971), // Rule ID 12516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12516,
        GIR_EraseRootFromParent_Done,
      // Label 4716: @232971
      GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(233013), // Rule ID 12517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12517,
        GIR_EraseRootFromParent_Done,
      // Label 4717: @233013
      GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(233055), // Rule ID 12518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12518,
        GIR_EraseRootFromParent_Done,
      // Label 4718: @233055
      GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(233097), // Rule ID 12519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1740:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12519,
        GIR_EraseRootFromParent_Done,
      // Label 4719: @233097
      GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(233139), // Rule ID 12520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1740:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12520,
        GIR_EraseRootFromParent_Done,
      // Label 4720: @233139
      GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(233181), // Rule ID 12521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1740:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12521,
        GIR_EraseRootFromParent_Done,
      // Label 4721: @233181
      GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(233223), // Rule ID 12522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1740:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12522,
        GIR_EraseRootFromParent_Done,
      // Label 4722: @233223
      GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(233265), // Rule ID 12533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1218:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12533,
        GIR_EraseRootFromParent_Done,
      // Label 4723: @233265
      GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(233307), // Rule ID 12534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1218:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12534,
        GIR_EraseRootFromParent_Done,
      // Label 4724: @233307
      GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(233349), // Rule ID 12535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1218:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12535,
        GIR_EraseRootFromParent_Done,
      // Label 4725: @233349
      GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(233391), // Rule ID 12536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1216:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12536,
        GIR_EraseRootFromParent_Done,
      // Label 4726: @233391
      GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(233433), // Rule ID 12537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1216:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12537,
        GIR_EraseRootFromParent_Done,
      // Label 4727: @233433
      GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(233475), // Rule ID 12538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1216:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12538,
        GIR_EraseRootFromParent_Done,
      // Label 4728: @233475
      GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(233517), // Rule ID 12539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1217:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12539,
        GIR_EraseRootFromParent_Done,
      // Label 4729: @233517
      GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(233559), // Rule ID 12542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1217:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12542,
        GIR_EraseRootFromParent_Done,
      // Label 4730: @233559
      GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(233601), // Rule ID 12545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1217:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12545,
        GIR_EraseRootFromParent_Done,
      // Label 4731: @233601
      GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(233643), // Rule ID 12548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1217:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12548,
        GIR_EraseRootFromParent_Done,
      // Label 4732: @233643
      GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(233685), // Rule ID 12551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1217:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12551,
        GIR_EraseRootFromParent_Done,
      // Label 4733: @233685
      GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(233727), // Rule ID 12554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1217:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12554,
        GIR_EraseRootFromParent_Done,
      // Label 4734: @233727
      GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(233769), // Rule ID 12557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1219:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12557,
        GIR_EraseRootFromParent_Done,
      // Label 4735: @233769
      GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(233811), // Rule ID 12560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1219:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12560,
        GIR_EraseRootFromParent_Done,
      // Label 4736: @233811
      GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(233853), // Rule ID 12563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1219:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12563,
        GIR_EraseRootFromParent_Done,
      // Label 4737: @233853
      GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(233895), // Rule ID 12566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1219:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12566,
        GIR_EraseRootFromParent_Done,
      // Label 4738: @233895
      GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(233937), // Rule ID 12569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1219:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12569,
        GIR_EraseRootFromParent_Done,
      // Label 4739: @233937
      GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(233979), // Rule ID 12572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1219:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12572,
        GIR_EraseRootFromParent_Done,
      // Label 4740: @233979
      GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(234122), // Rule ID 5615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 743:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5615,
        GIR_EraseRootFromParent_Done,
      // Label 4741: @234122
      GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(234213), // Rule ID 5616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5616,
        GIR_EraseRootFromParent_Done,
      // Label 4742: @234213
      GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(234304), // Rule ID 5617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 743:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5617,
        GIR_EraseRootFromParent_Done,
      // Label 4743: @234304
      GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(234343), // Rule ID 5618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5618,
        GIR_EraseRootFromParent_Done,
      // Label 4744: @234343
      GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(234486), // Rule ID 5619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 743:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5619,
        GIR_EraseRootFromParent_Done,
      // Label 4745: @234486
      GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(234577), // Rule ID 5620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5620,
        GIR_EraseRootFromParent_Done,
      // Label 4746: @234577
      GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(234668), // Rule ID 5621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 743:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5621,
        GIR_EraseRootFromParent_Done,
      // Label 4747: @234668
      GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(234707), // Rule ID 5622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5622,
        GIR_EraseRootFromParent_Done,
      // Label 4748: @234707
      GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(234850), // Rule ID 5623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 743:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5623,
        GIR_EraseRootFromParent_Done,
      // Label 4749: @234850
      GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(234941), // Rule ID 5624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 744:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5624,
        GIR_EraseRootFromParent_Done,
      // Label 4750: @234941
      GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(235032), // Rule ID 5625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 743:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5625,
        GIR_EraseRootFromParent_Done,
      // Label 4751: @235032
      GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(235071), // Rule ID 5626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 744:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5626,
        GIR_EraseRootFromParent_Done,
      // Label 4752: @235071
      GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(235214), // Rule ID 5627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 743:{ *:[iPTR] }, v4bf16:{ *:[v4bf16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5627,
        GIR_EraseRootFromParent_Done,
      // Label 4753: @235214
      GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(235305), // Rule ID 5628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 744:{ *:[iPTR] }, v4bf16:{ *:[v4bf16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5628,
        GIR_EraseRootFromParent_Done,
      // Label 4754: @235305
      GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(235396), // Rule ID 5629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 743:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5629,
        GIR_EraseRootFromParent_Done,
      // Label 4755: @235396
      GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(235435), // Rule ID 5630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 744:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5630,
        GIR_EraseRootFromParent_Done,
      // Label 4756: @235435
      GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(235474), // Rule ID 5631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 747:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5631,
        GIR_EraseRootFromParent_Done,
      // Label 4757: @235474
      GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(235565), // Rule ID 5632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 745:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5632,
        GIR_EraseRootFromParent_Done,
      // Label 4758: @235565
      GIM_Reject,
    // Label 3859: @235566
    GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(243276),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(235621), // Rule ID 2948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1424:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2948,
        GIR_EraseRootFromParent_Done,
      // Label 4760: @235621
      GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(235668), // Rule ID 2950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2950,
        GIR_EraseRootFromParent_Done,
      // Label 4761: @235668
      GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(235715), // Rule ID 2952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2952,
        GIR_EraseRootFromParent_Done,
      // Label 4762: @235715
      GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(235762), // Rule ID 2954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2954,
        GIR_EraseRootFromParent_Done,
      // Label 4763: @235762
      GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(235809), // Rule ID 7720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1427:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7720,
        GIR_EraseRootFromParent_Done,
      // Label 4764: @235809
      GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(235856), // Rule ID 7722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7722,
        GIR_EraseRootFromParent_Done,
      // Label 4765: @235856
      GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(235903), // Rule ID 7724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7724,
        GIR_EraseRootFromParent_Done,
      // Label 4766: @235903
      GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(235950), // Rule ID 7726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7726,
        GIR_EraseRootFromParent_Done,
      // Label 4767: @235950
      GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(236030), // Rule ID 5771 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v16i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5771,
        GIR_EraseRootFromParent_Done,
      // Label 4768: @236030
      GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(236110), // Rule ID 5772 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5772,
        GIR_EraseRootFromParent_Done,
      // Label 4769: @236110
      GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(236190), // Rule ID 5773 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5773,
        GIR_EraseRootFromParent_Done,
      // Label 4770: @236190
      GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(236270), // Rule ID 5774 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i64] } 736:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5774,
        GIR_EraseRootFromParent_Done,
      // Label 4771: @236270
      GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(236334), // Rule ID 3817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3817,
        GIR_EraseRootFromParent_Done,
      // Label 4772: @236334
      GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(236398), // Rule ID 3818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3818,
        GIR_EraseRootFromParent_Done,
      // Label 4773: @236398
      GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(236462), // Rule ID 3819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 531:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3819,
        GIR_EraseRootFromParent_Done,
      // Label 4774: @236462
      GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(236526), // Rule ID 3820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3820,
        GIR_EraseRootFromParent_Done,
      // Label 4775: @236526
      GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(236578), // Rule ID 2818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1309:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2818,
        GIR_EraseRootFromParent_Done,
      // Label 4776: @236578
      GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(236630), // Rule ID 2819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1309:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2819,
        GIR_EraseRootFromParent_Done,
      // Label 4777: @236630
      GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(236682), // Rule ID 2820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1309:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2820,
        GIR_EraseRootFromParent_Done,
      // Label 4778: @236682
      GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(236734), // Rule ID 2821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1309:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$op1, nxv8bf16:{ *:[nxv8bf16] }:$op2, nxv8bf16:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (BFMLA_ZZZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op1, ?:{ *:[nxv8bf16] }:$op2, ?:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLA_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2821,
        GIR_EraseRootFromParent_Done,
      // Label 4779: @236734
      GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(236786), // Rule ID 2844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalb_lane_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1128:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLALB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALB_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2844,
        GIR_EraseRootFromParent_Done,
      // Label 4780: @236786
      GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(236838), // Rule ID 2963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2963,
        GIR_EraseRootFromParent_Done,
      // Label 4781: @236838
      GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(236890), // Rule ID 2964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2964,
        GIR_EraseRootFromParent_Done,
      // Label 4782: @236890
      GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(236942), // Rule ID 2965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2965,
        GIR_EraseRootFromParent_Done,
      // Label 4783: @236942
      GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(236994), // Rule ID 2966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1565:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2966,
        GIR_EraseRootFromParent_Done,
      // Label 4784: @236994
      GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(237046), // Rule ID 2967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1565:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2967,
        GIR_EraseRootFromParent_Done,
      // Label 4785: @237046
      GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(237098), // Rule ID 2970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1531:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2970,
        GIR_EraseRootFromParent_Done,
      // Label 4786: @237098
      GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(237150), // Rule ID 2971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1531:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2971,
        GIR_EraseRootFromParent_Done,
      // Label 4787: @237150
      GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(237202), // Rule ID 3451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfdot_lane_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1126:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (BFDOT_ZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOT_ZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3451,
        GIR_EraseRootFromParent_Done,
      // Label 4788: @237202
      GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(237254), // Rule ID 3457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3457,
        GIR_EraseRootFromParent_Done,
      // Label 4789: @237254
      GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(237306), // Rule ID 3511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1532:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3511,
        GIR_EraseRootFromParent_Done,
      // Label 4790: @237306
      GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(237358), // Rule ID 7790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7790,
        GIR_EraseRootFromParent_Done,
      // Label 4791: @237358
      GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(237410), // Rule ID 7791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7791,
        GIR_EraseRootFromParent_Done,
      // Label 4792: @237410
      GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(237462), // Rule ID 8437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1316:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8437,
        GIR_EraseRootFromParent_Done,
      // Label 4793: @237462
      GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(237514), // Rule ID 8438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1316:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8438,
        GIR_EraseRootFromParent_Done,
      // Label 4794: @237514
      GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(237566), // Rule ID 8439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1316:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8439,
        GIR_EraseRootFromParent_Done,
      // Label 4795: @237566
      GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(237618), // Rule ID 10667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalt_lane_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1130:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLALT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10667,
        GIR_EraseRootFromParent_Done,
      // Label 4796: @237618
      GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(237670), // Rule ID 11545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11545,
        GIR_EraseRootFromParent_Done,
      // Label 4797: @237670
      GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(237722), // Rule ID 11597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1426:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11597,
        GIR_EraseRootFromParent_Done,
      // Label 4798: @237722
      GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(237774), // Rule ID 11598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1426:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11598,
        GIR_EraseRootFromParent_Done,
      // Label 4799: @237774
      GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(237826), // Rule ID 11599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1426:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11599,
        GIR_EraseRootFromParent_Done,
      // Label 4800: @237826
      GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(237878), // Rule ID 11600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1644:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11600,
        GIR_EraseRootFromParent_Done,
      // Label 4801: @237878
      GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(237930), // Rule ID 11601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1644:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11601,
        GIR_EraseRootFromParent_Done,
      // Label 4802: @237930
      GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(237982), // Rule ID 11602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1644:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11602,
        GIR_EraseRootFromParent_Done,
      // Label 4803: @237982
      GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(238034), // Rule ID 11603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1646:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11603,
        GIR_EraseRootFromParent_Done,
      // Label 4804: @238034
      GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(238086), // Rule ID 11604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1646:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11604,
        GIR_EraseRootFromParent_Done,
      // Label 4805: @238086
      GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(238138), // Rule ID 11605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1646:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11605,
        GIR_EraseRootFromParent_Done,
      // Label 4806: @238138
      GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(238190), // Rule ID 11648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11648,
        GIR_EraseRootFromParent_Done,
      // Label 4807: @238190
      GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(238242), // Rule ID 11649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1567:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11649,
        GIR_EraseRootFromParent_Done,
      // Label 4808: @238242
      GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(238294), // Rule ID 11650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11650,
        GIR_EraseRootFromParent_Done,
      // Label 4809: @238294
      GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(238346), // Rule ID 11651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11651,
        GIR_EraseRootFromParent_Done,
      // Label 4810: @238346
      GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(238398), // Rule ID 11652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11652,
        GIR_EraseRootFromParent_Done,
      // Label 4811: @238398
      GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(238450), // Rule ID 11653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11653,
        GIR_EraseRootFromParent_Done,
      // Label 4812: @238450
      GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(238502), // Rule ID 11654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1569:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11654,
        GIR_EraseRootFromParent_Done,
      // Label 4813: @238502
      GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(238554), // Rule ID 11655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1569:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11655,
        GIR_EraseRootFromParent_Done,
      // Label 4814: @238554
      GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(238606), // Rule ID 11656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1571:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11656,
        GIR_EraseRootFromParent_Done,
      // Label 4815: @238606
      GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(238658), // Rule ID 11657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1571:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11657,
        GIR_EraseRootFromParent_Done,
      // Label 4816: @238658
      GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(238710), // Rule ID 11658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1807:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11658,
        GIR_EraseRootFromParent_Done,
      // Label 4817: @238710
      GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(238762), // Rule ID 11659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1807:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11659,
        GIR_EraseRootFromParent_Done,
      // Label 4818: @238762
      GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(238814), // Rule ID 11660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11660,
        GIR_EraseRootFromParent_Done,
      // Label 4819: @238814
      GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(238866), // Rule ID 11661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11661,
        GIR_EraseRootFromParent_Done,
      // Label 4820: @238866
      GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(238918), // Rule ID 11683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11683,
        GIR_EraseRootFromParent_Done,
      // Label 4821: @238918
      GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(238970), // Rule ID 11684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11684,
        GIR_EraseRootFromParent_Done,
      // Label 4822: @238970
      GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(239022), // Rule ID 11685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1610:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11685,
        GIR_EraseRootFromParent_Done,
      // Label 4823: @239022
      GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(239074), // Rule ID 11686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1610:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11686,
        GIR_EraseRootFromParent_Done,
      // Label 4824: @239074
      GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(239126), // Rule ID 11687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11687,
        GIR_EraseRootFromParent_Done,
      // Label 4825: @239126
      GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(239178), // Rule ID 11688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11688,
        GIR_EraseRootFromParent_Done,
      // Label 4826: @239178
      GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(239230), // Rule ID 11689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11689,
        GIR_EraseRootFromParent_Done,
      // Label 4827: @239230
      GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(239282), // Rule ID 11690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11690,
        GIR_EraseRootFromParent_Done,
      // Label 4828: @239282
      GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(239334), // Rule ID 12144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1312:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12144,
        GIR_EraseRootFromParent_Done,
      // Label 4829: @239334
      GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(239386), // Rule ID 12145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1314:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12145,
        GIR_EraseRootFromParent_Done,
      // Label 4830: @239386
      GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(239438), // Rule ID 12146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1319:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12146,
        GIR_EraseRootFromParent_Done,
      // Label 4831: @239438
      GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(239490), // Rule ID 12147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1321:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12147,
        GIR_EraseRootFromParent_Done,
      // Label 4832: @239490
      GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(239542), // Rule ID 12283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1267:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12283,
        GIR_EraseRootFromParent_Done,
      // Label 4833: @239542
      GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(239594), // Rule ID 12286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1132:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLSLB_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12286,
        GIR_EraseRootFromParent_Done,
      // Label 4834: @239594
      GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(239646), // Rule ID 12287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1134:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLSLT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12287,
        GIR_EraseRootFromParent_Done,
      // Label 4835: @239646
      GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(239698), // Rule ID 12289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12289,
        GIR_EraseRootFromParent_Done,
      // Label 4836: @239698
      GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(239750), // Rule ID 12444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1316:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$op1, nxv8bf16:{ *:[nxv8bf16] }:$op2, nxv8bf16:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (BFMLS_ZZZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op1, ?:{ *:[nxv8bf16] }:$op2, ?:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12444,
        GIR_EraseRootFromParent_Done,
      // Label 4837: @239750
      GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(239797), // Rule ID 2794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2794,
        GIR_EraseRootFromParent_Done,
      // Label 4838: @239797
      GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(239844), // Rule ID 2797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2797,
        GIR_EraseRootFromParent_Done,
      // Label 4839: @239844
      GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(239891), // Rule ID 2800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2800,
        GIR_EraseRootFromParent_Done,
      // Label 4840: @239891
      GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(239938), // Rule ID 2803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2803,
        GIR_EraseRootFromParent_Done,
      // Label 4841: @239938
      GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(239985), // Rule ID 2806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2806,
        GIR_EraseRootFromParent_Done,
      // Label 4842: @239985
      GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(240032), // Rule ID 2809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2809,
        GIR_EraseRootFromParent_Done,
      // Label 4843: @240032
      GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(240079), // Rule ID 2812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, nxv8bf16:{ *:[nxv8bf16] }:$Op4)  =>  (BFMLA_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, ?:{ *:[nxv8bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLA_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2812,
        GIR_EraseRootFromParent_Done,
      // Label 4844: @240079
      GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(240126), // Rule ID 2815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1271:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2815,
        GIR_EraseRootFromParent_Done,
      // Label 4845: @240126
      GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(240173), // Rule ID 2816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1271:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2816,
        GIR_EraseRootFromParent_Done,
      // Label 4846: @240173
      GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(240220), // Rule ID 2817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1271:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2817,
        GIR_EraseRootFromParent_Done,
      // Label 4847: @240220
      GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(240267), // Rule ID 2928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1420:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2928,
        GIR_EraseRootFromParent_Done,
      // Label 4848: @240267
      GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(240314), // Rule ID 2931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1420:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2931,
        GIR_EraseRootFromParent_Done,
      // Label 4849: @240314
      GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(240361), // Rule ID 2934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1420:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2934,
        GIR_EraseRootFromParent_Done,
      // Label 4850: @240361
      GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(240408), // Rule ID 2937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1420:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2937,
        GIR_EraseRootFromParent_Done,
      // Label 4851: @240408
      GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(240455), // Rule ID 2940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1422:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2940,
        GIR_EraseRootFromParent_Done,
      // Label 4852: @240455
      GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(240502), // Rule ID 2942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1422:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2942,
        GIR_EraseRootFromParent_Done,
      // Label 4853: @240502
      GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(240549), // Rule ID 2944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1422:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2944,
        GIR_EraseRootFromParent_Done,
      // Label 4854: @240549
      GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(240596), // Rule ID 2946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1422:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2946,
        GIR_EraseRootFromParent_Done,
      // Label 4855: @240596
      GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(240643), // Rule ID 7700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1428:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7700,
        GIR_EraseRootFromParent_Done,
      // Label 4856: @240643
      GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(240690), // Rule ID 7703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1428:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7703,
        GIR_EraseRootFromParent_Done,
      // Label 4857: @240690
      GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(240737), // Rule ID 7706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1428:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7706,
        GIR_EraseRootFromParent_Done,
      // Label 4858: @240737
      GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(240784), // Rule ID 7709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1428:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7709,
        GIR_EraseRootFromParent_Done,
      // Label 4859: @240784
      GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(240831), // Rule ID 7712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1425:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7712,
        GIR_EraseRootFromParent_Done,
      // Label 4860: @240831
      GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(240878), // Rule ID 7714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1425:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7714,
        GIR_EraseRootFromParent_Done,
      // Label 4861: @240878
      GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(240925), // Rule ID 7716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1425:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7716,
        GIR_EraseRootFromParent_Done,
      // Label 4862: @240925
      GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(240972), // Rule ID 7718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1425:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7718,
        GIR_EraseRootFromParent_Done,
      // Label 4863: @240972
      GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(241019), // Rule ID 8350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8350,
        GIR_EraseRootFromParent_Done,
      // Label 4864: @241019
      GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(241066), // Rule ID 8353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8353,
        GIR_EraseRootFromParent_Done,
      // Label 4865: @241066
      GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(241113), // Rule ID 8356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8356,
        GIR_EraseRootFromParent_Done,
      // Label 4866: @241113
      GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(241160), // Rule ID 8359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8359,
        GIR_EraseRootFromParent_Done,
      // Label 4867: @241160
      GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(241207), // Rule ID 8362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8362,
        GIR_EraseRootFromParent_Done,
      // Label 4868: @241207
      GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(241254), // Rule ID 8365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8365,
        GIR_EraseRootFromParent_Done,
      // Label 4869: @241254
      GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(241301), // Rule ID 8368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8368,
        GIR_EraseRootFromParent_Done,
      // Label 4870: @241301
      GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(241348), // Rule ID 8369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8369,
        GIR_EraseRootFromParent_Done,
      // Label 4871: @241348
      GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(241395), // Rule ID 8370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1331:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8370,
        GIR_EraseRootFromParent_Done,
      // Label 4872: @241395
      GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(241442), // Rule ID 8371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8371,
        GIR_EraseRootFromParent_Done,
      // Label 4873: @241442
      GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(241489), // Rule ID 8372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1331:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8372,
        GIR_EraseRootFromParent_Done,
      // Label 4874: @241489
      GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(241536), // Rule ID 8373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8373,
        GIR_EraseRootFromParent_Done,
      // Label 4875: @241536
      GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(241583), // Rule ID 8374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8374,
        GIR_EraseRootFromParent_Done,
      // Label 4876: @241583
      GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(241630), // Rule ID 8375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8375,
        GIR_EraseRootFromParent_Done,
      // Label 4877: @241630
      GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(241677), // Rule ID 8376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1333:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8376,
        GIR_EraseRootFromParent_Done,
      // Label 4878: @241677
      GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(241724), // Rule ID 8377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8377,
        GIR_EraseRootFromParent_Done,
      // Label 4879: @241724
      GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(241771), // Rule ID 8378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1333:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8378,
        GIR_EraseRootFromParent_Done,
      // Label 4880: @241771
      GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(241818), // Rule ID 8379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1333:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8379,
        GIR_EraseRootFromParent_Done,
      // Label 4881: @241818
      GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(241865), // Rule ID 8380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8380,
        GIR_EraseRootFromParent_Done,
      // Label 4882: @241865
      GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(241912), // Rule ID 8381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8381,
        GIR_EraseRootFromParent_Done,
      // Label 4883: @241912
      GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(241959), // Rule ID 8382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8382,
        GIR_EraseRootFromParent_Done,
      // Label 4884: @241959
      GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(242006), // Rule ID 8383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8383,
        GIR_EraseRootFromParent_Done,
      // Label 4885: @242006
      GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(242053), // Rule ID 8384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8384,
        GIR_EraseRootFromParent_Done,
      // Label 4886: @242053
      GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(242100), // Rule ID 8385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1330:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8385,
        GIR_EraseRootFromParent_Done,
      // Label 4887: @242100
      GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(242147), // Rule ID 8386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8386,
        GIR_EraseRootFromParent_Done,
      // Label 4888: @242147
      GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(242194), // Rule ID 8387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8387,
        GIR_EraseRootFromParent_Done,
      // Label 4889: @242194
      GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(242241), // Rule ID 8388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8388,
        GIR_EraseRootFromParent_Done,
      // Label 4890: @242241
      GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(242288), // Rule ID 8389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8389,
        GIR_EraseRootFromParent_Done,
      // Label 4891: @242288
      GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(242335), // Rule ID 8392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8392,
        GIR_EraseRootFromParent_Done,
      // Label 4892: @242335
      GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(242382), // Rule ID 8395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1317:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8395,
        GIR_EraseRootFromParent_Done,
      // Label 4893: @242382
      GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(242429), // Rule ID 8398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8398,
        GIR_EraseRootFromParent_Done,
      // Label 4894: @242429
      GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(242476), // Rule ID 8401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1317:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8401,
        GIR_EraseRootFromParent_Done,
      // Label 4895: @242476
      GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(242523), // Rule ID 8404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1317:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8404,
        GIR_EraseRootFromParent_Done,
      // Label 4896: @242523
      GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(242570), // Rule ID 8407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1332:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8407,
        GIR_EraseRootFromParent_Done,
      // Label 4897: @242570
      GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(242617), // Rule ID 8410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1332:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8410,
        GIR_EraseRootFromParent_Done,
      // Label 4898: @242617
      GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(242664), // Rule ID 8413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1332:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8413,
        GIR_EraseRootFromParent_Done,
      // Label 4899: @242664
      GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(242711), // Rule ID 8416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1332:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8416,
        GIR_EraseRootFromParent_Done,
      // Label 4900: @242711
      GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(242758), // Rule ID 8419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1332:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8419,
        GIR_EraseRootFromParent_Done,
      // Label 4901: @242758
      GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(242805), // Rule ID 8422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1332:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8422,
        GIR_EraseRootFromParent_Done,
      // Label 4902: @242805
      GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(242852), // Rule ID 8425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8425,
        GIR_EraseRootFromParent_Done,
      // Label 4903: @242852
      GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(242899), // Rule ID 8427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8427,
        GIR_EraseRootFromParent_Done,
      // Label 4904: @242899
      GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(242946), // Rule ID 8429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1334:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8429,
        GIR_EraseRootFromParent_Done,
      // Label 4905: @242946
      GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(242993), // Rule ID 8431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8431,
        GIR_EraseRootFromParent_Done,
      // Label 4906: @242993
      GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(243040), // Rule ID 8433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1334:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8433,
        GIR_EraseRootFromParent_Done,
      // Label 4907: @243040
      GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(243087), // Rule ID 8435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1334:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8435,
        GIR_EraseRootFromParent_Done,
      // Label 4908: @243087
      GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(243134), // Rule ID 12432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, nxv8bf16:{ *:[nxv8bf16] }:$Op4)  =>  (BFMLS_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, ?:{ *:[nxv8bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12432,
        GIR_EraseRootFromParent_Done,
      // Label 4909: @243134
      GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(243181), // Rule ID 12435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, nxv8bf16:{ *:[nxv8bf16] }:$Op4)  =>  (BFMLS_ZPZZZ_UNDEF:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, ?:{ *:[nxv8bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPZZZ_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12435,
        GIR_EraseRootFromParent_Done,
      // Label 4910: @243181
      GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(243228), // Rule ID 12438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4bf16] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2, nxv4bf16:{ *:[nxv4bf16] }:$Op3, nxv4bf16:{ *:[nxv4bf16] }:$Op4)  =>  (BFMLS_ZPZZZ_UNDEF:{ *:[nxv4bf16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2, ?:{ *:[nxv4bf16] }:$Op3, ?:{ *:[nxv4bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPZZZ_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12438,
        GIR_EraseRootFromParent_Done,
      // Label 4911: @243228
      GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(243275), // Rule ID 12441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2bf16] } 1317:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2, nxv2bf16:{ *:[nxv2bf16] }:$Op3, nxv2bf16:{ *:[nxv2bf16] }:$Op4)  =>  (BFMLS_ZPZZZ_UNDEF:{ *:[nxv2bf16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2, ?:{ *:[nxv2bf16] }:$Op3, ?:{ *:[nxv2bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPZZZ_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12441,
        GIR_EraseRootFromParent_Done,
      // Label 4912: @243275
      GIM_Reject,
    // Label 4759: @243276
    GIM_Reject,
    // Label 33: @243277
    GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(243355),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
      GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(243307), // Rule ID 90 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
        // (intrinsic_void 1987:{ *:[iPTR] })  =>  (TCOMMIT)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 90,
        GIR_EraseRootFromParent_Done,
      // Label 4914: @243307
      GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(243332), // Rule ID 2362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
        // (intrinsic_void 1537:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2362,
        GIR_EraseRootFromParent_Done,
      // Label 4915: @243332
      GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(243354), // Rule ID 7324 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
        // (intrinsic_void 492:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7324,
        GIR_EraseRootFromParent_Done,
      // Label 4916: @243354
      GIM_Reject,
    // Label 4913: @243355
    GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(243955),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
      GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(243395), // Rule ID 91 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
        // (intrinsic_void 1986:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 91,
        GIR_EraseRootFromParent_Done,
      // Label 4918: @243395
      GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(243420), // Rule ID 238 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
        // (intrinsic_void 490:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 238,
        GIR_EraseRootFromParent_Done,
      // Label 4919: @243420
      GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(243445), // Rule ID 239 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
        // (intrinsic_void 549:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 239,
        GIR_EraseRootFromParent_Done,
      // Label 4920: @243445
      GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(243477), // Rule ID 3617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
        // (intrinsic_void 1069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3617,
        GIR_EraseRootFromParent_Done,
      // Label 4921: @243477
      GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(243517), // Rule ID 16 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 548:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16,
        GIR_EraseRootFromParent_Done,
      // Label 4922: @243517
      GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(243557), // Rule ID 17 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 536:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17,
        GIR_EraseRootFromParent_Done,
      // Label 4923: @243557
      GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(243597), // Rule ID 18 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 537:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18,
        GIR_EraseRootFromParent_Done,
      // Label 4924: @243597
      GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(243637), // Rule ID 19 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 552:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19,
        GIR_EraseRootFromParent_Done,
      // Label 4925: @243637
      GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(243661), // Rule ID 84 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 545:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 84,
        GIR_EraseRootFromParent_Done,
      // Label 4926: @243661
      GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(243685), // Rule ID 86 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 546:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 86,
        GIR_EraseRootFromParent_Done,
      // Label 4927: @243685
      GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(243716), // Rule ID 89 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 1988:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 89,
        GIR_EraseRootFromParent_Done,
      // Label 4928: @243716
      GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(243743), // Rule ID 92 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 1989:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 92,
        GIR_EraseRootFromParent_Done,
      // Label 4929: @243743
      GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(243774), // Rule ID 2361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv16i1] } 1487:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2361,
        GIR_EraseRootFromParent_Done,
      // Label 4930: @243774
      GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(243814), // Rule ID 12728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 823:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12728,
        GIR_EraseRootFromParent_Done,
      // Label 4931: @243814
      GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(243848), // Rule ID 2363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_void 1967:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
        GIR_RootToRootCopy, /*OpIdx*/1, // Pn
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2363,
        GIR_EraseRootFromParent_Done,
      // Label 4932: @243848
      GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(243871), // Rule ID 85 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 755:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 85,
        GIR_EraseRootFromParent_Done,
      // Label 4933: @243871
      GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(243894), // Rule ID 87 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 757:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 87,
        GIR_EraseRootFromParent_Done,
      // Label 4934: @243894
      GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(243921), // Rule ID 88 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 756:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 88,
        GIR_EraseRootFromParent_Done,
      // Label 4935: @243921
      GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(243954), // Rule ID 12727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 881:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12727,
        GIR_EraseRootFromParent_Done,
      // Label 4936: @243954
      GIM_Reject,
    // Label 4917: @243955
    GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(244622),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(244039), // Rule ID 7290 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7290,
        GIR_EraseRootFromParent_Done,
      // Label 4938: @244039
      GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(244115), // Rule ID 7291 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7291,
        GIR_EraseRootFromParent_Done,
      // Label 4939: @244115
      GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(244191), // Rule ID 7292 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7292,
        GIR_EraseRootFromParent_Done,
      // Label 4940: @244191
      GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(244233), // Rule ID 7293 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7293,
        GIR_EraseRootFromParent_Done,
      // Label 4941: @244233
      GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(244309), // Rule ID 7297 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7297,
        GIR_EraseRootFromParent_Done,
      // Label 4942: @244309
      GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(244385), // Rule ID 7298 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7298,
        GIR_EraseRootFromParent_Done,
      // Label 4943: @244385
      GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(244461), // Rule ID 7299 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7299,
        GIR_EraseRootFromParent_Done,
      // Label 4944: @244461
      GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(244503), // Rule ID 7300 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7300,
        GIR_EraseRootFromParent_Done,
      // Label 4945: @244503
      GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(244543), // Rule ID 20 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 543:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20,
        GIR_EraseRootFromParent_Done,
      // Label 4946: @244543
      GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(244583), // Rule ID 2360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv16i1] } 1488:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2360,
        GIR_EraseRootFromParent_Done,
      // Label 4947: @244583
      GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(244621), // Rule ID 3969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3969,
        GIR_EraseRootFromParent_Done,
      // Label 4948: @244621
      GIM_Reject,
    // Label 4937: @244622
    GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247383),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(244727), // Rule ID 7308 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7308,
        GIR_EraseRootFromParent_Done,
      // Label 4950: @244727
      GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(244824), // Rule ID 7309 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7309,
        GIR_EraseRootFromParent_Done,
      // Label 4951: @244824
      GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(244921), // Rule ID 7318 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7318,
        GIR_EraseRootFromParent_Done,
      // Label 4952: @244921
      GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(245018), // Rule ID 7319 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7319,
        GIR_EraseRootFromParent_Done,
      // Label 4953: @245018
      GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(245129), // Rule ID 7311 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7311,
        GIR_EraseRootFromParent_Done,
      // Label 4954: @245129
      GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(245240), // Rule ID 7312 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7312,
        GIR_EraseRootFromParent_Done,
      // Label 4955: @245240
      GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(245351), // Rule ID 7313 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7313,
        GIR_EraseRootFromParent_Done,
      // Label 4956: @245351
      GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(245462), // Rule ID 7321 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7321,
        GIR_EraseRootFromParent_Done,
      // Label 4957: @245462
      GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(245573), // Rule ID 7322 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7322,
        GIR_EraseRootFromParent_Done,
      // Label 4958: @245573
      GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(245684), // Rule ID 7323 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7323,
        GIR_EraseRootFromParent_Done,
      // Label 4959: @245684
      GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(245735), // Rule ID 82 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] fixed_shadow
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
        GIR_RootToRootCopy, /*OpIdx*/1, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
        GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 82,
        GIR_EraseRootFromParent_Done,
      // Label 4960: @245735
      GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(245786), // Rule ID 83 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] fixed_shadow
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
        GIR_RootToRootCopy, /*OpIdx*/1, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
        GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 83,
        GIR_EraseRootFromParent_Done,
      // Label 4961: @245786
      GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(245855), // Rule ID 7310 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7310,
        GIR_EraseRootFromParent_Done,
      // Label 4962: @245855
      GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(245924), // Rule ID 7320 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7320,
        GIR_EraseRootFromParent_Done,
      // Label 4963: @245924
      GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(245978), // Rule ID 9035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1455:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9035,
        GIR_EraseRootFromParent_Done,
      // Label 4964: @245978
      GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(246032), // Rule ID 9038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1455:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9038,
        GIR_EraseRootFromParent_Done,
      // Label 4965: @246032
      GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(246086), // Rule ID 9041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1455:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9041,
        GIR_EraseRootFromParent_Done,
      // Label 4966: @246086
      GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(246140), // Rule ID 9044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1455:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9044,
        GIR_EraseRootFromParent_Done,
      // Label 4967: @246140
      GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(246194), // Rule ID 15 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i64] } 1079:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15,
        GIR_EraseRootFromParent_Done,
      // Label 4968: @246194
      GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(246262), // Rule ID 80 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
        // MIs[0] Operand 1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
        GIR_RootToRootCopy, /*OpIdx*/2, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 80,
        GIR_EraseRootFromParent_Done,
      // Label 4969: @246262
      GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(246330), // Rule ID 81 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
        // MIs[0] Operand 1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
        GIR_RootToRootCopy, /*OpIdx*/2, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 81,
        GIR_EraseRootFromParent_Done,
      // Label 4970: @246330
      GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(246410), // Rule ID 7304 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7304,
        GIR_EraseRootFromParent_Done,
      // Label 4971: @246410
      GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(246490), // Rule ID 7305 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7305,
        GIR_EraseRootFromParent_Done,
      // Label 4972: @246490
      GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(246570), // Rule ID 7306 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7306,
        GIR_EraseRootFromParent_Done,
      // Label 4973: @246570
      GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(246621), // Rule ID 7307 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
        // (intrinsic_w_chain:{ *:[i32] } 1088:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7307,
        GIR_EraseRootFromParent_Done,
      // Label 4974: @246621
      GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(246701), // Rule ID 7314 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7314,
        GIR_EraseRootFromParent_Done,
      // Label 4975: @246701
      GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(246781), // Rule ID 7315 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7315,
        GIR_EraseRootFromParent_Done,
      // Label 4976: @246781
      GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(246861), // Rule ID 7316 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7316,
        GIR_EraseRootFromParent_Done,
      // Label 4977: @246861
      GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(246912), // Rule ID 7317 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
        // (intrinsic_w_chain:{ *:[i32] } 1086:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7317,
        GIR_EraseRootFromParent_Done,
      // Label 4978: @246912
      GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(246965), // Rule ID 8910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4i32] } 1388:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8910,
        GIR_EraseRootFromParent_Done,
      // Label 4979: @246965
      GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(247018), // Rule ID 8913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8913,
        GIR_EraseRootFromParent_Done,
      // Label 4980: @247018
      GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(247071), // Rule ID 8922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv2i64] } 1387:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8922,
        GIR_EraseRootFromParent_Done,
      // Label 4981: @247071
      GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(247124), // Rule ID 8925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv2f64] } 1387:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8925,
        GIR_EraseRootFromParent_Done,
      // Label 4982: @247124
      GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(247170), // Rule ID 149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 550:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 149,
        GIR_EraseRootFromParent_Done,
      // Label 4983: @247170
      GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(247223), // Rule ID 8916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1708:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8916,
        GIR_EraseRootFromParent_Done,
      // Label 4984: @247223
      GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(247276), // Rule ID 8919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1708:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8919,
        GIR_EraseRootFromParent_Done,
      // Label 4985: @247276
      GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(247329), // Rule ID 8928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1704:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8928,
        GIR_EraseRootFromParent_Done,
      // Label 4986: @247329
      GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(247382), // Rule ID 8931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1704:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8931,
        GIR_EraseRootFromParent_Done,
      // Label 4987: @247382
      GIM_Reject,
    // Label 4949: @247383
    GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249082),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(247462), // Rule ID 3404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 1457:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3404,
        GIR_EraseRootFromParent_Done,
      // Label 4989: @247462
      GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(247533), // Rule ID 3417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 1457:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3417,
        GIR_EraseRootFromParent_Done,
      // Label 4990: @247533
      GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(247592), // Rule ID 3606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3606,
        GIR_EraseRootFromParent_Done,
      // Label 4991: @247592
      GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(247651), // Rule ID 3607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3607,
        GIR_EraseRootFromParent_Done,
      // Label 4992: @247651
      GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(247710), // Rule ID 12577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 773:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12577,
        GIR_EraseRootFromParent_Done,
      // Label 4993: @247710
      GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(247769), // Rule ID 12578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 773:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12578,
        GIR_EraseRootFromParent_Done,
      // Label 4994: @247769
      GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(247829), // Rule ID 3402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1459:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3402,
        GIR_EraseRootFromParent_Done,
      // Label 4995: @247829
      GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(247889), // Rule ID 3403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1458:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3403,
        GIR_EraseRootFromParent_Done,
      // Label 4996: @247889
      GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(247949), // Rule ID 3414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1459:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3414,
        GIR_EraseRootFromParent_Done,
      // Label 4997: @247949
      GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(248009), // Rule ID 3415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1458:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3415,
        GIR_EraseRootFromParent_Done,
      // Label 4998: @248009
      GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(248069), // Rule ID 3416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1456:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3416,
        GIR_EraseRootFromParent_Done,
      // Label 4999: @248069
      GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(248129), // Rule ID 9047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1467:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9047,
        GIR_EraseRootFromParent_Done,
      // Label 5000: @248129
      GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(248189), // Rule ID 9048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1466:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9048,
        GIR_EraseRootFromParent_Done,
      // Label 5001: @248189
      GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(248249), // Rule ID 9049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1471:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9049,
        GIR_EraseRootFromParent_Done,
      // Label 5002: @248249
      GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(248309), // Rule ID 9050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1470:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9050,
        GIR_EraseRootFromParent_Done,
      // Label 5003: @248309
      GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(248369), // Rule ID 9051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1463:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9051,
        GIR_EraseRootFromParent_Done,
      // Label 5004: @248369
      GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(248429), // Rule ID 9052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1462:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9052,
        GIR_EraseRootFromParent_Done,
      // Label 5005: @248429
      GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(248489), // Rule ID 9053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1467:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9053,
        GIR_EraseRootFromParent_Done,
      // Label 5006: @248489
      GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(248549), // Rule ID 9054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1466:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9054,
        GIR_EraseRootFromParent_Done,
      // Label 5007: @248549
      GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(248609), // Rule ID 9055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1471:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9055,
        GIR_EraseRootFromParent_Done,
      // Label 5008: @248609
      GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(248669), // Rule ID 9056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1470:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9056,
        GIR_EraseRootFromParent_Done,
      // Label 5009: @248669
      GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(248729), // Rule ID 9057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1463:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9057,
        GIR_EraseRootFromParent_Done,
      // Label 5010: @248729
      GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(248789), // Rule ID 9058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1462:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9058,
        GIR_EraseRootFromParent_Done,
      // Label 5011: @248789
      GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(248849), // Rule ID 9059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1464:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9059,
        GIR_EraseRootFromParent_Done,
      // Label 5012: @248849
      GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(248909), // Rule ID 9060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1468:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9060,
        GIR_EraseRootFromParent_Done,
      // Label 5013: @248909
      GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(248969), // Rule ID 9061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1460:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9061,
        GIR_EraseRootFromParent_Done,
      // Label 5014: @248969
      GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(249025), // Rule ID 13095 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i32] } 1085:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // lo
        GIR_RootToRootCopy, /*OpIdx*/3, // hi
        GIR_RootToRootCopy, /*OpIdx*/4, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13095,
        GIR_EraseRootFromParent_Done,
      // Label 5015: @249025
      GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(249081), // Rule ID 13096 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i32] } 1087:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // lo
        GIR_RootToRootCopy, /*OpIdx*/3, // hi
        GIR_RootToRootCopy, /*OpIdx*/4, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13096,
        GIR_EraseRootFromParent_Done,
      // Label 5016: @249081
      GIM_Reject,
    // Label 4988: @249082
    GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(251131),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(249150), // Rule ID 3599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 843:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3599,
        GIR_EraseRootFromParent_Done,
      // Label 5018: @249150
      GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(249210), // Rule ID 3600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 843:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3600,
        GIR_EraseRootFromParent_Done,
      // Label 5019: @249210
      GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(249270), // Rule ID 3601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16orSMEF8F16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 843:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3601,
        GIR_EraseRootFromParent_Done,
      // Label 5020: @249270
      GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(249330), // Rule ID 3602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3602,
        GIR_EraseRootFromParent_Done,
      // Label 5021: @249330
      GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(249390), // Rule ID 3603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3603,
        GIR_EraseRootFromParent_Done,
      // Label 5022: @249390
      GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(249450), // Rule ID 3604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 845:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPA_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPA_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3604,
        GIR_EraseRootFromParent_Done,
      // Label 5023: @249450
      GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(249510), // Rule ID 3605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 845:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3605,
        GIR_EraseRootFromParent_Done,
      // Label 5024: @249510
      GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(249570), // Rule ID 3682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3682,
        GIR_EraseRootFromParent_Done,
      // Label 5025: @249570
      GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(249630), // Rule ID 3683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3683,
        GIR_EraseRootFromParent_Done,
      // Label 5026: @249630
      GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(249690), // Rule ID 12579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 848:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPS_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPS_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12579,
        GIR_EraseRootFromParent_Done,
      // Label 5027: @249690
      GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(249750), // Rule ID 12580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 846:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12580,
        GIR_EraseRootFromParent_Done,
      // Label 5028: @249750
      GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(249810), // Rule ID 12581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 846:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12581,
        GIR_EraseRootFromParent_Done,
      // Label 5029: @249810
      GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(249870), // Rule ID 12582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 848:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12582,
        GIR_EraseRootFromParent_Done,
      // Label 5030: @249870
      GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(249930), // Rule ID 12583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 932:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12583,
        GIR_EraseRootFromParent_Done,
      // Label 5031: @249930
      GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(249990), // Rule ID 12584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12584,
        GIR_EraseRootFromParent_Done,
      // Label 5032: @249990
      GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(250050), // Rule ID 12585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12585,
        GIR_EraseRootFromParent_Done,
      // Label 5033: @250050
      GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(250110), // Rule ID 12586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 965:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12586,
        GIR_EraseRootFromParent_Done,
      // Label 5034: @250110
      GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(250170), // Rule ID 12587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 966:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12587,
        GIR_EraseRootFromParent_Done,
      // Label 5035: @250170
      GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(250230), // Rule ID 12588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1049:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12588,
        GIR_EraseRootFromParent_Done,
      // Label 5036: @250230
      GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(250290), // Rule ID 12589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12589,
        GIR_EraseRootFromParent_Done,
      // Label 5037: @250290
      GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(250350), // Rule ID 12590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 932:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12590,
        GIR_EraseRootFromParent_Done,
      // Label 5038: @250350
      GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(250410), // Rule ID 12591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12591,
        GIR_EraseRootFromParent_Done,
      // Label 5039: @250410
      GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(250470), // Rule ID 12592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12592,
        GIR_EraseRootFromParent_Done,
      // Label 5040: @250470
      GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(250530), // Rule ID 12593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 965:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12593,
        GIR_EraseRootFromParent_Done,
      // Label 5041: @250530
      GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(250590), // Rule ID 12594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 966:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12594,
        GIR_EraseRootFromParent_Done,
      // Label 5042: @250590
      GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(250650), // Rule ID 12595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1049:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12595,
        GIR_EraseRootFromParent_Done,
      // Label 5043: @250650
      GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(250710), // Rule ID 12596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1050:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12596,
        GIR_EraseRootFromParent_Done,
      // Label 5044: @250710
      GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(250770), // Rule ID 12933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 775:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12933,
        GIR_EraseRootFromParent_Done,
      // Label 5045: @250770
      GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(250830), // Rule ID 12934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 933:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12934,
        GIR_EraseRootFromParent_Done,
      // Label 5046: @250830
      GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(250890), // Rule ID 12935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12935,
        GIR_EraseRootFromParent_Done,
      // Label 5047: @250890
      GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(250950), // Rule ID 12936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12936,
        GIR_EraseRootFromParent_Done,
      // Label 5048: @250950
      GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(251010), // Rule ID 13049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16orSMEF8F16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 846:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13049,
        GIR_EraseRootFromParent_Done,
      // Label 5049: @251010
      GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(251070), // Rule ID 13066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 843:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPA_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13066,
        GIR_EraseRootFromParent_Done,
      // Label 5050: @251070
      GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(251130), // Rule ID 13067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 846:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPS_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13067,
        GIR_EraseRootFromParent_Done,
      // Label 5051: @251130
      GIM_Reject,
    // Label 5017: @251131
    GIM_Reject,
    // Label 34: @251132
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5056*/ GIMT_Encode4(251421),
    /*GILLT_s64*//*Label 5052*/ GIMT_Encode4(251175), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5053*/ GIMT_Encode4(251235), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5054*/ GIMT_Encode4(251297), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5055*/ GIMT_Encode4(251359),
    // Label 5052: @251175
    GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(251234), // Rule ID 6566 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 6566,
      GIR_EraseRootFromParent_Done,
    // Label 5057: @251234
    GIM_Reject,
    // Label 5053: @251235
    GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(251296),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(251274), // Rule ID 6422 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6422,
        GIR_EraseRootFromParent_Done,
      // Label 5059: @251274
      GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(251295), // Rule ID 6413 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6413,
        GIR_EraseRootFromParent_Done,
      // Label 5060: @251295
      GIM_Reject,
    // Label 5058: @251296
    GIM_Reject,
    // Label 5054: @251297
    GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(251358),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(251336), // Rule ID 6419 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6419,
        GIR_EraseRootFromParent_Done,
      // Label 5062: @251336
      GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(251357), // Rule ID 6410 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6410,
        GIR_EraseRootFromParent_Done,
      // Label 5063: @251357
      GIM_Reject,
    // Label 5061: @251358
    GIM_Reject,
    // Label 5055: @251359
    GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(251420),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(251398), // Rule ID 6416 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6416,
        GIR_EraseRootFromParent_Done,
      // Label 5065: @251398
      GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(251419), // Rule ID 6407 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6407,
        GIR_EraseRootFromParent_Done,
      // Label 5066: @251419
      GIM_Reject,
    // Label 5064: @251420
    GIM_Reject,
    // Label 5056: @251421
    GIM_Reject,
    // Label 35: @251422
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5071*/ GIMT_Encode4(252624),
    /*GILLT_s32*//*Label 5067*/ GIMT_Encode4(251465), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5068*/ GIMT_Encode4(251504), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 5069*/ GIMT_Encode4(251782), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 5070*/ GIMT_Encode4(252203),
    // Label 5067: @251465
    GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(251503), // Rule ID 6587 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
      // GIR_Coverage, 6587,
      GIR_EraseRootFromParent_Done,
    // Label 5072: @251503
    GIM_Reject,
    // Label 5068: @251504
    GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(251781),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(251587), // Rule ID 5440 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5440,
        GIR_EraseRootFromParent_Done,
      // Label 5074: @251587
      GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(251658), // Rule ID 5446 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5446,
        GIR_EraseRootFromParent_Done,
      // Label 5075: @251658
      GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(251711), // Rule ID 2148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2148,
        GIR_EraseRootFromParent_Done,
      // Label 5076: @251711
      GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(251761), // Rule ID 6395 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6395,
        GIR_EraseRootFromParent_Done,
      // Label 5077: @251761
      GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(251780), // Rule ID 1087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1087,
        GIR_Done,
      // Label 5078: @251780
      GIM_Reject,
    // Label 5073: @251781
    GIM_Reject,
    // Label 5069: @251782
    GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(252202),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(251865), // Rule ID 5439 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5439,
        GIR_EraseRootFromParent_Done,
      // Label 5080: @251865
      GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(251936), // Rule ID 5445 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5445,
        GIR_EraseRootFromParent_Done,
      // Label 5081: @251936
      GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(252028), // Rule ID 5579 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5579,
        GIR_EraseRootFromParent_Done,
      // Label 5082: @252028
      GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(252081), // Rule ID 2147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2147,
        GIR_EraseRootFromParent_Done,
      // Label 5083: @252081
      GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(252131), // Rule ID 6394 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6394,
        GIR_EraseRootFromParent_Done,
      // Label 5084: @252131
      GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(252182), // Rule ID 5607 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5607,
        GIR_EraseRootFromParent_Done,
      // Label 5085: @252182
      GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(252201), // Rule ID 1086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1086,
        GIR_Done,
      // Label 5086: @252201
      GIM_Reject,
    // Label 5079: @252202
    GIM_Reject,
    // Label 5070: @252203
    GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(252623),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(252286), // Rule ID 5438 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5438,
        GIR_EraseRootFromParent_Done,
      // Label 5088: @252286
      GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(252357), // Rule ID 5444 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5444,
        GIR_EraseRootFromParent_Done,
      // Label 5089: @252357
      GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(252449), // Rule ID 5552 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5552,
        GIR_EraseRootFromParent_Done,
      // Label 5090: @252449
      GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(252502), // Rule ID 2146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2146,
        GIR_EraseRootFromParent_Done,
      // Label 5091: @252502
      GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(252552), // Rule ID 6393 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6393,
        GIR_EraseRootFromParent_Done,
      // Label 5092: @252552
      GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(252603), // Rule ID 5606 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5606,
        GIR_EraseRootFromParent_Done,
      // Label 5093: @252603
      GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(252622), // Rule ID 1085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1085,
        GIR_Done,
      // Label 5094: @252622
      GIM_Reject,
    // Label 5087: @252623
    GIM_Reject,
    // Label 5071: @252624
    GIM_Reject,
    // Label 36: @252625
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5097*/ GIMT_Encode4(252744),
    /*GILLT_s32*//*Label 5095*/ GIMT_Encode4(252644),
    /*GILLT_s64*//*Label 5096*/ GIMT_Encode4(252664),
    // Label 5095: @252644
    GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(252663), // Rule ID 93 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 93,
      GIR_EraseRootFromParent_Done,
    // Label 5098: @252663
    GIM_Reject,
    // Label 5096: @252664
    GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(252724), // Rule ID 3873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
      GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 3873,
      GIR_EraseRootFromParent_Done,
    // Label 5099: @252724
    GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(252743), // Rule ID 94 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 94,
      GIR_EraseRootFromParent_Done,
    // Label 5100: @252743
    GIM_Reject,
    // Label 5097: @252744
    GIM_Reject,
    // Label 37: @252745
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5104*/ GIMT_Encode4(253033),
    /*GILLT_s16*//*Label 5101*/ GIMT_Encode4(252768),
    /*GILLT_s32*//*Label 5102*/ GIMT_Encode4(252868),
    /*GILLT_s64*//*Label 5103*/ GIMT_Encode4(252981),
    // Label 5101: @252768
    GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(252791), // Rule ID 501 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 501,
      GIR_EraseRootFromParent_Done,
    // Label 5105: @252791
    GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(252819), // Rule ID 683 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 683,
      GIR_EraseRootFromParent_Done,
    // Label 5106: @252819
    GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(252839), // Rule ID 4793 //
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[bf16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[bf16] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4793,
      GIR_EraseRootFromParent_Done,
    // Label 5107: @252839
    GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(252867), // Rule ID 4905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmbf16),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[bf16] })<<P:Predicate_fpimmbf16>><<X:fpimm16XForm>>:$in  =>  (FMOVHi:{ *:[bf16] } (fpimm16XForm:{ *:[f16] } bf16:{ *:[bf16] }:$in))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // in
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4905,
      GIR_EraseRootFromParent_Done,
    // Label 5108: @252867
    GIM_Reject,
    // Label 5102: @252868
    GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(252891), // Rule ID 502 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 502,
      GIR_EraseRootFromParent_Done,
    // Label 5109: @252891
    GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(252919), // Rule ID 684 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 684,
      GIR_EraseRootFromParent_Done,
    // Label 5110: @252919
    GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(252980), // Rule ID 6074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
      GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6074,
      GIR_EraseRootFromParent_Done,
    // Label 5111: @252980
    GIM_Reject,
    // Label 5103: @252981
    GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(253004), // Rule ID 503 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 503,
      GIR_EraseRootFromParent_Done,
    // Label 5112: @253004
    GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(253032), // Rule ID 685 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 685,
      GIR_EraseRootFromParent_Done,
    // Label 5113: @253032
    GIM_Reject,
    // Label 5104: @253033
    GIM_Reject,
    // Label 38: @253034
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5119*/ GIMT_Encode4(254931),
    /*GILLT_s32*//*Label 5114*/ GIMT_Encode4(253081),
    /*GILLT_s64*//*Label 5115*/ GIMT_Encode4(254522), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5116*/ GIMT_Encode4(254745), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5117*/ GIMT_Encode4(254807), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5118*/ GIMT_Encode4(254869),
    // Label 5114: @253081
    GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(253201), // Rule ID 13097 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13097,
      GIR_EraseRootFromParent_Done,
    // Label 5120: @253201
    GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(253321), // Rule ID 13099 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13099,
      GIR_EraseRootFromParent_Done,
    // Label 5121: @253321
    GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(253441), // Rule ID 13101 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13101,
      GIR_EraseRootFromParent_Done,
    // Label 5122: @253441
    GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(253561), // Rule ID 13103 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13103,
      GIR_EraseRootFromParent_Done,
    // Label 5123: @253561
    GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(253681), // Rule ID 13119 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13119,
      GIR_EraseRootFromParent_Done,
    // Label 5124: @253681
    GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(253801), // Rule ID 13121 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13121,
      GIR_EraseRootFromParent_Done,
    // Label 5125: @253801
    GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(253921), // Rule ID 13123 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13123,
      GIR_EraseRootFromParent_Done,
    // Label 5126: @253921
    GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(254041), // Rule ID 13125 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13125,
      GIR_EraseRootFromParent_Done,
    // Label 5127: @254041
    GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(254161), // Rule ID 13129 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13129,
      GIR_EraseRootFromParent_Done,
    // Label 5128: @254161
    GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(254281), // Rule ID 13131 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13131,
      GIR_EraseRootFromParent_Done,
    // Label 5129: @254281
    GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(254401), // Rule ID 13133 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13133,
      GIR_EraseRootFromParent_Done,
    // Label 5130: @254401
    GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(254521), // Rule ID 13135 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13135,
      GIR_EraseRootFromParent_Done,
    // Label 5131: @254521
    GIM_Reject,
    // Label 5115: @254522
    GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(254744),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(254588), // Rule ID 5710 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5710,
        GIR_EraseRootFromParent_Done,
      // Label 5133: @254588
      GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(254667), // Rule ID 11517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11517,
        GIR_EraseRootFromParent_Done,
      // Label 5134: @254667
      GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(254743), // Rule ID 6568 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6568,
        GIR_EraseRootFromParent_Done,
      // Label 5135: @254743
      GIM_Reject,
    // Label 5132: @254744
    GIM_Reject,
    // Label 5116: @254745
    GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(254806),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(254784), // Rule ID 6424 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6424,
        GIR_EraseRootFromParent_Done,
      // Label 5137: @254784
      GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(254805), // Rule ID 6411 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6411,
        GIR_EraseRootFromParent_Done,
      // Label 5138: @254805
      GIM_Reject,
    // Label 5136: @254806
    GIM_Reject,
    // Label 5117: @254807
    GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(254868),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(254846), // Rule ID 6421 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6421,
        GIR_EraseRootFromParent_Done,
      // Label 5140: @254846
      GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(254867), // Rule ID 6408 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6408,
        GIR_EraseRootFromParent_Done,
      // Label 5141: @254867
      GIM_Reject,
    // Label 5139: @254868
    GIM_Reject,
    // Label 5118: @254869
    GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(254930),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(254908), // Rule ID 6418 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6418,
        GIR_EraseRootFromParent_Done,
      // Label 5143: @254908
      GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(254929), // Rule ID 6405 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6405,
        GIR_EraseRootFromParent_Done,
      // Label 5144: @254929
      GIM_Reject,
    // Label 5142: @254930
    GIM_Reject,
    // Label 5119: @254931
    GIM_Reject,
    // Label 39: @254932
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5150*/ GIMT_Encode4(256585),
    /*GILLT_s32*//*Label 5145*/ GIMT_Encode4(255023),
    /*GILLT_s64*//*Label 5146*/ GIMT_Encode4(255517), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5147*/ GIMT_Encode4(256159), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5148*/ GIMT_Encode4(256368), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5149*/ GIMT_Encode4(256512),
    // Label 5145: @255023
    GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(255516),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(255100), // Rule ID 5705 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5705,
        GIR_EraseRootFromParent_Done,
      // Label 5152: @255100
      GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(255165), // Rule ID 5707 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5707,
        GIR_EraseRootFromParent_Done,
      // Label 5153: @255165
      GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(255230), // Rule ID 5709 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5709,
        GIR_EraseRootFromParent_Done,
      // Label 5154: @255230
      GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(255320), // Rule ID 11513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11513,
        GIR_EraseRootFromParent_Done,
      // Label 5155: @255320
      GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(255410), // Rule ID 11515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11515,
        GIR_EraseRootFromParent_Done,
      // Label 5156: @255410
      GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(255445), // Rule ID 6573 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6573,
        GIR_EraseRootFromParent_Done,
      // Label 5157: @255445
      GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(255480), // Rule ID 6574 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6574,
        GIR_EraseRootFromParent_Done,
      // Label 5158: @255480
      GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(255515), // Rule ID 6575 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6575,
        GIR_EraseRootFromParent_Done,
      // Label 5159: @255515
      GIM_Reject,
    // Label 5151: @255516
    GIM_Reject,
    // Label 5146: @255517
    GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(256158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(255606), // Rule ID 5711 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5711,
        GIR_EraseRootFromParent_Done,
      // Label 5161: @255606
      GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(255683), // Rule ID 5712 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5712,
        GIR_EraseRootFromParent_Done,
      // Label 5162: @255683
      GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(255785), // Rule ID 11514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11514,
        GIR_EraseRootFromParent_Done,
      // Label 5163: @255785
      GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(255887), // Rule ID 11516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11516,
        GIR_EraseRootFromParent_Done,
      // Label 5164: @255887
      GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(255952), // Rule ID 5706 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5706,
        GIR_EraseRootFromParent_Done,
      // Label 5165: @255952
      GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(256017), // Rule ID 5708 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5708,
        GIR_EraseRootFromParent_Done,
      // Label 5166: @256017
      GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(256052), // Rule ID 6569 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6569,
        GIR_EraseRootFromParent_Done,
      // Label 5167: @256052
      GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(256087), // Rule ID 6570 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6570,
        GIR_EraseRootFromParent_Done,
      // Label 5168: @256087
      GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(256122), // Rule ID 6571 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6571,
        GIR_EraseRootFromParent_Done,
      // Label 5169: @256122
      GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(256157), // Rule ID 6572 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6572,
        GIR_EraseRootFromParent_Done,
      // Label 5170: @256157
      GIM_Reject,
    // Label 5160: @256158
    GIM_Reject,
    // Label 5147: @256159
    GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(256367),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(256236), // Rule ID 10725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
        // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10725,
        GIR_EraseRootFromParent_Done,
      // Label 5172: @256236
      GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(256301), // Rule ID 10726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10726,
        GIR_EraseRootFromParent_Done,
      // Label 5173: @256301
      GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(256366), // Rule ID 10727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10727,
        GIR_EraseRootFromParent_Done,
      // Label 5174: @256366
      GIM_Reject,
    // Label 5171: @256367
    GIM_Reject,
    // Label 5148: @256368
    GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(256511),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(256445), // Rule ID 10728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10728,
        GIR_EraseRootFromParent_Done,
      // Label 5176: @256445
      GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(256510), // Rule ID 10729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10729,
        GIR_EraseRootFromParent_Done,
      // Label 5177: @256510
      GIM_Reject,
    // Label 5175: @256511
    GIM_Reject,
    // Label 5149: @256512
    GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(256584), // Rule ID 10730 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 10730,
      GIR_EraseRootFromParent_Done,
    // Label 5178: @256584
    GIM_Reject,
    // Label 5150: @256585
    GIM_Reject,
    // Label 40: @256586
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5183*/ GIMT_Encode4(259364),
    /*GILLT_s32*//*Label 5179*/ GIMT_Encode4(256633), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5180*/ GIMT_Encode4(258434), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5181*/ GIMT_Encode4(258744), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5182*/ GIMT_Encode4(259054),
    // Label 5179: @256633
    GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(256783), // Rule ID 13106 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13106,
      GIR_EraseRootFromParent_Done,
    // Label 5184: @256783
    GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(256933), // Rule ID 13108 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13108,
      GIR_EraseRootFromParent_Done,
    // Label 5185: @256933
    GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(257083), // Rule ID 13110 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13110,
      GIR_EraseRootFromParent_Done,
    // Label 5186: @257083
    GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(257233), // Rule ID 13112 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13112,
      GIR_EraseRootFromParent_Done,
    // Label 5187: @257233
    GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(257383), // Rule ID 13139 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13139,
      GIR_EraseRootFromParent_Done,
    // Label 5188: @257383
    GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(257533), // Rule ID 13141 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13141,
      GIR_EraseRootFromParent_Done,
    // Label 5189: @257533
    GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(257683), // Rule ID 13143 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13143,
      GIR_EraseRootFromParent_Done,
    // Label 5190: @257683
    GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(257833), // Rule ID 13145 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13145,
      GIR_EraseRootFromParent_Done,
    // Label 5191: @257833
    GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(257983), // Rule ID 13149 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13149,
      GIR_EraseRootFromParent_Done,
    // Label 5192: @257983
    GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(258133), // Rule ID 13151 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13151,
      GIR_EraseRootFromParent_Done,
    // Label 5193: @258133
    GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(258283), // Rule ID 13153 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13153,
      GIR_EraseRootFromParent_Done,
    // Label 5194: @258283
    GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(258433), // Rule ID 13155 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13155,
      GIR_EraseRootFromParent_Done,
    // Label 5195: @258433
    GIM_Reject,
    // Label 5180: @258434
    GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(258743),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(258511), // Rule ID 697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 697,
        GIR_EraseRootFromParent_Done,
      // Label 5197: @258511
      GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(258576), // Rule ID 1699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1699,
        GIR_EraseRootFromParent_Done,
      // Label 5198: @258576
      GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(258635), // Rule ID 695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 695,
        GIR_EraseRootFromParent_Done,
      // Label 5199: @258635
      GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(258694), // Rule ID 1697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1697,
        GIR_EraseRootFromParent_Done,
      // Label 5200: @258694
      GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(258721), // Rule ID 6423 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6423,
        GIR_EraseRootFromParent_Done,
      // Label 5201: @258721
      GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(258742), // Rule ID 6412 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6412,
        GIR_EraseRootFromParent_Done,
      // Label 5202: @258742
      GIM_Reject,
    // Label 5196: @258743
    GIM_Reject,
    // Label 5181: @258744
    GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(259053),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(258821), // Rule ID 693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 693,
        GIR_EraseRootFromParent_Done,
      // Label 5204: @258821
      GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(258886), // Rule ID 1695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1695,
        GIR_EraseRootFromParent_Done,
      // Label 5205: @258886
      GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(258945), // Rule ID 691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 691,
        GIR_EraseRootFromParent_Done,
      // Label 5206: @258945
      GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(259004), // Rule ID 1693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1693,
        GIR_EraseRootFromParent_Done,
      // Label 5207: @259004
      GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(259031), // Rule ID 6420 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6420,
        GIR_EraseRootFromParent_Done,
      // Label 5208: @259031
      GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(259052), // Rule ID 6409 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6409,
        GIR_EraseRootFromParent_Done,
      // Label 5209: @259052
      GIM_Reject,
    // Label 5203: @259053
    GIM_Reject,
    // Label 5182: @259054
    GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(259363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(259131), // Rule ID 689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 689,
        GIR_EraseRootFromParent_Done,
      // Label 5211: @259131
      GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(259196), // Rule ID 1691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1691,
        GIR_EraseRootFromParent_Done,
      // Label 5212: @259196
      GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(259255), // Rule ID 687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 687,
        GIR_EraseRootFromParent_Done,
      // Label 5213: @259255
      GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(259314), // Rule ID 1689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1689,
        GIR_EraseRootFromParent_Done,
      // Label 5214: @259314
      GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(259341), // Rule ID 6417 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6417,
        GIR_EraseRootFromParent_Done,
      // Label 5215: @259341
      GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(259362), // Rule ID 6406 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6406,
        GIR_EraseRootFromParent_Done,
      // Label 5216: @259362
      GIM_Reject,
    // Label 5210: @259363
    GIM_Reject,
    // Label 5183: @259364
    GIM_Reject,
    // Label 41: @259365
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5222*/ GIMT_Encode4(260144),
    /*GILLT_s32*//*Label 5217*/ GIMT_Encode4(259412),
    /*GILLT_s64*//*Label 5218*/ GIMT_Encode4(259544), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5219*/ GIMT_Encode4(259717), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5220*/ GIMT_Encode4(259862), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5221*/ GIMT_Encode4(260003),
    // Label 5217: @259412
    GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(259543),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(259468), // Rule ID 3903 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3903,
        GIR_EraseRootFromParent_Done,
      // Label 5224: @259468
      GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(259505), // Rule ID 3904 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3904,
        GIR_EraseRootFromParent_Done,
      // Label 5225: @259505
      GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(259542), // Rule ID 3902 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3902,
        GIR_EraseRootFromParent_Done,
      // Label 5226: @259542
      GIM_Reject,
    // Label 5223: @259543
    GIM_Reject,
    // Label 5218: @259544
    GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(259716),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(259631), // Rule ID 3905 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3905,
        GIR_EraseRootFromParent_Done,
      // Label 5228: @259631
      GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(259699), // Rule ID 3906 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3906,
        GIR_EraseRootFromParent_Done,
      // Label 5229: @259699
      GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(259715), // Rule ID 132 //
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 132,
        GIR_Done,
      // Label 5230: @259715
      GIM_Reject,
    // Label 5227: @259716
    GIM_Reject,
    // Label 5219: @259717
    GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(259861),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(259796), // Rule ID 6404 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6404,
        GIR_EraseRootFromParent_Done,
      // Label 5232: @259796
      GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(259860), // Rule ID 6401 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6401,
        GIR_EraseRootFromParent_Done,
      // Label 5233: @259860
      GIM_Reject,
    // Label 5231: @259861
    GIM_Reject,
    // Label 5220: @259862
    GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(260002),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(259939), // Rule ID 6403 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6403,
        GIR_EraseRootFromParent_Done,
      // Label 5235: @259939
      GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(260001), // Rule ID 6400 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6400,
        GIR_EraseRootFromParent_Done,
      // Label 5236: @260001
      GIM_Reject,
    // Label 5234: @260002
    GIM_Reject,
    // Label 5221: @260003
    GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(260143),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(260080), // Rule ID 6402 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6402,
        GIR_EraseRootFromParent_Done,
      // Label 5238: @260080
      GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(260142), // Rule ID 6399 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6399,
        GIR_EraseRootFromParent_Done,
      // Label 5239: @260142
      GIM_Reject,
    // Label 5237: @260143
    GIM_Reject,
    // Label 5222: @260144
    GIM_Reject,
    // Label 42: @260145
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5242*/ GIMT_Encode4(260537),
    /*GILLT_s32*//*Label 5240*/ GIMT_Encode4(260164),
    /*GILLT_s64*//*Label 5241*/ GIMT_Encode4(260330),
    // Label 5240: @260164
    GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(260329),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(260217), // Rule ID 3992 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3992,
        GIR_EraseRootFromParent_Done,
      // Label 5244: @260217
      GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(260254), // Rule ID 3909 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3909,
        GIR_EraseRootFromParent_Done,
      // Label 5245: @260254
      GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(260291), // Rule ID 3910 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3910,
        GIR_EraseRootFromParent_Done,
      // Label 5246: @260291
      GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(260328), // Rule ID 3908 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3908,
        GIR_EraseRootFromParent_Done,
      // Label 5247: @260328
      GIM_Reject,
    // Label 5243: @260329
    GIM_Reject,
    // Label 5241: @260330
    GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(260536),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(260383), // Rule ID 3993 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3993,
        GIR_EraseRootFromParent_Done,
      // Label 5249: @260383
      GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(260451), // Rule ID 3911 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3911,
        GIR_EraseRootFromParent_Done,
      // Label 5250: @260451
      GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(260519), // Rule ID 3912 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3912,
        GIR_EraseRootFromParent_Done,
      // Label 5251: @260519
      GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(260535), // Rule ID 133 //
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 133,
        GIR_Done,
      // Label 5252: @260535
      GIM_Reject,
    // Label 5248: @260536
    GIM_Reject,
    // Label 5242: @260537
    GIM_Reject,
    // Label 43: @260538
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5255*/ GIMT_Encode4(261313),
    /*GILLT_s32*//*Label 5253*/ GIMT_Encode4(260557),
    /*GILLT_s64*//*Label 5254*/ GIMT_Encode4(260863),
    // Label 5253: @260557
    GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(260862),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(260636), // Rule ID 6582 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6582,
        GIR_EraseRootFromParent_Done,
      // Label 5257: @260636
      GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(260700), // Rule ID 6584 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6584,
        GIR_EraseRootFromParent_Done,
      // Label 5258: @260700
      GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(260738), // Rule ID 3990 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3990,
        GIR_EraseRootFromParent_Done,
      // Label 5259: @260738
      GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(260779), // Rule ID 2411 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2411,
        GIR_EraseRootFromParent_Done,
      // Label 5260: @260779
      GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(260820), // Rule ID 2412 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2412,
        GIR_EraseRootFromParent_Done,
      // Label 5261: @260820
      GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(260861), // Rule ID 2410 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2410,
        GIR_EraseRootFromParent_Done,
      // Label 5262: @260861
      GIM_Reject,
    // Label 5256: @260862
    GIM_Reject,
    // Label 5254: @260863
    GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(261312),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(260942), // Rule ID 6583 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6583,
        GIR_EraseRootFromParent_Done,
      // Label 5264: @260942
      GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(261006), // Rule ID 6585 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6585,
        GIR_EraseRootFromParent_Done,
      // Label 5265: @261006
      GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(261109), // Rule ID 6586 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6586,
        GIR_EraseRootFromParent_Done,
      // Label 5266: @261109
      GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(261147), // Rule ID 3991 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3991,
        GIR_EraseRootFromParent_Done,
      // Label 5267: @261147
      GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(261219), // Rule ID 2413 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2413,
        GIR_EraseRootFromParent_Done,
      // Label 5268: @261219
      GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(261291), // Rule ID 2414 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2414,
        GIR_EraseRootFromParent_Done,
      // Label 5269: @261291
      GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(261311), // Rule ID 131 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 131,
        GIR_Done,
      // Label 5270: @261311
      GIM_Reject,
    // Label 5263: @261312
    GIM_Reject,
    // Label 5255: @261313
    GIM_Reject,
    // Label 44: @261314
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5273*/ GIMT_Encode4(261443),
    /*GILLT_s32*//*Label 5271*/ GIMT_Encode4(261333),
    /*GILLT_s64*//*Label 5272*/ GIMT_Encode4(261388),
    // Label 5271: @261333
    GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(261387), // Rule ID 200 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/2, // Rm
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 200,
      GIR_EraseRootFromParent_Done,
    // Label 5274: @261387
    GIM_Reject,
    // Label 5272: @261388
    GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(261442), // Rule ID 201 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/2, // Rm
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 201,
      GIR_EraseRootFromParent_Done,
    // Label 5275: @261442
    GIM_Reject,
    // Label 5273: @261443
    GIM_Reject,
    // Label 45: @261444
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5278*/ GIMT_Encode4(261936),
    /*GILLT_s32*//*Label 5276*/ GIMT_Encode4(261463),
    /*GILLT_s64*//*Label 5277*/ GIMT_Encode4(261679),
    // Label 5276: @261463
    GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(261678),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(261517), // Rule ID 196 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 196,
        GIR_EraseRootFromParent_Done,
      // Label 5280: @261517
      GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(261554), // Rule ID 3986 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3986,
        GIR_EraseRootFromParent_Done,
      // Label 5281: @261554
      GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(261595), // Rule ID 3915 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3915,
        GIR_EraseRootFromParent_Done,
      // Label 5282: @261595
      GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(261636), // Rule ID 3916 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3916,
        GIR_EraseRootFromParent_Done,
      // Label 5283: @261636
      GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(261677), // Rule ID 3914 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3914,
        GIR_EraseRootFromParent_Done,
      // Label 5284: @261677
      GIM_Reject,
    // Label 5279: @261678
    GIM_Reject,
    // Label 5277: @261679
    GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(261935),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(261733), // Rule ID 199 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 199,
        GIR_EraseRootFromParent_Done,
      // Label 5286: @261733
      GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(261770), // Rule ID 3987 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3987,
        GIR_EraseRootFromParent_Done,
      // Label 5287: @261770
      GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(261842), // Rule ID 3917 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3917,
        GIR_EraseRootFromParent_Done,
      // Label 5288: @261842
      GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(261914), // Rule ID 3918 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3918,
        GIR_EraseRootFromParent_Done,
      // Label 5289: @261914
      GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(261934), // Rule ID 134 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 134,
        GIR_Done,
      // Label 5290: @261934
      GIM_Reject,
    // Label 5285: @261935
    GIM_Reject,
    // Label 5278: @261936
    GIM_Reject,
    // Label 46: @261937
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5298*/ GIMT_Encode4(266512),
    /*GILLT_v2s32*//*Label 5291*/ GIMT_Encode4(261976),
    /*GILLT_v2s64*//*Label 5292*/ GIMT_Encode4(262624),
    /*GILLT_v4s16*//*Label 5293*/ GIMT_Encode4(263272),
    /*GILLT_v4s32*//*Label 5294*/ GIMT_Encode4(263920),
    /*GILLT_v8s8*//*Label 5295*/ GIMT_Encode4(264568),
    /*GILLT_v8s16*//*Label 5296*/ GIMT_Encode4(265216),
    /*GILLT_v16s8*//*Label 5297*/ GIMT_Encode4(265864),
    // Label 5291: @261976
    GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(262623),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(262028), // Rule ID 5199 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5199,
        GIR_EraseRootFromParent_Done,
      // Label 5300: @262028
      GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(262065), // Rule ID 5206 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5206,
        GIR_EraseRootFromParent_Done,
      // Label 5301: @262065
      GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(262102), // Rule ID 5213 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5213,
        GIR_EraseRootFromParent_Done,
      // Label 5302: @262102
      GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(262139), // Rule ID 5220 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5220,
        GIR_EraseRootFromParent_Done,
      // Label 5303: @262139
      GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(262176), // Rule ID 5227 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5227,
        GIR_EraseRootFromParent_Done,
      // Label 5304: @262176
      GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(262213), // Rule ID 5164 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5164,
        GIR_EraseRootFromParent_Done,
      // Label 5305: @262213
      GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(262250), // Rule ID 5171 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5171,
        GIR_EraseRootFromParent_Done,
      // Label 5306: @262250
      GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(262287), // Rule ID 5178 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5178,
        GIR_EraseRootFromParent_Done,
      // Label 5307: @262287
      GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(262324), // Rule ID 5185 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5185,
        GIR_EraseRootFromParent_Done,
      // Label 5308: @262324
      GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(262361), // Rule ID 5192 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5192,
        GIR_EraseRootFromParent_Done,
      // Label 5309: @262361
      GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(262390), // Rule ID 5101 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5101,
        GIR_EraseRootFromParent_Done,
      // Label 5310: @262390
      GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(262419), // Rule ID 5108 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5108,
        GIR_EraseRootFromParent_Done,
      // Label 5311: @262419
      GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(262448), // Rule ID 5115 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5115,
        GIR_EraseRootFromParent_Done,
      // Label 5312: @262448
      GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(262477), // Rule ID 5122 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5122,
        GIR_EraseRootFromParent_Done,
      // Label 5313: @262477
      GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(262506), // Rule ID 5129 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5129,
        GIR_EraseRootFromParent_Done,
      // Label 5314: @262506
      GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(262535), // Rule ID 5136 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5136,
        GIR_EraseRootFromParent_Done,
      // Label 5315: @262535
      GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(262564), // Rule ID 5143 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5143,
        GIR_EraseRootFromParent_Done,
      // Label 5316: @262564
      GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(262593), // Rule ID 5150 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5150,
        GIR_EraseRootFromParent_Done,
      // Label 5317: @262593
      GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(262622), // Rule ID 5157 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5157,
        GIR_EraseRootFromParent_Done,
      // Label 5318: @262622
      GIM_Reject,
    // Label 5299: @262623
    GIM_Reject,
    // Label 5292: @262624
    GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(263271),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(262676), // Rule ID 5201 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5201,
        GIR_EraseRootFromParent_Done,
      // Label 5320: @262676
      GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(262713), // Rule ID 5208 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5208,
        GIR_EraseRootFromParent_Done,
      // Label 5321: @262713
      GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(262750), // Rule ID 5215 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5215,
        GIR_EraseRootFromParent_Done,
      // Label 5322: @262750
      GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(262787), // Rule ID 5222 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5222,
        GIR_EraseRootFromParent_Done,
      // Label 5323: @262787
      GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(262824), // Rule ID 5229 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5229,
        GIR_EraseRootFromParent_Done,
      // Label 5324: @262824
      GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(262861), // Rule ID 5166 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5166,
        GIR_EraseRootFromParent_Done,
      // Label 5325: @262861
      GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(262898), // Rule ID 5173 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5173,
        GIR_EraseRootFromParent_Done,
      // Label 5326: @262898
      GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(262935), // Rule ID 5180 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5180,
        GIR_EraseRootFromParent_Done,
      // Label 5327: @262935
      GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(262972), // Rule ID 5187 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5187,
        GIR_EraseRootFromParent_Done,
      // Label 5328: @262972
      GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(263009), // Rule ID 5194 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5194,
        GIR_EraseRootFromParent_Done,
      // Label 5329: @263009
      GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(263038), // Rule ID 5103 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5103,
        GIR_EraseRootFromParent_Done,
      // Label 5330: @263038
      GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(263067), // Rule ID 5110 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5110,
        GIR_EraseRootFromParent_Done,
      // Label 5331: @263067
      GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(263096), // Rule ID 5117 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5117,
        GIR_EraseRootFromParent_Done,
      // Label 5332: @263096
      GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(263125), // Rule ID 5124 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5124,
        GIR_EraseRootFromParent_Done,
      // Label 5333: @263125
      GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(263154), // Rule ID 5131 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5131,
        GIR_EraseRootFromParent_Done,
      // Label 5334: @263154
      GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(263183), // Rule ID 5138 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5138,
        GIR_EraseRootFromParent_Done,
      // Label 5335: @263183
      GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(263212), // Rule ID 5145 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5145,
        GIR_EraseRootFromParent_Done,
      // Label 5336: @263212
      GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(263241), // Rule ID 5152 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5152,
        GIR_EraseRootFromParent_Done,
      // Label 5337: @263241
      GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(263270), // Rule ID 5159 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5159,
        GIR_EraseRootFromParent_Done,
      // Label 5338: @263270
      GIM_Reject,
    // Label 5319: @263271
    GIM_Reject,
    // Label 5293: @263272
    GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(263919),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(263324), // Rule ID 5197 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5197,
        GIR_EraseRootFromParent_Done,
      // Label 5340: @263324
      GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(263361), // Rule ID 5204 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5204,
        GIR_EraseRootFromParent_Done,
      // Label 5341: @263361
      GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(263398), // Rule ID 5211 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5211,
        GIR_EraseRootFromParent_Done,
      // Label 5342: @263398
      GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(263435), // Rule ID 5218 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5218,
        GIR_EraseRootFromParent_Done,
      // Label 5343: @263435
      GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(263472), // Rule ID 5225 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5225,
        GIR_EraseRootFromParent_Done,
      // Label 5344: @263472
      GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(263509), // Rule ID 5162 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5162,
        GIR_EraseRootFromParent_Done,
      // Label 5345: @263509
      GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(263546), // Rule ID 5169 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5169,
        GIR_EraseRootFromParent_Done,
      // Label 5346: @263546
      GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(263583), // Rule ID 5176 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5176,
        GIR_EraseRootFromParent_Done,
      // Label 5347: @263583
      GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(263620), // Rule ID 5183 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5183,
        GIR_EraseRootFromParent_Done,
      // Label 5348: @263620
      GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(263657), // Rule ID 5190 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5190,
        GIR_EraseRootFromParent_Done,
      // Label 5349: @263657
      GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(263686), // Rule ID 5099 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5099,
        GIR_EraseRootFromParent_Done,
      // Label 5350: @263686
      GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(263715), // Rule ID 5106 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5106,
        GIR_EraseRootFromParent_Done,
      // Label 5351: @263715
      GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(263744), // Rule ID 5113 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5113,
        GIR_EraseRootFromParent_Done,
      // Label 5352: @263744
      GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(263773), // Rule ID 5120 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5120,
        GIR_EraseRootFromParent_Done,
      // Label 5353: @263773
      GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(263802), // Rule ID 5127 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5127,
        GIR_EraseRootFromParent_Done,
      // Label 5354: @263802
      GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(263831), // Rule ID 5134 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5134,
        GIR_EraseRootFromParent_Done,
      // Label 5355: @263831
      GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(263860), // Rule ID 5141 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5141,
        GIR_EraseRootFromParent_Done,
      // Label 5356: @263860
      GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(263889), // Rule ID 5148 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5148,
        GIR_EraseRootFromParent_Done,
      // Label 5357: @263889
      GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(263918), // Rule ID 5155 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5155,
        GIR_EraseRootFromParent_Done,
      // Label 5358: @263918
      GIM_Reject,
    // Label 5339: @263919
    GIM_Reject,
    // Label 5294: @263920
    GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(264567),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(263972), // Rule ID 5200 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5200,
        GIR_EraseRootFromParent_Done,
      // Label 5360: @263972
      GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(264009), // Rule ID 5207 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5207,
        GIR_EraseRootFromParent_Done,
      // Label 5361: @264009
      GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(264046), // Rule ID 5214 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5214,
        GIR_EraseRootFromParent_Done,
      // Label 5362: @264046
      GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(264083), // Rule ID 5221 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5221,
        GIR_EraseRootFromParent_Done,
      // Label 5363: @264083
      GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(264120), // Rule ID 5228 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5228,
        GIR_EraseRootFromParent_Done,
      // Label 5364: @264120
      GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(264157), // Rule ID 5165 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5165,
        GIR_EraseRootFromParent_Done,
      // Label 5365: @264157
      GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(264194), // Rule ID 5172 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5172,
        GIR_EraseRootFromParent_Done,
      // Label 5366: @264194
      GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(264231), // Rule ID 5179 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5179,
        GIR_EraseRootFromParent_Done,
      // Label 5367: @264231
      GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(264268), // Rule ID 5186 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5186,
        GIR_EraseRootFromParent_Done,
      // Label 5368: @264268
      GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(264305), // Rule ID 5193 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5193,
        GIR_EraseRootFromParent_Done,
      // Label 5369: @264305
      GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(264334), // Rule ID 5102 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5102,
        GIR_EraseRootFromParent_Done,
      // Label 5370: @264334
      GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(264363), // Rule ID 5109 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5109,
        GIR_EraseRootFromParent_Done,
      // Label 5371: @264363
      GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(264392), // Rule ID 5116 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5116,
        GIR_EraseRootFromParent_Done,
      // Label 5372: @264392
      GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(264421), // Rule ID 5123 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5123,
        GIR_EraseRootFromParent_Done,
      // Label 5373: @264421
      GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(264450), // Rule ID 5130 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5130,
        GIR_EraseRootFromParent_Done,
      // Label 5374: @264450
      GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(264479), // Rule ID 5137 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5137,
        GIR_EraseRootFromParent_Done,
      // Label 5375: @264479
      GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(264508), // Rule ID 5144 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5144,
        GIR_EraseRootFromParent_Done,
      // Label 5376: @264508
      GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(264537), // Rule ID 5151 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5151,
        GIR_EraseRootFromParent_Done,
      // Label 5377: @264537
      GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(264566), // Rule ID 5158 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5158,
        GIR_EraseRootFromParent_Done,
      // Label 5378: @264566
      GIM_Reject,
    // Label 5359: @264567
    GIM_Reject,
    // Label 5295: @264568
    GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(265215),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(264620), // Rule ID 5195 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5195,
        GIR_EraseRootFromParent_Done,
      // Label 5380: @264620
      GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(264657), // Rule ID 5202 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5202,
        GIR_EraseRootFromParent_Done,
      // Label 5381: @264657
      GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(264694), // Rule ID 5209 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5209,
        GIR_EraseRootFromParent_Done,
      // Label 5382: @264694
      GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(264731), // Rule ID 5216 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5216,
        GIR_EraseRootFromParent_Done,
      // Label 5383: @264731
      GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(264768), // Rule ID 5223 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5223,
        GIR_EraseRootFromParent_Done,
      // Label 5384: @264768
      GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(264805), // Rule ID 5160 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5160,
        GIR_EraseRootFromParent_Done,
      // Label 5385: @264805
      GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(264842), // Rule ID 5167 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5167,
        GIR_EraseRootFromParent_Done,
      // Label 5386: @264842
      GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(264879), // Rule ID 5174 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5174,
        GIR_EraseRootFromParent_Done,
      // Label 5387: @264879
      GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(264916), // Rule ID 5181 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5181,
        GIR_EraseRootFromParent_Done,
      // Label 5388: @264916
      GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(264953), // Rule ID 5188 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5188,
        GIR_EraseRootFromParent_Done,
      // Label 5389: @264953
      GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(264982), // Rule ID 5097 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5097,
        GIR_EraseRootFromParent_Done,
      // Label 5390: @264982
      GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(265011), // Rule ID 5104 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5104,
        GIR_EraseRootFromParent_Done,
      // Label 5391: @265011
      GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(265040), // Rule ID 5111 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5111,
        GIR_EraseRootFromParent_Done,
      // Label 5392: @265040
      GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(265069), // Rule ID 5118 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5118,
        GIR_EraseRootFromParent_Done,
      // Label 5393: @265069
      GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(265098), // Rule ID 5125 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5125,
        GIR_EraseRootFromParent_Done,
      // Label 5394: @265098
      GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(265127), // Rule ID 5132 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5132,
        GIR_EraseRootFromParent_Done,
      // Label 5395: @265127
      GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(265156), // Rule ID 5139 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5139,
        GIR_EraseRootFromParent_Done,
      // Label 5396: @265156
      GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(265185), // Rule ID 5146 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5146,
        GIR_EraseRootFromParent_Done,
      // Label 5397: @265185
      GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(265214), // Rule ID 5153 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5153,
        GIR_EraseRootFromParent_Done,
      // Label 5398: @265214
      GIM_Reject,
    // Label 5379: @265215
    GIM_Reject,
    // Label 5296: @265216
    GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(265863),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(265268), // Rule ID 5198 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5198,
        GIR_EraseRootFromParent_Done,
      // Label 5400: @265268
      GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(265305), // Rule ID 5205 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5205,
        GIR_EraseRootFromParent_Done,
      // Label 5401: @265305
      GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(265342), // Rule ID 5212 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5212,
        GIR_EraseRootFromParent_Done,
      // Label 5402: @265342
      GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(265379), // Rule ID 5219 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5219,
        GIR_EraseRootFromParent_Done,
      // Label 5403: @265379
      GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(265416), // Rule ID 5226 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5226,
        GIR_EraseRootFromParent_Done,
      // Label 5404: @265416
      GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(265453), // Rule ID 5163 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5163,
        GIR_EraseRootFromParent_Done,
      // Label 5405: @265453
      GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(265490), // Rule ID 5170 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5170,
        GIR_EraseRootFromParent_Done,
      // Label 5406: @265490
      GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(265527), // Rule ID 5177 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5177,
        GIR_EraseRootFromParent_Done,
      // Label 5407: @265527
      GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(265564), // Rule ID 5184 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5184,
        GIR_EraseRootFromParent_Done,
      // Label 5408: @265564
      GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(265601), // Rule ID 5191 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5191,
        GIR_EraseRootFromParent_Done,
      // Label 5409: @265601
      GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(265630), // Rule ID 5100 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5100,
        GIR_EraseRootFromParent_Done,
      // Label 5410: @265630
      GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(265659), // Rule ID 5107 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5107,
        GIR_EraseRootFromParent_Done,
      // Label 5411: @265659
      GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(265688), // Rule ID 5114 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5114,
        GIR_EraseRootFromParent_Done,
      // Label 5412: @265688
      GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(265717), // Rule ID 5121 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5121,
        GIR_EraseRootFromParent_Done,
      // Label 5413: @265717
      GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(265746), // Rule ID 5128 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5128,
        GIR_EraseRootFromParent_Done,
      // Label 5414: @265746
      GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(265775), // Rule ID 5135 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5135,
        GIR_EraseRootFromParent_Done,
      // Label 5415: @265775
      GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(265804), // Rule ID 5142 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5142,
        GIR_EraseRootFromParent_Done,
      // Label 5416: @265804
      GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(265833), // Rule ID 5149 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5149,
        GIR_EraseRootFromParent_Done,
      // Label 5417: @265833
      GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(265862), // Rule ID 5156 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5156,
        GIR_EraseRootFromParent_Done,
      // Label 5418: @265862
      GIM_Reject,
    // Label 5399: @265863
    GIM_Reject,
    // Label 5297: @265864
    GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(266511),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(265916), // Rule ID 5196 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5196,
        GIR_EraseRootFromParent_Done,
      // Label 5420: @265916
      GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(265953), // Rule ID 5203 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5203,
        GIR_EraseRootFromParent_Done,
      // Label 5421: @265953
      GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(265990), // Rule ID 5210 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5210,
        GIR_EraseRootFromParent_Done,
      // Label 5422: @265990
      GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(266027), // Rule ID 5217 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5217,
        GIR_EraseRootFromParent_Done,
      // Label 5423: @266027
      GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(266064), // Rule ID 5224 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5224,
        GIR_EraseRootFromParent_Done,
      // Label 5424: @266064
      GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(266101), // Rule ID 5161 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5161,
        GIR_EraseRootFromParent_Done,
      // Label 5425: @266101
      GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(266138), // Rule ID 5168 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5168,
        GIR_EraseRootFromParent_Done,
      // Label 5426: @266138
      GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(266175), // Rule ID 5175 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5175,
        GIR_EraseRootFromParent_Done,
      // Label 5427: @266175
      GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(266212), // Rule ID 5182 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5182,
        GIR_EraseRootFromParent_Done,
      // Label 5428: @266212
      GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(266249), // Rule ID 5189 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5189,
        GIR_EraseRootFromParent_Done,
      // Label 5429: @266249
      GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(266278), // Rule ID 5098 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5098,
        GIR_EraseRootFromParent_Done,
      // Label 5430: @266278
      GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(266307), // Rule ID 5105 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5105,
        GIR_EraseRootFromParent_Done,
      // Label 5431: @266307
      GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(266336), // Rule ID 5112 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5112,
        GIR_EraseRootFromParent_Done,
      // Label 5432: @266336
      GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(266365), // Rule ID 5119 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5119,
        GIR_EraseRootFromParent_Done,
      // Label 5433: @266365
      GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(266394), // Rule ID 5126 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5126,
        GIR_EraseRootFromParent_Done,
      // Label 5434: @266394
      GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(266423), // Rule ID 5133 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5133,
        GIR_EraseRootFromParent_Done,
      // Label 5435: @266423
      GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(266452), // Rule ID 5140 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5140,
        GIR_EraseRootFromParent_Done,
      // Label 5436: @266452
      GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(266481), // Rule ID 5147 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5147,
        GIR_EraseRootFromParent_Done,
      // Label 5437: @266481
      GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(266510), // Rule ID 5154 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5154,
        GIR_EraseRootFromParent_Done,
      // Label 5438: @266510
      GIM_Reject,
    // Label 5419: @266511
    GIM_Reject,
    // Label 5298: @266512
    GIM_Reject,
    // Label 47: @266513
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5451*/ GIMT_Encode4(266998),
    /*GILLT_nxv1s1*//*Label 5439*/ GIMT_Encode4(266572),
    /*GILLT_nxv2s1*//*Label 5440*/ GIMT_Encode4(266601),
    /*GILLT_nxv2s16*//*Label 5441*/ GIMT_Encode4(266630),
    /*GILLT_nxv2s32*//*Label 5442*/ GIMT_Encode4(266659),
    /*GILLT_nxv2s64*//*Label 5443*/ GIMT_Encode4(266688),
    /*GILLT_nxv4s1*//*Label 5444*/ GIMT_Encode4(266738),
    /*GILLT_nxv4s16*//*Label 5445*/ GIMT_Encode4(266767),
    /*GILLT_nxv4s32*//*Label 5446*/ GIMT_Encode4(266796),
    /*GILLT_nxv8s1*//*Label 5447*/ GIMT_Encode4(266846),
    /*GILLT_nxv8s16*//*Label 5448*/ GIMT_Encode4(266875),
    /*GILLT_nxv16s1*//*Label 5449*/ GIMT_Encode4(266940),
    /*GILLT_nxv16s8*//*Label 5450*/ GIMT_Encode4(266969),
    // Label 5439: @266572
    GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(266600), // Rule ID 8608 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8608,
      GIR_Done,
    // Label 5452: @266600
    GIM_Reject,
    // Label 5440: @266601
    GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(266629), // Rule ID 8607 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8607,
      GIR_Done,
    // Label 5453: @266629
    GIM_Reject,
    // Label 5441: @266630
    GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(266658), // Rule ID 2696 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2696,
      GIR_Done,
    // Label 5454: @266658
    GIM_Reject,
    // Label 5442: @266659
    GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(266687), // Rule ID 2697 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2697,
      GIR_Done,
    // Label 5455: @266687
    GIM_Reject,
    // Label 5443: @266688
    GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(266737),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(266721), // Rule ID 2692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2692,
        GIR_Done,
      // Label 5457: @266721
      GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(266736), // Rule ID 2698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2698,
        GIR_Done,
      // Label 5458: @266736
      GIM_Reject,
    // Label 5456: @266737
    GIM_Reject,
    // Label 5444: @266738
    GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(266766), // Rule ID 8606 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8606,
      GIR_Done,
    // Label 5459: @266766
    GIM_Reject,
    // Label 5445: @266767
    GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(266795), // Rule ID 2694 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2694,
      GIR_Done,
    // Label 5460: @266795
    GIM_Reject,
    // Label 5446: @266796
    GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(266845),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(266829), // Rule ID 2691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2691,
        GIR_Done,
      // Label 5462: @266829
      GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(266844), // Rule ID 2695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2695,
        GIR_Done,
      // Label 5463: @266844
      GIM_Reject,
    // Label 5461: @266845
    GIM_Reject,
    // Label 5447: @266846
    GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(266874), // Rule ID 8605 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8605,
      GIR_Done,
    // Label 5464: @266874
    GIM_Reject,
    // Label 5448: @266875
    GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(266939),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(266908), // Rule ID 2690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2690,
        GIR_Done,
      // Label 5466: @266908
      GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(266923), // Rule ID 2693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2693,
        GIR_Done,
      // Label 5467: @266923
      GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(266938), // Rule ID 2699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vselect:{ *:[nxv8bf16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2699,
        GIR_Done,
      // Label 5468: @266938
      GIM_Reject,
    // Label 5465: @266939
    GIM_Reject,
    // Label 5449: @266940
    GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(266968), // Rule ID 8604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8604,
      GIR_Done,
    // Label 5469: @266968
    GIM_Reject,
    // Label 5450: @266969
    GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(266997), // Rule ID 2689 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2689,
      GIR_Done,
    // Label 5470: @266997
    GIM_Reject,
    // Label 5451: @266998
    GIM_Reject,
    // Label 48: @266999
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5475*/ GIMT_Encode4(267482),
    /*GILLT_s64*//*Label 5471*/ GIMT_Encode4(267046), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5472*/ GIMT_Encode4(267077), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5473*/ GIMT_Encode4(267212),
    /*GILLT_v16s8*//*Label 5474*/ GIMT_Encode4(267347),
    // Label 5471: @267046
    GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(267076), // Rule ID 140 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 140,
      GIR_Done,
    // Label 5476: @267076
    GIM_Reject,
    // Label 5472: @267077
    GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(267211), // Rule ID 6596 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6596,
      GIR_EraseRootFromParent_Done,
    // Label 5477: @267211
    GIM_Reject,
    // Label 5473: @267212
    GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(267346), // Rule ID 6595 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6595,
      GIR_EraseRootFromParent_Done,
    // Label 5478: @267346
    GIM_Reject,
    // Label 5474: @267347
    GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(267481), // Rule ID 6594 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6594,
      GIR_EraseRootFromParent_Done,
    // Label 5479: @267481
    GIM_Reject,
    // Label 5475: @267482
    GIM_Reject,
    // Label 49: @267483
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5484*/ GIMT_Encode4(267966),
    /*GILLT_s64*//*Label 5480*/ GIMT_Encode4(267530), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5481*/ GIMT_Encode4(267561), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5482*/ GIMT_Encode4(267696),
    /*GILLT_v16s8*//*Label 5483*/ GIMT_Encode4(267831),
    // Label 5480: @267530
    GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(267560), // Rule ID 139 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 139,
      GIR_Done,
    // Label 5485: @267560
    GIM_Reject,
    // Label 5481: @267561
    GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(267695), // Rule ID 6593 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6593,
      GIR_EraseRootFromParent_Done,
    // Label 5486: @267695
    GIM_Reject,
    // Label 5482: @267696
    GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(267830), // Rule ID 6592 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6592,
      GIR_EraseRootFromParent_Done,
    // Label 5487: @267830
    GIM_Reject,
    // Label 5483: @267831
    GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(267965), // Rule ID 6591 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6591,
      GIR_EraseRootFromParent_Done,
    // Label 5488: @267965
    GIM_Reject,
    // Label 5484: @267966
    GIM_Reject,
    // Label 50: @267967
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5500*/ GIMT_Encode4(268396),
    /*GILLT_v2s32*//*Label 5489*/ GIMT_Encode4(268054),
    /*GILLT_v2s64*//*Label 5490*/ GIMT_Encode4(268088),
    /*GILLT_v4s16*//*Label 5491*/ GIMT_Encode4(268122),
    /*GILLT_v4s32*//*Label 5492*/ GIMT_Encode4(268156),
    /*GILLT_v8s8*//*Label 5493*/ GIMT_Encode4(268190),
    /*GILLT_v8s16*//*Label 5494*/ GIMT_Encode4(268224),
    /*GILLT_v16s8*//*Label 5495*/ GIMT_Encode4(268258), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5496*/ GIMT_Encode4(268292), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5497*/ GIMT_Encode4(268318), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5498*/ GIMT_Encode4(268344), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5499*/ GIMT_Encode4(268370),
    // Label 5489: @268054
    GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(268087), // Rule ID 5046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5046,
      GIR_Done,
    // Label 5501: @268087
    GIM_Reject,
    // Label 5490: @268088
    GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(268121), // Rule ID 5050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5050,
      GIR_Done,
    // Label 5502: @268121
    GIM_Reject,
    // Label 5491: @268122
    GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(268155), // Rule ID 5045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5045,
      GIR_Done,
    // Label 5503: @268155
    GIM_Reject,
    // Label 5492: @268156
    GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(268189), // Rule ID 5049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5049,
      GIR_Done,
    // Label 5504: @268189
    GIM_Reject,
    // Label 5493: @268190
    GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(268223), // Rule ID 5044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5044,
      GIR_Done,
    // Label 5505: @268223
    GIM_Reject,
    // Label 5494: @268224
    GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(268257), // Rule ID 5048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5048,
      GIR_Done,
    // Label 5506: @268257
    GIM_Reject,
    // Label 5495: @268258
    GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(268291), // Rule ID 5047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5047,
      GIR_Done,
    // Label 5507: @268291
    GIM_Reject,
    // Label 5496: @268292
    GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(268317), // Rule ID 7583 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7583,
      GIR_Done,
    // Label 5508: @268317
    GIM_Reject,
    // Label 5497: @268318
    GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(268343), // Rule ID 7582 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7582,
      GIR_Done,
    // Label 5509: @268343
    GIM_Reject,
    // Label 5498: @268344
    GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(268369), // Rule ID 7581 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7581,
      GIR_Done,
    // Label 5510: @268369
    GIM_Reject,
    // Label 5499: @268370
    GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(268395), // Rule ID 7580 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7580,
      GIR_Done,
    // Label 5511: @268395
    GIM_Reject,
    // Label 5500: @268396
    GIM_Reject,
    // Label 51: @268397
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5523*/ GIMT_Encode4(268826),
    /*GILLT_v2s32*//*Label 5512*/ GIMT_Encode4(268484),
    /*GILLT_v2s64*//*Label 5513*/ GIMT_Encode4(268518),
    /*GILLT_v4s16*//*Label 5514*/ GIMT_Encode4(268552),
    /*GILLT_v4s32*//*Label 5515*/ GIMT_Encode4(268586),
    /*GILLT_v8s8*//*Label 5516*/ GIMT_Encode4(268620),
    /*GILLT_v8s16*//*Label 5517*/ GIMT_Encode4(268654),
    /*GILLT_v16s8*//*Label 5518*/ GIMT_Encode4(268688), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5519*/ GIMT_Encode4(268722), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5520*/ GIMT_Encode4(268748), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5521*/ GIMT_Encode4(268774), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5522*/ GIMT_Encode4(268800),
    // Label 5512: @268484
    GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(268517), // Rule ID 2445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2445,
      GIR_Done,
    // Label 5524: @268517
    GIM_Reject,
    // Label 5513: @268518
    GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(268551), // Rule ID 2449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2449,
      GIR_Done,
    // Label 5525: @268551
    GIM_Reject,
    // Label 5514: @268552
    GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(268585), // Rule ID 2444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2444,
      GIR_Done,
    // Label 5526: @268585
    GIM_Reject,
    // Label 5515: @268586
    GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(268619), // Rule ID 2448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2448,
      GIR_Done,
    // Label 5527: @268619
    GIM_Reject,
    // Label 5516: @268620
    GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(268653), // Rule ID 2443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2443,
      GIR_Done,
    // Label 5528: @268653
    GIM_Reject,
    // Label 5517: @268654
    GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(268687), // Rule ID 2447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2447,
      GIR_Done,
    // Label 5529: @268687
    GIM_Reject,
    // Label 5518: @268688
    GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(268721), // Rule ID 2446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2446,
      GIR_Done,
    // Label 5530: @268721
    GIM_Reject,
    // Label 5519: @268722
    GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(268747), // Rule ID 7579 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7579,
      GIR_Done,
    // Label 5531: @268747
    GIM_Reject,
    // Label 5520: @268748
    GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(268773), // Rule ID 7578 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7578,
      GIR_Done,
    // Label 5532: @268773
    GIM_Reject,
    // Label 5521: @268774
    GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(268799), // Rule ID 7577 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7577,
      GIR_Done,
    // Label 5533: @268799
    GIM_Reject,
    // Label 5522: @268800
    GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(268825), // Rule ID 7576 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7576,
      GIR_Done,
    // Label 5534: @268825
    GIM_Reject,
    // Label 5523: @268826
    GIM_Reject,
    // Label 52: @268827
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5546*/ GIMT_Encode4(269256),
    /*GILLT_v2s32*//*Label 5535*/ GIMT_Encode4(268914),
    /*GILLT_v2s64*//*Label 5536*/ GIMT_Encode4(268948),
    /*GILLT_v4s16*//*Label 5537*/ GIMT_Encode4(268982),
    /*GILLT_v4s32*//*Label 5538*/ GIMT_Encode4(269016),
    /*GILLT_v8s8*//*Label 5539*/ GIMT_Encode4(269050),
    /*GILLT_v8s16*//*Label 5540*/ GIMT_Encode4(269084),
    /*GILLT_v16s8*//*Label 5541*/ GIMT_Encode4(269118), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5542*/ GIMT_Encode4(269152), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5543*/ GIMT_Encode4(269178), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5544*/ GIMT_Encode4(269204), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5545*/ GIMT_Encode4(269230),
    // Label 5535: @268914
    GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(268947), // Rule ID 5060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5060,
      GIR_Done,
    // Label 5547: @268947
    GIM_Reject,
    // Label 5536: @268948
    GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(268981), // Rule ID 5064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5064,
      GIR_Done,
    // Label 5548: @268981
    GIM_Reject,
    // Label 5537: @268982
    GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(269015), // Rule ID 5059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5059,
      GIR_Done,
    // Label 5549: @269015
    GIM_Reject,
    // Label 5538: @269016
    GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(269049), // Rule ID 5063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5063,
      GIR_Done,
    // Label 5550: @269049
    GIM_Reject,
    // Label 5539: @269050
    GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(269083), // Rule ID 5058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5058,
      GIR_Done,
    // Label 5551: @269083
    GIM_Reject,
    // Label 5540: @269084
    GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(269117), // Rule ID 5062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5062,
      GIR_Done,
    // Label 5552: @269117
    GIM_Reject,
    // Label 5541: @269118
    GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(269151), // Rule ID 5061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5061,
      GIR_Done,
    // Label 5553: @269151
    GIM_Reject,
    // Label 5542: @269152
    GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(269177), // Rule ID 7591 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7591,
      GIR_Done,
    // Label 5554: @269177
    GIM_Reject,
    // Label 5543: @269178
    GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(269203), // Rule ID 7590 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7590,
      GIR_Done,
    // Label 5555: @269203
    GIM_Reject,
    // Label 5544: @269204
    GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(269229), // Rule ID 7589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7589,
      GIR_Done,
    // Label 5556: @269229
    GIM_Reject,
    // Label 5545: @269230
    GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(269255), // Rule ID 7588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7588,
      GIR_Done,
    // Label 5557: @269255
    GIM_Reject,
    // Label 5546: @269256
    GIM_Reject,
    // Label 53: @269257
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5569*/ GIMT_Encode4(269686),
    /*GILLT_v2s32*//*Label 5558*/ GIMT_Encode4(269344),
    /*GILLT_v2s64*//*Label 5559*/ GIMT_Encode4(269378),
    /*GILLT_v4s16*//*Label 5560*/ GIMT_Encode4(269412),
    /*GILLT_v4s32*//*Label 5561*/ GIMT_Encode4(269446),
    /*GILLT_v8s8*//*Label 5562*/ GIMT_Encode4(269480),
    /*GILLT_v8s16*//*Label 5563*/ GIMT_Encode4(269514),
    /*GILLT_v16s8*//*Label 5564*/ GIMT_Encode4(269548), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5565*/ GIMT_Encode4(269582), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5566*/ GIMT_Encode4(269608), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5567*/ GIMT_Encode4(269634), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5568*/ GIMT_Encode4(269660),
    // Label 5558: @269344
    GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(269377), // Rule ID 5053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5053,
      GIR_Done,
    // Label 5570: @269377
    GIM_Reject,
    // Label 5559: @269378
    GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(269411), // Rule ID 5057 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5057,
      GIR_Done,
    // Label 5571: @269411
    GIM_Reject,
    // Label 5560: @269412
    GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(269445), // Rule ID 5052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5052,
      GIR_Done,
    // Label 5572: @269445
    GIM_Reject,
    // Label 5561: @269446
    GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(269479), // Rule ID 5056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5056,
      GIR_Done,
    // Label 5573: @269479
    GIM_Reject,
    // Label 5562: @269480
    GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(269513), // Rule ID 5051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5051,
      GIR_Done,
    // Label 5574: @269513
    GIM_Reject,
    // Label 5563: @269514
    GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(269547), // Rule ID 5055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5055,
      GIR_Done,
    // Label 5575: @269547
    GIM_Reject,
    // Label 5564: @269548
    GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(269581), // Rule ID 5054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5054,
      GIR_Done,
    // Label 5576: @269581
    GIM_Reject,
    // Label 5565: @269582
    GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(269607), // Rule ID 7587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7587,
      GIR_Done,
    // Label 5577: @269607
    GIM_Reject,
    // Label 5566: @269608
    GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(269633), // Rule ID 7586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7586,
      GIR_Done,
    // Label 5578: @269633
    GIM_Reject,
    // Label 5567: @269634
    GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(269659), // Rule ID 7585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7585,
      GIR_Done,
    // Label 5579: @269659
    GIM_Reject,
    // Label 5568: @269660
    GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(269685), // Rule ID 7584 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7584,
      GIR_Done,
    // Label 5580: @269685
    GIM_Reject,
    // Label 5569: @269686
    GIM_Reject,
    // Label 54: @269687
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5594*/ GIMT_Encode4(272412),
    /*GILLT_s16*//*Label 5581*/ GIMT_Encode4(269782),
    /*GILLT_s32*//*Label 5582*/ GIMT_Encode4(270008),
    /*GILLT_s64*//*Label 5583*/ GIMT_Encode4(270362), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5584*/ GIMT_Encode4(270534),
    /*GILLT_v2s64*//*Label 5585*/ GIMT_Encode4(270572),
    /*GILLT_v4s16*//*Label 5586*/ GIMT_Encode4(270610),
    /*GILLT_v4s32*//*Label 5587*/ GIMT_Encode4(270648), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5588*/ GIMT_Encode4(270686), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5589*/ GIMT_Encode4(272261), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5590*/ GIMT_Encode4(272287), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5591*/ GIMT_Encode4(272313),
    /*GILLT_nxv4s32*//*Label 5592*/ GIMT_Encode4(272339), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5593*/ GIMT_Encode4(272365),
    // Label 5581: @269782
    GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(270007),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(269888), // Rule ID 7077 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7077,
        GIR_EraseRootFromParent_Done,
      // Label 5596: @269888
      GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(269979), // Rule ID 13911 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13911,
        GIR_EraseRootFromParent_Done,
      // Label 5597: @269979
      GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(270006), // Rule ID 579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 579,
        GIR_Done,
      // Label 5598: @270006
      GIM_Reject,
    // Label 5595: @270007
    GIM_Reject,
    // Label 5582: @270008
    GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(270361),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(270114), // Rule ID 7075 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7075,
        GIR_EraseRootFromParent_Done,
      // Label 5600: @270114
      GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(270178), // Rule ID 13082 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13082,
        GIR_EraseRootFromParent_Done,
      // Label 5601: @270178
      GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(270269), // Rule ID 13909 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13909,
        GIR_EraseRootFromParent_Done,
      // Label 5602: @270269
      GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(270333), // Rule ID 15588 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15588,
        GIR_EraseRootFromParent_Done,
      // Label 5603: @270333
      GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(270360), // Rule ID 581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 581,
        GIR_Done,
      // Label 5604: @270360
      GIM_Reject,
    // Label 5599: @270361
    GIM_Reject,
    // Label 5583: @270362
    GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(270533),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(270441), // Rule ID 7073 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7073,
        GIR_EraseRootFromParent_Done,
      // Label 5606: @270441
      GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(270505), // Rule ID 13907 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13907,
        GIR_EraseRootFromParent_Done,
      // Label 5607: @270505
      GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(270532), // Rule ID 583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 583,
        GIR_Done,
      // Label 5608: @270532
      GIM_Reject,
    // Label 5605: @270533
    GIM_Reject,
    // Label 5584: @270534
    GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(270571), // Rule ID 1191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1191,
      GIR_Done,
    // Label 5609: @270571
    GIM_Reject,
    // Label 5585: @270572
    GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(270609), // Rule ID 1195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1195,
      GIR_Done,
    // Label 5610: @270609
    GIM_Reject,
    // Label 5586: @270610
    GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(270647), // Rule ID 1187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1187,
      GIR_Done,
    // Label 5611: @270647
    GIM_Reject,
    // Label 5587: @270648
    GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(270685), // Rule ID 1193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1193,
      GIR_Done,
    // Label 5612: @270685
    GIM_Reject,
    // Label 5588: @270686
    GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(272260),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(270728), // Rule ID 1189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1189,
        GIR_Done,
      // Label 5614: @270728
      GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(270982), // Rule ID 7188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7188,
        GIR_EraseRootFromParent_Done,
      // Label 5615: @270982
      GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(271186), // Rule ID 7190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7190,
        GIR_EraseRootFromParent_Done,
      // Label 5616: @271186
      GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(272259), // Rule ID 7192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7192,
        GIR_EraseRootFromParent_Done,
      // Label 5617: @272259
      GIM_Reject,
    // Label 5613: @272260
    GIM_Reject,
    // Label 5589: @272261
    GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(272286), // Rule ID 2789 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2)  =>  (BFADD_ZZZ:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2789,
      GIR_Done,
    // Label 5618: @272286
    GIM_Reject,
    // Label 5590: @272287
    GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(272312), // Rule ID 2783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2783,
      GIR_Done,
    // Label 5619: @272312
    GIM_Reject,
    // Label 5591: @272313
    GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(272338), // Rule ID 2787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2)  =>  (BFADD_ZZZ:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2787,
      GIR_Done,
    // Label 5620: @272338
    GIM_Reject,
    // Label 5592: @272339
    GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(272364), // Rule ID 2781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2781,
      GIR_Done,
    // Label 5621: @272364
    GIM_Reject,
    // Label 5593: @272365
    GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(272411),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(272395), // Rule ID 2779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2779,
        GIR_Done,
      // Label 5623: @272395
      GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(272410), // Rule ID 2785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        // (fadd:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (BFADD_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2785,
        GIR_Done,
      // Label 5624: @272410
      GIM_Reject,
    // Label 5622: @272411
    GIM_Reject,
    // Label 5594: @272412
    GIM_Reject,
    // Label 55: @272413
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5638*/ GIMT_Encode4(274500),
    /*GILLT_s16*//*Label 5625*/ GIMT_Encode4(272508),
    /*GILLT_s32*//*Label 5626*/ GIMT_Encode4(272546),
    /*GILLT_s64*//*Label 5627*/ GIMT_Encode4(272584), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5628*/ GIMT_Encode4(272622),
    /*GILLT_v2s64*//*Label 5629*/ GIMT_Encode4(272660),
    /*GILLT_v4s16*//*Label 5630*/ GIMT_Encode4(272698),
    /*GILLT_v4s32*//*Label 5631*/ GIMT_Encode4(272736), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5632*/ GIMT_Encode4(272774), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5633*/ GIMT_Encode4(274349), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5634*/ GIMT_Encode4(274375), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5635*/ GIMT_Encode4(274401),
    /*GILLT_nxv4s32*//*Label 5636*/ GIMT_Encode4(274427), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5637*/ GIMT_Encode4(274453),
    // Label 5625: @272508
    GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(272545), // Rule ID 627 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 627,
      GIR_Done,
    // Label 5639: @272545
    GIM_Reject,
    // Label 5626: @272546
    GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(272583), // Rule ID 629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 629,
      GIR_Done,
    // Label 5640: @272583
    GIM_Reject,
    // Label 5627: @272584
    GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(272621), // Rule ID 631 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 631,
      GIR_Done,
    // Label 5641: @272621
    GIM_Reject,
    // Label 5628: @272622
    GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(272659), // Rule ID 1331 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1331,
      GIR_Done,
    // Label 5642: @272659
    GIM_Reject,
    // Label 5629: @272660
    GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(272697), // Rule ID 1335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1335,
      GIR_Done,
    // Label 5643: @272697
    GIM_Reject,
    // Label 5630: @272698
    GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(272735), // Rule ID 1327 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1327,
      GIR_Done,
    // Label 5644: @272735
    GIM_Reject,
    // Label 5631: @272736
    GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(272773), // Rule ID 1333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1333,
      GIR_Done,
    // Label 5645: @272773
    GIM_Reject,
    // Label 5632: @272774
    GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(274348),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(272816), // Rule ID 1329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1329,
        GIR_Done,
      // Label 5647: @272816
      GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(273070), // Rule ID 7206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7206,
        GIR_EraseRootFromParent_Done,
      // Label 5648: @273070
      GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(273274), // Rule ID 7208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7208,
        GIR_EraseRootFromParent_Done,
      // Label 5649: @273274
      GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(274347), // Rule ID 7210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7210,
        GIR_EraseRootFromParent_Done,
      // Label 5650: @274347
      GIM_Reject,
    // Label 5646: @274348
    GIM_Reject,
    // Label 5633: @274349
    GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(274374), // Rule ID 12398 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2)  =>  (BFSUB_ZZZ:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12398,
      GIR_Done,
    // Label 5651: @274374
    GIM_Reject,
    // Label 5634: @274375
    GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(274400), // Rule ID 8336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8336,
      GIR_Done,
    // Label 5652: @274400
    GIM_Reject,
    // Label 5635: @274401
    GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(274426), // Rule ID 12396 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2)  =>  (BFSUB_ZZZ:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12396,
      GIR_Done,
    // Label 5653: @274426
    GIM_Reject,
    // Label 5636: @274427
    GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(274452), // Rule ID 8334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8334,
      GIR_Done,
    // Label 5654: @274452
    GIM_Reject,
    // Label 5637: @274453
    GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(274499),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(274483), // Rule ID 8332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8332,
        GIR_Done,
      // Label 5656: @274483
      GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(274498), // Rule ID 12394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        // (fsub:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (BFSUB_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12394,
        GIR_Done,
      // Label 5657: @274498
      GIM_Reject,
    // Label 5655: @274499
    GIM_Reject,
    // Label 5638: @274500
    GIM_Reject,
    // Label 56: @274501
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5671*/ GIMT_Encode4(279962),
    /*GILLT_s16*//*Label 5658*/ GIMT_Encode4(274596),
    /*GILLT_s32*//*Label 5659*/ GIMT_Encode4(275238),
    /*GILLT_s64*//*Label 5660*/ GIMT_Encode4(275868), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5661*/ GIMT_Encode4(276498),
    /*GILLT_v2s64*//*Label 5662*/ GIMT_Encode4(277028),
    /*GILLT_v4s16*//*Label 5663*/ GIMT_Encode4(277386),
    /*GILLT_v4s32*//*Label 5664*/ GIMT_Encode4(277728), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5665*/ GIMT_Encode4(278086), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5666*/ GIMT_Encode4(279811), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5667*/ GIMT_Encode4(279837), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5668*/ GIMT_Encode4(279863),
    /*GILLT_nxv4s32*//*Label 5669*/ GIMT_Encode4(279889), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5670*/ GIMT_Encode4(279915),
    // Label 5658: @274596
    GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(275237),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(274724), // Rule ID 6288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6288,
        GIR_EraseRootFromParent_Done,
      // Label 5673: @274724
      GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(274837), // Rule ID 13882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13882,
        GIR_EraseRootFromParent_Done,
      // Label 5674: @274837
      GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(274916), // Rule ID 13819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13819,
        GIR_EraseRootFromParent_Done,
      // Label 5675: @274916
      GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(274995), // Rule ID 4823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4823,
        GIR_EraseRootFromParent_Done,
      // Label 5676: @274995
      GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(275058), // Rule ID 13434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13434,
        GIR_EraseRootFromParent_Done,
      // Label 5677: @275058
      GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(275121), // Rule ID 2000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2000,
        GIR_EraseRootFromParent_Done,
      // Label 5678: @275121
      GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(275165), // Rule ID 4828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4828,
        GIR_EraseRootFromParent_Done,
      // Label 5679: @275165
      GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(275209), // Rule ID 13824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13824,
        GIR_EraseRootFromParent_Done,
      // Label 5680: @275209
      GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(275236), // Rule ID 615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 615,
        GIR_Done,
      // Label 5681: @275236
      GIM_Reject,
    // Label 5672: @275237
    GIM_Reject,
    // Label 5659: @275238
    GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(275867),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(275366), // Rule ID 6290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6290,
        GIR_EraseRootFromParent_Done,
      // Label 5683: @275366
      GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(275479), // Rule ID 13884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13884,
        GIR_EraseRootFromParent_Done,
      // Label 5684: @275479
      GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(275555), // Rule ID 13821 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13821,
        GIR_EraseRootFromParent_Done,
      // Label 5685: @275555
      GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(275631), // Rule ID 4825 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4825,
        GIR_EraseRootFromParent_Done,
      // Label 5686: @275631
      GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(275694), // Rule ID 13436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13436,
        GIR_EraseRootFromParent_Done,
      // Label 5687: @275694
      GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(275757), // Rule ID 2002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2002,
        GIR_EraseRootFromParent_Done,
      // Label 5688: @275757
      GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(275798), // Rule ID 4829 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4829,
        GIR_EraseRootFromParent_Done,
      // Label 5689: @275798
      GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(275839), // Rule ID 13825 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13825,
        GIR_EraseRootFromParent_Done,
      // Label 5690: @275839
      GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(275866), // Rule ID 617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 617,
        GIR_Done,
      // Label 5691: @275866
      GIM_Reject,
    // Label 5682: @275867
    GIM_Reject,
    // Label 5660: @275868
    GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(276497),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(275996), // Rule ID 6292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6292,
        GIR_EraseRootFromParent_Done,
      // Label 5693: @275996
      GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(276109), // Rule ID 13886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13886,
        GIR_EraseRootFromParent_Done,
      // Label 5694: @276109
      GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(276185), // Rule ID 13823 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13823,
        GIR_EraseRootFromParent_Done,
      // Label 5695: @276185
      GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(276261), // Rule ID 4827 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4827,
        GIR_EraseRootFromParent_Done,
      // Label 5696: @276261
      GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(276324), // Rule ID 13438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13438,
        GIR_EraseRootFromParent_Done,
      // Label 5697: @276324
      GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(276387), // Rule ID 2004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2004,
        GIR_EraseRootFromParent_Done,
      // Label 5698: @276387
      GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(276428), // Rule ID 4830 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4830,
        GIR_EraseRootFromParent_Done,
      // Label 5699: @276428
      GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(276469), // Rule ID 13826 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13826,
        GIR_EraseRootFromParent_Done,
      // Label 5700: @276469
      GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(276496), // Rule ID 619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 619,
        GIR_Done,
      // Label 5701: @276496
      GIM_Reject,
    // Label 5692: @276497
    GIM_Reject,
    // Label 5661: @276498
    GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(277027),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(276599), // Rule ID 13427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13427,
        GIR_EraseRootFromParent_Done,
      // Label 5703: @276599
      GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(276685), // Rule ID 1993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1993,
        GIR_EraseRootFromParent_Done,
      // Label 5704: @276685
      GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(276748), // Rule ID 13428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13428,
        GIR_EraseRootFromParent_Done,
      // Label 5705: @276748
      GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(276811), // Rule ID 1994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1994,
        GIR_EraseRootFromParent_Done,
      // Label 5706: @276811
      GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(276905), // Rule ID 13888 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13888,
        GIR_EraseRootFromParent_Done,
      // Label 5707: @276905
      GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(276999), // Rule ID 6294 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6294,
        GIR_EraseRootFromParent_Done,
      // Label 5708: @276999
      GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(277026), // Rule ID 1311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1311,
        GIR_Done,
      // Label 5709: @277026
      GIM_Reject,
    // Label 5702: @277027
    GIM_Reject,
    // Label 5662: @277028
    GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(277385),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(277106), // Rule ID 13432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13432,
        GIR_EraseRootFromParent_Done,
      // Label 5711: @277106
      GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(277169), // Rule ID 1998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1998,
        GIR_EraseRootFromParent_Done,
      // Label 5712: @277169
      GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(277263), // Rule ID 13892 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13892,
        GIR_EraseRootFromParent_Done,
      // Label 5713: @277263
      GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(277357), // Rule ID 6298 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6298,
        GIR_EraseRootFromParent_Done,
      // Label 5714: @277357
      GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(277384), // Rule ID 1315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1315,
        GIR_Done,
      // Label 5715: @277384
      GIM_Reject,
    // Label 5710: @277385
    GIM_Reject,
    // Label 5663: @277386
    GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(277727),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(277487), // Rule ID 13421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13421,
        GIR_EraseRootFromParent_Done,
      // Label 5717: @277487
      GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(277573), // Rule ID 1987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1987,
        GIR_EraseRootFromParent_Done,
      // Label 5718: @277573
      GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(277636), // Rule ID 13422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13422,
        GIR_EraseRootFromParent_Done,
      // Label 5719: @277636
      GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(277699), // Rule ID 1988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1988,
        GIR_EraseRootFromParent_Done,
      // Label 5720: @277699
      GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(277726), // Rule ID 1307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1307,
        GIR_Done,
      // Label 5721: @277726
      GIM_Reject,
    // Label 5716: @277727
    GIM_Reject,
    // Label 5664: @277728
    GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(278085),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(277806), // Rule ID 13430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13430,
        GIR_EraseRootFromParent_Done,
      // Label 5723: @277806
      GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(277869), // Rule ID 1996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1996,
        GIR_EraseRootFromParent_Done,
      // Label 5724: @277869
      GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(277963), // Rule ID 13890 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13890,
        GIR_EraseRootFromParent_Done,
      // Label 5725: @277963
      GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(278057), // Rule ID 6296 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6296,
        GIR_EraseRootFromParent_Done,
      // Label 5726: @278057
      GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(278084), // Rule ID 1313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1313,
        GIR_Done,
      // Label 5727: @278084
      GIM_Reject,
    // Label 5722: @278085
    GIM_Reject,
    // Label 5665: @278086
    GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(279810),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(278164), // Rule ID 13424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13424,
        GIR_EraseRootFromParent_Done,
      // Label 5729: @278164
      GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(278227), // Rule ID 1990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1990,
        GIR_EraseRootFromParent_Done,
      // Label 5730: @278227
      GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(278254), // Rule ID 1309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1309,
        GIR_Done,
      // Label 5731: @278254
      GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(278516), // Rule ID 7200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7200,
        GIR_EraseRootFromParent_Done,
      // Label 5732: @278516
      GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(278728), // Rule ID 7202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7202,
        GIR_EraseRootFromParent_Done,
      // Label 5733: @278728
      GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(279809), // Rule ID 7204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7204,
        GIR_EraseRootFromParent_Done,
      // Label 5734: @279809
      GIM_Reject,
    // Label 5728: @279810
    GIM_Reject,
    // Label 5666: @279811
    GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(279836), // Rule ID 12404 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2)  =>  (BFMUL_ZZZ:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12404,
      GIR_Done,
    // Label 5735: @279836
    GIM_Reject,
    // Label 5667: @279837
    GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(279862), // Rule ID 8342 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8342,
      GIR_Done,
    // Label 5736: @279862
    GIM_Reject,
    // Label 5668: @279863
    GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(279888), // Rule ID 12402 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2)  =>  (BFMUL_ZZZ:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12402,
      GIR_Done,
    // Label 5737: @279888
    GIM_Reject,
    // Label 5669: @279889
    GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(279914), // Rule ID 8340 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8340,
      GIR_Done,
    // Label 5738: @279914
    GIM_Reject,
    // Label 5670: @279915
    GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(279961),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(279945), // Rule ID 8338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8338,
        GIR_Done,
      // Label 5740: @279945
      GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(279960), // Rule ID 12400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        // (fmul:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (BFMUL_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12400,
        GIR_Done,
      // Label 5741: @279960
      GIM_Reject,
    // Label 5739: @279961
    GIM_Reject,
    // Label 5671: @279962
    GIM_Reject,
    // Label 57: @279963
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5750*/ GIMT_Encode4(296235),
    /*GILLT_s16*//*Label 5742*/ GIMT_Encode4(280014),
    /*GILLT_s32*//*Label 5743*/ GIMT_Encode4(283018),
    /*GILLT_s64*//*Label 5744*/ GIMT_Encode4(286166), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5745*/ GIMT_Encode4(289314),
    /*GILLT_v2s64*//*Label 5746*/ GIMT_Encode4(290835),
    /*GILLT_v4s16*//*Label 5747*/ GIMT_Encode4(292356),
    /*GILLT_v4s32*//*Label 5748*/ GIMT_Encode4(293535), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5749*/ GIMT_Encode4(295056),
    // Label 5742: @280014
    GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(283017),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(280182), // Rule ID 4885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4885,
        GIR_EraseRootFromParent_Done,
      // Label 5752: @280182
      GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(280329), // Rule ID 4849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4849,
        GIR_EraseRootFromParent_Done,
      // Label 5753: @280329
      GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(280476), // Rule ID 13832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13832,
        GIR_EraseRootFromParent_Done,
      // Label 5754: @280476
      GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(280607), // Rule ID 6126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6126,
        GIR_EraseRootFromParent_Done,
      // Label 5755: @280607
      GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(280738), // Rule ID 6158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6158,
        GIR_EraseRootFromParent_Done,
      // Label 5756: @280738
      GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(280869), // Rule ID 6222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6222,
        GIR_EraseRootFromParent_Done,
      // Label 5757: @280869
      GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(281000), // Rule ID 6190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6190,
        GIR_EraseRootFromParent_Done,
      // Label 5758: @281000
      GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(281135), // Rule ID 2424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2424,
        GIR_EraseRootFromParent_Done,
      // Label 5759: @281135
      GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(281254), // Rule ID 6094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6094,
        GIR_EraseRootFromParent_Done,
      // Label 5760: @281254
      GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(281373), // Rule ID 2496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2496,
        GIR_EraseRootFromParent_Done,
      // Label 5761: @281373
      GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(281473), // Rule ID 4847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4847,
        GIR_EraseRootFromParent_Done,
      // Label 5762: @281473
      GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(281573), // Rule ID 4883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4883,
        GIR_EraseRootFromParent_Done,
      // Label 5763: @281573
      GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(281670), // Rule ID 13828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13828,
        GIR_EraseRootFromParent_Done,
      // Label 5764: @281670
      GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(281770), // Rule ID 13830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13830,
        GIR_EraseRootFromParent_Done,
      // Label 5765: @281770
      GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(281870), // Rule ID 4881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4881,
        GIR_EraseRootFromParent_Done,
      // Label 5766: @281870
      GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(281967), // Rule ID 4845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4845,
        GIR_EraseRootFromParent_Done,
      // Label 5767: @281967
      GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(282051), // Rule ID 6156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6156,
        GIR_EraseRootFromParent_Done,
      // Label 5768: @282051
      GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(282132), // Rule ID 6188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6188,
        GIR_EraseRootFromParent_Done,
      // Label 5769: @282132
      GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(282216), // Rule ID 6220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6220,
        GIR_EraseRootFromParent_Done,
      // Label 5770: @282216
      GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(282297), // Rule ID 6124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6124,
        GIR_EraseRootFromParent_Done,
      // Label 5771: @282297
      GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(282382), // Rule ID 2422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2422,
        GIR_EraseRootFromParent_Done,
      // Label 5772: @282382
      GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(282467), // Rule ID 2420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2420,
        GIR_EraseRootFromParent_Done,
      // Label 5773: @282467
      GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(282536), // Rule ID 2494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2494,
        GIR_EraseRootFromParent_Done,
      // Label 5774: @282536
      GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(282605), // Rule ID 6092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6092,
        GIR_EraseRootFromParent_Done,
      // Label 5775: @282605
      GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(282670), // Rule ID 4901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4901,
        GIR_EraseRootFromParent_Done,
      // Label 5776: @282670
      GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(282735), // Rule ID 13848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13848,
        GIR_EraseRootFromParent_Done,
      // Label 5777: @282735
      GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(282785), // Rule ID 4898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4898,
        GIR_EraseRootFromParent_Done,
      // Label 5778: @282785
      GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(282835), // Rule ID 13274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13274,
        GIR_EraseRootFromParent_Done,
      // Label 5779: @282835
      GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(282885), // Rule ID 639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 639,
        GIR_EraseRootFromParent_Done,
      // Label 5780: @282885
      GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(282935), // Rule ID 13845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13845,
        GIR_EraseRootFromParent_Done,
      // Label 5781: @282935
      GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(282985), // Rule ID 651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 651,
        GIR_EraseRootFromParent_Done,
      // Label 5782: @282985
      GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(283016), // Rule ID 633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 633,
        GIR_Done,
      // Label 5783: @283016
      GIM_Reject,
    // Label 5751: @283017
    GIM_Reject,
    // Label 5743: @283018
    GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(286165),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(283186), // Rule ID 4891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4891,
        GIR_EraseRootFromParent_Done,
      // Label 5785: @283186
      GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(283333), // Rule ID 4855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4855,
        GIR_EraseRootFromParent_Done,
      // Label 5786: @283333
      GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(283480), // Rule ID 13838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13838,
        GIR_EraseRootFromParent_Done,
      // Label 5787: @283480
      GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(283611), // Rule ID 6142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6142,
        GIR_EraseRootFromParent_Done,
      // Label 5788: @283611
      GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(283742), // Rule ID 6174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6174,
        GIR_EraseRootFromParent_Done,
      // Label 5789: @283742
      GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(283873), // Rule ID 6238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6238,
        GIR_EraseRootFromParent_Done,
      // Label 5790: @283873
      GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(284004), // Rule ID 6206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6206,
        GIR_EraseRootFromParent_Done,
      // Label 5791: @284004
      GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(284139), // Rule ID 2430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2430,
        GIR_EraseRootFromParent_Done,
      // Label 5792: @284139
      GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(284258), // Rule ID 6110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6110,
        GIR_EraseRootFromParent_Done,
      // Label 5793: @284258
      GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(284377), // Rule ID 2512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2512,
        GIR_EraseRootFromParent_Done,
      // Label 5794: @284377
      GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(284477), // Rule ID 4853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4853,
        GIR_EraseRootFromParent_Done,
      // Label 5795: @284477
      GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(284577), // Rule ID 4889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4889,
        GIR_EraseRootFromParent_Done,
      // Label 5796: @284577
      GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(284674), // Rule ID 13834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13834,
        GIR_EraseRootFromParent_Done,
      // Label 5797: @284674
      GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(284774), // Rule ID 13836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13836,
        GIR_EraseRootFromParent_Done,
      // Label 5798: @284774
      GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(284874), // Rule ID 4887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4887,
        GIR_EraseRootFromParent_Done,
      // Label 5799: @284874
      GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(284971), // Rule ID 4851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4851,
        GIR_EraseRootFromParent_Done,
      // Label 5800: @284971
      GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(285049), // Rule ID 6260 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6260,
        GIR_EraseRootFromParent_Done,
      // Label 5801: @285049
      GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(285133), // Rule ID 6172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6172,
        GIR_EraseRootFromParent_Done,
      // Label 5802: @285133
      GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(285214), // Rule ID 6204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6204,
        GIR_EraseRootFromParent_Done,
      // Label 5803: @285214
      GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(285298), // Rule ID 6236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6236,
        GIR_EraseRootFromParent_Done,
      // Label 5804: @285298
      GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(285376), // Rule ID 6282 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6282,
        GIR_EraseRootFromParent_Done,
      // Label 5805: @285376
      GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(285457), // Rule ID 6140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6140,
        GIR_EraseRootFromParent_Done,
      // Label 5806: @285457
      GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(285542), // Rule ID 2428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2428,
        GIR_EraseRootFromParent_Done,
      // Label 5807: @285542
      GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(285627), // Rule ID 2426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2426,
        GIR_EraseRootFromParent_Done,
      // Label 5808: @285627
      GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(285696), // Rule ID 2510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2510,
        GIR_EraseRootFromParent_Done,
      // Label 5809: @285696
      GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(285765), // Rule ID 6108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6108,
        GIR_EraseRootFromParent_Done,
      // Label 5810: @285765
      GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(285827), // Rule ID 4902 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4902,
        GIR_EraseRootFromParent_Done,
      // Label 5811: @285827
      GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(285889), // Rule ID 13849 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13849,
        GIR_EraseRootFromParent_Done,
      // Label 5812: @285889
      GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(285936), // Rule ID 4899 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4899,
        GIR_EraseRootFromParent_Done,
      // Label 5813: @285936
      GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(285986), // Rule ID 13276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13276,
        GIR_EraseRootFromParent_Done,
      // Label 5814: @285986
      GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(286036), // Rule ID 641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 641,
        GIR_EraseRootFromParent_Done,
      // Label 5815: @286036
      GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(286083), // Rule ID 13846 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13846,
        GIR_EraseRootFromParent_Done,
      // Label 5816: @286083
      GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(286133), // Rule ID 653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 653,
        GIR_EraseRootFromParent_Done,
      // Label 5817: @286133
      GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(286164), // Rule ID 635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 635,
        GIR_Done,
      // Label 5818: @286164
      GIM_Reject,
    // Label 5784: @286165
    GIM_Reject,
    // Label 5744: @286166
    GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(289313),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(286334), // Rule ID 4897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4897,
        GIR_EraseRootFromParent_Done,
      // Label 5820: @286334
      GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(286481), // Rule ID 4861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4861,
        GIR_EraseRootFromParent_Done,
      // Label 5821: @286481
      GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(286628), // Rule ID 13844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13844,
        GIR_EraseRootFromParent_Done,
      // Label 5822: @286628
      GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(286759), // Rule ID 6146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6146,
        GIR_EraseRootFromParent_Done,
      // Label 5823: @286759
      GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(286890), // Rule ID 6178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6178,
        GIR_EraseRootFromParent_Done,
      // Label 5824: @286890
      GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(287021), // Rule ID 6242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6242,
        GIR_EraseRootFromParent_Done,
      // Label 5825: @287021
      GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(287152), // Rule ID 6210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6210,
        GIR_EraseRootFromParent_Done,
      // Label 5826: @287152
      GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(287287), // Rule ID 2436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2436,
        GIR_EraseRootFromParent_Done,
      // Label 5827: @287287
      GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(287406), // Rule ID 6114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6114,
        GIR_EraseRootFromParent_Done,
      // Label 5828: @287406
      GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(287525), // Rule ID 2516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2516,
        GIR_EraseRootFromParent_Done,
      // Label 5829: @287525
      GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(287625), // Rule ID 4859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4859,
        GIR_EraseRootFromParent_Done,
      // Label 5830: @287625
      GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(287725), // Rule ID 4895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4895,
        GIR_EraseRootFromParent_Done,
      // Label 5831: @287725
      GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(287822), // Rule ID 13840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13840,
        GIR_EraseRootFromParent_Done,
      // Label 5832: @287822
      GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(287922), // Rule ID 13842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13842,
        GIR_EraseRootFromParent_Done,
      // Label 5833: @287922
      GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(288022), // Rule ID 4893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4893,
        GIR_EraseRootFromParent_Done,
      // Label 5834: @288022
      GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(288119), // Rule ID 4857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4857,
        GIR_EraseRootFromParent_Done,
      // Label 5835: @288119
      GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(288197), // Rule ID 6264 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6264,
        GIR_EraseRootFromParent_Done,
      // Label 5836: @288197
      GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(288281), // Rule ID 6176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6176,
        GIR_EraseRootFromParent_Done,
      // Label 5837: @288281
      GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(288362), // Rule ID 6208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6208,
        GIR_EraseRootFromParent_Done,
      // Label 5838: @288362
      GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(288446), // Rule ID 6240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6240,
        GIR_EraseRootFromParent_Done,
      // Label 5839: @288446
      GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(288524), // Rule ID 6286 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6286,
        GIR_EraseRootFromParent_Done,
      // Label 5840: @288524
      GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(288605), // Rule ID 6144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6144,
        GIR_EraseRootFromParent_Done,
      // Label 5841: @288605
      GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(288690), // Rule ID 2434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2434,
        GIR_EraseRootFromParent_Done,
      // Label 5842: @288690
      GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(288775), // Rule ID 2432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2432,
        GIR_EraseRootFromParent_Done,
      // Label 5843: @288775
      GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(288844), // Rule ID 2514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2514,
        GIR_EraseRootFromParent_Done,
      // Label 5844: @288844
      GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(288913), // Rule ID 6112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6112,
        GIR_EraseRootFromParent_Done,
      // Label 5845: @288913
      GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(288975), // Rule ID 4903 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4903,
        GIR_EraseRootFromParent_Done,
      // Label 5846: @288975
      GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(289037), // Rule ID 13850 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13850,
        GIR_EraseRootFromParent_Done,
      // Label 5847: @289037
      GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(289084), // Rule ID 4900 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4900,
        GIR_EraseRootFromParent_Done,
      // Label 5848: @289084
      GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(289134), // Rule ID 13278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13278,
        GIR_EraseRootFromParent_Done,
      // Label 5849: @289134
      GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(289184), // Rule ID 643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 643,
        GIR_EraseRootFromParent_Done,
      // Label 5850: @289184
      GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(289231), // Rule ID 13847 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13847,
        GIR_EraseRootFromParent_Done,
      // Label 5851: @289231
      GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(289281), // Rule ID 655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 655,
        GIR_EraseRootFromParent_Done,
      // Label 5852: @289281
      GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(289312), // Rule ID 637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 637,
        GIR_Done,
      // Label 5853: @289312
      GIM_Reject,
    // Label 5819: @289313
    GIM_Reject,
    // Label 5745: @289314
    GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(290834),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(289410), // Rule ID 6244 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6244,
        GIR_EraseRootFromParent_Done,
      // Label 5855: @289410
      GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(289494), // Rule ID 6160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6160,
        GIR_EraseRootFromParent_Done,
      // Label 5856: @289494
      GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(289575), // Rule ID 6192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6192,
        GIR_EraseRootFromParent_Done,
      // Label 5857: @289575
      GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(289659), // Rule ID 6224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6224,
        GIR_EraseRootFromParent_Done,
      // Label 5858: @289659
      GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(289737), // Rule ID 6266 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6266,
        GIR_EraseRootFromParent_Done,
      // Label 5859: @289737
      GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(289818), // Rule ID 6128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6128,
        GIR_EraseRootFromParent_Done,
      // Label 5860: @289818
      GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(289887), // Rule ID 2498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2498,
        GIR_EraseRootFromParent_Done,
      // Label 5861: @289887
      GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(289956), // Rule ID 6096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6096,
        GIR_EraseRootFromParent_Done,
      // Label 5862: @289956
      GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(290049), // Rule ID 6248 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6248,
        GIR_EraseRootFromParent_Done,
      // Label 5863: @290049
      GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(290148), // Rule ID 6162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6162,
        GIR_EraseRootFromParent_Done,
      // Label 5864: @290148
      GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(290244), // Rule ID 6194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6194,
        GIR_EraseRootFromParent_Done,
      // Label 5865: @290244
      GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(290343), // Rule ID 6226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6226,
        GIR_EraseRootFromParent_Done,
      // Label 5866: @290343
      GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(290436), // Rule ID 6270 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6270,
        GIR_EraseRootFromParent_Done,
      // Label 5867: @290436
      GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(290532), // Rule ID 6130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6130,
        GIR_EraseRootFromParent_Done,
      // Label 5868: @290532
      GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(290616), // Rule ID 2500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2500,
        GIR_EraseRootFromParent_Done,
      // Label 5869: @290616
      GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(290666), // Rule ID 13308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13308,
        GIR_EraseRootFromParent_Done,
      // Label 5870: @290666
      GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(290750), // Rule ID 6098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6098,
        GIR_EraseRootFromParent_Done,
      // Label 5871: @290750
      GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(290800), // Rule ID 1296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1296,
        GIR_EraseRootFromParent_Done,
      // Label 5872: @290800
      GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(290833), // Rule ID 1286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1286,
        GIR_EraseRootFromParent_Done,
      // Label 5873: @290833
      GIM_Reject,
    // Label 5854: @290834
    GIM_Reject,
    // Label 5746: @290835
    GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(292355),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(290931), // Rule ID 6256 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6256,
        GIR_EraseRootFromParent_Done,
      // Label 5875: @290931
      GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(291015), // Rule ID 6168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6168,
        GIR_EraseRootFromParent_Done,
      // Label 5876: @291015
      GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(291096), // Rule ID 6200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6200,
        GIR_EraseRootFromParent_Done,
      // Label 5877: @291096
      GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(291180), // Rule ID 6232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6232,
        GIR_EraseRootFromParent_Done,
      // Label 5878: @291180
      GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(291258), // Rule ID 6278 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6278,
        GIR_EraseRootFromParent_Done,
      // Label 5879: @291258
      GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(291339), // Rule ID 6136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6136,
        GIR_EraseRootFromParent_Done,
      // Label 5880: @291339
      GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(291408), // Rule ID 2506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2506,
        GIR_EraseRootFromParent_Done,
      // Label 5881: @291408
      GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(291477), // Rule ID 6104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6104,
        GIR_EraseRootFromParent_Done,
      // Label 5882: @291477
      GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(291570), // Rule ID 6258 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6258,
        GIR_EraseRootFromParent_Done,
      // Label 5883: @291570
      GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(291669), // Rule ID 6170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6170,
        GIR_EraseRootFromParent_Done,
      // Label 5884: @291669
      GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(291765), // Rule ID 6202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6202,
        GIR_EraseRootFromParent_Done,
      // Label 5885: @291765
      GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(291864), // Rule ID 6234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6234,
        GIR_EraseRootFromParent_Done,
      // Label 5886: @291864
      GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(291957), // Rule ID 6280 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6280,
        GIR_EraseRootFromParent_Done,
      // Label 5887: @291957
      GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(292053), // Rule ID 6138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6138,
        GIR_EraseRootFromParent_Done,
      // Label 5888: @292053
      GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(292137), // Rule ID 2508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2508,
        GIR_EraseRootFromParent_Done,
      // Label 5889: @292137
      GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(292187), // Rule ID 13312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13312,
        GIR_EraseRootFromParent_Done,
      // Label 5890: @292187
      GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(292271), // Rule ID 6106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6106,
        GIR_EraseRootFromParent_Done,
      // Label 5891: @292271
      GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(292321), // Rule ID 1300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1300,
        GIR_EraseRootFromParent_Done,
      // Label 5892: @292321
      GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(292354), // Rule ID 1290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1290,
        GIR_EraseRootFromParent_Done,
      // Label 5893: @292354
      GIM_Reject,
    // Label 5874: @292355
    GIM_Reject,
    // Label 5747: @292356
    GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(293534),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(292458), // Rule ID 6152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6152,
        GIR_EraseRootFromParent_Done,
      // Label 5895: @292458
      GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(292539), // Rule ID 6184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6184,
        GIR_EraseRootFromParent_Done,
      // Label 5896: @292539
      GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(292623), // Rule ID 6216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6216,
        GIR_EraseRootFromParent_Done,
      // Label 5897: @292623
      GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(292704), // Rule ID 6120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6120,
        GIR_EraseRootFromParent_Done,
      // Label 5898: @292704
      GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(292773), // Rule ID 2490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2490,
        GIR_EraseRootFromParent_Done,
      // Label 5899: @292773
      GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(292842), // Rule ID 6088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6088,
        GIR_EraseRootFromParent_Done,
      // Label 5900: @292842
      GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(292941), // Rule ID 6154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6154,
        GIR_EraseRootFromParent_Done,
      // Label 5901: @292941
      GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(293037), // Rule ID 6186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6186,
        GIR_EraseRootFromParent_Done,
      // Label 5902: @293037
      GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(293136), // Rule ID 6218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6218,
        GIR_EraseRootFromParent_Done,
      // Label 5903: @293136
      GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(293232), // Rule ID 6122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6122,
        GIR_EraseRootFromParent_Done,
      // Label 5904: @293232
      GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(293316), // Rule ID 2492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2492,
        GIR_EraseRootFromParent_Done,
      // Label 5905: @293316
      GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(293366), // Rule ID 13304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13304,
        GIR_EraseRootFromParent_Done,
      // Label 5906: @293366
      GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(293450), // Rule ID 6090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6090,
        GIR_EraseRootFromParent_Done,
      // Label 5907: @293450
      GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(293500), // Rule ID 1292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1292,
        GIR_EraseRootFromParent_Done,
      // Label 5908: @293500
      GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(293533), // Rule ID 1282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1282,
        GIR_EraseRootFromParent_Done,
      // Label 5909: @293533
      GIM_Reject,
    // Label 5894: @293534
    GIM_Reject,
    // Label 5748: @293535
    GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(295055),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(293631), // Rule ID 6250 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6250,
        GIR_EraseRootFromParent_Done,
      // Label 5911: @293631
      GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(293715), // Rule ID 6164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6164,
        GIR_EraseRootFromParent_Done,
      // Label 5912: @293715
      GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(293796), // Rule ID 6196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6196,
        GIR_EraseRootFromParent_Done,
      // Label 5913: @293796
      GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(293880), // Rule ID 6228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6228,
        GIR_EraseRootFromParent_Done,
      // Label 5914: @293880
      GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(293958), // Rule ID 6272 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6272,
        GIR_EraseRootFromParent_Done,
      // Label 5915: @293958
      GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(294039), // Rule ID 6132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6132,
        GIR_EraseRootFromParent_Done,
      // Label 5916: @294039
      GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(294108), // Rule ID 2502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2502,
        GIR_EraseRootFromParent_Done,
      // Label 5917: @294108
      GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(294177), // Rule ID 6100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6100,
        GIR_EraseRootFromParent_Done,
      // Label 5918: @294177
      GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(294270), // Rule ID 6254 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6254,
        GIR_EraseRootFromParent_Done,
      // Label 5919: @294270
      GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(294369), // Rule ID 6166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6166,
        GIR_EraseRootFromParent_Done,
      // Label 5920: @294369
      GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(294465), // Rule ID 6198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6198,
        GIR_EraseRootFromParent_Done,
      // Label 5921: @294465
      GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(294564), // Rule ID 6230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6230,
        GIR_EraseRootFromParent_Done,
      // Label 5922: @294564
      GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(294657), // Rule ID 6276 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6276,
        GIR_EraseRootFromParent_Done,
      // Label 5923: @294657
      GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(294753), // Rule ID 6134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6134,
        GIR_EraseRootFromParent_Done,
      // Label 5924: @294753
      GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(294837), // Rule ID 2504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2504,
        GIR_EraseRootFromParent_Done,
      // Label 5925: @294837
      GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(294887), // Rule ID 13310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13310,
        GIR_EraseRootFromParent_Done,
      // Label 5926: @294887
      GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(294971), // Rule ID 6102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6102,
        GIR_EraseRootFromParent_Done,
      // Label 5927: @294971
      GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(295021), // Rule ID 1298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1298,
        GIR_EraseRootFromParent_Done,
      // Label 5928: @295021
      GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(295054), // Rule ID 1288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1288,
        GIR_EraseRootFromParent_Done,
      // Label 5929: @295054
      GIM_Reject,
    // Label 5910: @295055
    GIM_Reject,
    // Label 5749: @295056
    GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(296234),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(295158), // Rule ID 6148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6148,
        GIR_EraseRootFromParent_Done,
      // Label 5931: @295158
      GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(295239), // Rule ID 6180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6180,
        GIR_EraseRootFromParent_Done,
      // Label 5932: @295239
      GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(295323), // Rule ID 6212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6212,
        GIR_EraseRootFromParent_Done,
      // Label 5933: @295323
      GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(295404), // Rule ID 6116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6116,
        GIR_EraseRootFromParent_Done,
      // Label 5934: @295404
      GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(295473), // Rule ID 2486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2486,
        GIR_EraseRootFromParent_Done,
      // Label 5935: @295473
      GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(295542), // Rule ID 6084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6084,
        GIR_EraseRootFromParent_Done,
      // Label 5936: @295542
      GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(295641), // Rule ID 6150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6150,
        GIR_EraseRootFromParent_Done,
      // Label 5937: @295641
      GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(295737), // Rule ID 6182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6182,
        GIR_EraseRootFromParent_Done,
      // Label 5938: @295737
      GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(295836), // Rule ID 6214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6214,
        GIR_EraseRootFromParent_Done,
      // Label 5939: @295836
      GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(295932), // Rule ID 6118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6118,
        GIR_EraseRootFromParent_Done,
      // Label 5940: @295932
      GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(296016), // Rule ID 2488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2488,
        GIR_EraseRootFromParent_Done,
      // Label 5941: @296016
      GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(296066), // Rule ID 13306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13306,
        GIR_EraseRootFromParent_Done,
      // Label 5942: @296066
      GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(296150), // Rule ID 6086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6086,
        GIR_EraseRootFromParent_Done,
      // Label 5943: @296150
      GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(296200), // Rule ID 1294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1294,
        GIR_EraseRootFromParent_Done,
      // Label 5944: @296200
      GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(296233), // Rule ID 1284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1284,
        GIR_EraseRootFromParent_Done,
      // Label 5945: @296233
      GIM_Reject,
    // Label 5930: @296234
    GIM_Reject,
    // Label 5750: @296235
    GIM_Reject,
    // Label 58: @296236
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5954*/ GIMT_Encode4(298128),
    /*GILLT_s16*//*Label 5946*/ GIMT_Encode4(296287),
    /*GILLT_s32*//*Label 5947*/ GIMT_Encode4(296325),
    /*GILLT_s64*//*Label 5948*/ GIMT_Encode4(296363), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5949*/ GIMT_Encode4(296401),
    /*GILLT_v2s64*//*Label 5950*/ GIMT_Encode4(296439),
    /*GILLT_v4s16*//*Label 5951*/ GIMT_Encode4(296477),
    /*GILLT_v4s32*//*Label 5952*/ GIMT_Encode4(296515), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5953*/ GIMT_Encode4(296553),
    // Label 5946: @296287
    GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(296324), // Rule ID 585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 585,
      GIR_Done,
    // Label 5955: @296324
    GIM_Reject,
    // Label 5947: @296325
    GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(296362), // Rule ID 587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 587,
      GIR_Done,
    // Label 5956: @296362
    GIM_Reject,
    // Label 5948: @296363
    GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(296400), // Rule ID 589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 589,
      GIR_Done,
    // Label 5957: @296400
    GIM_Reject,
    // Label 5949: @296401
    GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(296438), // Rule ID 1216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1216,
      GIR_Done,
    // Label 5958: @296438
    GIM_Reject,
    // Label 5950: @296439
    GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(296476), // Rule ID 1220 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1220,
      GIR_Done,
    // Label 5959: @296476
    GIM_Reject,
    // Label 5951: @296477
    GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(296514), // Rule ID 1212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1212,
      GIR_Done,
    // Label 5960: @296514
    GIM_Reject,
    // Label 5952: @296515
    GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(296552), // Rule ID 1218 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1218,
      GIR_Done,
    // Label 5961: @296552
    GIM_Reject,
    // Label 5953: @296553
    GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(298127),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(296595), // Rule ID 1214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1214,
        GIR_Done,
      // Label 5963: @296595
      GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(296849), // Rule ID 7194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7194,
        GIR_EraseRootFromParent_Done,
      // Label 5964: @296849
      GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(297053), // Rule ID 7196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7196,
        GIR_EraseRootFromParent_Done,
      // Label 5965: @297053
      GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(298126), // Rule ID 7198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7198,
        GIR_EraseRootFromParent_Done,
      // Label 5966: @298126
      GIM_Reject,
    // Label 5962: @298127
    GIM_Reject,
    // Label 5954: @298128
    GIM_Reject,
    // Label 59: @298129
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5978*/ GIMT_Encode4(302056),
    /*GILLT_s16*//*Label 5967*/ GIMT_Encode4(298224),
    /*GILLT_s32*//*Label 5968*/ GIMT_Encode4(299585),
    /*GILLT_s64*//*Label 5969*/ GIMT_Encode4(300608), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5970*/ GIMT_Encode4(301631),
    /*GILLT_v2s64*//*Label 5971*/ GIMT_Encode4(301658),
    /*GILLT_v4s16*//*Label 5972*/ GIMT_Encode4(301685),
    /*GILLT_v4s32*//*Label 5973*/ GIMT_Encode4(301812), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5974*/ GIMT_Encode4(301839), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5975*/ GIMT_Encode4(301966), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5976*/ GIMT_Encode4(301996), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5977*/ GIMT_Encode4(302026),
    // Label 5967: @298224
    GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(299584),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(298394), // Rule ID 4867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4867,
        GIR_EraseRootFromParent_Done,
      // Label 5980: @298394
      GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(298556), // Rule ID 4866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4866,
        GIR_EraseRootFromParent_Done,
      // Label 5981: @298556
      GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(298671), // Rule ID 4865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4865,
        GIR_EraseRootFromParent_Done,
      // Label 5982: @298671
      GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(298786), // Rule ID 4863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4863,
        GIR_EraseRootFromParent_Done,
      // Label 5983: @298786
      GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(298901), // Rule ID 4864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4864,
        GIR_EraseRootFromParent_Done,
      // Label 5984: @298901
      GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(299016), // Rule ID 4862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4862,
        GIR_EraseRootFromParent_Done,
      // Label 5985: @299016
      GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(299084), // Rule ID 645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 645,
        GIR_EraseRootFromParent_Done,
      // Label 5986: @299084
      GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(299152), // Rule ID 644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 644,
        GIR_EraseRootFromParent_Done,
      // Label 5987: @299152
      GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(299207), // Rule ID 621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 621,
        GIR_EraseRootFromParent_Done,
      // Label 5988: @299207
      GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(299262), // Rule ID 620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 620,
        GIR_EraseRootFromParent_Done,
      // Label 5989: @299262
      GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(299285), // Rule ID 519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 519,
        GIR_Done,
      // Label 5990: @299285
      GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(299434), // Rule ID 6427 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6427,
        GIR_EraseRootFromParent_Done,
      // Label 5991: @299434
      GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(299583), // Rule ID 6428 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fneg:{ *:[bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6428,
        GIR_EraseRootFromParent_Done,
      // Label 5992: @299583
      GIM_Reject,
    // Label 5979: @299584
    GIM_Reject,
    // Label 5968: @299585
    GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(300607),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(299755), // Rule ID 4873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4873,
        GIR_EraseRootFromParent_Done,
      // Label 5994: @299755
      GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(299913), // Rule ID 4872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4872,
        GIR_EraseRootFromParent_Done,
      // Label 5995: @299913
      GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(300024), // Rule ID 4871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4871,
        GIR_EraseRootFromParent_Done,
      // Label 5996: @300024
      GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(300135), // Rule ID 4869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4869,
        GIR_EraseRootFromParent_Done,
      // Label 5997: @300135
      GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(300246), // Rule ID 4870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4870,
        GIR_EraseRootFromParent_Done,
      // Label 5998: @300246
      GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(300357), // Rule ID 4868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4868,
        GIR_EraseRootFromParent_Done,
      // Label 5999: @300357
      GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(300421), // Rule ID 647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 647,
        GIR_EraseRootFromParent_Done,
      // Label 6000: @300421
      GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(300485), // Rule ID 646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 646,
        GIR_EraseRootFromParent_Done,
      // Label 6001: @300485
      GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(300536), // Rule ID 623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 623,
        GIR_EraseRootFromParent_Done,
      // Label 6002: @300536
      GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(300587), // Rule ID 622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 622,
        GIR_EraseRootFromParent_Done,
      // Label 6003: @300587
      GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(300606), // Rule ID 520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 520,
        GIR_Done,
      // Label 6004: @300606
      GIM_Reject,
    // Label 5993: @300607
    GIM_Reject,
    // Label 5969: @300608
    GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301630),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(300778), // Rule ID 4879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4879,
        GIR_EraseRootFromParent_Done,
      // Label 6006: @300778
      GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(300936), // Rule ID 4878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4878,
        GIR_EraseRootFromParent_Done,
      // Label 6007: @300936
      GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(301047), // Rule ID 4877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4877,
        GIR_EraseRootFromParent_Done,
      // Label 6008: @301047
      GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(301158), // Rule ID 4875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4875,
        GIR_EraseRootFromParent_Done,
      // Label 6009: @301158
      GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(301269), // Rule ID 4876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4876,
        GIR_EraseRootFromParent_Done,
      // Label 6010: @301269
      GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(301380), // Rule ID 4874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4874,
        GIR_EraseRootFromParent_Done,
      // Label 6011: @301380
      GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(301444), // Rule ID 649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 649,
        GIR_EraseRootFromParent_Done,
      // Label 6012: @301444
      GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(301508), // Rule ID 648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 648,
        GIR_EraseRootFromParent_Done,
      // Label 6013: @301508
      GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(301559), // Rule ID 625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 625,
        GIR_EraseRootFromParent_Done,
      // Label 6014: @301559
      GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(301610), // Rule ID 624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 624,
        GIR_EraseRootFromParent_Done,
      // Label 6015: @301610
      GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(301629), // Rule ID 521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 521,
        GIR_Done,
      // Label 6016: @301629
      GIM_Reject,
    // Label 6005: @301630
    GIM_Reject,
    // Label 5970: @301631
    GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(301657), // Rule ID 848 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 848,
      GIR_Done,
    // Label 6017: @301657
    GIM_Reject,
    // Label 5971: @301658
    GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(301684), // Rule ID 850 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 850,
      GIR_Done,
    // Label 6018: @301684
    GIM_Reject,
    // Label 5972: @301685
    GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(301811),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(301716), // Rule ID 846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 846,
        GIR_Done,
      // Label 6020: @301716
      GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(301763), // Rule ID 6433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6433,
        GIR_EraseRootFromParent_Done,
      // Label 6021: @301763
      GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(301810), // Rule ID 6434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (EORv8i8:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, (MOVIv4i16:{ *:[v4i16] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6434,
        GIR_EraseRootFromParent_Done,
      // Label 6022: @301810
      GIM_Reject,
    // Label 6019: @301811
    GIM_Reject,
    // Label 5973: @301812
    GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(301838), // Rule ID 849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 849,
      GIR_Done,
    // Label 6023: @301838
    GIM_Reject,
    // Label 5974: @301839
    GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(301965),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(301870), // Rule ID 847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 847,
        GIR_Done,
      // Label 6025: @301870
      GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(301917), // Rule ID 6435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6435,
        GIR_EraseRootFromParent_Done,
      // Label 6026: @301917
      GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(301964), // Rule ID 6436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (EORv16i8:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (MOVIv8i16:{ *:[v8i16] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6436,
        GIR_EraseRootFromParent_Done,
      // Label 6027: @301964
      GIM_Reject,
    // Label 6024: @301965
    GIM_Reject,
    // Label 5975: @301966
    GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(301995), // Rule ID 7925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fneg:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$op)  =>  (EOR_ZI:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } -9223231297218904064:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7925,
      GIR_EraseRootFromParent_Done,
    // Label 6028: @301995
    GIM_Reject,
    // Label 5976: @301996
    GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(302025), // Rule ID 7927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fneg:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$op)  =>  (EOR_ZI:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } -9223231297218904064:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7927,
      GIR_EraseRootFromParent_Done,
    // Label 6029: @302025
    GIM_Reject,
    // Label 5977: @302026
    GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(302055), // Rule ID 7929 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fneg:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$op)  =>  (EOR_ZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } -9223231297218904064:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7929,
      GIR_EraseRootFromParent_Done,
    // Label 6030: @302055
    GIM_Reject,
    // Label 5978: @302056
    GIM_Reject,
    // Label 60: @302057
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 6037*/ GIMT_Encode4(302420),
    /*GILLT_s32*//*Label 6031*/ GIMT_Encode4(302140),
    /*GILLT_s64*//*Label 6032*/ GIMT_Encode4(302171), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 6033*/ GIMT_Encode4(302232), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 6034*/ GIMT_Encode4(302290), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s32*//*Label 6035*/ GIMT_Encode4(302364), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 6036*/ GIMT_Encode4(302392),
    // Label 6031: @302140
    GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(302170), // Rule ID 511 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 511,
      GIR_Done,
    // Label 6038: @302170
    GIM_Reject,
    // Label 6032: @302171
    GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(302201), // Rule ID 509 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 509,
      GIR_Done,
    // Label 6039: @302201
    GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(302231), // Rule ID 513 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 513,
      GIR_Done,
    // Label 6040: @302231
    GIM_Reject,
    // Label 6033: @302232
    GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(302289),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(302268), // Rule ID 4924 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
        // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4924,
        GIR_EraseRootFromParent_Done,
      // Label 6042: @302268
      GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(302288), // Rule ID 4922 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4922,
        GIR_Done,
      // Label 6043: @302288
      GIM_Reject,
    // Label 6041: @302289
    GIM_Reject,
    // Label 6034: @302290
    GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(302363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(302326), // Rule ID 4928 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
        // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4928,
        GIR_EraseRootFromParent_Done,
      // Label 6045: @302326
      GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(302346), // Rule ID 4926 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4926,
        GIR_Done,
      // Label 6046: @302346
      GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(302362), // Rule ID 6415 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fpextend:{ *:[v4f32] } V64:{ *:[v4bf16] }:$Rn)  =>  (SHLLv4i16:{ *:[v4f32] } V64:{ *:[v4bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6415,
        GIR_Done,
      // Label 6047: @302362
      GIM_Reject,
    // Label 6044: @302363
    GIM_Reject,
    // Label 6035: @302364
    GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(302391), // Rule ID 10499 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fpextend:{ *:[nxv2f32] } nxv2bf16:{ *:[nxv2bf16] }:$op)  =>  (LSL_ZZI_S:{ *:[nxv2f32] } ?:{ *:[nxv2bf16] }:$op, 16:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZZI_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 10499,
      GIR_EraseRootFromParent_Done,
    // Label 6048: @302391
    GIM_Reject,
    // Label 6036: @302392
    GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(302419), // Rule ID 10498 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fpextend:{ *:[nxv4f32] } nxv4bf16:{ *:[nxv4bf16] }:$op)  =>  (LSL_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4bf16] }:$op, 16:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZZI_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 10498,
      GIR_EraseRootFromParent_Done,
    // Label 6049: @302419
    GIM_Reject,
    // Label 6037: @302420
    GIM_Reject,
    // Label 61: @302421
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6054*/ GIMT_Encode4(302748),
    /*GILLT_s16*//*Label 6050*/ GIMT_Encode4(302460),
    /*GILLT_s32*//*Label 6051*/ GIMT_Encode4(302598), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6052*/ GIMT_Encode4(302629), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6053*/ GIMT_Encode4(302657),
    // Label 6050: @302460
    GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(302490), // Rule ID 505 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 505,
      GIR_Done,
    // Label 6055: @302490
    GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(302520), // Rule ID 515 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 515,
      GIR_Done,
    // Label 6056: @302520
    GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(302550), // Rule ID 3782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fpround:{ *:[bf16] } FPR32:{ *:[f32] }:$Rn)  =>  (BFCVT:{ *:[bf16] } ?:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFCVT),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3782,
      GIR_Done,
    // Label 6057: @302550
    GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(302597), // Rule ID 5275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fpround:{ *:[bf16] } FPR64:{ *:[f64] }:$Rn)  =>  (BFCVT:{ *:[bf16] } (FCVTXNv1i64:{ *:[i32] } ?:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5275,
      GIR_EraseRootFromParent_Done,
    // Label 6058: @302597
    GIM_Reject,
    // Label 6051: @302598
    GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(302628), // Rule ID 507 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 507,
      GIR_Done,
    // Label 6059: @302628
    GIM_Reject,
    // Label 6052: @302629
    GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(302656), // Rule ID 4932 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4932,
      GIR_Done,
    // Label 6060: @302656
    GIM_Reject,
    // Label 6053: @302657
    GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(302747),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(302722), // Rule ID 3779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fpround:{ *:[v4bf16] } V128:{ *:[v4f32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (BFCVTN:{ *:[f128] } V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 3779,
        GIR_EraseRootFromParent_Done,
      // Label 6062: @302722
      GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(302746), // Rule ID 4934 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4934,
        GIR_Done,
      // Label 6063: @302746
      GIM_Reject,
    // Label 6061: @302747
    GIM_Reject,
    // Label 6054: @302748
    GIM_Reject,
    // Label 62: @302749
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6071*/ GIMT_Encode4(303811),
    /*GILLT_s32*//*Label 6064*/ GIMT_Encode4(302796),
    /*GILLT_s64*//*Label 6065*/ GIMT_Encode4(303183), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6066*/ GIMT_Encode4(303570),
    /*GILLT_v2s64*//*Label 6067*/ GIMT_Encode4(303644),
    /*GILLT_v4s16*//*Label 6068*/ GIMT_Encode4(303718),
    /*GILLT_v4s32*//*Label 6069*/ GIMT_Encode4(303749), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6070*/ GIMT_Encode4(303780),
    // Label 6064: @302796
    GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(302833), // Rule ID 4671 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4671,
      GIR_EraseRootFromParent_Done,
    // Label 6072: @302833
    GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(302870), // Rule ID 4673 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4673,
      GIR_EraseRootFromParent_Done,
    // Label 6073: @302870
    GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(302907), // Rule ID 4691 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4691,
      GIR_EraseRootFromParent_Done,
    // Label 6074: @302907
    GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(302944), // Rule ID 4693 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4693,
      GIR_EraseRootFromParent_Done,
    // Label 6075: @302944
    GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(302981), // Rule ID 4731 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4731,
      GIR_EraseRootFromParent_Done,
    // Label 6076: @302981
    GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(303018), // Rule ID 4733 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4733,
      GIR_EraseRootFromParent_Done,
    // Label 6077: @303018
    GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(303055), // Rule ID 4711 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4711,
      GIR_EraseRootFromParent_Done,
    // Label 6078: @303055
    GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(303092), // Rule ID 4713 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4713,
      GIR_EraseRootFromParent_Done,
    // Label 6079: @303092
    GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(303122), // Rule ID 406 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 406,
      GIR_Done,
    // Label 6080: @303122
    GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(303152), // Rule ID 410 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 410,
      GIR_Done,
    // Label 6081: @303152
    GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(303182), // Rule ID 414 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 414,
      GIR_Done,
    // Label 6082: @303182
    GIM_Reject,
    // Label 6065: @303183
    GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(303220), // Rule ID 4672 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4672,
      GIR_EraseRootFromParent_Done,
    // Label 6083: @303220
    GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(303257), // Rule ID 4674 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4674,
      GIR_EraseRootFromParent_Done,
    // Label 6084: @303257
    GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(303294), // Rule ID 4692 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4692,
      GIR_EraseRootFromParent_Done,
    // Label 6085: @303294
    GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(303331), // Rule ID 4694 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4694,
      GIR_EraseRootFromParent_Done,
    // Label 6086: @303331
    GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(303368), // Rule ID 4732 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4732,
      GIR_EraseRootFromParent_Done,
    // Label 6087: @303368
    GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(303405), // Rule ID 4734 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4734,
      GIR_EraseRootFromParent_Done,
    // Label 6088: @303405
    GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(303442), // Rule ID 4712 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4712,
      GIR_EraseRootFromParent_Done,
    // Label 6089: @303442
    GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(303479), // Rule ID 4714 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4714,
      GIR_EraseRootFromParent_Done,
    // Label 6090: @303479
    GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(303509), // Rule ID 408 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 408,
      GIR_Done,
    // Label 6091: @303509
    GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(303539), // Rule ID 412 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 412,
      GIR_Done,
    // Label 6092: @303539
    GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(303569), // Rule ID 416 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 416,
      GIR_Done,
    // Label 6093: @303569
    GIM_Reject,
    // Label 6066: @303570
    GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(303600), // Rule ID 831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 831,
      GIR_Done,
    // Label 6094: @303600
    GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(303643), // Rule ID 13089 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13089,
      GIR_EraseRootFromParent_Done,
    // Label 6095: @303643
    GIM_Reject,
    // Label 6067: @303644
    GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(303674), // Rule ID 835 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 835,
      GIR_Done,
    // Label 6096: @303674
    GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(303717), // Rule ID 13087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13087,
      GIR_EraseRootFromParent_Done,
    // Label 6097: @303717
    GIM_Reject,
    // Label 6068: @303718
    GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(303748), // Rule ID 827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 827,
      GIR_Done,
    // Label 6098: @303748
    GIM_Reject,
    // Label 6069: @303749
    GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(303779), // Rule ID 833 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 833,
      GIR_Done,
    // Label 6099: @303779
    GIM_Reject,
    // Label 6070: @303780
    GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(303810), // Rule ID 829 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 829,
      GIR_Done,
    // Label 6100: @303810
    GIM_Reject,
    // Label 6071: @303811
    GIM_Reject,
    // Label 63: @303812
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6108*/ GIMT_Encode4(304874),
    /*GILLT_s32*//*Label 6101*/ GIMT_Encode4(303859),
    /*GILLT_s64*//*Label 6102*/ GIMT_Encode4(304246), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6103*/ GIMT_Encode4(304633),
    /*GILLT_v2s64*//*Label 6104*/ GIMT_Encode4(304707),
    /*GILLT_v4s16*//*Label 6105*/ GIMT_Encode4(304781),
    /*GILLT_v4s32*//*Label 6106*/ GIMT_Encode4(304812), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6107*/ GIMT_Encode4(304843),
    // Label 6101: @303859
    GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(303896), // Rule ID 4681 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4681,
      GIR_EraseRootFromParent_Done,
    // Label 6109: @303896
    GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(303933), // Rule ID 4683 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4683,
      GIR_EraseRootFromParent_Done,
    // Label 6110: @303933
    GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(303970), // Rule ID 4701 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4701,
      GIR_EraseRootFromParent_Done,
    // Label 6111: @303970
    GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(304007), // Rule ID 4703 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4703,
      GIR_EraseRootFromParent_Done,
    // Label 6112: @304007
    GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(304044), // Rule ID 4741 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4741,
      GIR_EraseRootFromParent_Done,
    // Label 6113: @304044
    GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(304081), // Rule ID 4743 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4743,
      GIR_EraseRootFromParent_Done,
    // Label 6114: @304081
    GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(304118), // Rule ID 4721 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4721,
      GIR_EraseRootFromParent_Done,
    // Label 6115: @304118
    GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(304155), // Rule ID 4723 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4723,
      GIR_EraseRootFromParent_Done,
    // Label 6116: @304155
    GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(304185), // Rule ID 418 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 418,
      GIR_Done,
    // Label 6117: @304185
    GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(304215), // Rule ID 422 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 422,
      GIR_Done,
    // Label 6118: @304215
    GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(304245), // Rule ID 426 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 426,
      GIR_Done,
    // Label 6119: @304245
    GIM_Reject,
    // Label 6102: @304246
    GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(304283), // Rule ID 4682 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4682,
      GIR_EraseRootFromParent_Done,
    // Label 6120: @304283
    GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(304320), // Rule ID 4684 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4684,
      GIR_EraseRootFromParent_Done,
    // Label 6121: @304320
    GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(304357), // Rule ID 4702 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4702,
      GIR_EraseRootFromParent_Done,
    // Label 6122: @304357
    GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(304394), // Rule ID 4704 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4704,
      GIR_EraseRootFromParent_Done,
    // Label 6123: @304394
    GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(304431), // Rule ID 4742 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4742,
      GIR_EraseRootFromParent_Done,
    // Label 6124: @304431
    GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(304468), // Rule ID 4744 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4744,
      GIR_EraseRootFromParent_Done,
    // Label 6125: @304468
    GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(304505), // Rule ID 4722 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4722,
      GIR_EraseRootFromParent_Done,
    // Label 6126: @304505
    GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(304542), // Rule ID 4724 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4724,
      GIR_EraseRootFromParent_Done,
    // Label 6127: @304542
    GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(304572), // Rule ID 420 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 420,
      GIR_Done,
    // Label 6128: @304572
    GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(304602), // Rule ID 424 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 424,
      GIR_Done,
    // Label 6129: @304602
    GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(304632), // Rule ID 428 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 428,
      GIR_Done,
    // Label 6130: @304632
    GIM_Reject,
    // Label 6103: @304633
    GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(304663), // Rule ID 841 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 841,
      GIR_Done,
    // Label 6131: @304663
    GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(304706), // Rule ID 13090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13090,
      GIR_EraseRootFromParent_Done,
    // Label 6132: @304706
    GIM_Reject,
    // Label 6104: @304707
    GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(304737), // Rule ID 845 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 845,
      GIR_Done,
    // Label 6133: @304737
    GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(304780), // Rule ID 13088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13088,
      GIR_EraseRootFromParent_Done,
    // Label 6134: @304780
    GIM_Reject,
    // Label 6105: @304781
    GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(304811), // Rule ID 837 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 837,
      GIR_Done,
    // Label 6135: @304811
    GIM_Reject,
    // Label 6106: @304812
    GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(304842), // Rule ID 843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 843,
      GIR_Done,
    // Label 6136: @304842
    GIM_Reject,
    // Label 6107: @304843
    GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(304873), // Rule ID 839 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 839,
      GIR_Done,
    // Label 6137: @304873
    GIM_Reject,
    // Label 6108: @304874
    GIM_Reject,
    // Label 64: @304875
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6146*/ GIMT_Encode4(309151),
    /*GILLT_s16*//*Label 6138*/ GIMT_Encode4(304926),
    /*GILLT_s32*//*Label 6139*/ GIMT_Encode4(305147),
    /*GILLT_s64*//*Label 6140*/ GIMT_Encode4(307033), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6141*/ GIMT_Encode4(308907),
    /*GILLT_v2s64*//*Label 6142*/ GIMT_Encode4(308981),
    /*GILLT_v4s16*//*Label 6143*/ GIMT_Encode4(309058),
    /*GILLT_v4s32*//*Label 6144*/ GIMT_Encode4(309089), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6145*/ GIMT_Encode4(309120),
    // Label 6138: @304926
    GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(305029), // Rule ID 5347 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
      // MIs[1] Operand 2
      GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5347,
      GIR_EraseRootFromParent_Done,
    // Label 6147: @305029
    GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(305086), // Rule ID 5338 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5338,
      GIR_EraseRootFromParent_Done,
    // Label 6148: @305086
    GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(305116), // Rule ID 454 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 454,
      GIR_Done,
    // Label 6149: @305116
    GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(305146), // Rule ID 460 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 460,
      GIR_Done,
    // Label 6150: @305146
    GIM_Reject,
    // Label 6139: @305147
    GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(305385), // Rule ID 6437 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6437,
      GIR_EraseRootFromParent_Done,
    // Label 6151: @305385
    GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(305623), // Rule ID 6438 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6438,
      GIR_EraseRootFromParent_Done,
    // Label 6152: @305623
    GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(305812), // Rule ID 6441 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6441,
      GIR_EraseRootFromParent_Done,
    // Label 6153: @305812
    GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(306001), // Rule ID 6442 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6442,
      GIR_EraseRootFromParent_Done,
    // Label 6154: @306001
    GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(306234), // Rule ID 6439 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6439,
      GIR_EraseRootFromParent_Done,
    // Label 6155: @306234
    GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(306467), // Rule ID 6440 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6440,
      GIR_EraseRootFromParent_Done,
    // Label 6156: @306467
    GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(306651), // Rule ID 6443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6443,
      GIR_EraseRootFromParent_Done,
    // Label 6157: @306651
    GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(306835), // Rule ID 6444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6444,
      GIR_EraseRootFromParent_Done,
    // Label 6158: @306835
    GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(306915), // Rule ID 5343 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5343,
      GIR_EraseRootFromParent_Done,
    // Label 6159: @306915
    GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(306972), // Rule ID 5326 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5326,
      GIR_EraseRootFromParent_Done,
    // Label 6160: @306972
    GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(307002), // Rule ID 456 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 456,
      GIR_Done,
    // Label 6161: @307002
    GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(307032), // Rule ID 462 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 462,
      GIR_Done,
    // Label 6162: @307032
    GIM_Reject,
    // Label 6140: @307033
    GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(307219), // Rule ID 6449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6449,
      GIR_EraseRootFromParent_Done,
    // Label 6163: @307219
    GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(307405), // Rule ID 6450 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6450,
      GIR_EraseRootFromParent_Done,
    // Label 6164: @307405
    GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(307643), // Rule ID 6445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6445,
      GIR_EraseRootFromParent_Done,
    // Label 6165: @307643
    GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(307881), // Rule ID 6446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6446,
      GIR_EraseRootFromParent_Done,
    // Label 6166: @307881
    GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(308062), // Rule ID 6451 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6451,
      GIR_EraseRootFromParent_Done,
    // Label 6167: @308062
    GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(308243), // Rule ID 6452 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6452,
      GIR_EraseRootFromParent_Done,
    // Label 6168: @308243
    GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308476), // Rule ID 6447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6447,
      GIR_EraseRootFromParent_Done,
    // Label 6169: @308476
    GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308709), // Rule ID 6448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6448,
      GIR_EraseRootFromParent_Done,
    // Label 6170: @308709
    GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(308789), // Rule ID 5345 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5345,
      GIR_EraseRootFromParent_Done,
    // Label 6171: @308789
    GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308846), // Rule ID 5322 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5322,
      GIR_EraseRootFromParent_Done,
    // Label 6172: @308846
    GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308876), // Rule ID 458 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 458,
      GIR_Done,
    // Label 6173: @308876
    GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308906), // Rule ID 464 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 464,
      GIR_Done,
    // Label 6174: @308906
    GIM_Reject,
    // Label 6141: @308907
    GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(308937), // Rule ID 1005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1005,
      GIR_Done,
    // Label 6175: @308937
    GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308980), // Rule ID 13085 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13085,
      GIR_EraseRootFromParent_Done,
    // Label 6176: @308980
    GIM_Reject,
    // Label 6142: @308981
    GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(309011), // Rule ID 1009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1009,
      GIR_Done,
    // Label 6177: @309011
    GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(309057), // Rule ID 13083 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13083,
      GIR_EraseRootFromParent_Done,
    // Label 6178: @309057
    GIM_Reject,
    // Label 6143: @309058
    GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(309088), // Rule ID 1001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1001,
      GIR_Done,
    // Label 6179: @309088
    GIM_Reject,
    // Label 6144: @309089
    GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(309119), // Rule ID 1007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1007,
      GIR_Done,
    // Label 6180: @309119
    GIM_Reject,
    // Label 6145: @309120
    GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(309150), // Rule ID 1003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1003,
      GIR_Done,
    // Label 6181: @309150
    GIM_Reject,
    // Label 6146: @309151
    GIM_Reject,
    // Label 65: @309152
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6190*/ GIMT_Encode4(312806),
    /*GILLT_s16*//*Label 6182*/ GIMT_Encode4(309203),
    /*GILLT_s32*//*Label 6183*/ GIMT_Encode4(309428),
    /*GILLT_s64*//*Label 6184*/ GIMT_Encode4(310726), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6185*/ GIMT_Encode4(312562),
    /*GILLT_v2s64*//*Label 6186*/ GIMT_Encode4(312636),
    /*GILLT_v4s16*//*Label 6187*/ GIMT_Encode4(312713),
    /*GILLT_v4s32*//*Label 6188*/ GIMT_Encode4(312744), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6189*/ GIMT_Encode4(312775),
    // Label 6182: @309203
    GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(309310), // Rule ID 5348 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
      GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5348,
      GIR_EraseRootFromParent_Done,
    // Label 6191: @309310
    GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(309367), // Rule ID 5342 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5342,
      GIR_EraseRootFromParent_Done,
    // Label 6192: @309367
    GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(309397), // Rule ID 478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 478,
      GIR_Done,
    // Label 6193: @309397
    GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(309427), // Rule ID 484 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 484,
      GIR_Done,
    // Label 6194: @309427
    GIM_Reject,
    // Label 6183: @309428
    GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(309568), // Rule ID 5349 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5349,
      GIR_EraseRootFromParent_Done,
    // Label 6195: @309568
    GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(309708), // Rule ID 5350 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5350,
      GIR_EraseRootFromParent_Done,
    // Label 6196: @309708
    GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(309848), // Rule ID 5353 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5353,
      GIR_EraseRootFromParent_Done,
    // Label 6197: @309848
    GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(309988), // Rule ID 5354 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5354,
      GIR_EraseRootFromParent_Done,
    // Label 6198: @309988
    GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310123), // Rule ID 5351 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5351,
      GIR_EraseRootFromParent_Done,
    // Label 6199: @310123
    GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310258), // Rule ID 5352 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5352,
      GIR_EraseRootFromParent_Done,
    // Label 6200: @310258
    GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310393), // Rule ID 5355 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5355,
      GIR_EraseRootFromParent_Done,
    // Label 6201: @310393
    GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310528), // Rule ID 5356 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5356,
      GIR_EraseRootFromParent_Done,
    // Label 6202: @310528
    GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310608), // Rule ID 5344 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5344,
      GIR_EraseRootFromParent_Done,
    // Label 6203: @310608
    GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310665), // Rule ID 5334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5334,
      GIR_EraseRootFromParent_Done,
    // Label 6204: @310665
    GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(310695), // Rule ID 480 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 480,
      GIR_Done,
    // Label 6205: @310695
    GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(310725), // Rule ID 486 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 486,
      GIR_Done,
    // Label 6206: @310725
    GIM_Reject,
    // Label 6184: @310726
    GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(310863), // Rule ID 5365 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5365,
      GIR_EraseRootFromParent_Done,
    // Label 6207: @310863
    GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(311000), // Rule ID 5366 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5366,
      GIR_EraseRootFromParent_Done,
    // Label 6208: @311000
    GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(311140), // Rule ID 5357 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5357,
      GIR_EraseRootFromParent_Done,
    // Label 6209: @311140
    GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(311280), // Rule ID 5358 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5358,
      GIR_EraseRootFromParent_Done,
    // Label 6210: @311280
    GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311420), // Rule ID 5361 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5361,
      GIR_EraseRootFromParent_Done,
    // Label 6211: @311420
    GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311560), // Rule ID 5362 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5362,
      GIR_EraseRootFromParent_Done,
    // Label 6212: @311560
    GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(311692), // Rule ID 5367 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5367,
      GIR_EraseRootFromParent_Done,
    // Label 6213: @311692
    GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(311824), // Rule ID 5368 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5368,
      GIR_EraseRootFromParent_Done,
    // Label 6214: @311824
    GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(311959), // Rule ID 5359 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5359,
      GIR_EraseRootFromParent_Done,
    // Label 6215: @311959
    GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(312094), // Rule ID 5360 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5360,
      GIR_EraseRootFromParent_Done,
    // Label 6216: @312094
    GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(312229), // Rule ID 5363 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5363,
      GIR_EraseRootFromParent_Done,
    // Label 6217: @312229
    GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(312364), // Rule ID 5364 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5364,
      GIR_EraseRootFromParent_Done,
    // Label 6218: @312364
    GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(312444), // Rule ID 5346 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5346,
      GIR_EraseRootFromParent_Done,
    // Label 6219: @312444
    GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(312501), // Rule ID 5330 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5330,
      GIR_EraseRootFromParent_Done,
    // Label 6220: @312501
    GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(312531), // Rule ID 482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 482,
      GIR_Done,
    // Label 6221: @312531
    GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(312561), // Rule ID 488 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 488,
      GIR_Done,
    // Label 6222: @312561
    GIM_Reject,
    // Label 6185: @312562
    GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(312592), // Rule ID 1066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1066,
      GIR_Done,
    // Label 6223: @312592
    GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(312635), // Rule ID 13086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13086,
      GIR_EraseRootFromParent_Done,
    // Label 6224: @312635
    GIM_Reject,
    // Label 6186: @312636
    GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(312666), // Rule ID 1070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1070,
      GIR_Done,
    // Label 6225: @312666
    GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(312712), // Rule ID 13084 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13084,
      GIR_EraseRootFromParent_Done,
    // Label 6226: @312712
    GIM_Reject,
    // Label 6187: @312713
    GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(312743), // Rule ID 1062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1062,
      GIR_Done,
    // Label 6227: @312743
    GIM_Reject,
    // Label 6188: @312744
    GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312774), // Rule ID 1068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1068,
      GIR_Done,
    // Label 6228: @312774
    GIM_Reject,
    // Label 6189: @312775
    GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312805), // Rule ID 1064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1064,
      GIR_Done,
    // Label 6229: @312805
    GIM_Reject,
    // Label 6190: @312806
    GIM_Reject,
    // Label 66: @312807
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6237*/ GIMT_Encode4(313126),
    /*GILLT_s32*//*Label 6230*/ GIMT_Encode4(312854),
    /*GILLT_s64*//*Label 6231*/ GIMT_Encode4(312927), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6232*/ GIMT_Encode4(313000),
    /*GILLT_v2s64*//*Label 6233*/ GIMT_Encode4(313024),
    /*GILLT_v4s16*//*Label 6234*/ GIMT_Encode4(313048),
    /*GILLT_v4s32*//*Label 6235*/ GIMT_Encode4(313075), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6236*/ GIMT_Encode4(313099),
    // Label 6230: @312854
    GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(312880), // Rule ID 4605 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4605,
      GIR_Done,
    // Label 6238: @312880
    GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(312903), // Rule ID 4607 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4607,
      GIR_Done,
    // Label 6239: @312903
    GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(312926), // Rule ID 4609 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4609,
      GIR_Done,
    // Label 6240: @312926
    GIM_Reject,
    // Label 6231: @312927
    GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(312953), // Rule ID 4606 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4606,
      GIR_Done,
    // Label 6241: @312953
    GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(312976), // Rule ID 4608 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4608,
      GIR_Done,
    // Label 6242: @312976
    GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(312999), // Rule ID 4610 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4610,
      GIR_Done,
    // Label 6243: @312999
    GIM_Reject,
    // Label 6232: @313000
    GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(313023), // Rule ID 4946 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4946,
      GIR_Done,
    // Label 6244: @313023
    GIM_Reject,
    // Label 6233: @313024
    GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(313047), // Rule ID 4948 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4948,
      GIR_Done,
    // Label 6245: @313047
    GIM_Reject,
    // Label 6234: @313048
    GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(313074), // Rule ID 4941 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4941,
      GIR_Done,
    // Label 6246: @313074
    GIM_Reject,
    // Label 6235: @313075
    GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(313098), // Rule ID 4947 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4947,
      GIR_Done,
    // Label 6247: @313098
    GIM_Reject,
    // Label 6236: @313099
    GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(313125), // Rule ID 4942 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4942,
      GIR_Done,
    // Label 6248: @313125
    GIM_Reject,
    // Label 6237: @313126
    GIM_Reject,
    // Label 67: @313127
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6256*/ GIMT_Encode4(313446),
    /*GILLT_s32*//*Label 6249*/ GIMT_Encode4(313174),
    /*GILLT_s64*//*Label 6250*/ GIMT_Encode4(313247), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6251*/ GIMT_Encode4(313320),
    /*GILLT_v2s64*//*Label 6252*/ GIMT_Encode4(313344),
    /*GILLT_v4s16*//*Label 6253*/ GIMT_Encode4(313368),
    /*GILLT_v4s32*//*Label 6254*/ GIMT_Encode4(313395), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6255*/ GIMT_Encode4(313419),
    // Label 6249: @313174
    GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(313200), // Rule ID 4629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4629,
      GIR_Done,
    // Label 6257: @313200
    GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(313223), // Rule ID 4631 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4631,
      GIR_Done,
    // Label 6258: @313223
    GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(313246), // Rule ID 4633 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4633,
      GIR_Done,
    // Label 6259: @313246
    GIM_Reject,
    // Label 6250: @313247
    GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(313273), // Rule ID 4630 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4630,
      GIR_Done,
    // Label 6260: @313273
    GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(313296), // Rule ID 4632 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4632,
      GIR_Done,
    // Label 6261: @313296
    GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(313319), // Rule ID 4634 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4634,
      GIR_Done,
    // Label 6262: @313319
    GIM_Reject,
    // Label 6251: @313320
    GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(313343), // Rule ID 4956 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4956,
      GIR_Done,
    // Label 6263: @313343
    GIM_Reject,
    // Label 6252: @313344
    GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(313367), // Rule ID 4958 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4958,
      GIR_Done,
    // Label 6264: @313367
    GIM_Reject,
    // Label 6253: @313368
    GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(313394), // Rule ID 4951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4951,
      GIR_Done,
    // Label 6265: @313394
    GIM_Reject,
    // Label 6254: @313395
    GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(313418), // Rule ID 4957 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4957,
      GIR_Done,
    // Label 6266: @313418
    GIM_Reject,
    // Label 6255: @313419
    GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(313445), // Rule ID 4952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4952,
      GIR_Done,
    // Label 6267: @313445
    GIM_Reject,
    // Label 6256: @313446
    GIM_Reject,
    // Label 68: @313447
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6279*/ GIMT_Encode4(314662),
    /*GILLT_s16*//*Label 6268*/ GIMT_Encode4(313542),
    /*GILLT_s32*//*Label 6269*/ GIMT_Encode4(313918),
    /*GILLT_s64*//*Label 6270*/ GIMT_Encode4(313992), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6271*/ GIMT_Encode4(314066),
    /*GILLT_v2s64*//*Label 6272*/ GIMT_Encode4(314140),
    /*GILLT_v4s16*//*Label 6273*/ GIMT_Encode4(314214),
    /*GILLT_v4s32*//*Label 6274*/ GIMT_Encode4(314356), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6275*/ GIMT_Encode4(314430), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 6276*/ GIMT_Encode4(314572), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 6277*/ GIMT_Encode4(314602), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 6278*/ GIMT_Encode4(314632),
    // Label 6268: @313542
    GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(313917),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(313595), // Rule ID 5231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5231,
        GIR_EraseRootFromParent_Done,
      // Label 6281: @313595
      GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(313618), // Rule ID 516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 516,
        GIR_Done,
      // Label 6282: @313618
      GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(313767), // Rule ID 6425 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6425,
        GIR_EraseRootFromParent_Done,
      // Label 6283: @313767
      GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(313916), // Rule ID 6426 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fabs:{ *:[bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6426,
        GIR_EraseRootFromParent_Done,
      // Label 6284: @313916
      GIM_Reject,
    // Label 6280: @313917
    GIM_Reject,
    // Label 6269: @313918
    GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(313991),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(313971), // Rule ID 5232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5232,
        GIR_EraseRootFromParent_Done,
      // Label 6286: @313971
      GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(313990), // Rule ID 517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 517,
        GIR_Done,
      // Label 6287: @313990
      GIM_Reject,
    // Label 6285: @313991
    GIM_Reject,
    // Label 6270: @313992
    GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(314065),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(314045), // Rule ID 5233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5233,
        GIR_EraseRootFromParent_Done,
      // Label 6289: @314045
      GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(314064), // Rule ID 518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 518,
        GIR_Done,
      // Label 6290: @314064
      GIM_Reject,
    // Label 6288: @314065
    GIM_Reject,
    // Label 6271: @314066
    GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(314139),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(314119), // Rule ID 5024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5024,
        GIR_EraseRootFromParent_Done,
      // Label 6292: @314119
      GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(314138), // Rule ID 756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 756,
        GIR_Done,
      // Label 6293: @314138
      GIM_Reject,
    // Label 6291: @314139
    GIM_Reject,
    // Label 6272: @314140
    GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(314213),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(314193), // Rule ID 5026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5026,
        GIR_EraseRootFromParent_Done,
      // Label 6295: @314193
      GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(314212), // Rule ID 758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 6296: @314212
      GIM_Reject,
    // Label 6294: @314213
    GIM_Reject,
    // Label 6273: @314214
    GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(314355),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(314267), // Rule ID 5027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5027,
        GIR_EraseRootFromParent_Done,
      // Label 6298: @314267
      GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(314286), // Rule ID 754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 754,
        GIR_Done,
      // Label 6299: @314286
      GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(314320), // Rule ID 6429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6429,
        GIR_EraseRootFromParent_Done,
      // Label 6300: @314320
      GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(314354), // Rule ID 6430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (BICv4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6430,
        GIR_EraseRootFromParent_Done,
      // Label 6301: @314354
      GIM_Reject,
    // Label 6297: @314355
    GIM_Reject,
    // Label 6274: @314356
    GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(314429),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(314409), // Rule ID 5025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5025,
        GIR_EraseRootFromParent_Done,
      // Label 6303: @314409
      GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(314428), // Rule ID 757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 6304: @314428
      GIM_Reject,
    // Label 6302: @314429
    GIM_Reject,
    // Label 6275: @314430
    GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(314571),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(314483), // Rule ID 5028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5028,
        GIR_EraseRootFromParent_Done,
      // Label 6306: @314483
      GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(314502), // Rule ID 755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 755,
        GIR_Done,
      // Label 6307: @314502
      GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(314536), // Rule ID 6431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6431,
        GIR_EraseRootFromParent_Done,
      // Label 6308: @314536
      GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(314570), // Rule ID 6432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BICv8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6432,
        GIR_EraseRootFromParent_Done,
      // Label 6309: @314570
      GIM_Reject,
    // Label 6305: @314571
    GIM_Reject,
    // Label 6276: @314572
    GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(314601), // Rule ID 7924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fabs:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$op)  =>  (AND_ZI:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } 9223231297218904063:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7924,
      GIR_EraseRootFromParent_Done,
    // Label 6310: @314601
    GIM_Reject,
    // Label 6277: @314602
    GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(314631), // Rule ID 7926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fabs:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$op)  =>  (AND_ZI:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } 9223231297218904063:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7926,
      GIR_EraseRootFromParent_Done,
    // Label 6311: @314631
    GIM_Reject,
    // Label 6278: @314632
    GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(314661), // Rule ID 7928 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fabs:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$op)  =>  (AND_ZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } 9223231297218904063:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7928,
      GIR_EraseRootFromParent_Done,
    // Label 6312: @314661
    GIM_Reject,
    // Label 6279: @314662
    GIM_Reject,
    // Label 69: @314663
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6321*/ GIMT_Encode4(314944),
    /*GILLT_s16*//*Label 6313*/ GIMT_Encode4(314714),
    /*GILLT_s32*//*Label 6314*/ GIMT_Encode4(314741),
    /*GILLT_s64*//*Label 6315*/ GIMT_Encode4(314765), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6316*/ GIMT_Encode4(314789),
    /*GILLT_v2s64*//*Label 6317*/ GIMT_Encode4(314820),
    /*GILLT_v4s16*//*Label 6318*/ GIMT_Encode4(314851),
    /*GILLT_v4s32*//*Label 6319*/ GIMT_Encode4(314882), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6320*/ GIMT_Encode4(314913),
    // Label 6313: @314714
    GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(314740), // Rule ID 4843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4843,
      GIR_EraseRootFromParent_Done,
    // Label 6322: @314740
    GIM_Reject,
    // Label 6314: @314741
    GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(314764), // Rule ID 4840 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4840,
      GIR_EraseRootFromParent_Done,
    // Label 6323: @314764
    GIM_Reject,
    // Label 6315: @314765
    GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(314788), // Rule ID 4837 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4837,
      GIR_EraseRootFromParent_Done,
    // Label 6324: @314788
    GIM_Reject,
    // Label 6316: @314789
    GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(314819), // Rule ID 5037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5037,
      GIR_EraseRootFromParent_Done,
    // Label 6325: @314819
    GIM_Reject,
    // Label 6317: @314820
    GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(314850), // Rule ID 5031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5031,
      GIR_EraseRootFromParent_Done,
    // Label 6326: @314850
    GIM_Reject,
    // Label 6318: @314851
    GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(314881), // Rule ID 5043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5043,
      GIR_EraseRootFromParent_Done,
    // Label 6327: @314881
    GIM_Reject,
    // Label 6319: @314882
    GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(314912), // Rule ID 5034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5034,
      GIR_EraseRootFromParent_Done,
    // Label 6328: @314912
    GIM_Reject,
    // Label 6320: @314913
    GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(314943), // Rule ID 5040 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5040,
      GIR_EraseRootFromParent_Done,
    // Label 6329: @314943
    GIM_Reject,
    // Label 6321: @314944
    GIM_Reject,
    // Label 70: @314945
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6338*/ GIMT_Encode4(315322),
    /*GILLT_s16*//*Label 6330*/ GIMT_Encode4(314996),
    /*GILLT_s32*//*Label 6331*/ GIMT_Encode4(315034),
    /*GILLT_s64*//*Label 6332*/ GIMT_Encode4(315072), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6333*/ GIMT_Encode4(315132),
    /*GILLT_v2s64*//*Label 6334*/ GIMT_Encode4(315170),
    /*GILLT_v4s16*//*Label 6335*/ GIMT_Encode4(315208),
    /*GILLT_v4s32*//*Label 6336*/ GIMT_Encode4(315246), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6337*/ GIMT_Encode4(315284),
    // Label 6330: @314996
    GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(315033), // Rule ID 603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 603,
      GIR_Done,
    // Label 6339: @315033
    GIM_Reject,
    // Label 6331: @315034
    GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(315071), // Rule ID 605 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 605,
      GIR_Done,
    // Label 6340: @315071
    GIM_Reject,
    // Label 6332: @315072
    GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(315131),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(315114), // Rule ID 607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 607,
        GIR_Done,
      // Label 6342: @315114
      GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(315130), // Rule ID 4834 //
        // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4834,
        GIR_Done,
      // Label 6343: @315130
      GIM_Reject,
    // Label 6341: @315131
    GIM_Reject,
    // Label 6333: @315132
    GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(315169), // Rule ID 1261 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1261,
      GIR_Done,
    // Label 6344: @315169
    GIM_Reject,
    // Label 6334: @315170
    GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(315207), // Rule ID 1265 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1265,
      GIR_Done,
    // Label 6345: @315207
    GIM_Reject,
    // Label 6335: @315208
    GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(315245), // Rule ID 1257 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1257,
      GIR_Done,
    // Label 6346: @315245
    GIM_Reject,
    // Label 6336: @315246
    GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(315283), // Rule ID 1263 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1263,
      GIR_Done,
    // Label 6347: @315283
    GIM_Reject,
    // Label 6337: @315284
    GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(315321), // Rule ID 1259 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1259,
      GIR_Done,
    // Label 6348: @315321
    GIM_Reject,
    // Label 6338: @315322
    GIM_Reject,
    // Label 71: @315323
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6357*/ GIMT_Encode4(315700),
    /*GILLT_s16*//*Label 6349*/ GIMT_Encode4(315374),
    /*GILLT_s32*//*Label 6350*/ GIMT_Encode4(315412),
    /*GILLT_s64*//*Label 6351*/ GIMT_Encode4(315450), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6352*/ GIMT_Encode4(315510),
    /*GILLT_v2s64*//*Label 6353*/ GIMT_Encode4(315548),
    /*GILLT_v4s16*//*Label 6354*/ GIMT_Encode4(315586),
    /*GILLT_v4s32*//*Label 6355*/ GIMT_Encode4(315624), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6356*/ GIMT_Encode4(315662),
    // Label 6349: @315374
    GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(315411), // Rule ID 591 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 591,
      GIR_Done,
    // Label 6358: @315411
    GIM_Reject,
    // Label 6350: @315412
    GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(315449), // Rule ID 593 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 593,
      GIR_Done,
    // Label 6359: @315449
    GIM_Reject,
    // Label 6351: @315450
    GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(315509),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(315492), // Rule ID 595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 595,
        GIR_Done,
      // Label 6361: @315492
      GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(315508), // Rule ID 4833 //
        // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4833,
        GIR_Done,
      // Label 6362: @315508
      GIM_Reject,
    // Label 6360: @315509
    GIM_Reject,
    // Label 6352: @315510
    GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(315547), // Rule ID 1231 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1231,
      GIR_Done,
    // Label 6363: @315547
    GIM_Reject,
    // Label 6353: @315548
    GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(315585), // Rule ID 1235 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1235,
      GIR_Done,
    // Label 6364: @315585
    GIM_Reject,
    // Label 6354: @315586
    GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(315623), // Rule ID 1227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1227,
      GIR_Done,
    // Label 6365: @315623
    GIM_Reject,
    // Label 6355: @315624
    GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(315661), // Rule ID 1233 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1233,
      GIR_Done,
    // Label 6366: @315661
    GIM_Reject,
    // Label 6356: @315662
    GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(315699), // Rule ID 1229 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1229,
      GIR_Done,
    // Label 6367: @315699
    GIM_Reject,
    // Label 6357: @315700
    GIM_Reject,
    // Label 72: @315701
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6376*/ GIMT_Encode4(316050),
    /*GILLT_s16*//*Label 6368*/ GIMT_Encode4(315752),
    /*GILLT_s32*//*Label 6369*/ GIMT_Encode4(315790),
    /*GILLT_s64*//*Label 6370*/ GIMT_Encode4(315825), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6371*/ GIMT_Encode4(315860),
    /*GILLT_v2s64*//*Label 6372*/ GIMT_Encode4(315898),
    /*GILLT_v4s16*//*Label 6373*/ GIMT_Encode4(315936),
    /*GILLT_v4s32*//*Label 6374*/ GIMT_Encode4(315974), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6375*/ GIMT_Encode4(316012),
    // Label 6368: @315752
    GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(315789), // Rule ID 4841 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4841,
      GIR_Done,
    // Label 6377: @315789
    GIM_Reject,
    // Label 6369: @315790
    GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(315824), // Rule ID 4838 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4838,
      GIR_Done,
    // Label 6378: @315824
    GIM_Reject,
    // Label 6370: @315825
    GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(315859), // Rule ID 4835 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4835,
      GIR_Done,
    // Label 6379: @315859
    GIM_Reject,
    // Label 6371: @315860
    GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(315897), // Rule ID 5035 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5035,
      GIR_Done,
    // Label 6380: @315897
    GIM_Reject,
    // Label 6372: @315898
    GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(315935), // Rule ID 5029 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5029,
      GIR_Done,
    // Label 6381: @315935
    GIM_Reject,
    // Label 6373: @315936
    GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(315973), // Rule ID 5041 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5041,
      GIR_Done,
    // Label 6382: @315973
    GIM_Reject,
    // Label 6374: @315974
    GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(316011), // Rule ID 5032 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5032,
      GIR_Done,
    // Label 6383: @316011
    GIM_Reject,
    // Label 6375: @316012
    GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(316049), // Rule ID 5038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5038,
      GIR_Done,
    // Label 6384: @316049
    GIM_Reject,
    // Label 6376: @316050
    GIM_Reject,
    // Label 73: @316051
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6393*/ GIMT_Encode4(316400),
    /*GILLT_s16*//*Label 6385*/ GIMT_Encode4(316102),
    /*GILLT_s32*//*Label 6386*/ GIMT_Encode4(316140),
    /*GILLT_s64*//*Label 6387*/ GIMT_Encode4(316175), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6388*/ GIMT_Encode4(316210),
    /*GILLT_v2s64*//*Label 6389*/ GIMT_Encode4(316248),
    /*GILLT_v4s16*//*Label 6390*/ GIMT_Encode4(316286),
    /*GILLT_v4s32*//*Label 6391*/ GIMT_Encode4(316324), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6392*/ GIMT_Encode4(316362),
    // Label 6385: @316102
    GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(316139), // Rule ID 4842 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4842,
      GIR_Done,
    // Label 6394: @316139
    GIM_Reject,
    // Label 6386: @316140
    GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(316174), // Rule ID 4839 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4839,
      GIR_Done,
    // Label 6395: @316174
    GIM_Reject,
    // Label 6387: @316175
    GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(316209), // Rule ID 4836 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4836,
      GIR_Done,
    // Label 6396: @316209
    GIM_Reject,
    // Label 6388: @316210
    GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(316247), // Rule ID 5036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5036,
      GIR_Done,
    // Label 6397: @316247
    GIM_Reject,
    // Label 6389: @316248
    GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(316285), // Rule ID 5030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5030,
      GIR_Done,
    // Label 6398: @316285
    GIM_Reject,
    // Label 6390: @316286
    GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(316323), // Rule ID 5042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5042,
      GIR_Done,
    // Label 6399: @316323
    GIM_Reject,
    // Label 6391: @316324
    GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(316361), // Rule ID 5033 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5033,
      GIR_Done,
    // Label 6400: @316361
    GIM_Reject,
    // Label 6392: @316362
    GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(316399), // Rule ID 5039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5039,
      GIR_Done,
    // Label 6401: @316399
    GIM_Reject,
    // Label 6393: @316400
    GIM_Reject,
    // Label 74: @316401
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6410*/ GIMT_Encode4(317103),
    /*GILLT_s16*//*Label 6402*/ GIMT_Encode4(316452),
    /*GILLT_s32*//*Label 6403*/ GIMT_Encode4(316490),
    /*GILLT_s64*//*Label 6404*/ GIMT_Encode4(316528), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6405*/ GIMT_Encode4(316588),
    /*GILLT_v2s64*//*Label 6406*/ GIMT_Encode4(316691),
    /*GILLT_v4s16*//*Label 6407*/ GIMT_Encode4(316794),
    /*GILLT_v4s32*//*Label 6408*/ GIMT_Encode4(316897), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6409*/ GIMT_Encode4(317000),
    // Label 6402: @316452
    GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(316489), // Rule ID 609 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 609,
      GIR_Done,
    // Label 6411: @316489
    GIM_Reject,
    // Label 6403: @316490
    GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(316527), // Rule ID 611 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 611,
      GIR_Done,
    // Label 6412: @316527
    GIM_Reject,
    // Label 6404: @316528
    GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(316587),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(316570), // Rule ID 613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 613,
        GIR_Done,
      // Label 6414: @316570
      GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(316586), // Rule ID 4832 //
        // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4832,
        GIR_Done,
      // Label 6415: @316586
      GIM_Reject,
    // Label 6413: @316587
    GIM_Reject,
    // Label 6405: @316588
    GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(316690),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(316662), // Rule ID 2352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2352,
        GIR_EraseRootFromParent_Done,
      // Label 6417: @316662
      GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(316689), // Rule ID 1276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1276,
        GIR_Done,
      // Label 6418: @316689
      GIM_Reject,
    // Label 6416: @316690
    GIM_Reject,
    // Label 6406: @316691
    GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(316793),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(316765), // Rule ID 2358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2358,
        GIR_EraseRootFromParent_Done,
      // Label 6420: @316765
      GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(316792), // Rule ID 1280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1280,
        GIR_Done,
      // Label 6421: @316792
      GIM_Reject,
    // Label 6419: @316793
    GIM_Reject,
    // Label 6407: @316794
    GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(316896),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(316868), // Rule ID 2346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2346,
        GIR_EraseRootFromParent_Done,
      // Label 6423: @316868
      GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(316895), // Rule ID 1272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1272,
        GIR_Done,
      // Label 6424: @316895
      GIM_Reject,
    // Label 6422: @316896
    GIM_Reject,
    // Label 6408: @316897
    GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(316999),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(316971), // Rule ID 2355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2355,
        GIR_EraseRootFromParent_Done,
      // Label 6426: @316971
      GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(316998), // Rule ID 1278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1278,
        GIR_Done,
      // Label 6427: @316998
      GIM_Reject,
    // Label 6425: @316999
    GIM_Reject,
    // Label 6409: @317000
    GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(317102),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(317074), // Rule ID 2349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2349,
        GIR_EraseRootFromParent_Done,
      // Label 6429: @317074
      GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(317101), // Rule ID 1274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1274,
        GIR_Done,
      // Label 6430: @317101
      GIM_Reject,
    // Label 6428: @317102
    GIM_Reject,
    // Label 6410: @317103
    GIM_Reject,
    // Label 75: @317104
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6439*/ GIMT_Encode4(317806),
    /*GILLT_s16*//*Label 6431*/ GIMT_Encode4(317155),
    /*GILLT_s32*//*Label 6432*/ GIMT_Encode4(317193),
    /*GILLT_s64*//*Label 6433*/ GIMT_Encode4(317231), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6434*/ GIMT_Encode4(317291),
    /*GILLT_v2s64*//*Label 6435*/ GIMT_Encode4(317394),
    /*GILLT_v4s16*//*Label 6436*/ GIMT_Encode4(317497),
    /*GILLT_v4s32*//*Label 6437*/ GIMT_Encode4(317600), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6438*/ GIMT_Encode4(317703),
    // Label 6431: @317155
    GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(317192), // Rule ID 597 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 597,
      GIR_Done,
    // Label 6440: @317192
    GIM_Reject,
    // Label 6432: @317193
    GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(317230), // Rule ID 599 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 599,
      GIR_Done,
    // Label 6441: @317230
    GIM_Reject,
    // Label 6433: @317231
    GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(317290),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(317273), // Rule ID 601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 601,
        GIR_Done,
      // Label 6443: @317273
      GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(317289), // Rule ID 4831 //
        // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4831,
        GIR_Done,
      // Label 6444: @317289
      GIM_Reject,
    // Label 6442: @317290
    GIM_Reject,
    // Label 6434: @317291
    GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(317393),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(317365), // Rule ID 2337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2337,
        GIR_EraseRootFromParent_Done,
      // Label 6446: @317365
      GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(317392), // Rule ID 1246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1246,
        GIR_Done,
      // Label 6447: @317392
      GIM_Reject,
    // Label 6445: @317393
    GIM_Reject,
    // Label 6435: @317394
    GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(317496),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(317468), // Rule ID 2343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2343,
        GIR_EraseRootFromParent_Done,
      // Label 6449: @317468
      GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(317495), // Rule ID 1250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1250,
        GIR_Done,
      // Label 6450: @317495
      GIM_Reject,
    // Label 6448: @317496
    GIM_Reject,
    // Label 6436: @317497
    GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(317599),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(317571), // Rule ID 2331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2331,
        GIR_EraseRootFromParent_Done,
      // Label 6452: @317571
      GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(317598), // Rule ID 1242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1242,
        GIR_Done,
      // Label 6453: @317598
      GIM_Reject,
    // Label 6451: @317599
    GIM_Reject,
    // Label 6437: @317600
    GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(317702),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(317674), // Rule ID 2340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2340,
        GIR_EraseRootFromParent_Done,
      // Label 6455: @317674
      GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(317701), // Rule ID 1248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1248,
        GIR_Done,
      // Label 6456: @317701
      GIM_Reject,
    // Label 6454: @317702
    GIM_Reject,
    // Label 6438: @317703
    GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(317805),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(317777), // Rule ID 2334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2334,
        GIR_EraseRootFromParent_Done,
      // Label 6458: @317777
      GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(317804), // Rule ID 1244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1244,
        GIR_Done,
      // Label 6459: @317804
      GIM_Reject,
    // Label 6457: @317805
    GIM_Reject,
    // Label 6439: @317806
    GIM_Reject,
    // Label 76: @317807
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6468*/ GIMT_Encode4(318210),
    /*GILLT_s32*//*Label 6460*/ GIMT_Encode4(317858),
    /*GILLT_s64*//*Label 6461*/ GIMT_Encode4(317932), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6462*/ GIMT_Encode4(318006), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6463*/ GIMT_Encode4(318040),
    /*GILLT_v4s32*//*Label 6464*/ GIMT_Encode4(318074),
    /*GILLT_v8s8*//*Label 6465*/ GIMT_Encode4(318108),
    /*GILLT_v8s16*//*Label 6466*/ GIMT_Encode4(318142),
    /*GILLT_v16s8*//*Label 6467*/ GIMT_Encode4(318176),
    // Label 6460: @317858
    GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(317931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(317911), // Rule ID 2314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2314,
        GIR_EraseRootFromParent_Done,
      // Label 6470: @317911
      GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(317930), // Rule ID 2313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2313,
        GIR_Done,
      // Label 6471: @317930
      GIM_Reject,
    // Label 6469: @317931
    GIM_Reject,
    // Label 6461: @317932
    GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(318005),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(317985), // Rule ID 2316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2316,
        GIR_EraseRootFromParent_Done,
      // Label 6473: @317985
      GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(318004), // Rule ID 2315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2315,
        GIR_Done,
      // Label 6474: @318004
      GIM_Reject,
    // Label 6472: @318005
    GIM_Reject,
    // Label 6462: @318006
    GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(318039), // Rule ID 1402 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1402,
      GIR_Done,
    // Label 6475: @318039
    GIM_Reject,
    // Label 6463: @318040
    GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(318073), // Rule ID 1400 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1400,
      GIR_Done,
    // Label 6476: @318073
    GIM_Reject,
    // Label 6464: @318074
    GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(318107), // Rule ID 1403 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1403,
      GIR_Done,
    // Label 6477: @318107
    GIM_Reject,
    // Label 6465: @318108
    GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(318141), // Rule ID 1398 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1398,
      GIR_Done,
    // Label 6478: @318141
    GIM_Reject,
    // Label 6466: @318142
    GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(318175), // Rule ID 1401 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1401,
      GIR_Done,
    // Label 6479: @318175
    GIM_Reject,
    // Label 6467: @318176
    GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(318209), // Rule ID 1399 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1399,
      GIR_Done,
    // Label 6480: @318209
    GIM_Reject,
    // Label 6468: @318210
    GIM_Reject,
    // Label 77: @318211
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6489*/ GIMT_Encode4(318614),
    /*GILLT_s32*//*Label 6481*/ GIMT_Encode4(318262),
    /*GILLT_s64*//*Label 6482*/ GIMT_Encode4(318336), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6483*/ GIMT_Encode4(318410), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6484*/ GIMT_Encode4(318444),
    /*GILLT_v4s32*//*Label 6485*/ GIMT_Encode4(318478),
    /*GILLT_v8s8*//*Label 6486*/ GIMT_Encode4(318512),
    /*GILLT_v8s16*//*Label 6487*/ GIMT_Encode4(318546),
    /*GILLT_v16s8*//*Label 6488*/ GIMT_Encode4(318580),
    // Label 6481: @318262
    GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(318335),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(318315), // Rule ID 2310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2310,
        GIR_EraseRootFromParent_Done,
      // Label 6491: @318315
      GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(318334), // Rule ID 2309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2309,
        GIR_Done,
      // Label 6492: @318334
      GIM_Reject,
    // Label 6490: @318335
    GIM_Reject,
    // Label 6482: @318336
    GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(318409),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(318389), // Rule ID 2312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2312,
        GIR_EraseRootFromParent_Done,
      // Label 6494: @318389
      GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(318408), // Rule ID 2311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2311,
        GIR_Done,
      // Label 6495: @318408
      GIM_Reject,
    // Label 6493: @318409
    GIM_Reject,
    // Label 6483: @318410
    GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(318443), // Rule ID 1390 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1390,
      GIR_Done,
    // Label 6496: @318443
    GIM_Reject,
    // Label 6484: @318444
    GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(318477), // Rule ID 1388 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1388,
      GIR_Done,
    // Label 6497: @318477
    GIM_Reject,
    // Label 6485: @318478
    GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(318511), // Rule ID 1391 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1391,
      GIR_Done,
    // Label 6498: @318511
    GIM_Reject,
    // Label 6486: @318512
    GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(318545), // Rule ID 1386 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1386,
      GIR_Done,
    // Label 6499: @318545
    GIM_Reject,
    // Label 6487: @318546
    GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(318579), // Rule ID 1389 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1389,
      GIR_Done,
    // Label 6500: @318579
    GIM_Reject,
    // Label 6488: @318580
    GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(318613), // Rule ID 1387 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1387,
      GIR_Done,
    // Label 6501: @318613
    GIM_Reject,
    // Label 6489: @318614
    GIM_Reject,
    // Label 78: @318615
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6510*/ GIMT_Encode4(319018),
    /*GILLT_s32*//*Label 6502*/ GIMT_Encode4(318666),
    /*GILLT_s64*//*Label 6503*/ GIMT_Encode4(318740), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6504*/ GIMT_Encode4(318814), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6505*/ GIMT_Encode4(318848),
    /*GILLT_v4s32*//*Label 6506*/ GIMT_Encode4(318882),
    /*GILLT_v8s8*//*Label 6507*/ GIMT_Encode4(318916),
    /*GILLT_v8s16*//*Label 6508*/ GIMT_Encode4(318950),
    /*GILLT_v16s8*//*Label 6509*/ GIMT_Encode4(318984),
    // Label 6502: @318666
    GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(318739),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(318719), // Rule ID 2322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2322,
        GIR_EraseRootFromParent_Done,
      // Label 6512: @318719
      GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(318738), // Rule ID 2321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2321,
        GIR_Done,
      // Label 6513: @318738
      GIM_Reject,
    // Label 6511: @318739
    GIM_Reject,
    // Label 6503: @318740
    GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(318813),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(318793), // Rule ID 2324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2324,
        GIR_EraseRootFromParent_Done,
      // Label 6515: @318793
      GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(318812), // Rule ID 2323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2323,
        GIR_Done,
      // Label 6516: @318812
      GIM_Reject,
    // Label 6514: @318813
    GIM_Reject,
    // Label 6504: @318814
    GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(318847), // Rule ID 1525 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1525,
      GIR_Done,
    // Label 6517: @318847
    GIM_Reject,
    // Label 6505: @318848
    GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(318881), // Rule ID 1523 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1523,
      GIR_Done,
    // Label 6518: @318881
    GIM_Reject,
    // Label 6506: @318882
    GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(318915), // Rule ID 1526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1526,
      GIR_Done,
    // Label 6519: @318915
    GIM_Reject,
    // Label 6507: @318916
    GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(318949), // Rule ID 1521 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1521,
      GIR_Done,
    // Label 6520: @318949
    GIM_Reject,
    // Label 6508: @318950
    GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(318983), // Rule ID 1524 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1524,
      GIR_Done,
    // Label 6521: @318983
    GIM_Reject,
    // Label 6509: @318984
    GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(319017), // Rule ID 1522 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1522,
      GIR_Done,
    // Label 6522: @319017
    GIM_Reject,
    // Label 6510: @319018
    GIM_Reject,
    // Label 79: @319019
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6531*/ GIMT_Encode4(319422),
    /*GILLT_s32*//*Label 6523*/ GIMT_Encode4(319070),
    /*GILLT_s64*//*Label 6524*/ GIMT_Encode4(319144), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6525*/ GIMT_Encode4(319218), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6526*/ GIMT_Encode4(319252),
    /*GILLT_v4s32*//*Label 6527*/ GIMT_Encode4(319286),
    /*GILLT_v8s8*//*Label 6528*/ GIMT_Encode4(319320),
    /*GILLT_v8s16*//*Label 6529*/ GIMT_Encode4(319354),
    /*GILLT_v16s8*//*Label 6530*/ GIMT_Encode4(319388),
    // Label 6523: @319070
    GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(319143),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(319123), // Rule ID 2318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2318,
        GIR_EraseRootFromParent_Done,
      // Label 6533: @319123
      GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(319142), // Rule ID 2317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2317,
        GIR_Done,
      // Label 6534: @319142
      GIM_Reject,
    // Label 6532: @319143
    GIM_Reject,
    // Label 6524: @319144
    GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(319217),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(319197), // Rule ID 2320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2320,
        GIR_EraseRootFromParent_Done,
      // Label 6536: @319197
      GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(319216), // Rule ID 2319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2319,
        GIR_Done,
      // Label 6537: @319216
      GIM_Reject,
    // Label 6535: @319217
    GIM_Reject,
    // Label 6525: @319218
    GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(319251), // Rule ID 1513 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1513,
      GIR_Done,
    // Label 6538: @319251
    GIM_Reject,
    // Label 6526: @319252
    GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(319285), // Rule ID 1511 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1511,
      GIR_Done,
    // Label 6539: @319285
    GIM_Reject,
    // Label 6527: @319286
    GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(319319), // Rule ID 1514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1514,
      GIR_Done,
    // Label 6540: @319319
    GIM_Reject,
    // Label 6528: @319320
    GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(319353), // Rule ID 1509 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1509,
      GIR_Done,
    // Label 6541: @319353
    GIM_Reject,
    // Label 6529: @319354
    GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(319387), // Rule ID 1512 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1512,
      GIR_Done,
    // Label 6542: @319387
    GIM_Reject,
    // Label 6530: @319388
    GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(319421), // Rule ID 1510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1510,
      GIR_Done,
    // Label 6543: @319421
    GIM_Reject,
    // Label 6531: @319422
    GIM_Reject,
    // Label 80: @319423
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6553*/ GIMT_Encode4(320237),
    /*GILLT_s32*//*Label 6544*/ GIMT_Encode4(319474),
    /*GILLT_s64*//*Label 6545*/ GIMT_Encode4(319501), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6546*/ GIMT_Encode4(319580),
    /*GILLT_v2s64*//*Label 6547*/ GIMT_Encode4(319607),
    /*GILLT_v4s16*//*Label 6548*/ GIMT_Encode4(319790),
    /*GILLT_v4s32*//*Label 6549*/ GIMT_Encode4(319817),
    /*GILLT_v8s8*//*Label 6550*/ GIMT_Encode4(320000),
    /*GILLT_v8s16*//*Label 6551*/ GIMT_Encode4(320027),
    /*GILLT_v16s8*//*Label 6552*/ GIMT_Encode4(320210),
    // Label 6544: @319474
    GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(319500), // Rule ID 2303 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2303,
      GIR_Done,
    // Label 6554: @319500
    GIM_Reject,
    // Label 6545: @319501
    GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(319579),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(319532), // Rule ID 1640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1640,
        GIR_Done,
      // Label 6556: @319532
      GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(319555), // Rule ID 2304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2304,
        GIR_Done,
      // Label 6557: @319555
      GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(319578), // Rule ID 2478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2478,
        GIR_Done,
      // Label 6558: @319578
      GIM_Reject,
    // Label 6555: @319579
    GIM_Reject,
    // Label 6546: @319580
    GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(319606), // Rule ID 702 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 702,
      GIR_Done,
    // Label 6559: @319606
    GIM_Reject,
    // Label 6547: @319607
    GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(319789),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(319697), // Rule ID 4911 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4911,
        GIR_EraseRootFromParent_Done,
      // Label 6561: @319697
      GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(319769), // Rule ID 4910 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4910,
        GIR_EraseRootFromParent_Done,
      // Label 6562: @319769
      GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(319788), // Rule ID 704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 704,
        GIR_Done,
      // Label 6563: @319788
      GIM_Reject,
    // Label 6560: @319789
    GIM_Reject,
    // Label 6548: @319790
    GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(319816), // Rule ID 700 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 700,
      GIR_Done,
    // Label 6564: @319816
    GIM_Reject,
    // Label 6549: @319817
    GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(319999),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(319907), // Rule ID 4909 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4909,
        GIR_EraseRootFromParent_Done,
      // Label 6566: @319907
      GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(319979), // Rule ID 4908 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4908,
        GIR_EraseRootFromParent_Done,
      // Label 6567: @319979
      GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(319998), // Rule ID 703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 703,
        GIR_Done,
      // Label 6568: @319998
      GIM_Reject,
    // Label 6565: @319999
    GIM_Reject,
    // Label 6550: @320000
    GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(320026), // Rule ID 698 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 698,
      GIR_Done,
    // Label 6569: @320026
    GIM_Reject,
    // Label 6551: @320027
    GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(320209),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(320117), // Rule ID 4907 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4907,
        GIR_EraseRootFromParent_Done,
      // Label 6571: @320117
      GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(320189), // Rule ID 4906 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4906,
        GIR_EraseRootFromParent_Done,
      // Label 6572: @320189
      GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(320208), // Rule ID 701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 701,
        GIR_Done,
      // Label 6573: @320208
      GIM_Reject,
    // Label 6570: @320209
    GIM_Reject,
    // Label 6552: @320210
    GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(320236), // Rule ID 699 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 699,
      GIR_Done,
    // Label 6574: @320236
    GIM_Reject,
    // Label 6553: @320237
    GIM_Reject,
    // Label 81: @320238
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6577*/ GIMT_Encode4(320403),
    /*GILLT_s32*//*Label 6575*/ GIMT_Encode4(320257),
    /*GILLT_s64*//*Label 6576*/ GIMT_Encode4(320330),
    // Label 6575: @320257
    GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(320283), // Rule ID 4752 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4752,
      GIR_Done,
    // Label 6578: @320283
    GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(320306), // Rule ID 4758 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4758,
      GIR_Done,
    // Label 6579: @320306
    GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(320329), // Rule ID 4760 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4760,
      GIR_Done,
    // Label 6580: @320329
    GIM_Reject,
    // Label 6576: @320330
    GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(320356), // Rule ID 4754 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4754,
      GIR_Done,
    // Label 6581: @320356
    GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(320379), // Rule ID 4762 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4762,
      GIR_Done,
    // Label 6582: @320379
    GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(320402), // Rule ID 4764 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4764,
      GIR_Done,
    // Label 6583: @320402
    GIM_Reject,
    // Label 6577: @320403
    GIM_Reject,
    // Label 82: @320404
    GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(320502),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6588*/ GIMT_Encode4(320501),
      /*GILLT_s16*//*Label 6585*/ GIMT_Encode4(320435),
      /*GILLT_s32*//*Label 6586*/ GIMT_Encode4(320459),
      /*GILLT_s64*//*Label 6587*/ GIMT_Encode4(320480),
      // Label 6585: @320435
      GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(320458), // Rule ID 4756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4756,
        GIR_Done,
      // Label 6589: @320458
      GIM_Reject,
      // Label 6586: @320459
      GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(320479), // Rule ID 4766 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4766,
        GIR_Done,
      // Label 6590: @320479
      GIM_Reject,
      // Label 6587: @320480
      GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(320500), // Rule ID 4768 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4768,
        GIR_Done,
      // Label 6591: @320500
      GIM_Reject,
      // Label 6588: @320501
      GIM_Reject,
    // Label 6584: @320502
    GIM_Reject,
    // Label 83: @320503
    GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(320518), // Rule ID 236 //
      // MIs[0] addr
      GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
      // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 236,
      GIR_Done,
    // Label 6592: @320518
    GIM_Reject,
    // Label 84: @320519
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6604*/ GIMT_Encode4(325974),
    /*GILLT_s64*//*Label 6593*/ GIMT_Encode4(320602), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6594*/ GIMT_Encode4(320884), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6595*/ GIMT_Encode4(321166), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 6596*/ GIMT_Encode4(321550), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s1*//*Label 6597*/ GIMT_Encode4(321730),
    /*GILLT_nxv2s1*//*Label 6598*/ GIMT_Encode4(323993),
    /*GILLT_nxv2s16*//*Label 6599*/ GIMT_Encode4(324848),
    /*GILLT_nxv2s32*//*Label 6600*/ GIMT_Encode4(325421), GIMT_Encode4(0),
    /*GILLT_nxv4s1*//*Label 6601*/ GIMT_Encode4(325491),
    /*GILLT_nxv4s16*//*Label 6602*/ GIMT_Encode4(325778), GIMT_Encode4(0),
    /*GILLT_nxv8s1*//*Label 6603*/ GIMT_Encode4(325904),
    // Label 6593: @320602
    GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(320883),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(320682), // Rule ID 5482 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5482,
        GIR_EraseRootFromParent_Done,
      // Label 6606: @320682
      GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(320746), // Rule ID 5487 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5487,
        GIR_EraseRootFromParent_Done,
      // Label 6607: @320746
      GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(320784), // Rule ID 7049 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7049,
        GIR_EraseRootFromParent_Done,
      // Label 6608: @320784
      GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(320822), // Rule ID 7050 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7050,
        GIR_EraseRootFromParent_Done,
      // Label 6609: @320822
      GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(320882), // Rule ID 7054 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7054,
        GIR_EraseRootFromParent_Done,
      // Label 6610: @320882
      GIM_Reject,
    // Label 6605: @320883
    GIM_Reject,
    // Label 6594: @320884
    GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(321165),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(320964), // Rule ID 5472 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
        // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5472,
        GIR_EraseRootFromParent_Done,
      // Label 6612: @320964
      GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(321028), // Rule ID 5477 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
        // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5477,
        GIR_EraseRootFromParent_Done,
      // Label 6613: @321028
      GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(321066), // Rule ID 7045 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7045,
        GIR_EraseRootFromParent_Done,
      // Label 6614: @321066
      GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(321104), // Rule ID 7048 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7048,
        GIR_EraseRootFromParent_Done,
      // Label 6615: @321104
      GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(321164), // Rule ID 7053 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7053,
        GIR_EraseRootFromParent_Done,
      // Label 6616: @321164
      GIM_Reject,
    // Label 6611: @321165
    GIM_Reject,
    // Label 6595: @321166
    GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(321549),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(321246), // Rule ID 5457 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5457,
        GIR_EraseRootFromParent_Done,
      // Label 6618: @321246
      GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(321310), // Rule ID 5462 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5462,
        GIR_EraseRootFromParent_Done,
      // Label 6619: @321310
      GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(321374), // Rule ID 5467 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5467,
        GIR_EraseRootFromParent_Done,
      // Label 6620: @321374
      GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(321412), // Rule ID 7043 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7043,
        GIR_EraseRootFromParent_Done,
      // Label 6621: @321412
      GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(321450), // Rule ID 7046 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7046,
        GIR_EraseRootFromParent_Done,
      // Label 6622: @321450
      GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(321488), // Rule ID 7047 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7047,
        GIR_EraseRootFromParent_Done,
      // Label 6623: @321488
      GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(321548), // Rule ID 7052 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7052,
        GIR_EraseRootFromParent_Done,
      // Label 6624: @321548
      GIM_Reject,
    // Label 6617: @321549
    GIM_Reject,
    // Label 6596: @321550
    GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(321729),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(321630), // Rule ID 5452 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5452,
        GIR_EraseRootFromParent_Done,
      // Label 6626: @321630
      GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(321668), // Rule ID 7044 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7044,
        GIR_EraseRootFromParent_Done,
      // Label 6627: @321668
      GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(321728), // Rule ID 7051 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7051,
        GIR_EraseRootFromParent_Done,
      // Label 6628: @321728
      GIM_Reject,
    // Label 6625: @321729
    GIM_Reject,
    // Label 6597: @321730
    GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(321765), // Rule ID 9160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9160,
      GIR_EraseRootFromParent_Done,
    // Label 6629: @321765
    GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(321800), // Rule ID 9161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9161,
      GIR_EraseRootFromParent_Done,
    // Label 6630: @321800
    GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(321854), // Rule ID 9168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9168,
      GIR_EraseRootFromParent_Done,
    // Label 6631: @321854
    GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(321908), // Rule ID 9169 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9169,
      GIR_EraseRootFromParent_Done,
    // Label 6632: @321908
    GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(321962), // Rule ID 9170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9170,
      GIR_EraseRootFromParent_Done,
    // Label 6633: @321962
    GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(322016), // Rule ID 9171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9171,
      GIR_EraseRootFromParent_Done,
    // Label 6634: @322016
    GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(322087), // Rule ID 9180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9180,
      GIR_EraseRootFromParent_Done,
    // Label 6635: @322087
    GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(322158), // Rule ID 9181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9181,
      GIR_EraseRootFromParent_Done,
    // Label 6636: @322158
    GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(322229), // Rule ID 9182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9182,
      GIR_EraseRootFromParent_Done,
    // Label 6637: @322229
    GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(322300), // Rule ID 9183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9183,
      GIR_EraseRootFromParent_Done,
    // Label 6638: @322300
    GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(322371), // Rule ID 9184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9184,
      GIR_EraseRootFromParent_Done,
    // Label 6639: @322371
    GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(322442), // Rule ID 9185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9185,
      GIR_EraseRootFromParent_Done,
    // Label 6640: @322442
    GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(322513), // Rule ID 9186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9186,
      GIR_EraseRootFromParent_Done,
    // Label 6641: @322513
    GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(322584), // Rule ID 9187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9187,
      GIR_EraseRootFromParent_Done,
    // Label 6642: @322584
    GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(322672), // Rule ID 9196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9196,
      GIR_EraseRootFromParent_Done,
    // Label 6643: @322672
    GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(322760), // Rule ID 9197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9197,
      GIR_EraseRootFromParent_Done,
    // Label 6644: @322760
    GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(322848), // Rule ID 9198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9198,
      GIR_EraseRootFromParent_Done,
    // Label 6645: @322848
    GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(322936), // Rule ID 9199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9199,
      GIR_EraseRootFromParent_Done,
    // Label 6646: @322936
    GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(323024), // Rule ID 9200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9200,
      GIR_EraseRootFromParent_Done,
    // Label 6647: @323024
    GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(323112), // Rule ID 9201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9201,
      GIR_EraseRootFromParent_Done,
    // Label 6648: @323112
    GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(323200), // Rule ID 9202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9202,
      GIR_EraseRootFromParent_Done,
    // Label 6649: @323200
    GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(323288), // Rule ID 9203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9203,
      GIR_EraseRootFromParent_Done,
    // Label 6650: @323288
    GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(323376), // Rule ID 9204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9204,
      GIR_EraseRootFromParent_Done,
    // Label 6651: @323376
    GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(323464), // Rule ID 9205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9205,
      GIR_EraseRootFromParent_Done,
    // Label 6652: @323464
    GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(323552), // Rule ID 9206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9206,
      GIR_EraseRootFromParent_Done,
    // Label 6653: @323552
    GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(323640), // Rule ID 9207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9207,
      GIR_EraseRootFromParent_Done,
    // Label 6654: @323640
    GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(323728), // Rule ID 9208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9208,
      GIR_EraseRootFromParent_Done,
    // Label 6655: @323728
    GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(323816), // Rule ID 9209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9209,
      GIR_EraseRootFromParent_Done,
    // Label 6656: @323816
    GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(323904), // Rule ID 9210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9210,
      GIR_EraseRootFromParent_Done,
    // Label 6657: @323904
    GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(323992), // Rule ID 9211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9211,
      GIR_EraseRootFromParent_Done,
    // Label 6658: @323992
    GIM_Reject,
    // Label 6598: @323993
    GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(324028), // Rule ID 9162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9162,
      GIR_EraseRootFromParent_Done,
    // Label 6659: @324028
    GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(324063), // Rule ID 9163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9163,
      GIR_EraseRootFromParent_Done,
    // Label 6660: @324063
    GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(324117), // Rule ID 9172 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9172,
      GIR_EraseRootFromParent_Done,
    // Label 6661: @324117
    GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(324171), // Rule ID 9173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9173,
      GIR_EraseRootFromParent_Done,
    // Label 6662: @324171
    GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(324225), // Rule ID 9174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9174,
      GIR_EraseRootFromParent_Done,
    // Label 6663: @324225
    GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(324279), // Rule ID 9175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9175,
      GIR_EraseRootFromParent_Done,
    // Label 6664: @324279
    GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(324350), // Rule ID 9188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9188,
      GIR_EraseRootFromParent_Done,
    // Label 6665: @324350
    GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(324421), // Rule ID 9189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9189,
      GIR_EraseRootFromParent_Done,
    // Label 6666: @324421
    GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(324492), // Rule ID 9190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9190,
      GIR_EraseRootFromParent_Done,
    // Label 6667: @324492
    GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(324563), // Rule ID 9191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9191,
      GIR_EraseRootFromParent_Done,
    // Label 6668: @324563
    GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(324634), // Rule ID 9192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9192,
      GIR_EraseRootFromParent_Done,
    // Label 6669: @324634
    GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(324705), // Rule ID 9193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9193,
      GIR_EraseRootFromParent_Done,
    // Label 6670: @324705
    GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(324776), // Rule ID 9194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9194,
      GIR_EraseRootFromParent_Done,
    // Label 6671: @324776
    GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(324847), // Rule ID 9195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9195,
      GIR_EraseRootFromParent_Done,
    // Label 6672: @324847
    GIM_Reject,
    // Label 6599: @324848
    GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(324883), // Rule ID 9212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9212,
      GIR_EraseRootFromParent_Done,
    // Label 6673: @324883
    GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(324918), // Rule ID 9213 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9213,
      GIR_EraseRootFromParent_Done,
    // Label 6674: @324918
    GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(324953), // Rule ID 9218 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2bf16] } ZPR:{ *:[nxv4bf16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9218,
      GIR_EraseRootFromParent_Done,
    // Label 6675: @324953
    GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(324988), // Rule ID 9219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2bf16] } ZPR:{ *:[nxv4bf16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9219,
      GIR_EraseRootFromParent_Done,
    // Label 6676: @324988
    GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(325042), // Rule ID 9222 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9222,
      GIR_EraseRootFromParent_Done,
    // Label 6677: @325042
    GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(325096), // Rule ID 9223 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9223,
      GIR_EraseRootFromParent_Done,
    // Label 6678: @325096
    GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(325150), // Rule ID 9224 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9224,
      GIR_EraseRootFromParent_Done,
    // Label 6679: @325150
    GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(325204), // Rule ID 9225 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9225,
      GIR_EraseRootFromParent_Done,
    // Label 6680: @325204
    GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(325258), // Rule ID 9226 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2bf16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9226,
      GIR_EraseRootFromParent_Done,
    // Label 6681: @325258
    GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(325312), // Rule ID 9227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2bf16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9227,
      GIR_EraseRootFromParent_Done,
    // Label 6682: @325312
    GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(325366), // Rule ID 9228 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2bf16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9228,
      GIR_EraseRootFromParent_Done,
    // Label 6683: @325366
    GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(325420), // Rule ID 9229 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2bf16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9229,
      GIR_EraseRootFromParent_Done,
    // Label 6684: @325420
    GIM_Reject,
    // Label 6600: @325421
    GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(325490),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(325461), // Rule ID 9216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9216,
        GIR_EraseRootFromParent_Done,
      // Label 6686: @325461
      GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(325489), // Rule ID 9217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
        // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9217,
        GIR_EraseRootFromParent_Done,
      // Label 6687: @325489
      GIM_Reject,
    // Label 6685: @325490
    GIM_Reject,
    // Label 6601: @325491
    GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(325526), // Rule ID 9164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9164,
      GIR_EraseRootFromParent_Done,
    // Label 6688: @325526
    GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(325561), // Rule ID 9165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9165,
      GIR_EraseRootFromParent_Done,
    // Label 6689: @325561
    GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(325615), // Rule ID 9176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9176,
      GIR_EraseRootFromParent_Done,
    // Label 6690: @325615
    GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(325669), // Rule ID 9177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9177,
      GIR_EraseRootFromParent_Done,
    // Label 6691: @325669
    GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(325723), // Rule ID 9178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9178,
      GIR_EraseRootFromParent_Done,
    // Label 6692: @325723
    GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(325777), // Rule ID 9179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9179,
      GIR_EraseRootFromParent_Done,
    // Label 6693: @325777
    GIM_Reject,
    // Label 6602: @325778
    GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(325903),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(325818), // Rule ID 9214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9214,
        GIR_EraseRootFromParent_Done,
      // Label 6695: @325818
      GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(325846), // Rule ID 9215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9215,
        GIR_EraseRootFromParent_Done,
      // Label 6696: @325846
      GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(325874), // Rule ID 9220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv4bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4bf16] } ZPR:{ *:[nxv8bf16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9220,
        GIR_EraseRootFromParent_Done,
      // Label 6697: @325874
      GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(325902), // Rule ID 9221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[nxv4bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4bf16] } ZPR:{ *:[nxv8bf16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9221,
        GIR_EraseRootFromParent_Done,
      // Label 6698: @325902
      GIM_Reject,
    // Label 6694: @325903
    GIM_Reject,
    // Label 6603: @325904
    GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(325973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(325944), // Rule ID 9166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9166,
        GIR_EraseRootFromParent_Done,
      // Label 6700: @325944
      GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(325972), // Rule ID 9167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9167,
        GIR_EraseRootFromParent_Done,
      // Label 6701: @325972
      GIM_Reject,
    // Label 6699: @325973
    GIM_Reject,
    // Label 6604: @325974
    GIM_Reject,
    // Label 85: @325975
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6717*/ GIMT_Encode4(357967),
    /*GILLT_s64*//*Label 6702*/ GIMT_Encode4(326070), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6703*/ GIMT_Encode4(326804),
    /*GILLT_v2s64*//*Label 6704*/ GIMT_Encode4(330451),
    /*GILLT_v4s16*//*Label 6705*/ GIMT_Encode4(333280),
    /*GILLT_v4s32*//*Label 6706*/ GIMT_Encode4(338629),
    /*GILLT_v8s8*//*Label 6707*/ GIMT_Encode4(341293),
    /*GILLT_v8s16*//*Label 6708*/ GIMT_Encode4(343137),
    /*GILLT_v16s8*//*Label 6709*/ GIMT_Encode4(347550), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 6710*/ GIMT_Encode4(349130),
    /*GILLT_nxv2s32*//*Label 6711*/ GIMT_Encode4(349364),
    /*GILLT_nxv2s64*//*Label 6712*/ GIMT_Encode4(349489), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 6713*/ GIMT_Encode4(351403),
    /*GILLT_nxv4s32*//*Label 6714*/ GIMT_Encode4(351691), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 6715*/ GIMT_Encode4(353659), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 6716*/ GIMT_Encode4(356917),
    // Label 6702: @326070
    GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(326803),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(326218), // Rule ID 5797 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5797,
        GIR_EraseRootFromParent_Done,
      // Label 6719: @326218
      GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(326383), // Rule ID 5798 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5798,
        GIR_EraseRootFromParent_Done,
      // Label 6720: @326383
      GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(326517), // Rule ID 5821 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5821,
        GIR_EraseRootFromParent_Done,
      // Label 6721: @326517
      GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(326682), // Rule ID 5822 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5822,
        GIR_EraseRootFromParent_Done,
      // Label 6722: @326682
      GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(326722), // Rule ID 6770 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Xn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 6770,
        GIR_EraseRootFromParent_Done,
      // Label 6723: @326722
      GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(326762), // Rule ID 6772 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Xn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 6772,
        GIR_EraseRootFromParent_Done,
      // Label 6724: @326762
      GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(326802), // Rule ID 6774 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/2, // Xn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 6774,
        GIR_EraseRootFromParent_Done,
      // Label 6725: @326802
      GIM_Reject,
    // Label 6718: @326803
    GIM_Reject,
    // Label 6703: @326804
    GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(330450),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(326931), // Rule ID 4247 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4247,
        GIR_EraseRootFromParent_Done,
      // Label 6727: @326931
      GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(327044), // Rule ID 4248 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4248,
        GIR_EraseRootFromParent_Done,
      // Label 6728: @327044
      GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(327157), // Rule ID 4391 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4391,
        GIR_EraseRootFromParent_Done,
      // Label 6729: @327157
      GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(327270), // Rule ID 4392 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4392,
        GIR_EraseRootFromParent_Done,
      // Label 6730: @327270
      GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(327379), // Rule ID 4253 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4253,
        GIR_EraseRootFromParent_Done,
      // Label 6731: @327379
      GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(327488), // Rule ID 4255 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4255,
        GIR_EraseRootFromParent_Done,
      // Label 6732: @327488
      GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(327597), // Rule ID 4397 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4397,
        GIR_EraseRootFromParent_Done,
      // Label 6733: @327597
      GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(327706), // Rule ID 4399 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4399,
        GIR_EraseRootFromParent_Done,
      // Label 6734: @327706
      GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(327814), // Rule ID 4245 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4245,
        GIR_EraseRootFromParent_Done,
      // Label 6735: @327814
      GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(327922), // Rule ID 4246 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4246,
        GIR_EraseRootFromParent_Done,
      // Label 6736: @327922
      GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(328030), // Rule ID 4389 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4389,
        GIR_EraseRootFromParent_Done,
      // Label 6737: @328030
      GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(328138), // Rule ID 4390 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4390,
        GIR_EraseRootFromParent_Done,
      // Label 6738: @328138
      GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(328242), // Rule ID 4249 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4249,
        GIR_EraseRootFromParent_Done,
      // Label 6739: @328242
      GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(328346), // Rule ID 4251 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4251,
        GIR_EraseRootFromParent_Done,
      // Label 6740: @328346
      GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(328450), // Rule ID 4393 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4393,
        GIR_EraseRootFromParent_Done,
      // Label 6741: @328450
      GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(328554), // Rule ID 4395 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4395,
        GIR_EraseRootFromParent_Done,
      // Label 6742: @328554
      GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(328678), // Rule ID 6506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6506,
        GIR_EraseRootFromParent_Done,
      // Label 6743: @328678
      GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(328802), // Rule ID 6508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6508,
        GIR_EraseRootFromParent_Done,
      // Label 6744: @328802
      GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(328936), // Rule ID 5791 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5791,
        GIR_EraseRootFromParent_Done,
      // Label 6745: @328936
      GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(329101), // Rule ID 5792 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5792,
        GIR_EraseRootFromParent_Done,
      // Label 6746: @329101
      GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(329235), // Rule ID 5815 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5815,
        GIR_EraseRootFromParent_Done,
      // Label 6747: @329235
      GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(329400), // Rule ID 5816 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5816,
        GIR_EraseRootFromParent_Done,
      // Label 6748: @329400
      GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(329470), // Rule ID 5734 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5734,
        GIR_EraseRootFromParent_Done,
      // Label 6749: @329470
      GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(329540), // Rule ID 5750 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5750,
        GIR_EraseRootFromParent_Done,
      // Label 6750: @329540
      GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(329679), // Rule ID 5758 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5758,
        GIR_EraseRootFromParent_Done,
      // Label 6751: @329679
      GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(329815), // Rule ID 6514 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6514,
        GIR_EraseRootFromParent_Done,
      // Label 6752: @329815
      GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(329951), // Rule ID 6515 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6515,
        GIR_EraseRootFromParent_Done,
      // Label 6753: @329951
      GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(330138), // Rule ID 5824 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5824,
        GIR_EraseRootFromParent_Done,
      // Label 6754: @330138
      GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(330320), // Rule ID 5763 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5763,
        GIR_EraseRootFromParent_Done,
      // Label 6755: @330320
      GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(330449), // Rule ID 5766 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5766,
        GIR_EraseRootFromParent_Done,
      // Label 6756: @330449
      GIM_Reject,
    // Label 6726: @330450
    GIM_Reject,
    // Label 6704: @330451
    GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(333279),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(330578), // Rule ID 4271 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4271,
        GIR_EraseRootFromParent_Done,
      // Label 6758: @330578
      GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(330687), // Rule ID 4272 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4272,
        GIR_EraseRootFromParent_Done,
      // Label 6759: @330687
      GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(330796), // Rule ID 4415 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4415,
        GIR_EraseRootFromParent_Done,
      // Label 6760: @330796
      GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(330905), // Rule ID 4416 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4416,
        GIR_EraseRootFromParent_Done,
      // Label 6761: @330905
      GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(331010), // Rule ID 4277 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4277,
        GIR_EraseRootFromParent_Done,
      // Label 6762: @331010
      GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(331115), // Rule ID 4279 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4279,
        GIR_EraseRootFromParent_Done,
      // Label 6763: @331115
      GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(331220), // Rule ID 4421 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4421,
        GIR_EraseRootFromParent_Done,
      // Label 6764: @331220
      GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(331325), // Rule ID 4423 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4423,
        GIR_EraseRootFromParent_Done,
      // Label 6765: @331325
      GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(331429), // Rule ID 4269 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4269,
        GIR_EraseRootFromParent_Done,
      // Label 6766: @331429
      GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(331533), // Rule ID 4270 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4270,
        GIR_EraseRootFromParent_Done,
      // Label 6767: @331533
      GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(331637), // Rule ID 4413 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4413,
        GIR_EraseRootFromParent_Done,
      // Label 6768: @331637
      GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(331741), // Rule ID 4414 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4414,
        GIR_EraseRootFromParent_Done,
      // Label 6769: @331741
      GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(331841), // Rule ID 4273 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4273,
        GIR_EraseRootFromParent_Done,
      // Label 6770: @331841
      GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(331941), // Rule ID 4275 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4275,
        GIR_EraseRootFromParent_Done,
      // Label 6771: @331941
      GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(332041), // Rule ID 4417 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4417,
        GIR_EraseRootFromParent_Done,
      // Label 6772: @332041
      GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(332141), // Rule ID 4419 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4419,
        GIR_EraseRootFromParent_Done,
      // Label 6773: @332141
      GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(332219), // Rule ID 1929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1929,
        GIR_EraseRootFromParent_Done,
      // Label 6774: @332219
      GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(332310), // Rule ID 7556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15268>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7556,
        GIR_EraseRootFromParent_Done,
      // Label 6775: @332310
      GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(332377), // Rule ID 5795 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5795,
        GIR_EraseRootFromParent_Done,
      // Label 6776: @332377
      GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(332475), // Rule ID 5796 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5796,
        GIR_EraseRootFromParent_Done,
      // Label 6777: @332475
      GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(332542), // Rule ID 5819 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5819,
        GIR_EraseRootFromParent_Done,
      // Label 6778: @332542
      GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(332640), // Rule ID 5820 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5820,
        GIR_EraseRootFromParent_Done,
      // Label 6779: @332640
      GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(332706), // Rule ID 5738 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5738,
        GIR_EraseRootFromParent_Done,
      // Label 6780: @332706
      GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(332772), // Rule ID 5752 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5752,
        GIR_EraseRootFromParent_Done,
      // Label 6781: @332772
      GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(332850), // Rule ID 7555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15268>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7555,
        GIR_EraseRootFromParent_Done,
      // Label 6782: @332850
      GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(332919), // Rule ID 6496 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6496,
        GIR_EraseRootFromParent_Done,
      // Label 6783: @332919
      GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(332988), // Rule ID 6497 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6497,
        GIR_EraseRootFromParent_Done,
      // Label 6784: @332988
      GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(333037), // Rule ID 5759 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5759,
        GIR_EraseRootFromParent_Done,
      // Label 6785: @333037
      GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(333138), // Rule ID 5825 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5825,
        GIR_EraseRootFromParent_Done,
      // Label 6786: @333138
      GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(333182), // Rule ID 1925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1925,
        GIR_EraseRootFromParent_Done,
      // Label 6787: @333182
      GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(333278), // Rule ID 5765 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5765,
        GIR_EraseRootFromParent_Done,
      // Label 6788: @333278
      GIM_Reject,
    // Label 6757: @333279
    GIM_Reject,
    // Label 6705: @333280
    GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(338628),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(333407), // Rule ID 4319 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4319,
        GIR_EraseRootFromParent_Done,
      // Label 6790: @333407
      GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(333526), // Rule ID 4320 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4320,
        GIR_EraseRootFromParent_Done,
      // Label 6791: @333526
      GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(333645), // Rule ID 4355 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4355,
        GIR_EraseRootFromParent_Done,
      // Label 6792: @333645
      GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(333764), // Rule ID 4356 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4356,
        GIR_EraseRootFromParent_Done,
      // Label 6793: @333764
      GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(333890), // Rule ID 4211 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4211,
        GIR_EraseRootFromParent_Done,
      // Label 6794: @333890
      GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(334016), // Rule ID 4212 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4212,
        GIR_EraseRootFromParent_Done,
      // Label 6795: @334016
      GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(334131), // Rule ID 4325 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4325,
        GIR_EraseRootFromParent_Done,
      // Label 6796: @334131
      GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(334246), // Rule ID 4327 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4327,
        GIR_EraseRootFromParent_Done,
      // Label 6797: @334246
      GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(334361), // Rule ID 4361 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4361,
        GIR_EraseRootFromParent_Done,
      // Label 6798: @334361
      GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(334476), // Rule ID 4363 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4363,
        GIR_EraseRootFromParent_Done,
      // Label 6799: @334476
      GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(334598), // Rule ID 4217 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4217,
        GIR_EraseRootFromParent_Done,
      // Label 6800: @334598
      GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(334720), // Rule ID 4219 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4219,
        GIR_EraseRootFromParent_Done,
      // Label 6801: @334720
      GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(334834), // Rule ID 4317 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4317,
        GIR_EraseRootFromParent_Done,
      // Label 6802: @334834
      GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(334948), // Rule ID 4318 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4318,
        GIR_EraseRootFromParent_Done,
      // Label 6803: @334948
      GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(335062), // Rule ID 4353 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4353,
        GIR_EraseRootFromParent_Done,
      // Label 6804: @335062
      GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(335176), // Rule ID 4354 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4354,
        GIR_EraseRootFromParent_Done,
      // Label 6805: @335176
      GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(335297), // Rule ID 4209 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4209,
        GIR_EraseRootFromParent_Done,
      // Label 6806: @335297
      GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(335418), // Rule ID 4210 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4210,
        GIR_EraseRootFromParent_Done,
      // Label 6807: @335418
      GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(335528), // Rule ID 4321 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4321,
        GIR_EraseRootFromParent_Done,
      // Label 6808: @335528
      GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(335638), // Rule ID 4323 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4323,
        GIR_EraseRootFromParent_Done,
      // Label 6809: @335638
      GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(335748), // Rule ID 4357 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4357,
        GIR_EraseRootFromParent_Done,
      // Label 6810: @335748
      GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(335858), // Rule ID 4359 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4359,
        GIR_EraseRootFromParent_Done,
      // Label 6811: @335858
      GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(335975), // Rule ID 4213 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4213,
        GIR_EraseRootFromParent_Done,
      // Label 6812: @335975
      GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(336092), // Rule ID 4215 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4215,
        GIR_EraseRootFromParent_Done,
      // Label 6813: @336092
      GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(336222), // Rule ID 6510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6510,
        GIR_EraseRootFromParent_Done,
      // Label 6814: @336222
      GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(336362), // Rule ID 5779 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5779,
        GIR_EraseRootFromParent_Done,
      // Label 6815: @336362
      GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(336533), // Rule ID 5780 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5780,
        GIR_EraseRootFromParent_Done,
      // Label 6816: @336533
      GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(336673), // Rule ID 5785 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$src, (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5785,
        GIR_EraseRootFromParent_Done,
      // Label 6817: @336673
      GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(336844), // Rule ID 5786 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$src, (vector_extract:{ *:[bf16] } V64:{ *:[v4bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5786,
        GIR_EraseRootFromParent_Done,
      // Label 6818: @336844
      GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(336984), // Rule ID 5809 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5809,
        GIR_EraseRootFromParent_Done,
      // Label 6819: @336984
      GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(337155), // Rule ID 5810 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5810,
        GIR_EraseRootFromParent_Done,
      // Label 6820: @337155
      GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(337234), // Rule ID 5724 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5724,
        GIR_EraseRootFromParent_Done,
      // Label 6821: @337234
      GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(337310), // Rule ID 5726 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5726,
        GIR_EraseRootFromParent_Done,
      // Label 6822: @337310
      GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(337386), // Rule ID 5730 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4bf16] } (IMPLICIT_DEF:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5730,
        GIR_EraseRootFromParent_Done,
      // Label 6823: @337386
      GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(337462), // Rule ID 5740 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5740,
        GIR_EraseRootFromParent_Done,
      // Label 6824: @337462
      GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(337538), // Rule ID 5744 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4bf16] } (IMPLICIT_DEF:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5744,
        GIR_EraseRootFromParent_Done,
      // Label 6825: @337538
      GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(337683), // Rule ID 5756 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5756,
        GIR_EraseRootFromParent_Done,
      // Label 6826: @337683
      GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(337825), // Rule ID 6516 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6516,
        GIR_EraseRootFromParent_Done,
      // Label 6827: @337825
      GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(337967), // Rule ID 6517 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4bf16] } VecListOne64:{ *:[v4bf16] }:$Rd, (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4bf16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6517,
        GIR_EraseRootFromParent_Done,
      // Label 6828: @337967
      GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(338116), // Rule ID 6513 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6513,
        GIR_EraseRootFromParent_Done,
      // Label 6829: @338116
      GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(338304), // Rule ID 5754 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5754,
        GIR_EraseRootFromParent_Done,
      // Label 6830: @338304
      GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(338492), // Rule ID 5761 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, FPR16:{ *:[bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5761,
        GIR_EraseRootFromParent_Done,
      // Label 6831: @338492
      GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(338627), // Rule ID 5767 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5767,
        GIR_EraseRootFromParent_Done,
      // Label 6832: @338627
      GIM_Reject,
    // Label 6789: @338628
    GIM_Reject,
    // Label 6706: @338629
    GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(341292),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(338756), // Rule ID 4235 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4235,
        GIR_EraseRootFromParent_Done,
      // Label 6834: @338756
      GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(338865), // Rule ID 4236 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4236,
        GIR_EraseRootFromParent_Done,
      // Label 6835: @338865
      GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(338974), // Rule ID 4379 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4379,
        GIR_EraseRootFromParent_Done,
      // Label 6836: @338974
      GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(339083), // Rule ID 4380 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4380,
        GIR_EraseRootFromParent_Done,
      // Label 6837: @339083
      GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(339188), // Rule ID 4241 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4241,
        GIR_EraseRootFromParent_Done,
      // Label 6838: @339188
      GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(339293), // Rule ID 4243 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4243,
        GIR_EraseRootFromParent_Done,
      // Label 6839: @339293
      GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(339398), // Rule ID 4385 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4385,
        GIR_EraseRootFromParent_Done,
      // Label 6840: @339398
      GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(339503), // Rule ID 4387 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4387,
        GIR_EraseRootFromParent_Done,
      // Label 6841: @339503
      GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(339607), // Rule ID 4233 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4233,
        GIR_EraseRootFromParent_Done,
      // Label 6842: @339607
      GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(339711), // Rule ID 4234 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4234,
        GIR_EraseRootFromParent_Done,
      // Label 6843: @339711
      GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(339815), // Rule ID 4377 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4377,
        GIR_EraseRootFromParent_Done,
      // Label 6844: @339815
      GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(339919), // Rule ID 4378 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4378,
        GIR_EraseRootFromParent_Done,
      // Label 6845: @339919
      GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(340019), // Rule ID 4237 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4237,
        GIR_EraseRootFromParent_Done,
      // Label 6846: @340019
      GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(340119), // Rule ID 4239 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4239,
        GIR_EraseRootFromParent_Done,
      // Label 6847: @340119
      GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(340219), // Rule ID 4381 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4381,
        GIR_EraseRootFromParent_Done,
      // Label 6848: @340219
      GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(340319), // Rule ID 4383 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4383,
        GIR_EraseRootFromParent_Done,
      // Label 6849: @340319
      GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(340397), // Rule ID 1928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1928,
        GIR_EraseRootFromParent_Done,
      // Label 6850: @340397
      GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(340464), // Rule ID 5789 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5789,
        GIR_EraseRootFromParent_Done,
      // Label 6851: @340464
      GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(340562), // Rule ID 5790 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5790,
        GIR_EraseRootFromParent_Done,
      // Label 6852: @340562
      GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(340629), // Rule ID 5813 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5813,
        GIR_EraseRootFromParent_Done,
      // Label 6853: @340629
      GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(340727), // Rule ID 5814 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5814,
        GIR_EraseRootFromParent_Done,
      // Label 6854: @340727
      GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(340793), // Rule ID 5736 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5736,
        GIR_EraseRootFromParent_Done,
      // Label 6855: @340793
      GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(340859), // Rule ID 5748 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5748,
        GIR_EraseRootFromParent_Done,
      // Label 6856: @340859
      GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(340912), // Rule ID 5757 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5757,
        GIR_EraseRootFromParent_Done,
      // Label 6857: @340912
      GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(340981), // Rule ID 6494 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6494,
        GIR_EraseRootFromParent_Done,
      // Label 6858: @340981
      GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(341050), // Rule ID 6495 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6495,
        GIR_EraseRootFromParent_Done,
      // Label 6859: @341050
      GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(341151), // Rule ID 5823 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5823,
        GIR_EraseRootFromParent_Done,
      // Label 6860: @341151
      GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(341195), // Rule ID 1924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1924,
        GIR_EraseRootFromParent_Done,
      // Label 6861: @341195
      GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(341291), // Rule ID 5764 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5764,
        GIR_EraseRootFromParent_Done,
      // Label 6862: @341291
      GIM_Reject,
    // Label 6833: @341292
    GIM_Reject,
    // Label 6707: @341293
    GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(343136),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(341427), // Rule ID 4175 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4175,
        GIR_EraseRootFromParent_Done,
      // Label 6864: @341427
      GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(341553), // Rule ID 4176 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4176,
        GIR_EraseRootFromParent_Done,
      // Label 6865: @341553
      GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(341675), // Rule ID 4181 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4181,
        GIR_EraseRootFromParent_Done,
      // Label 6866: @341675
      GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(341797), // Rule ID 4183 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4183,
        GIR_EraseRootFromParent_Done,
      // Label 6867: @341797
      GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(341918), // Rule ID 4173 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4173,
        GIR_EraseRootFromParent_Done,
      // Label 6868: @341918
      GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(342039), // Rule ID 4174 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4174,
        GIR_EraseRootFromParent_Done,
      // Label 6869: @342039
      GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(342156), // Rule ID 4177 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4177,
        GIR_EraseRootFromParent_Done,
      // Label 6870: @342156
      GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(342273), // Rule ID 4179 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4179,
        GIR_EraseRootFromParent_Done,
      // Label 6871: @342273
      GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(342413), // Rule ID 5803 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5803,
        GIR_EraseRootFromParent_Done,
      // Label 6872: @342413
      GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(342584), // Rule ID 5804 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5804,
        GIR_EraseRootFromParent_Done,
      // Label 6873: @342584
      GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(342663), // Rule ID 5719 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5719,
        GIR_EraseRootFromParent_Done,
      // Label 6874: @342663
      GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(342812), // Rule ID 6512 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6512,
        GIR_EraseRootFromParent_Done,
      // Label 6875: @342812
      GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(342947), // Rule ID 5768 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5768,
        GIR_EraseRootFromParent_Done,
      // Label 6876: @342947
      GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(343135), // Rule ID 5769 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5769,
        GIR_EraseRootFromParent_Done,
      // Label 6877: @343135
      GIM_Reject,
    // Label 6863: @343136
    GIM_Reject,
    // Label 6708: @343137
    GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(347549),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(343264), // Rule ID 4307 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4307,
        GIR_EraseRootFromParent_Done,
      // Label 6879: @343264
      GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(343383), // Rule ID 4308 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4308,
        GIR_EraseRootFromParent_Done,
      // Label 6880: @343383
      GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(343502), // Rule ID 4343 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4343,
        GIR_EraseRootFromParent_Done,
      // Label 6881: @343502
      GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(343621), // Rule ID 4344 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4344,
        GIR_EraseRootFromParent_Done,
      // Label 6882: @343621
      GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(343747), // Rule ID 4199 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4199,
        GIR_EraseRootFromParent_Done,
      // Label 6883: @343747
      GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(343873), // Rule ID 4200 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4200,
        GIR_EraseRootFromParent_Done,
      // Label 6884: @343873
      GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(343988), // Rule ID 4313 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4313,
        GIR_EraseRootFromParent_Done,
      // Label 6885: @343988
      GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(344103), // Rule ID 4315 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4315,
        GIR_EraseRootFromParent_Done,
      // Label 6886: @344103
      GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(344218), // Rule ID 4349 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4349,
        GIR_EraseRootFromParent_Done,
      // Label 6887: @344218
      GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(344333), // Rule ID 4351 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4351,
        GIR_EraseRootFromParent_Done,
      // Label 6888: @344333
      GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(344455), // Rule ID 4205 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4205,
        GIR_EraseRootFromParent_Done,
      // Label 6889: @344455
      GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(344577), // Rule ID 4207 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4207,
        GIR_EraseRootFromParent_Done,
      // Label 6890: @344577
      GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(344691), // Rule ID 4305 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4305,
        GIR_EraseRootFromParent_Done,
      // Label 6891: @344691
      GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(344805), // Rule ID 4306 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4306,
        GIR_EraseRootFromParent_Done,
      // Label 6892: @344805
      GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(344919), // Rule ID 4341 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4341,
        GIR_EraseRootFromParent_Done,
      // Label 6893: @344919
      GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(345033), // Rule ID 4342 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4342,
        GIR_EraseRootFromParent_Done,
      // Label 6894: @345033
      GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(345154), // Rule ID 4197 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4197,
        GIR_EraseRootFromParent_Done,
      // Label 6895: @345154
      GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(345275), // Rule ID 4198 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4198,
        GIR_EraseRootFromParent_Done,
      // Label 6896: @345275
      GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(345385), // Rule ID 4309 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4309,
        GIR_EraseRootFromParent_Done,
      // Label 6897: @345385
      GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(345495), // Rule ID 4311 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4311,
        GIR_EraseRootFromParent_Done,
      // Label 6898: @345495
      GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(345605), // Rule ID 4345 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4345,
        GIR_EraseRootFromParent_Done,
      // Label 6899: @345605
      GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(345715), // Rule ID 4347 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4347,
        GIR_EraseRootFromParent_Done,
      // Label 6900: @345715
      GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(345832), // Rule ID 4201 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4201,
        GIR_EraseRootFromParent_Done,
      // Label 6901: @345832
      GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(345949), // Rule ID 4203 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4203,
        GIR_EraseRootFromParent_Done,
      // Label 6902: @345949
      GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(346037), // Rule ID 1927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1927,
        GIR_EraseRootFromParent_Done,
      // Label 6903: @346037
      GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(346114), // Rule ID 5777 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5777,
        GIR_EraseRootFromParent_Done,
      // Label 6904: @346114
      GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(346222), // Rule ID 5778 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5778,
        GIR_EraseRootFromParent_Done,
      // Label 6905: @346222
      GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(346299), // Rule ID 5783 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5783,
        GIR_EraseRootFromParent_Done,
      // Label 6906: @346299
      GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(346407), // Rule ID 5784 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (vector_extract:{ *:[bf16] } V64:{ *:[v4bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5784,
        GIR_EraseRootFromParent_Done,
      // Label 6907: @346407
      GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(346484), // Rule ID 5807 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5807,
        GIR_EraseRootFromParent_Done,
      // Label 6908: @346484
      GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(346592), // Rule ID 5808 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5808,
        GIR_EraseRootFromParent_Done,
      // Label 6909: @346592
      GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(346671), // Rule ID 5722 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5722,
        GIR_EraseRootFromParent_Done,
      // Label 6910: @346671
      GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(346747), // Rule ID 5728 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5728,
        GIR_EraseRootFromParent_Done,
      // Label 6911: @346747
      GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(346823), // Rule ID 5732 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5732,
        GIR_EraseRootFromParent_Done,
      // Label 6912: @346823
      GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(346899), // Rule ID 5742 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5742,
        GIR_EraseRootFromParent_Done,
      // Label 6913: @346899
      GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(346975), // Rule ID 5746 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5746,
        GIR_EraseRootFromParent_Done,
      // Label 6914: @346975
      GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(347038), // Rule ID 5755 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5755,
        GIR_EraseRootFromParent_Done,
      // Label 6915: @347038
      GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(347117), // Rule ID 6498 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6498,
        GIR_EraseRootFromParent_Done,
      // Label 6916: @347117
      GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(347196), // Rule ID 6499 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8bf16] } VecListOne128:{ *:[v8bf16] }:$Rd, (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8bf16] } VecListOne128:{ *:[v8bf16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6499,
        GIR_EraseRootFromParent_Done,
      // Label 6917: @347196
      GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(347282), // Rule ID 6493 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6493,
        GIR_EraseRootFromParent_Done,
      // Label 6918: @347282
      GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(347336), // Rule ID 1923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1923,
        GIR_EraseRootFromParent_Done,
      // Label 6919: @347336
      GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(347442), // Rule ID 5760 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5760,
        GIR_EraseRootFromParent_Done,
      // Label 6920: @347442
      GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(347548), // Rule ID 5762 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, FPR16:{ *:[bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5762,
        GIR_EraseRootFromParent_Done,
      // Label 6921: @347548
      GIM_Reject,
    // Label 6878: @347549
    GIM_Reject,
    // Label 6709: @347550
    GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(349129),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(347684), // Rule ID 4163 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4163,
        GIR_EraseRootFromParent_Done,
      // Label 6923: @347684
      GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(347810), // Rule ID 4164 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4164,
        GIR_EraseRootFromParent_Done,
      // Label 6924: @347810
      GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(347932), // Rule ID 4169 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4169,
        GIR_EraseRootFromParent_Done,
      // Label 6925: @347932
      GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(348054), // Rule ID 4171 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4171,
        GIR_EraseRootFromParent_Done,
      // Label 6926: @348054
      GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(348175), // Rule ID 4161 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4161,
        GIR_EraseRootFromParent_Done,
      // Label 6927: @348175
      GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(348296), // Rule ID 4162 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4162,
        GIR_EraseRootFromParent_Done,
      // Label 6928: @348296
      GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(348413), // Rule ID 4165 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4165,
        GIR_EraseRootFromParent_Done,
      // Label 6929: @348413
      GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(348530), // Rule ID 4167 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4167,
        GIR_EraseRootFromParent_Done,
      // Label 6930: @348530
      GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(348618), // Rule ID 1926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1926,
        GIR_EraseRootFromParent_Done,
      // Label 6931: @348618
      GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(348695), // Rule ID 5801 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5801,
        GIR_EraseRootFromParent_Done,
      // Label 6932: @348695
      GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(348803), // Rule ID 5802 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5802,
        GIR_EraseRootFromParent_Done,
      // Label 6933: @348803
      GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(348882), // Rule ID 5717 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5717,
        GIR_EraseRootFromParent_Done,
      // Label 6934: @348882
      GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(348968), // Rule ID 6492 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6492,
        GIR_EraseRootFromParent_Done,
      // Label 6935: @348968
      GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(349022), // Rule ID 1922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1922,
        GIR_EraseRootFromParent_Done,
      // Label 6936: @349022
      GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(349128), // Rule ID 5770 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5770,
        GIR_EraseRootFromParent_Done,
      // Label 6937: @349128
      GIM_Reject,
    // Label 6922: @349129
    GIM_Reject,
    // Label 6710: @349130
    GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(349363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(349259), // Rule ID 11472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11472,
        GIR_EraseRootFromParent_Done,
      // Label 6939: @349259
      GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(349362), // Rule ID 11475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$vec, FPR16:{ *:[bf16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2bf16] } ZPR:{ *:[nxv2bf16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11475,
        GIR_EraseRootFromParent_Done,
      // Label 6940: @349362
      GIM_Reject,
    // Label 6938: @349363
    GIM_Reject,
    // Label 6711: @349364
    GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(349488), // Rule ID 11478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/2, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11478,
      GIR_EraseRootFromParent_Done,
    // Label 6941: @349488
    GIM_Reject,
    // Label 6712: @349489
    GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(351402),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(349616), // Rule ID 4295 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4295,
        GIR_EraseRootFromParent_Done,
      // Label 6943: @349616
      GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(349725), // Rule ID 4296 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4296,
        GIR_EraseRootFromParent_Done,
      // Label 6944: @349725
      GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(349834), // Rule ID 4439 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4439,
        GIR_EraseRootFromParent_Done,
      // Label 6945: @349834
      GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(349943), // Rule ID 4440 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4440,
        GIR_EraseRootFromParent_Done,
      // Label 6946: @349943
      GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(350048), // Rule ID 4301 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4301,
        GIR_EraseRootFromParent_Done,
      // Label 6947: @350048
      GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(350153), // Rule ID 4303 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4303,
        GIR_EraseRootFromParent_Done,
      // Label 6948: @350153
      GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(350258), // Rule ID 4445 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4445,
        GIR_EraseRootFromParent_Done,
      // Label 6949: @350258
      GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(350363), // Rule ID 4447 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4447,
        GIR_EraseRootFromParent_Done,
      // Label 6950: @350363
      GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(350467), // Rule ID 4293 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4293,
        GIR_EraseRootFromParent_Done,
      // Label 6951: @350467
      GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(350571), // Rule ID 4294 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4294,
        GIR_EraseRootFromParent_Done,
      // Label 6952: @350571
      GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(350675), // Rule ID 4437 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4437,
        GIR_EraseRootFromParent_Done,
      // Label 6953: @350675
      GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(350779), // Rule ID 4438 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4438,
        GIR_EraseRootFromParent_Done,
      // Label 6954: @350779
      GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(350879), // Rule ID 4297 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4297,
        GIR_EraseRootFromParent_Done,
      // Label 6955: @350879
      GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(350979), // Rule ID 4299 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4299,
        GIR_EraseRootFromParent_Done,
      // Label 6956: @350979
      GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(351079), // Rule ID 4441 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4441,
        GIR_EraseRootFromParent_Done,
      // Label 6957: @351079
      GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(351179), // Rule ID 4443 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4443,
        GIR_EraseRootFromParent_Done,
      // Label 6958: @351179
      GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(351290), // Rule ID 11471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11471,
        GIR_EraseRootFromParent_Done,
      // Label 6959: @351290
      GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(351401), // Rule ID 11480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11480,
        GIR_EraseRootFromParent_Done,
      // Label 6960: @351401
      GIM_Reject,
    // Label 6942: @351402
    GIM_Reject,
    // Label 6713: @351403
    GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(351690),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(351559), // Rule ID 11473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11473,
        GIR_EraseRootFromParent_Done,
      // Label 6962: @351559
      GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(351689), // Rule ID 11476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$vec, FPR16:{ *:[bf16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11476,
        GIR_EraseRootFromParent_Done,
      // Label 6963: @351689
      GIM_Reject,
    // Label 6961: @351690
    GIM_Reject,
    // Label 6714: @351691
    GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(353658),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(351818), // Rule ID 4259 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4259,
        GIR_EraseRootFromParent_Done,
      // Label 6965: @351818
      GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(351927), // Rule ID 4260 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4260,
        GIR_EraseRootFromParent_Done,
      // Label 6966: @351927
      GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(352036), // Rule ID 4403 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4403,
        GIR_EraseRootFromParent_Done,
      // Label 6967: @352036
      GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(352145), // Rule ID 4404 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4404,
        GIR_EraseRootFromParent_Done,
      // Label 6968: @352145
      GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(352250), // Rule ID 4265 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4265,
        GIR_EraseRootFromParent_Done,
      // Label 6969: @352250
      GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(352355), // Rule ID 4267 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4267,
        GIR_EraseRootFromParent_Done,
      // Label 6970: @352355
      GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(352460), // Rule ID 4409 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4409,
        GIR_EraseRootFromParent_Done,
      // Label 6971: @352460
      GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(352565), // Rule ID 4411 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4411,
        GIR_EraseRootFromParent_Done,
      // Label 6972: @352565
      GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(352669), // Rule ID 4257 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4257,
        GIR_EraseRootFromParent_Done,
      // Label 6973: @352669
      GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(352773), // Rule ID 4258 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4258,
        GIR_EraseRootFromParent_Done,
      // Label 6974: @352773
      GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(352877), // Rule ID 4401 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4401,
        GIR_EraseRootFromParent_Done,
      // Label 6975: @352877
      GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(352981), // Rule ID 4402 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4402,
        GIR_EraseRootFromParent_Done,
      // Label 6976: @352981
      GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(353081), // Rule ID 4261 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4261,
        GIR_EraseRootFromParent_Done,
      // Label 6977: @353081
      GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(353181), // Rule ID 4263 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4263,
        GIR_EraseRootFromParent_Done,
      // Label 6978: @353181
      GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(353281), // Rule ID 4405 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4405,
        GIR_EraseRootFromParent_Done,
      // Label 6979: @353281
      GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(353381), // Rule ID 4407 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4407,
        GIR_EraseRootFromParent_Done,
      // Label 6980: @353381
      GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(353519), // Rule ID 11470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11470,
        GIR_EraseRootFromParent_Done,
      // Label 6981: @353519
      GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(353657), // Rule ID 11479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11479,
        GIR_EraseRootFromParent_Done,
      // Label 6982: @353657
      GIM_Reject,
    // Label 6964: @353658
    GIM_Reject,
    // Label 6715: @353659
    GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(356916),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(353786), // Rule ID 4331 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4331,
        GIR_EraseRootFromParent_Done,
      // Label 6984: @353786
      GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(353905), // Rule ID 4332 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4332,
        GIR_EraseRootFromParent_Done,
      // Label 6985: @353905
      GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(354024), // Rule ID 4367 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4367,
        GIR_EraseRootFromParent_Done,
      // Label 6986: @354024
      GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(354143), // Rule ID 4368 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4368,
        GIR_EraseRootFromParent_Done,
      // Label 6987: @354143
      GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(354269), // Rule ID 4223 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4223,
        GIR_EraseRootFromParent_Done,
      // Label 6988: @354269
      GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(354395), // Rule ID 4224 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4224,
        GIR_EraseRootFromParent_Done,
      // Label 6989: @354395
      GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(354510), // Rule ID 4337 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4337,
        GIR_EraseRootFromParent_Done,
      // Label 6990: @354510
      GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(354625), // Rule ID 4339 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4339,
        GIR_EraseRootFromParent_Done,
      // Label 6991: @354625
      GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(354740), // Rule ID 4373 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4373,
        GIR_EraseRootFromParent_Done,
      // Label 6992: @354740
      GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(354855), // Rule ID 4375 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4375,
        GIR_EraseRootFromParent_Done,
      // Label 6993: @354855
      GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(354977), // Rule ID 4229 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4229,
        GIR_EraseRootFromParent_Done,
      // Label 6994: @354977
      GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(355099), // Rule ID 4231 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4231,
        GIR_EraseRootFromParent_Done,
      // Label 6995: @355099
      GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(355213), // Rule ID 4329 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4329,
        GIR_EraseRootFromParent_Done,
      // Label 6996: @355213
      GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(355327), // Rule ID 4330 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4330,
        GIR_EraseRootFromParent_Done,
      // Label 6997: @355327
      GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(355441), // Rule ID 4365 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4365,
        GIR_EraseRootFromParent_Done,
      // Label 6998: @355441
      GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(355555), // Rule ID 4366 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4366,
        GIR_EraseRootFromParent_Done,
      // Label 6999: @355555
      GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(355676), // Rule ID 4221 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4221,
        GIR_EraseRootFromParent_Done,
      // Label 7000: @355676
      GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(355797), // Rule ID 4222 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4222,
        GIR_EraseRootFromParent_Done,
      // Label 7001: @355797
      GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(355907), // Rule ID 4333 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4333,
        GIR_EraseRootFromParent_Done,
      // Label 7002: @355907
      GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(356017), // Rule ID 4335 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4335,
        GIR_EraseRootFromParent_Done,
      // Label 7003: @356017
      GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(356127), // Rule ID 4369 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4369,
        GIR_EraseRootFromParent_Done,
      // Label 7004: @356127
      GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(356237), // Rule ID 4371 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4371,
        GIR_EraseRootFromParent_Done,
      // Label 7005: @356237
      GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(356354), // Rule ID 4225 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4225,
        GIR_EraseRootFromParent_Done,
      // Label 7006: @356354
      GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(356471), // Rule ID 4227 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4227,
        GIR_EraseRootFromParent_Done,
      // Label 7007: @356471
      GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(356619), // Rule ID 11469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11469,
        GIR_EraseRootFromParent_Done,
      // Label 7008: @356619
      GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(356767), // Rule ID 11474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11474,
        GIR_EraseRootFromParent_Done,
      // Label 7009: @356767
      GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(356915), // Rule ID 11477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$vec, FPR16:{ *:[bf16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11477,
        GIR_EraseRootFromParent_Done,
      // Label 7010: @356915
      GIM_Reject,
    // Label 6983: @356916
    GIM_Reject,
    // Label 6716: @356917
    GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(357966),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(357051), // Rule ID 4187 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4187,
        GIR_EraseRootFromParent_Done,
      // Label 7012: @357051
      GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(357167), // Rule ID 4188 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4188,
        GIR_EraseRootFromParent_Done,
      // Label 7013: @357167
      GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(357279), // Rule ID 4193 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4193,
        GIR_EraseRootFromParent_Done,
      // Label 7014: @357279
      GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(357391), // Rule ID 4195 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4195,
        GIR_EraseRootFromParent_Done,
      // Label 7015: @357391
      GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(357502), // Rule ID 4185 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4185,
        GIR_EraseRootFromParent_Done,
      // Label 7016: @357502
      GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(357613), // Rule ID 4186 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4186,
        GIR_EraseRootFromParent_Done,
      // Label 7017: @357613
      GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(357720), // Rule ID 4189 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4189,
        GIR_EraseRootFromParent_Done,
      // Label 7018: @357720
      GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(357827), // Rule ID 4191 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4191,
        GIR_EraseRootFromParent_Done,
      // Label 7019: @357827
      GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(357965), // Rule ID 11468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11468,
        GIR_EraseRootFromParent_Done,
      // Label 7020: @357965
      GIM_Reject,
    // Label 7011: @357966
    GIM_Reject,
    // Label 6717: @357967
    GIM_Reject,
    // Label 86: @357968
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7024*/ GIMT_Encode4(361518),
    /*GILLT_s16*//*Label 7021*/ GIMT_Encode4(357991),
    /*GILLT_s32*//*Label 7022*/ GIMT_Encode4(359258),
    /*GILLT_s64*//*Label 7023*/ GIMT_Encode4(360851),
    // Label 7021: @357991
    GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(358035), // Rule ID 11522 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11522,
      GIR_EraseRootFromParent_Done,
    // Label 7025: @358035
    GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(358079), // Rule ID 11523 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11523,
      GIR_EraseRootFromParent_Done,
    // Label 7026: @358079
    GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(358123), // Rule ID 11524 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11524,
      GIR_EraseRootFromParent_Done,
    // Label 7027: @358123
    GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(358167), // Rule ID 11525 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11525,
      GIR_EraseRootFromParent_Done,
    // Label 7028: @358167
    GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(358211), // Rule ID 11526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } ZPR:{ *:[nxv4bf16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11526,
      GIR_EraseRootFromParent_Done,
    // Label 7029: @358211
    GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(358255), // Rule ID 11527 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } ZPR:{ *:[nxv2bf16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11527,
      GIR_EraseRootFromParent_Done,
    // Label 7030: @358255
    GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(358300), // Rule ID 5832 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5832,
      GIR_EraseRootFromParent_Done,
    // Label 7031: @358300
    GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(358345), // Rule ID 5833 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5833,
      GIR_EraseRootFromParent_Done,
    // Label 7032: @358345
    GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(358390), // Rule ID 5836 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5836,
      GIR_EraseRootFromParent_Done,
    // Label 7033: @358390
    GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(358435), // Rule ID 5837 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5837,
      GIR_EraseRootFromParent_Done,
    // Label 7034: @358435
    GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(358511), // Rule ID 11498 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11498,
      GIR_EraseRootFromParent_Done,
    // Label 7035: @358511
    GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(358587), // Rule ID 11499 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11499,
      GIR_EraseRootFromParent_Done,
    // Label 7036: @358587
    GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(358663), // Rule ID 11500 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11500,
      GIR_EraseRootFromParent_Done,
    // Label 7037: @358663
    GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(358739), // Rule ID 11501 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } nxv8bf16:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11501,
      GIR_EraseRootFromParent_Done,
    // Label 7038: @358739
    GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(358815), // Rule ID 11502 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } nxv4bf16:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11502,
      GIR_EraseRootFromParent_Done,
    // Label 7039: @358815
    GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(358891), // Rule ID 11503 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } nxv2bf16:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11503,
      GIR_EraseRootFromParent_Done,
    // Label 7040: @358891
    GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(358952), // Rule ID 11485 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11485,
      GIR_EraseRootFromParent_Done,
    // Label 7041: @358952
    GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(359013), // Rule ID 11486 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11486,
      GIR_EraseRootFromParent_Done,
    // Label 7042: @359013
    GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(359074), // Rule ID 11487 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11487,
      GIR_EraseRootFromParent_Done,
    // Label 7043: @359074
    GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(359135), // Rule ID 11488 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[bf16] } nxv8bf16:{ *:[nxv8bf16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[bf16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8bf16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11488,
      GIR_EraseRootFromParent_Done,
    // Label 7044: @359135
    GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(359196), // Rule ID 11489 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[bf16] } nxv4bf16:{ *:[nxv4bf16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[bf16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4bf16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11489,
      GIR_EraseRootFromParent_Done,
    // Label 7045: @359196
    GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(359257), // Rule ID 11490 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[bf16] } nxv2bf16:{ *:[nxv2bf16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[bf16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2bf16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11490,
      GIR_EraseRootFromParent_Done,
    // Label 7046: @359257
    GIM_Reject,
    // Label 7022: @359258
    GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(359303), // Rule ID 7120 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7120,
      GIR_EraseRootFromParent_Done,
    // Label 7047: @359303
    GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(359348), // Rule ID 7121 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 7121,
      GIR_EraseRootFromParent_Done,
    // Label 7048: @359348
    GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(359392), // Rule ID 11518 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11518,
      GIR_EraseRootFromParent_Done,
    // Label 7049: @359392
    GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(359436), // Rule ID 11519 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11519,
      GIR_EraseRootFromParent_Done,
    // Label 7050: @359436
    GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(359480), // Rule ID 11520 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11520,
      GIR_EraseRootFromParent_Done,
    // Label 7051: @359480
    GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(359524), // Rule ID 11528 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11528,
      GIR_EraseRootFromParent_Done,
    // Label 7052: @359524
    GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(359568), // Rule ID 11529 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11529,
      GIR_EraseRootFromParent_Done,
    // Label 7053: @359568
    GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(359613), // Rule ID 5831 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5831,
      GIR_EraseRootFromParent_Done,
    // Label 7054: @359613
    GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(359686), // Rule ID 11507 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11507,
      GIR_EraseRootFromParent_Done,
    // Label 7055: @359686
    GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(359759), // Rule ID 11508 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11508,
      GIR_EraseRootFromParent_Done,
    // Label 7056: @359759
    GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(359832), // Rule ID 11509 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11509,
      GIR_EraseRootFromParent_Done,
    // Label 7057: @359832
    GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(359880), // Rule ID 1914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1914,
      GIR_EraseRootFromParent_Done,
    // Label 7058: @359880
    GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(359928), // Rule ID 1915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1915,
      GIR_EraseRootFromParent_Done,
    // Label 7059: @359928
    GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(359976), // Rule ID 1916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1916,
      GIR_EraseRootFromParent_Done,
    // Label 7060: @359976
    GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(360024), // Rule ID 1918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1918,
      GIR_EraseRootFromParent_Done,
    // Label 7061: @360024
    GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(360072), // Rule ID 1919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1919,
      GIR_EraseRootFromParent_Done,
    // Label 7062: @360072
    GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(360120), // Rule ID 1920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1920,
      GIR_EraseRootFromParent_Done,
    // Label 7063: @360120
    GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(360165), // Rule ID 5835 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5835,
      GIR_EraseRootFromParent_Done,
    // Label 7064: @360165
    GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(360241), // Rule ID 11494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11494,
      GIR_EraseRootFromParent_Done,
    // Label 7065: @360241
    GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(360317), // Rule ID 11495 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11495,
      GIR_EraseRootFromParent_Done,
    // Label 7066: @360317
    GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(360393), // Rule ID 11496 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11496,
      GIR_EraseRootFromParent_Done,
    // Label 7067: @360393
    GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(360469), // Rule ID 11504 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11504,
      GIR_EraseRootFromParent_Done,
    // Label 7068: @360469
    GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(360545), // Rule ID 11505 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11505,
      GIR_EraseRootFromParent_Done,
    // Label 7069: @360545
    GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(360606), // Rule ID 11481 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11481,
      GIR_EraseRootFromParent_Done,
    // Label 7070: @360606
    GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(360667), // Rule ID 11482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11482,
      GIR_EraseRootFromParent_Done,
    // Label 7071: @360667
    GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(360728), // Rule ID 11483 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11483,
      GIR_EraseRootFromParent_Done,
    // Label 7072: @360728
    GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(360789), // Rule ID 11491 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11491,
      GIR_EraseRootFromParent_Done,
    // Label 7073: @360789
    GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(360850), // Rule ID 11492 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11492,
      GIR_EraseRootFromParent_Done,
    // Label 7074: @360850
    GIM_Reject,
    // Label 7023: @360851
    GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(360896), // Rule ID 7119 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7119,
      GIR_EraseRootFromParent_Done,
    // Label 7075: @360896
    GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(360940), // Rule ID 11521 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11521,
      GIR_EraseRootFromParent_Done,
    // Label 7076: @360940
    GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(360984), // Rule ID 11530 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11530,
      GIR_EraseRootFromParent_Done,
    // Label 7077: @360984
    GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(361029), // Rule ID 5830 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5830,
      GIR_EraseRootFromParent_Done,
    // Label 7078: @361029
    GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(361102), // Rule ID 11510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11510,
      GIR_EraseRootFromParent_Done,
    // Label 7079: @361102
    GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(361150), // Rule ID 1917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1917,
      GIR_EraseRootFromParent_Done,
    // Label 7080: @361150
    GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(361198), // Rule ID 1921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1921,
      GIR_EraseRootFromParent_Done,
    // Label 7081: @361198
    GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(361243), // Rule ID 5834 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5834,
      GIR_EraseRootFromParent_Done,
    // Label 7082: @361243
    GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(361319), // Rule ID 11497 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11497,
      GIR_EraseRootFromParent_Done,
    // Label 7083: @361319
    GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(361395), // Rule ID 11506 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11506,
      GIR_EraseRootFromParent_Done,
    // Label 7084: @361395
    GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(361456), // Rule ID 11484 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11484,
      GIR_EraseRootFromParent_Done,
    // Label 7085: @361456
    GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(361517), // Rule ID 11493 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11493,
      GIR_EraseRootFromParent_Done,
    // Label 7086: @361517
    GIM_Reject,
    // Label 7024: @361518
    GIM_Reject,
    // Label 87: @361519
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7094*/ GIMT_Encode4(363808),
    /*GILLT_nxv2s16*//*Label 7087*/ GIMT_Encode4(361570),
    /*GILLT_nxv2s32*//*Label 7088*/ GIMT_Encode4(362112),
    /*GILLT_nxv2s64*//*Label 7089*/ GIMT_Encode4(362350), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 7090*/ GIMT_Encode4(362607),
    /*GILLT_nxv4s32*//*Label 7091*/ GIMT_Encode4(363035), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 7092*/ GIMT_Encode4(363292), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 7093*/ GIMT_Encode4(363718),
    // Label 7087: @361570
    GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(362111),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(361639), // Rule ID 2622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2622,
        GIR_EraseRootFromParent_Done,
      // Label 7096: @361639
      GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(361696), // Rule ID 2624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2624,
        GIR_EraseRootFromParent_Done,
      // Label 7097: @361696
      GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(361753), // Rule ID 8479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8479,
        GIR_EraseRootFromParent_Done,
      // Label 7098: @361753
      GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(361810), // Rule ID 8488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8488,
        GIR_EraseRootFromParent_Done,
      // Label 7099: @361810
      GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(361867), // Rule ID 8506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8506,
        GIR_EraseRootFromParent_Done,
      // Label 7100: @361867
      GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(361924), // Rule ID 8509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2bf16] } ZPR:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8509,
        GIR_EraseRootFromParent_Done,
      // Label 7101: @361924
      GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(361958), // Rule ID 8540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8540,
        GIR_EraseRootFromParent_Done,
      // Label 7102: @361958
      GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(362034), // Rule ID 8512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8512,
        GIR_EraseRootFromParent_Done,
      // Label 7103: @362034
      GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(362110), // Rule ID 8518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv2bf16] } FPR16:{ *:[bf16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2bf16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[bf16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8518,
        GIR_EraseRootFromParent_Done,
      // Label 7104: @362110
      GIM_Reject,
    // Label 7095: @362111
    GIM_Reject,
    // Label 7088: @362112
    GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(362349),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(362181), // Rule ID 8497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8497,
        GIR_EraseRootFromParent_Done,
      // Label 7106: @362181
      GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(362238), // Rule ID 8508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8508,
        GIR_EraseRootFromParent_Done,
      // Label 7107: @362238
      GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(362272), // Rule ID 8542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8542,
        GIR_EraseRootFromParent_Done,
      // Label 7108: @362272
      GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(362348), // Rule ID 8514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8514,
        GIR_EraseRootFromParent_Done,
      // Label 7109: @362348
      GIM_Reject,
    // Label 7105: @362349
    GIM_Reject,
    // Label 7089: @362350
    GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(362606),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(362419), // Rule ID 2619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2619,
        GIR_EraseRootFromParent_Done,
      // Label 7111: @362419
      GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(362476), // Rule ID 8503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8503,
        GIR_EraseRootFromParent_Done,
      // Label 7112: @362476
      GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(362510), // Rule ID 8543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8543,
        GIR_EraseRootFromParent_Done,
      // Label 7113: @362510
      GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(362529), // Rule ID 2367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2367,
        GIR_Done,
      // Label 7114: @362529
      GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(362605), // Rule ID 8515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8515,
        GIR_EraseRootFromParent_Done,
      // Label 7115: @362605
      GIM_Reject,
    // Label 7110: @362606
    GIM_Reject,
    // Label 7090: @362607
    GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(363034),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(362676), // Rule ID 2623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2623,
        GIR_EraseRootFromParent_Done,
      // Label 7117: @362676
      GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(362733), // Rule ID 8482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8482,
        GIR_EraseRootFromParent_Done,
      // Label 7118: @362733
      GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(362790), // Rule ID 8491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8491,
        GIR_EraseRootFromParent_Done,
      // Label 7119: @362790
      GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(362847), // Rule ID 8507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8507,
        GIR_EraseRootFromParent_Done,
      // Label 7120: @362847
      GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(362881), // Rule ID 8539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8539,
        GIR_EraseRootFromParent_Done,
      // Label 7121: @362881
      GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(362957), // Rule ID 8511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8511,
        GIR_EraseRootFromParent_Done,
      // Label 7122: @362957
      GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(363033), // Rule ID 8517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv4bf16] } FPR16:{ *:[bf16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4bf16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[bf16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8517,
        GIR_EraseRootFromParent_Done,
      // Label 7123: @363033
      GIM_Reject,
    // Label 7116: @363034
    GIM_Reject,
    // Label 7091: @363035
    GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(363291),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(363104), // Rule ID 2616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2616,
        GIR_EraseRootFromParent_Done,
      // Label 7125: @363104
      GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(363161), // Rule ID 8500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8500,
        GIR_EraseRootFromParent_Done,
      // Label 7126: @363161
      GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(363195), // Rule ID 8541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8541,
        GIR_EraseRootFromParent_Done,
      // Label 7127: @363195
      GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(363214), // Rule ID 2366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2366,
        GIR_Done,
      // Label 7128: @363214
      GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(363290), // Rule ID 8513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8513,
        GIR_EraseRootFromParent_Done,
      // Label 7129: @363290
      GIM_Reject,
    // Label 7124: @363291
    GIM_Reject,
    // Label 7092: @363292
    GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(363356), // Rule ID 2613 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2613,
      GIR_EraseRootFromParent_Done,
    // Label 7130: @363356
    GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(363420), // Rule ID 8485 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8485,
      GIR_EraseRootFromParent_Done,
    // Label 7131: @363420
    GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(363484), // Rule ID 8494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (splat_vector:{ *:[nxv8bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8494,
      GIR_EraseRootFromParent_Done,
    // Label 7132: @363484
    GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(363525), // Rule ID 8538 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
      GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8538,
      GIR_EraseRootFromParent_Done,
    // Label 7133: @363525
    GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(363551), // Rule ID 2365 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
      // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2365,
      GIR_Done,
    // Label 7134: @363551
    GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(363634), // Rule ID 8510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8510,
      GIR_EraseRootFromParent_Done,
    // Label 7135: @363634
    GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(363717), // Rule ID 8516 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (splat_vector:{ *:[nxv8bf16] } FPR16:{ *:[bf16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8bf16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[bf16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8516,
      GIR_EraseRootFromParent_Done,
    // Label 7136: @363717
    GIM_Reject,
    // Label 7093: @363718
    GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(363807),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(363787), // Rule ID 2610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2610,
        GIR_EraseRootFromParent_Done,
      // Label 7138: @363787
      GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(363806), // Rule ID 2364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2364,
        GIR_Done,
      // Label 7139: @363806
      GIM_Reject,
    // Label 7137: @363807
    GIM_Reject,
    // Label 7094: @363808
    GIM_Reject,
    // Label 88: @363809
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7142*/ GIMT_Encode4(363960),
    /*GILLT_s32*//*Label 7140*/ GIMT_Encode4(363828),
    /*GILLT_s64*//*Label 7141*/ GIMT_Encode4(363894),
    // Label 7140: @363828
    GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(363893),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(363859), // Rule ID 2307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2307,
        GIR_Done,
      // Label 7144: @363859
      GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(363892), // Rule ID 3973 //
        // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3973,
        GIR_EraseRootFromParent_Done,
      // Label 7145: @363892
      GIM_Reject,
    // Label 7143: @363893
    GIM_Reject,
    // Label 7141: @363894
    GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(363959),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(363925), // Rule ID 2308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2308,
        GIR_Done,
      // Label 7147: @363925
      GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(363958), // Rule ID 3974 //
        // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3974,
        GIR_EraseRootFromParent_Done,
      // Label 7148: @363958
      GIM_Reject,
    // Label 7146: @363959
    GIM_Reject,
    // Label 7142: @363960
    GIM_Reject,
    // Label 89: @363961
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7157*/ GIMT_Encode4(364634),
    /*GILLT_s32*//*Label 7149*/ GIMT_Encode4(364012),
    /*GILLT_s64*//*Label 7150*/ GIMT_Encode4(364242), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7151*/ GIMT_Encode4(364472), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 7152*/ GIMT_Encode4(364499),
    /*GILLT_v4s32*//*Label 7153*/ GIMT_Encode4(364526),
    /*GILLT_v8s8*//*Label 7154*/ GIMT_Encode4(364553),
    /*GILLT_v8s16*//*Label 7155*/ GIMT_Encode4(364580),
    /*GILLT_v16s8*//*Label 7156*/ GIMT_Encode4(364607),
    // Label 7149: @364012
    GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(364241),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(364124), // Rule ID 3975 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
        // MIs[3] Rn
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3975,
        GIR_EraseRootFromParent_Done,
      // Label 7159: @364124
      GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(364224), // Rule ID 13769 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13769,
        GIR_EraseRootFromParent_Done,
      // Label 7160: @364224
      GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(364240), // Rule ID 192 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 192,
        GIR_Done,
      // Label 7161: @364240
      GIM_Reject,
    // Label 7158: @364241
    GIM_Reject,
    // Label 7150: @364242
    GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(364471),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(364354), // Rule ID 3976 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
        // MIs[3] Rn
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3976,
        GIR_EraseRootFromParent_Done,
      // Label 7163: @364354
      GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(364454), // Rule ID 13770 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13770,
        GIR_EraseRootFromParent_Done,
      // Label 7164: @364454
      GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(364470), // Rule ID 193 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 193,
        GIR_Done,
      // Label 7165: @364470
      GIM_Reject,
    // Label 7162: @364471
    GIM_Reject,
    // Label 7151: @364472
    GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(364498), // Rule ID 715 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 715,
      GIR_Done,
    // Label 7166: @364498
    GIM_Reject,
    // Label 7152: @364499
    GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(364525), // Rule ID 713 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 713,
      GIR_Done,
    // Label 7167: @364525
    GIM_Reject,
    // Label 7153: @364526
    GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(364552), // Rule ID 716 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 716,
      GIR_Done,
    // Label 7168: @364552
    GIM_Reject,
    // Label 7154: @364553
    GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(364579), // Rule ID 711 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 711,
      GIR_Done,
    // Label 7169: @364579
    GIM_Reject,
    // Label 7155: @364580
    GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(364606), // Rule ID 714 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 714,
      GIR_Done,
    // Label 7170: @364606
    GIM_Reject,
    // Label 7156: @364607
    GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(364633), // Rule ID 712 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 712,
      GIR_Done,
    // Label 7171: @364633
    GIM_Reject,
    // Label 7157: @364634
    GIM_Reject,
    // Label 90: @364635
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7176*/ GIMT_Encode4(364794),
    /*GILLT_s32*//*Label 7172*/ GIMT_Encode4(364686),
    /*GILLT_s64*//*Label 7173*/ GIMT_Encode4(364713), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 7174*/ GIMT_Encode4(364740), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 7175*/ GIMT_Encode4(364767),
    // Label 7172: @364686
    GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(364712), // Rule ID 2305 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2305,
      GIR_Done,
    // Label 7177: @364712
    GIM_Reject,
    // Label 7173: @364713
    GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(364739), // Rule ID 2306 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2306,
      GIR_Done,
    // Label 7178: @364739
    GIM_Reject,
    // Label 7174: @364740
    GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(364766), // Rule ID 752 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 752,
      GIR_Done,
    // Label 7179: @364766
    GIM_Reject,
    // Label 7175: @364767
    GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(364793), // Rule ID 753 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 753,
      GIR_Done,
    // Label 7180: @364793
    GIM_Reject,
    // Label 7176: @364794
    GIM_Reject,
    // Label 91: @364795
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7188*/ GIMT_Encode4(365108),
    /*GILLT_s32*//*Label 7181*/ GIMT_Encode4(364842),
    /*GILLT_s64*//*Label 7182*/ GIMT_Encode4(364915), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7183*/ GIMT_Encode4(364988),
    /*GILLT_v2s64*//*Label 7184*/ GIMT_Encode4(365012),
    /*GILLT_v4s16*//*Label 7185*/ GIMT_Encode4(365036),
    /*GILLT_v4s32*//*Label 7186*/ GIMT_Encode4(365060), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7187*/ GIMT_Encode4(365084),
    // Label 7181: @364842
    GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(364914),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(364897), // Rule ID 3979 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3979,
        GIR_EraseRootFromParent_Done,
      // Label 7190: @364897
      GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(364913), // Rule ID 197 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 197,
        GIR_Done,
      // Label 7191: @364913
      GIM_Reject,
    // Label 7189: @364914
    GIM_Reject,
    // Label 7182: @364915
    GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(364987),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(364970), // Rule ID 3980 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3980,
        GIR_EraseRootFromParent_Done,
      // Label 7193: @364970
      GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(364986), // Rule ID 198 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 198,
        GIR_Done,
      // Label 7194: @364986
      GIM_Reject,
    // Label 7192: @364987
    GIM_Reject,
    // Label 7183: @364988
    GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(365011), // Rule ID 5014 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5014,
      GIR_Done,
    // Label 7195: @365011
    GIM_Reject,
    // Label 7184: @365012
    GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(365035), // Rule ID 5016 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5016,
      GIR_Done,
    // Label 7196: @365035
    GIM_Reject,
    // Label 7185: @365036
    GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(365059), // Rule ID 5012 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5012,
      GIR_Done,
    // Label 7197: @365059
    GIM_Reject,
    // Label 7186: @365060
    GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(365083), // Rule ID 5015 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5015,
      GIR_Done,
    // Label 7198: @365083
    GIM_Reject,
    // Label 7187: @365084
    GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(365107), // Rule ID 5013 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5013,
      GIR_Done,
    // Label 7199: @365107
    GIM_Reject,
    // Label 7188: @365108
    GIM_Reject,
    // Label 92: @365109
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7204*/ GIMT_Encode4(365262),
    /*GILLT_s32*//*Label 7200*/ GIMT_Encode4(365160),
    /*GILLT_s64*//*Label 7201*/ GIMT_Encode4(365184), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 7202*/ GIMT_Encode4(365208), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 7203*/ GIMT_Encode4(365235),
    // Label 7200: @365160
    GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(365183), // Rule ID 194 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 194,
      GIR_Done,
    // Label 7205: @365183
    GIM_Reject,
    // Label 7201: @365184
    GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(365207), // Rule ID 195 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 195,
      GIR_Done,
    // Label 7206: @365207
    GIM_Reject,
    // Label 7202: @365208
    GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(365234), // Rule ID 962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 962,
      GIR_Done,
    // Label 7207: @365234
    GIM_Reject,
    // Label 7203: @365235
    GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(365261), // Rule ID 963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 963,
      GIR_Done,
    // Label 7208: @365261
    GIM_Reject,
    // Label 7204: @365262
    GIM_Reject,
    // Label 93: @365263
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7217*/ GIMT_Encode4(366685),
    /*GILLT_s16*//*Label 7209*/ GIMT_Encode4(365314),
    /*GILLT_s32*//*Label 7210*/ GIMT_Encode4(365345),
    /*GILLT_s64*//*Label 7211*/ GIMT_Encode4(365376), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7212*/ GIMT_Encode4(365407),
    /*GILLT_v2s64*//*Label 7213*/ GIMT_Encode4(365438),
    /*GILLT_v4s16*//*Label 7214*/ GIMT_Encode4(365469),
    /*GILLT_v4s32*//*Label 7215*/ GIMT_Encode4(365500), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7216*/ GIMT_Encode4(365531),
    // Label 7209: @365314
    GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(365344), // Rule ID 547 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 547,
      GIR_Done,
    // Label 7218: @365344
    GIM_Reject,
    // Label 7210: @365345
    GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(365375), // Rule ID 549 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 549,
      GIR_Done,
    // Label 7219: @365375
    GIM_Reject,
    // Label 7211: @365376
    GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(365406), // Rule ID 551 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 551,
      GIR_Done,
    // Label 7220: @365406
    GIM_Reject,
    // Label 7212: @365407
    GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(365437), // Rule ID 901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 901,
      GIR_Done,
    // Label 7221: @365437
    GIM_Reject,
    // Label 7213: @365438
    GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(365468), // Rule ID 905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 905,
      GIR_Done,
    // Label 7222: @365468
    GIM_Reject,
    // Label 7214: @365469
    GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(365499), // Rule ID 897 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 897,
      GIR_Done,
    // Label 7223: @365499
    GIM_Reject,
    // Label 7215: @365500
    GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(365530), // Rule ID 903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 903,
      GIR_Done,
    // Label 7224: @365530
    GIM_Reject,
    // Label 7216: @365531
    GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(366684),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(365566), // Rule ID 899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 899,
        GIR_Done,
      // Label 7226: @365566
      GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(365751), // Rule ID 7146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7146,
        GIR_EraseRootFromParent_Done,
      // Label 7227: @365751
      GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(365886), // Rule ID 7148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fceil:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7148,
        GIR_EraseRootFromParent_Done,
      // Label 7228: @365886
      GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(366683), // Rule ID 7150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fceil:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7150,
        GIR_EraseRootFromParent_Done,
      // Label 7229: @366683
      GIM_Reject,
    // Label 7225: @366684
    GIM_Reject,
    // Label 7217: @366685
    GIM_Reject,
    // Label 94: @366686
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7238*/ GIMT_Encode4(366985),
    /*GILLT_s16*//*Label 7230*/ GIMT_Encode4(366737),
    /*GILLT_s32*//*Label 7231*/ GIMT_Encode4(366768),
    /*GILLT_s64*//*Label 7232*/ GIMT_Encode4(366799), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7233*/ GIMT_Encode4(366830),
    /*GILLT_v2s64*//*Label 7234*/ GIMT_Encode4(366861),
    /*GILLT_v4s16*//*Label 7235*/ GIMT_Encode4(366892),
    /*GILLT_v4s32*//*Label 7236*/ GIMT_Encode4(366923), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7237*/ GIMT_Encode4(366954),
    // Label 7230: @366737
    GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(366767), // Rule ID 565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 565,
      GIR_Done,
    // Label 7239: @366767
    GIM_Reject,
    // Label 7231: @366768
    GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(366798), // Rule ID 567 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 567,
      GIR_Done,
    // Label 7240: @366798
    GIM_Reject,
    // Label 7232: @366799
    GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(366829), // Rule ID 569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 569,
      GIR_Done,
    // Label 7241: @366829
    GIM_Reject,
    // Label 7233: @366830
    GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(366860), // Rule ID 948 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 948,
      GIR_Done,
    // Label 7242: @366860
    GIM_Reject,
    // Label 7234: @366861
    GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(366891), // Rule ID 952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 952,
      GIR_Done,
    // Label 7243: @366891
    GIM_Reject,
    // Label 7235: @366892
    GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(366922), // Rule ID 944 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 944,
      GIR_Done,
    // Label 7244: @366922
    GIM_Reject,
    // Label 7236: @366923
    GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(366953), // Rule ID 950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 950,
      GIR_Done,
    // Label 7245: @366953
    GIM_Reject,
    // Label 7237: @366954
    GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(366984), // Rule ID 946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 946,
      GIR_Done,
    // Label 7246: @366984
    GIM_Reject,
    // Label 7238: @366985
    GIM_Reject,
    // Label 95: @366986
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7255*/ GIMT_Encode4(368408),
    /*GILLT_s16*//*Label 7247*/ GIMT_Encode4(367037),
    /*GILLT_s32*//*Label 7248*/ GIMT_Encode4(367068),
    /*GILLT_s64*//*Label 7249*/ GIMT_Encode4(367099), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7250*/ GIMT_Encode4(367130),
    /*GILLT_v2s64*//*Label 7251*/ GIMT_Encode4(367161),
    /*GILLT_v4s16*//*Label 7252*/ GIMT_Encode4(367192),
    /*GILLT_v4s32*//*Label 7253*/ GIMT_Encode4(367223), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7254*/ GIMT_Encode4(367254),
    // Label 7247: @367037
    GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(367067), // Rule ID 535 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 535,
      GIR_Done,
    // Label 7256: @367067
    GIM_Reject,
    // Label 7248: @367068
    GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(367098), // Rule ID 537 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 537,
      GIR_Done,
    // Label 7257: @367098
    GIM_Reject,
    // Label 7249: @367099
    GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(367129), // Rule ID 539 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 539,
      GIR_Done,
    // Label 7258: @367129
    GIM_Reject,
    // Label 7250: @367130
    GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(367160), // Rule ID 881 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 881,
      GIR_Done,
    // Label 7259: @367160
    GIM_Reject,
    // Label 7251: @367161
    GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(367191), // Rule ID 885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 885,
      GIR_Done,
    // Label 7260: @367191
    GIM_Reject,
    // Label 7252: @367192
    GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(367222), // Rule ID 877 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 877,
      GIR_Done,
    // Label 7261: @367222
    GIM_Reject,
    // Label 7253: @367223
    GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(367253), // Rule ID 883 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 883,
      GIR_Done,
    // Label 7262: @367253
    GIM_Reject,
    // Label 7254: @367254
    GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(368407),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(367289), // Rule ID 879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 879,
        GIR_Done,
      // Label 7264: @367289
      GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(367474), // Rule ID 7152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7152,
        GIR_EraseRootFromParent_Done,
      // Label 7265: @367474
      GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(367609), // Rule ID 7154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (ffloor:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7154,
        GIR_EraseRootFromParent_Done,
      // Label 7266: @367609
      GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(368406), // Rule ID 7156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (ffloor:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7156,
        GIR_EraseRootFromParent_Done,
      // Label 7267: @368406
      GIM_Reject,
    // Label 7263: @368407
    GIM_Reject,
    // Label 7255: @368408
    GIM_Reject,
    // Label 96: @368409
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7276*/ GIMT_Encode4(369831),
    /*GILLT_s16*//*Label 7268*/ GIMT_Encode4(368460),
    /*GILLT_s32*//*Label 7269*/ GIMT_Encode4(368491),
    /*GILLT_s64*//*Label 7270*/ GIMT_Encode4(368522), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7271*/ GIMT_Encode4(368553),
    /*GILLT_v2s64*//*Label 7272*/ GIMT_Encode4(368584),
    /*GILLT_v4s16*//*Label 7273*/ GIMT_Encode4(368615),
    /*GILLT_v4s32*//*Label 7274*/ GIMT_Encode4(368646), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7275*/ GIMT_Encode4(368677),
    // Label 7268: @368460
    GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(368490), // Rule ID 553 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 553,
      GIR_Done,
    // Label 7277: @368490
    GIM_Reject,
    // Label 7269: @368491
    GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(368521), // Rule ID 555 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 555,
      GIR_Done,
    // Label 7278: @368521
    GIM_Reject,
    // Label 7270: @368522
    GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(368552), // Rule ID 557 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 557,
      GIR_Done,
    // Label 7279: @368552
    GIM_Reject,
    // Label 7271: @368553
    GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(368583), // Rule ID 911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 911,
      GIR_Done,
    // Label 7280: @368583
    GIM_Reject,
    // Label 7272: @368584
    GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(368614), // Rule ID 915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 915,
      GIR_Done,
    // Label 7281: @368614
    GIM_Reject,
    // Label 7273: @368615
    GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(368645), // Rule ID 907 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 907,
      GIR_Done,
    // Label 7282: @368645
    GIM_Reject,
    // Label 7274: @368646
    GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(368676), // Rule ID 913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 913,
      GIR_Done,
    // Label 7283: @368676
    GIM_Reject,
    // Label 7275: @368677
    GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(369830),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(368712), // Rule ID 909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 909,
        GIR_Done,
      // Label 7285: @368712
      GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(368897), // Rule ID 7176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7176,
        GIR_EraseRootFromParent_Done,
      // Label 7286: @368897
      GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(369032), // Rule ID 7178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (frint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7178,
        GIR_EraseRootFromParent_Done,
      // Label 7287: @369032
      GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(369829), // Rule ID 7180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (frint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7180,
        GIR_EraseRootFromParent_Done,
      // Label 7288: @369829
      GIM_Reject,
    // Label 7284: @369830
    GIM_Reject,
    // Label 7276: @369831
    GIM_Reject,
    // Label 97: @369832
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7297*/ GIMT_Encode4(371254),
    /*GILLT_s16*//*Label 7289*/ GIMT_Encode4(369883),
    /*GILLT_s32*//*Label 7290*/ GIMT_Encode4(369914),
    /*GILLT_s64*//*Label 7291*/ GIMT_Encode4(369945), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7292*/ GIMT_Encode4(369976),
    /*GILLT_v2s64*//*Label 7293*/ GIMT_Encode4(370007),
    /*GILLT_v4s16*//*Label 7294*/ GIMT_Encode4(370038),
    /*GILLT_v4s32*//*Label 7295*/ GIMT_Encode4(370069), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7296*/ GIMT_Encode4(370100),
    // Label 7289: @369883
    GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(369913), // Rule ID 529 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 529,
      GIR_Done,
    // Label 7298: @369913
    GIM_Reject,
    // Label 7290: @369914
    GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(369944), // Rule ID 531 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 531,
      GIR_Done,
    // Label 7299: @369944
    GIM_Reject,
    // Label 7291: @369945
    GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(369975), // Rule ID 533 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 533,
      GIR_Done,
    // Label 7300: @369975
    GIM_Reject,
    // Label 7292: @369976
    GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(370006), // Rule ID 871 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 871,
      GIR_Done,
    // Label 7301: @370006
    GIM_Reject,
    // Label 7293: @370007
    GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(370037), // Rule ID 875 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 875,
      GIR_Done,
    // Label 7302: @370037
    GIM_Reject,
    // Label 7294: @370038
    GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(370068), // Rule ID 867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 867,
      GIR_Done,
    // Label 7303: @370068
    GIM_Reject,
    // Label 7295: @370069
    GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(370099), // Rule ID 873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 873,
      GIR_Done,
    // Label 7304: @370099
    GIM_Reject,
    // Label 7296: @370100
    GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(371253),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(370135), // Rule ID 869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 869,
        GIR_Done,
      // Label 7306: @370135
      GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(370320), // Rule ID 7158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7158,
        GIR_EraseRootFromParent_Done,
      // Label 7307: @370320
      GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(370455), // Rule ID 7160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fnearbyint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7160,
        GIR_EraseRootFromParent_Done,
      // Label 7308: @370455
      GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(371252), // Rule ID 7162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fnearbyint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7162,
        GIR_EraseRootFromParent_Done,
      // Label 7309: @371252
      GIM_Reject,
    // Label 7305: @371253
    GIM_Reject,
    // Label 7297: @371254
    GIM_Reject,
    // Label 98: @371255
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7318*/ GIMT_Encode4(373657),
    /*GILLT_s16*//*Label 7310*/ GIMT_Encode4(371306),
    /*GILLT_s32*//*Label 7311*/ GIMT_Encode4(371532),
    /*GILLT_s64*//*Label 7312*/ GIMT_Encode4(371758), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7313*/ GIMT_Encode4(371930),
    /*GILLT_v2s64*//*Label 7314*/ GIMT_Encode4(371968),
    /*GILLT_v4s16*//*Label 7315*/ GIMT_Encode4(372006),
    /*GILLT_v4s32*//*Label 7316*/ GIMT_Encode4(372044), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7317*/ GIMT_Encode4(372082),
    // Label 7310: @371306
    GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(371531),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(371412), // Rule ID 7076 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7076,
        GIR_EraseRootFromParent_Done,
      // Label 7320: @371412
      GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(371503), // Rule ID 13910 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13910,
        GIR_EraseRootFromParent_Done,
      // Label 7321: @371503
      GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(371530), // Rule ID 578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 578,
        GIR_Done,
      // Label 7322: @371530
      GIM_Reject,
    // Label 7319: @371531
    GIM_Reject,
    // Label 7311: @371532
    GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(371757),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(371638), // Rule ID 7074 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7074,
        GIR_EraseRootFromParent_Done,
      // Label 7324: @371638
      GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(371729), // Rule ID 13908 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13908,
        GIR_EraseRootFromParent_Done,
      // Label 7325: @371729
      GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(371756), // Rule ID 580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 580,
        GIR_Done,
      // Label 7326: @371756
      GIM_Reject,
    // Label 7323: @371757
    GIM_Reject,
    // Label 7312: @371758
    GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(371929),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(371837), // Rule ID 7072 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7072,
        GIR_EraseRootFromParent_Done,
      // Label 7328: @371837
      GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(371901), // Rule ID 13906 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13906,
        GIR_EraseRootFromParent_Done,
      // Label 7329: @371901
      GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(371928), // Rule ID 582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 582,
        GIR_Done,
      // Label 7330: @371928
      GIM_Reject,
    // Label 7327: @371929
    GIM_Reject,
    // Label 7313: @371930
    GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(371967), // Rule ID 1190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1190,
      GIR_Done,
    // Label 7331: @371967
    GIM_Reject,
    // Label 7314: @371968
    GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(372005), // Rule ID 1194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1194,
      GIR_Done,
    // Label 7332: @372005
    GIM_Reject,
    // Label 7315: @372006
    GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(372043), // Rule ID 1186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1186,
      GIR_Done,
    // Label 7333: @372043
    GIM_Reject,
    // Label 7316: @372044
    GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(372081), // Rule ID 1192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1192,
      GIR_Done,
    // Label 7334: @372081
    GIM_Reject,
    // Label 7317: @372082
    GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(373656),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(372124), // Rule ID 1188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1188,
        GIR_Done,
      // Label 7336: @372124
      GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(372378), // Rule ID 7187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7187,
        GIR_EraseRootFromParent_Done,
      // Label 7337: @372378
      GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(372582), // Rule ID 7189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (strict_fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7189,
        GIR_EraseRootFromParent_Done,
      // Label 7338: @372582
      GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(373655), // Rule ID 7191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (strict_fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7191,
        GIR_EraseRootFromParent_Done,
      // Label 7339: @373655
      GIM_Reject,
    // Label 7335: @373656
    GIM_Reject,
    // Label 7318: @373657
    GIM_Reject,
    // Label 99: @373658
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7348*/ GIMT_Encode4(375550),
    /*GILLT_s16*//*Label 7340*/ GIMT_Encode4(373709),
    /*GILLT_s32*//*Label 7341*/ GIMT_Encode4(373747),
    /*GILLT_s64*//*Label 7342*/ GIMT_Encode4(373785), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7343*/ GIMT_Encode4(373823),
    /*GILLT_v2s64*//*Label 7344*/ GIMT_Encode4(373861),
    /*GILLT_v4s16*//*Label 7345*/ GIMT_Encode4(373899),
    /*GILLT_v4s32*//*Label 7346*/ GIMT_Encode4(373937), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7347*/ GIMT_Encode4(373975),
    // Label 7340: @373709
    GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(373746), // Rule ID 626 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 626,
      GIR_Done,
    // Label 7349: @373746
    GIM_Reject,
    // Label 7341: @373747
    GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(373784), // Rule ID 628 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 628,
      GIR_Done,
    // Label 7350: @373784
    GIM_Reject,
    // Label 7342: @373785
    GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(373822), // Rule ID 630 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 630,
      GIR_Done,
    // Label 7351: @373822
    GIM_Reject,
    // Label 7343: @373823
    GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(373860), // Rule ID 1330 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1330,
      GIR_Done,
    // Label 7352: @373860
    GIM_Reject,
    // Label 7344: @373861
    GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(373898), // Rule ID 1334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1334,
      GIR_Done,
    // Label 7353: @373898
    GIM_Reject,
    // Label 7345: @373899
    GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(373936), // Rule ID 1326 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1326,
      GIR_Done,
    // Label 7354: @373936
    GIM_Reject,
    // Label 7346: @373937
    GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(373974), // Rule ID 1332 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1332,
      GIR_Done,
    // Label 7355: @373974
    GIM_Reject,
    // Label 7347: @373975
    GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(375549),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(374017), // Rule ID 1328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1328,
        GIR_Done,
      // Label 7357: @374017
      GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(374271), // Rule ID 7205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7205,
        GIR_EraseRootFromParent_Done,
      // Label 7358: @374271
      GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(374475), // Rule ID 7207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (strict_fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7207,
        GIR_EraseRootFromParent_Done,
      // Label 7359: @374475
      GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(375548), // Rule ID 7209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (strict_fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7209,
        GIR_EraseRootFromParent_Done,
      // Label 7360: @375548
      GIM_Reject,
    // Label 7356: @375549
    GIM_Reject,
    // Label 7348: @375550
    GIM_Reject,
    // Label 100: @375551
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7369*/ GIMT_Encode4(380565),
    /*GILLT_s16*//*Label 7361*/ GIMT_Encode4(375602),
    /*GILLT_s32*//*Label 7362*/ GIMT_Encode4(376156),
    /*GILLT_s64*//*Label 7363*/ GIMT_Encode4(376704), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7364*/ GIMT_Encode4(377252),
    /*GILLT_v2s64*//*Label 7365*/ GIMT_Encode4(377782),
    /*GILLT_v4s16*//*Label 7366*/ GIMT_Encode4(378140),
    /*GILLT_v4s32*//*Label 7367*/ GIMT_Encode4(378482), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7368*/ GIMT_Encode4(378840),
    // Label 7361: @375602
    GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(376155),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(375730), // Rule ID 6287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6287,
        GIR_EraseRootFromParent_Done,
      // Label 7371: @375730
      GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(375843), // Rule ID 13881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13881,
        GIR_EraseRootFromParent_Done,
      // Label 7372: @375843
      GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(375922), // Rule ID 13818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13818,
        GIR_EraseRootFromParent_Done,
      // Label 7373: @375922
      GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(376001), // Rule ID 4822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4822,
        GIR_EraseRootFromParent_Done,
      // Label 7374: @376001
      GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(376064), // Rule ID 13433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13433,
        GIR_EraseRootFromParent_Done,
      // Label 7375: @376064
      GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(376127), // Rule ID 1999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1999,
        GIR_EraseRootFromParent_Done,
      // Label 7376: @376127
      GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(376154), // Rule ID 614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 614,
        GIR_Done,
      // Label 7377: @376154
      GIM_Reject,
    // Label 7370: @376155
    GIM_Reject,
    // Label 7362: @376156
    GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(376703),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(376284), // Rule ID 6289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6289,
        GIR_EraseRootFromParent_Done,
      // Label 7379: @376284
      GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(376397), // Rule ID 13883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13883,
        GIR_EraseRootFromParent_Done,
      // Label 7380: @376397
      GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(376473), // Rule ID 13820 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13820,
        GIR_EraseRootFromParent_Done,
      // Label 7381: @376473
      GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(376549), // Rule ID 4824 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4824,
        GIR_EraseRootFromParent_Done,
      // Label 7382: @376549
      GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(376612), // Rule ID 13435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13435,
        GIR_EraseRootFromParent_Done,
      // Label 7383: @376612
      GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(376675), // Rule ID 2001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2001,
        GIR_EraseRootFromParent_Done,
      // Label 7384: @376675
      GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(376702), // Rule ID 616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 616,
        GIR_Done,
      // Label 7385: @376702
      GIM_Reject,
    // Label 7378: @376703
    GIM_Reject,
    // Label 7363: @376704
    GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(377251),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(376832), // Rule ID 6291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6291,
        GIR_EraseRootFromParent_Done,
      // Label 7387: @376832
      GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(376945), // Rule ID 13885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13885,
        GIR_EraseRootFromParent_Done,
      // Label 7388: @376945
      GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(377021), // Rule ID 13822 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13822,
        GIR_EraseRootFromParent_Done,
      // Label 7389: @377021
      GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(377097), // Rule ID 4826 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4826,
        GIR_EraseRootFromParent_Done,
      // Label 7390: @377097
      GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(377160), // Rule ID 13437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13437,
        GIR_EraseRootFromParent_Done,
      // Label 7391: @377160
      GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(377223), // Rule ID 2003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2003,
        GIR_EraseRootFromParent_Done,
      // Label 7392: @377223
      GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(377250), // Rule ID 618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 618,
        GIR_Done,
      // Label 7393: @377250
      GIM_Reject,
    // Label 7386: @377251
    GIM_Reject,
    // Label 7364: @377252
    GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(377781),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(377353), // Rule ID 13425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13425,
        GIR_EraseRootFromParent_Done,
      // Label 7395: @377353
      GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(377439), // Rule ID 1991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1991,
        GIR_EraseRootFromParent_Done,
      // Label 7396: @377439
      GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(377502), // Rule ID 13426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13426,
        GIR_EraseRootFromParent_Done,
      // Label 7397: @377502
      GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(377565), // Rule ID 1992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1992,
        GIR_EraseRootFromParent_Done,
      // Label 7398: @377565
      GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(377659), // Rule ID 13887 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13887,
        GIR_EraseRootFromParent_Done,
      // Label 7399: @377659
      GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(377753), // Rule ID 6293 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6293,
        GIR_EraseRootFromParent_Done,
      // Label 7400: @377753
      GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(377780), // Rule ID 1310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1310,
        GIR_Done,
      // Label 7401: @377780
      GIM_Reject,
    // Label 7394: @377781
    GIM_Reject,
    // Label 7365: @377782
    GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(378139),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(377860), // Rule ID 13431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13431,
        GIR_EraseRootFromParent_Done,
      // Label 7403: @377860
      GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(377923), // Rule ID 1997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1997,
        GIR_EraseRootFromParent_Done,
      // Label 7404: @377923
      GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(378017), // Rule ID 13891 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13891,
        GIR_EraseRootFromParent_Done,
      // Label 7405: @378017
      GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(378111), // Rule ID 6297 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6297,
        GIR_EraseRootFromParent_Done,
      // Label 7406: @378111
      GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(378138), // Rule ID 1314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1314,
        GIR_Done,
      // Label 7407: @378138
      GIM_Reject,
    // Label 7402: @378139
    GIM_Reject,
    // Label 7366: @378140
    GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(378481),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(378241), // Rule ID 13419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13419,
        GIR_EraseRootFromParent_Done,
      // Label 7409: @378241
      GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(378327), // Rule ID 1985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1985,
        GIR_EraseRootFromParent_Done,
      // Label 7410: @378327
      GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(378390), // Rule ID 13420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13420,
        GIR_EraseRootFromParent_Done,
      // Label 7411: @378390
      GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(378453), // Rule ID 1986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1986,
        GIR_EraseRootFromParent_Done,
      // Label 7412: @378453
      GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(378480), // Rule ID 1306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1306,
        GIR_Done,
      // Label 7413: @378480
      GIM_Reject,
    // Label 7408: @378481
    GIM_Reject,
    // Label 7367: @378482
    GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(378839),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(378560), // Rule ID 13429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13429,
        GIR_EraseRootFromParent_Done,
      // Label 7415: @378560
      GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(378623), // Rule ID 1995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1995,
        GIR_EraseRootFromParent_Done,
      // Label 7416: @378623
      GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(378717), // Rule ID 13889 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13889,
        GIR_EraseRootFromParent_Done,
      // Label 7417: @378717
      GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(378811), // Rule ID 6295 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6295,
        GIR_EraseRootFromParent_Done,
      // Label 7418: @378811
      GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(378838), // Rule ID 1312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1312,
        GIR_Done,
      // Label 7419: @378838
      GIM_Reject,
    // Label 7414: @378839
    GIM_Reject,
    // Label 7368: @378840
    GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(380564),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(378918), // Rule ID 13423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13423,
        GIR_EraseRootFromParent_Done,
      // Label 7421: @378918
      GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(378981), // Rule ID 1989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1989,
        GIR_EraseRootFromParent_Done,
      // Label 7422: @378981
      GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(379008), // Rule ID 1308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1308,
        GIR_Done,
      // Label 7423: @379008
      GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(379270), // Rule ID 7199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7199,
        GIR_EraseRootFromParent_Done,
      // Label 7424: @379270
      GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(379482), // Rule ID 7201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7201,
        GIR_EraseRootFromParent_Done,
      // Label 7425: @379482
      GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(380563), // Rule ID 7203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7203,
        GIR_EraseRootFromParent_Done,
      // Label 7426: @380563
      GIM_Reject,
    // Label 7420: @380564
    GIM_Reject,
    // Label 7369: @380565
    GIM_Reject,
    // Label 101: @380566
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7435*/ GIMT_Encode4(382458),
    /*GILLT_s16*//*Label 7427*/ GIMT_Encode4(380617),
    /*GILLT_s32*//*Label 7428*/ GIMT_Encode4(380655),
    /*GILLT_s64*//*Label 7429*/ GIMT_Encode4(380693), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7430*/ GIMT_Encode4(380731),
    /*GILLT_v2s64*//*Label 7431*/ GIMT_Encode4(380769),
    /*GILLT_v4s16*//*Label 7432*/ GIMT_Encode4(380807),
    /*GILLT_v4s32*//*Label 7433*/ GIMT_Encode4(380845), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7434*/ GIMT_Encode4(380883),
    // Label 7427: @380617
    GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(380654), // Rule ID 584 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 584,
      GIR_Done,
    // Label 7436: @380654
    GIM_Reject,
    // Label 7428: @380655
    GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(380692), // Rule ID 586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 586,
      GIR_Done,
    // Label 7437: @380692
    GIM_Reject,
    // Label 7429: @380693
    GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(380730), // Rule ID 588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 588,
      GIR_Done,
    // Label 7438: @380730
    GIM_Reject,
    // Label 7430: @380731
    GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(380768), // Rule ID 1215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1215,
      GIR_Done,
    // Label 7439: @380768
    GIM_Reject,
    // Label 7431: @380769
    GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(380806), // Rule ID 1219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1219,
      GIR_Done,
    // Label 7440: @380806
    GIM_Reject,
    // Label 7432: @380807
    GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(380844), // Rule ID 1211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1211,
      GIR_Done,
    // Label 7441: @380844
    GIM_Reject,
    // Label 7433: @380845
    GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(380882), // Rule ID 1217 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1217,
      GIR_Done,
    // Label 7442: @380882
    GIM_Reject,
    // Label 7434: @380883
    GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(382457),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(380925), // Rule ID 1213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1213,
        GIR_Done,
      // Label 7444: @380925
      GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(381179), // Rule ID 7193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7193,
        GIR_EraseRootFromParent_Done,
      // Label 7445: @381179
      GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(381383), // Rule ID 7195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (strict_fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7195,
        GIR_EraseRootFromParent_Done,
      // Label 7446: @381383
      GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(382456), // Rule ID 7197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (strict_fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7197,
        GIR_EraseRootFromParent_Done,
      // Label 7447: @382456
      GIM_Reject,
    // Label 7443: @382457
    GIM_Reject,
    // Label 7435: @382458
    GIM_Reject,
    // Label 102: @382459
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7456*/ GIMT_Encode4(398065),
    /*GILLT_s16*//*Label 7448*/ GIMT_Encode4(382510),
    /*GILLT_s32*//*Label 7449*/ GIMT_Encode4(385284),
    /*GILLT_s64*//*Label 7450*/ GIMT_Encode4(388214), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7451*/ GIMT_Encode4(391144),
    /*GILLT_v2s64*//*Label 7452*/ GIMT_Encode4(392665),
    /*GILLT_v4s16*//*Label 7453*/ GIMT_Encode4(394186),
    /*GILLT_v4s32*//*Label 7454*/ GIMT_Encode4(395365), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7455*/ GIMT_Encode4(396886),
    // Label 7448: @382510
    GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(385283),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(382678), // Rule ID 4884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4884,
        GIR_EraseRootFromParent_Done,
      // Label 7458: @382678
      GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(382825), // Rule ID 4848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4848,
        GIR_EraseRootFromParent_Done,
      // Label 7459: @382825
      GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(382972), // Rule ID 13831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13831,
        GIR_EraseRootFromParent_Done,
      // Label 7460: @382972
      GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(383103), // Rule ID 6125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6125,
        GIR_EraseRootFromParent_Done,
      // Label 7461: @383103
      GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(383234), // Rule ID 6157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6157,
        GIR_EraseRootFromParent_Done,
      // Label 7462: @383234
      GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(383365), // Rule ID 6221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6221,
        GIR_EraseRootFromParent_Done,
      // Label 7463: @383365
      GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(383496), // Rule ID 6189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6189,
        GIR_EraseRootFromParent_Done,
      // Label 7464: @383496
      GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(383631), // Rule ID 2423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2423,
        GIR_EraseRootFromParent_Done,
      // Label 7465: @383631
      GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(383750), // Rule ID 6093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6093,
        GIR_EraseRootFromParent_Done,
      // Label 7466: @383750
      GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(383869), // Rule ID 2495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2495,
        GIR_EraseRootFromParent_Done,
      // Label 7467: @383869
      GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(383969), // Rule ID 4846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4846,
        GIR_EraseRootFromParent_Done,
      // Label 7468: @383969
      GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(384069), // Rule ID 4882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4882,
        GIR_EraseRootFromParent_Done,
      // Label 7469: @384069
      GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(384166), // Rule ID 13827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13827,
        GIR_EraseRootFromParent_Done,
      // Label 7470: @384166
      GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(384266), // Rule ID 13829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13829,
        GIR_EraseRootFromParent_Done,
      // Label 7471: @384266
      GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(384366), // Rule ID 4880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4880,
        GIR_EraseRootFromParent_Done,
      // Label 7472: @384366
      GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(384463), // Rule ID 4844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4844,
        GIR_EraseRootFromParent_Done,
      // Label 7473: @384463
      GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(384547), // Rule ID 6155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6155,
        GIR_EraseRootFromParent_Done,
      // Label 7474: @384547
      GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(384628), // Rule ID 6187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6187,
        GIR_EraseRootFromParent_Done,
      // Label 7475: @384628
      GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(384712), // Rule ID 6219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6219,
        GIR_EraseRootFromParent_Done,
      // Label 7476: @384712
      GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(384793), // Rule ID 6123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6123,
        GIR_EraseRootFromParent_Done,
      // Label 7477: @384793
      GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(384878), // Rule ID 2421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2421,
        GIR_EraseRootFromParent_Done,
      // Label 7478: @384878
      GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(384963), // Rule ID 2419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2419,
        GIR_EraseRootFromParent_Done,
      // Label 7479: @384963
      GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(385032), // Rule ID 2493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2493,
        GIR_EraseRootFromParent_Done,
      // Label 7480: @385032
      GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(385101), // Rule ID 6091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6091,
        GIR_EraseRootFromParent_Done,
      // Label 7481: @385101
      GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(385151), // Rule ID 13273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13273,
        GIR_EraseRootFromParent_Done,
      // Label 7482: @385151
      GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(385201), // Rule ID 638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 638,
        GIR_EraseRootFromParent_Done,
      // Label 7483: @385201
      GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(385251), // Rule ID 650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 650,
        GIR_EraseRootFromParent_Done,
      // Label 7484: @385251
      GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(385282), // Rule ID 632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 632,
        GIR_Done,
      // Label 7485: @385282
      GIM_Reject,
    // Label 7457: @385283
    GIM_Reject,
    // Label 7449: @385284
    GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388213),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(385452), // Rule ID 4890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4890,
        GIR_EraseRootFromParent_Done,
      // Label 7487: @385452
      GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(385599), // Rule ID 4854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4854,
        GIR_EraseRootFromParent_Done,
      // Label 7488: @385599
      GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(385746), // Rule ID 13837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13837,
        GIR_EraseRootFromParent_Done,
      // Label 7489: @385746
      GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(385877), // Rule ID 6141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6141,
        GIR_EraseRootFromParent_Done,
      // Label 7490: @385877
      GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(386008), // Rule ID 6173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6173,
        GIR_EraseRootFromParent_Done,
      // Label 7491: @386008
      GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(386139), // Rule ID 6237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6237,
        GIR_EraseRootFromParent_Done,
      // Label 7492: @386139
      GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(386270), // Rule ID 6205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6205,
        GIR_EraseRootFromParent_Done,
      // Label 7493: @386270
      GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(386405), // Rule ID 2429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2429,
        GIR_EraseRootFromParent_Done,
      // Label 7494: @386405
      GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(386524), // Rule ID 6109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6109,
        GIR_EraseRootFromParent_Done,
      // Label 7495: @386524
      GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(386643), // Rule ID 2511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2511,
        GIR_EraseRootFromParent_Done,
      // Label 7496: @386643
      GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(386743), // Rule ID 4852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4852,
        GIR_EraseRootFromParent_Done,
      // Label 7497: @386743
      GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(386843), // Rule ID 4888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4888,
        GIR_EraseRootFromParent_Done,
      // Label 7498: @386843
      GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(386940), // Rule ID 13833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13833,
        GIR_EraseRootFromParent_Done,
      // Label 7499: @386940
      GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(387040), // Rule ID 13835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13835,
        GIR_EraseRootFromParent_Done,
      // Label 7500: @387040
      GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(387140), // Rule ID 4886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4886,
        GIR_EraseRootFromParent_Done,
      // Label 7501: @387140
      GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(387237), // Rule ID 4850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4850,
        GIR_EraseRootFromParent_Done,
      // Label 7502: @387237
      GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(387315), // Rule ID 6259 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6259,
        GIR_EraseRootFromParent_Done,
      // Label 7503: @387315
      GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(387399), // Rule ID 6171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6171,
        GIR_EraseRootFromParent_Done,
      // Label 7504: @387399
      GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(387480), // Rule ID 6203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6203,
        GIR_EraseRootFromParent_Done,
      // Label 7505: @387480
      GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(387564), // Rule ID 6235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6235,
        GIR_EraseRootFromParent_Done,
      // Label 7506: @387564
      GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(387642), // Rule ID 6281 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6281,
        GIR_EraseRootFromParent_Done,
      // Label 7507: @387642
      GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(387723), // Rule ID 6139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6139,
        GIR_EraseRootFromParent_Done,
      // Label 7508: @387723
      GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(387808), // Rule ID 2427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2427,
        GIR_EraseRootFromParent_Done,
      // Label 7509: @387808
      GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(387893), // Rule ID 2425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2425,
        GIR_EraseRootFromParent_Done,
      // Label 7510: @387893
      GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(387962), // Rule ID 2509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2509,
        GIR_EraseRootFromParent_Done,
      // Label 7511: @387962
      GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(388031), // Rule ID 6107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6107,
        GIR_EraseRootFromParent_Done,
      // Label 7512: @388031
      GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(388081), // Rule ID 13275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13275,
        GIR_EraseRootFromParent_Done,
      // Label 7513: @388081
      GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(388131), // Rule ID 640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 640,
        GIR_EraseRootFromParent_Done,
      // Label 7514: @388131
      GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(388181), // Rule ID 652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 652,
        GIR_EraseRootFromParent_Done,
      // Label 7515: @388181
      GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(388212), // Rule ID 634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 634,
        GIR_Done,
      // Label 7516: @388212
      GIM_Reject,
    // Label 7486: @388213
    GIM_Reject,
    // Label 7450: @388214
    GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(391143),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(388382), // Rule ID 4896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4896,
        GIR_EraseRootFromParent_Done,
      // Label 7518: @388382
      GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(388529), // Rule ID 4860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4860,
        GIR_EraseRootFromParent_Done,
      // Label 7519: @388529
      GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(388676), // Rule ID 13843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13843,
        GIR_EraseRootFromParent_Done,
      // Label 7520: @388676
      GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(388807), // Rule ID 6145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6145,
        GIR_EraseRootFromParent_Done,
      // Label 7521: @388807
      GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(388938), // Rule ID 6177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6177,
        GIR_EraseRootFromParent_Done,
      // Label 7522: @388938
      GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(389069), // Rule ID 6241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6241,
        GIR_EraseRootFromParent_Done,
      // Label 7523: @389069
      GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(389200), // Rule ID 6209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6209,
        GIR_EraseRootFromParent_Done,
      // Label 7524: @389200
      GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(389335), // Rule ID 2435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2435,
        GIR_EraseRootFromParent_Done,
      // Label 7525: @389335
      GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(389454), // Rule ID 6113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6113,
        GIR_EraseRootFromParent_Done,
      // Label 7526: @389454
      GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(389573), // Rule ID 2515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2515,
        GIR_EraseRootFromParent_Done,
      // Label 7527: @389573
      GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(389673), // Rule ID 4858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4858,
        GIR_EraseRootFromParent_Done,
      // Label 7528: @389673
      GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(389773), // Rule ID 4894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4894,
        GIR_EraseRootFromParent_Done,
      // Label 7529: @389773
      GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(389870), // Rule ID 13839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13839,
        GIR_EraseRootFromParent_Done,
      // Label 7530: @389870
      GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(389970), // Rule ID 13841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13841,
        GIR_EraseRootFromParent_Done,
      // Label 7531: @389970
      GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390070), // Rule ID 4892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4892,
        GIR_EraseRootFromParent_Done,
      // Label 7532: @390070
      GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390167), // Rule ID 4856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4856,
        GIR_EraseRootFromParent_Done,
      // Label 7533: @390167
      GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390245), // Rule ID 6263 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6263,
        GIR_EraseRootFromParent_Done,
      // Label 7534: @390245
      GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(390329), // Rule ID 6175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6175,
        GIR_EraseRootFromParent_Done,
      // Label 7535: @390329
      GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(390410), // Rule ID 6207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6207,
        GIR_EraseRootFromParent_Done,
      // Label 7536: @390410
      GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(390494), // Rule ID 6239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6239,
        GIR_EraseRootFromParent_Done,
      // Label 7537: @390494
      GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(390572), // Rule ID 6285 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6285,
        GIR_EraseRootFromParent_Done,
      // Label 7538: @390572
      GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390653), // Rule ID 6143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6143,
        GIR_EraseRootFromParent_Done,
      // Label 7539: @390653
      GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(390738), // Rule ID 2433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2433,
        GIR_EraseRootFromParent_Done,
      // Label 7540: @390738
      GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(390823), // Rule ID 2431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2431,
        GIR_EraseRootFromParent_Done,
      // Label 7541: @390823
      GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(390892), // Rule ID 2513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2513,
        GIR_EraseRootFromParent_Done,
      // Label 7542: @390892
      GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(390961), // Rule ID 6111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6111,
        GIR_EraseRootFromParent_Done,
      // Label 7543: @390961
      GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(391011), // Rule ID 13277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13277,
        GIR_EraseRootFromParent_Done,
      // Label 7544: @391011
      GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(391061), // Rule ID 642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 642,
        GIR_EraseRootFromParent_Done,
      // Label 7545: @391061
      GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(391111), // Rule ID 654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 654,
        GIR_EraseRootFromParent_Done,
      // Label 7546: @391111
      GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(391142), // Rule ID 636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 636,
        GIR_Done,
      // Label 7547: @391142
      GIM_Reject,
    // Label 7517: @391143
    GIM_Reject,
    // Label 7451: @391144
    GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(392664),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(391240), // Rule ID 6243 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6243,
        GIR_EraseRootFromParent_Done,
      // Label 7549: @391240
      GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(391324), // Rule ID 6159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6159,
        GIR_EraseRootFromParent_Done,
      // Label 7550: @391324
      GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(391405), // Rule ID 6191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6191,
        GIR_EraseRootFromParent_Done,
      // Label 7551: @391405
      GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(391489), // Rule ID 6223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6223,
        GIR_EraseRootFromParent_Done,
      // Label 7552: @391489
      GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391567), // Rule ID 6265 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6265,
        GIR_EraseRootFromParent_Done,
      // Label 7553: @391567
      GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391648), // Rule ID 6127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6127,
        GIR_EraseRootFromParent_Done,
      // Label 7554: @391648
      GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391717), // Rule ID 2497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2497,
        GIR_EraseRootFromParent_Done,
      // Label 7555: @391717
      GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(391786), // Rule ID 6095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6095,
        GIR_EraseRootFromParent_Done,
      // Label 7556: @391786
      GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(391879), // Rule ID 6247 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6247,
        GIR_EraseRootFromParent_Done,
      // Label 7557: @391879
      GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(391978), // Rule ID 6161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6161,
        GIR_EraseRootFromParent_Done,
      // Label 7558: @391978
      GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(392074), // Rule ID 6193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6193,
        GIR_EraseRootFromParent_Done,
      // Label 7559: @392074
      GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(392173), // Rule ID 6225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6225,
        GIR_EraseRootFromParent_Done,
      // Label 7560: @392173
      GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(392266), // Rule ID 6269 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6269,
        GIR_EraseRootFromParent_Done,
      // Label 7561: @392266
      GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(392362), // Rule ID 6129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6129,
        GIR_EraseRootFromParent_Done,
      // Label 7562: @392362
      GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(392446), // Rule ID 2499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2499,
        GIR_EraseRootFromParent_Done,
      // Label 7563: @392446
      GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(392496), // Rule ID 13307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13307,
        GIR_EraseRootFromParent_Done,
      // Label 7564: @392496
      GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(392580), // Rule ID 6097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6097,
        GIR_EraseRootFromParent_Done,
      // Label 7565: @392580
      GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(392630), // Rule ID 1295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1295,
        GIR_EraseRootFromParent_Done,
      // Label 7566: @392630
      GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(392663), // Rule ID 1285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1285,
        GIR_EraseRootFromParent_Done,
      // Label 7567: @392663
      GIM_Reject,
    // Label 7548: @392664
    GIM_Reject,
    // Label 7452: @392665
    GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(394185),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(392761), // Rule ID 6255 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6255,
        GIR_EraseRootFromParent_Done,
      // Label 7569: @392761
      GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(392845), // Rule ID 6167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6167,
        GIR_EraseRootFromParent_Done,
      // Label 7570: @392845
      GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(392926), // Rule ID 6199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6199,
        GIR_EraseRootFromParent_Done,
      // Label 7571: @392926
      GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(393010), // Rule ID 6231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6231,
        GIR_EraseRootFromParent_Done,
      // Label 7572: @393010
      GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(393088), // Rule ID 6277 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6277,
        GIR_EraseRootFromParent_Done,
      // Label 7573: @393088
      GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(393169), // Rule ID 6135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6135,
        GIR_EraseRootFromParent_Done,
      // Label 7574: @393169
      GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(393238), // Rule ID 2505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2505,
        GIR_EraseRootFromParent_Done,
      // Label 7575: @393238
      GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(393307), // Rule ID 6103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6103,
        GIR_EraseRootFromParent_Done,
      // Label 7576: @393307
      GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(393400), // Rule ID 6257 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6257,
        GIR_EraseRootFromParent_Done,
      // Label 7577: @393400
      GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(393499), // Rule ID 6169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6169,
        GIR_EraseRootFromParent_Done,
      // Label 7578: @393499
      GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(393595), // Rule ID 6201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6201,
        GIR_EraseRootFromParent_Done,
      // Label 7579: @393595
      GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(393694), // Rule ID 6233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6233,
        GIR_EraseRootFromParent_Done,
      // Label 7580: @393694
      GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(393787), // Rule ID 6279 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6279,
        GIR_EraseRootFromParent_Done,
      // Label 7581: @393787
      GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(393883), // Rule ID 6137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6137,
        GIR_EraseRootFromParent_Done,
      // Label 7582: @393883
      GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(393967), // Rule ID 2507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2507,
        GIR_EraseRootFromParent_Done,
      // Label 7583: @393967
      GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(394017), // Rule ID 13311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13311,
        GIR_EraseRootFromParent_Done,
      // Label 7584: @394017
      GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(394101), // Rule ID 6105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6105,
        GIR_EraseRootFromParent_Done,
      // Label 7585: @394101
      GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(394151), // Rule ID 1299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1299,
        GIR_EraseRootFromParent_Done,
      // Label 7586: @394151
      GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(394184), // Rule ID 1289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1289,
        GIR_EraseRootFromParent_Done,
      // Label 7587: @394184
      GIM_Reject,
    // Label 7568: @394185
    GIM_Reject,
    // Label 7453: @394186
    GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(395364),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(394288), // Rule ID 6151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6151,
        GIR_EraseRootFromParent_Done,
      // Label 7589: @394288
      GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(394369), // Rule ID 6183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6183,
        GIR_EraseRootFromParent_Done,
      // Label 7590: @394369
      GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(394453), // Rule ID 6215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6215,
        GIR_EraseRootFromParent_Done,
      // Label 7591: @394453
      GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(394534), // Rule ID 6119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6119,
        GIR_EraseRootFromParent_Done,
      // Label 7592: @394534
      GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(394603), // Rule ID 2489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2489,
        GIR_EraseRootFromParent_Done,
      // Label 7593: @394603
      GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(394672), // Rule ID 6087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6087,
        GIR_EraseRootFromParent_Done,
      // Label 7594: @394672
      GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(394771), // Rule ID 6153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6153,
        GIR_EraseRootFromParent_Done,
      // Label 7595: @394771
      GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(394867), // Rule ID 6185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6185,
        GIR_EraseRootFromParent_Done,
      // Label 7596: @394867
      GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(394966), // Rule ID 6217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6217,
        GIR_EraseRootFromParent_Done,
      // Label 7597: @394966
      GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(395062), // Rule ID 6121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6121,
        GIR_EraseRootFromParent_Done,
      // Label 7598: @395062
      GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(395146), // Rule ID 2491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2491,
        GIR_EraseRootFromParent_Done,
      // Label 7599: @395146
      GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(395196), // Rule ID 13303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13303,
        GIR_EraseRootFromParent_Done,
      // Label 7600: @395196
      GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(395280), // Rule ID 6089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6089,
        GIR_EraseRootFromParent_Done,
      // Label 7601: @395280
      GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(395330), // Rule ID 1291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1291,
        GIR_EraseRootFromParent_Done,
      // Label 7602: @395330
      GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(395363), // Rule ID 1281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1281,
        GIR_EraseRootFromParent_Done,
      // Label 7603: @395363
      GIM_Reject,
    // Label 7588: @395364
    GIM_Reject,
    // Label 7454: @395365
    GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(396885),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(395461), // Rule ID 6249 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6249,
        GIR_EraseRootFromParent_Done,
      // Label 7605: @395461
      GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(395545), // Rule ID 6163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6163,
        GIR_EraseRootFromParent_Done,
      // Label 7606: @395545
      GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(395626), // Rule ID 6195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6195,
        GIR_EraseRootFromParent_Done,
      // Label 7607: @395626
      GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(395710), // Rule ID 6227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6227,
        GIR_EraseRootFromParent_Done,
      // Label 7608: @395710
      GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(395788), // Rule ID 6271 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6271,
        GIR_EraseRootFromParent_Done,
      // Label 7609: @395788
      GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(395869), // Rule ID 6131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6131,
        GIR_EraseRootFromParent_Done,
      // Label 7610: @395869
      GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(395938), // Rule ID 2501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2501,
        GIR_EraseRootFromParent_Done,
      // Label 7611: @395938
      GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(396007), // Rule ID 6099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6099,
        GIR_EraseRootFromParent_Done,
      // Label 7612: @396007
      GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(396100), // Rule ID 6253 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6253,
        GIR_EraseRootFromParent_Done,
      // Label 7613: @396100
      GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(396199), // Rule ID 6165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6165,
        GIR_EraseRootFromParent_Done,
      // Label 7614: @396199
      GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(396295), // Rule ID 6197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6197,
        GIR_EraseRootFromParent_Done,
      // Label 7615: @396295
      GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(396394), // Rule ID 6229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6229,
        GIR_EraseRootFromParent_Done,
      // Label 7616: @396394
      GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(396487), // Rule ID 6275 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6275,
        GIR_EraseRootFromParent_Done,
      // Label 7617: @396487
      GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(396583), // Rule ID 6133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6133,
        GIR_EraseRootFromParent_Done,
      // Label 7618: @396583
      GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(396667), // Rule ID 2503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2503,
        GIR_EraseRootFromParent_Done,
      // Label 7619: @396667
      GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(396717), // Rule ID 13309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13309,
        GIR_EraseRootFromParent_Done,
      // Label 7620: @396717
      GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(396801), // Rule ID 6101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6101,
        GIR_EraseRootFromParent_Done,
      // Label 7621: @396801
      GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(396851), // Rule ID 1297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1297,
        GIR_EraseRootFromParent_Done,
      // Label 7622: @396851
      GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(396884), // Rule ID 1287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1287,
        GIR_EraseRootFromParent_Done,
      // Label 7623: @396884
      GIM_Reject,
    // Label 7604: @396885
    GIM_Reject,
    // Label 7455: @396886
    GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(398064),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(396988), // Rule ID 6147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6147,
        GIR_EraseRootFromParent_Done,
      // Label 7625: @396988
      GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(397069), // Rule ID 6179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6179,
        GIR_EraseRootFromParent_Done,
      // Label 7626: @397069
      GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(397153), // Rule ID 6211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6211,
        GIR_EraseRootFromParent_Done,
      // Label 7627: @397153
      GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(397234), // Rule ID 6115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6115,
        GIR_EraseRootFromParent_Done,
      // Label 7628: @397234
      GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(397303), // Rule ID 2485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2485,
        GIR_EraseRootFromParent_Done,
      // Label 7629: @397303
      GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(397372), // Rule ID 6083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6083,
        GIR_EraseRootFromParent_Done,
      // Label 7630: @397372
      GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(397471), // Rule ID 6149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6149,
        GIR_EraseRootFromParent_Done,
      // Label 7631: @397471
      GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(397567), // Rule ID 6181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6181,
        GIR_EraseRootFromParent_Done,
      // Label 7632: @397567
      GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(397666), // Rule ID 6213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6213,
        GIR_EraseRootFromParent_Done,
      // Label 7633: @397666
      GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(397762), // Rule ID 6117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6117,
        GIR_EraseRootFromParent_Done,
      // Label 7634: @397762
      GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(397846), // Rule ID 2487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2487,
        GIR_EraseRootFromParent_Done,
      // Label 7635: @397846
      GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(397896), // Rule ID 13305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13305,
        GIR_EraseRootFromParent_Done,
      // Label 7636: @397896
      GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(397980), // Rule ID 6085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6085,
        GIR_EraseRootFromParent_Done,
      // Label 7637: @397980
      GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(398030), // Rule ID 1293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1293,
        GIR_EraseRootFromParent_Done,
      // Label 7638: @398030
      GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(398063), // Rule ID 1283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1283,
        GIR_EraseRootFromParent_Done,
      // Label 7639: @398063
      GIM_Reject,
    // Label 7624: @398064
    GIM_Reject,
    // Label 7456: @398065
    GIM_Reject,
    // Label 103: @398066
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7648*/ GIMT_Encode4(398365),
    /*GILLT_s16*//*Label 7640*/ GIMT_Encode4(398117),
    /*GILLT_s32*//*Label 7641*/ GIMT_Encode4(398148),
    /*GILLT_s64*//*Label 7642*/ GIMT_Encode4(398179), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7643*/ GIMT_Encode4(398210),
    /*GILLT_v2s64*//*Label 7644*/ GIMT_Encode4(398241),
    /*GILLT_v4s16*//*Label 7645*/ GIMT_Encode4(398272),
    /*GILLT_v4s32*//*Label 7646*/ GIMT_Encode4(398303), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7647*/ GIMT_Encode4(398334),
    // Label 7640: @398117
    GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(398147), // Rule ID 564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 564,
      GIR_Done,
    // Label 7649: @398147
    GIM_Reject,
    // Label 7641: @398148
    GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(398178), // Rule ID 566 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 566,
      GIR_Done,
    // Label 7650: @398178
    GIM_Reject,
    // Label 7642: @398179
    GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(398209), // Rule ID 568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 568,
      GIR_Done,
    // Label 7651: @398209
    GIM_Reject,
    // Label 7643: @398210
    GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(398240), // Rule ID 947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 947,
      GIR_Done,
    // Label 7652: @398240
    GIM_Reject,
    // Label 7644: @398241
    GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(398271), // Rule ID 951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 951,
      GIR_Done,
    // Label 7653: @398271
    GIM_Reject,
    // Label 7645: @398272
    GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(398302), // Rule ID 943 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 943,
      GIR_Done,
    // Label 7654: @398302
    GIM_Reject,
    // Label 7646: @398303
    GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(398333), // Rule ID 949 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 949,
      GIR_Done,
    // Label 7655: @398333
    GIM_Reject,
    // Label 7647: @398334
    GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(398364), // Rule ID 945 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 945,
      GIR_Done,
    // Label 7656: @398364
    GIM_Reject,
    // Label 7648: @398365
    GIM_Reject,
    // Label 104: @398366
    GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(398379), // Rule ID 6588 //
      // (trap)  =>  (BRK 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6588,
      GIR_EraseRootFromParent_Done,
    // Label 7657: @398379
    GIM_Reject,
    // Label 105: @398380
    GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(398400), // Rule ID 6589 //
      // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6589,
      GIR_EraseRootFromParent_Done,
    // Label 7658: @398400
    GIM_Reject,
    // Label 106: @398401
    GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(398425), // Rule ID 6590 //
      // MIs[0] kind
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
      // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
      GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6590,
      GIR_EraseRootFromParent_Done,
    // Label 7659: @398425
    GIM_Reject,
    // Label 107: @398426
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7663*/ GIMT_Encode4(398735),
    /*GILLT_s16*//*Label 7660*/ GIMT_Encode4(398449),
    /*GILLT_s32*//*Label 7661*/ GIMT_Encode4(398602),
    /*GILLT_s64*//*Label 7662*/ GIMT_Encode4(398707),
    // Label 7660: @398449
    GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(398550), // Rule ID 5639 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5639,
      GIR_EraseRootFromParent_Done,
    // Label 7664: @398550
    GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(398601), // Rule ID 5640 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5640,
      GIR_EraseRootFromParent_Done,
    // Label 7665: @398601
    GIM_Reject,
    // Label 7661: @398602
    GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(398679), // Rule ID 5641 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5641,
      GIR_EraseRootFromParent_Done,
    // Label 7666: @398679
    GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(398706), // Rule ID 5642 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5642,
      GIR_Done,
    // Label 7667: @398706
    GIM_Reject,
    // Label 7662: @398707
    GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(398734), // Rule ID 5643 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5643,
      GIR_Done,
    // Label 7668: @398734
    GIM_Reject,
    // Label 7663: @398735
    GIM_Reject,
    // Label 108: @398736
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7672*/ GIMT_Encode4(398906),
    /*GILLT_s16*//*Label 7669*/ GIMT_Encode4(398759),
    /*GILLT_s32*//*Label 7670*/ GIMT_Encode4(398820),
    /*GILLT_s64*//*Label 7671*/ GIMT_Encode4(398878),
    // Label 7669: @398759
    GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(398789), // Rule ID 1930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1930,
      GIR_Done,
    // Label 7673: @398789
    GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(398819), // Rule ID 1932 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1932,
      GIR_Done,
    // Label 7674: @398819
    GIM_Reject,
    // Label 7670: @398820
    GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(398850), // Rule ID 1934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1934,
      GIR_Done,
    // Label 7675: @398850
    GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(398877), // Rule ID 5649 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5649,
      GIR_Done,
    // Label 7676: @398877
    GIM_Reject,
    // Label 7671: @398878
    GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(398905), // Rule ID 5651 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5651,
      GIR_Done,
    // Label 7677: @398905
    GIM_Reject,
    // Label 7672: @398906
    GIM_Reject,
    // Label 109: @398907
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7681*/ GIMT_Encode4(399077),
    /*GILLT_s16*//*Label 7678*/ GIMT_Encode4(398930),
    /*GILLT_s32*//*Label 7679*/ GIMT_Encode4(398991),
    /*GILLT_s64*//*Label 7680*/ GIMT_Encode4(399049),
    // Label 7678: @398930
    GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(398960), // Rule ID 1942 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1942,
      GIR_Done,
    // Label 7682: @398960
    GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(398990), // Rule ID 1944 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1944,
      GIR_Done,
    // Label 7683: @398990
    GIM_Reject,
    // Label 7679: @398991
    GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(399021), // Rule ID 1946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1946,
      GIR_Done,
    // Label 7684: @399021
    GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(399048), // Rule ID 5657 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5657,
      GIR_Done,
    // Label 7685: @399048
    GIM_Reject,
    // Label 7680: @399049
    GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(399076), // Rule ID 5659 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5659,
      GIR_Done,
    // Label 7686: @399076
    GIM_Reject,
    // Label 7681: @399077
    GIM_Reject,
    // Label 110: @399078
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7690*/ GIMT_Encode4(399248),
    /*GILLT_s16*//*Label 7687*/ GIMT_Encode4(399101),
    /*GILLT_s32*//*Label 7688*/ GIMT_Encode4(399162),
    /*GILLT_s64*//*Label 7689*/ GIMT_Encode4(399220),
    // Label 7687: @399101
    GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(399131), // Rule ID 1936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1936,
      GIR_Done,
    // Label 7691: @399131
    GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(399161), // Rule ID 1938 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1938,
      GIR_Done,
    // Label 7692: @399161
    GIM_Reject,
    // Label 7688: @399162
    GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(399192), // Rule ID 1940 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1940,
      GIR_Done,
    // Label 7693: @399192
    GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(399219), // Rule ID 5653 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5653,
      GIR_Done,
    // Label 7694: @399219
    GIM_Reject,
    // Label 7689: @399220
    GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(399247), // Rule ID 5655 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5655,
      GIR_Done,
    // Label 7695: @399247
    GIM_Reject,
    // Label 7690: @399248
    GIM_Reject,
    // Label 111: @399249
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7699*/ GIMT_Encode4(399419),
    /*GILLT_s16*//*Label 7696*/ GIMT_Encode4(399272),
    /*GILLT_s32*//*Label 7697*/ GIMT_Encode4(399333),
    /*GILLT_s64*//*Label 7698*/ GIMT_Encode4(399391),
    // Label 7696: @399272
    GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(399302), // Rule ID 1948 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1948,
      GIR_Done,
    // Label 7700: @399302
    GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(399332), // Rule ID 1950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1950,
      GIR_Done,
    // Label 7701: @399332
    GIM_Reject,
    // Label 7697: @399333
    GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(399363), // Rule ID 1952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1952,
      GIR_Done,
    // Label 7702: @399363
    GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(399390), // Rule ID 5661 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5661,
      GIR_Done,
    // Label 7703: @399390
    GIM_Reject,
    // Label 7698: @399391
    GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(399418), // Rule ID 5663 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5663,
      GIR_Done,
    // Label 7704: @399418
    GIM_Reject,
    // Label 7699: @399419
    GIM_Reject,
    // Label 112: @399420
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7709*/ GIMT_Encode4(400548),
    /*GILLT_s8*//*Label 7705*/ GIMT_Encode4(399447),
    /*GILLT_s16*//*Label 7706*/ GIMT_Encode4(399494),
    /*GILLT_s32*//*Label 7707*/ GIMT_Encode4(399909),
    /*GILLT_s64*//*Label 7708*/ GIMT_Encode4(400362),
    // Label 7705: @399447
    GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(399470), // Rule ID 5944 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5944,
      GIR_Done,
    // Label 7710: @399470
    GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(399493), // Rule ID 5945 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5945,
      GIR_Done,
    // Label 7711: @399493
    GIM_Reject,
    // Label 7706: @399494
    GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(399544), // Rule ID 5891 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5891,
      GIR_EraseRootFromParent_Done,
    // Label 7712: @399544
    GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(399594), // Rule ID 5893 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5893,
      GIR_EraseRootFromParent_Done,
    // Label 7713: @399594
    GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(399644), // Rule ID 5901 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5901,
      GIR_EraseRootFromParent_Done,
    // Label 7714: @399644
    GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(399694), // Rule ID 5903 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5903,
      GIR_EraseRootFromParent_Done,
    // Label 7715: @399694
    GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(399736), // Rule ID 5900 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5900,
      GIR_EraseRootFromParent_Done,
    // Label 7716: @399736
    GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(399778), // Rule ID 5902 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5902,
      GIR_EraseRootFromParent_Done,
    // Label 7717: @399778
    GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(399820), // Rule ID 5890 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5890,
      GIR_EraseRootFromParent_Done,
    // Label 7718: @399820
    GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(399862), // Rule ID 5892 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5892,
      GIR_EraseRootFromParent_Done,
    // Label 7719: @399862
    GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(399885), // Rule ID 5946 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5946,
      GIR_Done,
    // Label 7720: @399885
    GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(399908), // Rule ID 5947 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5947,
      GIR_Done,
    // Label 7721: @399908
    GIM_Reject,
    // Label 7707: @399909
    GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(399959), // Rule ID 5895 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5895,
      GIR_EraseRootFromParent_Done,
    // Label 7722: @399959
    GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(400009), // Rule ID 5897 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5897,
      GIR_EraseRootFromParent_Done,
    // Label 7723: @400009
    GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(400059), // Rule ID 5905 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5905,
      GIR_EraseRootFromParent_Done,
    // Label 7724: @400059
    GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(400109), // Rule ID 5907 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5907,
      GIR_EraseRootFromParent_Done,
    // Label 7725: @400109
    GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(400151), // Rule ID 5904 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5904,
      GIR_EraseRootFromParent_Done,
    // Label 7726: @400151
    GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(400193), // Rule ID 5906 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5906,
      GIR_EraseRootFromParent_Done,
    // Label 7727: @400193
    GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(400235), // Rule ID 5894 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5894,
      GIR_EraseRootFromParent_Done,
    // Label 7728: @400235
    GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(400277), // Rule ID 5896 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5896,
      GIR_EraseRootFromParent_Done,
    // Label 7729: @400277
    GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(400338), // Rule ID 5948 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 5948,
      GIR_EraseRootFromParent_Done,
    // Label 7730: @400338
    GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(400361), // Rule ID 5949 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5949,
      GIR_Done,
    // Label 7731: @400361
    GIM_Reject,
    // Label 7708: @400362
    GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(400547),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(400417), // Rule ID 5899 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5899,
        GIR_EraseRootFromParent_Done,
      // Label 7733: @400417
      GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(400460), // Rule ID 5909 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5909,
        GIR_EraseRootFromParent_Done,
      // Label 7734: @400460
      GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(400495), // Rule ID 5908 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5908,
        GIR_EraseRootFromParent_Done,
      // Label 7735: @400495
      GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(400530), // Rule ID 5898 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5898,
        GIR_EraseRootFromParent_Done,
      // Label 7736: @400530
      GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(400546), // Rule ID 5950 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5950,
        GIR_Done,
      // Label 7737: @400546
      GIM_Reject,
    // Label 7732: @400547
    GIM_Reject,
    // Label 7709: @400548
    GIM_Reject,
    // Label 113: @400549
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7741*/ GIMT_Encode4(400751),
    /*GILLT_s8*//*Label 7738*/ GIMT_Encode4(400572),
    /*GILLT_s16*//*Label 7739*/ GIMT_Encode4(400619),
    /*GILLT_s32*//*Label 7740*/ GIMT_Encode4(400666),
    // Label 7738: @400572
    GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(400595), // Rule ID 6041 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6041,
      GIR_Done,
    // Label 7742: @400595
    GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(400618), // Rule ID 6042 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6042,
      GIR_Done,
    // Label 7743: @400618
    GIM_Reject,
    // Label 7739: @400619
    GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(400642), // Rule ID 6043 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6043,
      GIR_Done,
    // Label 7744: @400642
    GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(400665), // Rule ID 6044 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6044,
      GIR_Done,
    // Label 7745: @400665
    GIM_Reject,
    // Label 7740: @400666
    GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(400689), // Rule ID 6045 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6045,
      GIR_Done,
    // Label 7746: @400689
    GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(400750), // Rule ID 6046 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6046,
      GIR_EraseRootFromParent_Done,
    // Label 7747: @400750
    GIM_Reject,
    // Label 7741: @400751
    GIM_Reject,
    // Label 114: @400752
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7751*/ GIMT_Encode4(400954),
    /*GILLT_s8*//*Label 7748*/ GIMT_Encode4(400775),
    /*GILLT_s16*//*Label 7749*/ GIMT_Encode4(400822),
    /*GILLT_s32*//*Label 7750*/ GIMT_Encode4(400869),
    // Label 7748: @400775
    GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(400798), // Rule ID 6035 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6035,
      GIR_Done,
    // Label 7752: @400798
    GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(400821), // Rule ID 6036 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6036,
      GIR_Done,
    // Label 7753: @400821
    GIM_Reject,
    // Label 7749: @400822
    GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(400845), // Rule ID 6037 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6037,
      GIR_Done,
    // Label 7754: @400845
    GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(400868), // Rule ID 6038 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6038,
      GIR_Done,
    // Label 7755: @400868
    GIM_Reject,
    // Label 7750: @400869
    GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(400892), // Rule ID 6039 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6039,
      GIR_Done,
    // Label 7756: @400892
    GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(400953), // Rule ID 6040 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6040,
      GIR_EraseRootFromParent_Done,
    // Label 7757: @400953
    GIM_Reject,
    // Label 7751: @400954
    GIM_Reject,
    // Label 115: @400955
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7761*/ GIMT_Encode4(401157),
    /*GILLT_s8*//*Label 7758*/ GIMT_Encode4(400978),
    /*GILLT_s16*//*Label 7759*/ GIMT_Encode4(401025),
    /*GILLT_s32*//*Label 7760*/ GIMT_Encode4(401072),
    // Label 7758: @400978
    GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(401001), // Rule ID 6029 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6029,
      GIR_Done,
    // Label 7762: @401001
    GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(401024), // Rule ID 6030 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6030,
      GIR_Done,
    // Label 7763: @401024
    GIM_Reject,
    // Label 7759: @401025
    GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(401048), // Rule ID 6031 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6031,
      GIR_Done,
    // Label 7764: @401048
    GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(401071), // Rule ID 6032 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6032,
      GIR_Done,
    // Label 7765: @401071
    GIM_Reject,
    // Label 7760: @401072
    GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(401095), // Rule ID 6033 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6033,
      GIR_Done,
    // Label 7766: @401095
    GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(401156), // Rule ID 6034 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6034,
      GIR_EraseRootFromParent_Done,
    // Label 7767: @401156
    GIM_Reject,
    // Label 7761: @401157
    GIM_Reject,
    // Label 116: @401158
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7771*/ GIMT_Encode4(401360),
    /*GILLT_s8*//*Label 7768*/ GIMT_Encode4(401181),
    /*GILLT_s16*//*Label 7769*/ GIMT_Encode4(401228),
    /*GILLT_s32*//*Label 7770*/ GIMT_Encode4(401275),
    // Label 7768: @401181
    GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(401204), // Rule ID 6023 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6023,
      GIR_Done,
    // Label 7772: @401204
    GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(401227), // Rule ID 6024 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6024,
      GIR_Done,
    // Label 7773: @401227
    GIM_Reject,
    // Label 7769: @401228
    GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(401251), // Rule ID 6025 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6025,
      GIR_Done,
    // Label 7774: @401251
    GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(401274), // Rule ID 6026 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6026,
      GIR_Done,
    // Label 7775: @401274
    GIM_Reject,
    // Label 7770: @401275
    GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(401298), // Rule ID 6027 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6027,
      GIR_Done,
    // Label 7776: @401298
    GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(401359), // Rule ID 6028 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6028,
      GIR_EraseRootFromParent_Done,
    // Label 7777: @401359
    GIM_Reject,
    // Label 7771: @401360
    GIM_Reject,
    // Label 117: @401361
    GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(401500),
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(401407), // Rule ID 268 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 268,
        GIR_EraseRootFromParent_Done,
      // Label 7779: @401407
      GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(401441), // Rule ID 269 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 269,
        GIR_EraseRootFromParent_Done,
      // Label 7780: @401441
      GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(401470), // Rule ID 284 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 284,
        GIR_EraseRootFromParent_Done,
      // Label 7781: @401470
      GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(401499), // Rule ID 305 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 305,
        GIR_EraseRootFromParent_Done,
      // Label 7782: @401499
      GIM_Reject,
    // Label 7778: @401500
    GIM_Reject,
    // Label 118: @401501
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7795*/ GIMT_Encode4(402040),
    /*GILLT_s64*//*Label 7783*/ GIMT_Encode4(401596), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7784*/ GIMT_Encode4(401634),
    /*GILLT_v2s64*//*Label 7785*/ GIMT_Encode4(401672),
    /*GILLT_v4s16*//*Label 7786*/ GIMT_Encode4(401710),
    /*GILLT_v4s32*//*Label 7787*/ GIMT_Encode4(401748),
    /*GILLT_v8s8*//*Label 7788*/ GIMT_Encode4(401786),
    /*GILLT_v8s16*//*Label 7789*/ GIMT_Encode4(401824),
    /*GILLT_v16s8*//*Label 7790*/ GIMT_Encode4(401862), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 7791*/ GIMT_Encode4(401900), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 7792*/ GIMT_Encode4(401935), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 7793*/ GIMT_Encode4(401970), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 7794*/ GIMT_Encode4(402005),
    // Label 7783: @401596
    GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(401633), // Rule ID 5092 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5092,
      GIR_Done,
    // Label 7796: @401633
    GIM_Reject,
    // Label 7784: @401634
    GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(401671), // Rule ID 5091 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5091,
      GIR_Done,
    // Label 7797: @401671
    GIM_Reject,
    // Label 7785: @401672
    GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(401709), // Rule ID 5096 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5096,
      GIR_Done,
    // Label 7798: @401709
    GIM_Reject,
    // Label 7786: @401710
    GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(401747), // Rule ID 5090 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5090,
      GIR_Done,
    // Label 7799: @401747
    GIM_Reject,
    // Label 7787: @401748
    GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(401785), // Rule ID 5095 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5095,
      GIR_Done,
    // Label 7800: @401785
    GIM_Reject,
    // Label 7788: @401786
    GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(401823), // Rule ID 5089 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5089,
      GIR_Done,
    // Label 7801: @401823
    GIM_Reject,
    // Label 7789: @401824
    GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(401861), // Rule ID 5094 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5094,
      GIR_Done,
    // Label 7802: @401861
    GIM_Reject,
    // Label 7790: @401862
    GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(401899), // Rule ID 5093 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5093,
      GIR_Done,
    // Label 7803: @401899
    GIM_Reject,
    // Label 7791: @401900
    GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(401934), // Rule ID 12167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12167,
      GIR_EraseRootFromParent_Done,
    // Label 7804: @401934
    GIM_Reject,
    // Label 7792: @401935
    GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(401969), // Rule ID 12165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12165,
      GIR_EraseRootFromParent_Done,
    // Label 7805: @401969
    GIM_Reject,
    // Label 7793: @401970
    GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(402004), // Rule ID 12163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12163,
      GIR_EraseRootFromParent_Done,
    // Label 7806: @402004
    GIM_Reject,
    // Label 7794: @402005
    GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(402039), // Rule ID 12161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12161,
      GIR_EraseRootFromParent_Done,
    // Label 7807: @402039
    GIM_Reject,
    // Label 7795: @402040
    GIM_Reject,
    // Label 119: @402041
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7816*/ GIMT_Encode4(404131),
    /*GILLT_s64*//*Label 7808*/ GIMT_Encode4(402088), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7809*/ GIMT_Encode4(402283),
    /*GILLT_v2s64*//*Label 7810*/ GIMT_Encode4(402530),
    /*GILLT_v4s16*//*Label 7811*/ GIMT_Encode4(402777),
    /*GILLT_v4s32*//*Label 7812*/ GIMT_Encode4(403187),
    /*GILLT_v8s8*//*Label 7813*/ GIMT_Encode4(403434),
    /*GILLT_v8s16*//*Label 7814*/ GIMT_Encode4(403579),
    /*GILLT_v16s8*//*Label 7815*/ GIMT_Encode4(403989),
    // Label 7808: @402088
    GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(402282),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(402147), // Rule ID 6476 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6476,
        GIR_EraseRootFromParent_Done,
      // Label 7818: @402147
      GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(402194), // Rule ID 6487 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6487,
        GIR_EraseRootFromParent_Done,
      // Label 7819: @402194
      GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(402241), // Rule ID 13176 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13176,
        GIR_EraseRootFromParent_Done,
      // Label 7820: @402241
      GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(402261), // Rule ID 5665 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5665,
        GIR_Done,
      // Label 7821: @402261
      GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(402281), // Rule ID 5666 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5666,
        GIR_Done,
      // Label 7822: @402281
      GIM_Reject,
    // Label 7817: @402282
    GIM_Reject,
    // Label 7809: @402283
    GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(402529),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(402342), // Rule ID 6473 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6473,
        GIR_EraseRootFromParent_Done,
      // Label 7824: @402342
      GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(402389), // Rule ID 6484 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6484,
        GIR_EraseRootFromParent_Done,
      // Label 7825: @402389
      GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(402436), // Rule ID 13173 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13173,
        GIR_EraseRootFromParent_Done,
      // Label 7826: @402436
      GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(402455), // Rule ID 1904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1904,
        GIR_Done,
      // Label 7827: @402455
      GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(402528), // Rule ID 5667 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5667,
        GIR_EraseRootFromParent_Done,
      // Label 7828: @402528
      GIM_Reject,
    // Label 7823: @402529
    GIM_Reject,
    // Label 7810: @402530
    GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(402776),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(402589), // Rule ID 6475 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6475,
        GIR_EraseRootFromParent_Done,
      // Label 7830: @402589
      GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(402636), // Rule ID 6486 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6486,
        GIR_EraseRootFromParent_Done,
      // Label 7831: @402636
      GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(402683), // Rule ID 13175 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13175,
        GIR_EraseRootFromParent_Done,
      // Label 7832: @402683
      GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(402702), // Rule ID 1906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1906,
        GIR_Done,
      // Label 7833: @402702
      GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(402775), // Rule ID 5669 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5669,
        GIR_EraseRootFromParent_Done,
      // Label 7834: @402775
      GIM_Reject,
    // Label 7829: @402776
    GIM_Reject,
    // Label 7811: @402777
    GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(402831), // Rule ID 6488 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6488,
      GIR_EraseRootFromParent_Done,
    // Label 7835: @402831
    GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(402885), // Rule ID 6490 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4bf16] } (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6490,
      GIR_EraseRootFromParent_Done,
    // Label 7836: @402885
    GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(402939), // Rule ID 13171 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13171,
      GIR_EraseRootFromParent_Done,
    // Label 7837: @402939
    GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(403000), // Rule ID 6471 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6471,
      GIR_EraseRootFromParent_Done,
    // Label 7838: @403000
    GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(403026), // Rule ID 1902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1902,
      GIR_Done,
    // Label 7839: @403026
    GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(403106), // Rule ID 5670 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5670,
      GIR_EraseRootFromParent_Done,
    // Label 7840: @403106
    GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(403186), // Rule ID 5671 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v4bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4bf16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5671,
      GIR_EraseRootFromParent_Done,
    // Label 7841: @403186
    GIM_Reject,
    // Label 7812: @403187
    GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(403433),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(403246), // Rule ID 6474 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6474,
        GIR_EraseRootFromParent_Done,
      // Label 7843: @403246
      GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(403293), // Rule ID 6485 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6485,
        GIR_EraseRootFromParent_Done,
      // Label 7844: @403293
      GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(403340), // Rule ID 13174 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13174,
        GIR_EraseRootFromParent_Done,
      // Label 7845: @403340
      GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(403359), // Rule ID 1905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1905,
        GIR_Done,
      // Label 7846: @403359
      GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(403432), // Rule ID 5668 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5668,
        GIR_EraseRootFromParent_Done,
      // Label 7847: @403432
      GIM_Reject,
    // Label 7842: @403433
    GIM_Reject,
    // Label 7813: @403434
    GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(403491), // Rule ID 13169 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13169,
      GIR_EraseRootFromParent_Done,
    // Label 7848: @403491
    GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(403552), // Rule ID 6469 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6469,
      GIR_EraseRootFromParent_Done,
    // Label 7849: @403552
    GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(403578), // Rule ID 1900 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1900,
      GIR_Done,
    // Label 7850: @403578
    GIM_Reject,
    // Label 7814: @403579
    GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(403633), // Rule ID 6489 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6489,
      GIR_EraseRootFromParent_Done,
    // Label 7851: @403633
    GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(403687), // Rule ID 6491 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8bf16] } (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6491,
      GIR_EraseRootFromParent_Done,
    // Label 7852: @403687
    GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(403741), // Rule ID 13172 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13172,
      GIR_EraseRootFromParent_Done,
    // Label 7853: @403741
    GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(403802), // Rule ID 6472 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6472,
      GIR_EraseRootFromParent_Done,
    // Label 7854: @403802
    GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(403828), // Rule ID 1903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1903,
      GIR_Done,
    // Label 7855: @403828
    GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(403908), // Rule ID 5672 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5672,
      GIR_EraseRootFromParent_Done,
    // Label 7856: @403908
    GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(403988), // Rule ID 5673 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v8bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5673,
      GIR_EraseRootFromParent_Done,
    // Label 7857: @403988
    GIM_Reject,
    // Label 7815: @403989
    GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(404043), // Rule ID 13170 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13170,
      GIR_EraseRootFromParent_Done,
    // Label 7858: @404043
    GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(404104), // Rule ID 6470 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6470,
      GIR_EraseRootFromParent_Done,
    // Label 7859: @404104
    GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(404130), // Rule ID 1901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1901,
      GIR_Done,
    // Label 7860: @404130
    GIM_Reject,
    // Label 7816: @404131
    GIM_Reject,
    // Label 120: @404132
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7863*/ GIMT_Encode4(404452),
    /*GILLT_v4s16*//*Label 7861*/ GIMT_Encode4(404159), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7862*/ GIMT_Encode4(404276),
    // Label 7861: @404159
    GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(404275),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(404212), // Rule ID 1910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1910,
        GIR_EraseRootFromParent_Done,
      // Label 7865: @404212
      GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(404243), // Rule ID 5674 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5674,
        GIR_EraseRootFromParent_Done,
      // Label 7866: @404243
      GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(404274), // Rule ID 5676 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5676,
        GIR_EraseRootFromParent_Done,
      // Label 7867: @404274
      GIM_Reject,
    // Label 7864: @404275
    GIM_Reject,
    // Label 7862: @404276
    GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(404451),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(404342), // Rule ID 6480 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6480,
        GIR_EraseRootFromParent_Done,
      // Label 7869: @404342
      GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(404380), // Rule ID 1911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1911,
        GIR_EraseRootFromParent_Done,
      // Label 7870: @404380
      GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(404415), // Rule ID 5675 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5675,
        GIR_EraseRootFromParent_Done,
      // Label 7871: @404415
      GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(404450), // Rule ID 5677 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5677,
        GIR_EraseRootFromParent_Done,
      // Label 7872: @404450
      GIM_Reject,
    // Label 7868: @404451
    GIM_Reject,
    // Label 7863: @404452
    GIM_Reject,
    // Label 121: @404453
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 7875*/ GIMT_Encode4(404707),
    /*GILLT_v2s32*//*Label 7873*/ GIMT_Encode4(404480), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 7874*/ GIMT_Encode4(404566),
    // Label 7873: @404480
    GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(404565),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(404533), // Rule ID 1908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1908,
        GIR_EraseRootFromParent_Done,
      // Label 7877: @404533
      GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(404564), // Rule ID 5678 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5678,
        GIR_EraseRootFromParent_Done,
      // Label 7878: @404564
      GIM_Reject,
    // Label 7876: @404565
    GIM_Reject,
    // Label 7874: @404566
    GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(404706),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(404632), // Rule ID 6482 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6482,
        GIR_EraseRootFromParent_Done,
      // Label 7880: @404632
      GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(404670), // Rule ID 1909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1909,
        GIR_EraseRootFromParent_Done,
      // Label 7881: @404670
      GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(404705), // Rule ID 5679 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5679,
        GIR_EraseRootFromParent_Done,
      // Label 7882: @404705
      GIM_Reject,
    // Label 7879: @404706
    GIM_Reject,
    // Label 7875: @404707
    GIM_Reject,
    // Label 122: @404708
    GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(404853),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(404777), // Rule ID 6483 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6483,
        GIR_EraseRootFromParent_Done,
      // Label 7884: @404777
      GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(404852),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(404820), // Rule ID 1907 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
          // MIs[1] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1907,
          GIR_EraseRootFromParent_Done,
        // Label 7886: @404820
        GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(404851), // Rule ID 5680 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
          // MIs[1] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5680,
          GIR_EraseRootFromParent_Done,
        // Label 7887: @404851
        GIM_Reject,
      // Label 7885: @404852
      GIM_Reject,
    // Label 7883: @404853
    GIM_Reject,
    // Label 123: @404854
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7890*/ GIMT_Encode4(405032),
    /*GILLT_v8s8*//*Label 7888*/ GIMT_Encode4(404877), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 7889*/ GIMT_Encode4(404926),
    // Label 7888: @404877
    GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(404925), // Rule ID 1912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1912,
      GIR_EraseRootFromParent_Done,
    // Label 7891: @404925
    GIM_Reject,
    // Label 7889: @404926
    GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(405031),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(404992), // Rule ID 6478 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6478,
        GIR_EraseRootFromParent_Done,
      // Label 7893: @404992
      GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(405030), // Rule ID 1913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1913,
        GIR_EraseRootFromParent_Done,
      // Label 7894: @405030
      GIM_Reject,
    // Label 7892: @405031
    GIM_Reject,
    // Label 7890: @405032
    GIM_Reject,
    // Label 124: @405033
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7904*/ GIMT_Encode4(406915),
    /*GILLT_s64*//*Label 7895*/ GIMT_Encode4(405128), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7896*/ GIMT_Encode4(405461),
    /*GILLT_v2s64*//*Label 7897*/ GIMT_Encode4(405794),
    /*GILLT_v4s16*//*Label 7898*/ GIMT_Encode4(405877),
    /*GILLT_v4s32*//*Label 7899*/ GIMT_Encode4(406370),
    /*GILLT_v8s8*//*Label 7900*/ GIMT_Encode4(406453),
    /*GILLT_v8s16*//*Label 7901*/ GIMT_Encode4(406670),
    /*GILLT_v16s8*//*Label 7902*/ GIMT_Encode4(406782), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 7903*/ GIMT_Encode4(406868),
    // Label 7895: @405128
    GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(405460),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(405258), // Rule ID 5483 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5483,
        GIR_EraseRootFromParent_Done,
      // Label 7906: @405258
      GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(405377), // Rule ID 5488 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5488,
        GIR_EraseRootFromParent_Done,
      // Label 7907: @405377
      GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(405418), // Rule ID 5480 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5480,
        GIR_EraseRootFromParent_Done,
      // Label 7908: @405418
      GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(405459), // Rule ID 5485 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5485,
        GIR_EraseRootFromParent_Done,
      // Label 7909: @405459
      GIM_Reject,
    // Label 7905: @405460
    GIM_Reject,
    // Label 7896: @405461
    GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(405793),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(405591), // Rule ID 5473 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5473,
        GIR_EraseRootFromParent_Done,
      // Label 7911: @405591
      GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(405710), // Rule ID 5478 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5478,
        GIR_EraseRootFromParent_Done,
      // Label 7912: @405710
      GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(405751), // Rule ID 5470 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5470,
        GIR_EraseRootFromParent_Done,
      // Label 7913: @405751
      GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(405792), // Rule ID 5475 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5475,
        GIR_EraseRootFromParent_Done,
      // Label 7914: @405792
      GIM_Reject,
    // Label 7910: @405793
    GIM_Reject,
    // Label 7897: @405794
    GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(405876),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(405846), // Rule ID 5481 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5481,
        GIR_EraseRootFromParent_Done,
      // Label 7916: @405846
      GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(405875), // Rule ID 5486 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5486,
        GIR_EraseRootFromParent_Done,
      // Label 7917: @405875
      GIM_Reject,
    // Label 7915: @405876
    GIM_Reject,
    // Label 7898: @405877
    GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(406369),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(406007), // Rule ID 5458 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5458,
        GIR_EraseRootFromParent_Done,
      // Label 7919: @406007
      GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(406126), // Rule ID 5463 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5463,
        GIR_EraseRootFromParent_Done,
      // Label 7920: @406126
      GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(406245), // Rule ID 5468 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v4bf16] } (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5468,
        GIR_EraseRootFromParent_Done,
      // Label 7921: @406245
      GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(406286), // Rule ID 5455 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5455,
        GIR_EraseRootFromParent_Done,
      // Label 7922: @406286
      GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(406327), // Rule ID 5460 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5460,
        GIR_EraseRootFromParent_Done,
      // Label 7923: @406327
      GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(406368), // Rule ID 5465 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5465,
        GIR_EraseRootFromParent_Done,
      // Label 7924: @406368
      GIM_Reject,
    // Label 7918: @406369
    GIM_Reject,
    // Label 7899: @406370
    GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(406452),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(406422), // Rule ID 5471 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5471,
        GIR_EraseRootFromParent_Done,
      // Label 7926: @406422
      GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(406451), // Rule ID 5476 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5476,
        GIR_EraseRootFromParent_Done,
      // Label 7927: @406451
      GIM_Reject,
    // Label 7925: @406452
    GIM_Reject,
    // Label 7900: @406453
    GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(406669),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(406583), // Rule ID 5453 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5453,
        GIR_EraseRootFromParent_Done,
      // Label 7929: @406583
      GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(406627), // Rule ID 1856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1856,
        GIR_EraseRootFromParent_Done,
      // Label 7930: @406627
      GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(406668), // Rule ID 5450 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5450,
        GIR_EraseRootFromParent_Done,
      // Label 7931: @406668
      GIM_Reject,
    // Label 7928: @406669
    GIM_Reject,
    // Label 7901: @406670
    GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(406781),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(406722), // Rule ID 5456 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5456,
        GIR_EraseRootFromParent_Done,
      // Label 7933: @406722
      GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(406751), // Rule ID 5461 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5461,
        GIR_EraseRootFromParent_Done,
      // Label 7934: @406751
      GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(406780), // Rule ID 5466 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5466,
        GIR_EraseRootFromParent_Done,
      // Label 7935: @406780
      GIM_Reject,
    // Label 7932: @406781
    GIM_Reject,
    // Label 7902: @406782
    GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(406867),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(406837), // Rule ID 1857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1857,
        GIR_EraseRootFromParent_Done,
      // Label 7937: @406837
      GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(406866), // Rule ID 5451 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5451,
        GIR_EraseRootFromParent_Done,
      // Label 7938: @406866
      GIM_Reject,
    // Label 7936: @406867
    GIM_Reject,
    // Label 7903: @406868
    GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(406914), // Rule ID 2688 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Op3
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2688,
      GIR_EraseRootFromParent_Done,
    // Label 7939: @406914
    GIM_Reject,
    // Label 7904: @406915
    GIM_Reject,
    // Label 125: @406916
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7947*/ GIMT_Encode4(407254),
    /*GILLT_s32*//*Label 7940*/ GIMT_Encode4(406963),
    /*GILLT_s64*//*Label 7941*/ GIMT_Encode4(407001), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7942*/ GIMT_Encode4(407064),
    /*GILLT_v2s64*//*Label 7943*/ GIMT_Encode4(407102),
    /*GILLT_v4s16*//*Label 7944*/ GIMT_Encode4(407140),
    /*GILLT_v4s32*//*Label 7945*/ GIMT_Encode4(407178), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7946*/ GIMT_Encode4(407216),
    // Label 7940: @406963
    GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(407000), // Rule ID 1610 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1610,
      GIR_Done,
    // Label 7948: @407000
    GIM_Reject,
    // Label 7941: @407001
    GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(407063),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(407043), // Rule ID 1609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1609,
        GIR_Done,
      // Label 7950: @407043
      GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(407062), // Rule ID 5235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5235,
        GIR_Done,
      // Label 7951: @407062
      GIM_Reject,
    // Label 7949: @407063
    GIM_Reject,
    // Label 7942: @407064
    GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(407101), // Rule ID 1198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1198,
      GIR_Done,
    // Label 7952: @407101
    GIM_Reject,
    // Label 7943: @407102
    GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(407139), // Rule ID 1200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1200,
      GIR_Done,
    // Label 7953: @407139
    GIM_Reject,
    // Label 7944: @407140
    GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(407177), // Rule ID 1196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1196,
      GIR_Done,
    // Label 7954: @407177
    GIM_Reject,
    // Label 7945: @407178
    GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(407215), // Rule ID 1199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1199,
      GIR_Done,
    // Label 7955: @407215
    GIM_Reject,
    // Label 7946: @407216
    GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(407253), // Rule ID 1197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1197,
      GIR_Done,
    // Label 7956: @407253
    GIM_Reject,
    // Label 7947: @407254
    GIM_Reject,
    // Label 126: @407255
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7963*/ GIMT_Encode4(407484),
    /*GILLT_s64*//*Label 7957*/ GIMT_Encode4(407298), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7958*/ GIMT_Encode4(407329),
    /*GILLT_v2s64*//*Label 7959*/ GIMT_Encode4(407360),
    /*GILLT_v4s16*//*Label 7960*/ GIMT_Encode4(407391),
    /*GILLT_v4s32*//*Label 7961*/ GIMT_Encode4(407422), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7962*/ GIMT_Encode4(407453),
    // Label 7957: @407298
    GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(407328), // Rule ID 2477 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2477,
      GIR_Done,
    // Label 7964: @407328
    GIM_Reject,
    // Label 7958: @407329
    GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(407359), // Rule ID 761 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 761,
      GIR_Done,
    // Label 7965: @407359
    GIM_Reject,
    // Label 7959: @407360
    GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(407390), // Rule ID 763 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 763,
      GIR_Done,
    // Label 7966: @407390
    GIM_Reject,
    // Label 7960: @407391
    GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(407421), // Rule ID 759 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 759,
      GIR_Done,
    // Label 7967: @407421
    GIM_Reject,
    // Label 7961: @407422
    GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(407452), // Rule ID 762 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 762,
      GIR_Done,
    // Label 7968: @407452
    GIM_Reject,
    // Label 7962: @407453
    GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(407483), // Rule ID 760 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 760,
      GIR_Done,
    // Label 7969: @407483
    GIM_Reject,
    // Label 7963: @407484
    GIM_Reject,
    // Label 127: @407485
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7977*/ GIMT_Encode4(408148),
    /*GILLT_s32*//*Label 7970*/ GIMT_Encode4(407532),
    /*GILLT_s64*//*Label 7971*/ GIMT_Encode4(407570), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7972*/ GIMT_Encode4(407633),
    /*GILLT_v2s64*//*Label 7973*/ GIMT_Encode4(407736),
    /*GILLT_v4s16*//*Label 7974*/ GIMT_Encode4(407839),
    /*GILLT_v4s32*//*Label 7975*/ GIMT_Encode4(407942), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7976*/ GIMT_Encode4(408045),
    // Label 7970: @407532
    GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(407569), // Rule ID 1612 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1612,
      GIR_Done,
    // Label 7978: @407569
    GIM_Reject,
    // Label 7971: @407570
    GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(407632),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(407612), // Rule ID 1611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1611,
        GIR_Done,
      // Label 7980: @407612
      GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(407631), // Rule ID 5236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5236,
        GIR_Done,
      // Label 7981: @407631
      GIM_Reject,
    // Label 7979: @407632
    GIM_Reject,
    // Label 7972: @407633
    GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(407735),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(407707), // Rule ID 1160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1160,
        GIR_EraseRootFromParent_Done,
      // Label 7983: @407707
      GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(407734), // Rule ID 1203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1203,
        GIR_Done,
      // Label 7984: @407734
      GIM_Reject,
    // Label 7982: @407735
    GIM_Reject,
    // Label 7973: @407736
    GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(407838),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(407810), // Rule ID 1164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1164,
        GIR_EraseRootFromParent_Done,
      // Label 7986: @407810
      GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(407837), // Rule ID 1205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1205,
        GIR_Done,
      // Label 7987: @407837
      GIM_Reject,
    // Label 7985: @407838
    GIM_Reject,
    // Label 7974: @407839
    GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(407941),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(407913), // Rule ID 1156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1156,
        GIR_EraseRootFromParent_Done,
      // Label 7989: @407913
      GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(407940), // Rule ID 1201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1201,
        GIR_Done,
      // Label 7990: @407940
      GIM_Reject,
    // Label 7988: @407941
    GIM_Reject,
    // Label 7975: @407942
    GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(408044),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(408016), // Rule ID 1162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1162,
        GIR_EraseRootFromParent_Done,
      // Label 7992: @408016
      GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(408043), // Rule ID 1204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1204,
        GIR_Done,
      // Label 7993: @408043
      GIM_Reject,
    // Label 7991: @408044
    GIM_Reject,
    // Label 7976: @408045
    GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(408147),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(408119), // Rule ID 1158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1158,
        GIR_EraseRootFromParent_Done,
      // Label 7995: @408119
      GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(408146), // Rule ID 1202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1202,
        GIR_Done,
      // Label 7996: @408146
      GIM_Reject,
    // Label 7994: @408147
    GIM_Reject,
    // Label 7977: @408148
    GIM_Reject,
    // Label 128: @408149
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8003*/ GIMT_Encode4(408378),
    /*GILLT_s64*//*Label 7997*/ GIMT_Encode4(408192), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7998*/ GIMT_Encode4(408223),
    /*GILLT_v2s64*//*Label 7999*/ GIMT_Encode4(408254),
    /*GILLT_v4s16*//*Label 8000*/ GIMT_Encode4(408285),
    /*GILLT_v4s32*//*Label 8001*/ GIMT_Encode4(408316), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8002*/ GIMT_Encode4(408347),
    // Label 7997: @408192
    GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(408222), // Rule ID 5266 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5266,
      GIR_Done,
    // Label 8004: @408222
    GIM_Reject,
    // Label 7998: @408223
    GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(408253), // Rule ID 766 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 766,
      GIR_Done,
    // Label 8005: @408253
    GIM_Reject,
    // Label 7999: @408254
    GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(408284), // Rule ID 768 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 768,
      GIR_Done,
    // Label 8006: @408284
    GIM_Reject,
    // Label 8000: @408285
    GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(408315), // Rule ID 764 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 764,
      GIR_Done,
    // Label 8007: @408315
    GIM_Reject,
    // Label 8001: @408316
    GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(408346), // Rule ID 767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 767,
      GIR_Done,
    // Label 8008: @408346
    GIM_Reject,
    // Label 8002: @408347
    GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(408377), // Rule ID 765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 765,
      GIR_Done,
    // Label 8009: @408377
    GIM_Reject,
    // Label 8003: @408378
    GIM_Reject,
    // Label 129: @408379
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8017*/ GIMT_Encode4(409042),
    /*GILLT_s32*//*Label 8010*/ GIMT_Encode4(408426),
    /*GILLT_s64*//*Label 8011*/ GIMT_Encode4(408464), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8012*/ GIMT_Encode4(408527),
    /*GILLT_v2s64*//*Label 8013*/ GIMT_Encode4(408630),
    /*GILLT_v4s16*//*Label 8014*/ GIMT_Encode4(408733),
    /*GILLT_v4s32*//*Label 8015*/ GIMT_Encode4(408836), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8016*/ GIMT_Encode4(408939),
    // Label 8010: @408426
    GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(408463), // Rule ID 1614 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1614,
      GIR_Done,
    // Label 8018: @408463
    GIM_Reject,
    // Label 8011: @408464
    GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(408526),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(408506), // Rule ID 1613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1613,
        GIR_Done,
      // Label 8020: @408506
      GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(408525), // Rule ID 5237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5237,
        GIR_Done,
      // Label 8021: @408525
      GIM_Reject,
    // Label 8019: @408526
    GIM_Reject,
    // Label 8012: @408527
    GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(408629),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(408601), // Rule ID 1170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1170,
        GIR_EraseRootFromParent_Done,
      // Label 8023: @408601
      GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(408628), // Rule ID 1208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1208,
        GIR_Done,
      // Label 8024: @408628
      GIM_Reject,
    // Label 8022: @408629
    GIM_Reject,
    // Label 8013: @408630
    GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(408732),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(408704), // Rule ID 1174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1174,
        GIR_EraseRootFromParent_Done,
      // Label 8026: @408704
      GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(408731), // Rule ID 1210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1210,
        GIR_Done,
      // Label 8027: @408731
      GIM_Reject,
    // Label 8025: @408732
    GIM_Reject,
    // Label 8014: @408733
    GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(408835),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(408807), // Rule ID 1166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1166,
        GIR_EraseRootFromParent_Done,
      // Label 8029: @408807
      GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(408834), // Rule ID 1206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1206,
        GIR_Done,
      // Label 8030: @408834
      GIM_Reject,
    // Label 8028: @408835
    GIM_Reject,
    // Label 8015: @408836
    GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(408938),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(408910), // Rule ID 1172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1172,
        GIR_EraseRootFromParent_Done,
      // Label 8032: @408910
      GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(408937), // Rule ID 1209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1209,
        GIR_Done,
      // Label 8033: @408937
      GIM_Reject,
    // Label 8031: @408938
    GIM_Reject,
    // Label 8016: @408939
    GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(409041),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(409013), // Rule ID 1168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1168,
        GIR_EraseRootFromParent_Done,
      // Label 8035: @409013
      GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(409040), // Rule ID 1207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1207,
        GIR_Done,
      // Label 8036: @409040
      GIM_Reject,
    // Label 8034: @409041
    GIM_Reject,
    // Label 8017: @409042
    GIM_Reject,
    // Label 130: @409043
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8043*/ GIMT_Encode4(409272),
    /*GILLT_s64*//*Label 8037*/ GIMT_Encode4(409086), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8038*/ GIMT_Encode4(409117),
    /*GILLT_v2s64*//*Label 8039*/ GIMT_Encode4(409148),
    /*GILLT_v4s16*//*Label 8040*/ GIMT_Encode4(409179),
    /*GILLT_v4s32*//*Label 8041*/ GIMT_Encode4(409210), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8042*/ GIMT_Encode4(409241),
    // Label 8037: @409086
    GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(409116), // Rule ID 5267 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5267,
      GIR_Done,
    // Label 8044: @409116
    GIM_Reject,
    // Label 8038: @409117
    GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(409147), // Rule ID 771 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 771,
      GIR_Done,
    // Label 8045: @409147
    GIM_Reject,
    // Label 8039: @409148
    GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(409178), // Rule ID 773 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 773,
      GIR_Done,
    // Label 8046: @409178
    GIM_Reject,
    // Label 8040: @409179
    GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(409209), // Rule ID 769 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 769,
      GIR_Done,
    // Label 8047: @409209
    GIM_Reject,
    // Label 8041: @409210
    GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(409240), // Rule ID 772 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 772,
      GIR_Done,
    // Label 8048: @409240
    GIM_Reject,
    // Label 8042: @409241
    GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(409271), // Rule ID 770 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 770,
      GIR_Done,
    // Label 8049: @409271
    GIM_Reject,
    // Label 8043: @409272
    GIM_Reject,
    // Label 131: @409273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8056*/ GIMT_Encode4(409502),
    /*GILLT_s64*//*Label 8050*/ GIMT_Encode4(409316), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8051*/ GIMT_Encode4(409347),
    /*GILLT_v2s64*//*Label 8052*/ GIMT_Encode4(409378),
    /*GILLT_v4s16*//*Label 8053*/ GIMT_Encode4(409409),
    /*GILLT_v4s32*//*Label 8054*/ GIMT_Encode4(409440), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8055*/ GIMT_Encode4(409471),
    // Label 8050: @409316
    GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(409346), // Rule ID 5268 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5268,
      GIR_Done,
    // Label 8057: @409346
    GIM_Reject,
    // Label 8051: @409347
    GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(409377), // Rule ID 776 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 776,
      GIR_Done,
    // Label 8058: @409377
    GIM_Reject,
    // Label 8052: @409378
    GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(409408), // Rule ID 778 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 778,
      GIR_Done,
    // Label 8059: @409408
    GIM_Reject,
    // Label 8053: @409409
    GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(409439), // Rule ID 774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 774,
      GIR_Done,
    // Label 8060: @409439
    GIM_Reject,
    // Label 8054: @409440
    GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(409470), // Rule ID 777 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 777,
      GIR_Done,
    // Label 8061: @409470
    GIM_Reject,
    // Label 8055: @409471
    GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(409501), // Rule ID 775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 775,
      GIR_Done,
    // Label 8062: @409501
    GIM_Reject,
    // Label 8056: @409502
    GIM_Reject,
    // Label 132: @409503
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8069*/ GIMT_Encode4(409732),
    /*GILLT_s64*//*Label 8063*/ GIMT_Encode4(409546), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8064*/ GIMT_Encode4(409577),
    /*GILLT_v2s64*//*Label 8065*/ GIMT_Encode4(409608),
    /*GILLT_v4s16*//*Label 8066*/ GIMT_Encode4(409639),
    /*GILLT_v4s32*//*Label 8067*/ GIMT_Encode4(409670), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8068*/ GIMT_Encode4(409701),
    // Label 8063: @409546
    GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(409576), // Rule ID 5269 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5269,
      GIR_Done,
    // Label 8070: @409576
    GIM_Reject,
    // Label 8064: @409577
    GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(409607), // Rule ID 781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 781,
      GIR_Done,
    // Label 8071: @409607
    GIM_Reject,
    // Label 8065: @409608
    GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(409638), // Rule ID 783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 783,
      GIR_Done,
    // Label 8072: @409638
    GIM_Reject,
    // Label 8066: @409639
    GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(409669), // Rule ID 779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 779,
      GIR_Done,
    // Label 8073: @409669
    GIM_Reject,
    // Label 8067: @409670
    GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(409700), // Rule ID 782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 782,
      GIR_Done,
    // Label 8074: @409700
    GIM_Reject,
    // Label 8068: @409701
    GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(409731), // Rule ID 780 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 780,
      GIR_Done,
    // Label 8075: @409731
    GIM_Reject,
    // Label 8069: @409732
    GIM_Reject,
    // Label 133: @409733
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8078*/ GIMT_Encode4(409810),
    /*GILLT_v8s8*//*Label 8076*/ GIMT_Encode4(409756), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 8077*/ GIMT_Encode4(409783),
    // Label 8076: @409756
    GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(409782), // Rule ID 964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 964,
      GIR_Done,
    // Label 8079: @409782
    GIM_Reject,
    // Label 8077: @409783
    GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(409809), // Rule ID 965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 965,
      GIR_Done,
    // Label 8080: @409809
    GIM_Reject,
    // Label 8078: @409810
    GIM_Reject,
    // Label 134: @409811
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8085*/ GIMT_Encode4(410010),
    /*GILLT_v4s16*//*Label 8081*/ GIMT_Encode4(409842), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 8082*/ GIMT_Encode4(409899),
    /*GILLT_v8s16*//*Label 8083*/ GIMT_Encode4(409926),
    /*GILLT_v16s8*//*Label 8084*/ GIMT_Encode4(409983),
    // Label 8081: @409842
    GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(409898),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(409873), // Rule ID 968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 968,
        GIR_Done,
      // Label 8087: @409873
      GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(409885), // Rule ID 4984 //
        // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4984,
        GIR_Done,
      // Label 8088: @409885
      GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(409897), // Rule ID 4986 //
        // (AArch64rev32:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (REV32v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4986,
        GIR_Done,
      // Label 8089: @409897
      GIM_Reject,
    // Label 8086: @409898
    GIM_Reject,
    // Label 8082: @409899
    GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(409925), // Rule ID 966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 966,
      GIR_Done,
    // Label 8090: @409925
    GIM_Reject,
    // Label 8083: @409926
    GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(409982),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(409957), // Rule ID 969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 969,
        GIR_Done,
      // Label 8092: @409957
      GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(409969), // Rule ID 4988 //
        // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4988,
        GIR_Done,
      // Label 8093: @409969
      GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(409981), // Rule ID 4990 //
        // (AArch64rev32:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (REV32v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4990,
        GIR_Done,
      // Label 8094: @409981
      GIM_Reject,
    // Label 8091: @409982
    GIM_Reject,
    // Label 8084: @409983
    GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(410009), // Rule ID 967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 967,
      GIR_Done,
    // Label 8095: @410009
    GIM_Reject,
    // Label 8085: @410010
    GIM_Reject,
    // Label 135: @410011
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8102*/ GIMT_Encode4(410308),
    /*GILLT_v2s32*//*Label 8096*/ GIMT_Encode4(410050), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 8097*/ GIMT_Encode4(410095),
    /*GILLT_v4s32*//*Label 8098*/ GIMT_Encode4(410152),
    /*GILLT_v8s8*//*Label 8099*/ GIMT_Encode4(410197),
    /*GILLT_v8s16*//*Label 8100*/ GIMT_Encode4(410224),
    /*GILLT_v16s8*//*Label 8101*/ GIMT_Encode4(410281),
    // Label 8096: @410050
    GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(410094),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(410081), // Rule ID 974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 974,
        GIR_Done,
      // Label 8104: @410081
      GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(410093), // Rule ID 4992 //
        // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4992,
        GIR_Done,
      // Label 8105: @410093
      GIM_Reject,
    // Label 8103: @410094
    GIM_Reject,
    // Label 8097: @410095
    GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(410151),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(410126), // Rule ID 972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 972,
        GIR_Done,
      // Label 8107: @410126
      GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(410138), // Rule ID 4985 //
        // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4985,
        GIR_Done,
      // Label 8108: @410138
      GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(410150), // Rule ID 4987 //
        // (AArch64rev64:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (REV64v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4987,
        GIR_Done,
      // Label 8109: @410150
      GIM_Reject,
    // Label 8106: @410151
    GIM_Reject,
    // Label 8098: @410152
    GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(410196),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(410183), // Rule ID 975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 975,
        GIR_Done,
      // Label 8111: @410183
      GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(410195), // Rule ID 4993 //
        // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4993,
        GIR_Done,
      // Label 8112: @410195
      GIM_Reject,
    // Label 8110: @410196
    GIM_Reject,
    // Label 8099: @410197
    GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(410223), // Rule ID 970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 970,
      GIR_Done,
    // Label 8113: @410223
    GIM_Reject,
    // Label 8100: @410224
    GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(410280),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(410255), // Rule ID 973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 973,
        GIR_Done,
      // Label 8115: @410255
      GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(410267), // Rule ID 4989 //
        // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4989,
        GIR_Done,
      // Label 8116: @410267
      GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(410279), // Rule ID 4991 //
        // (AArch64rev64:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (REV64v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4991,
        GIR_Done,
      // Label 8117: @410279
      GIM_Reject,
    // Label 8114: @410280
    GIM_Reject,
    // Label 8101: @410281
    GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(410307), // Rule ID 971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 971,
      GIR_Done,
    // Label 8118: @410307
    GIM_Reject,
    // Label 8102: @410308
    GIM_Reject,
    // Label 136: @410309
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8125*/ GIMT_Encode4(410514),
    /*GILLT_s64*//*Label 8119*/ GIMT_Encode4(410352), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8120*/ GIMT_Encode4(410379),
    /*GILLT_v2s64*//*Label 8121*/ GIMT_Encode4(410406),
    /*GILLT_v4s16*//*Label 8122*/ GIMT_Encode4(410433),
    /*GILLT_v4s32*//*Label 8123*/ GIMT_Encode4(410460), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8124*/ GIMT_Encode4(410487),
    // Label 8119: @410352
    GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(410378), // Rule ID 996 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 996,
      GIR_Done,
    // Label 8126: @410378
    GIM_Reject,
    // Label 8120: @410379
    GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(410405), // Rule ID 992 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 992,
      GIR_Done,
    // Label 8127: @410405
    GIM_Reject,
    // Label 8121: @410406
    GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(410432), // Rule ID 998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 998,
      GIR_Done,
    // Label 8128: @410432
    GIM_Reject,
    // Label 8122: @410433
    GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(410459), // Rule ID 988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 988,
      GIR_Done,
    // Label 8129: @410459
    GIM_Reject,
    // Label 8123: @410460
    GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(410486), // Rule ID 994 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 994,
      GIR_Done,
    // Label 8130: @410486
    GIM_Reject,
    // Label 8124: @410487
    GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(410513), // Rule ID 990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 990,
      GIR_Done,
    // Label 8131: @410513
    GIM_Reject,
    // Label 8125: @410514
    GIM_Reject,
    // Label 137: @410515
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8134*/ GIMT_Encode4(410913),
    /*GILLT_v2s64*//*Label 8132*/ GIMT_Encode4(410538), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8133*/ GIMT_Encode4(410676),
    // Label 8132: @410538
    GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(410597), // Rule ID 5925 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 5925,
      GIR_EraseRootFromParent_Done,
    // Label 8135: @410597
    GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(410675), // Rule ID 6047 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6047,
      GIR_EraseRootFromParent_Done,
    // Label 8136: @410675
    GIM_Reject,
    // Label 8133: @410676
    GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(410735), // Rule ID 5921 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5921,
      GIR_EraseRootFromParent_Done,
    // Label 8137: @410735
    GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(410794), // Rule ID 5922 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5922,
      GIR_EraseRootFromParent_Done,
    // Label 8138: @410794
    GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(410853), // Rule ID 5923 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5923,
      GIR_EraseRootFromParent_Done,
    // Label 8139: @410853
    GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(410912), // Rule ID 5924 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5924,
      GIR_EraseRootFromParent_Done,
    // Label 8140: @410912
    GIM_Reject,
    // Label 8134: @410913
    GIM_Reject,
    // Label 138: @410914
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8145*/ GIMT_Encode4(411283),
    /*GILLT_v2s32*//*Label 8141*/ GIMT_Encode4(410985), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8142*/ GIMT_Encode4(411105), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 8143*/ GIMT_Encode4(411225), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 8144*/ GIMT_Encode4(411254),
    // Label 8141: @410985
    GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(411104),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(411084), // Rule ID 26 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 26,
        GIR_EraseRootFromParent_Done,
      // Label 8147: @411084
      GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(411103), // Rule ID 22 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22,
        GIR_Done,
      // Label 8148: @411103
      GIM_Reject,
    // Label 8146: @411104
    GIM_Reject,
    // Label 8142: @411105
    GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(411224),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(411204), // Rule ID 27 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 27,
        GIR_EraseRootFromParent_Done,
      // Label 8150: @411204
      GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(411223), // Rule ID 23 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23,
        GIR_Done,
      // Label 8151: @411223
      GIM_Reject,
    // Label 8149: @411224
    GIM_Reject,
    // Label 8143: @411225
    GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(411253), // Rule ID 2969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2969,
      GIR_Done,
    // Label 8152: @411253
    GIM_Reject,
    // Label 8144: @411254
    GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(411282), // Rule ID 2968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2968,
      GIR_Done,
    // Label 8153: @411282
    GIM_Reject,
    // Label 8145: @411283
    GIM_Reject,
    // Label 139: @411284
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8157*/ GIMT_Encode4(411400),
    /*GILLT_s16*//*Label 8154*/ GIMT_Encode4(411307),
    /*GILLT_s32*//*Label 8155*/ GIMT_Encode4(411338),
    /*GILLT_s64*//*Label 8156*/ GIMT_Encode4(411369),
    // Label 8154: @411307
    GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(411337), // Rule ID 1646 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1646,
      GIR_Done,
    // Label 8158: @411337
    GIM_Reject,
    // Label 8155: @411338
    GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(411368), // Rule ID 1645 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1645,
      GIR_Done,
    // Label 8159: @411368
    GIM_Reject,
    // Label 8156: @411369
    GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(411399), // Rule ID 1644 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1644,
      GIR_Done,
    // Label 8160: @411399
    GIM_Reject,
    // Label 8157: @411400
    GIM_Reject,
    // Label 140: @411401
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8164*/ GIMT_Encode4(412633),
    /*GILLT_v2s64*//*Label 8161*/ GIMT_Encode4(411432), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8162*/ GIMT_Encode4(411993), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8163*/ GIMT_Encode4(412554),
    // Label 8161: @411432
    GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(411992),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(411539), // Rule ID 2042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2042,
        GIR_EraseRootFromParent_Done,
      // Label 8166: @411539
      GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(411631), // Rule ID 13474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13474,
        GIR_EraseRootFromParent_Done,
      // Label 8167: @411631
      GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(411717), // Rule ID 13472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13472,
        GIR_EraseRootFromParent_Done,
      // Label 8168: @411717
      GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(411803), // Rule ID 2040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2040,
        GIR_EraseRootFromParent_Done,
      // Label 8169: @411803
      GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(411842), // Rule ID 1729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1729,
        GIR_EraseRootFromParent_Done,
      // Label 8170: @411842
      GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(411905), // Rule ID 13473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13473,
        GIR_EraseRootFromParent_Done,
      // Label 8171: @411905
      GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(411968), // Rule ID 2041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2041,
        GIR_EraseRootFromParent_Done,
      // Label 8172: @411968
      GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(411991), // Rule ID 1728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1728,
        GIR_Done,
      // Label 8173: @411991
      GIM_Reject,
    // Label 8165: @411992
    GIM_Reject,
    // Label 8162: @411993
    GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(412553),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(412100), // Rule ID 2039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2039,
        GIR_EraseRootFromParent_Done,
      // Label 8175: @412100
      GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(412192), // Rule ID 13471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13471,
        GIR_EraseRootFromParent_Done,
      // Label 8176: @412192
      GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(412278), // Rule ID 13469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13469,
        GIR_EraseRootFromParent_Done,
      // Label 8177: @412278
      GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(412364), // Rule ID 2037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2037,
        GIR_EraseRootFromParent_Done,
      // Label 8178: @412364
      GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(412403), // Rule ID 1727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1727,
        GIR_EraseRootFromParent_Done,
      // Label 8179: @412403
      GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(412466), // Rule ID 13470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13470,
        GIR_EraseRootFromParent_Done,
      // Label 8180: @412466
      GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(412529), // Rule ID 2038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2038,
        GIR_EraseRootFromParent_Done,
      // Label 8181: @412529
      GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(412552), // Rule ID 1726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1726,
        GIR_Done,
      // Label 8182: @412552
      GIM_Reject,
    // Label 8174: @412553
    GIM_Reject,
    // Label 8163: @412554
    GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(412632),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(412608), // Rule ID 1725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1725,
        GIR_EraseRootFromParent_Done,
      // Label 8184: @412608
      GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(412631), // Rule ID 1724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1724,
        GIR_Done,
      // Label 8185: @412631
      GIM_Reject,
    // Label 8183: @412632
    GIM_Reject,
    // Label 8164: @412633
    GIM_Reject,
    // Label 141: @412634
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8204*/ GIMT_Encode4(413458),
    /*GILLT_v2s32*//*Label 8186*/ GIMT_Encode4(412721),
    /*GILLT_v2s64*//*Label 8187*/ GIMT_Encode4(412776),
    /*GILLT_v4s16*//*Label 8188*/ GIMT_Encode4(412831),
    /*GILLT_v4s32*//*Label 8189*/ GIMT_Encode4(412901),
    /*GILLT_v8s8*//*Label 8190*/ GIMT_Encode4(412956),
    /*GILLT_v8s16*//*Label 8191*/ GIMT_Encode4(412990),
    /*GILLT_v16s8*//*Label 8192*/ GIMT_Encode4(413060), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8193*/ GIMT_Encode4(413094),
    /*GILLT_nxv2s16*//*Label 8194*/ GIMT_Encode4(413120),
    /*GILLT_nxv2s32*//*Label 8195*/ GIMT_Encode4(413146),
    /*GILLT_nxv2s64*//*Label 8196*/ GIMT_Encode4(413172),
    /*GILLT_nxv4s1*//*Label 8197*/ GIMT_Encode4(413219),
    /*GILLT_nxv4s16*//*Label 8198*/ GIMT_Encode4(413245),
    /*GILLT_nxv4s32*//*Label 8199*/ GIMT_Encode4(413271),
    /*GILLT_nxv8s1*//*Label 8200*/ GIMT_Encode4(413318),
    /*GILLT_nxv8s16*//*Label 8201*/ GIMT_Encode4(413344),
    /*GILLT_nxv16s1*//*Label 8202*/ GIMT_Encode4(413406),
    /*GILLT_nxv16s8*//*Label 8203*/ GIMT_Encode4(413432),
    // Label 8186: @412721
    GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(412775),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(412759), // Rule ID 1862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1862,
        GIR_Done,
      // Label 8206: @412759
      GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(412774), // Rule ID 2469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2469,
        GIR_Done,
      // Label 8207: @412774
      GIM_Reject,
    // Label 8205: @412775
    GIM_Reject,
    // Label 8187: @412776
    GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(412830),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(412814), // Rule ID 1864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1864,
        GIR_Done,
      // Label 8209: @412814
      GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(412829), // Rule ID 2471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2471,
        GIR_Done,
      // Label 8210: @412829
      GIM_Reject,
    // Label 8208: @412830
    GIM_Reject,
    // Label 8188: @412831
    GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(412900),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(412869), // Rule ID 1860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1860,
        GIR_Done,
      // Label 8212: @412869
      GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(412884), // Rule ID 2465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2465,
        GIR_Done,
      // Label 8213: @412884
      GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(412899), // Rule ID 2466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2466,
        GIR_Done,
      // Label 8214: @412899
      GIM_Reject,
    // Label 8211: @412900
    GIM_Reject,
    // Label 8189: @412901
    GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(412955),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(412939), // Rule ID 1863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1863,
        GIR_Done,
      // Label 8216: @412939
      GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(412954), // Rule ID 2470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2470,
        GIR_Done,
      // Label 8217: @412954
      GIM_Reject,
    // Label 8215: @412955
    GIM_Reject,
    // Label 8190: @412956
    GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(412989), // Rule ID 1858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1858,
      GIR_Done,
    // Label 8218: @412989
    GIM_Reject,
    // Label 8191: @412990
    GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(413059),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(413028), // Rule ID 1861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1861,
        GIR_Done,
      // Label 8220: @413028
      GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(413043), // Rule ID 2467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2467,
        GIR_Done,
      // Label 8221: @413043
      GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(413058), // Rule ID 2468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2468,
        GIR_Done,
      // Label 8222: @413058
      GIM_Reject,
    // Label 8219: @413059
    GIM_Reject,
    // Label 8192: @413060
    GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(413093), // Rule ID 1859 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1859,
      GIR_Done,
    // Label 8223: @413093
    GIM_Reject,
    // Label 8193: @413094
    GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(413119), // Rule ID 9156 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9156,
      GIR_Done,
    // Label 8224: @413119
    GIM_Reject,
    // Label 8194: @413120
    GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(413145), // Rule ID 9130 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9130,
      GIR_Done,
    // Label 8225: @413145
    GIM_Reject,
    // Label 8195: @413146
    GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(413171), // Rule ID 9131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9131,
      GIR_Done,
    // Label 8226: @413171
    GIM_Reject,
    // Label 8196: @413172
    GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(413218),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(413202), // Rule ID 9126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9126,
        GIR_Done,
      // Label 8228: @413202
      GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(413217), // Rule ID 9132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9132,
        GIR_Done,
      // Label 8229: @413217
      GIM_Reject,
    // Label 8227: @413218
    GIM_Reject,
    // Label 8197: @413219
    GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(413244), // Rule ID 9155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9155,
      GIR_Done,
    // Label 8230: @413244
    GIM_Reject,
    // Label 8198: @413245
    GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(413270), // Rule ID 9128 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9128,
      GIR_Done,
    // Label 8231: @413270
    GIM_Reject,
    // Label 8199: @413271
    GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(413317),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(413301), // Rule ID 9125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9125,
        GIR_Done,
      // Label 8233: @413301
      GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(413316), // Rule ID 9129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9129,
        GIR_Done,
      // Label 8234: @413316
      GIM_Reject,
    // Label 8232: @413317
    GIM_Reject,
    // Label 8200: @413318
    GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(413343), // Rule ID 9154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9154,
      GIR_Done,
    // Label 8235: @413343
    GIM_Reject,
    // Label 8201: @413344
    GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(413405),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(413374), // Rule ID 9124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9124,
        GIR_Done,
      // Label 8237: @413374
      GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(413389), // Rule ID 9127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9127,
        GIR_Done,
      // Label 8238: @413389
      GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(413404), // Rule ID 9133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9133,
        GIR_Done,
      // Label 8239: @413404
      GIM_Reject,
    // Label 8236: @413405
    GIM_Reject,
    // Label 8202: @413406
    GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(413431), // Rule ID 2390 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2390,
      GIR_Done,
    // Label 8240: @413431
    GIM_Reject,
    // Label 8203: @413432
    GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(413457), // Rule ID 9123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9123,
      GIR_Done,
    // Label 8241: @413457
    GIM_Reject,
    // Label 8204: @413458
    GIM_Reject,
    // Label 142: @413459
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8260*/ GIMT_Encode4(414283),
    /*GILLT_v2s32*//*Label 8242*/ GIMT_Encode4(413546),
    /*GILLT_v2s64*//*Label 8243*/ GIMT_Encode4(413601),
    /*GILLT_v4s16*//*Label 8244*/ GIMT_Encode4(413656),
    /*GILLT_v4s32*//*Label 8245*/ GIMT_Encode4(413726),
    /*GILLT_v8s8*//*Label 8246*/ GIMT_Encode4(413781),
    /*GILLT_v8s16*//*Label 8247*/ GIMT_Encode4(413815),
    /*GILLT_v16s8*//*Label 8248*/ GIMT_Encode4(413885), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8249*/ GIMT_Encode4(413919),
    /*GILLT_nxv2s16*//*Label 8250*/ GIMT_Encode4(413945),
    /*GILLT_nxv2s32*//*Label 8251*/ GIMT_Encode4(413971),
    /*GILLT_nxv2s64*//*Label 8252*/ GIMT_Encode4(413997),
    /*GILLT_nxv4s1*//*Label 8253*/ GIMT_Encode4(414044),
    /*GILLT_nxv4s16*//*Label 8254*/ GIMT_Encode4(414070),
    /*GILLT_nxv4s32*//*Label 8255*/ GIMT_Encode4(414096),
    /*GILLT_nxv8s1*//*Label 8256*/ GIMT_Encode4(414143),
    /*GILLT_nxv8s16*//*Label 8257*/ GIMT_Encode4(414169),
    /*GILLT_nxv16s1*//*Label 8258*/ GIMT_Encode4(414231),
    /*GILLT_nxv16s8*//*Label 8259*/ GIMT_Encode4(414257),
    // Label 8242: @413546
    GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(413600),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(413584), // Rule ID 1869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1869,
        GIR_Done,
      // Label 8262: @413584
      GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(413599), // Rule ID 5494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5494,
        GIR_Done,
      // Label 8263: @413599
      GIM_Reject,
    // Label 8261: @413600
    GIM_Reject,
    // Label 8243: @413601
    GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(413655),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(413639), // Rule ID 1871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1871,
        GIR_Done,
      // Label 8265: @413639
      GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(413654), // Rule ID 5496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5496,
        GIR_Done,
      // Label 8266: @413654
      GIM_Reject,
    // Label 8264: @413655
    GIM_Reject,
    // Label 8244: @413656
    GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(413725),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(413694), // Rule ID 1867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1867,
        GIR_Done,
      // Label 8268: @413694
      GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(413709), // Rule ID 5490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5490,
        GIR_Done,
      // Label 8269: @413709
      GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(413724), // Rule ID 5491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5491,
        GIR_Done,
      // Label 8270: @413724
      GIM_Reject,
    // Label 8267: @413725
    GIM_Reject,
    // Label 8245: @413726
    GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(413780),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(413764), // Rule ID 1870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1870,
        GIR_Done,
      // Label 8272: @413764
      GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(413779), // Rule ID 5495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5495,
        GIR_Done,
      // Label 8273: @413779
      GIM_Reject,
    // Label 8271: @413780
    GIM_Reject,
    // Label 8246: @413781
    GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(413814), // Rule ID 1865 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1865,
      GIR_Done,
    // Label 8274: @413814
    GIM_Reject,
    // Label 8247: @413815
    GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(413884),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(413853), // Rule ID 1868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1868,
        GIR_Done,
      // Label 8276: @413853
      GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(413868), // Rule ID 5492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5492,
        GIR_Done,
      // Label 8277: @413868
      GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(413883), // Rule ID 5493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5493,
        GIR_Done,
      // Label 8278: @413883
      GIM_Reject,
    // Label 8275: @413884
    GIM_Reject,
    // Label 8248: @413885
    GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(413918), // Rule ID 1866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1866,
      GIR_Done,
    // Label 8279: @413918
    GIM_Reject,
    // Label 8249: @413919
    GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(413944), // Rule ID 9159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9159,
      GIR_Done,
    // Label 8280: @413944
    GIM_Reject,
    // Label 8250: @413945
    GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(413970), // Rule ID 9141 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9141,
      GIR_Done,
    // Label 8281: @413970
    GIM_Reject,
    // Label 8251: @413971
    GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(413996), // Rule ID 9142 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9142,
      GIR_Done,
    // Label 8282: @413996
    GIM_Reject,
    // Label 8252: @413997
    GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(414043),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(414027), // Rule ID 9137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9137,
        GIR_Done,
      // Label 8284: @414027
      GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(414042), // Rule ID 9143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9143,
        GIR_Done,
      // Label 8285: @414042
      GIM_Reject,
    // Label 8283: @414043
    GIM_Reject,
    // Label 8253: @414044
    GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(414069), // Rule ID 9158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9158,
      GIR_Done,
    // Label 8286: @414069
    GIM_Reject,
    // Label 8254: @414070
    GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(414095), // Rule ID 9139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9139,
      GIR_Done,
    // Label 8287: @414095
    GIM_Reject,
    // Label 8255: @414096
    GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(414142),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(414126), // Rule ID 9136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9136,
        GIR_Done,
      // Label 8289: @414126
      GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(414141), // Rule ID 9140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9140,
        GIR_Done,
      // Label 8290: @414141
      GIM_Reject,
    // Label 8288: @414142
    GIM_Reject,
    // Label 8256: @414143
    GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(414168), // Rule ID 9157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9157,
      GIR_Done,
    // Label 8291: @414168
    GIM_Reject,
    // Label 8257: @414169
    GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(414230),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(414199), // Rule ID 9135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9135,
        GIR_Done,
      // Label 8293: @414199
      GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(414214), // Rule ID 9138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9138,
        GIR_Done,
      // Label 8294: @414214
      GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(414229), // Rule ID 9144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9144,
        GIR_Done,
      // Label 8295: @414229
      GIM_Reject,
    // Label 8292: @414230
    GIM_Reject,
    // Label 8258: @414231
    GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(414256), // Rule ID 2394 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2394,
      GIR_Done,
    // Label 8296: @414256
    GIM_Reject,
    // Label 8259: @414257
    GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(414282), // Rule ID 9134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9134,
      GIR_Done,
    // Label 8297: @414282
    GIM_Reject,
    // Label 8260: @414283
    GIM_Reject,
    // Label 143: @414284
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8304*/ GIMT_Encode4(414489),
    /*GILLT_s64*//*Label 8298*/ GIMT_Encode4(414327), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8299*/ GIMT_Encode4(414354),
    /*GILLT_v2s64*//*Label 8300*/ GIMT_Encode4(414381),
    /*GILLT_v4s16*//*Label 8301*/ GIMT_Encode4(414408),
    /*GILLT_v4s32*//*Label 8302*/ GIMT_Encode4(414435), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8303*/ GIMT_Encode4(414462),
    // Label 8298: @414327
    GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(414353), // Rule ID 1057 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1057,
      GIR_Done,
    // Label 8305: @414353
    GIM_Reject,
    // Label 8299: @414354
    GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(414380), // Rule ID 1053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1053,
      GIR_Done,
    // Label 8306: @414380
    GIM_Reject,
    // Label 8300: @414381
    GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(414407), // Rule ID 1059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1059,
      GIR_Done,
    // Label 8307: @414407
    GIM_Reject,
    // Label 8301: @414408
    GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(414434), // Rule ID 1049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1049,
      GIR_Done,
    // Label 8308: @414434
    GIM_Reject,
    // Label 8302: @414435
    GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(414461), // Rule ID 1055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1055,
      GIR_Done,
    // Label 8309: @414461
    GIM_Reject,
    // Label 8303: @414462
    GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(414488), // Rule ID 1051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1051,
      GIR_Done,
    // Label 8310: @414488
    GIM_Reject,
    // Label 8304: @414489
    GIM_Reject,
    // Label 144: @414490
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8313*/ GIMT_Encode4(415356),
    /*GILLT_v2s64*//*Label 8311*/ GIMT_Encode4(414513), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8312*/ GIMT_Encode4(414807),
    // Label 8311: @414513
    GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(414595), // Rule ID 5911 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5911,
      GIR_EraseRootFromParent_Done,
    // Label 8314: @414595
    GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(414669), // Rule ID 5910 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5910,
      GIR_EraseRootFromParent_Done,
    // Label 8315: @414669
    GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(414728), // Rule ID 5920 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 5920,
      GIR_EraseRootFromParent_Done,
    // Label 8316: @414728
    GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(414806), // Rule ID 6048 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6048,
      GIR_EraseRootFromParent_Done,
    // Label 8317: @414806
    GIM_Reject,
    // Label 8312: @414807
    GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(414889), // Rule ID 5913 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5913,
      GIR_EraseRootFromParent_Done,
    // Label 8318: @414889
    GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(414971), // Rule ID 5915 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5915,
      GIR_EraseRootFromParent_Done,
    // Label 8319: @414971
    GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(415045), // Rule ID 5912 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5912,
      GIR_EraseRootFromParent_Done,
    // Label 8320: @415045
    GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(415119), // Rule ID 5914 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5914,
      GIR_EraseRootFromParent_Done,
    // Label 8321: @415119
    GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(415178), // Rule ID 5916 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5916,
      GIR_EraseRootFromParent_Done,
    // Label 8322: @415178
    GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(415237), // Rule ID 5917 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5917,
      GIR_EraseRootFromParent_Done,
    // Label 8323: @415237
    GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(415296), // Rule ID 5918 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5918,
      GIR_EraseRootFromParent_Done,
    // Label 8324: @415296
    GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(415355), // Rule ID 5919 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5919,
      GIR_EraseRootFromParent_Done,
    // Label 8325: @415355
    GIM_Reject,
    // Label 8313: @415356
    GIM_Reject,
    // Label 145: @415357
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8330*/ GIMT_Encode4(415726),
    /*GILLT_v2s32*//*Label 8326*/ GIMT_Encode4(415428), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8327*/ GIMT_Encode4(415548), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 8328*/ GIMT_Encode4(415668), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 8329*/ GIMT_Encode4(415697),
    // Label 8326: @415428
    GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(415547),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(415527), // Rule ID 28 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 28,
        GIR_EraseRootFromParent_Done,
      // Label 8332: @415527
      GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(415546), // Rule ID 24 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24,
        GIR_Done,
      // Label 8333: @415546
      GIM_Reject,
    // Label 8331: @415547
    GIM_Reject,
    // Label 8327: @415548
    GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(415667),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(415647), // Rule ID 29 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 29,
        GIR_EraseRootFromParent_Done,
      // Label 8335: @415647
      GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(415666), // Rule ID 25 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25,
        GIR_Done,
      // Label 8336: @415666
      GIM_Reject,
    // Label 8334: @415667
    GIM_Reject,
    // Label 8328: @415668
    GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(415696), // Rule ID 7789 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7789,
      GIR_Done,
    // Label 8337: @415696
    GIM_Reject,
    // Label 8329: @415697
    GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(415725), // Rule ID 7788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7788,
      GIR_Done,
    // Label 8338: @415725
    GIM_Reject,
    // Label 8330: @415726
    GIM_Reject,
    // Label 146: @415727
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8342*/ GIMT_Encode4(415843),
    /*GILLT_s16*//*Label 8339*/ GIMT_Encode4(415750),
    /*GILLT_s32*//*Label 8340*/ GIMT_Encode4(415781),
    /*GILLT_s64*//*Label 8341*/ GIMT_Encode4(415812),
    // Label 8339: @415750
    GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(415780), // Rule ID 1657 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1657,
      GIR_Done,
    // Label 8343: @415780
    GIM_Reject,
    // Label 8340: @415781
    GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(415811), // Rule ID 1656 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1656,
      GIR_Done,
    // Label 8344: @415811
    GIM_Reject,
    // Label 8341: @415812
    GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(415842), // Rule ID 1655 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1655,
      GIR_Done,
    // Label 8345: @415842
    GIM_Reject,
    // Label 8342: @415843
    GIM_Reject,
    // Label 147: @415844
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8349*/ GIMT_Encode4(417076),
    /*GILLT_v2s64*//*Label 8346*/ GIMT_Encode4(415875), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8347*/ GIMT_Encode4(416436), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8348*/ GIMT_Encode4(416997),
    // Label 8346: @415875
    GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(416435),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(415982), // Rule ID 2094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2094,
        GIR_EraseRootFromParent_Done,
      // Label 8351: @415982
      GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(416074), // Rule ID 13504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13504,
        GIR_EraseRootFromParent_Done,
      // Label 8352: @416074
      GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(416160), // Rule ID 13502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13502,
        GIR_EraseRootFromParent_Done,
      // Label 8353: @416160
      GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(416246), // Rule ID 2092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2092,
        GIR_EraseRootFromParent_Done,
      // Label 8354: @416246
      GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(416285), // Rule ID 1819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1819,
        GIR_EraseRootFromParent_Done,
      // Label 8355: @416285
      GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(416348), // Rule ID 13503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13503,
        GIR_EraseRootFromParent_Done,
      // Label 8356: @416348
      GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(416411), // Rule ID 2093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2093,
        GIR_EraseRootFromParent_Done,
      // Label 8357: @416411
      GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(416434), // Rule ID 1818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1818,
        GIR_Done,
      // Label 8358: @416434
      GIM_Reject,
    // Label 8350: @416435
    GIM_Reject,
    // Label 8347: @416436
    GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(416996),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(416543), // Rule ID 2091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2091,
        GIR_EraseRootFromParent_Done,
      // Label 8360: @416543
      GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(416635), // Rule ID 13501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13501,
        GIR_EraseRootFromParent_Done,
      // Label 8361: @416635
      GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(416721), // Rule ID 13499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13499,
        GIR_EraseRootFromParent_Done,
      // Label 8362: @416721
      GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(416807), // Rule ID 2089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2089,
        GIR_EraseRootFromParent_Done,
      // Label 8363: @416807
      GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(416846), // Rule ID 1817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1817,
        GIR_EraseRootFromParent_Done,
      // Label 8364: @416846
      GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(416909), // Rule ID 13500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13500,
        GIR_EraseRootFromParent_Done,
      // Label 8365: @416909
      GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(416972), // Rule ID 2090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2090,
        GIR_EraseRootFromParent_Done,
      // Label 8366: @416972
      GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(416995), // Rule ID 1816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1816,
        GIR_Done,
      // Label 8367: @416995
      GIM_Reject,
    // Label 8359: @416996
    GIM_Reject,
    // Label 8348: @416997
    GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(417075),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(417051), // Rule ID 1815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1815,
        GIR_EraseRootFromParent_Done,
      // Label 8369: @417051
      GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(417074), // Rule ID 1814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1814,
        GIR_Done,
      // Label 8370: @417074
      GIM_Reject,
    // Label 8368: @417075
    GIM_Reject,
    // Label 8349: @417076
    GIM_Reject,
    // Label 148: @417077
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8389*/ GIMT_Encode4(417901),
    /*GILLT_v2s32*//*Label 8371*/ GIMT_Encode4(417164),
    /*GILLT_v2s64*//*Label 8372*/ GIMT_Encode4(417219),
    /*GILLT_v4s16*//*Label 8373*/ GIMT_Encode4(417274),
    /*GILLT_v4s32*//*Label 8374*/ GIMT_Encode4(417344),
    /*GILLT_v8s8*//*Label 8375*/ GIMT_Encode4(417399),
    /*GILLT_v8s16*//*Label 8376*/ GIMT_Encode4(417433),
    /*GILLT_v16s8*//*Label 8377*/ GIMT_Encode4(417503), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8378*/ GIMT_Encode4(417537),
    /*GILLT_nxv2s16*//*Label 8379*/ GIMT_Encode4(417563),
    /*GILLT_nxv2s32*//*Label 8380*/ GIMT_Encode4(417589),
    /*GILLT_nxv2s64*//*Label 8381*/ GIMT_Encode4(417615),
    /*GILLT_nxv4s1*//*Label 8382*/ GIMT_Encode4(417662),
    /*GILLT_nxv4s16*//*Label 8383*/ GIMT_Encode4(417688),
    /*GILLT_nxv4s32*//*Label 8384*/ GIMT_Encode4(417714),
    /*GILLT_nxv8s1*//*Label 8385*/ GIMT_Encode4(417761),
    /*GILLT_nxv8s16*//*Label 8386*/ GIMT_Encode4(417787),
    /*GILLT_nxv16s1*//*Label 8387*/ GIMT_Encode4(417849),
    /*GILLT_nxv16s8*//*Label 8388*/ GIMT_Encode4(417875),
    // Label 8371: @417164
    GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(417218),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(417202), // Rule ID 1876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1876,
        GIR_Done,
      // Label 8391: @417202
      GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(417217), // Rule ID 5501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5501,
        GIR_Done,
      // Label 8392: @417217
      GIM_Reject,
    // Label 8390: @417218
    GIM_Reject,
    // Label 8372: @417219
    GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(417273),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(417257), // Rule ID 1878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1878,
        GIR_Done,
      // Label 8394: @417257
      GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(417272), // Rule ID 5503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5503,
        GIR_Done,
      // Label 8395: @417272
      GIM_Reject,
    // Label 8393: @417273
    GIM_Reject,
    // Label 8373: @417274
    GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(417343),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(417312), // Rule ID 1874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1874,
        GIR_Done,
      // Label 8397: @417312
      GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(417327), // Rule ID 5497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5497,
        GIR_Done,
      // Label 8398: @417327
      GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(417342), // Rule ID 5498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5498,
        GIR_Done,
      // Label 8399: @417342
      GIM_Reject,
    // Label 8396: @417343
    GIM_Reject,
    // Label 8374: @417344
    GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(417398),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(417382), // Rule ID 1877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1877,
        GIR_Done,
      // Label 8401: @417382
      GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(417397), // Rule ID 5502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5502,
        GIR_Done,
      // Label 8402: @417397
      GIM_Reject,
    // Label 8400: @417398
    GIM_Reject,
    // Label 8375: @417399
    GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(417432), // Rule ID 1872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1872,
      GIR_Done,
    // Label 8403: @417432
    GIM_Reject,
    // Label 8376: @417433
    GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(417502),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(417471), // Rule ID 1875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1875,
        GIR_Done,
      // Label 8405: @417471
      GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(417486), // Rule ID 5499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5499,
        GIR_Done,
      // Label 8406: @417486
      GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(417501), // Rule ID 5500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5500,
        GIR_Done,
      // Label 8407: @417501
      GIM_Reject,
    // Label 8404: @417502
    GIM_Reject,
    // Label 8377: @417503
    GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(417536), // Rule ID 1873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1873,
      GIR_Done,
    // Label 8408: @417536
    GIM_Reject,
    // Label 8378: @417537
    GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(417562), // Rule ID 9150 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9150,
      GIR_Done,
    // Label 8409: @417562
    GIM_Reject,
    // Label 8379: @417563
    GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(417588), // Rule ID 9108 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9108,
      GIR_Done,
    // Label 8410: @417588
    GIM_Reject,
    // Label 8380: @417589
    GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(417614), // Rule ID 9109 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9109,
      GIR_Done,
    // Label 8411: @417614
    GIM_Reject,
    // Label 8381: @417615
    GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(417661),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(417645), // Rule ID 9104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9104,
        GIR_Done,
      // Label 8413: @417645
      GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(417660), // Rule ID 9110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9110,
        GIR_Done,
      // Label 8414: @417660
      GIM_Reject,
    // Label 8412: @417661
    GIM_Reject,
    // Label 8382: @417662
    GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(417687), // Rule ID 9149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9149,
      GIR_Done,
    // Label 8415: @417687
    GIM_Reject,
    // Label 8383: @417688
    GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(417713), // Rule ID 9106 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9106,
      GIR_Done,
    // Label 8416: @417713
    GIM_Reject,
    // Label 8384: @417714
    GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(417760),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(417744), // Rule ID 9103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9103,
        GIR_Done,
      // Label 8418: @417744
      GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(417759), // Rule ID 9107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9107,
        GIR_Done,
      // Label 8419: @417759
      GIM_Reject,
    // Label 8417: @417760
    GIM_Reject,
    // Label 8385: @417761
    GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(417786), // Rule ID 9148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9148,
      GIR_Done,
    // Label 8420: @417786
    GIM_Reject,
    // Label 8386: @417787
    GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(417848),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(417817), // Rule ID 9102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9102,
        GIR_Done,
      // Label 8422: @417817
      GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(417832), // Rule ID 9105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9105,
        GIR_Done,
      // Label 8423: @417832
      GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(417847), // Rule ID 9111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9111,
        GIR_Done,
      // Label 8424: @417847
      GIM_Reject,
    // Label 8421: @417848
    GIM_Reject,
    // Label 8387: @417849
    GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(417874), // Rule ID 2382 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2382,
      GIR_Done,
    // Label 8425: @417874
    GIM_Reject,
    // Label 8388: @417875
    GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(417900), // Rule ID 9101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9101,
      GIR_Done,
    // Label 8426: @417900
    GIM_Reject,
    // Label 8389: @417901
    GIM_Reject,
    // Label 149: @417902
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8445*/ GIMT_Encode4(418726),
    /*GILLT_v2s32*//*Label 8427*/ GIMT_Encode4(417989),
    /*GILLT_v2s64*//*Label 8428*/ GIMT_Encode4(418044),
    /*GILLT_v4s16*//*Label 8429*/ GIMT_Encode4(418099),
    /*GILLT_v4s32*//*Label 8430*/ GIMT_Encode4(418169),
    /*GILLT_v8s8*//*Label 8431*/ GIMT_Encode4(418224),
    /*GILLT_v8s16*//*Label 8432*/ GIMT_Encode4(418258),
    /*GILLT_v16s8*//*Label 8433*/ GIMT_Encode4(418328), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8434*/ GIMT_Encode4(418362),
    /*GILLT_nxv2s16*//*Label 8435*/ GIMT_Encode4(418388),
    /*GILLT_nxv2s32*//*Label 8436*/ GIMT_Encode4(418414),
    /*GILLT_nxv2s64*//*Label 8437*/ GIMT_Encode4(418440),
    /*GILLT_nxv4s1*//*Label 8438*/ GIMT_Encode4(418487),
    /*GILLT_nxv4s16*//*Label 8439*/ GIMT_Encode4(418513),
    /*GILLT_nxv4s32*//*Label 8440*/ GIMT_Encode4(418539),
    /*GILLT_nxv8s1*//*Label 8441*/ GIMT_Encode4(418586),
    /*GILLT_nxv8s16*//*Label 8442*/ GIMT_Encode4(418612),
    /*GILLT_nxv16s1*//*Label 8443*/ GIMT_Encode4(418674),
    /*GILLT_nxv16s8*//*Label 8444*/ GIMT_Encode4(418700),
    // Label 8427: @417989
    GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(418043),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(418027), // Rule ID 1883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1883,
        GIR_Done,
      // Label 8447: @418027
      GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(418042), // Rule ID 5508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5508,
        GIR_Done,
      // Label 8448: @418042
      GIM_Reject,
    // Label 8446: @418043
    GIM_Reject,
    // Label 8428: @418044
    GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(418098),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(418082), // Rule ID 1885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1885,
        GIR_Done,
      // Label 8450: @418082
      GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(418097), // Rule ID 5510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5510,
        GIR_Done,
      // Label 8451: @418097
      GIM_Reject,
    // Label 8449: @418098
    GIM_Reject,
    // Label 8429: @418099
    GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(418168),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(418137), // Rule ID 1881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1881,
        GIR_Done,
      // Label 8453: @418137
      GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(418152), // Rule ID 5504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5504,
        GIR_Done,
      // Label 8454: @418152
      GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(418167), // Rule ID 5505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5505,
        GIR_Done,
      // Label 8455: @418167
      GIM_Reject,
    // Label 8452: @418168
    GIM_Reject,
    // Label 8430: @418169
    GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(418223),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(418207), // Rule ID 1884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1884,
        GIR_Done,
      // Label 8457: @418207
      GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(418222), // Rule ID 5509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5509,
        GIR_Done,
      // Label 8458: @418222
      GIM_Reject,
    // Label 8456: @418223
    GIM_Reject,
    // Label 8431: @418224
    GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(418257), // Rule ID 1879 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1879,
      GIR_Done,
    // Label 8459: @418257
    GIM_Reject,
    // Label 8432: @418258
    GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(418327),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(418296), // Rule ID 1882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1882,
        GIR_Done,
      // Label 8461: @418296
      GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(418311), // Rule ID 5506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5506,
        GIR_Done,
      // Label 8462: @418311
      GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(418326), // Rule ID 5507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5507,
        GIR_Done,
      // Label 8463: @418326
      GIM_Reject,
    // Label 8460: @418327
    GIM_Reject,
    // Label 8433: @418328
    GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(418361), // Rule ID 1880 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1880,
      GIR_Done,
    // Label 8464: @418361
    GIM_Reject,
    // Label 8434: @418362
    GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(418387), // Rule ID 9153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9153,
      GIR_Done,
    // Label 8465: @418387
    GIM_Reject,
    // Label 8435: @418388
    GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(418413), // Rule ID 9119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9119,
      GIR_Done,
    // Label 8466: @418413
    GIM_Reject,
    // Label 8436: @418414
    GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(418439), // Rule ID 9120 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9120,
      GIR_Done,
    // Label 8467: @418439
    GIM_Reject,
    // Label 8437: @418440
    GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(418486),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(418470), // Rule ID 9115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9115,
        GIR_Done,
      // Label 8469: @418470
      GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(418485), // Rule ID 9121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9121,
        GIR_Done,
      // Label 8470: @418485
      GIM_Reject,
    // Label 8468: @418486
    GIM_Reject,
    // Label 8438: @418487
    GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(418512), // Rule ID 9152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9152,
      GIR_Done,
    // Label 8471: @418512
    GIM_Reject,
    // Label 8439: @418513
    GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(418538), // Rule ID 9117 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9117,
      GIR_Done,
    // Label 8472: @418538
    GIM_Reject,
    // Label 8440: @418539
    GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(418585),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(418569), // Rule ID 9114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9114,
        GIR_Done,
      // Label 8474: @418569
      GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(418584), // Rule ID 9118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9118,
        GIR_Done,
      // Label 8475: @418584
      GIM_Reject,
    // Label 8473: @418585
    GIM_Reject,
    // Label 8441: @418586
    GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(418611), // Rule ID 9151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9151,
      GIR_Done,
    // Label 8476: @418611
    GIM_Reject,
    // Label 8442: @418612
    GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(418673),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(418642), // Rule ID 9113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9113,
        GIR_Done,
      // Label 8478: @418642
      GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(418657), // Rule ID 9116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9116,
        GIR_Done,
      // Label 8479: @418657
      GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(418672), // Rule ID 9122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9122,
        GIR_Done,
      // Label 8480: @418672
      GIM_Reject,
    // Label 8477: @418673
    GIM_Reject,
    // Label 8443: @418674
    GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(418699), // Rule ID 2386 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2386,
      GIR_Done,
    // Label 8481: @418699
    GIM_Reject,
    // Label 8444: @418700
    GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(418725), // Rule ID 9112 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9112,
      GIR_Done,
    // Label 8482: @418725
    GIM_Reject,
    // Label 8445: @418726
    GIM_Reject,
    // Label 150: @418727
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8491*/ GIMT_Encode4(419424),
    /*GILLT_s64*//*Label 8483*/ GIMT_Encode4(418774), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8484*/ GIMT_Encode4(418885),
    /*GILLT_v2s64*//*Label 8485*/ GIMT_Encode4(418962),
    /*GILLT_v4s16*//*Label 8486*/ GIMT_Encode4(419039),
    /*GILLT_v4s32*//*Label 8487*/ GIMT_Encode4(419116),
    /*GILLT_v8s8*//*Label 8488*/ GIMT_Encode4(419193),
    /*GILLT_v8s16*//*Label 8489*/ GIMT_Encode4(419270),
    /*GILLT_v16s8*//*Label 8490*/ GIMT_Encode4(419347),
    // Label 8483: @418774
    GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(418884),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(418815), // Rule ID 5273 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
        // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5273,
        GIR_EraseRootFromParent_Done,
      // Label 8493: @418815
      GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(418849), // Rule ID 2106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2106,
        GIR_EraseRootFromParent_Done,
      // Label 8494: @418849
      GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(418883), // Rule ID 6337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6337,
        GIR_EraseRootFromParent_Done,
      // Label 8495: @418883
      GIM_Reject,
    // Label 8492: @418884
    GIM_Reject,
    // Label 8484: @418885
    GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(418961),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(418926), // Rule ID 4914 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
        // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4914,
        GIR_EraseRootFromParent_Done,
      // Label 8497: @418926
      GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(418960), // Rule ID 2213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2213,
        GIR_EraseRootFromParent_Done,
      // Label 8498: @418960
      GIM_Reject,
    // Label 8496: @418961
    GIM_Reject,
    // Label 8485: @418962
    GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(419038),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(419003), // Rule ID 4918 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
        // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4918,
        GIR_EraseRootFromParent_Done,
      // Label 8500: @419003
      GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(419037), // Rule ID 2215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2215,
        GIR_EraseRootFromParent_Done,
      // Label 8501: @419037
      GIM_Reject,
    // Label 8499: @419038
    GIM_Reject,
    // Label 8486: @419039
    GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(419115),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(419080), // Rule ID 4913 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
        // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4913,
        GIR_EraseRootFromParent_Done,
      // Label 8503: @419080
      GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(419114), // Rule ID 2211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2211,
        GIR_EraseRootFromParent_Done,
      // Label 8504: @419114
      GIM_Reject,
    // Label 8502: @419115
    GIM_Reject,
    // Label 8487: @419116
    GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(419192),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(419157), // Rule ID 4917 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
        // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4917,
        GIR_EraseRootFromParent_Done,
      // Label 8506: @419157
      GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(419191), // Rule ID 2214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2214,
        GIR_EraseRootFromParent_Done,
      // Label 8507: @419191
      GIM_Reject,
    // Label 8505: @419192
    GIM_Reject,
    // Label 8488: @419193
    GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(419269),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(419234), // Rule ID 4912 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
        // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4912,
        GIR_EraseRootFromParent_Done,
      // Label 8509: @419234
      GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(419268), // Rule ID 2209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2209,
        GIR_EraseRootFromParent_Done,
      // Label 8510: @419268
      GIM_Reject,
    // Label 8508: @419269
    GIM_Reject,
    // Label 8489: @419270
    GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(419346),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(419311), // Rule ID 4916 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
        // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4916,
        GIR_EraseRootFromParent_Done,
      // Label 8512: @419311
      GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(419345), // Rule ID 2212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2212,
        GIR_EraseRootFromParent_Done,
      // Label 8513: @419345
      GIM_Reject,
    // Label 8511: @419346
    GIM_Reject,
    // Label 8490: @419347
    GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(419423),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(419388), // Rule ID 4915 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
        // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4915,
        GIR_EraseRootFromParent_Done,
      // Label 8515: @419388
      GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(419422), // Rule ID 2210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2210,
        GIR_EraseRootFromParent_Done,
      // Label 8516: @419422
      GIM_Reject,
    // Label 8514: @419423
    GIM_Reject,
    // Label 8491: @419424
    GIM_Reject,
    // Label 151: @419425
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8525*/ GIMT_Encode4(419880),
    /*GILLT_s64*//*Label 8517*/ GIMT_Encode4(419472), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8518*/ GIMT_Encode4(419558),
    /*GILLT_v2s64*//*Label 8519*/ GIMT_Encode4(419604),
    /*GILLT_v4s16*//*Label 8520*/ GIMT_Encode4(419650),
    /*GILLT_v4s32*//*Label 8521*/ GIMT_Encode4(419696),
    /*GILLT_v8s8*//*Label 8522*/ GIMT_Encode4(419742),
    /*GILLT_v8s16*//*Label 8523*/ GIMT_Encode4(419788),
    /*GILLT_v16s8*//*Label 8524*/ GIMT_Encode4(419834),
    // Label 8517: @419472
    GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(419557),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(419522), // Rule ID 2115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2115,
        GIR_EraseRootFromParent_Done,
      // Label 8527: @419522
      GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(419556), // Rule ID 6343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6343,
        GIR_EraseRootFromParent_Done,
      // Label 8528: @419556
      GIM_Reject,
    // Label 8526: @419557
    GIM_Reject,
    // Label 8518: @419558
    GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(419603), // Rule ID 2272 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2272,
      GIR_EraseRootFromParent_Done,
    // Label 8529: @419603
    GIM_Reject,
    // Label 8519: @419604
    GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(419649), // Rule ID 2274 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2274,
      GIR_EraseRootFromParent_Done,
    // Label 8530: @419649
    GIM_Reject,
    // Label 8520: @419650
    GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(419695), // Rule ID 2270 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2270,
      GIR_EraseRootFromParent_Done,
    // Label 8531: @419695
    GIM_Reject,
    // Label 8521: @419696
    GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(419741), // Rule ID 2273 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2273,
      GIR_EraseRootFromParent_Done,
    // Label 8532: @419741
    GIM_Reject,
    // Label 8522: @419742
    GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(419787), // Rule ID 2268 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2268,
      GIR_EraseRootFromParent_Done,
    // Label 8533: @419787
    GIM_Reject,
    // Label 8523: @419788
    GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(419833), // Rule ID 2271 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2271,
      GIR_EraseRootFromParent_Done,
    // Label 8534: @419833
    GIM_Reject,
    // Label 8524: @419834
    GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(419879), // Rule ID 2269 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2269,
      GIR_EraseRootFromParent_Done,
    // Label 8535: @419879
    GIM_Reject,
    // Label 8525: @419880
    GIM_Reject,
    // Label 152: @419881
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8554*/ GIMT_Encode4(420705),
    /*GILLT_v2s32*//*Label 8536*/ GIMT_Encode4(419968),
    /*GILLT_v2s64*//*Label 8537*/ GIMT_Encode4(420023),
    /*GILLT_v4s16*//*Label 8538*/ GIMT_Encode4(420078),
    /*GILLT_v4s32*//*Label 8539*/ GIMT_Encode4(420148),
    /*GILLT_v8s8*//*Label 8540*/ GIMT_Encode4(420203),
    /*GILLT_v8s16*//*Label 8541*/ GIMT_Encode4(420237),
    /*GILLT_v16s8*//*Label 8542*/ GIMT_Encode4(420307), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8543*/ GIMT_Encode4(420341),
    /*GILLT_nxv2s16*//*Label 8544*/ GIMT_Encode4(420367),
    /*GILLT_nxv2s32*//*Label 8545*/ GIMT_Encode4(420393),
    /*GILLT_nxv2s64*//*Label 8546*/ GIMT_Encode4(420419),
    /*GILLT_nxv4s1*//*Label 8547*/ GIMT_Encode4(420466),
    /*GILLT_nxv4s16*//*Label 8548*/ GIMT_Encode4(420492),
    /*GILLT_nxv4s32*//*Label 8549*/ GIMT_Encode4(420518),
    /*GILLT_nxv8s1*//*Label 8550*/ GIMT_Encode4(420565),
    /*GILLT_nxv8s16*//*Label 8551*/ GIMT_Encode4(420591),
    /*GILLT_nxv16s1*//*Label 8552*/ GIMT_Encode4(420653),
    /*GILLT_nxv16s8*//*Label 8553*/ GIMT_Encode4(420679),
    // Label 8536: @419968
    GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(420022),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(420006), // Rule ID 1890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1890,
        GIR_Done,
      // Label 8556: @420006
      GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(420021), // Rule ID 5515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5515,
        GIR_Done,
      // Label 8557: @420021
      GIM_Reject,
    // Label 8555: @420022
    GIM_Reject,
    // Label 8537: @420023
    GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(420077),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(420061), // Rule ID 1892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1892,
        GIR_Done,
      // Label 8559: @420061
      GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(420076), // Rule ID 5517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5517,
        GIR_Done,
      // Label 8560: @420076
      GIM_Reject,
    // Label 8558: @420077
    GIM_Reject,
    // Label 8538: @420078
    GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(420147),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(420116), // Rule ID 1888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1888,
        GIR_Done,
      // Label 8562: @420116
      GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(420131), // Rule ID 5511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5511,
        GIR_Done,
      // Label 8563: @420131
      GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(420146), // Rule ID 5512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5512,
        GIR_Done,
      // Label 8564: @420146
      GIM_Reject,
    // Label 8561: @420147
    GIM_Reject,
    // Label 8539: @420148
    GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(420202),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(420186), // Rule ID 1891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1891,
        GIR_Done,
      // Label 8566: @420186
      GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(420201), // Rule ID 5516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5516,
        GIR_Done,
      // Label 8567: @420201
      GIM_Reject,
    // Label 8565: @420202
    GIM_Reject,
    // Label 8540: @420203
    GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(420236), // Rule ID 1886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1886,
      GIR_Done,
    // Label 8568: @420236
    GIM_Reject,
    // Label 8541: @420237
    GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(420306),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(420275), // Rule ID 1889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1889,
        GIR_Done,
      // Label 8570: @420275
      GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(420290), // Rule ID 5513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5513,
        GIR_Done,
      // Label 8571: @420290
      GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(420305), // Rule ID 5514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5514,
        GIR_Done,
      // Label 8572: @420305
      GIM_Reject,
    // Label 8569: @420306
    GIM_Reject,
    // Label 8542: @420307
    GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(420340), // Rule ID 1887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1887,
      GIR_Done,
    // Label 8573: @420340
    GIM_Reject,
    // Label 8543: @420341
    GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(420366), // Rule ID 3335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3335,
      GIR_Done,
    // Label 8574: @420366
    GIM_Reject,
    // Label 8544: @420367
    GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(420392), // Rule ID 2853 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2853,
      GIR_Done,
    // Label 8575: @420392
    GIM_Reject,
    // Label 8545: @420393
    GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(420418), // Rule ID 2854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2854,
      GIR_Done,
    // Label 8576: @420418
    GIM_Reject,
    // Label 8546: @420419
    GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(420465),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(420449), // Rule ID 2849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2849,
        GIR_Done,
      // Label 8578: @420449
      GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(420464), // Rule ID 2855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2855,
        GIR_Done,
      // Label 8579: @420464
      GIM_Reject,
    // Label 8577: @420465
    GIM_Reject,
    // Label 8547: @420466
    GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(420491), // Rule ID 3334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3334,
      GIR_Done,
    // Label 8580: @420491
    GIM_Reject,
    // Label 8548: @420492
    GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(420517), // Rule ID 2851 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2851,
      GIR_Done,
    // Label 8581: @420517
    GIM_Reject,
    // Label 8549: @420518
    GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(420564),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(420548), // Rule ID 2848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2848,
        GIR_Done,
      // Label 8583: @420548
      GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(420563), // Rule ID 2852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2852,
        GIR_Done,
      // Label 8584: @420563
      GIM_Reject,
    // Label 8582: @420564
    GIM_Reject,
    // Label 8550: @420565
    GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(420590), // Rule ID 3333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3333,
      GIR_Done,
    // Label 8585: @420590
    GIM_Reject,
    // Label 8551: @420591
    GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(420652),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(420621), // Rule ID 2847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2847,
        GIR_Done,
      // Label 8587: @420621
      GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(420636), // Rule ID 2850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2850,
        GIR_Done,
      // Label 8588: @420636
      GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(420651), // Rule ID 2856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2856,
        GIR_Done,
      // Label 8589: @420651
      GIM_Reject,
    // Label 8586: @420652
    GIM_Reject,
    // Label 8552: @420653
    GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(420678), // Rule ID 2374 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2374,
      GIR_Done,
    // Label 8590: @420678
    GIM_Reject,
    // Label 8553: @420679
    GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(420704), // Rule ID 2846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2846,
      GIR_Done,
    // Label 8591: @420704
    GIM_Reject,
    // Label 8554: @420705
    GIM_Reject,
    // Label 153: @420706
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8610*/ GIMT_Encode4(421530),
    /*GILLT_v2s32*//*Label 8592*/ GIMT_Encode4(420793),
    /*GILLT_v2s64*//*Label 8593*/ GIMT_Encode4(420848),
    /*GILLT_v4s16*//*Label 8594*/ GIMT_Encode4(420903),
    /*GILLT_v4s32*//*Label 8595*/ GIMT_Encode4(420973),
    /*GILLT_v8s8*//*Label 8596*/ GIMT_Encode4(421028),
    /*GILLT_v8s16*//*Label 8597*/ GIMT_Encode4(421062),
    /*GILLT_v16s8*//*Label 8598*/ GIMT_Encode4(421132), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8599*/ GIMT_Encode4(421166),
    /*GILLT_nxv2s16*//*Label 8600*/ GIMT_Encode4(421192),
    /*GILLT_nxv2s32*//*Label 8601*/ GIMT_Encode4(421218),
    /*GILLT_nxv2s64*//*Label 8602*/ GIMT_Encode4(421244),
    /*GILLT_nxv4s1*//*Label 8603*/ GIMT_Encode4(421291),
    /*GILLT_nxv4s16*//*Label 8604*/ GIMT_Encode4(421317),
    /*GILLT_nxv4s32*//*Label 8605*/ GIMT_Encode4(421343),
    /*GILLT_nxv8s1*//*Label 8606*/ GIMT_Encode4(421390),
    /*GILLT_nxv8s16*//*Label 8607*/ GIMT_Encode4(421416),
    /*GILLT_nxv16s1*//*Label 8608*/ GIMT_Encode4(421478),
    /*GILLT_nxv16s8*//*Label 8609*/ GIMT_Encode4(421504),
    // Label 8592: @420793
    GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(420847),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(420831), // Rule ID 1897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1897,
        GIR_Done,
      // Label 8612: @420831
      GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(420846), // Rule ID 5522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5522,
        GIR_Done,
      // Label 8613: @420846
      GIM_Reject,
    // Label 8611: @420847
    GIM_Reject,
    // Label 8593: @420848
    GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(420902),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(420886), // Rule ID 1899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1899,
        GIR_Done,
      // Label 8615: @420886
      GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(420901), // Rule ID 5524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5524,
        GIR_Done,
      // Label 8616: @420901
      GIM_Reject,
    // Label 8614: @420902
    GIM_Reject,
    // Label 8594: @420903
    GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(420972),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(420941), // Rule ID 1895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1895,
        GIR_Done,
      // Label 8618: @420941
      GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(420956), // Rule ID 5518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5518,
        GIR_Done,
      // Label 8619: @420956
      GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(420971), // Rule ID 5519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5519,
        GIR_Done,
      // Label 8620: @420971
      GIM_Reject,
    // Label 8617: @420972
    GIM_Reject,
    // Label 8595: @420973
    GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(421027),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(421011), // Rule ID 1898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1898,
        GIR_Done,
      // Label 8622: @421011
      GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(421026), // Rule ID 5523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5523,
        GIR_Done,
      // Label 8623: @421026
      GIM_Reject,
    // Label 8621: @421027
    GIM_Reject,
    // Label 8596: @421028
    GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(421061), // Rule ID 1893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1893,
      GIR_Done,
    // Label 8624: @421061
    GIM_Reject,
    // Label 8597: @421062
    GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(421131),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(421100), // Rule ID 1896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1896,
        GIR_Done,
      // Label 8626: @421100
      GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(421115), // Rule ID 5520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5520,
        GIR_Done,
      // Label 8627: @421115
      GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(421130), // Rule ID 5521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5521,
        GIR_Done,
      // Label 8628: @421130
      GIM_Reject,
    // Label 8625: @421131
    GIM_Reject,
    // Label 8598: @421132
    GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(421165), // Rule ID 1894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1894,
      GIR_Done,
    // Label 8629: @421165
    GIM_Reject,
    // Label 8599: @421166
    GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(421191), // Rule ID 9147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9147,
      GIR_Done,
    // Label 8630: @421191
    GIM_Reject,
    // Label 8600: @421192
    GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(421217), // Rule ID 9097 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9097,
      GIR_Done,
    // Label 8631: @421217
    GIM_Reject,
    // Label 8601: @421218
    GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(421243), // Rule ID 9098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9098,
      GIR_Done,
    // Label 8632: @421243
    GIM_Reject,
    // Label 8602: @421244
    GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(421290),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(421274), // Rule ID 9093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9093,
        GIR_Done,
      // Label 8634: @421274
      GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(421289), // Rule ID 9099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9099,
        GIR_Done,
      // Label 8635: @421289
      GIM_Reject,
    // Label 8633: @421290
    GIM_Reject,
    // Label 8603: @421291
    GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(421316), // Rule ID 9146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9146,
      GIR_Done,
    // Label 8636: @421316
    GIM_Reject,
    // Label 8604: @421317
    GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(421342), // Rule ID 9095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9095,
      GIR_Done,
    // Label 8637: @421342
    GIM_Reject,
    // Label 8605: @421343
    GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(421389),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(421373), // Rule ID 9092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9092,
        GIR_Done,
      // Label 8639: @421373
      GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(421388), // Rule ID 9096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9096,
        GIR_Done,
      // Label 8640: @421388
      GIM_Reject,
    // Label 8638: @421389
    GIM_Reject,
    // Label 8606: @421390
    GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(421415), // Rule ID 9145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9145,
      GIR_Done,
    // Label 8641: @421415
    GIM_Reject,
    // Label 8607: @421416
    GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(421477),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(421446), // Rule ID 9091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9091,
        GIR_Done,
      // Label 8643: @421446
      GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(421461), // Rule ID 9094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9094,
        GIR_Done,
      // Label 8644: @421461
      GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(421476), // Rule ID 9100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9100,
        GIR_Done,
      // Label 8645: @421476
      GIM_Reject,
    // Label 8642: @421477
    GIM_Reject,
    // Label 8608: @421478
    GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(421503), // Rule ID 2378 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2378,
      GIR_Done,
    // Label 8646: @421503
    GIM_Reject,
    // Label 8609: @421504
    GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(421529), // Rule ID 9090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9090,
      GIR_Done,
    // Label 8647: @421529
    GIM_Reject,
    // Label 8610: @421530
    GIM_Reject,
    // Label 154: @421531
    GIM_Reject,
    }; // Size: 421532 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
